/*
 * Internal module API header file.
 *
 * Generated by SIP 4.9.3 on Tue Mar 12 12:46:44 2013
 *
 * Copyright (c) 2009 Riverbank Computing Limited <info@riverbankcomputing.com>
 * 
 * This file is part of PyQt.
 * 
 * This file may be used under the terms of the GNU General Public
 * License versions 2.0 or 3.0 as published by the Free Software
 * Foundation and appearing in the files LICENSE.GPL2 and LICENSE.GPL3
 * included in the packaging of this file.  Alternatively you may (at
 * your option) use any later version of the GNU General Public
 * License if such license has been publicly approved by Riverbank
 * Computing Limited (or its successors, if any) and the KDE Free Qt
 * Foundation. In addition, as a special exception, Riverbank gives you
 * certain additional rights. These rights are described in the Riverbank
 * GPL Exception version 1.1, which can be found in the file
 * GPL_EXCEPTION.txt in this package.
 * 
 * Please review the following information to ensure GNU General
 * Public Licensing requirements will be met:
 * http://trolltech.com/products/qt/licenses/licensing/opensource/. If
 * you are unsure which license is appropriate for your use, please
 * review the following information:
 * http://trolltech.com/products/qt/licenses/licensing/licensingoverview
 * or contact the sales department at sales@riverbankcomputing.com.
 * 
 * This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
 * WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#ifndef _QtGuiAPI_H
#define _QtGuiAPI_H


#include <sip.h>

#include <QMetaType>

/* These are the features that are enabled. */
#define SIP_FEATURE_PyQt_qreal_double
#define SIP_FEATURE_PyQt_SizeGrip
#define SIP_FEATURE_PyQt_OpenSSL
#define SIP_FEATURE_Py_DateTime
#define SIP_FEATURE_PyQt_NoQtPrintRangeBug
#define SIP_FEATURE_PyQt_WhatsThis
#define SIP_FEATURE_PyQt_ToolTip
#define SIP_FEATURE_PyQt_StatusTip
#define SIP_FEATURE_PyQt_SessionManager
#define SIP_FEATURE_PyQt_Accessibility

#line 716 "sip/QtGui/qapplication.sip"
// Used to track QObject instances that must be explicitly destroyed before the
// QApplication instance is destroyed.  Typically these are instances that
// sometimes don't have a parent (and are not QWidgets).  (QGraphicsScene seems
// to be the most common, possibly only, example.)
void qtgui_track(QObject *o);
void qtgui_delete_tracked();

extern char **(*qpygui_ArgvToC)(PyObject *, int &);
extern void (*qpygui_UpdatePyArgv)(PyObject *, int, char **);
#line 187 "sip/QtGui/qfontmetrics.sip"
// Used by QFontMetrics and QFontMetricsF.
int *qtgui_tabarray(PyObject *l);
#line 244 "sip/QtGui/qimage.sip"
const char **QtGui_ListToArray(PyObject *lst);
void QtGui_DeleteArray(const char **arr);
#line 71 "sipAPIQtGui.h"

/*
 * Convenient names to refer to various strings defined in this module.
 * Only the class names are part of the public API.
 */
#define sipNameNr_SH_ItemView_PaintAlternatingRowColorsForEmptyArea 0
#define sipName_SH_ItemView_PaintAlternatingRowColorsForEmptyArea &sipStrings_QtGui[0]
#define sipNameNr_50 50
#define sipName_50 &sipStrings_QtGui[50]
#define sipNameNr_QStyleOptionTabWidgetFrame__StyleOptionVersion 98
#define sipName_QStyleOptionTabWidgetFrame__StyleOptionVersion &sipStrings_QtGui[98]
#define sipNameNr_QStyleOptionProgressBarV2__StyleOptionVersion 145
#define sipName_QStyleOptionProgressBarV2__StyleOptionVersion &sipStrings_QtGui[145]
#define sipNameNr_QStyleOptionTabBarBaseV2__StyleOptionVersion 191
#define sipName_QStyleOptionTabBarBaseV2__StyleOptionVersion &sipStrings_QtGui[191]
#define sipNameNr_QStyleOptionDockWidgetV2__StyleOptionVersion 236
#define sipName_QStyleOptionDockWidgetV2__StyleOptionVersion &sipStrings_QtGui[236]
#define sipNameNr_QStyleOptionGraphicsItem__StyleOptionVersion 281
#define sipName_QStyleOptionGraphicsItem__StyleOptionVersion &sipStrings_QtGui[281]
#define sipNameNr_SH_ItemView_MovementWithoutUpdatingSelection 326
#define sipName_SH_ItemView_MovementWithoutUpdatingSelection &sipStrings_QtGui[326]
#define sipNameNr_QStyleHintReturnVariant__StyleOptionVersion 371
#define sipName_QStyleHintReturnVariant__StyleOptionVersion &sipStrings_QtGui[371]
#define sipNameNr_QStyleOptionProgressBar__StyleOptionVersion 415
#define sipName_QStyleOptionProgressBar__StyleOptionVersion &sipStrings_QtGui[415]
#define sipNameNr_QStyleOptionTabWidgetFrame__StyleOptionType 459
#define sipName_QStyleOptionTabWidgetFrame__StyleOptionType &sipStrings_QtGui[459]
#define sipNameNr_SH_TextControl_FocusIndicatorTextCharFormat 503
#define sipName_SH_TextControl_FocusIndicatorTextCharFormat &sipStrings_QtGui[503]
#define sipNameNr_SH_ScrollBar_ScrollWhenPointerLeavesControl 547
#define sipName_SH_ScrollBar_ScrollWhenPointerLeavesControl &sipStrings_QtGui[547]
#define sipNameNr_QStyleOptionViewItemV4__StyleOptionVersion 591
#define sipName_QStyleOptionViewItemV4__StyleOptionVersion &sipStrings_QtGui[591]
#define sipNameNr_QStyleOptionViewItemV3__StyleOptionVersion 634
#define sipName_QStyleOptionViewItemV3__StyleOptionVersion &sipStrings_QtGui[634]
#define sipNameNr_QStyleOptionViewItemV2__StyleOptionVersion 677
#define sipName_QStyleOptionViewItemV2__StyleOptionVersion &sipStrings_QtGui[677]
#define sipNameNr_QStyleOptionToolButton__ToolButtonFeatures 720
#define sipName_QStyleOptionToolButton__ToolButtonFeatures &sipStrings_QtGui[720]
#define sipNameNr_QStyleOptionToolButton__StyleOptionVersion 763
#define sipName_QStyleOptionToolButton__StyleOptionVersion &sipStrings_QtGui[763]
#define sipNameNr_QStyleOptionRubberBand__StyleOptionVersion 806
#define sipName_QStyleOptionRubberBand__StyleOptionVersion &sipStrings_QtGui[806]
#define sipNameNr_QStyleOptionDockWidget__StyleOptionVersion 849
#define sipName_QStyleOptionDockWidget__StyleOptionVersion &sipStrings_QtGui[849]
#define sipNameNr_QStyleOptionProgressBarV2__StyleOptionType 892
#define sipName_QStyleOptionProgressBarV2__StyleOptionType &sipStrings_QtGui[892]
#define sipNameNr_QStyleOptionTabBarBase__StyleOptionVersion 935
#define sipName_QStyleOptionTabBarBase__StyleOptionVersion &sipStrings_QtGui[935]
#define sipNameNr_QStyleOptionToolBoxV2__StyleOptionVersion 978
#define sipName_QStyleOptionToolBoxV2__StyleOptionVersion &sipStrings_QtGui[978]
#define sipNameNr_QStyleOptionGraphicsItem__StyleOptionType 1020
#define sipName_QStyleOptionGraphicsItem__StyleOptionType &sipStrings_QtGui[1020]
#define sipNameNr_QStyleOptionToolButton__ToolButtonFeature 1062
#define sipName_QStyleOptionToolButton__ToolButtonFeature &sipStrings_QtGui[1062]
#define sipNameNr_QStyleOptionFocusRect__StyleOptionVersion 1104
#define sipName_QStyleOptionFocusRect__StyleOptionVersion &sipStrings_QtGui[1104]
#define sipNameNr_SH_ItemView_ArrowKeysNavigateIntoChildren 1146
#define sipName_SH_ItemView_ArrowKeysNavigateIntoChildren &sipStrings_QtGui[1146]
#define sipNameNr_QAbstractTextDocumentLayout__PaintContext 1188
#define sipName_QAbstractTextDocumentLayout__PaintContext &sipStrings_QtGui[1188]
#define sipNameNr_QStyleOptionViewItemV4__ViewItemPosition 1230
#define sipName_QStyleOptionViewItemV4__ViewItemPosition &sipStrings_QtGui[1230]
#define sipNameNr_QStyleHintReturnVariant__StyleOptionType 1271
#define sipName_QStyleHintReturnVariant__StyleOptionType &sipStrings_QtGui[1271]
#define sipNameNr_QStyleOptionSizeGrip__StyleOptionVersion 1312
#define sipName_QStyleOptionSizeGrip__StyleOptionVersion &sipStrings_QtGui[1312]
#define sipNameNr_QStyleOptionViewItemV2__ViewItemFeatures 1353
#define sipName_QStyleOptionViewItemV2__ViewItemFeatures &sipStrings_QtGui[1353]
#define sipNameNr_QStyleOptionGroupBox__StyleOptionVersion 1394
#define sipName_QStyleOptionGroupBox__StyleOptionVersion &sipStrings_QtGui[1394]
#define sipNameNr_QStyleHintReturnMask__StyleOptionVersion 1435
#define sipName_QStyleHintReturnMask__StyleOptionVersion &sipStrings_QtGui[1435]
#define sipNameNr_QStyleOptionTitleBar__StyleOptionVersion 1476
#define sipName_QStyleOptionTitleBar__StyleOptionVersion &sipStrings_QtGui[1476]
#define sipNameNr_QStyleOptionComboBox__StyleOptionVersion 1517
#define sipName_QStyleOptionComboBox__StyleOptionVersion &sipStrings_QtGui[1517]
#define sipNameNr_QStyleOptionViewItem__StyleOptionVersion 1558
#define sipName_QStyleOptionViewItem__StyleOptionVersion &sipStrings_QtGui[1558]
#define sipNameNr_QStyleOptionMenuItem__StyleOptionVersion 1599
#define sipName_QStyleOptionMenuItem__StyleOptionVersion &sipStrings_QtGui[1599]
#define sipNameNr_QStyleOptionProgressBar__StyleOptionType 1640
#define sipName_QStyleOptionProgressBar__StyleOptionType &sipStrings_QtGui[1640]
#define sipNameNr_SH_ScrollBar_MiddleClickAbsolutePosition 1681
#define sipName_SH_ScrollBar_MiddleClickAbsolutePosition &sipStrings_QtGui[1681]
#define sipNameNr_QPageSetupDialog__PageSetupDialogOptions 1722
#define sipName_QPageSetupDialog__PageSetupDialogOptions &sipStrings_QtGui[1722]
#define sipNameNr_QAbstractPrintDialog__PrintDialogOptions 1763
#define sipName_QAbstractPrintDialog__PrintDialogOptions &sipStrings_QtGui[1763]
#define sipNameNr_QAbstractItemView__DropIndicatorPosition 1804
#define sipName_QAbstractItemView__DropIndicatorPosition &sipStrings_QtGui[1804]
#define sipNameNr_QStyleOptionFrameV3__StyleOptionVersion 1845
#define sipName_QStyleOptionFrameV3__StyleOptionVersion &sipStrings_QtGui[1845]
#define sipNameNr_QStyleOptionToolBoxV2__SelectedPosition 1885
#define sipName_QStyleOptionToolBoxV2__SelectedPosition &sipStrings_QtGui[1885]
#define sipNameNr_QStyleOptionViewItemV2__ViewItemFeature 1925
#define sipName_QStyleOptionViewItemV2__ViewItemFeature &sipStrings_QtGui[1925]
#define sipNameNr_QStyleOptionToolBar__StyleOptionVersion 1965
#define sipName_QStyleOptionToolBar__StyleOptionVersion &sipStrings_QtGui[1965]
#define sipNameNr_QStyleOptionToolButton__StyleOptionType 2005
#define sipName_QStyleOptionToolButton__StyleOptionType &sipStrings_QtGui[2005]
#define sipNameNr_QStyleOptionSpinBox__StyleOptionVersion 2045
#define sipName_QStyleOptionSpinBox__StyleOptionVersion &sipStrings_QtGui[2045]
#define sipNameNr_QStyleOptionComplex__StyleOptionVersion 2085
#define sipName_QStyleOptionComplex__StyleOptionVersion &sipStrings_QtGui[2085]
#define sipNameNr_QStyleOptionRubberBand__StyleOptionType 2125
#define sipName_QStyleOptionRubberBand__StyleOptionType &sipStrings_QtGui[2125]
#define sipNameNr_QStyleOptionToolBox__StyleOptionVersion 2165
#define sipName_QStyleOptionToolBox__StyleOptionVersion &sipStrings_QtGui[2165]
#define sipNameNr_QStyleOptionDockWidget__StyleOptionType 2205
#define sipName_QStyleOptionDockWidget__StyleOptionType &sipStrings_QtGui[2205]
#define sipNameNr_QStyleOptionTabBarBase__StyleOptionType 2245
#define sipName_QStyleOptionTabBarBase__StyleOptionType &sipStrings_QtGui[2245]
#define sipNameNr_QStyleOptionFrameV2__StyleOptionVersion 2285
#define sipName_QStyleOptionFrameV2__StyleOptionVersion &sipStrings_QtGui[2285]
#define sipNameNr_SH_MessageBox_UseBorderForButtonSpacing 2325
#define sipName_SH_MessageBox_UseBorderForButtonSpacing &sipStrings_QtGui[2325]
#define sipNameNr_QPageSetupDialog__PageSetupDialogOption 2365
#define sipName_QPageSetupDialog__PageSetupDialogOption &sipStrings_QtGui[2365]
#define sipNameNr_QCalendarWidget__HorizontalHeaderFormat 2405
#define sipName_QCalendarWidget__HorizontalHeaderFormat &sipStrings_QtGui[2405]
#define sipNameNr_QAbstractPrintDialog__PrintDialogOption 2445
#define sipName_QAbstractPrintDialog__PrintDialogOption &sipStrings_QtGui[2445]
#define sipNameNr_QTreeWidgetItemIterator__IteratorFlags 2485
#define sipName_QTreeWidgetItemIterator__IteratorFlags &sipStrings_QtGui[2485]
#define sipNameNr_QStyleOptionSlider__StyleOptionVersion 2524
#define sipName_QStyleOptionSlider__StyleOptionVersion &sipStrings_QtGui[2524]
#define sipNameNr_QStyleOptionButton__StyleOptionVersion 2563
#define sipName_QStyleOptionButton__StyleOptionVersion &sipStrings_QtGui[2563]
#define sipNameNr_QStyleOptionHeader__StyleOptionVersion 2602
#define sipName_QStyleOptionHeader__StyleOptionVersion &sipStrings_QtGui[2602]
#define sipNameNr_QStyleOptionFocusRect__StyleOptionType 2641
#define sipName_QStyleOptionFocusRect__StyleOptionType &sipStrings_QtGui[2641]
#define sipNameNr_SH_ScrollBar_LeftClickAbsolutePosition 2680
#define sipName_SH_ScrollBar_LeftClickAbsolutePosition &sipStrings_QtGui[2680]
#define sipNameNr_SH_GroupBox_TextLabelVerticalAlignment 2719
#define sipName_SH_GroupBox_TextLabelVerticalAlignment &sipStrings_QtGui[2719]
#define sipNameNr_QGraphicsSceneContextMenuEvent__Reason 2758
#define sipName_QGraphicsSceneContextMenuEvent__Reason &sipStrings_QtGui[2758]
#define sipNameNr_QAbstractTextDocumentLayout__Selection 2797
#define sipName_QAbstractTextDocumentLayout__Selection &sipStrings_QtGui[2797]
#define sipNameNr_QTreeWidgetItemIterator__IteratorFlag 2836
#define sipName_QTreeWidgetItemIterator__IteratorFlag &sipStrings_QtGui[2836]
#define sipNameNr_QTreeWidgetItem__ChildIndicatorPolicy 2874
#define sipName_QTreeWidgetItem__ChildIndicatorPolicy &sipStrings_QtGui[2874]
#define sipNameNr_AddSpaceForLineAndParagraphSeparators 2912
#define sipName_AddSpaceForLineAndParagraphSeparators &sipStrings_QtGui[2912]
#define sipNameNr_QStyleOptionTabV3__StyleOptionVersion 2950
#define sipName_QStyleOptionTabV3__StyleOptionVersion &sipStrings_QtGui[2950]
#define sipNameNr_QStyleOptionSizeGrip__StyleOptionType 2988
#define sipName_QStyleOptionSizeGrip__StyleOptionType &sipStrings_QtGui[2988]
#define sipNameNr_QStyleOptionGroupBox__StyleOptionType 3026
#define sipName_QStyleOptionGroupBox__StyleOptionType &sipStrings_QtGui[3026]
#define sipNameNr_QStyleHintReturnMask__StyleOptionType 3064
#define sipName_QStyleHintReturnMask__StyleOptionType &sipStrings_QtGui[3064]
#define sipNameNr_QStyleOptionTitleBar__StyleOptionType 3102
#define sipName_QStyleOptionTitleBar__StyleOptionType &sipStrings_QtGui[3102]
#define sipNameNr_QStyleOptionComboBox__StyleOptionType 3140
#define sipName_QStyleOptionComboBox__StyleOptionType &sipStrings_QtGui[3140]
#define sipNameNr_QStyleOptionViewItem__StyleOptionType 3178
#define sipName_QStyleOptionViewItem__StyleOptionType &sipStrings_QtGui[3178]
#define sipNameNr_QStyleOptionMenuItem__StyleOptionType 3216
#define sipName_QStyleOptionMenuItem__StyleOptionType &sipStrings_QtGui[3216]
#define sipNameNr_QStyleOptionTabV2__StyleOptionVersion 3254
#define sipName_QStyleOptionTabV2__StyleOptionVersion &sipStrings_QtGui[3254]
#define sipNameNr_QStyleOptionFrame__StyleOptionVersion 3292
#define sipName_QStyleOptionFrame__StyleOptionVersion &sipStrings_QtGui[3292]
#define sipNameNr_SH_ItemView_ActivateItemOnSingleClick 3330
#define sipName_SH_ItemView_ActivateItemOnSingleClick &sipStrings_QtGui[3330]
#define sipNameNr_SH_ScrollView_FrameOnlyAroundContents 3368
#define sipName_SH_ScrollView_FrameOnlyAroundContents &sipStrings_QtGui[3368]
#define sipNameNr_QIconEngineV2__AvailableSizesArgument 3406
#define sipName_QIconEngineV2__AvailableSizesArgument &sipStrings_QtGui[3406]
#define sipNameNr_AdjustToMinimumContentsLengthWithIcon 3444
#define sipName_AdjustToMinimumContentsLengthWithIcon &sipStrings_QtGui[3444]
#define sipNameNr_QCalendarWidget__VerticalHeaderFormat 3482
#define sipName_QCalendarWidget__VerticalHeaderFormat &sipStrings_QtGui[3482]
#define sipNameNr_QStyleOptionToolBar__ToolBarFeatures 3520
#define sipName_QStyleOptionToolBar__ToolBarFeatures &sipStrings_QtGui[3520]
#define sipNameNr_QStyleOptionToolBar__ToolBarPosition 3557
#define sipName_QStyleOptionToolBar__ToolBarPosition &sipStrings_QtGui[3557]
#define sipNameNr_QStyleOptionToolBar__StyleOptionType 3594
#define sipName_QStyleOptionToolBar__StyleOptionType &sipStrings_QtGui[3594]
#define sipNameNr_QStyleHintReturn__StyleOptionVersion 3631
#define sipName_QStyleHintReturn__StyleOptionVersion &sipStrings_QtGui[3631]
#define sipNameNr_QStyleOptionSpinBox__StyleOptionType 3668
#define sipName_QStyleOptionSpinBox__StyleOptionType &sipStrings_QtGui[3668]
#define sipNameNr_QStyleOptionComplex__StyleOptionType 3705
#define sipName_QStyleOptionComplex__StyleOptionType &sipStrings_QtGui[3705]
#define sipNameNr_QStyleOptionToolBox__StyleOptionType 3742
#define sipName_QStyleOptionToolBox__StyleOptionType &sipStrings_QtGui[3742]
#define sipNameNr_QStyleOptionHeader__SelectedPosition 3779
#define sipName_QStyleOptionHeader__SelectedPosition &sipStrings_QtGui[3779]
#define sipNameNr_SH_ProgressDialog_TextLabelAlignment 3816
#define sipName_SH_ProgressDialog_TextLabelAlignment &sipStrings_QtGui[3816]
#define sipNameNr_SH_ProgressDialog_CenterCancelButton 3853
#define sipName_SH_ProgressDialog_CenterCancelButton &sipStrings_QtGui[3853]
#define sipNameNr_QPrintEngine__PrintEnginePropertyKey 3890
#define sipName_QPrintEngine__PrintEnginePropertyKey &sipStrings_QtGui[3890]
#define sipNameNr_ItemDoesntPropagateOpacityToChildren 3927
#define sipName_ItemDoesntPropagateOpacityToChildren &sipStrings_QtGui[3927]
#define sipNameNr_QAbstractItemView__SelectionBehavior 3964
#define sipName_QAbstractItemView__SelectionBehavior &sipStrings_QtGui[3964]
#define sipNameNr_4001 4001
#define sipName_4001 &sipStrings_QtGui[4001]
#define sipNameNr_QStyleOptionToolBar__ToolBarFeature 4037
#define sipName_QStyleOptionToolBar__ToolBarFeature &sipStrings_QtGui[4037]
#define sipNameNr_QStyleOptionSlider__StyleOptionType 4073
#define sipName_QStyleOptionSlider__StyleOptionType &sipStrings_QtGui[4073]
#define sipNameNr_QStyleOptionTab__StyleOptionVersion 4109
#define sipName_QStyleOptionTab__StyleOptionVersion &sipStrings_QtGui[4109]
#define sipNameNr_QStyleOptionButton__StyleOptionType 4145
#define sipName_QStyleOptionButton__StyleOptionType &sipStrings_QtGui[4145]
#define sipNameNr_QStyleOptionHeader__SectionPosition 4181
#define sipName_QStyleOptionHeader__SectionPosition &sipStrings_QtGui[4181]
#define sipNameNr_QStyleOptionHeader__StyleOptionType 4217
#define sipName_QStyleOptionHeader__StyleOptionType &sipStrings_QtGui[4217]
#define sipNameNr_SP_ToolBarHorizontalExtensionButton 4253
#define sipName_SP_ToolBarHorizontalExtensionButton &sipStrings_QtGui[4253]
#define sipNameNr_SH_SpinBox_ClickAutoRepeatThreshold 4289
#define sipName_SH_SpinBox_ClickAutoRepeatThreshold &sipStrings_QtGui[4289]
#define sipNameNr_SH_DialogButtonBox_ButtonsHaveIcons 4325
#define sipName_SH_DialogButtonBox_ButtonsHaveIcons &sipStrings_QtGui[4325]
#define sipNameNr_SH_Q3ListViewExpand_SelectMouseType 4361
#define sipName_SH_Q3ListViewExpand_SelectMouseType &sipStrings_QtGui[4361]
#define sipNameNr_RasterOp_NotSourceAndNotDestination 4397
#define sipName_RasterOp_NotSourceAndNotDestination &sipStrings_QtGui[4397]
#define sipNameNr_QItemSelectionModel__SelectionFlags 4433
#define sipName_QItemSelectionModel__SelectionFlags &sipStrings_QtGui[4433]
#define sipNameNr_4469 4469
#define sipName_4469 &sipStrings_QtGui[4469]
#define sipNameNr_QTextCharFormat__VerticalAlignment 4505
#define sipName_QTextCharFormat__VerticalAlignment &sipStrings_QtGui[4505]
#define sipNameNr_QStyleOptionToolBoxV2__TabPosition 4540
#define sipName_QStyleOptionToolBoxV2__TabPosition &sipStrings_QtGui[4540]
#define sipNameNr_QStyleOptionMenuItem__MenuItemType 4575
#define sipName_QStyleOptionMenuItem__MenuItemType &sipStrings_QtGui[4575]
#define sipNameNr_QStyleOptionButton__ButtonFeatures 4610
#define sipName_QStyleOptionButton__ButtonFeatures &sipStrings_QtGui[4610]
#define sipNameNr_QStyleOptionFrameV2__FrameFeatures 4645
#define sipName_QStyleOptionFrameV2__FrameFeatures &sipStrings_QtGui[4645]
#define sipNameNr_QStyleOptionFrame__StyleOptionType 4680
#define sipName_QStyleOptionFrame__StyleOptionType &sipStrings_QtGui[4680]
#define sipNameNr_SH_MessageBox_TextInteractionFlags 4715
#define sipName_SH_MessageBox_TextInteractionFlags &sipStrings_QtGui[4715]
#define sipNameNr_SH_ItemView_ShowDecorationSelected 4750
#define sipName_SH_ItemView_ShowDecorationSelected &sipStrings_QtGui[4750]
#define sipNameNr_SH_ItemView_ChangeHighlightOnFocus 4785
#define sipName_SH_ItemView_ChangeHighlightOnFocus &sipStrings_QtGui[4785]
#define sipNameNr_SH_FontDialog_SelectAssociatedText 4820
#define sipName_SH_FontDialog_SelectAssociatedText &sipStrings_QtGui[4820]
#define sipNameNr_PE_IndicatorDockWidgetResizeHandle 4855
#define sipName_PE_IndicatorDockWidgetResizeHandle &sipStrings_QtGui[4855]
#define sipNameNr_RasterOp_NotSourceOrNotDestination 4890
#define sipName_RasterOp_NotSourceOrNotDestination &sipStrings_QtGui[4890]
#define sipNameNr_QItemSelectionModel__SelectionFlag 4925
#define sipName_QItemSelectionModel__SelectionFlag &sipStrings_QtGui[4925]
#define sipNameNr_QDesktopServices__StandardLocation 4960
#define sipName_QDesktopServices__StandardLocation &sipStrings_QtGui[4960]
#define sipNameNr_QAbstractItemDelegate__EndEditHint 4995
#define sipName_QAbstractItemDelegate__EndEditHint &sipStrings_QtGui[4995]
#define sipNameNr_5030 5030
#define sipName_5030 &sipStrings_QtGui[5030]
#define sipNameNr_5064 5064
#define sipName_5064 &sipStrings_QtGui[5064]
#define sipNameNr_BlockTrailingHorizontalRulerWidth 5098
#define sipName_BlockTrailingHorizontalRulerWidth &sipStrings_QtGui[5098]
#define sipNameNr_QSystemTrayIcon__ActivationReason 5132
#define sipName_QSystemTrayIcon__ActivationReason &sipStrings_QtGui[5132]
#define sipNameNr_QStyleHintReturn__StyleOptionType 5166
#define sipName_QStyleHintReturn__StyleOptionType &sipStrings_QtGui[5166]
#define sipNameNr_QStyleOptionTab__SelectedPosition 5200
#define sipName_QStyleOptionTab__SelectedPosition &sipStrings_QtGui[5200]
#define sipNameNr_QStyleOptionButton__ButtonFeature 5234
#define sipName_QStyleOptionButton__ButtonFeature &sipStrings_QtGui[5234]
#define sipNameNr_QStyleOptionHeader__SortIndicator 5268
#define sipName_QStyleOptionHeader__SortIndicator &sipStrings_QtGui[5268]
#define sipNameNr_QStyleOptionFrameV2__FrameFeature 5302
#define sipName_QStyleOptionFrameV2__FrameFeature &sipStrings_QtGui[5302]
#define sipNameNr_SP_ToolBarVerticalExtensionButton 5336
#define sipName_SP_ToolBarVerticalExtensionButton &sipStrings_QtGui[5336]
#define sipNameNr_SH_SpinBox_KeyPressAutoRepeatRate 5370
#define sipName_SH_SpinBox_KeyPressAutoRepeatRate &sipStrings_QtGui[5370]
#define sipNameNr_PM_DockWidgetTitleBarButtonMargin 5404
#define sipName_PM_DockWidgetTitleBarButtonMargin &sipStrings_QtGui[5404]
#define sipNameNr_QPaintEngine__PaintEngineFeatures 5438
#define sipName_QPaintEngine__PaintEngineFeatures &sipStrings_QtGui[5438]
#define sipNameNr_DontMaximizeSubWindowOnActivation 5472
#define sipName_DontMaximizeSubWindowOnActivation &sipStrings_QtGui[5472]
#define sipNameNr_QGraphicsView__ViewportUpdateMode 5506
#define sipName_QGraphicsView__ViewportUpdateMode &sipStrings_QtGui[5506]
#define sipNameNr_QGraphicsItem__GraphicsItemChange 5540
#define sipName_QGraphicsItem__GraphicsItemChange &sipStrings_QtGui[5540]
#define sipNameNr_QDialogButtonBox__StandardButtons 5574
#define sipName_QDialogButtonBox__StandardButtons &sipStrings_QtGui[5574]
#define sipNameNr_QAbstractSpinBox__StepEnabledFlag 5608
#define sipName_QAbstractSpinBox__StepEnabledFlag &sipStrings_QtGui[5608]
#define sipNameNr_5642 5642
#define sipName_5642 &sipStrings_QtGui[5642]
#define sipNameNr_QToolButton__ToolButtonPopupMode 5675
#define sipName_QToolButton__ToolButtonPopupMode &sipStrings_QtGui[5675]
#define sipNameNr_QStyleHintReturn__HintReturnType 5708
#define sipName_QStyleHintReturn__HintReturnType &sipStrings_QtGui[5708]
#define sipNameNr_QStyleOptionTab__StyleOptionType 5741
#define sipName_QStyleOptionTab__StyleOptionType &sipStrings_QtGui[5741]
#define sipNameNr_QStyleOption__StyleOptionVersion 5774
#define sipName_QStyleOption__StyleOptionVersion &sipStrings_QtGui[5774]
#define sipNameNr_SH_ToolBox_SelectedPageTitleBold 5807
#define sipName_SH_ToolBox_SelectedPageTitleBold &sipStrings_QtGui[5807]
#define sipNameNr_SH_ScrollBar_StopMouseOverSlider 5840
#define sipName_SH_ScrollBar_StopMouseOverSlider &sipStrings_QtGui[5840]
#define sipNameNr_SH_Workspace_FillSpaceOnMaximize 5873
#define sipName_SH_Workspace_FillSpaceOnMaximize &sipStrings_QtGui[5873]
#define sipNameNr_SH_PrintDialog_RightAlignButtons 5906
#define sipName_SH_PrintDialog_RightAlignButtons &sipStrings_QtGui[5906]
#define sipNameNr_PE_Q3CheckListExclusiveIndicator 5939
#define sipName_PE_Q3CheckListExclusiveIndicator &sipStrings_QtGui[5939]
#define sipNameNr_QPaintEngine__PaintEngineFeature 5972
#define sipName_QPaintEngine__PaintEngineFeature &sipStrings_QtGui[5972]
#define sipNameNr_RasterOp_SourceAndNotDestination 6005
#define sipName_RasterOp_SourceAndNotDestination &sipStrings_QtGui[6005]
#define sipNameNr_RasterOp_NotSourceAndDestination 6038
#define sipName_RasterOp_NotSourceAndDestination &sipStrings_QtGui[6038]
#define sipNameNr_RasterOp_NotSourceXorDestination 6071
#define sipName_RasterOp_NotSourceXorDestination &sipStrings_QtGui[6071]
#define sipNameNr_QInputDialog__InputDialogOptions 6104
#define sipName_QInputDialog__InputDialogOptions &sipStrings_QtGui[6104]
#define sipNameNr_QGraphicsView__OptimizationFlags 6137
#define sipName_QGraphicsView__OptimizationFlags &sipStrings_QtGui[6137]
#define sipNameNr_QGraphicsItem__GraphicsItemFlags 6170
#define sipName_QGraphicsItem__GraphicsItemFlags &sipStrings_QtGui[6170]
#define sipNameNr_QInputMethodEvent__AttributeType 6203
#define sipName_QInputMethodEvent__AttributeType &sipStrings_QtGui[6203]
#define sipNameNr_QDialogButtonBox__StandardButton 6236
#define sipName_QDialogButtonBox__StandardButton &sipStrings_QtGui[6236]
#define sipNameNr_setAutoCompletionCaseSensitivity 6269
#define sipName_setAutoCompletionCaseSensitivity &sipStrings_QtGui[6269]
#define sipNameNr_QColorDialog__ColorDialogOptions 6302
#define sipName_QColorDialog__ColorDialogOptions &sipStrings_QtGui[6302]
#define sipNameNr_QAbstractSpinBox__CorrectionMode 6335
#define sipName_QAbstractSpinBox__CorrectionMode &sipStrings_QtGui[6335]
#define sipNameNr_QAbstractPrintDialog__PrintRange 6368
#define sipName_QAbstractPrintDialog__PrintRange &sipStrings_QtGui[6368]
#define sipNameNr_QAbstractItemView__SelectionMode 6401
#define sipName_QAbstractItemView__SelectionMode &sipStrings_QtGui[6401]
#define sipNameNr_6434 6434
#define sipName_6434 &sipStrings_QtGui[6434]
#define sipNameNr_QTextCharFormat__UnderlineStyle 6466
#define sipName_QTextCharFormat__UnderlineStyle &sipStrings_QtGui[6466]
#define sipNameNr_QStyleOptionMenuItem__CheckType 6498
#define sipName_QStyleOptionMenuItem__CheckType &sipStrings_QtGui[6498]
#define sipNameNr_SH_TabWidget_DefaultTabPosition 6530
#define sipName_SH_TabWidget_DefaultTabPosition &sipStrings_QtGui[6530]
#define sipNameNr_SH_ScrollBar_RollBetweenButtons 6562
#define sipName_SH_ScrollBar_RollBetweenButtons &sipStrings_QtGui[6562]
#define sipNameNr_SH_SpinControls_DisableOnBounds 6594
#define sipName_SH_SpinControls_DisableOnBounds &sipStrings_QtGui[6594]
#define sipNameNr_SH_MenuBar_DismissOnSecondClick 6626
#define sipName_SH_MenuBar_DismissOnSecondClick &sipStrings_QtGui[6626]
#define sipNameNr_SH_MainWindow_SpaceBelowMenuBar 6658
#define sipName_SH_MainWindow_SpaceBelowMenuBar &sipStrings_QtGui[6658]
#define sipNameNr_QPaintDevice__PaintDeviceMetric 6690
#define sipName_QPaintDevice__PaintDeviceMetric &sipStrings_QtGui[6690]
#define sipNameNr_CompositionMode_DestinationAtop 6722
#define sipName_CompositionMode_DestinationAtop &sipStrings_QtGui[6722]
#define sipNameNr_CompositionMode_DestinationOver 6754
#define sipName_CompositionMode_DestinationOver &sipStrings_QtGui[6754]
#define sipNameNr_QMdiSubWindow__SubWindowOptions 6786
#define sipName_QMdiSubWindow__SubWindowOptions &sipStrings_QtGui[6786]
#define sipNameNr_QInputDialog__InputDialogOption 6818
#define sipName_QInputDialog__InputDialogOption &sipStrings_QtGui[6818]
#define sipNameNr_QGraphicsView__OptimizationFlag 6850
#define sipName_QGraphicsView__OptimizationFlag &sipStrings_QtGui[6850]
#define sipNameNr_QGraphicsScene__ItemIndexMethod 6882
#define sipName_QGraphicsScene__ItemIndexMethod &sipStrings_QtGui[6882]
#define sipNameNr_QGraphicsItem__GraphicsItemFlag 6914
#define sipName_QGraphicsItem__GraphicsItemFlag &sipStrings_QtGui[6914]
#define sipNameNr_QDockWidget__DockWidgetFeatures 6946
#define sipName_QDockWidget__DockWidgetFeatures &sipStrings_QtGui[6946]
#define sipNameNr_QDataWidgetMapper__SubmitPolicy 6978
#define sipName_QDataWidgetMapper__SubmitPolicy &sipStrings_QtGui[6978]
#define sipNameNr_QColorDialog__ColorDialogOption 7010
#define sipName_QColorDialog__ColorDialogOption &sipStrings_QtGui[7010]
#define sipNameNr_QAbstractSpinBox__ButtonSymbols 7042
#define sipName_QAbstractSpinBox__ButtonSymbols &sipStrings_QtGui[7042]
#define sipNameNr_QAbstractItemView__CursorAction 7074
#define sipName_QAbstractItemView__CursorAction &sipStrings_QtGui[7074]
#define sipNameNr_horizontalScrollbarValueChanged 7106
#define sipName_horizontalScrollbarValueChanged &sipStrings_QtGui[7106]
#define sipNameNr_QAbstractItemView__EditTriggers 7138
#define sipName_QAbstractItemView__EditTriggers &sipStrings_QtGui[7138]
#define sipNameNr_QAbstractItemView__DragDropMode 7170
#define sipName_QAbstractItemView__DragDropMode &sipStrings_QtGui[7170]
#define sipNameNr_DontShowIndicatorWhenChildless 7202
#define sipName_DontShowIndicatorWhenChildless &sipStrings_QtGui[7202]
#define sipNameNr_QTransform__TransformationType 7233
#define sipName_QTransform__TransformationType &sipStrings_QtGui[7233]
#define sipNameNr_ShowLineAndParagraphSeparators 7264
#define sipName_ShowLineAndParagraphSeparators &sipStrings_QtGui[7264]
#define sipNameNr_QTextDocument__MetaInformation 7295
#define sipName_QTextDocument__MetaInformation &sipStrings_QtGui[7295]
#define sipNameNr_QStyleOptionViewItem__Position 7326
#define sipName_QStyleOptionViewItem__Position &sipStrings_QtGui[7326]
#define sipNameNr_QStyleOptionTab__CornerWidgets 7357
#define sipName_QStyleOptionTab__CornerWidgets &sipStrings_QtGui[7357]
#define sipNameNr_SH_DockWidget_ButtonsHaveFrame 7388
#define sipName_SH_DockWidget_ButtonsHaveFrame &sipStrings_QtGui[7388]
#define sipNameNr_SH_FormLayoutFieldGrowthPolicy 7419
#define sipName_SH_FormLayoutFieldGrowthPolicy &sipStrings_QtGui[7419]
#define sipNameNr_SH_TitleBar_ModifyNotification 7450
#define sipName_SH_TitleBar_ModifyNotification &sipStrings_QtGui[7450]
#define sipNameNr_SH_SpinBox_ClickAutoRepeatRate 7481
#define sipName_SH_SpinBox_ClickAutoRepeatRate &sipStrings_QtGui[7481]
#define sipNameNr_SH_DialogButtons_DefaultButton 7512
#define sipName_SH_DialogButtons_DefaultButton &sipStrings_QtGui[7512]
#define sipNameNr_SH_RichText_FullWidthSelection 7543
#define sipName_SH_RichText_FullWidthSelection &sipStrings_QtGui[7543]
#define sipNameNr_SH_BlinkCursorWhenTextSelected 7574
#define sipName_SH_BlinkCursorWhenTextSelected &sipStrings_QtGui[7574]
#define sipNameNr_SH_Menu_AllowActiveAndDisabled 7605
#define sipName_SH_Menu_AllowActiveAndDisabled &sipStrings_QtGui[7605]
#define sipNameNr_PM_ScrollView_ScrollBarSpacing 7636
#define sipName_PM_ScrollView_ScrollBarSpacing &sipStrings_QtGui[7636]
#define sipNameNr_CompositionMode_DestinationOut 7667
#define sipName_CompositionMode_DestinationOut &sipStrings_QtGui[7667]
#define sipNameNr_QMdiSubWindow__SubWindowOption 7698
#define sipName_QMdiSubWindow__SubWindowOption &sipStrings_QtGui[7698]
#define sipNameNr_setUnifiedTitleAndToolBarOnMac 7729
#define sipName_setUnifiedTitleAndToolBarOnMac &sipStrings_QtGui[7729]
#define sipNameNr_QImageWriter__ImageWriterError 7760
#define sipName_QImageWriter__ImageWriterError &sipStrings_QtGui[7760]
#define sipNameNr_QImageReader__ImageReaderError 7791
#define sipName_QImageReader__ImageReaderError &sipStrings_QtGui[7791]
#define sipNameNr_QGraphicsSceneContextMenuEvent 7822
#define sipName_QGraphicsSceneContextMenuEvent &sipStrings_QtGui[7822]
#define sipNameNr_QGraphicsPixmapItem__ShapeMode 7853
#define sipName_QGraphicsPixmapItem__ShapeMode &sipStrings_QtGui[7853]
#define sipNameNr_QFormLayout__FieldGrowthPolicy 7884
#define sipName_QFormLayout__FieldGrowthPolicy &sipStrings_QtGui[7884]
#define sipNameNr_QFontDialog__FontDialogOptions 7915
#define sipName_QFontDialog__FontDialogOptions &sipStrings_QtGui[7915]
#define sipNameNr_QDockWidget__DockWidgetFeature 7946
#define sipName_QDockWidget__DockWidgetFeature &sipStrings_QtGui[7946]
#define sipNameNr_QDialogButtonBox__ButtonLayout 7977
#define sipName_QDialogButtonBox__ButtonLayout &sipStrings_QtGui[7977]
#define sipNameNr_QCalendarWidget__SelectionMode 8008
#define sipName_QCalendarWidget__SelectionMode &sipStrings_QtGui[8008]
#define sipNameNr_qt_x11_wait_for_window_manager 8039
#define sipName_qt_x11_wait_for_window_manager &sipStrings_QtGui[8039]
#define sipNameNr_QAbstractItemView__EditTrigger 8070
#define sipName_QAbstractItemView__EditTrigger &sipStrings_QtGui[8070]
#define sipNameNr_8101 8101
#define sipName_8101 &sipStrings_QtGui[8101]
#define sipNameNr_QTextFrameFormat__BorderStyle 8131
#define sipName_QTextFrameFormat__BorderStyle &sipStrings_QtGui[8131]
#define sipNameNr_QTextEdit__AutoFormattingFlag 8161
#define sipName_QTextEdit__AutoFormattingFlag &sipStrings_QtGui[8161]
#define sipNameNr_QStyleOptionTab__CornerWidget 8191
#define sipName_QStyleOptionTab__CornerWidget &sipStrings_QtGui[8191]
#define sipNameNr_QStyleOption__StyleOptionType 8221
#define sipName_QStyleOption__StyleOptionType &sipStrings_QtGui[8221]
#define sipNameNr_SH_TabBar_CloseButtonPosition 8251
#define sipName_SH_TabBar_CloseButtonPosition &sipStrings_QtGui[8251]
#define sipNameNr_SH_ItemView_DrawDelegateFrame 8281
#define sipName_SH_ItemView_DrawDelegateFrame &sipStrings_QtGui[8281]
#define sipNameNr_SH_Slider_StopMouseOverSlider 8311
#define sipName_SH_Slider_StopMouseOverSlider &sipStrings_QtGui[8311]
#define sipNameNr_SH_LineEdit_PasswordCharacter 8341
#define sipName_SH_LineEdit_PasswordCharacter &sipStrings_QtGui[8341]
#define sipNameNr_SH_ComboBox_ListMouseTracking 8371
#define sipName_SH_ComboBox_ListMouseTracking &sipStrings_QtGui[8371]
#define sipNameNr_PM_TabBar_ScrollButtonOverlap 8401
#define sipName_PM_TabBar_ScrollButtonOverlap &sipStrings_QtGui[8401]
#define sipNameNr_PM_MdiSubWindowMinimizedWidth 8431
#define sipName_PM_MdiSubWindowMinimizedWidth &sipStrings_QtGui[8431]
#define sipNameNr_SE_ItemViewItemCheckIndicator 8461
#define sipName_SE_ItemViewItemCheckIndicator &sipStrings_QtGui[8461]
#define sipNameNr_PE_IndicatorItemViewItemCheck 8491
#define sipName_PE_IndicatorItemViewItemCheck &sipStrings_QtGui[8491]
#define sipNameNr_QPrintPreviewWidget__ZoomMode 8521
#define sipName_QPrintPreviewWidget__ZoomMode &sipStrings_QtGui[8521]
#define sipNameNr_QPrintPreviewWidget__ViewMode 8551
#define sipName_QPrintPreviewWidget__ViewMode &sipStrings_QtGui[8551]
#define sipNameNr_PPK_SuppressSystemPrintStatus 8581
#define sipName_PPK_SuppressSystemPrintStatus &sipStrings_QtGui[8581]
#define sipNameNr_QPaintEngine__PolygonDrawMode 8611
#define sipName_QPaintEngine__PolygonDrawMode &sipStrings_QtGui[8611]
#define sipNameNr_RasterOp_SourceXorDestination 8641
#define sipName_RasterOp_SourceXorDestination &sipStrings_QtGui[8641]
#define sipNameNr_RasterOp_SourceAndDestination 8671
#define sipName_RasterOp_SourceAndDestination &sipStrings_QtGui[8671]
#define sipNameNr_CompositionMode_DestinationIn 8701
#define sipName_CompositionMode_DestinationIn &sipStrings_QtGui[8701]
#define sipNameNr_QInputContext__StandardFormat 8731
#define sipName_QInputContext__StandardFormat &sipStrings_QtGui[8731]
#define sipNameNr_Format_ARGB4444_Premultiplied 8761
#define sipName_Format_ARGB4444_Premultiplied &sipStrings_QtGui[8761]
#define sipNameNr_Format_ARGB8555_Premultiplied 8791
#define sipName_Format_ARGB8555_Premultiplied &sipStrings_QtGui[8791]
#define sipNameNr_Format_ARGB6666_Premultiplied 8821
#define sipName_Format_ARGB6666_Premultiplied &sipStrings_QtGui[8821]
#define sipNameNr_Format_ARGB8565_Premultiplied 8851
#define sipName_Format_ARGB8565_Premultiplied &sipStrings_QtGui[8851]
#define sipNameNr_QIconEngineV2__IconEngineHook 8881
#define sipName_QIconEngineV2__IconEngineHook &sipStrings_QtGui[8881]
#define sipNameNr_QGraphicsView__ViewportAnchor 8911
#define sipName_QGraphicsView__ViewportAnchor &sipStrings_QtGui[8911]
#define sipNameNr_QFontDialog__FontDialogOption 8941
#define sipName_QFontDialog__FontDialogOption &sipStrings_QtGui[8941]
#define sipNameNr_supportsThreadedFontRendering 8971
#define sipName_supportsThreadedFontRendering &sipStrings_QtGui[8971]
#define sipNameNr_AdjustToMinimumContentsLength 9001
#define sipName_AdjustToMinimumContentsLength &sipStrings_QtGui[9001]
#define sipNameNr_autoCompletionCaseSensitivity 9031
#define sipName_autoCompletionCaseSensitivity &sipStrings_QtGui[9031]
#define sipNameNr_QAbstractSlider__SliderChange 9061
#define sipName_QAbstractSlider__SliderChange &sipStrings_QtGui[9061]
#define sipNameNr_QAbstractSlider__SliderAction 9091
#define sipName_QAbstractSlider__SliderAction &sipStrings_QtGui[9091]
#define sipNameNr_QAbstractSpinBox__StepEnabled 9121
#define sipName_QAbstractSpinBox__StepEnabled &sipStrings_QtGui[9121]
#define sipNameNr_verticalScrollbarValueChanged 9151
#define sipName_verticalScrollbarValueChanged &sipStrings_QtGui[9151]
#define sipNameNr_QAbstractItemView__ScrollMode 9181
#define sipName_QAbstractItemView__ScrollMode &sipStrings_QtGui[9181]
#define sipNameNr_QAbstractItemView__ScrollHint 9211
#define sipName_QAbstractItemView__ScrollHint &sipStrings_QtGui[9211]
#define sipNameNr_9241 9241
#define sipName_9241 &sipStrings_QtGui[9241]
#define sipNameNr_9270 9270
#define sipName_9270 &sipStrings_QtGui[9270]
#define sipNameNr_HaveFinishButtonOnEarlyPages 9299
#define sipName_HaveFinishButtonOnEarlyPages &sipStrings_QtGui[9299]
#define sipNameNr_DisabledBackButtonOnLastPage 9328
#define sipName_DisabledBackButtonOnLastPage &sipStrings_QtGui[9328]
#define sipNameNr_WrapAtWordBoundaryOrAnywhere 9357
#define sipName_WrapAtWordBoundaryOrAnywhere &sipStrings_QtGui[9357]
#define sipNameNr_setSelectionBehaviorOnRemove 9386
#define sipName_setSelectionBehaviorOnRemove &sipStrings_QtGui[9386]
#define sipNameNr_QSystemTrayIcon__MessageIcon 9415
#define sipName_QSystemTrayIcon__MessageIcon &sipStrings_QtGui[9415]
#define sipNameNr_QStyleOptionTab__TabPosition 9444
#define sipName_QStyleOptionTab__TabPosition &sipStrings_QtGui[9444]
#define sipNameNr_SP_TitleBarContextHelpButton 9473
#define sipName_SP_TitleBarContextHelpButton &sipStrings_QtGui[9473]
#define sipNameNr_SH_Slider_AbsoluteSetButtons 9502
#define sipName_SH_Slider_AbsoluteSetButtons &sipStrings_QtGui[9502]
#define sipNameNr_SH_ItemView_EllipsisLocation 9531
#define sipName_SH_ItemView_EllipsisLocation &sipStrings_QtGui[9531]
#define sipNameNr_SH_Menu_FillScreenWithScroll 9560
#define sipName_SH_Menu_FillScreenWithScroll &sipStrings_QtGui[9560]
#define sipNameNr_PM_DialogButtonsButtonHeight 9589
#define sipName_PM_DialogButtonsButtonHeight &sipStrings_QtGui[9589]
#define sipNameNr_PM_DockWidgetSeparatorExtent 9618
#define sipName_PM_DockWidgetSeparatorExtent &sipStrings_QtGui[9618]
#define sipNameNr_SC_TitleBarContextHelpButton 9647
#define sipName_SC_TitleBarContextHelpButton &sipStrings_QtGui[9647]
#define sipNameNr_SE_DialogButtonBoxLayoutItem 9676
#define sipName_SE_DialogButtonBoxLayoutItem &sipStrings_QtGui[9676]
#define sipNameNr_PE_IndicatorItemViewItemDrop 9705
#define sipName_PE_IndicatorItemViewItemDrop &sipStrings_QtGui[9705]
#define sipNameNr_PE_IndicatorToolBarSeparator 9734
#define sipName_PE_IndicatorToolBarSeparator &sipStrings_QtGui[9734]
#define sipNameNr_QStackedLayout__StackingMode 9763
#define sipName_QStackedLayout__StackingMode &sipStrings_QtGui[9763]
#define sipNameNr_QSessionManager__RestartHint 9792
#define sipName_QSessionManager__RestartHint &sipStrings_QtGui[9792]
#define sipNameNr_QPlainTextEdit__LineWrapMode 9821
#define sipName_QPlainTextEdit__LineWrapMode &sipStrings_QtGui[9821]
#define sipNameNr_RasterOp_SourceOrDestination 9850
#define sipName_RasterOp_SourceOrDestination &sipStrings_QtGui[9850]
#define sipNameNr_QMessageBox__StandardButtons 9879
#define sipName_QMessageBox__StandardButtons &sipStrings_QtGui[9879]
#define sipNameNr_QKeySequence__SequenceFormat 9908
#define sipName_QKeySequence__SequenceFormat &sipStrings_QtGui[9908]
#define sipNameNr_QImageIOHandler__ImageOption 9937
#define sipName_QImageIOHandler__ImageOption &sipStrings_QtGui[9937]
#define sipNameNr_QGraphicsView__CacheModeFlag 9966
#define sipName_QGraphicsView__CacheModeFlag &sipStrings_QtGui[9966]
#define sipNameNr_setBoundingRegionGranularity 9995
#define sipName_setBoundingRegionGranularity &sipStrings_QtGui[9995]
#define sipNameNr_QFontDatabase__WritingSystem 10024
#define sipName_QFontDatabase__WritingSystem &sipStrings_QtGui[10024]
#define sipNameNr_QInputMethodEvent__Attribute 10053
#define sipName_QInputMethodEvent__Attribute &sipStrings_QtGui[10053]
#define sipNameNr_QDialogButtonBox__ButtonRole 10082
#define sipName_QDialogButtonBox__ButtonRole &sipStrings_QtGui[10082]
#define sipNameNr_CaseInsensitivelySortedModel 10111
#define sipName_CaseInsensitivelySortedModel &sipStrings_QtGui[10111]
#define sipNameNr_setHorizontalScrollBarPolicy 10140
#define sipName_setHorizontalScrollBarPolicy &sipStrings_QtGui[10140]
#define sipNameNr_PyQt4_QtCore_pyqtWrapperType 10169
#define sipName_PyQt4_QtCore_pyqtWrapperType &sipStrings_QtGui[10169]
#define sipNameNr_10198 10198
#define sipName_10198 &sipStrings_QtGui[10198]
#define sipNameNr_isCompositingManagerRunning 10226
#define sipName_isCompositingManagerRunning &sipStrings_QtGui[10226]
#define sipNameNr_clearColumnWidthConstraints 10254
#define sipName_clearColumnWidthConstraints &sipStrings_QtGui[10254]
#define sipNameNr_TableColumnWidthConstraints 10282
#define sipName_TableColumnWidthConstraints &sipStrings_QtGui[10282]
#define sipNameNr_QTextFormat__PageBreakFlags 10310
#define sipName_QTextFormat__PageBreakFlags &sipStrings_QtGui[10310]
#define sipNameNr_QTextDocument__ResourceType 10338
#define sipName_QTextDocument__ResourceType &sipStrings_QtGui[10338]
#define sipNameNr_layoutSpacingImplementation 10366
#define sipName_layoutSpacingImplementation &sipStrings_QtGui[10366]
#define sipNameNr_SH_FormLayoutLabelAlignment 10394
#define sipName_SH_FormLayoutLabelAlignment &sipStrings_QtGui[10394]
#define sipNameNr_SH_MessageBox_CenterButtons 10422
#define sipName_SH_MessageBox_CenterButtons &sipStrings_QtGui[10422]
#define sipNameNr_SH_SpellCheckUnderlineStyle 10450
#define sipName_SH_SpellCheckUnderlineStyle &sipStrings_QtGui[10450]
#define sipNameNr_SH_ComboBox_PopupFrameStyle 10478
#define sipName_SH_ComboBox_PopupFrameStyle &sipStrings_QtGui[10478]
#define sipNameNr_SH_ComboBox_LayoutDirection 10506
#define sipName_SH_ComboBox_LayoutDirection &sipStrings_QtGui[10506]
#define sipNameNr_SH_MenuBar_AltKeyNavigation 10534
#define sipName_SH_MenuBar_AltKeyNavigation &sipStrings_QtGui[10534]
#define sipNameNr_PM_TabBarTabShiftHorizontal 10562
#define sipName_PM_TabBarTabShiftHorizontal &sipStrings_QtGui[10562]
#define sipNameNr_PM_DialogButtonsButtonWidth 10590
#define sipName_PM_DialogButtonsButtonWidth &sipStrings_QtGui[10590]
#define sipNameNr_PM_ExclusiveIndicatorHeight 10618
#define sipName_PM_ExclusiveIndicatorHeight &sipStrings_QtGui[10618]
#define sipNameNr_PE_IndicatorColumnViewArrow 10646
#define sipName_PE_IndicatorColumnViewArrow &sipStrings_QtGui[10646]
#define sipNameNr_createMimeDataFromSelection 10674
#define sipName_createMimeDataFromSelection &sipStrings_QtGui[10674]
#define sipNameNr_ObjectBoundingModeGradients 10702
#define sipName_ObjectBoundingModeGradients &sipStrings_QtGui[10702]
#define sipNameNr_CompositionMode_Destination 10730
#define sipName_CompositionMode_Destination &sipStrings_QtGui[10730]
#define sipNameNr_QMessageBox__StandardButton 10758
#define sipName_QMessageBox__StandardButton &sipStrings_QtGui[10758]
#define sipNameNr_unifiedTitleAndToolBarOnMac 10786
#define sipName_unifiedTitleAndToolBarOnMac &sipStrings_QtGui[10786]
#define sipNameNr_QKeySequence__SequenceMatch 10814
#define sipName_QKeySequence__SequenceMatch &sipStrings_QtGui[10814]
#define sipNameNr_UseListViewForComboBoxItems 10842
#define sipName_UseListViewForComboBoxItems &sipStrings_QtGui[10842]
#define sipNameNr_Format_ARGB32_Premultiplied 10870
#define sipName_Format_ARGB32_Premultiplied &sipStrings_QtGui[10870]
#define sipNameNr_QGraphicsSceneDragDropEvent 10898
#define sipName_QGraphicsSceneDragDropEvent &sipStrings_QtGui[10898]
#define sipNameNr_QGraphicsScene__SceneLayers 10926
#define sipName_QGraphicsScene__SceneLayers &sipStrings_QtGui[10926]
#define sipNameNr_QFileIconProvider__IconType 10954
#define sipName_QFileIconProvider__IconType &sipStrings_QtGui[10954]
#define sipNameNr_setNameFilterDetailsVisible 10982
#define sipName_setNameFilterDetailsVisible &sipStrings_QtGui[10982]
#define sipNameNr_AdjustToContentsOnFirstShow 11010
#define sipName_AdjustToContentsOnFirstShow &sipStrings_QtGui[11010]
#define sipNameNr_QComboBox__SizeAdjustPolicy 11038
#define sipName_QComboBox__SizeAdjustPolicy &sipStrings_QtGui[11038]
#define sipNameNr_QAbstractTextDocumentLayout 11066
#define sipName_QAbstractTextDocumentLayout &sipStrings_QtGui[11066]
#define sipNameNr_customContextMenuRequested 11094
#define sipName_customContextMenuRequested &sipStrings_QtGui[11094]
#define sipNameNr_QDoubleValidator__Notation 11121
#define sipName_QDoubleValidator__Notation &sipStrings_QtGui[11121]
#define sipNameNr_QTextFrameFormat__Position 11148
#define sipName_QTextFrameFormat__Position &sipStrings_QtGui[11148]
#define sipNameNr_QTextFormat__PageBreakFlag 11175
#define sipName_QTextFormat__PageBreakFlag &sipStrings_QtGui[11175]
#define sipNameNr_QTextCursor__SelectionType 11202
#define sipName_QTextCursor__SelectionType &sipStrings_QtGui[11202]
#define sipNameNr_QTextCursor__MoveOperation 11229
#define sipName_QTextCursor__MoveOperation &sipStrings_QtGui[11229]
#define sipNameNr_QTableWidgetItem__ItemType 11256
#define sipName_QTableWidgetItem__ItemType &sipStrings_QtGui[11256]
#define sipNameNr_QTableWidgetSelectionRange 11283
#define sipName_QTableWidgetSelectionRange &sipStrings_QtGui[11283]
#define sipNameNr_QTabBar__SelectionBehavior 11310
#define sipName_QTabBar__SelectionBehavior &sipStrings_QtGui[11310]
#define sipNameNr_NextAndPreviousAreSelected 11337
#define sipName_NextAndPreviousAreSelected &sipStrings_QtGui[11337]
#define sipNameNr_QStyleOptionTabWidgetFrame 11364
#define sipName_QStyleOptionTabWidgetFrame &sipStrings_QtGui[11364]
#define sipNameNr_standardIconImplementation 11391
#define sipName_standardIconImplementation &sipStrings_QtGui[11391]
#define sipNameNr_SH_FormLayoutFormAlignment 11418
#define sipName_SH_FormLayoutFormAlignment &sipStrings_QtGui[11418]
#define sipNameNr_SH_Menu_FlashTriggeredItem 11445
#define sipName_SH_Menu_FlashTriggeredItem &sipStrings_QtGui[11445]
#define sipNameNr_SH_GroupBox_TextLabelColor 11472
#define sipName_SH_GroupBox_TextLabelColor &sipStrings_QtGui[11472]
#define sipNameNr_SH_Menu_SpaceActivatesItem 11499
#define sipName_SH_Menu_SpaceActivatesItem &sipStrings_QtGui[11499]
#define sipNameNr_PM_TabCloseIndicatorHeight 11526
#define sipName_PM_TabCloseIndicatorHeight &sipStrings_QtGui[11526]
#define sipNameNr_PM_LayoutHorizontalSpacing 11553
#define sipName_PM_LayoutHorizontalSpacing &sipStrings_QtGui[11553]
#define sipNameNr_PM_RadioButtonLabelSpacing 11580
#define sipName_PM_RadioButtonLabelSpacing &sipStrings_QtGui[11580]
#define sipNameNr_PM_TabBarScrollButtonWidth 11607
#define sipName_PM_TabBarScrollButtonWidth &sipStrings_QtGui[11607]
#define sipNameNr_PM_CheckListControllerSize 11634
#define sipName_PM_CheckListControllerSize &sipStrings_QtGui[11634]
#define sipNameNr_PM_ExclusiveIndicatorWidth 11661
#define sipName_PM_ExclusiveIndicatorWidth &sipStrings_QtGui[11661]
#define sipNameNr_PE_IndicatorButtonDropDown 11688
#define sipName_PE_IndicatorButtonDropDown &sipStrings_QtGui[11688]
#define sipNameNr_CompositionMode_Difference 11715
#define sipName_CompositionMode_Difference &sipStrings_QtGui[11715]
#define sipNameNr_CompositionMode_ColorDodge 11742
#define sipName_CompositionMode_ColorDodge &sipStrings_QtGui[11742]
#define sipNameNr_CompositionMode_SourceAtop 11769
#define sipName_CompositionMode_SourceAtop &sipStrings_QtGui[11769]
#define sipNameNr_CompositionMode_SourceOver 11796
#define sipName_CompositionMode_SourceOver &sipStrings_QtGui[11796]
#define sipNameNr_setCascadingSectionResizes 11823
#define sipName_setCascadingSectionResizes &sipStrings_QtGui[11823]
#define sipNameNr_sectionHandleDoubleClicked 11850
#define sipName_sectionHandleDoubleClicked &sipStrings_QtGui[11850]
#define sipNameNr_setOffsetToSectionPosition 11877
#define sipName_setOffsetToSectionPosition &sipStrings_QtGui[11877]
#define sipNameNr_setRubberBandSelectionMode 11904
#define sipName_setRubberBandSelectionMode &sipStrings_QtGui[11904]
#define sipNameNr_BoundingRectViewportUpdate 11931
#define sipName_BoundingRectViewportUpdate &sipStrings_QtGui[11931]
#define sipNameNr_QGraphicsScene__SceneLayer 11958
#define sipName_QGraphicsScene__SceneLayer &sipStrings_QtGui[11958]
#define sipNameNr_QAbstractGraphicsShapeItem 11985
#define sipName_QAbstractGraphicsShapeItem &sipStrings_QtGui[11985]
#define sipNameNr_ItemIgnoresTransformations 12012
#define sipName_ItemIgnoresTransformations &sipStrings_QtGui[12012]
#define sipNameNr_QFormLayout__RowWrapPolicy 12039
#define sipName_QFormLayout__RowWrapPolicy &sipStrings_QtGui[12039]
#define sipNameNr_addApplicationFontFromData 12066
#define sipName_addApplicationFontFromData &sipStrings_QtGui[12066]
#define sipNameNr_QFontComboBox__FontFilters 12093
#define sipName_QFontComboBox__FontFilters &sipStrings_QtGui[12093]
#define sipNameNr_isNameFilterDetailsVisible 12120
#define sipName_isNameFilterDetailsVisible &sipStrings_QtGui[12120]
#define sipNameNr_QTabletEvent__TabletDevice 12147
#define sipName_QTabletEvent__TabletDevice &sipStrings_QtGui[12147]
#define sipNameNr_DockWidgetVerticalTitleBar 12174
#define sipName_DockWidgetVerticalTitleBar &sipStrings_QtGui[12174]
#define sipNameNr_CaseSensitivelySortedModel 12201
#define sipName_CaseSensitivelySortedModel &sipStrings_QtGui[12201]
#define sipNameNr_QCompleter__CompletionMode 12228
#define sipName_QCompleter__CompletionMode &sipStrings_QtGui[12228]
#define sipNameNr_setVerticalScrollBarPolicy 12255
#define sipName_setVerticalScrollBarPolicy &sipStrings_QtGui[12255]
#define sipNameNr_scheduleDelayedItemsLayout 12282
#define sipName_scheduleDelayedItemsLayout &sipStrings_QtGui[12282]
#define sipNameNr_QX11EmbedContainer__Error 12309
#define sipName_QX11EmbedContainer__Error &sipStrings_QtGui[12309]
#define sipNameNr_setFirstItemColumnSpanned 12335
#define sipName_setFirstItemColumnSpanned &sipStrings_QtGui[12335]
#define sipNameNr_QTreeWidgetItem__ItemType 12361
#define sipName_QTreeWidgetItem__ItemType &sipStrings_QtGui[12361]
#define sipNameNr_QTextLine__CursorPosition 12387
#define sipName_QTextLine__CursorPosition &sipStrings_QtGui[12387]
#define sipNameNr_setColumnWidthConstraints 12413
#define sipName_setColumnWidthConstraints &sipStrings_QtGui[12413]
#define sipNameNr_QTextEdit__AutoFormatting 12439
#define sipName_QTextEdit__AutoFormatting &sipStrings_QtGui[12439]
#define sipNameNr_QTextEdit__ExtraSelection 12465
#define sipName_QTextEdit__ExtraSelection &sipStrings_QtGui[12465]
#define sipNameNr_selectionBehaviorOnRemove 12491
#define sipName_selectionBehaviorOnRemove &sipStrings_QtGui[12491]
#define sipNameNr_QStyleOptionProgressBarV2 12517
#define sipName_QStyleOptionProgressBarV2 &sipStrings_QtGui[12517]
#define sipNameNr_SP_FileDialogContentsView 12543
#define sipName_SP_FileDialogContentsView &sipStrings_QtGui[12543]
#define sipNameNr_SP_FileDialogDetailedView 12569
#define sipName_SP_FileDialogDetailedView &sipStrings_QtGui[12569]
#define sipNameNr_SH_FocusFrame_AboveWidget 12595
#define sipName_SH_FocusFrame_AboveWidget &sipStrings_QtGui[12595]
#define sipNameNr_SH_Widget_ShareActivation 12621
#define sipName_SH_Widget_ShareActivation &sipStrings_QtGui[12621]
#define sipNameNr_SH_Menu_SubMenuPopupDelay 12647
#define sipName_SH_Menu_SubMenuPopupDelay &sipStrings_QtGui[12647]
#define sipNameNr_SH_Slider_SloppyKeyEvents 12673
#define sipName_SH_Slider_SloppyKeyEvents &sipStrings_QtGui[12673]
#define sipNameNr_SH_TabBar_SelectMouseType 12699
#define sipName_SH_TabBar_SelectMouseType &sipStrings_QtGui[12699]
#define sipNameNr_PM_TabCloseIndicatorWidth 12725
#define sipName_PM_TabCloseIndicatorWidth &sipStrings_QtGui[12725]
#define sipNameNr_PM_ToolTipLabelFrameWidth 12751
#define sipName_PM_ToolTipLabelFrameWidth &sipStrings_QtGui[12751]
#define sipNameNr_PM_ToolBarExtensionExtent 12777
#define sipName_PM_ToolBarExtensionExtent &sipStrings_QtGui[12777]
#define sipNameNr_PM_ToolBarSeparatorExtent 12803
#define sipName_PM_ToolBarSeparatorExtent &sipStrings_QtGui[12803]
#define sipNameNr_PM_TabBarTabShiftVertical 12829
#define sipName_PM_TabBarTabShiftVertical &sipStrings_QtGui[12829]
#define sipNameNr_PM_MdiSubWindowFrameWidth 12855
#define sipName_PM_MdiSubWindowFrameWidth &sipStrings_QtGui[12855]
#define sipNameNr_PM_DialogButtonsSeparator 12881
#define sipName_PM_DialogButtonsSeparator &sipStrings_QtGui[12881]
#define sipNameNr_PM_DockWidgetHandleExtent 12907
#define sipName_PM_DockWidgetHandleExtent &sipStrings_QtGui[12907]
#define sipNameNr_PM_SliderControlThickness 12933
#define sipName_PM_SliderControlThickness &sipStrings_QtGui[12933]
#define sipNameNr_PM_ButtonDefaultIndicator 12959
#define sipName_PM_ButtonDefaultIndicator &sipStrings_QtGui[12959]
#define sipNameNr_SE_ItemViewItemDecoration 12985
#define sipName_SE_ItemViewItemDecoration &sipStrings_QtGui[12985]
#define sipNameNr_SE_DateTimeEditLayoutItem 13011
#define sipName_SE_DateTimeEditLayoutItem &sipStrings_QtGui[13011]
#define sipNameNr_SE_DockWidgetTitleBarText 13037
#define sipName_SE_DockWidgetTitleBarText &sipStrings_QtGui[13037]
#define sipNameNr_SE_TreeViewDisclosureItem 13063
#define sipName_SE_TreeViewDisclosureItem &sipStrings_QtGui[13063]
#define sipNameNr_SE_ViewItemCheckIndicator 13089
#define sipName_SE_ViewItemCheckIndicator &sipStrings_QtGui[13089]
#define sipNameNr_SE_Q3DockWindowHandleRect 13115
#define sipName_SE_Q3DockWindowHandleRect &sipStrings_QtGui[13115]
#define sipNameNr_PE_IndicatorToolBarHandle 13141
#define sipName_PE_IndicatorToolBarHandle &sipStrings_QtGui[13141]
#define sipNameNr_PE_IndicatorProgressChunk 13167
#define sipName_PE_IndicatorProgressChunk &sipStrings_QtGui[13167]
#define sipNameNr_PE_IndicatorMenuCheckMark 13193
#define sipName_PE_IndicatorMenuCheckMark &sipStrings_QtGui[13193]
#define sipNameNr_PE_IndicatorViewItemCheck 13219
#define sipName_PE_IndicatorViewItemCheck &sipStrings_QtGui[13219]
#define sipNameNr_State_KeyboardFocusChange 13245
#define sipName_State_KeyboardFocusChange &sipStrings_QtGui[13245]
#define sipNameNr_setHorizontalHeaderLabels 13271
#define sipName_setHorizontalHeaderLabels &sipStrings_QtGui[13271]
#define sipNameNr_QSizePolicy__ControlTypes 13297
#define sipName_QSizePolicy__ControlTypes &sipStrings_QtGui[13297]
#define sipNameNr_13323 13323
#define sipName_13323 &sipStrings_QtGui[13323]
#define sipNameNr_setPrinterSelectionOption 13349
#define sipName_setPrinterSelectionOption &sipStrings_QtGui[13349]
#define sipNameNr_QPainterPath__ElementType 13375
#define sipName_QPainterPath__ElementType &sipStrings_QtGui[13375]
#define sipNameNr_CompositionMode_Exclusion 13401
#define sipName_CompositionMode_Exclusion &sipStrings_QtGui[13401]
#define sipNameNr_CompositionMode_SoftLight 13427
#define sipName_CompositionMode_SoftLight &sipStrings_QtGui[13427]
#define sipNameNr_CompositionMode_HardLight 13453
#define sipName_CompositionMode_HardLight &sipStrings_QtGui[13453]
#define sipNameNr_CompositionMode_ColorBurn 13479
#define sipName_CompositionMode_ColorBurn &sipStrings_QtGui[13479]
#define sipNameNr_CompositionMode_SourceOut 13505
#define sipName_CompositionMode_SourceOut &sipStrings_QtGui[13505]
#define sipNameNr_QPainter__CompositionMode 13531
#define sipName_QPainter__CompositionMode &sipStrings_QtGui[13531]
#define sipNameNr_activatePreviousSubWindow 13557
#define sipName_activatePreviousSubWindow &sipStrings_QtGui[13557]
#define sipNameNr_QListWidgetItem__ItemType 13583
#define sipName_QListWidgetItem__ItemType &sipStrings_QtGui[13583]
#define sipNameNr_createStandardContextMenu 13609
#define sipName_createStandardContextMenu &sipStrings_QtGui[13609]
#define sipNameNr_QKeySequence__StandardKey 13635
#define sipName_QKeySequence__StandardKey &sipStrings_QtGui[13635]
#define sipNameNr_columnIntersectsSelection 13661
#define sipName_columnIntersectsSelection &sipStrings_QtGui[13661]
#define sipNameNr_DontAdjustForAntialiasing 13687
#define sipName_DontAdjustForAntialiasing &sipStrings_QtGui[13687]
#define sipNameNr_QGraphicsSceneResizeEvent 13713
#define sipName_QGraphicsSceneResizeEvent &sipStrings_QtGui[13713]
#define sipNameNr_createProxyForChildWidget 13739
#define sipName_createProxyForChildWidget &sipStrings_QtGui[13739]
#define sipNameNr_boundingRegionGranularity 13765
#define sipName_boundingRegionGranularity &sipStrings_QtGui[13765]
#define sipNameNr_removeAllApplicationFonts 13791
#define sipName_removeAllApplicationFonts &sipStrings_QtGui[13791]
#define sipNameNr_QFontComboBox__FontFilter 13817
#define sipName_QFontComboBox__FontFilter &sipStrings_QtGui[13817]
#define sipNameNr_getOpenFileNamesAndFilter 13843
#define sipName_getOpenFileNamesAndFilter &sipStrings_QtGui[13843]
#define sipNameNr_QContextMenuEvent__Reason 13869
#define sipName_QContextMenuEvent__Reason &sipStrings_QtGui[13869]
#define sipNameNr_QTabletEvent__PointerType 13895
#define sipName_QTabletEvent__PointerType &sipStrings_QtGui[13895]
#define sipNameNr_UnfilteredPopupCompletion 13921
#define sipName_UnfilteredPopupCompletion &sipStrings_QtGui[13921]
#define sipNameNr_setHorizontalHeaderFormat 13947
#define sipName_setHorizontalHeaderFormat &sipStrings_QtGui[13947]
#define sipNameNr_QGradient__CoordinateMode 13973
#define sipName_QGradient__CoordinateMode &sipStrings_QtGui[13973]
#define sipNameNr_setQuitOnLastWindowClosed 13999
#define sipName_setQuitOnLastWindowClosed &sipStrings_QtGui[13999]
#define sipNameNr_associatedGraphicsWidgets 14025
#define sipName_associatedGraphicsWidgets &sipStrings_QtGui[14025]
#define sipNameNr_horizontalScrollBarPolicy 14051
#define sipName_horizontalScrollBarPolicy &sipStrings_QtGui[14051]
#define sipNameNr_executeDelayedItemsLayout 14077
#define sipName_executeDelayedItemsLayout &sipStrings_QtGui[14077]
#define sipNameNr_setHorizontalStepsPerItem 14103
#define sipName_setHorizontalStepsPerItem &sipStrings_QtGui[14103]
#define sipNameNr_horizontalScrollbarAction 14129
#define sipName_horizontalScrollbarAction &sipStrings_QtGui[14129]
#define sipNameNr_changePersistentIndexList 14155
#define sipName_changePersistentIndexList &sipStrings_QtGui[14155]
#define sipNameNr_14181 14181
#define sipName_14181 &sipStrings_QtGui[14181]
#define sipNameNr_HaveNextButtonOnLastPage 14206
#define sipName_HaveNextButtonOnLastPage &sipStrings_QtGui[14206]
#define sipNameNr_isFirstItemColumnSpanned 14231
#define sipName_isFirstItemColumnSpanned &sipStrings_QtGui[14231]
#define sipNameNr_QTextLayout__FormatRange 14256
#define sipName_QTextLayout__FormatRange &sipStrings_QtGui[14256]
#define sipNameNr_QTextFormat__ObjectTypes 14281
#define sipName_QTextFormat__ObjectTypes &sipStrings_QtGui[14281]
#define sipNameNr_currentCharFormatChanged 14306
#define sipName_currentCharFormatChanged &sipStrings_QtGui[14306]
#define sipNameNr_setLineWrapColumnOrWidth 14331
#define sipName_setLineWrapColumnOrWidth &sipStrings_QtGui[14331]
#define sipNameNr_supportedDocumentFormats 14356
#define sipName_supportedDocumentFormats &sipStrings_QtGui[14356]
#define sipNameNr_QTextDocument__FindFlags 14381
#define sipName_QTextDocument__FindFlags &sipStrings_QtGui[14381]
#define sipNameNr_QStyleOptionTabBarBaseV2 14406
#define sipName_QStyleOptionTabBarBaseV2 &sipStrings_QtGui[14406]
#define sipNameNr_QStyleOptionDockWidgetV2 14431
#define sipName_QStyleOptionDockWidgetV2 &sipStrings_QtGui[14431]
#define sipNameNr_QStyleOptionGraphicsItem 14456
#define sipName_QStyleOptionGraphicsItem &sipStrings_QtGui[14456]
#define sipNameNr_QStyleOption__OptionType 14481
#define sipName_QStyleOption__OptionType &sipStrings_QtGui[14481]
#define sipNameNr_SP_MessageBoxInformation 14506
#define sipName_SP_MessageBoxInformation &sipStrings_QtGui[14506]
#define sipNameNr_SP_DockWidgetCloseButton 14531
#define sipName_SP_DockWidgetCloseButton &sipStrings_QtGui[14531]
#define sipNameNr_SP_TitleBarUnshadeButton 14556
#define sipName_SP_TitleBarUnshadeButton &sipStrings_QtGui[14556]
#define sipNameNr_SH_Slider_PageSetButtons 14581
#define sipName_SH_Slider_PageSetButtons &sipStrings_QtGui[14581]
#define sipNameNr_SH_ScrollBar_ContextMenu 14606
#define sipName_SH_ScrollBar_ContextMenu &sipStrings_QtGui[14606]
#define sipNameNr_SH_ToolButton_PopupDelay 14631
#define sipName_SH_ToolButton_PopupDelay &sipStrings_QtGui[14631]
#define sipNameNr_SH_SpinBox_AnimateButton 14656
#define sipName_SH_SpinBox_AnimateButton &sipStrings_QtGui[14656]
#define sipNameNr_SH_TabBar_PreferNoArrows 14681
#define sipName_SH_TabBar_PreferNoArrows &sipStrings_QtGui[14681]
#define sipNameNr_SH_MenuBar_MouseTracking 14706
#define sipName_SH_MenuBar_MouseTracking &sipStrings_QtGui[14706]
#define sipNameNr_SH_Header_ArrowAlignment 14731
#define sipName_SH_Header_ArrowAlignment &sipStrings_QtGui[14731]
#define sipNameNr_PM_LayoutVerticalSpacing 14756
#define sipName_PM_LayoutVerticalSpacing &sipStrings_QtGui[14756]
#define sipNameNr_PM_DockWidgetTitleMargin 14781
#define sipName_PM_DockWidgetTitleMargin &sipStrings_QtGui[14781]
#define sipNameNr_PM_DefaultTopLevelMargin 14806
#define sipName_PM_DefaultTopLevelMargin &sipStrings_QtGui[14806]
#define sipNameNr_PM_MenuDesktopFrameWidth 14831
#define sipName_PM_MenuDesktopFrameWidth &sipStrings_QtGui[14831]
#define sipNameNr_PM_ProgressBarChunkWidth 14856
#define sipName_PM_ProgressBarChunkWidth &sipStrings_QtGui[14856]
#define sipNameNr_PM_ButtonShiftHorizontal 14881
#define sipName_PM_ButtonShiftHorizontal &sipStrings_QtGui[14881]
#define sipNameNr_SC_TitleBarUnshadeButton 14906
#define sipName_SC_TitleBarUnshadeButton &sipStrings_QtGui[14906]
#define sipNameNr_SE_ItemViewItemFocusRect 14931
#define sipName_SE_ItemViewItemFocusRect &sipStrings_QtGui[14931]
#define sipNameNr_SE_RadioButtonLayoutItem 14956
#define sipName_SE_RadioButtonLayoutItem &sipStrings_QtGui[14956]
#define sipNameNr_SE_ProgressBarLayoutItem 14981
#define sipName_SE_ProgressBarLayoutItem &sipStrings_QtGui[14981]
#define sipNameNr_SE_DockWidgetFloatButton 15006
#define sipName_SE_DockWidgetFloatButton &sipStrings_QtGui[15006]
#define sipNameNr_SE_DockWidgetCloseButton 15031
#define sipName_SE_DockWidgetCloseButton &sipStrings_QtGui[15031]
#define sipNameNr_CE_Q3DockWindowEmptyArea 15056
#define sipName_CE_Q3DockWindowEmptyArea &sipStrings_QtGui[15056]
#define sipNameNr_PE_PanelScrollAreaCorner 15081
#define sipName_PE_PanelScrollAreaCorner &sipStrings_QtGui[15081]
#define sipNameNr_PE_Q3DockWindowSeparator 15106
#define sipName_PE_Q3DockWindowSeparator &sipStrings_QtGui[15106]
#define sipNameNr_PE_Q3CheckListController 15131
#define sipName_PE_Q3CheckListController &sipStrings_QtGui[15131]
#define sipNameNr_QStyle__PrimitiveElement 15156
#define sipName_QStyle__PrimitiveElement &sipStrings_QtGui[15156]
#define sipNameNr_setAccessibleDescription 15181
#define sipName_setAccessibleDescription &sipStrings_QtGui[15181]
#define sipNameNr_takeHorizontalHeaderItem 15206
#define sipName_takeHorizontalHeaderItem &sipStrings_QtGui[15206]
#define sipNameNr_setFilterCaseSensitivity 15231
#define sipName_setFilterCaseSensitivity &sipStrings_QtGui[15231]
#define sipNameNr_QSizePolicy__ControlType 15256
#define sipName_QSizePolicy__ControlType &sipStrings_QtGui[15256]
#define sipNameNr_PPK_SupportedResolutions 15281
#define sipName_PPK_SupportedResolutions &sipStrings_QtGui[15281]
#define sipNameNr_QPlainTextDocumentLayout 15306
#define sipName_QPlainTextDocumentLayout &sipStrings_QtGui[15306]
#define sipNameNr_QPaintEngine__DirtyFlags 15331
#define sipName_QPaintEngine__DirtyFlags &sipStrings_QtGui[15331]
#define sipNameNr_CompositionMode_Multiply 15356
#define sipName_CompositionMode_Multiply &sipStrings_QtGui[15356]
#define sipNameNr_CompositionMode_SourceIn 15381
#define sipName_CompositionMode_SourceIn &sipStrings_QtGui[15381]
#define sipNameNr_setSeparatorsCollapsible 15406
#define sipName_setSeparatorsCollapsible &sipStrings_QtGui[15406]
#define sipNameNr_QMainWindow__DockOptions 15431
#define sipName_QMainWindow__DockOptions &sipStrings_QtGui[15431]
#define sipNameNr_QLCDNumber__SegmentStyle 15456
#define sipName_QLCDNumber__SegmentStyle &sipStrings_QtGui[15456]
#define sipNameNr_InsertParagraphSeparator 15481
#define sipName_InsertParagraphSeparator &sipStrings_QtGui[15481]
#define sipNameNr_setAutoDetectImageFormat 15506
#define sipName_setAutoDetectImageFormat &sipStrings_QtGui[15506]
#define sipNameNr_sectionsAboutToBeRemoved 15531
#define sipName_sectionsAboutToBeRemoved &sipStrings_QtGui[15531]
#define sipNameNr_QGraphicsView__CacheMode 15556
#define sipName_QGraphicsView__CacheMode &sipStrings_QtGui[15556]
#define sipNameNr_QGraphicsSceneHoverEvent 15581
#define sipName_QGraphicsSceneHoverEvent &sipStrings_QtGui[15581]
#define sipNameNr_QGraphicsSceneWheelEvent 15606
#define sipName_QGraphicsSceneWheelEvent &sipStrings_QtGui[15606]
#define sipNameNr_QGraphicsSceneMouseEvent 15631
#define sipName_QGraphicsSceneMouseEvent &sipStrings_QtGui[15631]
#define sipNameNr_ItemIgnoresParentOpacity 15656
#define sipName_ItemIgnoresParentOpacity &sipStrings_QtGui[15656]
#define sipNameNr_ItemClipsChildrenToShape 15681
#define sipName_ItemClipsChildrenToShape &sipStrings_QtGui[15681]
#define sipNameNr_QGraphicsItem__CacheMode 15706
#define sipName_QGraphicsItem__CacheMode &sipStrings_QtGui[15706]
#define sipNameNr_getSaveFileNameAndFilter 15731
#define sipName_getSaveFileNameAndFilter &sipStrings_QtGui[15731]
#define sipNameNr_getOpenFileNameAndFilter 15756
#define sipName_getOpenFileNameAndFilter &sipStrings_QtGui[15756]
#define sipNameNr_QFileDialog__DialogLabel 15781
#define sipName_QFileDialog__DialogLabel &sipStrings_QtGui[15781]
#define sipNameNr_QCompleter__ModelSorting 15806
#define sipName_QCompleter__ModelSorting &sipStrings_QtGui[15806]
#define sipNameNr_setMinimumContentsLength 15831
#define sipName_setMinimumContentsLength &sipStrings_QtGui[15831]
#define sipNameNr_setKeyboardInputInterval 15856
#define sipName_setKeyboardInputInterval &sipStrings_QtGui[15856]
#define sipNameNr_setItemDelegateForColumn 15881
#define sipName_setItemDelegateForColumn &sipStrings_QtGui[15881]
#define sipNameNr_setDragDropOverwriteMode 15906
#define sipName_setDragDropOverwriteMode &sipStrings_QtGui[15906]
#define sipNameNr_QAbstractItemView__State 15931
#define sipName_QAbstractItemView__State &sipStrings_QtGui[15931]
#define sipNameNr_visualRegionForSelection 15956
#define sipName_visualRegionForSelection &sipStrings_QtGui[15956]
#define sipNameNr_15981 15981
#define sipName_15981 &sipStrings_QtGui[15981]
#define sipNameNr_16005 16005
#define sipName_16005 &sipStrings_QtGui[16005]
#define sipNameNr_16029 16029
#define sipName_16029 &sipStrings_QtGui[16029]
#define sipNameNr_16053 16053
#define sipName_16053 &sipStrings_QtGui[16053]
#define sipNameNr_16077 16077
#define sipName_16077 &sipStrings_QtGui[16077]
#define sipNameNr_QWorkspace__WindowOrder 16101
#define sipName_QWorkspace__WindowOrder &sipStrings_QtGui[16101]
#define sipNameNr_NoBackButtonOnStartPage 16125
#define sipName_NoBackButtonOnStartPage &sipStrings_QtGui[16125]
#define sipNameNr_ExtendedWatermarkPixmap 16149
#define sipName_ExtendedWatermarkPixmap &sipStrings_QtGui[16149]
#define sipNameNr_QTreeWidgetItemIterator 16173
#define sipName_QTreeWidgetItemIterator &sipStrings_QtGui[16173]
#define sipNameNr_setChildIndicatorPolicy 16197
#define sipName_setChildIndicatorPolicy &sipStrings_QtGui[16197]
#define sipNameNr_setExpandsOnDoubleClick 16221
#define sipName_setExpandsOnDoubleClick &sipStrings_QtGui[16221]
#define sipNameNr_CursorBetweenCharacters 16245
#define sipName_CursorBetweenCharacters &sipStrings_QtGui[16245]
#define sipNameNr_QTextLayout__CursorMode 16269
#define sipName_QTextLayout__CursorMode &sipStrings_QtGui[16269]
#define sipNameNr_QTextFormat__FormatType 16293
#define sipName_QTextFormat__FormatType &sipStrings_QtGui[16293]
#define sipNameNr_QTextEdit__LineWrapMode 16317
#define sipName_QTextEdit__LineWrapMode &sipStrings_QtGui[16317]
#define sipNameNr_QTextDocument__FindFlag 16341
#define sipName_QTextDocument__FindFlag &sipStrings_QtGui[16341]
#define sipNameNr_WhiteSpaceModeUndefined 16365
#define sipName_WhiteSpaceModeUndefined &sipStrings_QtGui[16365]
#define sipNameNr_QTabWidget__TabPosition 16389
#define sipName_QTabWidget__TabPosition &sipStrings_QtGui[16389]
#define sipNameNr_resizeColumnsToContents 16413
#define sipName_resizeColumnsToContents &sipStrings_QtGui[16413]
#define sipNameNr_QTabBar__ButtonPosition 16437
#define sipName_QTabBar__ButtonPosition &sipStrings_QtGui[16437]
#define sipNameNr_setCurrentBlockUserData 16461
#define sipName_setCurrentBlockUserData &sipStrings_QtGui[16461]
#define sipNameNr_QStyleHintReturnVariant 16485
#define sipName_QStyleHintReturnVariant &sipStrings_QtGui[16485]
#define sipNameNr_QStyleOptionProgressBar 16509
#define sipName_QStyleOptionProgressBar &sipStrings_QtGui[16509]
#define sipNameNr_sliderValueFromPosition 16533
#define sipName_sliderValueFromPosition &sipStrings_QtGui[16533]
#define sipNameNr_sliderPositionFromValue 16557
#define sipName_sliderPositionFromValue &sipStrings_QtGui[16557]
#define sipNameNr_SP_TitleBarNormalButton 16581
#define sipName_SP_TitleBarNormalButton &sipStrings_QtGui[16581]
#define sipNameNr_SH_FormLayoutWrapPolicy 16605
#define sipName_SH_FormLayoutWrapPolicy &sipStrings_QtGui[16605]
#define sipNameNr_SH_DrawMenuBarSeparator 16629
#define sipName_SH_DrawMenuBarSeparator &sipStrings_QtGui[16629]
#define sipNameNr_SH_ToolTipLabel_Opacity 16653
#define sipName_SH_ToolTipLabel_Opacity &sipStrings_QtGui[16653]
#define sipNameNr_PM_CheckBoxLabelSpacing 16677
#define sipName_PM_CheckBoxLabelSpacing &sipStrings_QtGui[16677]
#define sipNameNr_PM_DefaultLayoutSpacing 16701
#define sipName_PM_DefaultLayoutSpacing &sipStrings_QtGui[16701]
#define sipNameNr_PM_DockWidgetFrameWidth 16725
#define sipName_PM_DockWidgetFrameWidth &sipStrings_QtGui[16725]
#define sipNameNr_PM_SliderSpaceAvailable 16749
#define sipName_PM_SliderSpaceAvailable &sipStrings_QtGui[16749]
#define sipNameNr_PM_SliderTickmarkOffset 16773
#define sipName_PM_SliderTickmarkOffset &sipStrings_QtGui[16773]
#define sipNameNr_SC_TitleBarNormalButton 16797
#define sipName_SC_TitleBarNormalButton &sipStrings_QtGui[16797]
#define sipNameNr_SC_ComboBoxListBoxPopup 16821
#define sipName_SC_ComboBoxListBoxPopup &sipStrings_QtGui[16821]
#define sipNameNr_SE_TabBarTabRightButton 16845
#define sipName_SE_TabBarTabRightButton &sipStrings_QtGui[16845]
#define sipNameNr_SE_ToolButtonLayoutItem 16869
#define sipName_SE_ToolButtonLayoutItem &sipStrings_QtGui[16869]
#define sipNameNr_SE_PushButtonLayoutItem 16893
#define sipName_SE_PushButtonLayoutItem &sipStrings_QtGui[16893]
#define sipNameNr_SE_TabWidgetRightCorner 16917
#define sipName_SE_TabWidgetRightCorner &sipStrings_QtGui[16917]
#define sipNameNr_SE_TabWidgetTabContents 16941
#define sipName_SE_TabWidgetTabContents &sipStrings_QtGui[16941]
#define sipNameNr_SE_RadioButtonClickRect 16965
#define sipName_SE_RadioButtonClickRect &sipStrings_QtGui[16965]
#define sipNameNr_SE_RadioButtonFocusRect 16989
#define sipName_SE_RadioButtonFocusRect &sipStrings_QtGui[16989]
#define sipNameNr_SE_RadioButtonIndicator 17013
#define sipName_SE_RadioButtonIndicator &sipStrings_QtGui[17013]
#define sipNameNr_PE_IndicatorRadioButton 17037
#define sipName_PE_IndicatorRadioButton &sipStrings_QtGui[17037]
#define sipNameNr_PE_IndicatorHeaderArrow 17061
#define sipName_PE_IndicatorHeaderArrow &sipStrings_QtGui[17061]
#define sipNameNr_PE_Q3CheckListIndicator 17085
#define sipName_PE_Q3CheckListIndicator &sipStrings_QtGui[17085]
#define sipNameNr_QStandardItem__ItemType 17109
#define sipName_QStandardItem__ItemType &sipStrings_QtGui[17109]
#define sipNameNr_setVerticalHeaderLabels 17133
#define sipName_setVerticalHeaderLabels &sipStrings_QtGui[17133]
#define sipNameNr_setHorizontalHeaderItem 17157
#define sipName_setHorizontalHeaderItem &sipStrings_QtGui[17157]
#define sipNameNr_QSizePolicy__PolicyFlag 17181
#define sipName_QSizePolicy__PolicyFlag &sipStrings_QtGui[17181]
#define sipNameNr_QProgressBar__Direction 17205
#define sipName_QProgressBar__Direction &sipStrings_QtGui[17205]
#define sipNameNr_setLandscapeOrientation 17229
#define sipName_setLandscapeOrientation &sipStrings_QtGui[17229]
#define sipNameNr_setFontEmbeddingEnabled 17253
#define sipName_setFontEmbeddingEnabled &sipStrings_QtGui[17253]
#define sipNameNr_QPaintEngine__DirtyFlag 17277
#define sipName_QPaintEngine__DirtyFlag &sipStrings_QtGui[17277]
#define sipNameNr_setViewTransformEnabled 17301
#define sipName_setViewTransformEnabled &sipStrings_QtGui[17301]
#define sipNameNr_CompositionMode_Lighten 17325
#define sipName_CompositionMode_Lighten &sipStrings_QtGui[17325]
#define sipNameNr_CompositionMode_Overlay 17349
#define sipName_CompositionMode_Overlay &sipStrings_QtGui[17349]
#define sipNameNr_HighQualityAntialiasing 17373
#define sipName_HighQualityAntialiasing &sipStrings_QtGui[17373]
#define sipNameNr_QMessageBox__ButtonRole 17397
#define sipName_QMessageBox__ButtonRole &sipStrings_QtGui[17397]
#define sipNameNr_QMainWindow__DockOption 17421
#define sipName_QMainWindow__DockOption &sipStrings_QtGui[17421]
#define sipNameNr_setSelectionRectVisible 17445
#define sipName_setSelectionRectVisible &sipStrings_QtGui[17445]
#define sipNameNr_QLayout__SizeConstraint 17469
#define sipName_QLayout__SizeConstraint &sipStrings_QtGui[17469]
#define sipNameNr_QInputDialog__InputMode 17493
#define sipName_QInputDialog__InputMode &sipStrings_QtGui[17493]
#define sipNameNr_cascadingSectionResizes 17517
#define sipName_cascadingSectionResizes &sipStrings_QtGui[17517]
#define sipNameNr_sectionSizeFromContents 17541
#define sipName_sectionSizeFromContents &sipStrings_QtGui[17541]
#define sipNameNr_sectionViewportPosition 17565
#define sipName_sectionViewportPosition &sipStrings_QtGui[17565]
#define sipNameNr_QHeaderView__ResizeMode 17589
#define sipName_QHeaderView__ResizeMode &sipStrings_QtGui[17589]
#define sipNameNr_rubberBandSelectionMode 17613
#define sipName_rubberBandSelectionMode &sipStrings_QtGui[17613]
#define sipNameNr_setTransformationAnchor 17637
#define sipName_setTransformationAnchor &sipStrings_QtGui[17637]
#define sipNameNr_QGraphicsView__DragMode 17661
#define sipName_QGraphicsView__DragMode &sipStrings_QtGui[17661]
#define sipNameNr_QGraphicsSceneMoveEvent 17685
#define sipName_QGraphicsSceneMoveEvent &sipStrings_QtGui[17685]
#define sipNameNr_QGraphicsSceneHelpEvent 17709
#define sipName_QGraphicsSceneHelpEvent &sipStrings_QtGui[17709]
#define sipNameNr_unsetWindowFrameMargins 17733
#define sipName_unsetWindowFrameMargins &sipStrings_QtGui[17733]
#define sipNameNr_QGraphicsSimpleTextItem 17757
#define sipName_QGraphicsSimpleTextItem &sipStrings_QtGui[17757]
#define sipNameNr_setTextInteractionFlags 17781
#define sipName_setTextInteractionFlags &sipStrings_QtGui[17781]
#define sipNameNr_installSceneEventFilter 17805
#define sipName_installSceneEventFilter &sipStrings_QtGui[17805]
#define sipNameNr_setAcceptedMouseButtons 17829
#define sipName_setAcceptedMouseButtons &sipStrings_QtGui[17829]
#define sipNameNr_ItemTransformHasChanged 17853
#define sipName_ItemTransformHasChanged &sipStrings_QtGui[17853]
#define sipNameNr_setColumnPreferredWidth 17877
#define sipName_setColumnPreferredWidth &sipStrings_QtGui[17877]
#define sipNameNr_applicationFontFamilies 17901
#define sipName_applicationFontFamilies &sipStrings_QtGui[17901]
#define sipNameNr_QFileSystemModel__Roles 17925
#define sipName_QFileSystemModel__Roles &sipStrings_QtGui[17925]
#define sipNameNr_QFileDialog__AcceptMode 17949
#define sipName_QFileDialog__AcceptMode &sipStrings_QtGui[17949]
#define sipNameNr_QWindowStateChangeEvent 17973
#define sipName_QWindowStateChangeEvent &sipStrings_QtGui[17973]
#define sipNameNr_QDateTimeEdit__Sections 17997
#define sipName_QDateTimeEdit__Sections &sipStrings_QtGui[17997]
#define sipNameNr_QComboBox__InsertPolicy 18021
#define sipName_QComboBox__InsertPolicy &sipStrings_QtGui[18021]
#define sipNameNr_setNavigationBarVisible 18045
#define sipName_setNavigationBarVisible &sipStrings_QtGui[18045]
#define sipNameNr_setVerticalHeaderFormat 18069
#define sipName_setVerticalHeaderFormat &sipStrings_QtGui[18069]
#define sipNameNr_setDesktopSettingsAware 18093
#define sipName_setDesktopSettingsAware &sipStrings_QtGui[18093]
#define sipNameNr_QApplication__ColorSpec 18117
#define sipName_QApplication__ColorSpec &sipStrings_QtGui[18117]
#define sipNameNr_ApplicationSpecificRole 18141
#define sipName_ApplicationSpecificRole &sipStrings_QtGui[18141]
#define sipNameNr_SliderOrientationChange 18165
#define sipName_SliderOrientationChange &sipStrings_QtGui[18165]
#define sipNameNr_verticalScrollBarPolicy 18189
#define sipName_verticalScrollBarPolicy &sipStrings_QtGui[18189]
#define sipNameNr_setHorizontalScrollMode 18213
#define sipName_setHorizontalScrollMode &sipStrings_QtGui[18213]
#define sipNameNr_setVerticalStepsPerItem 18237
#define sipName_setVerticalStepsPerItem &sipStrings_QtGui[18237]
#define sipNameNr_verticalScrollbarAction 18261
#define sipName_verticalScrollbarAction &sipStrings_QtGui[18261]
#define sipNameNr_setAlternatingRowColors 18285
#define sipName_setAlternatingRowColors &sipStrings_QtGui[18285]
#define sipNameNr_QX11EmbedWidget__Error 18309
#define sipName_QX11EmbedWidget__Error &sipStrings_QtGui[18309]
#define sipNameNr_activatePreviousWindow 18332
#define sipName_activatePreviousWindow &sipStrings_QtGui[18332]
#define sipNameNr_QWizard__WizardOptions 18355
#define sipName_QWizard__WizardOptions &sipStrings_QtGui[18355]
#define sipNameNr_NoBackButtonOnLastPage 18378
#define sipName_NoBackButtonOnLastPage &sipStrings_QtGui[18378]
#define sipNameNr_windowActivationChange 18401
#define sipName_windowActivationChange &sipStrings_QtGui[18401]
#define sipNameNr_setAllColumnsShowFocus 18424
#define sipName_setAllColumnsShowFocus &sipStrings_QtGui[18424]
#define sipNameNr_previousCursorPosition 18447
#define sipName_previousCursorPosition &sipStrings_QtGui[18447]
#define sipNameNr_clearAdditionalFormats 18470
#define sipName_clearAdditionalFormats &sipStrings_QtGui[18470]
#define sipNameNr_columnWidthConstraints 18493
#define sipName_columnWidthConstraints &sipStrings_QtGui[18493]
#define sipNameNr_BorderStyle_DotDotDash 18516
#define sipName_BorderStyle_DotDotDash &sipStrings_QtGui[18516]
#define sipNameNr_QTextListFormat__Style 18539
#define sipName_QTextListFormat__Style &sipStrings_QtGui[18539]
#define sipNameNr_setTableCellColumnSpan 18562
#define sipName_setTableCellColumnSpan &sipStrings_QtGui[18562]
#define sipNameNr_TableCellBottomPadding 18585
#define sipName_TableCellBottomPadding &sipStrings_QtGui[18585]
#define sipNameNr_BlockNonBreakableLines 18608
#define sipName_BlockNonBreakableLines &sipStrings_QtGui[18608]
#define sipNameNr_PageBreak_AlwaysBefore 18631
#define sipName_PageBreak_AlwaysBefore &sipStrings_QtGui[18631]
#define sipNameNr_setTextBackgroundColor 18654
#define sipName_setTextBackgroundColor &sipStrings_QtGui[18654]
#define sipNameNr_setCornerButtonEnabled 18677
#define sipName_setCornerButtonEnabled &sipStrings_QtGui[18677]
#define sipNameNr_resizeColumnToContents 18700
#define sipName_resizeColumnToContents &sipStrings_QtGui[18700]
#define sipNameNr_columnViewportPosition 18723
#define sipName_columnViewportPosition &sipStrings_QtGui[18723]
#define sipNameNr_QStyleOptionViewItemV4 18746
#define sipName_QStyleOptionViewItemV4 &sipStrings_QtGui[18746]
#define sipNameNr_QStyleOptionViewItemV3 18769
#define sipName_QStyleOptionViewItemV3 &sipStrings_QtGui[18769]
#define sipNameNr_QStyleOptionViewItemV2 18792
#define sipName_QStyleOptionViewItemV2 &sipStrings_QtGui[18792]
#define sipNameNr_QStyleOptionToolButton 18815
#define sipName_QStyleOptionToolButton &sipStrings_QtGui[18815]
#define sipNameNr_QStyleOptionRubberBand 18838
#define sipName_QStyleOptionRubberBand &sipStrings_QtGui[18838]
#define sipNameNr_showDecorationSelected 18861
#define sipName_showDecorationSelected &sipStrings_QtGui[18861]
#define sipNameNr_QStyleOptionDockWidget 18884
#define sipName_QStyleOptionDockWidget &sipStrings_QtGui[18884]
#define sipNameNr_QStyleOptionTabBarBase 18907
#define sipName_QStyleOptionTabBarBase &sipStrings_QtGui[18907]
#define sipNameNr_SP_DialogDiscardButton 18930
#define sipName_SP_DialogDiscardButton &sipStrings_QtGui[18930]
#define sipNameNr_SP_FileDialogNewFolder 18953
#define sipName_SP_FileDialogNewFolder &sipStrings_QtGui[18953]
#define sipNameNr_SP_TitleBarShadeButton 18976
#define sipName_SP_TitleBarShadeButton &sipStrings_QtGui[18976]
#define sipNameNr_SP_TitleBarCloseButton 18999
#define sipName_SP_TitleBarCloseButton &sipStrings_QtGui[18999]
#define sipNameNr_QStyle__StandardPixmap 19022
#define sipName_QStyle__StandardPixmap &sipStrings_QtGui[19022]
#define sipNameNr_SH_Menu_KeyboardSearch 19045
#define sipName_SH_Menu_KeyboardSearch &sipStrings_QtGui[19045]
#define sipNameNr_SH_Dial_BackgroundRole 19068
#define sipName_SH_Dial_BackgroundRole &sipStrings_QtGui[19068]
#define sipNameNr_SH_Table_GridLineColor 19091
#define sipName_SH_Table_GridLineColor &sipStrings_QtGui[19091]
#define sipNameNr_SH_Menu_SloppySubMenus 19114
#define sipName_SH_Menu_SloppySubMenus &sipStrings_QtGui[19114]
#define sipNameNr_PM_SpinBoxSliderHeight 19137
#define sipName_PM_SpinBoxSliderHeight &sipStrings_QtGui[19137]
#define sipNameNr_PM_ToolBarHandleExtent 19160
#define sipName_PM_ToolBarHandleExtent &sipStrings_QtGui[19160]
#define sipNameNr_PM_CheckListButtonSize 19183
#define sipName_PM_CheckListButtonSize &sipStrings_QtGui[19183]
#define sipNameNr_PM_MaximumDragDistance 19206
#define sipName_PM_MaximumDragDistance &sipStrings_QtGui[19206]
#define sipNameNr_PM_ButtonShiftVertical 19229
#define sipName_PM_ButtonShiftVertical &sipStrings_QtGui[19229]
#define sipNameNr_PM_MenuButtonIndicator 19252
#define sipName_PM_MenuButtonIndicator &sipStrings_QtGui[19252]
#define sipNameNr_SC_TitleBarShadeButton 19275
#define sipName_SC_TitleBarShadeButton &sipStrings_QtGui[19275]
#define sipNameNr_SC_TitleBarCloseButton 19298
#define sipName_SC_TitleBarCloseButton &sipStrings_QtGui[19298]
#define sipNameNr_QStyle__ComplexControl 19321
#define sipName_QStyle__ComplexControl &sipStrings_QtGui[19321]
#define sipNameNr_SE_ShapedFrameContents 19344
#define sipName_SE_ShapedFrameContents &sipStrings_QtGui[19344]
#define sipNameNr_SE_TabBarTabLeftButton 19367
#define sipName_SE_TabBarTabLeftButton &sipStrings_QtGui[19367]
#define sipNameNr_SE_TabWidgetLayoutItem 19390
#define sipName_SE_TabWidgetLayoutItem &sipStrings_QtGui[19390]
#define sipNameNr_SE_TabBarTearIndicator 19413
#define sipName_SE_TabBarTearIndicator &sipStrings_QtGui[19413]
#define sipNameNr_SE_TabWidgetLeftCorner 19436
#define sipName_SE_TabWidgetLeftCorner &sipStrings_QtGui[19436]
#define sipNameNr_SE_ProgressBarContents 19459
#define sipName_SE_ProgressBarContents &sipStrings_QtGui[19459]
#define sipNameNr_SE_RadioButtonContents 19482
#define sipName_SE_RadioButtonContents &sipStrings_QtGui[19482]
#define sipNameNr_SE_PushButtonFocusRect 19505
#define sipName_SE_PushButtonFocusRect &sipStrings_QtGui[19505]
#define sipNameNr_CE_ProgressBarContents 19528
#define sipName_CE_ProgressBarContents &sipStrings_QtGui[19528]
#define sipNameNr_QStyle__ControlElement 19551
#define sipName_QStyle__ControlElement &sipStrings_QtGui[19551]
#define sipNameNr_PE_IndicatorArrowRight 19574
#define sipName_PE_IndicatorArrowRight &sipStrings_QtGui[19574]
#define sipNameNr_takeVerticalHeaderItem 19597
#define sipName_takeVerticalHeaderItem &sipStrings_QtGui[19597]
#define sipNameNr_setChildrenCollapsible 19620
#define sipName_setChildrenCollapsible &sipStrings_QtGui[19620]
#define sipNameNr_setSortCaseSensitivity 19643
#define sipName_setSortCaseSensitivity &sipStrings_QtGui[19643]
#define sipNameNr_allowsErrorInteraction 19666
#define sipName_allowsErrorInteraction &sipStrings_QtGui[19666]
#define sipNameNr_setFacingPagesViewMode 19689
#define sipName_setFacingPagesViewMode &sipStrings_QtGui[19689]
#define sipNameNr_setPortraitOrientation 19712
#define sipName_setPortraitOrientation &sipStrings_QtGui[19712]
#define sipNameNr_PrintEnginePropertyKey 3904
#define sipName_PrintEnginePropertyKey &sipStrings_QtGui[3904]
#define sipNameNr_setDoubleSidedPrinting 19735
#define sipName_setDoubleSidedPrinting &sipStrings_QtGui[19735]
#define sipNameNr_printerSelectionOption 19758
#define sipName_printerSelectionOption &sipStrings_QtGui[19758]
#define sipNameNr_QPrinter__OutputFormat 19781
#define sipName_QPrinter__OutputFormat &sipStrings_QtGui[19781]
#define sipNameNr_QPrinter__PrinterState 19804
#define sipName_QPrinter__PrinterState &sipStrings_QtGui[19804]
#define sipNameNr_mergeCurrentCharFormat 19827
#define sipName_mergeCurrentCharFormat &sipStrings_QtGui[19827]
#define sipNameNr_PaintOutsidePaintEvent 19850
#define sipName_PaintOutsidePaintEvent &sipStrings_QtGui[19850]
#define sipNameNr_QTextItem__RenderFlags 19873
#define sipName_QTextItem__RenderFlags &sipStrings_QtGui[19873]
#define sipNameNr_CompositionMode_Darken 19896
#define sipName_CompositionMode_Darken &sipStrings_QtGui[19896]
#define sipNameNr_CompositionMode_Screen 19919
#define sipName_CompositionMode_Screen &sipStrings_QtGui[19919]
#define sipNameNr_CompositionMode_Source 19942
#define sipName_CompositionMode_Source &sipStrings_QtGui[19942]
#define sipNameNr_PageSetupDialogOptions 1740
#define sipName_PageSetupDialogOptions &sipStrings_QtGui[1740]
#define sipNameNr_ActivationHistoryOrder 19965
#define sipName_ActivationHistoryOrder &sipStrings_QtGui[19965]
#define sipNameNr_toolButtonStyleChanged 19988
#define sipName_toolButtonStyleChanged &sipStrings_QtGui[19988]
#define sipNameNr_isSelectionRectVisible 20011
#define sipName_isSelectionRectVisible &sipStrings_QtGui[20011]
#define sipNameNr_UnsupportedFormatError 20034
#define sipName_UnsupportedFormatError &sipStrings_QtGui[20034]
#define sipNameNr_rowIntersectsSelection 20057
#define sipName_rowIntersectsSelection &sipStrings_QtGui[20057]
#define sipNameNr_QItemEditorCreatorBase 20080
#define sipName_QItemEditorCreatorBase &sipStrings_QtGui[20080]
#define sipNameNr_AvailableSizesArgument 3421
#define sipName_AvailableSizesArgument &sipStrings_QtGui[3421]
#define sipNameNr_setOffsetToLastSection 20103
#define sipName_setOffsetToLastSection &sipStrings_QtGui[20103]
#define sipNameNr_QGraphicsItemAnimation 20126
#define sipName_QGraphicsItemAnimation &sipStrings_QtGui[20126]
#define sipNameNr_removeSceneEventFilter 20149
#define sipName_removeSceneEventFilter &sipStrings_QtGui[20149]
#define sipNameNr_ItemStacksBehindParent 20172
#define sipName_ItemStacksBehindParent &sipStrings_QtGui[20172]
#define sipNameNr_ItemSelectedHasChanged 20195
#define sipName_ItemSelectedHasChanged &sipStrings_QtGui[20195]
#define sipNameNr_ItemPositionHasChanged 20218
#define sipName_ItemPositionHasChanged &sipStrings_QtGui[20218]
#define sipNameNr_ItemChildRemovedChange 20241
#define sipName_ItemChildRemovedChange &sipStrings_QtGui[20241]
#define sipNameNr_setColumnStretchFactor 20264
#define sipName_setColumnStretchFactor &sipStrings_QtGui[20264]
#define sipNameNr_QWhatsThisClickedEvent 20287
#define sipName_QWhatsThisClickedEvent &sipStrings_QtGui[20287]
#define sipNameNr_setCurrentSectionIndex 20310
#define sipName_setCurrentSectionIndex &sipStrings_QtGui[20310]
#define sipNameNr_QDateTimeEdit__Section 20333
#define sipName_QDateTimeEdit__Section &sipStrings_QtGui[20333]
#define sipNameNr_setDateEditAcceptDelay 20356
#define sipName_setDateEditAcceptDelay &sipStrings_QtGui[20356]
#define sipNameNr_isNavigationBarVisible 20379
#define sipName_isNavigationBarVisible &sipStrings_QtGui[20379]
#define sipNameNr_horizontalHeaderFormat 20402
#define sipName_horizontalHeaderFormat &sipStrings_QtGui[20402]
#define sipNameNr_HorizontalHeaderFormat 2422
#define sipName_HorizontalHeaderFormat &sipStrings_QtGui[2422]
#define sipNameNr_keyboardInputDirection 20425
#define sipName_keyboardInputDirection &sipStrings_QtGui[20425]
#define sipNameNr_quitOnLastWindowClosed 20448
#define sipName_quitOnLastWindowClosed &sipStrings_QtGui[20448]
#define sipNameNr_setDoubleClickInterval 20471
#define sipName_setDoubleClickInterval &sipStrings_QtGui[20471]
#define sipNameNr_CorrectToPreviousValue 20494
#define sipName_CorrectToPreviousValue &sipStrings_QtGui[20494]
#define sipNameNr_setHorizontalScrollBar 20517
#define sipName_setHorizontalScrollBar &sipStrings_QtGui[20517]
#define sipNameNr_mapSelectionFromSource 20540
#define sipName_mapSelectionFromSource &sipStrings_QtGui[20540]
#define sipNameNr_horizontalStepsPerItem 20563
#define sipName_horizontalStepsPerItem &sipStrings_QtGui[20563]
#define sipNameNr_updateEditorGeometries 20586
#define sipName_updateEditorGeometries &sipStrings_QtGui[20586]
#define sipNameNr_20609 20609
#define sipName_20609 &sipStrings_QtGui[20609]
#define sipNameNr_20631 20631
#define sipName_20631 &sipStrings_QtGui[20631]
#define sipNameNr_20653 20653
#define sipName_20653 &sipStrings_QtGui[20653]
#define sipNameNr_20675 20675
#define sipName_20675 &sipStrings_QtGui[20675]
#define sipNameNr_QWizard__WizardOption 20697
#define sipName_QWizard__WizardOption &sipStrings_QtGui[20697]
#define sipNameNr_QWizard__WizardPixmap 20719
#define sipName_QWizard__WizardPixmap &sipStrings_QtGui[20719]
#define sipNameNr_QWizard__WizardButton 20741
#define sipName_QWizard__WizardButton &sipStrings_QtGui[20741]
#define sipNameNr_setAutoFillBackground 20763
#define sipName_setAutoFillBackground &sipStrings_QtGui[20763]
#define sipNameNr_setFirstColumnSpanned 20785
#define sipName_setFirstColumnSpanned &sipStrings_QtGui[20785]
#define sipNameNr_IncludeTrailingSpaces 20807
#define sipName_IncludeTrailingSpaces &sipStrings_QtGui[20807]
#define sipNameNr_QTextOption__WrapMode 20829
#define sipName_QTextOption__WrapMode &sipStrings_QtGui[20829]
#define sipNameNr_isValidCursorPosition 20851
#define sipName_isValidCursorPosition &sipStrings_QtGui[20851]
#define sipNameNr_setFontCapitalization 20873
#define sipName_setFontCapitalization &sipStrings_QtGui[20873]
#define sipNameNr_TableCellRightPadding 20895
#define sipName_TableCellRightPadding &sipStrings_QtGui[20895]
#define sipNameNr_TextVerticalAlignment 20917
#define sipName_TextVerticalAlignment &sipStrings_QtGui[20917]
#define sipNameNr_QTextFormat__Property 20939
#define sipName_QTextFormat__Property &sipStrings_QtGui[20939]
#define sipNameNr_PageBreak_AlwaysAfter 20961
#define sipName_PageBreak_AlwaysAfter &sipStrings_QtGui[20961]
#define sipNameNr_lineWrapColumnOrWidth 20983
#define sipName_lineWrapColumnOrWidth &sipStrings_QtGui[20983]
#define sipNameNr_QTextDocumentFragment 21005
#define sipName_QTextDocumentFragment &sipStrings_QtGui[21005]
#define sipNameNr_documentLayoutChanged 21027
#define sipName_documentLayoutChanged &sipStrings_QtGui[21027]
#define sipNameNr_findBlockByLineNumber 21049
#define sipName_findBlockByLineNumber &sipStrings_QtGui[21049]
#define sipNameNr_joinPreviousEditBlock 21071
#define sipName_joinPreviousEditBlock &sipStrings_QtGui[21071]
#define sipNameNr_QTextCursor__MoveMode 21093
#define sipName_QTextCursor__MoveMode &sipStrings_QtGui[21093]
#define sipNameNr_isCornerButtonEnabled 21115
#define sipName_isCornerButtonEnabled &sipStrings_QtGui[21115]
#define sipNameNr_isSystemTrayAvailable 21137
#define sipName_isSystemTrayAvailable &sipStrings_QtGui[21137]
#define sipNameNr_QStyleOptionToolBoxV2 21159
#define sipName_QStyleOptionToolBoxV2 &sipStrings_QtGui[21159]
#define sipNameNr_menuHasCheckableItems 21181
#define sipName_menuHasCheckableItems &sipStrings_QtGui[21181]
#define sipNameNr_rightCornerWidgetSize 21203
#define sipName_rightCornerWidgetSize &sipStrings_QtGui[21203]
#define sipNameNr_QStyleOptionFocusRect 21225
#define sipName_QStyleOptionFocusRect &sipStrings_QtGui[21225]
#define sipNameNr_combinedLayoutSpacing 21247
#define sipName_combinedLayoutSpacing &sipStrings_QtGui[21247]
#define sipNameNr_SP_DialogCancelButton 21269
#define sipName_SP_DialogCancelButton &sipStrings_QtGui[21269]
#define sipNameNr_SP_FileDialogListView 21291
#define sipName_SP_FileDialogListView &sipStrings_QtGui[21291]
#define sipNameNr_SP_FileDialogInfoView 21313
#define sipName_SP_FileDialogInfoView &sipStrings_QtGui[21313]
#define sipNameNr_SP_FileDialogToParent 21335
#define sipName_SP_FileDialogToParent &sipStrings_QtGui[21335]
#define sipNameNr_SP_MessageBoxQuestion 21357
#define sipName_SP_MessageBoxQuestion &sipStrings_QtGui[21357]
#define sipNameNr_SP_MessageBoxCritical 21379
#define sipName_SP_MessageBoxCritical &sipStrings_QtGui[21379]
#define sipNameNr_SP_TitleBarMenuButton 21401
#define sipName_SP_TitleBarMenuButton &sipStrings_QtGui[21401]
#define sipNameNr_SH_Menu_FadeOutOnHide 21423
#define sipName_SH_Menu_FadeOutOnHide &sipStrings_QtGui[21423]
#define sipNameNr_SH_Menu_SelectionWrap 21445
#define sipName_SH_Menu_SelectionWrap &sipStrings_QtGui[21445]
#define sipNameNr_SH_DialogButtonLayout 21467
#define sipName_SH_DialogButtonLayout &sipStrings_QtGui[21467]
#define sipNameNr_SH_TitleBar_AutoRaise 21489
#define sipName_SH_TitleBar_AutoRaise &sipStrings_QtGui[21489]
#define sipNameNr_SH_Button_FocusPolicy 21511
#define sipName_SH_Button_FocusPolicy &sipStrings_QtGui[21511]
#define sipNameNr_SH_Menu_MouseTracking 21533
#define sipName_SH_Menu_MouseTracking &sipStrings_QtGui[21533]
#define sipNameNr_SH_Slider_SnapToValue 21555
#define sipName_SH_Slider_SnapToValue &sipStrings_QtGui[21555]
#define sipNameNr_SH_DitherDisabledText 21577
#define sipName_SH_DitherDisabledText &sipStrings_QtGui[21577]
#define sipNameNr_PM_LayoutBottomMargin 21599
#define sipName_PM_LayoutBottomMargin &sipStrings_QtGui[21599]
#define sipNameNr_PM_MessageBoxIconSize 21621
#define sipName_PM_MessageBoxIconSize &sipStrings_QtGui[21621]
#define sipNameNr_PM_DefaultChildMargin 21643
#define sipName_PM_DefaultChildMargin &sipStrings_QtGui[21643]
#define sipNameNr_PM_ToolBarItemSpacing 21665
#define sipName_PM_ToolBarItemSpacing &sipStrings_QtGui[21665]
#define sipNameNr_PM_MenuBarItemSpacing 21687
#define sipName_PM_MenuBarItemSpacing &sipStrings_QtGui[21687]
#define sipNameNr_PM_MenuScrollerHeight 21709
#define sipName_PM_MenuScrollerHeight &sipStrings_QtGui[21709]
#define sipNameNr_PM_ScrollBarSliderMin 21731
#define sipName_PM_ScrollBarSliderMin &sipStrings_QtGui[21731]
#define sipNameNr_PM_ComboBoxFrameWidth 21753
#define sipName_PM_ComboBoxFrameWidth &sipStrings_QtGui[21753]
#define sipNameNr_hitTestComplexControl 21775
#define sipName_hitTestComplexControl &sipStrings_QtGui[21775]
#define sipNameNr_SE_GroupBoxLayoutItem 21797
#define sipName_SE_GroupBoxLayoutItem &sipStrings_QtGui[21797]
#define sipNameNr_SE_ComboBoxLayoutItem 21819
#define sipName_SE_ComboBoxLayoutItem &sipStrings_QtGui[21819]
#define sipNameNr_SE_CheckBoxLayoutItem 21841
#define sipName_SE_CheckBoxLayoutItem &sipStrings_QtGui[21841]
#define sipNameNr_SE_ToolBoxTabContents 21863
#define sipName_SE_ToolBoxTabContents &sipStrings_QtGui[21863]
#define sipNameNr_SE_DialogButtonCustom 21885
#define sipName_SE_DialogButtonCustom &sipStrings_QtGui[21885]
#define sipNameNr_SE_DialogButtonIgnore 21907
#define sipName_SE_DialogButtonIgnore &sipStrings_QtGui[21907]
#define sipNameNr_SE_DialogButtonReject 21929
#define sipName_SE_DialogButtonReject &sipStrings_QtGui[21929]
#define sipNameNr_SE_DialogButtonAccept 21951
#define sipName_SE_DialogButtonAccept &sipStrings_QtGui[21951]
#define sipNameNr_SE_PushButtonContents 21973
#define sipName_SE_PushButtonContents &sipStrings_QtGui[21973]
#define sipNameNr_PE_FrameStatusBarItem 21995
#define sipName_PE_FrameStatusBarItem &sipStrings_QtGui[21995]
#define sipNameNr_PE_IndicatorSpinMinus 22017
#define sipName_PE_IndicatorSpinMinus &sipStrings_QtGui[22017]
#define sipNameNr_PE_IndicatorArrowLeft 22039
#define sipName_PE_IndicatorArrowLeft &sipStrings_QtGui[22039]
#define sipNameNr_PE_IndicatorArrowDown 22061
#define sipName_PE_IndicatorArrowDown &sipStrings_QtGui[22061]
#define sipNameNr_PE_PanelButtonCommand 22083
#define sipName_PE_PanelButtonCommand &sipStrings_QtGui[22083]
#define sipNameNr_PE_FrameDefaultButton 22105
#define sipName_PE_FrameDefaultButton &sipStrings_QtGui[22105]
#define sipNameNr_insertPermanentWidget 22127
#define sipName_insertPermanentWidget &sipStrings_QtGui[22127]
#define sipNameNr_accessibleDescription 22149
#define sipName_accessibleDescription &sipStrings_QtGui[22149]
#define sipNameNr_setVerticalHeaderItem 22171
#define sipName_setVerticalHeaderItem &sipStrings_QtGui[22171]
#define sipNameNr_filterCaseSensitivity 22193
#define sipName_filterCaseSensitivity &sipStrings_QtGui[22193]
#define sipNameNr_QSortFilterProxyModel 22215
#define sipName_QSortFilterProxyModel &sipStrings_QtGui[22215]
#define sipNameNr_QSlider__TickPosition 22237
#define sipName_QSlider__TickPosition &sipStrings_QtGui[22237]
#define sipNameNr_setSinglePageViewMode 22259
#define sipName_setSinglePageViewMode &sipStrings_QtGui[22259]
#define sipNameNr_QPrinter__PaperSource 22281
#define sipName_QPrinter__PaperSource &sipStrings_QtGui[22281]
#define sipNameNr_QPrinter__Orientation 22303
#define sipName_QPrinter__Orientation &sipStrings_QtGui[22303]
#define sipNameNr_QPrinter__PrinterMode 22325
#define sipName_QPrinter__PrinterMode &sipStrings_QtGui[22325]
#define sipNameNr_blockBoundingGeometry 22347
#define sipName_blockBoundingGeometry &sipStrings_QtGui[22347]
#define sipNameNr_canInsertFromMimeData 22369
#define sipName_canInsertFromMimeData &sipStrings_QtGui[22369]
#define sipNameNr_QPainterPath__Element 22391
#define sipName_QPainterPath__Element &sipStrings_QtGui[22391]
#define sipNameNr_QTextItem__RenderFlag 22413
#define sipName_QTextItem__RenderFlag &sipStrings_QtGui[22413]
#define sipNameNr_setWorldMatrixEnabled 22435
#define sipName_setWorldMatrixEnabled &sipStrings_QtGui[22435]
#define sipNameNr_CompositionMode_Clear 22457
#define sipName_CompositionMode_Clear &sipStrings_QtGui[22457]
#define sipNameNr_QPainter__RenderHints 22479
#define sipName_QPainter__RenderHints &sipStrings_QtGui[22479]
#define sipNameNr_NonCosmeticDefaultPen 22501
#define sipName_NonCosmeticDefaultPen &sipStrings_QtGui[22501]
#define sipNameNr_SmoothPixmapTransform 22523
#define sipName_SmoothPixmapTransform &sipStrings_QtGui[22523]
#define sipNameNr_PageSetupDialogOption 2383
#define sipName_PageSetupDialogOption &sipStrings_QtGui[2383]
#define sipNameNr_separatorsCollapsible 22545
#define sipName_separatorsCollapsible &sipStrings_QtGui[22545]
#define sipNameNr_setKeyboardSingleStep 22567
#define sipName_setKeyboardSingleStep &sipStrings_QtGui[22567]
#define sipNameNr_activateNextSubWindow 22589
#define sipName_activateNextSubWindow &sipStrings_QtGui[22589]
#define sipNameNr_QMdiArea__WindowOrder 22611
#define sipName_QMdiArea__WindowOrder &sipStrings_QtGui[22611]
#define sipNameNr_QMdiArea__AreaOptions 22633
#define sipName_QMdiArea__AreaOptions &sipStrings_QtGui[22633]
#define sipNameNr_setDockNestingEnabled 22655
#define sipName_setDockNestingEnabled &sipStrings_QtGui[22655]
#define sipNameNr_QListView__LayoutMode 22677
#define sipName_QListView__LayoutMode &sipStrings_QtGui[22677]
#define sipNameNr_QListView__ResizeMode 22699
#define sipName_QListView__ResizeMode &sipStrings_QtGui[22699]
#define sipNameNr_cursorPositionChanged 22721
#define sipName_cursorPositionChanged &sipStrings_QtGui[22721]
#define sipNameNr_closestAcceptableSize 22743
#define sipName_closestAcceptableSize &sipStrings_QtGui[22743]
#define sipNameNr_SelectStartOfDocument 22765
#define sipName_SelectStartOfDocument &sipStrings_QtGui[22765]
#define sipNameNr_MoveToStartOfDocument 22787
#define sipName_MoveToStartOfDocument &sipStrings_QtGui[22787]
#define sipNameNr_autoDetectImageFormat 22809
#define sipName_autoDetectImageFormat &sipStrings_QtGui[22809]
#define sipNameNr_supportedImageFormats 22831
#define sipName_supportedImageFormats &sipStrings_QtGui[22831]
#define sipNameNr_setMinimumSectionSize 22853
#define sipName_setMinimumSectionSize &sipStrings_QtGui[22853]
#define sipNameNr_setDefaultSectionSize 22875
#define sipName_setDefaultSectionSize &sipStrings_QtGui[22875]
#define sipNameNr_setStretchLastSection 22897
#define sipName_setStretchLastSection &sipStrings_QtGui[22897]
#define sipNameNr_setSortIndicatorShown 22919
#define sipName_setSortIndicatorShown &sipStrings_QtGui[22919]
#define sipNameNr_setDefaultPositioning 22941
#define sipName_setDefaultPositioning &sipStrings_QtGui[22941]
#define sipNameNr_setViewportUpdateMode 22963
#define sipName_setViewportUpdateMode &sipStrings_QtGui[22963]
#define sipNameNr_MinimalViewportUpdate 22985
#define sipName_MinimalViewportUpdate &sipStrings_QtGui[22985]
#define sipNameNr_setShortcutAutoRepeat 23007
#define sipName_setShortcutAutoRepeat &sipStrings_QtGui[23007]
#define sipNameNr_getWindowFrameMargins 23029
#define sipName_getWindowFrameMargins &sipStrings_QtGui[23029]
#define sipNameNr_setWindowFrameMargins 17735
#define sipName_setWindowFrameMargins &sipStrings_QtGui[17735]
#define sipNameNr_QGraphicsLinearLayout 23051
#define sipName_QGraphicsLinearLayout &sipStrings_QtGui[23051]
#define sipNameNr_setTransformationMode 23073
#define sipName_setTransformationMode &sipStrings_QtGui[23073]
#define sipNameNr_prepareGeometryChange 23095
#define sipName_prepareGeometryChange &sipStrings_QtGui[23095]
#define sipNameNr_setHandlesChildEvents 23117
#define sipName_setHandlesChildEvents &sipStrings_QtGui[23117]
#define sipNameNr_setAcceptsHoverEvents 23139
#define sipName_setAcceptsHoverEvents &sipStrings_QtGui[23139]
#define sipNameNr_ItemOpacityHasChanged 23161
#define sipName_ItemOpacityHasChanged &sipStrings_QtGui[23161]
#define sipNameNr_ItemToolTipHasChanged 23183
#define sipName_ItemToolTipHasChanged &sipStrings_QtGui[23183]
#define sipNameNr_ItemEnabledHasChanged 23205
#define sipName_ItemEnabledHasChanged &sipStrings_QtGui[23205]
#define sipNameNr_ItemVisibleHasChanged 23227
#define sipName_ItemVisibleHasChanged &sipStrings_QtGui[23227]
#define sipNameNr_DeviceCoordinateCache 23249
#define sipName_DeviceCoordinateCache &sipStrings_QtGui[23249]
#define sipNameNr_setColumnMaximumWidth 23271
#define sipName_setColumnMaximumWidth &sipStrings_QtGui[23271]
#define sipNameNr_setColumnMinimumWidth 23293
#define sipName_setColumnMinimumWidth &sipStrings_QtGui[23293]
#define sipNameNr_setRowPreferredHeight 23315
#define sipName_setRowPreferredHeight &sipStrings_QtGui[23315]
#define sipNameNr_QFormLayout__ItemRole 23337
#define sipName_QFormLayout__ItemRole &sipStrings_QtGui[23337]
#define sipNameNr_AllNonFixedFieldsGrow 23359
#define sipName_AllNonFixedFieldsGrow &sipStrings_QtGui[23359]
#define sipNameNr_removeApplicationFont 23381
#define sipName_removeApplicationFont &sipStrings_QtGui[23381]
#define sipNameNr_QFont__Capitalization 23403
#define sipName_QFont__Capitalization &sipStrings_QtGui[23403]
#define sipNameNr_setNameFilterDisables 23425
#define sipName_setNameFilterDisables &sipStrings_QtGui[23425]
#define sipNameNr_HideNameFilterDetails 23447
#define sipName_HideNameFilterDetails &sipStrings_QtGui[23447]
#define sipNameNr_QFileDialog__FileMode 23469
#define sipName_QFileDialog__FileMode &sipStrings_QtGui[23469]
#define sipNameNr_QFileDialog__ViewMode 23491
#define sipName_QFileDialog__ViewMode &sipStrings_QtGui[23491]
#define sipNameNr_AllDockWidgetFeatures 23513
#define sipName_AllDockWidgetFeatures &sipStrings_QtGui[23513]
#define sipNameNr_minimumContentsLength 23535
#define sipName_minimumContentsLength &sipStrings_QtGui[23535]
#define sipNameNr_setResizeGripsVisible 23557
#define sipName_setResizeGripsVisible &sipStrings_QtGui[23557]
#define sipNameNr_setAllowX11ColorNames 23579
#define sipName_setAllowX11ColorNames &sipStrings_QtGui[23579]
#define sipNameNr_minimumHeightForWidth 23601
#define sipName_minimumHeightForWidth &sipStrings_QtGui[23601]
#define sipNameNr_QBoxLayout__Direction 23623
#define sipName_QBoxLayout__Direction &sipStrings_QtGui[23623]
#define sipNameNr_keyboardInputInterval 23645
#define sipName_keyboardInputInterval &sipStrings_QtGui[23645]
#define sipNameNr_restoreOverrideCursor 23667
#define sipName_restoreOverrideCursor &sipStrings_QtGui[23667]
#define sipNameNr_setInvertedAppearance 23689
#define sipName_setInvertedAppearance &sipStrings_QtGui[23689]
#define sipNameNr_CorrectToNearestValue 23711
#define sipName_CorrectToNearestValue &sipStrings_QtGui[23711]
#define sipNameNr_itemDelegateForColumn 23733
#define sipName_itemDelegateForColumn &sipStrings_QtGui[23733]
#define sipNameNr_setItemDelegateForRow 23755
#define sipName_setItemDelegateForRow &sipStrings_QtGui[23755]
#define sipNameNr_dragDropOverwriteMode 23777
#define sipName_dragDropOverwriteMode &sipStrings_QtGui[23777]
#define sipNameNr_setVerticalScrollMode 23799
#define sipName_setVerticalScrollMode &sipStrings_QtGui[23799]
#define sipNameNr_dropIndicatorPosition 23821
#define sipName_dropIndicatorPosition &sipStrings_QtGui[23821]
#define sipNameNr_DropIndicatorPosition 1823
#define sipName_DropIndicatorPosition &sipStrings_QtGui[1823]
#define sipNameNr_mouseDoubleClickEvent 23843
#define sipName_mouseDoubleClickEvent &sipStrings_QtGui[23843]
#define sipNameNr_closePersistentEditor 23865
#define sipName_closePersistentEditor &sipStrings_QtGui[23865]
#define sipNameNr_setDropIndicatorShown 23887
#define sipName_setDropIndicatorShown &sipStrings_QtGui[23887]
#define sipNameNr_QAbstractItemDelegate 23909
#define sipName_QAbstractItemDelegate &sipStrings_QtGui[23909]
#define sipNameNr_setAutoRepeatInterval 23931
#define sipName_setAutoRepeatInterval &sipStrings_QtGui[23931]
#define sipNameNr_changePersistentIndex 23953
#define sipName_changePersistentIndex &sipStrings_QtGui[23953]
#define sipNameNr_23975 23975
#define sipName_23975 &sipStrings_QtGui[23975]
#define sipNameNr_23996 23996
#define sipName_23996 &sipStrings_QtGui[23996]
#define sipNameNr_setScrollBarsEnabled 24017
#define sipName_setScrollBarsEnabled &sipStrings_QtGui[24017]
#define sipNameNr_QWizard__WizardStyle 24038
#define sipName_QWizard__WizardStyle &sipStrings_QtGui[24038]
#define sipNameNr_QWidget__RenderFlags 24059
#define sipName_QWidget__RenderFlags &sipStrings_QtGui[24059]
#define sipNameNr_DrawWindowBackground 24080
#define sipName_DrawWindowBackground &sipStrings_QtGui[24080]
#define sipNameNr_setContextMenuPolicy 24101
#define sipName_setContextMenuPolicy &sipStrings_QtGui[24101]
#define sipNameNr_childIndicatorPolicy 24122
#define sipName_childIndicatorPolicy &sipStrings_QtGui[24122]
#define sipNameNr_ChildIndicatorPolicy 2891
#define sipName_ChildIndicatorPolicy &sipStrings_QtGui[2891]
#define sipNameNr_expandsOnDoubleClick 24143
#define sipName_expandsOnDoubleClick &sipStrings_QtGui[24143]
#define sipNameNr_isFirstColumnSpanned 24164
#define sipName_isFirstColumnSpanned &sipStrings_QtGui[24164]
#define sipNameNr_setUniformRowHeights 24185
#define sipName_setUniformRowHeights &sipStrings_QtGui[24185]
#define sipNameNr_tableCellFormatIndex 24206
#define sipName_tableCellFormatIndex &sipStrings_QtGui[24206]
#define sipNameNr_QTextOption__TabType 24227
#define sipName_QTextOption__TabType &sipStrings_QtGui[24227]
#define sipNameNr_QTextBlock__iterator 24248
#define sipName_QTextBlock__iterator &sipStrings_QtGui[24248]
#define sipNameNr_QTextFrame__iterator 24269
#define sipName_QTextFrame__iterator &sipStrings_QtGui[24269]
#define sipNameNr_setAdditionalFormats 24290
#define sipName_setAdditionalFormats &sipStrings_QtGui[24290]
#define sipNameNr_QTextTableCellFormat 24311
#define sipName_QTextTableCellFormat &sipStrings_QtGui[24311]
#define sipNameNr_setNonBreakableLines 24332
#define sipName_setNonBreakableLines &sipStrings_QtGui[24332]
#define sipNameNr_setFontStyleStrategy 24353
#define sipName_setFontStyleStrategy &sipStrings_QtGui[24353]
#define sipNameNr_setFontLetterSpacing 24374
#define sipName_setFontLetterSpacing &sipStrings_QtGui[24374]
#define sipNameNr_setVerticalAlignment 24395
#define sipName_setVerticalAlignment &sipStrings_QtGui[24395]
#define sipNameNr_lengthVectorProperty 24416
#define sipName_lengthVectorProperty &sipStrings_QtGui[24416]
#define sipNameNr_TableCellLeftPadding 24437
#define sipName_TableCellLeftPadding &sipStrings_QtGui[24437]
#define sipNameNr_setDefaultTextOption 24458
#define sipName_setDefaultTextOption &sipStrings_QtGui[24458]
#define sipNameNr_setDefaultStyleSheet 24479
#define sipName_setDefaultStyleSheet &sipStrings_QtGui[24479]
#define sipNameNr_convertFromPlainText 24500
#define sipName_convertFromPlainText &sipStrings_QtGui[24500]
#define sipNameNr_mergeBlockCharFormat 24521
#define sipName_mergeBlockCharFormat &sipStrings_QtGui[24521]
#define sipNameNr_backwardHistoryCount 24542
#define sipName_backwardHistoryCount &sipStrings_QtGui[24542]
#define sipNameNr_QTabWidget__TabShape 24563
#define sipName_QTabWidget__TabShape &sipStrings_QtGui[24563]
#define sipNameNr_resizeRowsToContents 24584
#define sipName_resizeRowsToContents &sipStrings_QtGui[24584]
#define sipNameNr_setUsesScrollButtons 24605
#define sipName_setUsesScrollButtons &sipStrings_QtGui[24605]
#define sipNameNr_currentBlockUserData 24626
#define sipName_currentBlockUserData &sipStrings_QtGui[24626]
#define sipNameNr_setCurrentBlockState 24647
#define sipName_setCurrentBlockState &sipStrings_QtGui[24647]
#define sipNameNr_QStyleOptionSizeGrip 24668
#define sipName_QStyleOptionSizeGrip &sipStrings_QtGui[24668]
#define sipNameNr_QStyleOptionGroupBox 24689
#define sipName_QStyleOptionGroupBox &sipStrings_QtGui[24689]
#define sipNameNr_QStyleHintReturnMask 24710
#define sipName_QStyleHintReturnMask &sipStrings_QtGui[24710]
#define sipNameNr_QStyleOptionTitleBar 24731
#define sipName_QStyleOptionTitleBar &sipStrings_QtGui[24731]
#define sipNameNr_QStyleOptionComboBox 24752
#define sipName_QStyleOptionComboBox &sipStrings_QtGui[24752]
#define sipNameNr_QStyleOptionViewItem 24773
#define sipName_QStyleOptionViewItem &sipStrings_QtGui[24773]
#define sipNameNr_QStyleOptionMenuItem 24794
#define sipName_QStyleOptionMenuItem &sipStrings_QtGui[24794]
#define sipNameNr_leftCornerWidgetSize 24815
#define sipName_leftCornerWidgetSize &sipStrings_QtGui[24815]
#define sipNameNr_SO_ComplexCustomBase 24836
#define sipName_SO_ComplexCustomBase &sipStrings_QtGui[24836]
#define sipNameNr_SP_MediaSeekBackward 24857
#define sipName_SP_MediaSeekBackward &sipStrings_QtGui[24857]
#define sipNameNr_SP_MediaSkipBackward 24878
#define sipName_SP_MediaSkipBackward &sipStrings_QtGui[24878]
#define sipNameNr_SP_DialogResetButton 24899
#define sipName_SP_DialogResetButton &sipStrings_QtGui[24899]
#define sipNameNr_SP_DialogApplyButton 24920
#define sipName_SP_DialogApplyButton &sipStrings_QtGui[24920]
#define sipNameNr_SP_DialogCloseButton 24941
#define sipName_SP_DialogCloseButton &sipStrings_QtGui[24941]
#define sipNameNr_SP_MessageBoxWarning 24962
#define sipName_SP_MessageBoxWarning &sipStrings_QtGui[24962]
#define sipNameNr_SP_TitleBarMaxButton 24983
#define sipName_SP_TitleBarMaxButton &sipStrings_QtGui[24983]
#define sipNameNr_SP_TitleBarMinButton 25004
#define sipName_SP_TitleBarMinButton &sipStrings_QtGui[25004]
#define sipNameNr_SH_UnderlineShortcut 25025
#define sipName_SH_UnderlineShortcut &sipStrings_QtGui[25025]
#define sipNameNr_SH_TitleBar_NoBorder 25046
#define sipName_SH_TitleBar_NoBorder &sipStrings_QtGui[25046]
#define sipNameNr_QStyle__ContentsType 25067
#define sipName_QStyle__ContentsType &sipStrings_QtGui[25067]
#define sipNameNr_PM_LayoutRightMargin 25088
#define sipName_PM_LayoutRightMargin &sipStrings_QtGui[25088]
#define sipNameNr_PM_FocusFrameHMargin 25109
#define sipName_PM_FocusFrameHMargin &sipStrings_QtGui[25109]
#define sipNameNr_PM_FocusFrameVMargin 25130
#define sipName_PM_FocusFrameVMargin &sipStrings_QtGui[25130]
#define sipNameNr_PM_ToolBarItemMargin 25151
#define sipName_PM_ToolBarItemMargin &sipStrings_QtGui[25151]
#define sipNameNr_PM_ToolBarFrameWidth 25172
#define sipName_PM_ToolBarFrameWidth &sipStrings_QtGui[25172]
#define sipNameNr_PM_MDIMinimizedWidth 25193
#define sipName_PM_MDIMinimizedWidth &sipStrings_QtGui[25193]
#define sipNameNr_PM_MenuBarPanelWidth 25214
#define sipName_PM_MenuBarPanelWidth &sipStrings_QtGui[25214]
#define sipNameNr_PM_MenuTearoffHeight 25235
#define sipName_PM_MenuTearoffHeight &sipStrings_QtGui[25235]
#define sipNameNr_PM_TabBarBaseOverlap 25256
#define sipName_PM_TabBarBaseOverlap &sipStrings_QtGui[25256]
#define sipNameNr_PM_SpinBoxFrameWidth 25277
#define sipName_PM_SpinBoxFrameWidth &sipStrings_QtGui[25277]
#define sipNameNr_PM_DefaultFrameWidth 25298
#define sipName_PM_DefaultFrameWidth &sipStrings_QtGui[25298]
#define sipNameNr_SC_TitleBarMaxButton 25319
#define sipName_SC_TitleBarMaxButton &sipStrings_QtGui[25319]
#define sipNameNr_SC_TitleBarMinButton 25340
#define sipName_SC_TitleBarMinButton &sipStrings_QtGui[25340]
#define sipNameNr_SC_ComboBoxEditField 25361
#define sipName_SC_ComboBoxEditField &sipStrings_QtGui[25361]
#define sipNameNr_SE_SpinBoxLayoutItem 25382
#define sipName_SE_SpinBoxLayoutItem &sipStrings_QtGui[25382]
#define sipNameNr_SE_DialogButtonRetry 25403
#define sipName_SE_DialogButtonRetry &sipStrings_QtGui[25403]
#define sipNameNr_SE_DialogButtonAbort 25424
#define sipName_SE_DialogButtonAbort &sipStrings_QtGui[25424]
#define sipNameNr_SE_DialogButtonApply 25445
#define sipName_SE_DialogButtonApply &sipStrings_QtGui[25445]
#define sipNameNr_SE_ProgressBarGroove 25466
#define sipName_SE_ProgressBarGroove &sipStrings_QtGui[25466]
#define sipNameNr_SE_ComboBoxFocusRect 25487
#define sipName_SE_ComboBoxFocusRect &sipStrings_QtGui[25487]
#define sipNameNr_SE_CheckBoxClickRect 25508
#define sipName_SE_CheckBoxClickRect &sipStrings_QtGui[25508]
#define sipNameNr_SE_CheckBoxFocusRect 25529
#define sipName_SE_CheckBoxFocusRect &sipStrings_QtGui[25529]
#define sipNameNr_SE_CheckBoxIndicator 25550
#define sipName_SE_CheckBoxIndicator &sipStrings_QtGui[25550]
#define sipNameNr_CE_ProgressBarGroove 25571
#define sipName_CE_ProgressBarGroove &sipStrings_QtGui[25571]
#define sipNameNr_PE_IndicatorTabClose 25592
#define sipName_PE_IndicatorTabClose &sipStrings_QtGui[25592]
#define sipNameNr_PE_PanelItemViewItem 25613
#define sipName_PE_PanelItemViewItem &sipStrings_QtGui[25613]
#define sipNameNr_PE_IndicatorSpinPlus 25634
#define sipName_PE_IndicatorSpinPlus &sipStrings_QtGui[25634]
#define sipNameNr_PE_IndicatorSpinDown 25655
#define sipName_PE_IndicatorSpinDown &sipStrings_QtGui[25655]
#define sipNameNr_PE_IndicatorCheckBox 25676
#define sipName_PE_IndicatorCheckBox &sipStrings_QtGui[25676]
#define sipNameNr_horizontalHeaderItem 25697
#define sipName_horizontalHeaderItem &sipStrings_QtGui[25697]
#define sipNameNr_closestLegalPosition 25718
#define sipName_closestLegalPosition &sipStrings_QtGui[25718]
#define sipNameNr_setDynamicSortFilter 25739
#define sipName_setDynamicSortFilter &sipStrings_QtGui[25739]
#define sipNameNr_setFilterFixedString 25760
#define sipName_setFilterFixedString &sipStrings_QtGui[25760]
#define sipNameNr_setHorizontalStretch 25781
#define sipName_setHorizontalStretch &sipStrings_QtGui[25781]
#define sipNameNr_activatedAmbiguously 25802
#define sipName_activatedAmbiguously &sipStrings_QtGui[25802]
#define sipNameNr_fontEmbeddingEnabled 25823
#define sipName_fontEmbeddingEnabled &sipStrings_QtGui[25823]
#define sipNameNr_supportedResolutions 25844
#define sipName_supportedResolutions &sipStrings_QtGui[25844]
#define sipNameNr_QPrinter__DuplexMode 25865
#define sipName_QPrinter__DuplexMode &sipStrings_QtGui[25865]
#define sipNameNr_QPrinter__PrintRange 25886
#define sipName_QPrinter__PrintRange &sipStrings_QtGui[25886]
#define sipNameNr_setBackgroundVisible 25907
#define sipName_setBackgroundVisible &sipStrings_QtGui[25907]
#define sipNameNr_setMaximumBlockCount 25928
#define sipName_setMaximumBlockCount &sipStrings_QtGui[25928]
#define sipNameNr_setCurrentCharFormat 25949
#define sipName_setCurrentCharFormat &sipStrings_QtGui[25949]
#define sipNameNr_setCurrentColorGroup 25970
#define sipName_setCurrentColorGroup &sipStrings_QtGui[25970]
#define sipNameNr_QPalette__ColorGroup 25991
#define sipName_QPalette__ColorGroup &sipStrings_QtGui[25991]
#define sipNameNr_setElementPositionAt 26012
#define sipName_setElementPositionAt &sipStrings_QtGui[26012]
#define sipNameNr_DirtyCompositionMode 26033
#define sipName_DirtyCompositionMode &sipStrings_QtGui[26033]
#define sipNameNr_PerspectiveTransform 26054
#define sipName_PerspectiveTransform &sipStrings_QtGui[26054]
#define sipNameNr_viewTransformEnabled 26075
#define sipName_viewTransformEnabled &sipStrings_QtGui[26075]
#define sipNameNr_CompositionMode_Plus 26096
#define sipName_CompositionMode_Plus &sipStrings_QtGui[26096]
#define sipNameNr_QPainter__RenderHint 26117
#define sipName_QPainter__RenderHint &sipStrings_QtGui[26117]
#define sipNameNr_isTearOffMenuVisible 26138
#define sipName_isTearOffMenuVisible &sipStrings_QtGui[26138]
#define sipNameNr_closeActiveSubWindow 26159
#define sipName_closeActiveSubWindow &sipStrings_QtGui[26159]
#define sipNameNr_QMdiArea__AreaOption 26180
#define sipName_QMdiArea__AreaOption &sipStrings_QtGui[26180]
#define sipNameNr_isDockNestingEnabled 26201
#define sipName_isDockNestingEnabled &sipStrings_QtGui[26201]
#define sipNameNr_itemSelectionChanged 26222
#define sipName_itemSelectionChanged &sipStrings_QtGui[26222]
#define sipNameNr_setSmallDecimalPoint 26243
#define sipName_setSmallDecimalPoint &sipStrings_QtGui[26243]
#define sipNameNr_SetDefaultConstraint 26264
#define sipName_SetDefaultConstraint &sipStrings_QtGui[26264]
#define sipNameNr_setItemEditorFactory 26285
#define sipName_setItemEditorFactory &sipStrings_QtGui[26285]
#define sipNameNr_QInputContextFactory 26306
#define sipName_QInputContextFactory &sipStrings_QtGui[26306]
#define sipNameNr_emitSelectionChanged 26327
#define sipName_emitSelectionChanged &sipStrings_QtGui[26327]
#define sipNameNr_currentColumnChanged 26348
#define sipName_currentColumnChanged &sipStrings_QtGui[26348]
#define sipNameNr_sortIndicatorChanged 26369
#define sipName_sortIndicatorChanged &sipStrings_QtGui[26369]
#define sipNameNr_sectionDoubleClicked 26390
#define sipName_sectionDoubleClicked &sipStrings_QtGui[26390]
#define sipNameNr_sortIndicatorSection 26411
#define sipName_sortIndicatorSection &sipStrings_QtGui[26411]
#define sipNameNr_isSortIndicatorShown 26432
#define sipName_isSortIndicatorShown &sipStrings_QtGui[26432]
#define sipNameNr_setHighlightSections 26453
#define sipName_setHighlightSections &sipStrings_QtGui[26453]
#define sipNameNr_setOptimizationFlags 26474
#define sipName_setOptimizationFlags &sipStrings_QtGui[26474]
#define sipNameNr_DontSavePainterState 26495
#define sipName_DontSavePainterState &sipStrings_QtGui[26495]
#define sipNameNr_transformationAnchor 26516
#define sipName_transformationAnchor &sipStrings_QtGui[26516]
#define sipNameNr_windowFrameSectionAt 26537
#define sipName_windowFrameSectionAt &sipStrings_QtGui[26537]
#define sipNameNr_unsetLayoutDirection 26558
#define sipName_unsetLayoutDirection &sipStrings_QtGui[26558]
#define sipNameNr_QGraphicsProxyWidget 26579
#define sipName_QGraphicsProxyWidget &sipStrings_QtGui[26579]
#define sipNameNr_setOpenExternalLinks 26600
#define sipName_setOpenExternalLinks &sipStrings_QtGui[26600]
#define sipNameNr_textInteractionFlags 26621
#define sipName_textInteractionFlags &sipStrings_QtGui[26621]
#define sipNameNr_QGraphicsPolygonItem 26642
#define sipName_QGraphicsPolygonItem &sipStrings_QtGui[26642]
#define sipNameNr_QGraphicsEllipseItem 26663
#define sipName_QGraphicsEllipseItem &sipStrings_QtGui[26663]
#define sipNameNr_setAcceptHoverEvents 26684
#define sipName_setAcceptHoverEvents &sipStrings_QtGui[26684]
#define sipNameNr_childrenBoundingRect 26705
#define sipName_childrenBoundingRect &sipStrings_QtGui[26705]
#define sipNameNr_acceptedMouseButtons 26726
#define sipName_acceptedMouseButtons &sipStrings_QtGui[26726]
#define sipNameNr_ItemZValueHasChanged 26747
#define sipName_ItemZValueHasChanged &sipStrings_QtGui[26747]
#define sipNameNr_ItemFlagsHaveChanged 26768
#define sipName_ItemFlagsHaveChanged &sipStrings_QtGui[26768]
#define sipNameNr_ItemCursorHasChanged 26789
#define sipName_ItemCursorHasChanged &sipStrings_QtGui[26789]
#define sipNameNr_ItemParentHasChanged 26810
#define sipName_ItemParentHasChanged &sipStrings_QtGui[26810]
#define sipNameNr_ItemChildAddedChange 26831
#define sipName_ItemChildAddedChange &sipStrings_QtGui[26831]
#define sipNameNr_columnPreferredWidth 26852
#define sipName_columnPreferredWidth &sipStrings_QtGui[26852]
#define sipNameNr_setHorizontalSpacing 26873
#define sipName_setHorizontalSpacing &sipStrings_QtGui[26873]
#define sipNameNr_setFieldGrowthPolicy 26894
#define sipName_setFieldGrowthPolicy &sipStrings_QtGui[26894]
#define sipNameNr_FieldsStayAtSizeHint 26915
#define sipName_FieldsStayAtSizeHint &sipStrings_QtGui[26915]
#define sipNameNr_QFont__StyleStrategy 26936
#define sipName_QFont__StyleStrategy &sipStrings_QtGui[26936]
#define sipNameNr_getExistingDirectory 26957
#define sipName_getExistingDirectory &sipStrings_QtGui[26957]
#define sipNameNr_QFileDialog__Options 26978
#define sipName_QFileDialog__Options &sipStrings_QtGui[26978]
#define sipNameNr_DontConfirmOverwrite 26999
#define sipName_DontConfirmOverwrite &sipStrings_QtGui[26999]
#define sipNameNr_acceptProposedAction 27020
#define sipName_acceptProposedAction &sipStrings_QtGui[27020]
#define sipNameNr_NoDockWidgetFeatures 27041
#define sipName_NoDockWidgetFeatures &sipStrings_QtGui[27041]
#define sipNameNr_ApplicationsLocation 27062
#define sipName_ApplicationsLocation &sipStrings_QtGui[27062]
#define sipNameNr_clearMaximumDateTime 27083
#define sipName_clearMaximumDateTime &sipStrings_QtGui[27083]
#define sipNameNr_clearMinimumDateTime 27104
#define sipName_clearMinimumDateTime &sipStrings_QtGui[27104]
#define sipNameNr_setCurrentModelIndex 27125
#define sipName_setCurrentModelIndex &sipStrings_QtGui[27125]
#define sipNameNr_InsertAlphabetically 27146
#define sipName_InsertAlphabetically &sipStrings_QtGui[27146]
#define sipNameNr_setDuplicatesEnabled 27167
#define sipName_setDuplicatesEnabled &sipStrings_QtGui[27167]
#define sipNameNr_setWeekdayTextFormat 27188
#define sipName_setWeekdayTextFormat &sipStrings_QtGui[27188]
#define sipNameNr_verticalHeaderFormat 27209
#define sipName_verticalHeaderFormat &sipStrings_QtGui[27209]
#define sipNameNr_VerticalHeaderFormat 3499
#define sipName_VerticalHeaderFormat &sipStrings_QtGui[3499]
#define sipNameNr_SingleLetterDayNames 27230
#define sipName_SingleLetterDayNames &sipStrings_QtGui[27230]
#define sipNameNr_setStartDragDistance 27251
#define sipName_setStartDragDistance &sipStrings_QtGui[27251]
#define sipNameNr_desktopSettingsAware 27272
#define sipName_desktopSettingsAware &sipStrings_QtGui[27272]
#define sipNameNr_changeOverrideCursor 27293
#define sipName_changeOverrideCursor &sipStrings_QtGui[27293]
#define sipNameNr_setIconVisibleInMenu 27314
#define sipName_setIconVisibleInMenu &sipStrings_QtGui[27314]
#define sipNameNr_QAction__ActionEvent 27335
#define sipName_QAction__ActionEvent &sipStrings_QtGui[27335]
#define sipNameNr_QTextObjectInterface 27356
#define sipName_QTextObjectInterface &sipStrings_QtGui[27356]
#define sipNameNr_positionInlineObject 27377
#define sipName_positionInlineObject &sipStrings_QtGui[27377]
#define sipNameNr_setVerticalScrollBar 27398
#define sipName_setVerticalScrollBar &sipStrings_QtGui[27398]
#define sipNameNr_mapSelectionToSource 27419
#define sipName_mapSelectionToSource &sipStrings_QtGui[27419]
#define sipNameNr_QAbstractPrintDialog 27440
#define sipName_QAbstractPrintDialog &sipStrings_QtGui[27440]
#define sipNameNr_horizontalScrollMode 27461
#define sipName_horizontalScrollMode &sipStrings_QtGui[27461]
#define sipNameNr_verticalStepsPerItem 27482
#define sipName_verticalStepsPerItem &sipStrings_QtGui[27482]
#define sipNameNr_openPersistentEditor 27503
#define sipName_openPersistentEditor &sipStrings_QtGui[27503]
#define sipNameNr_alternatingRowColors 27524
#define sipName_alternatingRowColors &sipStrings_QtGui[27524]
#define sipNameNr_setSelectionBehavior 27545
#define sipName_setSelectionBehavior &sipStrings_QtGui[27545]
#define sipNameNr_updateEditorGeometry 27566
#define sipName_updateEditorGeometry &sipStrings_QtGui[27566]
#define sipNameNr_rowsAboutToBeRemoved 27587
#define sipName_rowsAboutToBeRemoved &sipStrings_QtGui[27587]
#define sipNameNr_supportedDropActions 27608
#define sipName_supportedDropActions &sipStrings_QtGui[27608]
#define sipNameNr_27629 27629
#define sipName_27629 &sipStrings_QtGui[27629]
#define sipNameNr_27649 27649
#define sipName_27649 &sipStrings_QtGui[27649]
#define sipNameNr_27669 27669
#define sipName_27669 &sipStrings_QtGui[27669]
#define sipNameNr_customButtonClicked 27689
#define sipName_customButtonClicked &sipStrings_QtGui[27689]
#define sipNameNr_validateCurrentPage 27709
#define sipName_validateCurrentPage &sipStrings_QtGui[27709]
#define sipNameNr_graphicsProxyWidget 27729
#define sipName_graphicsProxyWidget &sipStrings_QtGui[27729]
#define sipNameNr_QWidget__RenderFlag 27749
#define sipName_QWidget__RenderFlag &sipStrings_QtGui[27749]
#define sipNameNr_overrideWindowFlags 27769
#define sipName_overrideWindowFlags &sipStrings_QtGui[27769]
#define sipNameNr_overrideWindowState 27789
#define sipName_overrideWindowState &sipStrings_QtGui[27789]
#define sipNameNr_insertTopLevelItems 27809
#define sipName_insertTopLevelItems &sipStrings_QtGui[27809]
#define sipNameNr_indexOfTopLevelItem 27829
#define sipName_indexOfTopLevelItem &sipStrings_QtGui[27829]
#define sipNameNr_allColumnsShowFocus 27849
#define sipName_allColumnsShowFocus &sipStrings_QtGui[27849]
#define sipNameNr_ToolButtonPopupMode 5688
#define sipName_ToolButtonPopupMode &sipStrings_QtGui[5688]
#define sipNameNr_firstCursorPosition 27869
#define sipName_firstCursorPosition &sipStrings_QtGui[27869]
#define sipNameNr_lineForTextPosition 27889
#define sipName_lineForTextPosition &sipStrings_QtGui[27889]
#define sipNameNr_preeditAreaPosition 27909
#define sipName_preeditAreaPosition &sipStrings_QtGui[27909]
#define sipNameNr_BorderStyle_DotDash 27929
#define sipName_BorderStyle_DotDash &sipStrings_QtGui[27929]
#define sipNameNr_SpellCheckUnderline 27949
#define sipName_SpellCheckUnderline &sipStrings_QtGui[27949]
#define sipNameNr_setTableCellRowSpan 27969
#define sipName_setTableCellRowSpan &sipStrings_QtGui[27969]
#define sipNameNr_tableCellColumnSpan 27989
#define sipName_tableCellColumnSpan &sipStrings_QtGui[27989]
#define sipNameNr_TableCellTopPadding 28009
#define sipName_TableCellTopPadding &sipStrings_QtGui[28009]
#define sipNameNr_TableHeaderRowCount 28029
#define sipName_TableHeaderRowCount &sipStrings_QtGui[28029]
#define sipNameNr_TableCellColumnSpan 18565
#define sipName_TableCellColumnSpan &sipStrings_QtGui[18565]
#define sipNameNr_textBackgroundColor 28049
#define sipName_textBackgroundColor &sipStrings_QtGui[28049]
#define sipNameNr_QTextDocumentWriter 28069
#define sipName_QTextDocumentWriter &sipStrings_QtGui[28069]
#define sipNameNr_setUseDesignMetrics 28089
#define sipName_setUseDesignMetrics &sipStrings_QtGui[28089]
#define sipNameNr_FindCaseSensitively 28109
#define sipName_FindCaseSensitively &sipStrings_QtGui[28109]
#define sipNameNr_Qt__HitTestAccuracy 28129
#define sipName_Qt__HitTestAccuracy &sipStrings_QtGui[28129]
#define sipNameNr_setVisualNavigation 28149
#define sipName_setVisualNavigation &sipStrings_QtGui[28149]
#define sipNameNr_hasComplexSelection 28169
#define sipName_hasComplexSelection &sipStrings_QtGui[28169]
#define sipNameNr_forwardHistoryCount 28189
#define sipName_forwardHistoryCount &sipStrings_QtGui[28189]
#define sipNameNr_isBackwardAvailable 28209
#define sipName_isBackwardAvailable &sipStrings_QtGui[28209]
#define sipNameNr_resizeRowToContents 28229
#define sipName_resizeRowToContents &sipStrings_QtGui[28229]
#define sipNameNr_rowViewportPosition 28249
#define sipName_rowViewportPosition &sipStrings_QtGui[28249]
#define sipNameNr_setHorizontalHeader 28269
#define sipName_setHorizontalHeader &sipStrings_QtGui[28269]
#define sipNameNr_QStyleOptionFrameV3 28289
#define sipName_QStyleOptionFrameV3 &sipStrings_QtGui[28289]
#define sipNameNr_QStyleOptionToolBar 28309
#define sipName_QStyleOptionToolBar &sipStrings_QtGui[28309]
#define sipNameNr_QStyleOptionSpinBox 28329
#define sipName_QStyleOptionSpinBox &sipStrings_QtGui[28329]
#define sipNameNr_QStyleOptionComplex 28349
#define sipName_QStyleOptionComplex &sipStrings_QtGui[28349]
#define sipNameNr_QStyleOptionToolBox 28369
#define sipName_QStyleOptionToolBox &sipStrings_QtGui[28369]
#define sipNameNr_decorationAlignment 28389
#define sipName_decorationAlignment &sipStrings_QtGui[28389]
#define sipNameNr_QStyleOptionFrameV2 28409
#define sipName_QStyleOptionFrameV2 &sipStrings_QtGui[28409]
#define sipNameNr_QStyledItemDelegate 28429
#define sipName_QStyledItemDelegate &sipStrings_QtGui[28429]
#define sipNameNr_generatedIconPixmap 28449
#define sipName_generatedIconPixmap &sipStrings_QtGui[28449]
#define sipNameNr_SP_MediaVolumeMuted 28469
#define sipName_SP_MediaVolumeMuted &sipStrings_QtGui[28469]
#define sipNameNr_SP_MediaSeekForward 28489
#define sipName_SP_MediaSeekForward &sipStrings_QtGui[28489]
#define sipNameNr_SP_MediaSkipForward 28509
#define sipName_SP_MediaSkipForward &sipStrings_QtGui[28509]
#define sipNameNr_SP_DialogSaveButton 28529
#define sipName_SP_DialogSaveButton &sipStrings_QtGui[28529]
#define sipNameNr_SP_DialogOpenButton 28549
#define sipName_SP_DialogOpenButton &sipStrings_QtGui[28549]
#define sipNameNr_SP_DialogHelpButton 28569
#define sipName_SP_DialogHelpButton &sipStrings_QtGui[28569]
#define sipNameNr_SH_TabBar_ElideMode 28589
#define sipName_SH_TabBar_ElideMode &sipStrings_QtGui[28589]
#define sipNameNr_SH_WindowFrame_Mask 28609
#define sipName_SH_WindowFrame_Mask &sipStrings_QtGui[28609]
#define sipNameNr_SH_TabBar_Alignment 28629
#define sipName_SH_TabBar_Alignment &sipStrings_QtGui[28629]
#define sipNameNr_SH_EtchDisabledText 28649
#define sipName_SH_EtchDisabledText &sipStrings_QtGui[28649]
#define sipNameNr_PM_LayoutLeftMargin 28669
#define sipName_PM_LayoutLeftMargin &sipStrings_QtGui[28669]
#define sipNameNr_PM_IconViewIconSize 28689
#define sipName_PM_IconViewIconSize &sipStrings_QtGui[28689]
#define sipNameNr_PM_ListViewIconSize 28709
#define sipName_PM_ListViewIconSize &sipStrings_QtGui[28709]
#define sipNameNr_PM_HeaderGripMargin 28729
#define sipName_PM_HeaderGripMargin &sipStrings_QtGui[28729]
#define sipNameNr_PM_TabBarBaseHeight 28749
#define sipName_PM_TabBarBaseHeight &sipStrings_QtGui[28749]
#define sipNameNr_PM_TabBarTabOverlap 28769
#define sipName_PM_TabBarTabOverlap &sipStrings_QtGui[28769]
#define sipNameNr_QStyle__PixelMetric 28789
#define sipName_QStyle__PixelMetric &sipStrings_QtGui[28789]
#define sipNameNr_QStyle__SubControls 28809
#define sipName_QStyle__SubControls &sipStrings_QtGui[28809]
#define sipNameNr_SC_GroupBoxContents 28829
#define sipName_SC_GroupBoxContents &sipStrings_QtGui[28829]
#define sipNameNr_SC_GroupBoxCheckBox 28849
#define sipName_SC_GroupBoxCheckBox &sipStrings_QtGui[28849]
#define sipNameNr_SC_Q3ListViewExpand 28869
#define sipName_SC_Q3ListViewExpand &sipStrings_QtGui[28869]
#define sipNameNr_SC_Q3ListViewBranch 28889
#define sipName_SC_Q3ListViewBranch &sipStrings_QtGui[28889]
#define sipNameNr_SC_SpinBoxEditField 28909
#define sipName_SC_SpinBoxEditField &sipStrings_QtGui[28909]
#define sipNameNr_SC_ScrollBarSubPage 28929
#define sipName_SC_ScrollBarSubPage &sipStrings_QtGui[28929]
#define sipNameNr_SC_ScrollBarAddPage 28949
#define sipName_SC_ScrollBarAddPage &sipStrings_QtGui[28949]
#define sipNameNr_SC_ScrollBarSubLine 28969
#define sipName_SC_ScrollBarSubLine &sipStrings_QtGui[28969]
#define sipNameNr_SC_ScrollBarAddLine 28989
#define sipName_SC_ScrollBarAddLine &sipStrings_QtGui[28989]
#define sipNameNr_SE_ItemViewItemText 29009
#define sipName_SE_ItemViewItemText &sipStrings_QtGui[29009]
#define sipNameNr_SE_SliderLayoutItem 29029
#define sipName_SE_SliderLayoutItem &sipStrings_QtGui[29029]
#define sipNameNr_SE_LineEditContents 29049
#define sipName_SE_LineEditContents &sipStrings_QtGui[29049]
#define sipNameNr_SE_TabWidgetTabPane 29069
#define sipName_SE_TabWidgetTabPane &sipStrings_QtGui[29069]
#define sipNameNr_SE_DialogButtonHelp 29089
#define sipName_SE_DialogButtonHelp &sipStrings_QtGui[29089]
#define sipNameNr_SE_ProgressBarLabel 29109
#define sipName_SE_ProgressBarLabel &sipStrings_QtGui[29109]
#define sipNameNr_SE_CheckBoxContents 29129
#define sipName_SE_CheckBoxContents &sipStrings_QtGui[29129]
#define sipNameNr_CE_ScrollBarSubPage 29149
#define sipName_CE_ScrollBarSubPage &sipStrings_QtGui[29149]
#define sipNameNr_CE_ScrollBarAddPage 29169
#define sipName_CE_ScrollBarAddPage &sipStrings_QtGui[29169]
#define sipNameNr_CE_ScrollBarSubLine 29189
#define sipName_CE_ScrollBarSubLine &sipStrings_QtGui[29189]
#define sipNameNr_CE_ScrollBarAddLine 29209
#define sipName_CE_ScrollBarAddLine &sipStrings_QtGui[29209]
#define sipNameNr_CE_MenuBarEmptyArea 29229
#define sipName_CE_MenuBarEmptyArea &sipStrings_QtGui[29229]
#define sipNameNr_CE_ProgressBarLabel 29249
#define sipName_CE_ProgressBarLabel &sipStrings_QtGui[29249]
#define sipNameNr_CE_RadioButtonLabel 29269
#define sipName_CE_RadioButtonLabel &sipStrings_QtGui[29269]
#define sipNameNr_PE_PanelItemViewRow 29289
#define sipName_PE_PanelItemViewRow &sipStrings_QtGui[29289]
#define sipNameNr_PE_IndicatorTabTear 29309
#define sipName_PE_IndicatorTabTear &sipStrings_QtGui[29309]
#define sipNameNr_PE_IndicatorArrowUp 29329
#define sipName_PE_IndicatorArrowUp &sipStrings_QtGui[29329]
#define sipNameNr_PE_PanelButtonBevel 29349
#define sipName_PE_PanelButtonBevel &sipStrings_QtGui[29349]
#define sipNameNr_PE_FrameButtonBevel 29369
#define sipName_PE_FrameButtonBevel &sipStrings_QtGui[29369]
#define sipNameNr_State_FocusAtBorder 29389
#define sipName_State_FocusAtBorder &sipStrings_QtGui[29389]
#define sipNameNr_childrenCollapsible 29409
#define sipName_childrenCollapsible &sipStrings_QtGui[29409]
#define sipNameNr_sortCaseSensitivity 29429
#define sipName_sortCaseSensitivity &sipStrings_QtGui[29429]
#define sipNameNr_filterAcceptsColumn 29449
#define sipName_filterAcceptsColumn &sipStrings_QtGui[29449]
#define sipNameNr_setHorizontalPolicy 29469
#define sipName_setHorizontalPolicy &sipStrings_QtGui[29469]
#define sipNameNr_QSizePolicy__Policy 29489
#define sipName_QSizePolicy__Policy &sipStrings_QtGui[29489]
#define sipNameNr_ensureWidgetVisible 29509
#define sipName_ensureWidgetVisible &sipStrings_QtGui[29509]
#define sipNameNr_QRegion__RegionType 29529
#define sipName_QRegion__RegionType &sipStrings_QtGui[29529]
#define sipNameNr_setAllPagesViewMode 29549
#define sipName_setAllPagesViewMode &sipStrings_QtGui[29549]
#define sipNameNr_QPrintPreviewWidget 29569
#define sipName_QPrintPreviewWidget &sipStrings_QtGui[29569]
#define sipNameNr_QPrintPreviewDialog 29589
#define sipName_QPrintPreviewDialog &sipStrings_QtGui[29589]
#define sipNameNr_supportedPaperSizes 29609
#define sipName_supportedPaperSizes &sipStrings_QtGui[29609]
#define sipNameNr_PPK_CustomPaperSize 29629
#define sipName_PPK_CustomPaperSize &sipStrings_QtGui[29629]
#define sipNameNr_PPK_WindowsPageSize 29649
#define sipName_PPK_WindowsPageSize &sipStrings_QtGui[29649]
#define sipNameNr_PPK_SelectionOption 29669
#define sipName_PPK_SelectionOption &sipStrings_QtGui[29669]
#define sipNameNr_doubleSidedPrinting 29689
#define sipName_doubleSidedPrinting &sipStrings_QtGui[29689]
#define sipNameNr_QPrinter__ColorMode 29709
#define sipName_QPrinter__ColorMode &sipStrings_QtGui[29709]
#define sipNameNr_QPrinter__PageOrder 29729
#define sipName_QPrinter__PageOrder &sipStrings_QtGui[29729]
#define sipNameNr_modificationChanged 29749
#define sipName_modificationChanged &sipStrings_QtGui[29749]
#define sipNameNr_ensureCursorVisible 29769
#define sipName_ensureCursorVisible &sipStrings_QtGui[29769]
#define sipNameNr_QPalette__ColorRole 29789
#define sipName_QPalette__ColorRole &sipStrings_QtGui[29789]
#define sipNameNr_QPainterPathStroker 29809
#define sipName_QPainterPathStroker &sipStrings_QtGui[29809]
#define sipNameNr_brushNeedsResolving 29829
#define sipName_brushNeedsResolving &sipStrings_QtGui[29829]
#define sipNameNr_DirtyBackgroundMode 29849
#define sipName_DirtyBackgroundMode &sipStrings_QtGui[29849]
#define sipNameNr_PaintEngineFeatures 5452
#define sipName_PaintEngineFeatures &sipStrings_QtGui[5452]
#define sipNameNr_ConicalGradientFill 29869
#define sipName_ConicalGradientFill &sipStrings_QtGui[29869]
#define sipNameNr_CompositionMode_Xor 29889
#define sipName_CompositionMode_Xor &sipStrings_QtGui[29889]
#define sipNameNr_setKeyboardPageStep 29909
#define sipName_setKeyboardPageStep &sipStrings_QtGui[29909]
#define sipNameNr_tabifiedDockWidgets 29929
#define sipName_tabifiedDockWidgets &sipStrings_QtGui[29929]
#define sipNameNr_setPositionForIndex 29949
#define sipName_setPositionForIndex &sipStrings_QtGui[29949]
#define sipNameNr_setUniformItemSizes 29969
#define sipName_setUniformItemSizes &sipStrings_QtGui[29969]
#define sipNameNr_QListView__ViewMode 29989
#define sipName_QListView__ViewMode &sipStrings_QtGui[29989]
#define sipNameNr_QListView__Movement 30009
#define sipName_QListView__Movement &sipStrings_QtGui[30009]
#define sipNameNr_QLineEdit__EchoMode 30029
#define sipName_QLineEdit__EchoMode &sipStrings_QtGui[30029]
#define sipNameNr_totalHeightForWidth 30049
#define sipName_totalHeightForWidth &sipStrings_QtGui[30049]
#define sipNameNr_InsertLineSeparator 30069
#define sipName_InsertLineSeparator &sipStrings_QtGui[30069]
#define sipNameNr_SelectEndOfDocument 30089
#define sipName_SelectEndOfDocument &sipStrings_QtGui[30089]
#define sipNameNr_MoveToEndOfDocument 30109
#define sipName_MoveToEndOfDocument &sipStrings_QtGui[30109]
#define sipNameNr_doubleValueSelected 30129
#define sipName_doubleValueSelected &sipStrings_QtGui[30129]
#define sipNameNr_setCancelButtonText 30149
#define sipName_setCancelButtonText &sipStrings_QtGui[30149]
#define sipNameNr_setComboBoxEditable 30169
#define sipName_setComboBoxEditable &sipStrings_QtGui[30169]
#define sipNameNr_createMaskFromColor 30189
#define sipName_createMaskFromColor &sipStrings_QtGui[30189]
#define sipNameNr_createHeuristicMask 30209
#define sipName_createHeuristicMask &sipStrings_QtGui[30209]
#define sipNameNr_QItemSelectionModel 30229
#define sipName_QItemSelectionModel &sipStrings_QtGui[30229]
#define sipNameNr_QItemSelectionRange 30249
#define sipName_QItemSelectionRange &sipStrings_QtGui[30249]
#define sipNameNr_setDefaultAlignment 30269
#define sipName_setDefaultAlignment &sipStrings_QtGui[30269]
#define sipNameNr_sectionCountChanged 30289
#define sipName_sectionCountChanged &sipStrings_QtGui[30289]
#define sipNameNr_stretchSectionCount 30309
#define sipName_stretchSectionCount &sipStrings_QtGui[30309]
#define sipNameNr_setOptimizationFlag 30329
#define sipName_setOptimizationFlag &sipStrings_QtGui[30329]
#define sipNameNr_SmartViewportUpdate 30349
#define sipName_SmartViewportUpdate &sipStrings_QtGui[30349]
#define sipNameNr_buttonDownScreenPos 30369
#define sipName_buttonDownScreenPos &sipStrings_QtGui[30369]
#define sipNameNr_QGraphicsSceneEvent 30389
#define sipName_QGraphicsSceneEvent &sipStrings_QtGui[30389]
#define sipNameNr_ungrabKeyboardEvent 30409
#define sipName_ungrabKeyboardEvent &sipStrings_QtGui[30409]
#define sipNameNr_windowFrameGeometry 30429
#define sipName_windowFrameGeometry &sipStrings_QtGui[30429]
#define sipNameNr_setSortCacheEnabled 30449
#define sipName_setSortCacheEnabled &sipStrings_QtGui[30449]
#define sipNameNr_setParentLayoutItem 30469
#define sipName_setParentLayoutItem &sipStrings_QtGui[30469]
#define sipNameNr_QGraphicsLayoutItem 30489
#define sipName_QGraphicsLayoutItem &sipStrings_QtGui[30489]
#define sipNameNr_beforeAnimationStep 30509
#define sipName_beforeAnimationStep &sipStrings_QtGui[30509]
#define sipNameNr_setDefaultTextColor 30529
#define sipName_setDefaultTextColor &sipStrings_QtGui[30529]
#define sipNameNr_QGraphicsPixmapItem 30549
#define sipName_QGraphicsPixmapItem &sipStrings_QtGui[30549]
#define sipNameNr_ItemSceneHasChanged 30569
#define sipName_ItemSceneHasChanged &sipStrings_QtGui[30569]
#define sipNameNr_ItemTransformChange 30589
#define sipName_ItemTransformChange &sipStrings_QtGui[30589]
#define sipNameNr_ItemCoordinateCache 30609
#define sipName_ItemCoordinateCache &sipStrings_QtGui[30609]
#define sipNameNr_setColumnFixedWidth 30629
#define sipName_setColumnFixedWidth &sipStrings_QtGui[30629]
#define sipNameNr_setRowMaximumHeight 30649
#define sipName_setRowMaximumHeight &sipStrings_QtGui[30649]
#define sipNameNr_setRowMinimumHeight 30669
#define sipName_setRowMinimumHeight &sipStrings_QtGui[30669]
#define sipNameNr_columnStretchFactor 30689
#define sipName_columnStretchFactor &sipStrings_QtGui[30689]
#define sipNameNr_setRowStretchFactor 30709
#define sipName_setRowStretchFactor &sipStrings_QtGui[30709]
#define sipNameNr_QGraphicsGridLayout 30729
#define sipName_QGraphicsGridLayout &sipStrings_QtGui[30729]
#define sipNameNr_ExpandingFieldsGrow 30749
#define sipName_ExpandingFieldsGrow &sipStrings_QtGui[30749]
#define sipNameNr_writingSystemSample 30769
#define sipName_writingSystemSample &sipStrings_QtGui[30769]
#define sipNameNr_insertSubstitutions 30789
#define sipName_insertSubstitutions &sipStrings_QtGui[30789]
#define sipNameNr_setConfirmOverwrite 30809
#define sipName_setConfirmOverwrite &sipStrings_QtGui[30809]
#define sipNameNr_DontResolveSymlinks 30829
#define sipName_DontResolveSymlinks &sipStrings_QtGui[30829]
#define sipNameNr_QFileDialog__Option 30849
#define sipName_QFileDialog__Option &sipStrings_QtGui[30849]
#define sipNameNr_dockLocationChanged 30869
#define sipName_dockLocationChanged &sipStrings_QtGui[30869]
#define sipNameNr_allowedAreasChanged 30889
#define sipName_allowedAreasChanged &sipStrings_QtGui[30889]
#define sipNameNr_DockWidgetFloatable 30909
#define sipName_DockWidgetFloatable &sipStrings_QtGui[30909]
#define sipNameNr_QDialog__DialogCode 30929
#define sipName_QDialog__DialogCode &sipStrings_QtGui[30929]
#define sipNameNr_currentSectionIndex 30949
#define sipName_currentSectionIndex &sipStrings_QtGui[30949]
#define sipNameNr_setCompletionPrefix 30969
#define sipName_setCompletionPrefix &sipStrings_QtGui[30969]
#define sipNameNr_setCompletionColumn 30989
#define sipName_setCompletionColumn &sipStrings_QtGui[30989]
#define sipNameNr_currentIndexChanged 31009
#define sipName_currentIndexChanged &sipStrings_QtGui[31009]
#define sipNameNr_setSizeAdjustPolicy 31029
#define sipName_setSizeAdjustPolicy &sipStrings_QtGui[31029]
#define sipNameNr_InsertBeforeCurrent 31049
#define sipName_InsertBeforeCurrent &sipStrings_QtGui[31049]
#define sipNameNr_currentColorChanged 31069
#define sipName_currentColorChanged &sipStrings_QtGui[31069]
#define sipNameNr_DontUseNativeDialog 31089
#define sipName_DontUseNativeDialog &sipStrings_QtGui[31089]
#define sipNameNr_updatePreviewWidget 31109
#define sipName_updatePreviewWidget &sipStrings_QtGui[31109]
#define sipNameNr_dateEditAcceptDelay 31129
#define sipName_dateEditAcceptDelay &sipStrings_QtGui[31129]
#define sipNameNr_setHeaderTextFormat 31149
#define sipName_setHeaderTextFormat &sipStrings_QtGui[31149]
#define sipNameNr_StretchToDeviceMode 31169
#define sipName_StretchToDeviceMode &sipStrings_QtGui[31169]
#define sipNameNr_expandingDirections 31189
#define sipName_expandingDirections &sipStrings_QtGui[31189]
#define sipNameNr_keyboardInputLocale 31209
#define sipName_keyboardInputLocale &sipStrings_QtGui[31209]
#define sipNameNr_fontDatabaseChanged 31229
#define sipName_fontDatabaseChanged &sipStrings_QtGui[31229]
#define sipNameNr_setWheelScrollLines 31249
#define sipName_setWheelScrollLines &sipStrings_QtGui[31249]
#define sipNameNr_doubleClickInterval 31269
#define sipName_doubleClickInterval &sipStrings_QtGui[31269]
#define sipNameNr_isIconVisibleInMenu 31289
#define sipName_isIconVisibleInMenu &sipStrings_QtGui[31289]
#define sipNameNr_SliderSingleStepSub 31309
#define sipName_SliderSingleStepSub &sipStrings_QtGui[31309]
#define sipNameNr_SliderSingleStepAdd 31329
#define sipName_SliderSingleStepAdd &sipStrings_QtGui[31329]
#define sipNameNr_setInvertedControls 31349
#define sipName_setInvertedControls &sipStrings_QtGui[31349]
#define sipNameNr_documentSizeChanged 31369
#define sipName_documentSizeChanged &sipStrings_QtGui[31369]
#define sipNameNr_setKeyboardTracking 31389
#define sipName_setKeyboardTracking &sipStrings_QtGui[31389]
#define sipNameNr_setSpecialValueText 31409
#define sipName_setSpecialValueText &sipStrings_QtGui[31409]
#define sipNameNr_maximumViewportSize 31429
#define sipName_maximumViewportSize &sipStrings_QtGui[31429]
#define sipNameNr_horizontalScrollBar 31449
#define sipName_horizontalScrollBar &sipStrings_QtGui[31449]
#define sipNameNr_QAbstractProxyModel 31469
#define sipName_QAbstractProxyModel &sipStrings_QtGui[31469]
#define sipNameNr_setAutoScrollMargin 31489
#define sipName_setAutoScrollMargin &sipStrings_QtGui[31489]
#define sipNameNr_setTabKeyNavigation 31509
#define sipName_setTabKeyNavigation &sipStrings_QtGui[31509]
#define sipNameNr_ContiguousSelection 31529
#define sipName_ContiguousSelection &sipStrings_QtGui[31529]
#define sipNameNr_QAbstractScrollArea 31549
#define sipName_QAbstractScrollArea &sipStrings_QtGui[31549]
#define sipNameNr_persistentIndexList 31569
#define sipName_persistentIndexList &sipStrings_QtGui[31569]
#define sipNameNr_31589 31589
#define sipName_31589 &sipStrings_QtGui[31589]
#define sipNameNr_31608 31608
#define sipName_31608 &sipStrings_QtGui[31608]
#define sipNameNr_appDefaultColormap 31627
#define sipName_appDefaultColormap &sipStrings_QtGui[31627]
#define sipNameNr_QX11EmbedContainer 31646
#define sipName_QX11EmbedContainer &sipStrings_QtGui[31646]
#define sipNameNr_activateNextWindow 31665
#define sipName_activateNextWindow &sipStrings_QtGui[31665]
#define sipNameNr_setDefaultProperty 31684
#define sipName_setDefaultProperty &sipStrings_QtGui[31684]
#define sipNameNr_CancelButtonOnLeft 31703
#define sipName_CancelButtonOnLeft &sipStrings_QtGui[31703]
#define sipNameNr_nativeParentWidget 31722
#define sipName_nativeParentWidget &sipStrings_QtGui[31722]
#define sipNameNr_autoFillBackground 31741
#define sipName_autoFillBackground &sipStrings_QtGui[31741]
#define sipNameNr_focusPreviousChild 31760
#define sipName_focusPreviousChild &sipStrings_QtGui[31760]
#define sipNameNr_leaveWhatsThisMode 31779
#define sipName_leaveWhatsThisMode &sipStrings_QtGui[31779]
#define sipNameNr_enterWhatsThisMode 31798
#define sipName_enterWhatsThisMode &sipStrings_QtGui[31798]
#define sipNameNr_activeStackChanged 31817
#define sipName_activeStackChanged &sipStrings_QtGui[31817]
#define sipNameNr_insertTopLevelItem 31836
#define sipName_insertTopLevelItem &sipStrings_QtGui[31836]
#define sipNameNr_setAutoExpandDelay 31855
#define sipName_setAutoExpandDelay &sipStrings_QtGui[31855]
#define sipNameNr_setItemsExpandable 31874
#define sipName_setItemsExpandable &sipStrings_QtGui[31874]
#define sipNameNr_setRootIsDecorated 31893
#define sipName_setRootIsDecorated &sipStrings_QtGui[31893]
#define sipNameNr_TransformationType 7245
#define sipName_TransformationType &sipStrings_QtGui[7245]
#define sipNameNr_orientationChanged 31912
#define sipName_orientationChanged &sipStrings_QtGui[31912]
#define sipNameNr_QTextOption__Flags 31931
#define sipName_QTextOption__Flags &sipStrings_QtGui[31931]
#define sipNameNr_QTextBlockUserData 31950
#define sipName_QTextBlockUserData &sipStrings_QtGui[31950]
#define sipNameNr_lastCursorPosition 31969
#define sipName_lastCursorPosition &sipStrings_QtGui[31969]
#define sipNameNr_blockFormatChanged 31988
#define sipName_blockFormatChanged &sipStrings_QtGui[31988]
#define sipNameNr_nextCursorPosition 32007
#define sipName_nextCursorPosition &sipStrings_QtGui[32007]
#define sipNameNr_BorderStyle_Outset 32026
#define sipName_BorderStyle_Outset &sipStrings_QtGui[32026]
#define sipNameNr_BorderStyle_Groove 32045
#define sipName_BorderStyle_Groove &sipStrings_QtGui[32045]
#define sipNameNr_BorderStyle_Double 32064
#define sipName_BorderStyle_Double &sipStrings_QtGui[32064]
#define sipNameNr_BorderStyle_Dashed 32083
#define sipName_BorderStyle_Dashed &sipStrings_QtGui[32083]
#define sipNameNr_BorderStyle_Dotted 32102
#define sipName_BorderStyle_Dotted &sipStrings_QtGui[32102]
#define sipNameNr_ListStyleUndefined 32121
#define sipName_ListStyleUndefined &sipStrings_QtGui[32121]
#define sipNameNr_setPageBreakPolicy 32140
#define sipName_setPageBreakPolicy &sipStrings_QtGui[32140]
#define sipNameNr_setFontWordSpacing 32159
#define sipName_setFontWordSpacing &sipStrings_QtGui[32159]
#define sipNameNr_fontCapitalization 32178
#define sipName_fontCapitalization &sipStrings_QtGui[32178]
#define sipNameNr_FontCapitalization 20876
#define sipName_FontCapitalization &sipStrings_QtGui[20876]
#define sipNameNr_BackgroundImageUrl 32197
#define sipName_BackgroundImageUrl &sipStrings_QtGui[32197]
#define sipNameNr_FullWidthSelection 7555
#define sipName_FullWidthSelection &sipStrings_QtGui[7555]
#define sipNameNr_TextUnderlineStyle 32216
#define sipName_TextUnderlineStyle &sipStrings_QtGui[32216]
#define sipNameNr_TextUnderlineColor 32235
#define sipName_TextUnderlineColor &sipStrings_QtGui[32235]
#define sipNameNr_FontSizeAdjustment 32254
#define sipName_FontSizeAdjustment &sipStrings_QtGui[32254]
#define sipNameNr_AutoFormattingFlag 8172
#define sipName_AutoFormattingFlag &sipStrings_QtGui[8172]
#define sipNameNr_StyleSheetResource 32273
#define sipName_StyleSheetResource &sipStrings_QtGui[32273]
#define sipNameNr_setMetaInformation 32292
#define sipName_setMetaInformation &sipStrings_QtGui[32292]
#define sipNameNr_Qt__WhiteSpaceMode 32311
#define sipName_Qt__WhiteSpaceMode &sipStrings_QtGui[32311]
#define sipNameNr_setBlockCharFormat 32330
#define sipName_setBlockCharFormat &sipStrings_QtGui[32330]
#define sipNameNr_selectedTableCells 32349
#define sipName_selectedTableCells &sipStrings_QtGui[32349]
#define sipNameNr_removeSelectedText 32368
#define sipName_removeSelectedText &sipStrings_QtGui[32368]
#define sipNameNr_deletePreviousChar 32387
#define sipName_deletePreviousChar &sipStrings_QtGui[32387]
#define sipNameNr_isForwardAvailable 32406
#define sipName_isForwardAvailable &sipStrings_QtGui[32406]
#define sipNameNr_currentCellChanged 32425
#define sipName_currentCellChanged &sipStrings_QtGui[32425]
#define sipNameNr_columnCountChanged 32444
#define sipName_columnCountChanged &sipStrings_QtGui[32444]
#define sipNameNr_previousBlockState 32463
#define sipName_previousBlockState &sipStrings_QtGui[32463]
#define sipNameNr_QSyntaxHighlighter 32482
#define sipName_QSyntaxHighlighter &sipStrings_QtGui[32482]
#define sipNameNr_positionWithinLine 32501
#define sipName_positionWithinLine &sipStrings_QtGui[32501]
#define sipNameNr_ToolButtonFeatures 744
#define sipName_ToolButtonFeatures &sipStrings_QtGui[744]
#define sipNameNr_QStyleOptionSlider 32520
#define sipName_QStyleOptionSlider &sipStrings_QtGui[32520]
#define sipNameNr_decorationPosition 32539
#define sipName_decorationPosition &sipStrings_QtGui[32539]
#define sipNameNr_QStyleOptionButton 32558
#define sipName_QStyleOptionButton &sipStrings_QtGui[32558]
#define sipNameNr_PreviousIsSelected 32577
#define sipName_PreviousIsSelected &sipStrings_QtGui[32577]
#define sipNameNr_QStyleOptionHeader 32596
#define sipName_QStyleOptionHeader &sipStrings_QtGui[32596]
#define sipNameNr_StyleOptionVersion 126
#define sipName_StyleOptionVersion &sipStrings_QtGui[126]
#define sipNameNr_SP_DialogYesButton 32615
#define sipName_SP_DialogYesButton &sipStrings_QtGui[32615]
#define sipNameNr_SP_FileDialogStart 32634
#define sipName_SP_FileDialogStart &sipStrings_QtGui[32634]
#define sipNameNr_SH_ToolBar_Movable 32653
#define sipName_SH_ToolBar_Movable &sipStrings_QtGui[32653]
#define sipNameNr_SH_RubberBand_Mask 32672
#define sipName_SH_RubberBand_Mask &sipStrings_QtGui[32672]
#define sipNameNr_SH_FocusFrame_Mask 32691
#define sipName_SH_FocusFrame_Mask &sipStrings_QtGui[32691]
#define sipNameNr_SH_Menu_Scrollable 32710
#define sipName_SH_Menu_Scrollable &sipStrings_QtGui[32710]
#define sipNameNr_PM_TextCursorWidth 32729
#define sipName_PM_TextCursorWidth &sipStrings_QtGui[32729]
#define sipNameNr_PM_LayoutTopMargin 32748
#define sipName_PM_LayoutTopMargin &sipStrings_QtGui[32748]
#define sipNameNr_PM_ToolBarIconSize 32767
#define sipName_PM_ToolBarIconSize &sipStrings_QtGui[32767]
#define sipNameNr_PM_IndicatorHeight 32786
#define sipName_PM_IndicatorHeight &sipStrings_QtGui[32786]
#define sipNameNr_PM_TabBarTabVSpace 32805
#define sipName_PM_TabBarTabVSpace &sipStrings_QtGui[32805]
#define sipNameNr_PM_TabBarTabHSpace 32824
#define sipName_PM_TabBarTabHSpace &sipStrings_QtGui[32824]
#define sipNameNr_PM_SliderThickness 32843
#define sipName_PM_SliderThickness &sipStrings_QtGui[32843]
#define sipNameNr_PM_ScrollBarExtent 32862
#define sipName_PM_ScrollBarExtent &sipStrings_QtGui[32862]
#define sipNameNr_drawComplexControl 32881
#define sipName_drawComplexControl &sipStrings_QtGui[32881]
#define sipNameNr_SC_MdiNormalButton 32900
#define sipName_SC_MdiNormalButton &sipStrings_QtGui[32900]
#define sipNameNr_SC_TitleBarSysMenu 32919
#define sipName_SC_TitleBarSysMenu &sipStrings_QtGui[32919]
#define sipNameNr_SC_SliderTickmarks 32938
#define sipName_SC_SliderTickmarks &sipStrings_QtGui[32938]
#define sipNameNr_SC_ScrollBarGroove 32957
#define sipName_SC_ScrollBarGroove &sipStrings_QtGui[32957]
#define sipNameNr_SC_ScrollBarSlider 32976
#define sipName_SC_ScrollBarSlider &sipStrings_QtGui[32976]
#define sipNameNr_QStyle__SubControl 32995
#define sipName_QStyle__SubControl &sipStrings_QtGui[32995]
#define sipNameNr_SE_FrameLayoutItem 33014
#define sipName_SE_FrameLayoutItem &sipStrings_QtGui[33014]
#define sipNameNr_SE_LabelLayoutItem 33033
#define sipName_SE_LabelLayoutItem &sipStrings_QtGui[33033]
#define sipNameNr_SE_TabWidgetTabBar 33052
#define sipName_SE_TabWidgetTabBar &sipStrings_QtGui[33052]
#define sipNameNr_SE_DialogButtonAll 33071
#define sipName_SE_DialogButtonAll &sipStrings_QtGui[33071]
#define sipNameNr_SE_SliderFocusRect 33090
#define sipName_SE_SliderFocusRect &sipStrings_QtGui[33090]
#define sipNameNr_QStyle__SubElement 33109
#define sipName_QStyle__SubElement &sipStrings_QtGui[33109]
#define sipNameNr_CE_HeaderEmptyArea 33128
#define sipName_CE_HeaderEmptyArea &sipStrings_QtGui[33128]
#define sipNameNr_CE_ToolBoxTabLabel 33147
#define sipName_CE_ToolBoxTabLabel &sipStrings_QtGui[33147]
#define sipNameNr_CE_ToolBoxTabShape 33166
#define sipName_CE_ToolBoxTabShape &sipStrings_QtGui[33166]
#define sipNameNr_CE_ScrollBarSlider 33185
#define sipName_CE_ScrollBarSlider &sipStrings_QtGui[33185]
#define sipNameNr_CE_DockWidgetTitle 33204
#define sipName_CE_DockWidgetTitle &sipStrings_QtGui[33204]
#define sipNameNr_CE_ToolButtonLabel 33223
#define sipName_CE_ToolButtonLabel &sipStrings_QtGui[33223]
#define sipNameNr_CE_PushButtonLabel 33242
#define sipName_CE_PushButtonLabel &sipStrings_QtGui[33242]
#define sipNameNr_CE_PushButtonBevel 33261
#define sipName_CE_PushButtonBevel &sipStrings_QtGui[33261]
#define sipNameNr_PE_IndicatorSpinUp 33280
#define sipName_PE_IndicatorSpinUp &sipStrings_QtGui[33280]
#define sipNameNr_PE_IndicatorBranch 33299
#define sipName_PE_IndicatorBranch &sipStrings_QtGui[33299]
#define sipNameNr_PE_PanelButtonTool 33318
#define sipName_PE_PanelButtonTool &sipStrings_QtGui[33318]
#define sipNameNr_PE_FrameTabBarBase 33337
#define sipName_PE_FrameTabBarBase &sipStrings_QtGui[33337]
#define sipNameNr_PE_FrameButtonTool 33356
#define sipName_PE_FrameButtonTool &sipStrings_QtGui[33356]
#define sipNameNr_PE_FrameDockWidget 33375
#define sipName_PE_FrameDockWidget &sipStrings_QtGui[33375]
#define sipNameNr_addPermanentWidget 33394
#define sipName_addPermanentWidget &sipStrings_QtGui[33394]
#define sipNameNr_verticalHeaderItem 33413
#define sipName_verticalHeaderItem &sipStrings_QtGui[33413]
#define sipNameNr_QStandardItemModel 33432
#define sipName_QStandardItemModel &sipStrings_QtGui[33432]
#define sipNameNr_setSortLocaleAware 33451
#define sipName_setSortLocaleAware &sipStrings_QtGui[33451]
#define sipNameNr_setFilterKeyColumn 33470
#define sipName_setFilterKeyColumn &sipStrings_QtGui[33470]
#define sipNameNr_setVerticalStretch 33489
#define sipName_setVerticalStretch &sipStrings_QtGui[33489]
#define sipNameNr_setManagerProperty 33508
#define sipName_setManagerProperty &sipStrings_QtGui[33508]
#define sipNameNr_RestartImmediately 33527
#define sipName_RestartImmediately &sipStrings_QtGui[33527]
#define sipNameNr_setWidgetResizable 33546
#define sipName_setWidgetResizable &sipStrings_QtGui[33546]
#define sipNameNr_QRubberBand__Shape 33565
#define sipName_QRubberBand__Shape &sipStrings_QtGui[33565]
#define sipNameNr_setMinimumDuration 33584
#define sipName_setMinimumDuration &sipStrings_QtGui[33584]
#define sipNameNr_PPK_PrinterProgram 33603
#define sipName_PPK_PrinterProgram &sipStrings_QtGui[33603]
#define sipNameNr_PPK_OutputFileName 33622
#define sipName_PPK_OutputFileName &sipStrings_QtGui[33622]
#define sipNameNr_PPK_NumberOfCopies 33641
#define sipName_PPK_NumberOfCopies &sipStrings_QtGui[33641]
#define sipNameNr_QPrinter__PageSize 33660
#define sipName_QPrinter__PageSize &sipStrings_QtGui[33660]
#define sipNameNr_insertFromMimeData 33679
#define sipName_insertFromMimeData &sipStrings_QtGui[33679]
#define sipNameNr_setExtraSelections 33698
#define sipName_setExtraSelections &sipStrings_QtGui[33698]
#define sipNameNr_setUndoRedoEnabled 33717
#define sipName_setUndoRedoEnabled &sipStrings_QtGui[33717]
#define sipNameNr_QPixmap__ShareMode 33736
#define sipName_QPixmap__ShareMode &sipStrings_QtGui[33736]
#define sipNameNr_subtractedInverted 33755
#define sipName_subtractedInverted &sipStrings_QtGui[33755]
#define sipNameNr_CurveToDataElement 33774
#define sipName_CurveToDataElement &sipStrings_QtGui[33774]
#define sipNameNr_QPaintEngine__Type 33793
#define sipName_QPaintEngine__Type &sipStrings_QtGui[33793]
#define sipNameNr_RadialGradientFill 33812
#define sipName_RadialGradientFill &sipStrings_QtGui[33812]
#define sipNameNr_LinearGradientFill 33831
#define sipName_LinearGradientFill &sipStrings_QtGui[33831]
#define sipNameNr_PrimitiveTransform 33850
#define sipName_PrimitiveTransform &sipStrings_QtGui[33850]
#define sipNameNr_PaintEngineFeature 5986
#define sipName_PaintEngineFeature &sipStrings_QtGui[5986]
#define sipNameNr_worldMatrixEnabled 33869
#define sipName_worldMatrixEnabled &sipStrings_QtGui[33869]
#define sipNameNr_setCompositionMode 33888
#define sipName_setCompositionMode &sipStrings_QtGui[33888]
#define sipNameNr_RasterOp_NotSource 33907
#define sipName_RasterOp_NotSource &sipStrings_QtGui[33907]
#define sipNameNr_currentFrameNumber 33926
#define sipName_currentFrameNumber &sipStrings_QtGui[33926]
#define sipNameNr_QMovie__MovieState 33945
#define sipName_QMovie__MovieState &sipStrings_QtGui[33945]
#define sipNameNr_setInformativeText 33964
#define sipName_setInformativeText &sipStrings_QtGui[33964]
#define sipNameNr_windowStateChanged 33983
#define sipName_windowStateChanged &sipStrings_QtGui[33983]
#define sipNameNr_keyboardSingleStep 34002
#define sipName_keyboardSingleStep &sipStrings_QtGui[34002]
#define sipNameNr_setActivationOrder 34021
#define sipName_setActivationOrder &sipStrings_QtGui[34021]
#define sipNameNr_closeAllSubWindows 34040
#define sipName_closeAllSubWindows &sipStrings_QtGui[34040]
#define sipNameNr_setActiveSubWindow 34059
#define sipName_setActiveSubWindow &sipStrings_QtGui[34059]
#define sipNameNr_subWindowActivated 34078
#define sipName_subWindowActivated &sipStrings_QtGui[34078]
#define sipNameNr_QMdiArea__ViewMode 34097
#define sipName_QMdiArea__ViewMode &sipStrings_QtGui[34097]
#define sipNameNr_removeToolBarBreak 34116
#define sipName_removeToolBarBreak &sipStrings_QtGui[34116]
#define sipNameNr_insertToolBarBreak 34135
#define sipName_insertToolBarBreak &sipStrings_QtGui[34135]
#define sipNameNr_setToolButtonStyle 34154
#define sipName_setToolButtonStyle &sipStrings_QtGui[34154]
#define sipNameNr_currentTextChanged 34173
#define sipName_currentTextChanged &sipStrings_QtGui[34173]
#define sipNameNr_currentItemChanged 34192
#define sipName_currentItemChanged &sipStrings_QtGui[34192]
#define sipNameNr_clearPropertyFlags 34211
#define sipName_clearPropertyFlags &sipStrings_QtGui[34211]
#define sipNameNr_cursorWordBackward 34230
#define sipName_cursorWordBackward &sipStrings_QtGui[34230]
#define sipNameNr_PasswordEchoOnEdit 34249
#define sipName_PasswordEchoOnEdit &sipStrings_QtGui[34249]
#define sipNameNr_SelectStartOfBlock 34268
#define sipName_SelectStartOfBlock &sipStrings_QtGui[34268]
#define sipNameNr_SelectPreviousPage 34287
#define sipName_SelectPreviousPage &sipStrings_QtGui[34287]
#define sipNameNr_SelectPreviousLine 34306
#define sipName_SelectPreviousLine &sipStrings_QtGui[34306]
#define sipNameNr_SelectPreviousWord 34325
#define sipName_SelectPreviousWord &sipStrings_QtGui[34325]
#define sipNameNr_SelectPreviousChar 34344
#define sipName_SelectPreviousChar &sipStrings_QtGui[34344]
#define sipNameNr_MoveToStartOfBlock 34363
#define sipName_MoveToStartOfBlock &sipStrings_QtGui[34363]
#define sipNameNr_MoveToPreviousPage 34382
#define sipName_MoveToPreviousPage &sipStrings_QtGui[34382]
#define sipNameNr_MoveToPreviousLine 34401
#define sipName_MoveToPreviousLine &sipStrings_QtGui[34401]
#define sipNameNr_MoveToPreviousWord 34420
#define sipName_MoveToPreviousWord &sipStrings_QtGui[34420]
#define sipNameNr_MoveToPreviousChar 34439
#define sipName_MoveToPreviousChar &sipStrings_QtGui[34439]
#define sipNameNr_doubleValueChanged 34458
#define sipName_doubleValueChanged &sipStrings_QtGui[34458]
#define sipNameNr_isComboBoxEditable 34477
#define sipName_isComboBoxEditable &sipStrings_QtGui[34477]
#define sipNameNr_InputDialogOptions 6118
#define sipName_InputDialogOptions &sipStrings_QtGui[6118]
#define sipNameNr_setBackgroundColor 34496
#define sipName_setBackgroundColor &sipStrings_QtGui[34496]
#define sipNameNr_currentImageNumber 34515
#define sipName_currentImageNumber &sipStrings_QtGui[34515]
#define sipNameNr_IncrementalReading 34534
#define sipName_IncrementalReading &sipStrings_QtGui[34534]
#define sipNameNr_QImage__InvertMode 34553
#define sipName_QImage__InvertMode &sipStrings_QtGui[34553]
#define sipNameNr_QItemEditorFactory 34572
#define sipName_QItemEditorFactory &sipStrings_QtGui[34572]
#define sipNameNr_AvailableSizesHook 34591
#define sipName_AvailableSizesHook &sipStrings_QtGui[34591]
#define sipNameNr_minimumSectionSize 34610
#define sipName_minimumSectionSize &sipStrings_QtGui[34610]
#define sipNameNr_defaultSectionSize 34629
#define sipName_defaultSectionSize &sipStrings_QtGui[34629]
#define sipNameNr_hiddenSectionCount 34648
#define sipName_hiddenSectionCount &sipStrings_QtGui[34648]
#define sipNameNr_initializeSections 34667
#define sipName_initializeSections &sipStrings_QtGui[34667]
#define sipNameNr_stretchLastSection 34686
#define sipName_stretchLastSection &sipStrings_QtGui[34686]
#define sipNameNr_sortIndicatorOrder 34705
#define sipName_sortIndicatorOrder &sipStrings_QtGui[34705]
#define sipNameNr_viewportUpdateMode 34724
#define sipName_viewportUpdateMode &sipStrings_QtGui[34724]
#define sipNameNr_FullViewportUpdate 34743
#define sipName_FullViewportUpdate &sipStrings_QtGui[34743]
#define sipNameNr_ViewportUpdateMode 5521
#define sipName_ViewportUpdateMode &sipStrings_QtGui[5521]
#define sipNameNr_resetCachedContent 34762
#define sipName_resetCachedContent &sipStrings_QtGui[34762]
#define sipNameNr_buttonDownScenePos 34781
#define sipName_buttonDownScenePos &sipStrings_QtGui[34781]
#define sipNameNr_setShortcutEnabled 34800
#define sipName_setShortcutEnabled &sipStrings_QtGui[34800]
#define sipNameNr_isSortCacheEnabled 34819
#define sipName_isSortCacheEnabled &sipStrings_QtGui[34819]
#define sipNameNr_setForegroundBrush 34838
#define sipName_setForegroundBrush &sipStrings_QtGui[34838]
#define sipNameNr_setBackgroundBrush 34857
#define sipName_setBackgroundBrush &sipStrings_QtGui[34857]
#define sipNameNr_setItemIndexMethod 34876
#define sipName_setItemIndexMethod &sipStrings_QtGui[34876]
#define sipNameNr_setPreferredHeight 34895
#define sipName_setPreferredHeight &sipStrings_QtGui[34895]
#define sipNameNr_getContentsMargins 34914
#define sipName_getContentsMargins &sipStrings_QtGui[34914]
#define sipNameNr_setContentsMargins 34933
#define sipName_setContentsMargins &sipStrings_QtGui[34933]
#define sipNameNr_afterAnimationStep 34952
#define sipName_afterAnimationStep &sipStrings_QtGui[34952]
#define sipNameNr_QGraphicsItemGroup 34971
#define sipName_QGraphicsItemGroup &sipStrings_QtGui[34971]
#define sipNameNr_setTabChangesFocus 34990
#define sipName_setTabChangesFocus &sipStrings_QtGui[34990]
#define sipNameNr_transformationMode 35009
#define sipName_transformationMode &sipStrings_QtGui[35009]
#define sipNameNr_HeuristicMaskShape 35028
#define sipName_HeuristicMaskShape &sipStrings_QtGui[35028]
#define sipNameNr_commonAncestorItem 35047
#define sipName_commonAncestorItem &sipStrings_QtGui[35047]
#define sipNameNr_handlesChildEvents 35066
#define sipName_handlesChildEvents &sipStrings_QtGui[35066]
#define sipNameNr_acceptsHoverEvents 35085
#define sipName_acceptsHoverEvents &sipStrings_QtGui[35085]
#define sipNameNr_ItemSelectedChange 35104
#define sipName_ItemSelectedChange &sipStrings_QtGui[35104]
#define sipNameNr_ItemPositionChange 35123
#define sipName_ItemPositionChange &sipStrings_QtGui[35123]
#define sipNameNr_GraphicsItemChange 5555
#define sipName_GraphicsItemChange &sipStrings_QtGui[5555]
#define sipNameNr_setColumnAlignment 35142
#define sipName_setColumnAlignment &sipStrings_QtGui[35142]
#define sipNameNr_columnMaximumWidth 35161
#define sipName_columnMaximumWidth &sipStrings_QtGui[35161]
#define sipNameNr_columnMinimumWidth 35180
#define sipName_columnMinimumWidth &sipStrings_QtGui[35180]
#define sipNameNr_rowPreferredHeight 35199
#define sipName_rowPreferredHeight &sipStrings_QtGui[35199]
#define sipNameNr_setVerticalSpacing 35218
#define sipName_setVerticalSpacing &sipStrings_QtGui[35218]
#define sipNameNr_addApplicationFont 35237
#define sipName_addApplicationFont &sipStrings_QtGui[35237]
#define sipNameNr_isSmoothlyScalable 35256
#define sipName_isSmoothlyScalable &sipStrings_QtGui[35256]
#define sipNameNr_TraditionalChinese 35275
#define sipName_TraditionalChinese &sipStrings_QtGui[35275]
#define sipNameNr_currentFontChanged 35294
#define sipName_currentFontChanged &sipStrings_QtGui[35294]
#define sipNameNr_QFont__SpacingType 35313
#define sipName_QFont__SpacingType &sipStrings_QtGui[35313]
#define sipNameNr_removeSubstitution 35332
#define sipName_removeSubstitution &sipStrings_QtGui[35332]
#define sipNameNr_insertSubstitution 35351
#define sipName_insertSubstitution &sipStrings_QtGui[35351]
#define sipNameNr_nameFilterDisables 35370
#define sipName_nameFilterDisables &sipStrings_QtGui[35370]
#define sipNameNr_selectedNameFilter 35389
#define sipName_selectedNameFilter &sipStrings_QtGui[35389]
#define sipNameNr_tangentialPressure 35408
#define sipName_tangentialPressure &sipStrings_QtGui[35408]
#define sipNameNr_DockWidgetFeatures 6959
#define sipName_DockWidgetFeatures &sipStrings_QtGui[6959]
#define sipNameNr_DockWidgetClosable 35427
#define sipName_DockWidgetClosable &sipStrings_QtGui[35427]
#define sipNameNr_setResolveSymlinks 35446
#define sipName_setResolveSymlinks &sipStrings_QtGui[35446]
#define sipNameNr_setStandardButtons 35465
#define sipName_setStandardButtons &sipStrings_QtGui[35465]
#define sipNameNr_setSizeGripEnabled 35484
#define sipName_setSizeGripEnabled &sipStrings_QtGui[35484]
#define sipNameNr_setMaximumDateTime 35503
#define sipName_setMaximumDateTime &sipStrings_QtGui[35503]
#define sipNameNr_setMinimumDateTime 35522
#define sipName_setMinimumDateTime &sipStrings_QtGui[35522]
#define sipNameNr_setSelectedSection 35541
#define sipName_setSelectedSection &sipStrings_QtGui[35541]
#define sipNameNr_mappedPropertyName 35560
#define sipName_mappedPropertyName &sipStrings_QtGui[35560]
#define sipNameNr_InsertAfterCurrent 35579
#define sipName_InsertAfterCurrent &sipStrings_QtGui[35579]
#define sipNameNr_setMaxVisibleItems 35598
#define sipName_setMaxVisibleItems &sipStrings_QtGui[35598]
#define sipNameNr_ColorDialogOptions 6316
#define sipName_ColorDialogOptions &sipStrings_QtGui[6316]
#define sipNameNr_resizeGripsVisible 35617
#define sipName_resizeGripsVisible &sipStrings_QtGui[35617]
#define sipNameNr_supportsFindBuffer 35636
#define sipName_supportsFindBuffer &sipStrings_QtGui[35636]
#define sipNameNr_setDateEditEnabled 35655
#define sipName_setDateEditEnabled &sipStrings_QtGui[35655]
#define sipNameNr_currentPageChanged 35674
#define sipName_currentPageChanged &sipStrings_QtGui[35674]
#define sipNameNr_NoHorizontalHeader 35693
#define sipName_NoHorizontalHeader &sipStrings_QtGui[35693]
#define sipNameNr_ObjectBoundingMode 35712
#define sipName_ObjectBoundingMode &sipStrings_QtGui[35712]
#define sipNameNr_QCommandLinkButton 35731
#define sipName_QCommandLinkButton &sipStrings_QtGui[35731]
#define sipNameNr_allowX11ColorNames 35750
#define sipName_allowX11ColorNames &sipStrings_QtGui[35750]
#define sipNameNr_setLayoutDirection 26560
#define sipName_setLayoutDirection &sipStrings_QtGui[26560]
#define sipNameNr_setCursorFlashTime 35769
#define sipName_setCursorFlashTime &sipStrings_QtGui[35769]
#define sipNameNr_QApplication__Type 35788
#define sipName_QApplication__Type &sipStrings_QtGui[35788]
#define sipNameNr_setShortcutContext 35807
#define sipName_setShortcutContext &sipStrings_QtGui[35807]
#define sipNameNr_invertedAppearance 35826
#define sipName_invertedAppearance &sipStrings_QtGui[35826]
#define sipNameNr_resizeInlineObject 35845
#define sipName_resizeInlineObject &sipStrings_QtGui[35845]
#define sipNameNr_hasAcceptableInput 35864
#define sipName_hasAcceptableInput &sipStrings_QtGui[35864]
#define sipNameNr_addScrollBarWidget 35883
#define sipName_addScrollBarWidget &sipStrings_QtGui[35883]
#define sipNameNr_setViewportMargins 35902
#define sipName_setViewportMargins &sipStrings_QtGui[35902]
#define sipNameNr_PrintDialogOptions 1785
#define sipName_PrintDialogOptions &sipStrings_QtGui[1785]
#define sipNameNr_PrintCollateCopies 35921
#define sipName_PrintCollateCopies &sipStrings_QtGui[35921]
#define sipNameNr_focusNextPrevChild 35940
#define sipName_focusNextPrevChild &sipStrings_QtGui[35940]
#define sipNameNr_itemDelegateForRow 35959
#define sipName_itemDelegateForRow &sipStrings_QtGui[35959]
#define sipNameNr_verticalScrollMode 35978
#define sipName_verticalScrollMode &sipStrings_QtGui[35978]
#define sipNameNr_DragSelectingState 35997
#define sipName_DragSelectingState &sipStrings_QtGui[35997]
#define sipNameNr_autoRepeatInterval 36016
#define sipName_autoRepeatInterval &sipStrings_QtGui[36016]
#define sipNameNr_setAutoRepeatDelay 36035
#define sipName_setAutoRepeatDelay &sipStrings_QtGui[36035]
#define sipNameNr_ScientificNotation 36054
#define sipName_ScientificNotation &sipStrings_QtGui[36054]
#define sipNameNr_setCaseSensitivity 36073
#define sipName_setCaseSensitivity &sipStrings_QtGui[36073]
#define sipNameNr_beginRemoveColumns 36092
#define sipName_beginRemoveColumns &sipStrings_QtGui[36092]
#define sipNameNr_beginInsertColumns 36111
#define sipName_beginInsertColumns &sipStrings_QtGui[36111]
#define sipNameNr_36130 36130
#define sipName_36130 &sipStrings_QtGui[36130]
#define sipNameNr_closeActiveWindow 36148
#define sipName_closeActiveWindow &sipStrings_QtGui[36148]
#define sipNameNr_scrollBarsEnabled 36166
#define sipName_scrollBarsEnabled &sipStrings_QtGui[36166]
#define sipNameNr_setSubTitleFormat 36184
#define sipName_setSubTitleFormat &sipStrings_QtGui[36184]
#define sipNameNr_HaveCustomButton3 36202
#define sipName_HaveCustomButton3 &sipStrings_QtGui[36202]
#define sipNameNr_HaveCustomButton2 36220
#define sipName_HaveCustomButton2 &sipStrings_QtGui[36220]
#define sipNameNr_HaveCustomButton1 36238
#define sipName_HaveCustomButton1 &sipStrings_QtGui[36238]
#define sipNameNr_HelpButtonOnRight 36256
#define sipName_HelpButtonOnRight &sipStrings_QtGui[36256]
#define sipNameNr_setWindowFilePath 36274
#define sipName_setWindowFilePath &sipStrings_QtGui[36274]
#define sipNameNr_resetInputContext 36292
#define sipName_resetInputContext &sipStrings_QtGui[36292]
#define sipNameNr_setUpdatesEnabled 36310
#define sipName_setUpdatesEnabled &sipStrings_QtGui[36310]
#define sipNameNr_contextMenuPolicy 36328
#define sipName_contextMenuPolicy &sipStrings_QtGui[36328]
#define sipNameNr_setAccessibleName 36346
#define sipName_setAccessibleName &sipStrings_QtGui[36346]
#define sipNameNr_setWindowIconText 36364
#define sipName_setWindowIconText &sipStrings_QtGui[36364]
#define sipNameNr_setForegroundRole 36382
#define sipName_setForegroundRole &sipStrings_QtGui[36382]
#define sipNameNr_setBackgroundRole 36400
#define sipName_setBackgroundRole &sipStrings_QtGui[36400]
#define sipNameNr_setWindowModified 36418
#define sipName_setWindowModified &sipStrings_QtGui[36418]
#define sipNameNr_QValidator__State 36436
#define sipName_QValidator__State &sipStrings_QtGui[36436]
#define sipNameNr_topLevelItemCount 36454
#define sipName_topLevelItemCount &sipStrings_QtGui[36454]
#define sipNameNr_DontShowIndicator 36472
#define sipName_DontShowIndicator &sipStrings_QtGui[36472]
#define sipNameNr_uniformRowHeights 36490
#define sipName_uniformRowHeights &sipStrings_QtGui[36490]
#define sipNameNr_ShowTabsAndSpaces 36508
#define sipName_ShowTabsAndSpaces &sipStrings_QtGui[36508]
#define sipNameNr_QTextOption__Flag 36526
#define sipName_QTextOption__Flag &sipStrings_QtGui[36526]
#define sipNameNr_CursorOnCharacter 36544
#define sipName_CursorOnCharacter &sipStrings_QtGui[36544]
#define sipNameNr_additionalFormats 36562
#define sipName_additionalFormats &sipStrings_QtGui[36562]
#define sipNameNr_QTextInlineObject 36580
#define sipName_QTextInlineObject &sipStrings_QtGui[36580]
#define sipNameNr_setHeaderRowCount 36598
#define sipName_setHeaderRowCount &sipStrings_QtGui[36598]
#define sipNameNr_BorderStyle_Inset 36616
#define sipName_BorderStyle_Inset &sipStrings_QtGui[36616]
#define sipNameNr_BorderStyle_Ridge 36634
#define sipName_BorderStyle_Ridge &sipStrings_QtGui[36634]
#define sipNameNr_BorderStyle_Solid 36652
#define sipName_BorderStyle_Solid &sipStrings_QtGui[36652]
#define sipNameNr_nonBreakableLines 36670
#define sipName_nonBreakableLines &sipStrings_QtGui[36670]
#define sipNameNr_fontStyleStrategy 36688
#define sipName_fontStyleStrategy &sipStrings_QtGui[36688]
#define sipNameNr_fontLetterSpacing 36706
#define sipName_fontLetterSpacing &sipStrings_QtGui[36706]
#define sipNameNr_setUnderlineStyle 36724
#define sipName_setUnderlineStyle &sipStrings_QtGui[36724]
#define sipNameNr_verticalAlignment 36742
#define sipName_verticalAlignment &sipStrings_QtGui[36742]
#define sipNameNr_setFontFixedPitch 36760
#define sipName_setFontFixedPitch &sipStrings_QtGui[36760]
#define sipNameNr_setUnderlineColor 36778
#define sipName_setUnderlineColor &sipStrings_QtGui[36778]
#define sipNameNr_VerticalAlignment 2740
#define sipName_VerticalAlignment &sipStrings_QtGui[2740]
#define sipNameNr_toTableCellFormat 36796
#define sipName_toTableCellFormat &sipStrings_QtGui[36796]
#define sipNameNr_isTableCellFormat 36814
#define sipName_isTableCellFormat &sipStrings_QtGui[36814]
#define sipNameNr_FontStyleStrategy 24356
#define sipName_FontStyleStrategy &sipStrings_QtGui[24356]
#define sipNameNr_FontLetterSpacing 24377
#define sipName_FontLetterSpacing &sipStrings_QtGui[24377]
#define sipNameNr_FirstFontProperty 36832
#define sipName_FirstFontProperty &sipStrings_QtGui[36832]
#define sipNameNr_FrameBottomMargin 36850
#define sipName_FrameBottomMargin &sipStrings_QtGui[36850]
#define sipNameNr_FontSizeIncrement 36868
#define sipName_FontSizeIncrement &sipStrings_QtGui[36868]
#define sipNameNr_BlockBottomMargin 36886
#define sipName_BlockBottomMargin &sipStrings_QtGui[36886]
#define sipNameNr_QTextLength__Type 36904
#define sipName_QTextLength__Type &sipStrings_QtGui[36904]
#define sipNameNr_setAcceptRichText 36922
#define sipName_setAcceptRichText &sipStrings_QtGui[36922]
#define sipNameNr_setDocumentMargin 36940
#define sipName_setDocumentMargin &sipStrings_QtGui[36940]
#define sipNameNr_findBlockByNumber 36958
#define sipName_findBlockByNumber &sipStrings_QtGui[36958]
#define sipNameNr_defaultTextOption 36976
#define sipName_defaultTextOption &sipStrings_QtGui[36976]
#define sipNameNr_defaultStyleSheet 36994
#define sipName_defaultStyleSheet &sipStrings_QtGui[36994]
#define sipNameNr_markContentsDirty 37012
#define sipName_markContentsDirty &sipStrings_QtGui[37012]
#define sipNameNr_setDocumentLayout 37030
#define sipName_setDocumentLayout &sipStrings_QtGui[37030]
#define sipNameNr_PreviousCharacter 37048
#define sipName_PreviousCharacter &sipStrings_QtGui[37048]
#define sipNameNr_backwardAvailable 37066
#define sipName_backwardAvailable &sipStrings_QtGui[37066]
#define sipNameNr_cellDoubleClicked 37084
#define sipName_cellDoubleClicked &sipStrings_QtGui[37084]
#define sipNameNr_setVerticalHeader 37102
#define sipName_setVerticalHeader &sipStrings_QtGui[37102]
#define sipNameNr_tabCloseRequested 37120
#define sipName_tabCloseRequested &sipStrings_QtGui[37120]
#define sipNameNr_SelectPreviousTab 37138
#define sipName_SelectPreviousTab &sipStrings_QtGui[37138]
#define sipNameNr_usesScrollButtons 37156
#define sipName_usesScrollButtons &sipStrings_QtGui[37156]
#define sipNameNr_currentBlockState 37174
#define sipName_currentBlockState &sipStrings_QtGui[37174]
#define sipNameNr_QStyleOptionTabV3 37192
#define sipName_QStyleOptionTabV3 &sipStrings_QtGui[37192]
#define sipNameNr_HasCheckIndicator 37210
#define sipName_HasCheckIndicator &sipStrings_QtGui[37210]
#define sipNameNr_ToolButtonFeature 1086
#define sipName_ToolButtonFeature &sipStrings_QtGui[1086]
#define sipNameNr_activeSubControls 37228
#define sipName_activeSubControls &sipStrings_QtGui[37228]
#define sipNameNr_QStyleOptionTabV2 37246
#define sipName_QStyleOptionTabV2 &sipStrings_QtGui[37246]
#define sipNameNr_RightCornerWidget 37264
#define sipName_RightCornerWidget &sipStrings_QtGui[37264]
#define sipNameNr_CommandLinkButton 35732
#define sipName_CommandLinkButton &sipStrings_QtGui[35732]
#define sipNameNr_AutoDefaultButton 37282
#define sipName_AutoDefaultButton &sipStrings_QtGui[37282]
#define sipNameNr_QStyleOptionFrame 37300
#define sipName_QStyleOptionFrame &sipStrings_QtGui[37300]
#define sipNameNr_SO_TabWidgetFrame 37318
#define sipName_SO_TabWidgetFrame &sipStrings_QtGui[37318]
#define sipNameNr_SO_Q3ListViewItem 37336
#define sipName_SO_Q3ListViewItem &sipStrings_QtGui[37336]
#define sipNameNr_SP_DialogNoButton 37354
#define sipName_SP_DialogNoButton &sipStrings_QtGui[37354]
#define sipNameNr_SP_DialogOkButton 37372
#define sipName_SP_DialogOkButton &sipStrings_QtGui[37372]
#define sipNameNr_SP_FileDialogBack 37390
#define sipName_SP_FileDialogBack &sipStrings_QtGui[37390]
#define sipNameNr_SH_ComboBox_Popup 37408
#define sipName_SH_ComboBox_Popup &sipStrings_QtGui[37408]
#define sipNameNr_QStyle__StyleHint 37426
#define sipName_QStyle__StyleHint &sipStrings_QtGui[37426]
#define sipNameNr_PM_SubMenuOverlap 37444
#define sipName_PM_SubMenuOverlap &sipStrings_QtGui[37444]
#define sipNameNr_PM_ButtonIconSize 37462
#define sipName_PM_ButtonIconSize &sipStrings_QtGui[37462]
#define sipNameNr_PM_TabBarIconSize 37480
#define sipName_PM_TabBarIconSize &sipStrings_QtGui[37480]
#define sipNameNr_PM_HeaderMarkSize 37498
#define sipName_PM_HeaderMarkSize &sipStrings_QtGui[37498]
#define sipNameNr_PM_IndicatorWidth 37516
#define sipName_PM_IndicatorWidth &sipStrings_QtGui[37516]
#define sipNameNr_PM_MenuBarHMargin 37534
#define sipName_PM_MenuBarHMargin &sipStrings_QtGui[37534]
#define sipNameNr_PM_MenuBarVMargin 37552
#define sipName_PM_MenuBarVMargin &sipStrings_QtGui[37552]
#define sipNameNr_PM_MenuPanelWidth 37570
#define sipName_PM_MenuPanelWidth &sipStrings_QtGui[37570]
#define sipNameNr_PM_TitleBarHeight 37588
#define sipName_PM_TitleBarHeight &sipStrings_QtGui[37588]
#define sipNameNr_SC_MdiCloseButton 37606
#define sipName_SC_MdiCloseButton &sipStrings_QtGui[37606]
#define sipNameNr_SC_ToolButtonMenu 37624
#define sipName_SC_ToolButtonMenu &sipStrings_QtGui[37624]
#define sipNameNr_SC_ScrollBarFirst 37642
#define sipName_SC_ScrollBarFirst &sipStrings_QtGui[37642]
#define sipNameNr_SE_DockWidgetIcon 37660
#define sipName_SE_DockWidgetIcon &sipStrings_QtGui[37660]
#define sipNameNr_CE_ColumnViewGrip 37678
#define sipName_CE_ColumnViewGrip &sipStrings_QtGui[37678]
#define sipNameNr_CE_ScrollBarFirst 37696
#define sipName_CE_ScrollBarFirst &sipStrings_QtGui[37696]
#define sipNameNr_CE_TabBarTabLabel 37714
#define sipName_CE_TabBarTabLabel &sipStrings_QtGui[37714]
#define sipNameNr_CE_TabBarTabShape 37732
#define sipName_CE_TabBarTabShape &sipStrings_QtGui[37732]
#define sipNameNr_PE_PanelStatusBar 37750
#define sipName_PE_PanelStatusBar &sipStrings_QtGui[37750]
#define sipNameNr_PE_FrameTabWidget 37768
#define sipName_PE_FrameTabWidget &sipStrings_QtGui[37768]
#define sipNameNr_PE_FrameStatusBar 37786
#define sipName_PE_FrameStatusBar &sipStrings_QtGui[37786]
#define sipNameNr_PE_FrameFocusRect 37804
#define sipName_PE_FrameFocusRect &sipStrings_QtGui[37804]
#define sipNameNr_QStyle__StateFlag 37822
#define sipName_QStyle__StateFlag &sipStrings_QtGui[37822]
#define sipNameNr_setAccessibleText 37840
#define sipName_setAccessibleText &sipStrings_QtGui[37840]
#define sipNameNr_invisibleRootItem 37858
#define sipName_invisibleRootItem &sipStrings_QtGui[37858]
#define sipNameNr_isSortLocaleAware 37876
#define sipName_isSortLocaleAware &sipStrings_QtGui[37876]
#define sipNameNr_dynamicSortFilter 37894
#define sipName_dynamicSortFilter &sipStrings_QtGui[37894]
#define sipNameNr_setFilterWildcard 37912
#define sipName_setFilterWildcard &sipStrings_QtGui[37912]
#define sipNameNr_horizontalStretch 37930
#define sipName_horizontalStretch &sipStrings_QtGui[37930]
#define sipNameNr_setHeightForWidth 37948
#define sipName_setHeightForWidth &sipStrings_QtGui[37948]
#define sipNameNr_setVerticalPolicy 37966
#define sipName_setVerticalPolicy &sipStrings_QtGui[37966]
#define sipNameNr_setDiscardCommand 37984
#define sipName_setDiscardCommand &sipStrings_QtGui[37984]
#define sipNameNr_setRestartCommand 38002
#define sipName_setRestartCommand &sipStrings_QtGui[38002]
#define sipNameNr_allowsInteraction 38020
#define sipName_allowsInteraction &sipStrings_QtGui[38020]
#define sipNameNr_availablePrinters 38038
#define sipName_availablePrinters &sipStrings_QtGui[38038]
#define sipNameNr_PPK_FontEmbedding 38056
#define sipName_PPK_FontEmbedding &sipStrings_QtGui[38056]
#define sipNameNr_PPK_CollateCopies 38074
#define sipName_PPK_CollateCopies &sipStrings_QtGui[38074]
#define sipNameNr_setOutputFileName 38092
#define sipName_setOutputFileName &sipStrings_QtGui[38092]
#define sipNameNr_PrinterResolution 38110
#define sipName_PrinterResolution &sipStrings_QtGui[38110]
#define sipNameNr_ensureBlockLayout 38128
#define sipName_ensureBlockLayout &sipStrings_QtGui[38128]
#define sipNameNr_firstVisibleBlock 38146
#define sipName_firstVisibleBlock &sipStrings_QtGui[38146]
#define sipNameNr_blockCountChanged 38164
#define sipName_blockCountChanged &sipStrings_QtGui[38164]
#define sipNameNr_cursorForPosition 38182
#define sipName_cursorForPosition &sipStrings_QtGui[38182]
#define sipNameNr_setCenterOnScroll 38200
#define sipName_setCenterOnScroll &sipStrings_QtGui[38200]
#define sipNameNr_backgroundVisible 38218
#define sipName_backgroundVisible &sipStrings_QtGui[38218]
#define sipNameNr_maximumBlockCount 38236
#define sipName_maximumBlockCount &sipStrings_QtGui[38236]
#define sipNameNr_isUndoRedoEnabled 38254
#define sipName_isUndoRedoEnabled &sipStrings_QtGui[38254]
#define sipNameNr_currentCharFormat 38272
#define sipName_currentCharFormat &sipStrings_QtGui[38272]
#define sipNameNr_currentColorGroup 38290
#define sipName_currentColorGroup &sipStrings_QtGui[38290]
#define sipNameNr_setCurveThreshold 38308
#define sipName_setCurveThreshold &sipStrings_QtGui[38308]
#define sipNameNr_toSubpathPolygons 38326
#define sipName_toSubpathPolygons &sipStrings_QtGui[38326]
#define sipNameNr_penNeedsResolving 38344
#define sipName_penNeedsResolving &sipStrings_QtGui[38344]
#define sipNameNr_QPaintEngineState 38362
#define sipName_QPaintEngineState &sipStrings_QtGui[38362]
#define sipNameNr_PaintDeviceMetric 6704
#define sipName_PaintDeviceMetric &sipStrings_QtGui[6704]
#define sipNameNr_combinedTransform 38380
#define sipName_combinedTransform &sipStrings_QtGui[38380]
#define sipNameNr_setWorldTransform 38398
#define sipName_setWorldTransform &sipStrings_QtGui[38398]
#define sipNameNr_restoreRedirected 38416
#define sipName_restoreRedirected &sipStrings_QtGui[38416]
#define sipNameNr_drawConvexPolygon 38434
#define sipName_drawConvexPolygon &sipStrings_QtGui[38434]
#define sipNameNr_setBackgroundMode 38452
#define sipName_setBackgroundMode &sipStrings_QtGui[38452]
#define sipNameNr_QMovie__CacheMode 38470
#define sipName_QMovie__CacheMode &sipStrings_QtGui[38470]
#define sipNameNr_setWindowModality 38488
#define sipName_setWindowModality &sipStrings_QtGui[38488]
#define sipNameNr_QMessageBox__Icon 38506
#define sipName_QMessageBox__Icon &sipStrings_QtGui[38506]
#define sipNameNr_setTearOffEnabled 38524
#define sipName_setTearOffEnabled &sipStrings_QtGui[38524]
#define sipNameNr_cascadeSubWindows 38542
#define sipName_cascadeSubWindows &sipStrings_QtGui[38542]
#define sipNameNr_restoreDockWidget 38560
#define sipName_restoreDockWidget &sipStrings_QtGui[38560]
#define sipNameNr_setSortingEnabled 38578
#define sipName_setSortingEnabled &sipStrings_QtGui[38578]
#define sipNameNr_itemDoubleClicked 38596
#define sipName_itemDoubleClicked &sipStrings_QtGui[38596]
#define sipNameNr_cursorWordForward 38614
#define sipName_cursorWordForward &sipStrings_QtGui[38614]
#define sipNameNr_setCursorPosition 38632
#define sipName_setCursorPosition &sipStrings_QtGui[38632]
#define sipNameNr_smallDecimalPoint 38650
#define sipName_smallDecimalPoint &sipStrings_QtGui[38650]
#define sipNameNr_setSizeConstraint 38668
#define sipName_setSizeConstraint &sipStrings_QtGui[38668]
#define sipNameNr_setScaledContents 38686
#define sipName_setScaledContents &sipStrings_QtGui[38686]
#define sipNameNr_hasScaledContents 38704
#define sipName_hasScaledContents &sipStrings_QtGui[38704]
#define sipNameNr_DeleteStartOfWord 38722
#define sipName_DeleteStartOfWord &sipStrings_QtGui[38722]
#define sipNameNr_SelectStartOfLine 38740
#define sipName_SelectStartOfLine &sipStrings_QtGui[38740]
#define sipNameNr_MoveToStartOfLine 38758
#define sipName_MoveToStartOfLine &sipStrings_QtGui[38758]
#define sipNameNr_itemEditorFactory 38776
#define sipName_itemEditorFactory &sipStrings_QtGui[38776]
#define sipNameNr_textValueSelected 38794
#define sipName_textValueSelected &sipStrings_QtGui[38794]
#define sipNameNr_setDoubleDecimals 38812
#define sipName_setDoubleDecimals &sipStrings_QtGui[38812]
#define sipNameNr_InputDialogOption 6832
#define sipName_InputDialogOption &sipStrings_QtGui[6832]
#define sipNameNr_supportsAnimation 38830
#define sipName_supportsAnimation &sipStrings_QtGui[38830]
#define sipNameNr_setScaledClipRect 38848
#define sipName_setScaledClipRect &sipStrings_QtGui[38848]
#define sipNameNr_FileNotFoundError 38866
#define sipName_FileNotFoundError &sipStrings_QtGui[38866]
#define sipNameNr_currentRowChanged 38884
#define sipName_currentRowChanged &sipStrings_QtGui[38884]
#define sipNameNr_setDefaultFactory 38902
#define sipName_setDefaultFactory &sipStrings_QtGui[38902]
#define sipNameNr_valuePropertyName 38920
#define sipName_valuePropertyName &sipStrings_QtGui[38920]
#define sipNameNr_sectionAutoResize 38938
#define sipName_sectionAutoResize &sipStrings_QtGui[38938]
#define sipNameNr_geometriesChanged 38956
#define sipName_geometriesChanged &sipStrings_QtGui[38956]
#define sipNameNr_highlightSections 38974
#define sipName_highlightSections &sipStrings_QtGui[38974]
#define sipNameNr_viewportTransform 38992
#define sipName_viewportTransform &sipStrings_QtGui[38992]
#define sipNameNr_optimizationFlags 39010
#define sipName_optimizationFlags &sipStrings_QtGui[39010]
#define sipNameNr_OptimizationFlags 6152
#define sipName_OptimizationFlags &sipStrings_QtGui[6152]
#define sipNameNr_grabKeyboardEvent 30411
#define sipName_grabKeyboardEvent &sipStrings_QtGui[30411]
#define sipNameNr_itemsBoundingRect 39028
#define sipName_itemsBoundingRect &sipStrings_QtGui[39028]
#define sipNameNr_effectiveSizeHint 39046
#define sipName_effectiveSizeHint &sipStrings_QtGui[39046]
#define sipNameNr_setPreferredWidth 39064
#define sipName_setPreferredWidth &sipStrings_QtGui[39064]
#define sipNameNr_horizontalShearAt 39082
#define sipName_horizontalShearAt &sipStrings_QtGui[39082]
#define sipNameNr_horizontalScaleAt 39100
#define sipName_horizontalScaleAt &sipStrings_QtGui[39100]
#define sipNameNr_openExternalLinks 39118
#define sipName_openExternalLinks &sipStrings_QtGui[39118]
#define sipNameNr_QGraphicsTextItem 39136
#define sipName_QGraphicsTextItem &sipStrings_QtGui[39136]
#define sipNameNr_BoundingRectShape 39154
#define sipName_BoundingRectShape &sipStrings_QtGui[39154]
#define sipNameNr_QGraphicsLineItem 39172
#define sipName_QGraphicsLineItem &sipStrings_QtGui[39172]
#define sipNameNr_QGraphicsRectItem 39190
#define sipName_QGraphicsRectItem &sipStrings_QtGui[39190]
#define sipNameNr_QGraphicsPathItem 39208
#define sipName_QGraphicsPathItem &sipStrings_QtGui[39208]
#define sipNameNr_mapRectFromParent 39226
#define sipName_mapRectFromParent &sipStrings_QtGui[39226]
#define sipNameNr_acceptHoverEvents 39244
#define sipName_acceptHoverEvents &sipStrings_QtGui[39244]
#define sipNameNr_sceneBoundingRect 39262
#define sipName_sceneBoundingRect &sipStrings_QtGui[39262]
#define sipNameNr_GraphicsItemFlags 6185
#define sipName_GraphicsItemFlags &sipStrings_QtGui[6185]
#define sipNameNr_ItemOpacityChange 39280
#define sipName_ItemOpacityChange &sipStrings_QtGui[39280]
#define sipNameNr_ItemToolTipChange 39298
#define sipName_ItemToolTipChange &sipStrings_QtGui[39298]
#define sipNameNr_ItemEnabledChange 39316
#define sipName_ItemEnabledChange &sipStrings_QtGui[39316]
#define sipNameNr_ItemVisibleChange 39334
#define sipName_ItemVisibleChange &sipStrings_QtGui[39334]
#define sipNameNr_setRowFixedHeight 39352
#define sipName_setRowFixedHeight &sipStrings_QtGui[39352]
#define sipNameNr_QFrame__StyleMask 39370
#define sipName_QFrame__StyleMask &sipStrings_QtGui[39370]
#define sipNameNr_getLayoutPosition 39388
#define sipName_getLayoutPosition &sipStrings_QtGui[39388]
#define sipNameNr_getWidgetPosition 39406
#define sipName_getWidgetPosition &sipStrings_QtGui[39406]
#define sipNameNr_horizontalSpacing 39424
#define sipName_horizontalSpacing &sipStrings_QtGui[39424]
#define sipNameNr_setLabelAlignment 39442
#define sipName_setLabelAlignment &sipStrings_QtGui[39442]
#define sipNameNr_fieldGrowthPolicy 39460
#define sipName_fieldGrowthPolicy &sipStrings_QtGui[39460]
#define sipNameNr_FieldGrowthPolicy 7432
#define sipName_FieldGrowthPolicy &sipStrings_QtGui[7432]
#define sipNameNr_tightBoundingRect 39478
#define sipName_tightBoundingRect &sipStrings_QtGui[39478]
#define sipNameNr_FontDialogOptions 7928
#define sipName_FontDialogOptions &sipStrings_QtGui[7928]
#define sipNameNr_writingSystemName 39496
#define sipName_writingSystemName &sipStrings_QtGui[39496]
#define sipNameNr_SimplifiedChinese 39514
#define sipName_SimplifiedChinese &sipStrings_QtGui[39514]
#define sipNameNr_ProportionalFonts 39532
#define sipName_ProportionalFonts &sipStrings_QtGui[39532]
#define sipNameNr_setCapitalization 39550
#define sipName_setCapitalization &sipStrings_QtGui[39550]
#define sipNameNr_letterSpacingType 39568
#define sipName_letterSpacingType &sipStrings_QtGui[39568]
#define sipNameNr_PercentageSpacing 39586
#define sipName_PercentageSpacing &sipStrings_QtGui[39586]
#define sipNameNr_QFileIconProvider 39604
#define sipName_QFileIconProvider &sipStrings_QtGui[39604]
#define sipNameNr_replacementLength 39622
#define sipName_replacementLength &sipStrings_QtGui[39622]
#define sipNameNr_QInputMethodEvent 39640
#define sipName_QInputMethodEvent &sipStrings_QtGui[39640]
#define sipNameNr_QContextMenuEvent 39658
#define sipName_QContextMenuEvent &sipStrings_QtGui[39658]
#define sipNameNr_visibilityChanged 39676
#define sipName_visibilityChanged &sipStrings_QtGui[39676]
#define sipNameNr_setTitleBarWidget 39694
#define sipName_setTitleBarWidget &sipStrings_QtGui[39694]
#define sipNameNr_DockWidgetMovable 39712
#define sipName_DockWidgetMovable &sipStrings_QtGui[39712]
#define sipNameNr_DockWidgetFeature 7959
#define sipName_DockWidgetFeature &sipStrings_QtGui[7959]
#define sipNameNr_setLazyChildCount 39730
#define sipName_setLazyChildCount &sipStrings_QtGui[39730]
#define sipNameNr_isSizeGripEnabled 39748
#define sipName_isSizeGripEnabled &sipStrings_QtGui[39748]
#define sipNameNr_setNotchesVisible 39766
#define sipName_setNotchesVisible &sipStrings_QtGui[39766]
#define sipNameNr_availableGeometry 39784
#define sipName_availableGeometry &sipStrings_QtGui[39784]
#define sipNameNr_DocumentsLocation 39802
#define sipName_DocumentsLocation &sipStrings_QtGui[39802]
#define sipNameNr_setCalendarWidget 39820
#define sipName_setCalendarWidget &sipStrings_QtGui[39820]
#define sipNameNr_setCurrentSection 39838
#define sipName_setCurrentSection &sipStrings_QtGui[39838]
#define sipNameNr_displayedSections 39856
#define sipName_displayedSections &sipStrings_QtGui[39856]
#define sipNameNr_DateSections_Mask 39874
#define sipName_DateSections_Mask &sipStrings_QtGui[39874]
#define sipNameNr_TimeSections_Mask 39892
#define sipName_TimeSections_Mask &sipStrings_QtGui[39892]
#define sipNameNr_QDataWidgetMapper 39910
#define sipName_QDataWidgetMapper &sipStrings_QtGui[39910]
#define sipNameNr_currentCompletion 39928
#define sipName_currentCompletion &sipStrings_QtGui[39928]
#define sipNameNr_setCompletionRole 39946
#define sipName_setCompletionRole &sipStrings_QtGui[39946]
#define sipNameNr_setCompletionMode 39964
#define sipName_setCompletionMode &sipStrings_QtGui[39964]
#define sipNameNr_setRootModelIndex 39982
#define sipName_setRootModelIndex &sipStrings_QtGui[39982]
#define sipNameNr_duplicatesEnabled 40000
#define sipName_duplicatesEnabled &sipStrings_QtGui[40000]
#define sipNameNr_setAutoCompletion 40018
#define sipName_setAutoCompletion &sipStrings_QtGui[40018]
#define sipNameNr_ColorDialogOption 7024
#define sipName_ColorDialogOption &sipStrings_QtGui[7024]
#define sipNameNr_findBufferChanged 40036
#define sipName_findBufferChanged &sipStrings_QtGui[40036]
#define sipNameNr_supportsSelection 40054
#define sipName_supportsSelection &sipStrings_QtGui[40054]
#define sipNameNr_isDateEditEnabled 40072
#define sipName_isDateEditEnabled &sipStrings_QtGui[40072]
#define sipNameNr_showPreviousMonth 40090
#define sipName_showPreviousMonth &sipStrings_QtGui[40090]
#define sipNameNr_setDateTextFormat 40108
#define sipName_setDateTextFormat &sipStrings_QtGui[40108]
#define sipNameNr_weekdayTextFormat 40126
#define sipName_weekdayTextFormat &sipStrings_QtGui[40126]
#define sipNameNr_setFirstDayOfWeek 40144
#define sipName_setFirstDayOfWeek &sipStrings_QtGui[40144]
#define sipNameNr_setCoordinateMode 40162
#define sipName_setCoordinateMode &sipStrings_QtGui[40162]
#define sipNameNr_QGradient__Spread 40180
#define sipName_QGradient__Spread &sipStrings_QtGui[40180]
#define sipNameNr_hasHeightForWidth 40198
#define sipName_hasHeightForWidth &sipStrings_QtGui[40198]
#define sipNameNr_setGraphicsSystem 40216
#define sipName_setGraphicsSystem &sipStrings_QtGui[40216]
#define sipNameNr_commitDataRequest 40234
#define sipName_commitDataRequest &sipStrings_QtGui[40234]
#define sipNameNr_isSessionRestored 40252
#define sipName_isSessionRestored &sipStrings_QtGui[40252]
#define sipNameNr_startDragDistance 40270
#define sipName_startDragDistance &sipStrings_QtGui[40270]
#define sipNameNr_keyboardModifiers 40288
#define sipName_keyboardModifiers &sipStrings_QtGui[40288]
#define sipNameNr_activeModalWidget 40306
#define sipName_activeModalWidget &sipStrings_QtGui[40306]
#define sipNameNr_activePopupWidget 40324
#define sipName_activePopupWidget &sipStrings_QtGui[40324]
#define sipNameNr_setOverrideCursor 40342
#define sipName_setOverrideCursor &sipStrings_QtGui[40342]
#define sipNameNr_associatedWidgets 40360
#define sipName_associatedWidgets &sipStrings_QtGui[40360]
#define sipNameNr_TextHeuristicRole 40378
#define sipName_TextHeuristicRole &sipStrings_QtGui[40378]
#define sipNameNr_QAction__MenuRole 40396
#define sipName_QAction__MenuRole &sipStrings_QtGui[40396]
#define sipNameNr_SliderValueChange 40414
#define sipName_SliderValueChange &sipStrings_QtGui[40414]
#define sipNameNr_SliderStepsChange 40432
#define sipName_SliderStepsChange &sipStrings_QtGui[40432]
#define sipNameNr_SliderRangeChange 40450
#define sipName_SliderRangeChange &sipStrings_QtGui[40450]
#define sipNameNr_SliderPageStepSub 40468
#define sipName_SliderPageStepSub &sipStrings_QtGui[40468]
#define sipNameNr_SliderPageStepAdd 40486
#define sipName_SliderPageStepAdd &sipStrings_QtGui[40486]
#define sipNameNr_setSliderPosition 40504
#define sipName_setSliderPosition &sipStrings_QtGui[40504]
#define sipNameNr_blockBoundingRect 40522
#define sipName_blockBoundingRect &sipStrings_QtGui[40522]
#define sipNameNr_frameBoundingRect 40540
#define sipName_frameBoundingRect &sipStrings_QtGui[40540]
#define sipNameNr_setCorrectionMode 40558
#define sipName_setCorrectionMode &sipStrings_QtGui[40558]
#define sipNameNr_verticalScrollBar 40576
#define sipName_verticalScrollBar &sipStrings_QtGui[40576]
#define sipNameNr_setEnabledOptions 40594
#define sipName_setEnabledOptions &sipStrings_QtGui[40594]
#define sipNameNr_PrintShowPageSize 40612
#define sipName_PrintShowPageSize &sipStrings_QtGui[40612]
#define sipNameNr_PrintDialogOption 2467
#define sipName_PrintDialogOption &sipStrings_QtGui[2467]
#define sipNameNr_dirtyRegionOffset 40630
#define sipName_dirtyRegionOffset &sipStrings_QtGui[40630]
#define sipNameNr_scrollDirtyRegion 40648
#define sipName_scrollDirtyRegion &sipStrings_QtGui[40648]
#define sipNameNr_sizeHintForColumn 40666
#define sipName_sizeHintForColumn &sipStrings_QtGui[40666]
#define sipNameNr_showDropIndicator 40684
#define sipName_showDropIndicator &sipStrings_QtGui[40684]
#define sipNameNr_selectionBehavior 40702
#define sipName_selectionBehavior &sipStrings_QtGui[40702]
#define sipNameNr_setSelectionModel 40720
#define sipName_setSelectionModel &sipStrings_QtGui[40720]
#define sipNameNr_ExtendedSelection 40738
#define sipName_ExtendedSelection &sipStrings_QtGui[40738]
#define sipNameNr_SelectionBehavior 3983
#define sipName_SelectionBehavior &sipStrings_QtGui[3983]
#define sipNameNr_QAbstractItemView 40756
#define sipName_QAbstractItemView &sipStrings_QtGui[40756]
#define sipNameNr_mouseReleaseEvent 40774
#define sipName_mouseReleaseEvent &sipStrings_QtGui[40774]
#define sipNameNr_setAutoFormatting 40792
#define sipName_setAutoFormatting &sipStrings_QtGui[40792]
#define sipNameNr_headerDataChanged 40810
#define sipName_headerDataChanged &sipStrings_QtGui[40810]
#define sipNameNr_sip_simplewrapper 40828
#define sipName_sip_simplewrapper &sipStrings_QtGui[40828]
#define sipNameNr_40846 40846
#define sipName_40846 &sipStrings_QtGui[40846]
#define sipNameNr_40863 40863
#define sipName_40863 &sipStrings_QtGui[40863]
#define sipNameNr_appDefaultVisual 40880
#define sipName_appDefaultVisual &sipStrings_QtGui[40880]
#define sipNameNr_clientIsEmbedded 40897
#define sipName_clientIsEmbedded &sipStrings_QtGui[40897]
#define sipNameNr_currentIdChanged 40914
#define sipName_currentIdChanged &sipStrings_QtGui[40914]
#define sipNameNr_IndependentPages 40931
#define sipName_IndependentPages &sipStrings_QtGui[40931]
#define sipNameNr_BackgroundPixmap 40948
#define sipName_BackgroundPixmap &sipStrings_QtGui[40948]
#define sipNameNr_setDefaultWidget 40965
#define sipName_setDefaultWidget &sipStrings_QtGui[40965]
#define sipNameNr_hasMouseTracking 40982
#define sipName_hasMouseTracking &sipStrings_QtGui[40982]
#define sipNameNr_setMouseTracking 40999
#define sipName_setMouseTracking &sipStrings_QtGui[40999]
#define sipNameNr_updateMicroFocus 41016
#define sipName_updateMicroFocus &sipStrings_QtGui[41016]
#define sipNameNr_nextInFocusChain 41033
#define sipName_nextInFocusChain &sipStrings_QtGui[41033]
#define sipNameNr_isWindowModified 41050
#define sipName_isWindowModified &sipStrings_QtGui[41050]
#define sipNameNr_setWindowOpacity 41067
#define sipName_setWindowOpacity &sipStrings_QtGui[41067]
#define sipNameNr_setSizeIncrement 41084
#define sipName_setSizeIncrement &sipStrings_QtGui[41084]
#define sipNameNr_QRegExpValidator 41101
#define sipName_QRegExpValidator &sipStrings_QtGui[41101]
#define sipNameNr_StandardNotation 41118
#define sipName_StandardNotation &sipStrings_QtGui[41118]
#define sipNameNr_QDoubleValidator 41135
#define sipName_QDoubleValidator &sipStrings_QtGui[41135]
#define sipNameNr_createUndoAction 41152
#define sipName_createUndoAction &sipStrings_QtGui[41152]
#define sipNameNr_createRedoAction 41169
#define sipName_createRedoAction &sipStrings_QtGui[41169]
#define sipNameNr_addTopLevelItems 41186
#define sipName_addTopLevelItems &sipStrings_QtGui[41186]
#define sipNameNr_takeTopLevelItem 41203
#define sipName_takeTopLevelItem &sipStrings_QtGui[41203]
#define sipNameNr_indexRowSizeHint 41220
#define sipName_indexRowSizeHint &sipStrings_QtGui[41220]
#define sipNameNr_QTextOption__Tab 41237
#define sipName_QTextOption__Tab &sipStrings_QtGui[41237]
#define sipNameNr_blockFormatIndex 41254
#define sipName_blockFormatIndex &sipStrings_QtGui[41254]
#define sipNameNr_naturalTextWidth 41271
#define sipName_naturalTextWidth &sipStrings_QtGui[41271]
#define sipNameNr_setBottomPadding 41288
#define sipName_setBottomPadding &sipStrings_QtGui[41288]
#define sipNameNr_QTextTableFormat 41305
#define sipName_QTextTableFormat &sipStrings_QtGui[41305]
#define sipNameNr_BorderStyle_None 41322
#define sipName_BorderStyle_None &sipStrings_QtGui[41322]
#define sipNameNr_QTextFrameFormat 41339
#define sipName_QTextFrameFormat &sipStrings_QtGui[41339]
#define sipNameNr_QTextImageFormat 41356
#define sipName_QTextImageFormat &sipStrings_QtGui[41356]
#define sipNameNr_QTextBlockFormat 41373
#define sipName_QTextBlockFormat &sipStrings_QtGui[41373]
#define sipNameNr_setFontStyleHint 41390
#define sipName_setFontStyleHint &sipStrings_QtGui[41390]
#define sipNameNr_tableCellRowSpan 41407
#define sipName_tableCellRowSpan &sipStrings_QtGui[41407]
#define sipNameNr_setFontStrikeOut 41424
#define sipName_setFontStrikeOut &sipStrings_QtGui[41424]
#define sipNameNr_AlignSuperScript 41441
#define sipName_AlignSuperScript &sipStrings_QtGui[41441]
#define sipNameNr_LastFontProperty 41458
#define sipName_LastFontProperty &sipStrings_QtGui[41458]
#define sipNameNr_FrameBorderStyle 41475
#define sipName_FrameBorderStyle &sipStrings_QtGui[41475]
#define sipNameNr_FrameBorderBrush 41492
#define sipName_FrameBorderBrush &sipStrings_QtGui[41492]
#define sipNameNr_FrameRightMargin 41509
#define sipName_FrameRightMargin &sipStrings_QtGui[41509]
#define sipNameNr_TableCellRowSpan 27972
#define sipName_TableCellRowSpan &sipStrings_QtGui[27972]
#define sipNameNr_TableCellPadding 41526
#define sipName_TableCellPadding &sipStrings_QtGui[41526]
#define sipNameNr_TableCellSpacing 41543
#define sipName_TableCellSpacing &sipStrings_QtGui[41543]
#define sipNameNr_BlockRightMargin 41560
#define sipName_BlockRightMargin &sipStrings_QtGui[41560]
#define sipNameNr_PercentageLength 41577
#define sipName_PercentageLength &sipStrings_QtGui[41577]
#define sipNameNr_setFontUnderline 41594
#define sipName_setFontUnderline &sipStrings_QtGui[41594]
#define sipNameNr_setFontPointSize 41611
#define sipName_setFontPointSize &sipStrings_QtGui[41611]
#define sipNameNr_FixedColumnWidth 41628
#define sipName_FixedColumnWidth &sipStrings_QtGui[41628]
#define sipNameNr_undoCommandAdded 41645
#define sipName_undoCommandAdded &sipStrings_QtGui[41645]
#define sipNameNr_useDesignMetrics 41662
#define sipName_useDesignMetrics &sipStrings_QtGui[41662]
#define sipNameNr_WhiteSpaceNoWrap 41679
#define sipName_WhiteSpaceNoWrap &sipStrings_QtGui[41679]
#define sipNameNr_WhiteSpaceNormal 41696
#define sipName_WhiteSpaceNormal &sipStrings_QtGui[41696]
#define sipNameNr_visualNavigation 41713
#define sipName_visualNavigation &sipStrings_QtGui[41713]
#define sipNameNr_mergeBlockFormat 41730
#define sipName_mergeBlockFormat &sipStrings_QtGui[41730]
#define sipNameNr_BlockUnderCursor 41747
#define sipName_BlockUnderCursor &sipStrings_QtGui[41747]
#define sipNameNr_forwardAvailable 41764
#define sipName_forwardAvailable &sipStrings_QtGui[41764]
#define sipNameNr_setRangeSelected 41781
#define sipName_setRangeSelected &sipStrings_QtGui[41781]
#define sipNameNr_removeCellWidget 41798
#define sipName_removeCellWidget &sipStrings_QtGui[41798]
#define sipNameNr_QTableWidgetItem 41815
#define sipName_QTableWidgetItem &sipStrings_QtGui[41815]
#define sipNameNr_horizontalHeader 41832
#define sipName_horizontalHeader &sipStrings_QtGui[41832]
#define sipNameNr_supportsMessages 41849
#define sipName_supportsMessages &sipStrings_QtGui[41849]
#define sipNameNr_ActivationReason 5149
#define sipName_ActivationReason &sipStrings_QtGui[5149]
#define sipNameNr_viewItemPosition 41866
#define sipName_viewItemPosition &sipStrings_QtGui[41866]
#define sipNameNr_ViewItemPosition 1254
#define sipName_ViewItemPosition &sipStrings_QtGui[1254]
#define sipNameNr_verticalTitleBar 41883
#define sipName_verticalTitleBar &sipStrings_QtGui[41883]
#define sipNameNr_ViewItemFeatures 1377
#define sipName_ViewItemFeatures &sipStrings_QtGui[1377]
#define sipNameNr_QStyleHintReturn 41900
#define sipName_QStyleHintReturn &sipStrings_QtGui[41900]
#define sipNameNr_displayAlignment 41917
#define sipName_displayAlignment &sipStrings_QtGui[41917]
#define sipNameNr_LeftCornerWidget 41934
#define sipName_LeftCornerWidget &sipStrings_QtGui[41934]
#define sipNameNr_selectedPosition 41951
#define sipName_selectedPosition &sipStrings_QtGui[41951]
#define sipNameNr_SelectedPosition 1908
#define sipName_SelectedPosition &sipStrings_QtGui[1908]
#define sipNameNr_SP_BrowserReload 41968
#define sipName_SP_BrowserReload &sipStrings_QtGui[41968]
#define sipNameNr_SP_FileDialogEnd 41985
#define sipName_SP_FileDialogEnd &sipStrings_QtGui[41985]
#define sipNameNr_SP_DirClosedIcon 42002
#define sipName_SP_DirClosedIcon &sipStrings_QtGui[42002]
#define sipNameNr_sizeFromContents 42019
#define sipName_sizeFromContents &sipStrings_QtGui[42019]
#define sipNameNr_CT_HeaderSection 42036
#define sipName_CT_HeaderSection &sipStrings_QtGui[42036]
#define sipNameNr_CT_DialogButtons 42053
#define sipName_CT_DialogButtons &sipStrings_QtGui[42053]
#define sipNameNr_PM_LargeIconSize 42070
#define sipName_PM_LargeIconSize &sipStrings_QtGui[42070]
#define sipNameNr_PM_SmallIconSize 42087
#define sipName_PM_SmallIconSize &sipStrings_QtGui[42087]
#define sipNameNr_PM_MDIFrameWidth 42104
#define sipName_PM_MDIFrameWidth &sipStrings_QtGui[42104]
#define sipNameNr_PM_SplitterWidth 42121
#define sipName_PM_SplitterWidth &sipStrings_QtGui[42121]
#define sipNameNr_SC_GroupBoxFrame 42138
#define sipName_SC_GroupBoxFrame &sipStrings_QtGui[42138]
#define sipNameNr_SC_GroupBoxLabel 42155
#define sipName_SC_GroupBoxLabel &sipStrings_QtGui[42155]
#define sipNameNr_SC_DialTickmarks 42172
#define sipName_SC_DialTickmarks &sipStrings_QtGui[42172]
#define sipNameNr_SC_TitleBarLabel 42189
#define sipName_SC_TitleBarLabel &sipStrings_QtGui[42189]
#define sipNameNr_SC_ComboBoxArrow 42206
#define sipName_SC_ComboBoxArrow &sipStrings_QtGui[42206]
#define sipNameNr_SC_ComboBoxFrame 42223
#define sipName_SC_ComboBoxFrame &sipStrings_QtGui[42223]
#define sipNameNr_SC_ScrollBarLast 42240
#define sipName_SC_ScrollBarLast &sipStrings_QtGui[42240]
#define sipNameNr_SE_TabBarTabText 42257
#define sipName_SE_TabBarTabText &sipStrings_QtGui[42257]
#define sipNameNr_SE_FrameContents 42274
#define sipName_SE_FrameContents &sipStrings_QtGui[42274]
#define sipNameNr_CE_ComboBoxLabel 42291
#define sipName_CE_ComboBoxLabel &sipStrings_QtGui[42291]
#define sipNameNr_CE_ScrollBarLast 42308
#define sipName_CE_ScrollBarLast &sipStrings_QtGui[42308]
#define sipNameNr_CE_HeaderSection 42325
#define sipName_CE_HeaderSection &sipStrings_QtGui[42325]
#define sipNameNr_CE_MenuEmptyArea 42342
#define sipName_CE_MenuEmptyArea &sipStrings_QtGui[42342]
#define sipNameNr_CE_CheckBoxLabel 42359
#define sipName_CE_CheckBoxLabel &sipStrings_QtGui[42359]
#define sipNameNr_PE_PanelTipLabel 42376
#define sipName_PE_PanelTipLabel &sipStrings_QtGui[42376]
#define sipNameNr_PE_PanelLineEdit 42393
#define sipName_PE_PanelLineEdit &sipStrings_QtGui[42393]
#define sipNameNr_PE_FrameLineEdit 42410
#define sipName_PE_FrameLineEdit &sipStrings_QtGui[42410]
#define sipNameNr_PE_FrameGroupBox 42427
#define sipName_PE_FrameGroupBox &sipStrings_QtGui[42427]
#define sipNameNr_PrimitiveElement 15164
#define sipName_PrimitiveElement &sipStrings_QtGui[15164]
#define sipNameNr_State_Horizontal 42444
#define sipName_State_Horizontal &sipStrings_QtGui[42444]
#define sipNameNr_QStringListModel 42461
#define sipName_QStringListModel &sipStrings_QtGui[42461]
#define sipNameNr_setItemPrototype 42478
#define sipName_setItemPrototype &sipStrings_QtGui[42478]
#define sipNameNr_setCurrentWidget 42495
#define sipName_setCurrentWidget &sipStrings_QtGui[42495]
#define sipNameNr_invalidateFilter 42512
#define sipName_invalidateFilter &sipStrings_QtGui[42512]
#define sipNameNr_filterAcceptsRow 42529
#define sipName_filterAcceptsRow &sipStrings_QtGui[42529]
#define sipNameNr_horizontalPolicy 42546
#define sipName_horizontalPolicy &sipStrings_QtGui[42546]
#define sipNameNr_MinimumExpanding 42563
#define sipName_MinimumExpanding &sipStrings_QtGui[42563]
#define sipNameNr_RestartIfRunning 42580
#define sipName_RestartIfRunning &sipStrings_QtGui[42580]
#define sipNameNr_setTextDirection 42597
#define sipName_setTextDirection &sipStrings_QtGui[42597]
#define sipNameNr_PPK_PaperSources 42614
#define sipName_PPK_PaperSources &sipStrings_QtGui[42614]
#define sipNameNr_PPK_DocumentName 42631
#define sipName_PPK_DocumentName &sipStrings_QtGui[42631]
#define sipNameNr_setCollateCopies 42648
#define sipName_setCollateCopies &sipStrings_QtGui[42648]
#define sipNameNr_PostScriptFormat 42665
#define sipName_PostScriptFormat &sipStrings_QtGui[42665]
#define sipNameNr_ScreenResolution 42682
#define sipName_ScreenResolution &sipStrings_QtGui[42682]
#define sipNameNr_setOverwriteMode 42699
#define sipName_setOverwriteMode &sipStrings_QtGui[42699]
#define sipNameNr_setDocumentTitle 42716
#define sipName_setDocumentTitle &sipStrings_QtGui[42716]
#define sipNameNr_ExplicitlyShared 42733
#define sipName_ExplicitlyShared &sipStrings_QtGui[42733]
#define sipNameNr_ImplicitlyShared 42750
#define sipName_ImplicitlyShared &sipStrings_QtGui[42750]
#define sipNameNr_x11PictureHandle 42767
#define sipName_x11PictureHandle &sipStrings_QtGui[42767]
#define sipNameNr_outputFormatList 42784
#define sipName_outputFormatList &sipStrings_QtGui[42784]
#define sipNameNr_controlPointRect 42801
#define sipName_controlPointRect &sipStrings_QtGui[42801]
#define sipNameNr_DirtyClipEnabled 42818
#define sipName_DirtyClipEnabled &sipStrings_QtGui[42818]
#define sipNameNr_DirtyBrushOrigin 42835
#define sipName_DirtyBrushOrigin &sipStrings_QtGui[42835]
#define sipNameNr_PatternTransform 42852
#define sipName_PatternTransform &sipStrings_QtGui[42852]
#define sipNameNr_setMatrixEnabled 42869
#define sipName_setMatrixEnabled &sipStrings_QtGui[42869]
#define sipNameNr_TextAntialiasing 42886
#define sipName_TextAntialiasing &sipStrings_QtGui[42886]
#define sipNameNr_QPageSetupDialog 42903
#define sipName_QPageSetupDialog &sipStrings_QtGui[42903]
#define sipNameNr_supportedFormats 42920
#define sipName_supportedFormats &sipStrings_QtGui[42920]
#define sipNameNr_setDefaultButton 42937
#define sipName_setDefaultButton &sipStrings_QtGui[42937]
#define sipNameNr_setDefaultAction 42954
#define sipName_setDefaultAction &sipStrings_QtGui[42954]
#define sipNameNr_isTearOffEnabled 42971
#define sipName_isTearOffEnabled &sipStrings_QtGui[42971]
#define sipNameNr_keyboardPageStep 42988
#define sipName_keyboardPageStep &sipStrings_QtGui[42988]
#define sipNameNr_SubWindowOptions 6801
#define sipName_SubWindowOptions &sipStrings_QtGui[6801]
#define sipNameNr_RubberBandResize 43005
#define sipName_RubberBandResize &sipStrings_QtGui[43005]
#define sipNameNr_currentSubWindow 43022
#define sipName_currentSubWindow &sipStrings_QtGui[43022]
#define sipNameNr_ForceTabbedDocks 43039
#define sipName_ForceTabbedDocks &sipStrings_QtGui[43039]
#define sipNameNr_AllowTabbedDocks 43056
#define sipName_AllowTabbedDocks &sipStrings_QtGui[43056]
#define sipNameNr_AllowNestedDocks 43073
#define sipName_AllowNestedDocks &sipStrings_QtGui[43073]
#define sipNameNr_tabifyDockWidget 43090
#define sipName_tabifyDockWidget &sipStrings_QtGui[43090]
#define sipNameNr_removeDockWidget 43107
#define sipName_removeDockWidget &sipStrings_QtGui[43107]
#define sipNameNr_setCentralWidget 43124
#define sipName_setCentralWidget &sipStrings_QtGui[43124]
#define sipNameNr_removeItemWidget 43141
#define sipName_removeItemWidget &sipStrings_QtGui[43141]
#define sipNameNr_isSortingEnabled 43158
#define sipName_isSortingEnabled &sipStrings_QtGui[43158]
#define sipNameNr_setTextAlignment 43175
#define sipName_setTextAlignment &sipStrings_QtGui[43175]
#define sipNameNr_uniformItemSizes 43192
#define sipName_uniformItemSizes &sipStrings_QtGui[43192]
#define sipNameNr_cursorPositionAt 43209
#define sipName_cursorPositionAt &sipStrings_QtGui[43209]
#define sipNameNr_QLCDNumber__Mode 43226
#define sipName_QLCDNumber__Mode &sipStrings_QtGui[43226]
#define sipNameNr_totalMaximumSize 43243
#define sipName_totalMaximumSize &sipStrings_QtGui[43243]
#define sipNameNr_totalMinimumSize 43260
#define sipName_totalMinimumSize &sipStrings_QtGui[43260]
#define sipNameNr_SetMinAndMaxSize 43277
#define sipName_SetMinAndMaxSize &sipStrings_QtGui[43277]
#define sipNameNr_SelectEndOfBlock 43294
#define sipName_SelectEndOfBlock &sipStrings_QtGui[43294]
#define sipNameNr_MoveToEndOfBlock 43311
#define sipName_MoveToEndOfBlock &sipStrings_QtGui[43311]
#define sipNameNr_intValueSelected 43328
#define sipName_intValueSelected &sipStrings_QtGui[43328]
#define sipNameNr_textValueChanged 43345
#define sipName_textValueChanged &sipStrings_QtGui[43345]
#define sipNameNr_cancelButtonText 43362
#define sipName_cancelButtonText &sipStrings_QtGui[43362]
#define sipNameNr_setDoubleMaximum 43379
#define sipName_setDoubleMaximum &sipStrings_QtGui[43379]
#define sipNameNr_setDoubleMinimum 43396
#define sipName_setDoubleMinimum &sipStrings_QtGui[43396]
#define sipNameNr_setComboBoxItems 43413
#define sipName_setComboBoxItems &sipStrings_QtGui[43413]
#define sipNameNr_ImageWriterError 7774
#define sipName_ImageWriterError &sipStrings_QtGui[7774]
#define sipNameNr_InvalidDataError 43430
#define sipName_InvalidDataError &sipStrings_QtGui[43430]
#define sipNameNr_ImageReaderError 7805
#define sipName_ImageReaderError &sipStrings_QtGui[7805]
#define sipNameNr_currentImageRect 43447
#define sipName_currentImageRect &sipStrings_QtGui[43447]
#define sipNameNr_CompressionRatio 43464
#define sipName_CompressionRatio &sipStrings_QtGui[43464]
#define sipNameNr_setDotsPerMeterY 43481
#define sipName_setDotsPerMeterY &sipStrings_QtGui[43481]
#define sipNameNr_setDotsPerMeterX 43498
#define sipName_setDotsPerMeterX &sipStrings_QtGui[43498]
#define sipNameNr_isColumnSelected 43515
#define sipName_isColumnSelected &sipStrings_QtGui[43515]
#define sipNameNr_defaultAlignment 43532
#define sipName_defaultAlignment &sipStrings_QtGui[43532]
#define sipNameNr_sectionsInserted 43549
#define sipName_sectionsInserted &sipStrings_QtGui[43549]
#define sipNameNr_setSortIndicator 43566
#define sipName_setSortIndicator &sipStrings_QtGui[43566]
#define sipNameNr_setSectionHidden 43583
#define sipName_setSectionHidden &sipStrings_QtGui[43583]
#define sipNameNr_ResizeToContents 43600
#define sipName_ResizeToContents &sipStrings_QtGui[43600]
#define sipNameNr_setColumnStretch 43617
#define sipName_setColumnStretch &sipStrings_QtGui[43617]
#define sipNameNr_OptimizationFlag 6865
#define sipName_OptimizationFlag &sipStrings_QtGui[6865]
#define sipNameNr_NoViewportUpdate 43634
#define sipName_NoViewportUpdate &sipStrings_QtGui[43634]
#define sipNameNr_AnchorUnderMouse 43651
#define sipName_AnchorUnderMouse &sipStrings_QtGui[43651]
#define sipNameNr_AnchorViewCenter 43668
#define sipName_AnchorViewCenter &sipStrings_QtGui[43668]
#define sipNameNr_windowFrameEvent 43685
#define sipName_windowFrameEvent &sipStrings_QtGui[43685]
#define sipNameNr_paintWindowFrame 43702
#define sipName_paintWindowFrame &sipStrings_QtGui[43702]
#define sipNameNr_sceneRectChanged 43719
#define sipName_sceneRectChanged &sipStrings_QtGui[43719]
#define sipNameNr_mouseGrabberItem 43736
#define sipName_mouseGrabberItem &sipStrings_QtGui[43736]
#define sipNameNr_destroyItemGroup 43753
#define sipName_destroyItemGroup &sipStrings_QtGui[43753]
#define sipNameNr_setSelectionArea 43770
#define sipName_setSelectionArea &sipStrings_QtGui[43770]
#define sipNameNr_ungrabMouseEvent 43787
#define sipName_ungrabMouseEvent &sipStrings_QtGui[43787]
#define sipNameNr_setOwnedByLayout 43804
#define sipName_setOwnedByLayout &sipStrings_QtGui[43804]
#define sipNameNr_parentLayoutItem 43821
#define sipName_parentLayoutItem &sipStrings_QtGui[43821]
#define sipNameNr_setMaximumHeight 43838
#define sipName_setMaximumHeight &sipStrings_QtGui[43838]
#define sipNameNr_setPreferredSize 43855
#define sipName_setPreferredSize &sipStrings_QtGui[43855]
#define sipNameNr_setMinimumHeight 43872
#define sipName_setMinimumHeight &sipStrings_QtGui[43872]
#define sipNameNr_setTranslationAt 43889
#define sipName_setTranslationAt &sipStrings_QtGui[43889]
#define sipNameNr_defaultTextColor 43906
#define sipName_defaultTextColor &sipStrings_QtGui[43906]
#define sipNameNr_mapRectFromScene 43923
#define sipName_mapRectFromScene &sipStrings_QtGui[43923]
#define sipNameNr_effectiveOpacity 43940
#define sipName_effectiveOpacity &sipStrings_QtGui[43940]
#define sipNameNr_sceneEventFilter 43957
#define sipName_sceneEventFilter &sipStrings_QtGui[43957]
#define sipNameNr_collidesWithPath 43974
#define sipName_collidesWithPath &sipStrings_QtGui[43974]
#define sipNameNr_collidesWithItem 43991
#define sipName_collidesWithItem &sipStrings_QtGui[43991]
#define sipNameNr_ItemClipsToShape 44008
#define sipName_ItemClipsToShape &sipStrings_QtGui[44008]
#define sipNameNr_GraphicsItemFlag 6929
#define sipName_GraphicsItemFlag &sipStrings_QtGui[6929]
#define sipNameNr_ItemZValueChange 44025
#define sipName_ItemZValueChange &sipStrings_QtGui[44025]
#define sipNameNr_ItemCursorChange 44042
#define sipName_ItemCursorChange &sipStrings_QtGui[44042]
#define sipNameNr_ItemParentChange 44059
#define sipName_ItemParentChange &sipStrings_QtGui[44059]
#define sipNameNr_ItemMatrixChange 44076
#define sipName_ItemMatrixChange &sipStrings_QtGui[44076]
#define sipNameNr_rowMaximumHeight 44093
#define sipName_rowMaximumHeight &sipStrings_QtGui[44093]
#define sipNameNr_rowMinimumHeight 44110
#define sipName_rowMinimumHeight &sipStrings_QtGui[44110]
#define sipNameNr_rowStretchFactor 44127
#define sipName_rowStretchFactor &sipStrings_QtGui[44127]
#define sipNameNr_setColumnSpacing 44144
#define sipName_setColumnSpacing &sipStrings_QtGui[44144]
#define sipNameNr_setFormAlignment 44161
#define sipName_setFormAlignment &sipStrings_QtGui[44161]
#define sipNameNr_setRowWrapPolicy 44178
#define sipName_setRowWrapPolicy &sipStrings_QtGui[44178]
#define sipNameNr_averageCharWidth 44195
#define sipName_averageCharWidth &sipStrings_QtGui[44195]
#define sipNameNr_boundingRectChar 44212
#define sipName_boundingRectChar &sipStrings_QtGui[44212]
#define sipNameNr_FontDialogOption 8954
#define sipName_FontDialogOption &sipStrings_QtGui[8954]
#define sipNameNr_isBitmapScalable 44229
#define sipName_isBitmapScalable &sipStrings_QtGui[44229]
#define sipNameNr_setWritingSystem 44246
#define sipName_setWritingSystem &sipStrings_QtGui[44246]
#define sipNameNr_NonScalableFonts 44263
#define sipName_NonScalableFonts &sipStrings_QtGui[44263]
#define sipNameNr_setLetterSpacing 44280
#define sipName_setLetterSpacing &sipStrings_QtGui[44280]
#define sipNameNr_lastResortFamily 44297
#define sipName_lastResortFamily &sipStrings_QtGui[44297]
#define sipNameNr_setStyleStrategy 44314
#define sipName_setStyleStrategy &sipStrings_QtGui[44314]
#define sipNameNr_OpenGLCompatible 44331
#define sipName_OpenGLCompatible &sipStrings_QtGui[44331]
#define sipNameNr_QFont__StyleHint 44348
#define sipName_QFont__StyleHint &sipStrings_QtGui[44348]
#define sipNameNr_QFileSystemModel 44365
#define sipName_QFileSystemModel &sipStrings_QtGui[44365]
#define sipNameNr_selectNameFilter 44382
#define sipName_selectNameFilter &sipStrings_QtGui[44382]
#define sipNameNr_getOpenFileNames 44399
#define sipName_getOpenFileNames &sipStrings_QtGui[44399]
#define sipNameNr_directoryEntered 44416
#define sipName_directoryEntered &sipStrings_QtGui[44416]
#define sipNameNr_setDefaultSuffix 44433
#define sipName_setDefaultSuffix &sipStrings_QtGui[44433]
#define sipNameNr_confirmOverwrite 44450
#define sipName_confirmOverwrite &sipStrings_QtGui[44450]
#define sipNameNr_replacementStart 44467
#define sipName_replacementStart &sipStrings_QtGui[44467]
#define sipNameNr_nativeVirtualKey 44484
#define sipName_nativeVirtualKey &sipStrings_QtGui[44484]
#define sipNameNr_toggleViewAction 44501
#define sipName_toggleViewAction &sipStrings_QtGui[44501]
#define sipNameNr_QDirModel__Roles 44518
#define sipName_QDirModel__Roles &sipStrings_QtGui[44518]
#define sipNameNr_setCenterButtons 44535
#define sipName_setCenterButtons &sipStrings_QtGui[44535]
#define sipNameNr_QDialogButtonBox 44552
#define sipName_QDialogButtonBox &sipStrings_QtGui[44552]
#define sipNameNr_isVirtualDesktop 44569
#define sipName_isVirtualDesktop &sipStrings_QtGui[44569]
#define sipNameNr_PicturesLocation 44586
#define sipName_PicturesLocation &sipStrings_QtGui[44586]
#define sipNameNr_StandardLocation 4978
#define sipName_StandardLocation &sipStrings_QtGui[4978]
#define sipNameNr_QDesktopServices 44603
#define sipName_QDesktopServices &sipStrings_QtGui[44603]
#define sipNameNr_setDateTimeRange 44620
#define sipName_setDateTimeRange &sipStrings_QtGui[44620]
#define sipNameNr_textFromDateTime 44637
#define sipName_textFromDateTime &sipStrings_QtGui[44637]
#define sipNameNr_dateTimeFromText 44654
#define sipName_dateTimeFromText &sipStrings_QtGui[44654]
#define sipNameNr_setCalendarPopup 44671
#define sipName_setCalendarPopup &sipStrings_QtGui[44671]
#define sipNameNr_setDisplayFormat 44688
#define sipName_setDisplayFormat &sipStrings_QtGui[44688]
#define sipNameNr_clearMaximumTime 44705
#define sipName_clearMaximumTime &sipStrings_QtGui[44705]
#define sipNameNr_clearMinimumTime 44722
#define sipName_clearMinimumTime &sipStrings_QtGui[44722]
#define sipNameNr_clearMaximumDate 44739
#define sipName_clearMaximumDate &sipStrings_QtGui[44739]
#define sipNameNr_clearMinimumDate 44756
#define sipName_clearMinimumDate &sipStrings_QtGui[44756]
#define sipNameNr_completionPrefix 44773
#define sipName_completionPrefix &sipStrings_QtGui[44773]
#define sipNameNr_completionColumn 44790
#define sipName_completionColumn &sipStrings_QtGui[44790]
#define sipNameNr_InlineCompletion 44807
#define sipName_InlineCompletion &sipStrings_QtGui[44807]
#define sipNameNr_sizeAdjustPolicy 44824
#define sipName_sizeAdjustPolicy &sipStrings_QtGui[44824]
#define sipNameNr_AdjustToContents 44841
#define sipName_AdjustToContents &sipStrings_QtGui[44841]
#define sipNameNr_SizeAdjustPolicy 11049
#define sipName_SizeAdjustPolicy &sipStrings_QtGui[11049]
#define sipNameNr_setStandardColor 44858
#define sipName_setStandardColor &sipStrings_QtGui[44858]
#define sipNameNr_ShowAlphaChannel 44875
#define sipName_ShowAlphaChannel &sipStrings_QtGui[44875]
#define sipNameNr_initializeColumn 44892
#define sipName_initializeColumn &sipStrings_QtGui[44892]
#define sipNameNr_setPreviewWidget 44909
#define sipName_setPreviewWidget &sipStrings_QtGui[44909]
#define sipNameNr_QClipboard__Mode 44926
#define sipName_QClipboard__Mode &sipStrings_QtGui[44926]
#define sipNameNr_showSelectedDate 44943
#define sipName_showSelectedDate &sipStrings_QtGui[44943]
#define sipNameNr_showPreviousYear 44960
#define sipName_showPreviousYear &sipStrings_QtGui[44960]
#define sipNameNr_headerTextFormat 44977
#define sipName_headerTextFormat &sipStrings_QtGui[44977]
#define sipNameNr_setHeaderVisible 44994
#define sipName_setHeaderVisible &sipStrings_QtGui[44994]
#define sipNameNr_NoVerticalHeader 45011
#define sipName_NoVerticalHeader &sipStrings_QtGui[45011]
#define sipNameNr_QConicalGradient 45028
#define sipName_QConicalGradient &sipStrings_QtGui[45028]
#define sipNameNr_insertSpacerItem 45045
#define sipName_insertSpacerItem &sipStrings_QtGui[45045]
#define sipNameNr_setStretchFactor 45062
#define sipName_setStretchFactor &sipStrings_QtGui[45062]
#define sipNameNr_saveStateRequest 45079
#define sipName_saveStateRequest &sipStrings_QtGui[45079]
#define sipNameNr_lastWindowClosed 45096
#define sipName_lastWindowClosed &sipStrings_QtGui[45096]
#define sipNameNr_setEffectEnabled 45113
#define sipName_setEffectEnabled &sipStrings_QtGui[45113]
#define sipNameNr_setStartDragTime 45130
#define sipName_setStartDragTime &sipStrings_QtGui[45130]
#define sipNameNr_wheelScrollLines 45147
#define sipName_wheelScrollLines &sipStrings_QtGui[45147]
#define sipNameNr_invertedControls 45164
#define sipName_invertedControls &sipStrings_QtGui[45164]
#define sipNameNr_drawInlineObject 45181
#define sipName_drawInlineObject &sipStrings_QtGui[45181]
#define sipNameNr_pageCountChanged 45198
#define sipName_pageCountChanged &sipStrings_QtGui[45198]
#define sipNameNr_handlerForObject 45215
#define sipName_handlerForObject &sipStrings_QtGui[45215]
#define sipNameNr_keyboardTracking 45232
#define sipName_keyboardTracking &sipStrings_QtGui[45232]
#define sipNameNr_specialValueText 45249
#define sipName_specialValueText &sipStrings_QtGui[45249]
#define sipNameNr_setButtonSymbols 45266
#define sipName_setButtonSymbols &sipStrings_QtGui[45266]
#define sipNameNr_QAbstractSpinBox 45283
#define sipName_QAbstractSpinBox &sipStrings_QtGui[45283]
#define sipNameNr_scrollBarWidgets 45300
#define sipName_scrollBarWidgets &sipStrings_QtGui[45300]
#define sipNameNr_scrollContentsBy 45317
#define sipName_scrollContentsBy &sipStrings_QtGui[45317]
#define sipNameNr_contextMenuEvent 45334
#define sipName_contextMenuEvent &sipStrings_QtGui[45334]
#define sipNameNr_addEnabledOption 45351
#define sipName_addEnabledOption &sipStrings_QtGui[45351]
#define sipNameNr_inputMethodEvent 45368
#define sipName_inputMethodEvent &sipStrings_QtGui[45368]
#define sipNameNr_autoScrollMargin 45385
#define sipName_autoScrollMargin &sipStrings_QtGui[45385]
#define sipNameNr_inputMethodQuery 45402
#define sipName_inputMethodQuery &sipStrings_QtGui[45402]
#define sipNameNr_selectionCommand 45419
#define sipName_selectionCommand &sipStrings_QtGui[45419]
#define sipNameNr_horizontalOffset 45436
#define sipName_horizontalOffset &sipStrings_QtGui[45436]
#define sipNameNr_updateGeometries 45453
#define sipName_updateGeometries &sipStrings_QtGui[45453]
#define sipNameNr_updateEditorData 45470
#define sipName_updateEditorData &sipStrings_QtGui[45470]
#define sipNameNr_selectionChanged 45487
#define sipName_selectionChanged &sipStrings_QtGui[45487]
#define sipNameNr_sizeHintForIndex 45504
#define sipName_sizeHintForIndex &sipStrings_QtGui[45504]
#define sipNameNr_setTextElideMode 45521
#define sipName_setTextElideMode &sipStrings_QtGui[45521]
#define sipNameNr_tabKeyNavigation 45538
#define sipName_tabKeyNavigation &sipStrings_QtGui[45538]
#define sipNameNr_setSelectionMode 45555
#define sipName_setSelectionMode &sipStrings_QtGui[45555]
#define sipNameNr_PositionAtCenter 45572
#define sipName_PositionAtCenter &sipStrings_QtGui[45572]
#define sipNameNr_PositionAtBottom 45589
#define sipName_PositionAtBottom &sipStrings_QtGui[45589]
#define sipNameNr_RevertModelCache 45606
#define sipName_RevertModelCache &sipStrings_QtGui[45606]
#define sipNameNr_SubmitModelCache 45623
#define sipName_SubmitModelCache &sipStrings_QtGui[45623]
#define sipNameNr_EditPreviousItem 45640
#define sipName_EditPreviousItem &sipStrings_QtGui[45640]
#define sipNameNr_setAutoExclusive 45657
#define sipName_setAutoExclusive &sipStrings_QtGui[45657]
#define sipNameNr_disconnectNotify 45674
#define sipName_disconnectNotify &sipStrings_QtGui[45674]
#define sipNameNr_endRemoveColumns 45691
#define sipName_endRemoveColumns &sipStrings_QtGui[45691]
#define sipNameNr_endInsertColumns 45708
#define sipName_endInsertColumns &sipStrings_QtGui[45708]
#define sipNameNr_ItemIsSelectable 45725
#define sipName_ItemIsSelectable &sipStrings_QtGui[45725]
#define sipNameNr_45742 45742
#define sipName_45742 &sipStrings_QtGui[45742]
#define sipNameNr_45758 45758
#define sipName_45758 &sipStrings_QtGui[45758]
#define sipNameNr_45774 45774
#define sipName_45774 &sipStrings_QtGui[45774]
#define sipNameNr_45790 45790
#define sipName_45790 &sipStrings_QtGui[45790]
#define sipNameNr_45806 45806
#define sipName_45806 &sipStrings_QtGui[45806]
#define sipNameNr_defaultColormap 45822
#define sipName_defaultColormap &sipStrings_QtGui[45822]
#define sipNameNr_containerClosed 45838
#define sipName_containerClosed &sipStrings_QtGui[45838]
#define sipNameNr_InvalidWindowID 45854
#define sipName_InvalidWindowID &sipStrings_QtGui[45854]
#define sipNameNr_QX11EmbedWidget 45870
#define sipName_QX11EmbedWidget &sipStrings_QtGui[45870]
#define sipNameNr_windowActivated 45886
#define sipName_windowActivated &sipStrings_QtGui[45886]
#define sipNameNr_completeChanged 45902
#define sipName_completeChanged &sipStrings_QtGui[45902]
#define sipNameNr_setButtonLayout 45918
#define sipName_setButtonLayout &sipStrings_QtGui[45918]
#define sipNameNr_NoDefaultButton 45934
#define sipName_NoDefaultButton &sipStrings_QtGui[45934]
#define sipNameNr_IgnoreSubTitles 45950
#define sipName_IgnoreSubTitles &sipStrings_QtGui[45950]
#define sipNameNr_WatermarkPixmap 16157
#define sipName_WatermarkPixmap &sipStrings_QtGui[16157]
#define sipNameNr_restoreGeometry 45966
#define sipName_restoreGeometry &sipStrings_QtGui[45966]
#define sipNameNr_keyboardGrabber 45982
#define sipName_keyboardGrabber &sipStrings_QtGui[45982]
#define sipNameNr_releaseKeyboard 45998
#define sipName_releaseKeyboard &sipStrings_QtGui[45998]
#define sipNameNr_inWhatsThisMode 46014
#define sipName_inWhatsThisMode &sipStrings_QtGui[46014]
#define sipNameNr_undoTextChanged 46030
#define sipName_undoTextChanged &sipStrings_QtGui[46030]
#define sipNameNr_redoTextChanged 46046
#define sipName_redoTextChanged &sipStrings_QtGui[46046]
#define sipNameNr_setItemExpanded 46062
#define sipName_setItemExpanded &sipStrings_QtGui[46062]
#define sipNameNr_setHeaderLabels 46078
#define sipName_setHeaderLabels &sipStrings_QtGui[46078]
#define sipNameNr_addTopLevelItem 46094
#define sipName_addTopLevelItem &sipStrings_QtGui[46094]
#define sipNameNr_QTreeWidgetItem 46110
#define sipName_QTreeWidgetItem &sipStrings_QtGui[46110]
#define sipNameNr_setHeaderHidden 46126
#define sipName_setHeaderHidden &sipStrings_QtGui[46126]
#define sipNameNr_autoExpandDelay 46142
#define sipName_autoExpandDelay &sipStrings_QtGui[46142]
#define sipNameNr_itemsExpandable 46158
#define sipName_itemsExpandable &sipStrings_QtGui[46158]
#define sipNameNr_rootIsDecorated 46174
#define sipName_rootIsDecorated &sipStrings_QtGui[46174]
#define sipNameNr_widgetForAction 46190
#define sipName_widgetForAction &sipStrings_QtGui[46190]
#define sipNameNr_firstLineNumber 46206
#define sipName_firstLineNumber &sipStrings_QtGui[46206]
#define sipNameNr_charFormatIndex 46222
#define sipName_charFormatIndex &sipStrings_QtGui[46222]
#define sipNameNr_QTextBlockGroup 46238
#define sipName_QTextBlockGroup &sipStrings_QtGui[46238]
#define sipNameNr_QTextLine__Edge 46254
#define sipName_QTextLine__Edge &sipStrings_QtGui[46254]
#define sipNameNr_naturalTextRect 46270
#define sipName_naturalTextRect &sipStrings_QtGui[46270]
#define sipNameNr_setCacheEnabled 46286
#define sipName_setCacheEnabled &sipStrings_QtGui[46286]
#define sipNameNr_preeditAreaText 46302
#define sipName_preeditAreaText &sipStrings_QtGui[46302]
#define sipNameNr_setRightPadding 46318
#define sipName_setRightPadding &sipStrings_QtGui[46318]
#define sipNameNr_QTextListFormat 46334
#define sipName_QTextListFormat &sipStrings_QtGui[46334]
#define sipNameNr_setTabPositions 46350
#define sipName_setTabPositions &sipStrings_QtGui[46350]
#define sipNameNr_pageBreakPolicy 46366
#define sipName_pageBreakPolicy &sipStrings_QtGui[46366]
#define sipNameNr_setBottomMargin 46382
#define sipName_setBottomMargin &sipStrings_QtGui[46382]
#define sipNameNr_fontWordSpacing 46398
#define sipName_fontWordSpacing &sipStrings_QtGui[46398]
#define sipNameNr_SingleUnderline 46414
#define sipName_SingleUnderline &sipStrings_QtGui[46414]
#define sipNameNr_setFontOverline 46430
#define sipName_setFontOverline &sipStrings_QtGui[46430]
#define sipNameNr_QTextCharFormat 46446
#define sipName_QTextCharFormat &sipStrings_QtGui[46446]
#define sipNameNr_clearForeground 46462
#define sipName_clearForeground &sipStrings_QtGui[46462]
#define sipNameNr_clearBackground 46478
#define sipName_clearBackground &sipStrings_QtGui[46478]
#define sipNameNr_FontWordSpacing 32162
#define sipName_FontWordSpacing &sipStrings_QtGui[32162]
#define sipNameNr_FrameLeftMargin 46494
#define sipName_FrameLeftMargin &sipStrings_QtGui[46494]
#define sipNameNr_PageBreakPolicy 32143
#define sipName_PageBreakPolicy &sipStrings_QtGui[32143]
#define sipNameNr_BlockLeftMargin 46510
#define sipName_BlockLeftMargin &sipStrings_QtGui[46510]
#define sipNameNr_ForegroundBrush 34841
#define sipName_ForegroundBrush &sipStrings_QtGui[34841]
#define sipNameNr_BackgroundBrush 34860
#define sipName_BackgroundBrush &sipStrings_QtGui[34860]
#define sipNameNr_TableCellObject 46526
#define sipName_TableCellObject &sipStrings_QtGui[46526]
#define sipNameNr_FixedPixelWidth 46542
#define sipName_FixedPixelWidth &sipStrings_QtGui[46542]
#define sipNameNr_contentsChanged 46558
#define sipName_contentsChanged &sipStrings_QtGui[46558]
#define sipNameNr_objectForFormat 46574
#define sipName_objectForFormat &sipStrings_QtGui[46574]
#define sipNameNr_metaInformation 46590
#define sipName_metaInformation &sipStrings_QtGui[46590]
#define sipNameNr_MetaInformation 7310
#define sipName_MetaInformation &sipStrings_QtGui[7310]
#define sipNameNr_mightBeRichText 46606
#define sipName_mightBeRichText &sipStrings_QtGui[46606]
#define sipNameNr_HitTestAccuracy 28133
#define sipName_HitTestAccuracy &sipStrings_QtGui[28133]
#define sipNameNr_blockCharFormat 46622
#define sipName_blockCharFormat &sipStrings_QtGui[46622]
#define sipNameNr_mergeCharFormat 46638
#define sipName_mergeCharFormat &sipStrings_QtGui[46638]
#define sipNameNr_LineUnderCursor 46654
#define sipName_LineUnderCursor &sipStrings_QtGui[46654]
#define sipNameNr_WordUnderCursor 46670
#define sipName_WordUnderCursor &sipStrings_QtGui[46670]
#define sipNameNr_rowCountChanged 46686
#define sipName_rowCountChanged &sipStrings_QtGui[46686]
#define sipNameNr_setColumnHidden 46702
#define sipName_setColumnHidden &sipStrings_QtGui[46702]
#define sipNameNr_setTabsClosable 46718
#define sipName_setTabsClosable &sipStrings_QtGui[46718]
#define sipNameNr_tabLayoutChange 46734
#define sipName_tabLayoutChange &sipStrings_QtGui[46734]
#define sipNameNr_setTabWhatsThis 46750
#define sipName_setTabWhatsThis &sipStrings_QtGui[46750]
#define sipNameNr_setTabTextColor 46766
#define sipName_setTabTextColor &sipStrings_QtGui[46766]
#define sipNameNr_TriangularSouth 46782
#define sipName_TriangularSouth &sipStrings_QtGui[46782]
#define sipNameNr_TriangularNorth 46798
#define sipName_TriangularNorth &sipStrings_QtGui[46798]
#define sipNameNr_QSystemTrayIcon 46814
#define sipName_QSystemTrayIcon &sipStrings_QtGui[46814]
#define sipNameNr_rightButtonSize 46830
#define sipName_rightButtonSize &sipStrings_QtGui[46830]
#define sipNameNr_ViewItemFeature 1949
#define sipName_ViewItemFeature &sipStrings_QtGui[1949]
#define sipNameNr_ToolBarFeatures 3541
#define sipName_ToolBarFeatures &sipStrings_QtGui[3541]
#define sipNameNr_ToolBarPosition 3578
#define sipName_ToolBarPosition &sipStrings_QtGui[3578]
#define sipNameNr_MenuButtonPopup 46846
#define sipName_MenuButtonPopup &sipStrings_QtGui[46846]
#define sipNameNr_NoCornerWidgets 46862
#define sipName_NoCornerWidgets &sipStrings_QtGui[46862]
#define sipNameNr_QStyleOptionTab 46878
#define sipName_QStyleOptionTab &sipStrings_QtGui[46878]
#define sipNameNr_SectionPosition 4201
#define sipName_SectionPosition &sipStrings_QtGui[4201]
#define sipNameNr_selectedTabRect 46894
#define sipName_selectedTabRect &sipStrings_QtGui[46894]
#define sipNameNr_StyleOptionType 487
#define sipName_StyleOptionType &sipStrings_QtGui[487]
#define sipNameNr_SO_GraphicsItem 46910
#define sipName_SO_GraphicsItem &sipStrings_QtGui[46910]
#define sipNameNr_SO_Q3DockWindow 46926
#define sipName_SO_Q3DockWindow &sipStrings_QtGui[46926]
#define sipNameNr_visualAlignment 46942
#define sipName_visualAlignment &sipStrings_QtGui[46942]
#define sipNameNr_SP_ArrowForward 46958
#define sipName_SP_ArrowForward &sipStrings_QtGui[46958]
#define sipNameNr_SP_FileLinkIcon 46974
#define sipName_SP_FileLinkIcon &sipStrings_QtGui[46974]
#define sipNameNr_SP_DriveNetIcon 46990
#define sipName_SP_DriveNetIcon &sipStrings_QtGui[46990]
#define sipNameNr_SP_DriveDVDIcon 47006
#define sipName_SP_DriveDVDIcon &sipStrings_QtGui[47006]
#define sipNameNr_SP_ComputerIcon 47022
#define sipName_SP_ComputerIcon &sipStrings_QtGui[47022]
#define sipNameNr_SH_ToolTip_Mask 47038
#define sipName_SH_ToolTip_Mask &sipStrings_QtGui[47038]
#define sipNameNr_CT_ItemViewItem 47054
#define sipName_CT_ItemViewItem &sipStrings_QtGui[47054]
#define sipNameNr_CT_Q3DockWindow 47070
#define sipName_CT_Q3DockWindow &sipStrings_QtGui[47070]
#define sipNameNr_PM_SizeGripSize 47086
#define sipName_PM_SizeGripSize &sipStrings_QtGui[47086]
#define sipNameNr_PM_HeaderMargin 47102
#define sipName_PM_HeaderMargin &sipStrings_QtGui[47102]
#define sipNameNr_PM_SliderLength 47118
#define sipName_PM_SliderLength &sipStrings_QtGui[47118]
#define sipNameNr_PM_ButtonMargin 47134
#define sipName_PM_ButtonMargin &sipStrings_QtGui[47134]
#define sipNameNr_SC_MdiMinButton 47150
#define sipName_SC_MdiMinButton &sipStrings_QtGui[47150]
#define sipNameNr_SC_SliderHandle 47166
#define sipName_SC_SliderHandle &sipStrings_QtGui[47166]
#define sipNameNr_SC_SliderGroove 47182
#define sipName_SC_SliderGroove &sipStrings_QtGui[47182]
#define sipNameNr_SC_SpinBoxFrame 47198
#define sipName_SC_SpinBoxFrame &sipStrings_QtGui[47198]
#define sipNameNr_CE_ItemViewItem 47214
#define sipName_CE_ItemViewItem &sipStrings_QtGui[47214]
#define sipNameNr_CE_MenuScroller 47230
#define sipName_CE_MenuScroller &sipStrings_QtGui[47230]
#define sipNameNr_PE_PanelToolBar 47246
#define sipName_PE_PanelToolBar &sipStrings_QtGui[47246]
#define sipNameNr_PE_PanelMenuBar 47262
#define sipName_PE_PanelMenuBar &sipStrings_QtGui[47262]
#define sipNameNr_State_MouseOver 47278
#define sipName_State_MouseOver &sipStrings_QtGui[47278]
#define sipNameNr_State_AutoRaise 47294
#define sipName_State_AutoRaise &sipStrings_QtGui[47294]
#define sipNameNr_State_DownArrow 47310
#define sipName_State_DownArrow &sipStrings_QtGui[47310]
#define sipNameNr_standardPalette 47326
#define sipName_standardPalette &sipStrings_QtGui[47326]
#define sipNameNr_emitDataChanged 47342
#define sipName_emitDataChanged &sipStrings_QtGui[47342]
#define sipNameNr_setStackingMode 47358
#define sipName_setStackingMode &sipStrings_QtGui[47358]
#define sipNameNr_QSplitterHandle 47374
#define sipName_QSplitterHandle &sipStrings_QtGui[47374]
#define sipNameNr_setOpaqueResize 47390
#define sipName_setOpaqueResize &sipStrings_QtGui[47390]
#define sipNameNr_filterKeyColumn 47406
#define sipName_filterKeyColumn &sipStrings_QtGui[47406]
#define sipNameNr_setFilterRegExp 47422
#define sipName_setFilterRegExp &sipStrings_QtGui[47422]
#define sipNameNr_setTickInterval 47438
#define sipName_setTickInterval &sipStrings_QtGui[47438]
#define sipNameNr_setTickPosition 47454
#define sipName_setTickPosition &sipStrings_QtGui[47454]
#define sipNameNr_verticalStretch 47470
#define sipName_verticalStretch &sipStrings_QtGui[47470]
#define sipNameNr_QSessionManager 47486
#define sipName_QSessionManager &sipStrings_QtGui[47486]
#define sipNameNr_widgetResizable 47502
#define sipName_widgetResizable &sipStrings_QtGui[47502]
#define sipNameNr_minimumDuration 47518
#define sipName_minimumDuration &sipStrings_QtGui[47518]
#define sipNameNr_setCancelButton 47534
#define sipName_setCancelButton &sipStrings_QtGui[47534]
#define sipNameNr_QProgressDialog 47550
#define sipName_QProgressDialog &sipStrings_QtGui[47550]
#define sipNameNr_FacingPagesView 47566
#define sipName_FacingPagesView &sipStrings_QtGui[47566]
#define sipNameNr_PPK_PageMargins 47582
#define sipName_PPK_PageMargins &sipStrings_QtGui[47582]
#define sipNameNr_PPK_PrinterName 47598
#define sipName_PPK_PrinterName &sipStrings_QtGui[47598]
#define sipNameNr_PPK_PaperSource 47614
#define sipName_PPK_PaperSource &sipStrings_QtGui[47614]
#define sipNameNr_PPK_Orientation 47630
#define sipName_PPK_Orientation &sipStrings_QtGui[47630]
#define sipNameNr_setOutputFormat 47646
#define sipName_setOutputFormat &sipStrings_QtGui[47646]
#define sipNameNr_setPrintProgram 47662
#define sipName_setPrintProgram &sipStrings_QtGui[47662]
#define sipNameNr_DuplexShortSide 47678
#define sipName_DuplexShortSide &sipStrings_QtGui[47678]
#define sipNameNr_getPaintContext 47694
#define sipName_getPaintContext &sipStrings_QtGui[47694]
#define sipNameNr_appendPlainText 47710
#define sipName_appendPlainText &sipStrings_QtGui[47710]
#define sipNameNr_insertPlainText 47726
#define sipName_insertPlainText &sipStrings_QtGui[47726]
#define sipNameNr_extraSelections 47742
#define sipName_extraSelections &sipStrings_QtGui[47742]
#define sipNameNr_setTabStopWidth 47758
#define sipName_setTabStopWidth &sipStrings_QtGui[47758]
#define sipNameNr_setWordWrapMode 47774
#define sipName_setWordWrapMode &sipStrings_QtGui[47774]
#define sipNameNr_setLineWrapMode 47790
#define sipName_setLineWrapMode &sipStrings_QtGui[47790]
#define sipNameNr_defineIOHandler 47806
#define sipName_defineIOHandler &sipStrings_QtGui[47806]
#define sipNameNr_inputFormatList 47822
#define sipName_inputFormatList &sipStrings_QtGui[47822]
#define sipNameNr_setBoundingRect 47838
#define sipName_setBoundingRect &sipStrings_QtGui[47838]
#define sipNameNr_highlightedText 47854
#define sipName_highlightedText &sipStrings_QtGui[47854]
#define sipNameNr_HighlightedText 47870
#define sipName_HighlightedText &sipStrings_QtGui[47870]
#define sipNameNr_percentAtLength 47886
#define sipName_percentAtLength &sipStrings_QtGui[47886]
#define sipNameNr_currentPosition 47902
#define sipName_currentPosition &sipStrings_QtGui[47902]
#define sipNameNr_PolygonDrawMode 8625
#define sipName_PolygonDrawMode &sipStrings_QtGui[8625]
#define sipNameNr_DirtyClipRegion 47918
#define sipName_DirtyClipRegion &sipStrings_QtGui[47918]
#define sipNameNr_DirtyBackground 47934
#define sipName_DirtyBackground &sipStrings_QtGui[47934]
#define sipNameNr_ConstantOpacity 47950
#define sipName_ConstantOpacity &sipStrings_QtGui[47950]
#define sipNameNr_PixmapTransform 22529
#define sipName_PixmapTransform &sipStrings_QtGui[22529]
#define sipNameNr_PdmPhysicalDpiY 47966
#define sipName_PdmPhysicalDpiY &sipStrings_QtGui[47966]
#define sipNameNr_PdmPhysicalDpiX 47982
#define sipName_PdmPhysicalDpiX &sipStrings_QtGui[47982]
#define sipNameNr_drawRoundedRect 47998
#define sipName_drawRoundedRect &sipStrings_QtGui[47998]
#define sipNameNr_drawTiledPixmap 48014
#define sipName_drawTiledPixmap &sipStrings_QtGui[48014]
#define sipNameNr_compositionMode 48030
#define sipName_compositionMode &sipStrings_QtGui[48030]
#define sipNameNr_CompositionMode 13541
#define sipName_CompositionMode &sipStrings_QtGui[13541]
#define sipNameNr_jumpToNextFrame 48046
#define sipName_jumpToNextFrame &sipStrings_QtGui[48046]
#define sipNameNr_setDetailedText 48062
#define sipName_setDetailedText &sipStrings_QtGui[48062]
#define sipNameNr_informativeText 48078
#define sipName_informativeText &sipStrings_QtGui[48078]
#define sipNameNr_setEscapeButton 48094
#define sipName_setEscapeButton &sipStrings_QtGui[48094]
#define sipNameNr_setActiveAction 48110
#define sipName_setActiveAction &sipStrings_QtGui[48110]
#define sipNameNr_hideTearOffMenu 48126
#define sipName_hideTearOffMenu &sipStrings_QtGui[48126]
#define sipNameNr_aboutToActivate 48142
#define sipName_aboutToActivate &sipStrings_QtGui[48142]
#define sipNameNr_SubWindowOption 7713
#define sipName_SubWindowOption &sipStrings_QtGui[7713]
#define sipNameNr_activationOrder 48158
#define sipName_activationOrder &sipStrings_QtGui[48158]
#define sipNameNr_removeSubWindow 48174
#define sipName_removeSubWindow &sipStrings_QtGui[48174]
#define sipNameNr_activeSubWindow 48190
#define sipName_activeSubWindow &sipStrings_QtGui[48190]
#define sipNameNr_setDocumentMode 48206
#define sipName_setDocumentMode &sipStrings_QtGui[48206]
#define sipNameNr_iconSizeChanged 48222
#define sipName_iconSizeChanged &sipStrings_QtGui[48222]
#define sipNameNr_createPopupMenu 48238
#define sipName_createPopupMenu &sipStrings_QtGui[48238]
#define sipNameNr_splitDockWidget 48254
#define sipName_splitDockWidget &sipStrings_QtGui[48254]
#define sipNameNr_addToolBarBreak 48270
#define sipName_addToolBarBreak &sipStrings_QtGui[48270]
#define sipNameNr_toolButtonStyle 48286
#define sipName_toolButtonStyle &sipStrings_QtGui[48286]
#define sipNameNr_setItemSelected 48302
#define sipName_setItemSelected &sipStrings_QtGui[48302]
#define sipNameNr_QListWidgetItem 48318
#define sipName_QListWidgetItem &sipStrings_QtGui[48318]
#define sipNameNr_QListView__Flow 48334
#define sipName_QListView__Flow &sipStrings_QtGui[48334]
#define sipNameNr_isRedoAvailable 48350
#define sipName_isRedoAvailable &sipStrings_QtGui[48350]
#define sipNameNr_isUndoAvailable 48366
#define sipName_isUndoAvailable &sipStrings_QtGui[48366]
#define sipNameNr_hasSelectedText 48382
#define sipName_hasSelectedText &sipStrings_QtGui[48382]
#define sipNameNr_setSegmentStyle 48398
#define sipName_setSegmentStyle &sipStrings_QtGui[48398]
#define sipNameNr_SetNoConstraint 48414
#define sipName_SetNoConstraint &sipStrings_QtGui[48414]
#define sipNameNr_DeleteEndOfLine 48430
#define sipName_DeleteEndOfLine &sipStrings_QtGui[48430]
#define sipNameNr_DeleteEndOfWord 48446
#define sipName_DeleteEndOfWord &sipStrings_QtGui[48446]
#define sipNameNr_SelectEndOfLine 48462
#define sipName_SelectEndOfLine &sipStrings_QtGui[48462]
#define sipNameNr_MoveToEndOfLine 48478
#define sipName_MoveToEndOfLine &sipStrings_QtGui[48478]
#define sipNameNr_intValueChanged 48494
#define sipName_intValueChanged &sipStrings_QtGui[48494]
#define sipNameNr_setOkButtonText 48510
#define sipName_setOkButtonText &sipStrings_QtGui[48510]
#define sipNameNr_setTextEchoMode 48526
#define sipName_setTextEchoMode &sipStrings_QtGui[48526]
#define sipNameNr_SelectionFormat 48542
#define sipName_SelectionFormat &sipStrings_QtGui[48542]
#define sipNameNr_widgetDestroyed 48558
#define sipName_widgetDestroyed &sipStrings_QtGui[48558]
#define sipNameNr_backgroundColor 48574
#define sipName_backgroundColor &sipStrings_QtGui[48574]
#define sipNameNr_jumpToNextImage 48590
#define sipName_jumpToNextImage &sipStrings_QtGui[48590]
#define sipNameNr_BackgroundColor 18661
#define sipName_BackgroundColor &sipStrings_QtGui[18661]
#define sipNameNr_QImageIOHandler 48606
#define sipName_QImageIOHandler &sipStrings_QtGui[48606]
#define sipNameNr_createAlphaMask 48622
#define sipName_createAlphaMask &sipStrings_QtGui[48622]
#define sipNameNr_setAlphaChannel 48638
#define sipName_setAlphaChannel &sipStrings_QtGui[48638]
#define sipNameNr_hasAlphaChannel 48654
#define sipName_hasAlphaChannel &sipStrings_QtGui[48654]
#define sipNameNr_convertToFormat 48670
#define sipName_convertToFormat &sipStrings_QtGui[48670]
#define sipNameNr_Format_Indexed8 48686
#define sipName_Format_Indexed8 &sipStrings_QtGui[48686]
#define sipNameNr_selectedColumns 48702
#define sipName_selectedColumns &sipStrings_QtGui[48702]
#define sipNameNr_isSectionHidden 48718
#define sipName_isSectionHidden &sipStrings_QtGui[48718]
#define sipNameNr_sectionPosition 48734
#define sipName_sectionPosition &sipStrings_QtGui[48734]
#define sipNameNr_sectionSizeHint 48750
#define sipName_sectionSizeHint &sipStrings_QtGui[48750]
#define sipNameNr_setOriginCorner 48766
#define sipName_setOriginCorner &sipStrings_QtGui[48766]
#define sipNameNr_DontClipPainter 48782
#define sipName_DontClipPainter &sipStrings_QtGui[48782]
#define sipNameNr_updateSceneRect 48798
#define sipName_updateSceneRect &sipStrings_QtGui[48798]
#define sipNameNr_invalidateScene 48814
#define sipName_invalidateScene &sipStrings_QtGui[48814]
#define sipNameNr_setResizeAnchor 48830
#define sipName_setResizeAnchor &sipStrings_QtGui[48830]
#define sipNameNr_CacheBackground 48846
#define sipName_CacheBackground &sipStrings_QtGui[48846]
#define sipNameNr_releaseShortcut 48862
#define sipName_releaseShortcut &sipStrings_QtGui[48862]
#define sipNameNr_windowFrameRect 48878
#define sipName_windowFrameRect &sipStrings_QtGui[48878]
#define sipNameNr_setBspTreeDepth 48894
#define sipName_setBspTreeDepth &sipStrings_QtGui[48894]
#define sipNameNr_ForegroundLayer 48910
#define sipName_ForegroundLayer &sipStrings_QtGui[48910]
#define sipNameNr_BackgroundLayer 48926
#define sipName_BackgroundLayer &sipStrings_QtGui[48926]
#define sipNameNr_foregroundBrush 48942
#define sipName_foregroundBrush &sipStrings_QtGui[48942]
#define sipNameNr_backgroundBrush 48958
#define sipName_backgroundBrush &sipStrings_QtGui[48958]
#define sipNameNr_createItemGroup 48974
#define sipName_createItemGroup &sipStrings_QtGui[48974]
#define sipNameNr_itemIndexMethod 48990
#define sipName_itemIndexMethod &sipStrings_QtGui[48990]
#define sipNameNr_ItemIndexMethod 6898
#define sipName_ItemIndexMethod &sipStrings_QtGui[6898]
#define sipNameNr_QGraphicsWidget 49006
#define sipName_QGraphicsWidget &sipStrings_QtGui[49006]
#define sipNameNr_setGraphicsItem 49022
#define sipName_setGraphicsItem &sipStrings_QtGui[49022]
#define sipNameNr_preferredHeight 49038
#define sipName_preferredHeight &sipStrings_QtGui[49038]
#define sipNameNr_setMaximumWidth 49054
#define sipName_setMaximumWidth &sipStrings_QtGui[49054]
#define sipNameNr_setMinimumWidth 49070
#define sipName_setMinimumWidth &sipStrings_QtGui[49070]
#define sipNameNr_translationList 49086
#define sipName_translationList &sipStrings_QtGui[49086]
#define sipNameNr_verticalShearAt 49102
#define sipName_verticalShearAt &sipStrings_QtGui[49102]
#define sipNameNr_verticalScaleAt 49118
#define sipName_verticalScaleAt &sipStrings_QtGui[49118]
#define sipNameNr_removeFromGroup 49134
#define sipName_removeFromGroup &sipStrings_QtGui[49134]
#define sipNameNr_tabChangesFocus 49150
#define sipName_tabChangesFocus &sipStrings_QtGui[49150]
#define sipNameNr_mapRectFromItem 49166
#define sipName_mapRectFromItem &sipStrings_QtGui[49166]
#define sipNameNr_mapRectToParent 49182
#define sipName_mapRectToParent &sipStrings_QtGui[49182]
#define sipNameNr_deviceTransform 49198
#define sipName_deviceTransform &sipStrings_QtGui[49198]
#define sipNameNr_hoverLeaveEvent 49214
#define sipName_hoverLeaveEvent &sipStrings_QtGui[49214]
#define sipNameNr_hoverEnterEvent 49230
#define sipName_hoverEnterEvent &sipStrings_QtGui[49230]
#define sipNameNr_ItemIsFocusable 49246
#define sipName_ItemIsFocusable &sipStrings_QtGui[49246]
#define sipNameNr_ItemFlagsChange 49262
#define sipName_ItemFlagsChange &sipStrings_QtGui[49262]
#define sipNameNr_ItemSceneChange 49278
#define sipName_ItemSceneChange &sipStrings_QtGui[49278]
#define sipNameNr_columnAlignment 49294
#define sipName_columnAlignment &sipStrings_QtGui[49294]
#define sipNameNr_setRowAlignment 49310
#define sipName_setRowAlignment &sipStrings_QtGui[49310]
#define sipNameNr_QGraphicsLayout 49326
#define sipName_QGraphicsLayout &sipStrings_QtGui[49326]
#define sipNameNr_setMidLineWidth 49342
#define sipName_setMidLineWidth &sipStrings_QtGui[49342]
#define sipNameNr_getItemPosition 49358
#define sipName_getItemPosition &sipStrings_QtGui[49358]
#define sipNameNr_verticalSpacing 49374
#define sipName_verticalSpacing &sipStrings_QtGui[49374]
#define sipNameNr_minRightBearing 49390
#define sipName_minRightBearing &sipStrings_QtGui[49390]
#define sipNameNr_MonospacedFonts 49406
#define sipName_MonospacedFonts &sipStrings_QtGui[49406]
#define sipNameNr_AbsoluteSpacing 49422
#define sipName_AbsoluteSpacing &sipStrings_QtGui[49422]
#define sipNameNr_cacheStatistics 49438
#define sipName_cacheStatistics &sipStrings_QtGui[49438]
#define sipNameNr_PreferAntialias 49454
#define sipName_PreferAntialias &sipStrings_QtGui[49454]
#define sipNameNr_rootPathChanged 49470
#define sipName_rootPathChanged &sipStrings_QtGui[49470]
#define sipNameNr_FilePermissions 49486
#define sipName_FilePermissions &sipStrings_QtGui[49486]
#define sipNameNr_getSaveFileName 49502
#define sipName_getSaveFileName &sipStrings_QtGui[49502]
#define sipNameNr_getOpenFileName 49518
#define sipName_getOpenFileName &sipStrings_QtGui[49518]
#define sipNameNr_QStatusTipEvent 49534
#define sipName_QStatusTipEvent &sipStrings_QtGui[49534]
#define sipNameNr_QDragLeaveEvent 49550
#define sipName_QDragLeaveEvent &sipStrings_QtGui[49550]
#define sipNameNr_QDragEnterEvent 49566
#define sipName_QDragEnterEvent &sipStrings_QtGui[49566]
#define sipNameNr_possibleActions 49582
#define sipName_possibleActions &sipStrings_QtGui[49582]
#define sipNameNr_setCommitString 49598
#define sipName_setCommitString &sipStrings_QtGui[49598]
#define sipNameNr_nativeModifiers 49614
#define sipName_nativeModifiers &sipStrings_QtGui[49614]
#define sipNameNr_hasExtendedInfo 49630
#define sipName_hasExtendedInfo &sipStrings_QtGui[49630]
#define sipNameNr_qDrawShadePanel 49646
#define sipName_qDrawShadePanel &sipStrings_QtGui[49646]
#define sipNameNr_topLevelChanged 49662
#define sipName_topLevelChanged &sipStrings_QtGui[49662]
#define sipNameNr_featuresChanged 49678
#define sipName_featuresChanged &sipStrings_QtGui[49678]
#define sipNameNr_setAllowedAreas 49694
#define sipName_setAllowedAreas &sipStrings_QtGui[49694]
#define sipNameNr_resolveSymlinks 49710
#define sipName_resolveSymlinks &sipStrings_QtGui[49710]
#define sipNameNr_setIconProvider 49726
#define sipName_setIconProvider &sipStrings_QtGui[49726]
#define sipNameNr_standardButtons 49742
#define sipName_standardButtons &sipStrings_QtGui[49742]
#define sipNameNr_StandardButtons 5592
#define sipName_StandardButtons &sipStrings_QtGui[5592]
#define sipNameNr_RestoreDefaults 49758
#define sipName_RestoreDefaults &sipStrings_QtGui[49758]
#define sipNameNr_DestructiveRole 49774
#define sipName_DestructiveRole &sipStrings_QtGui[49774]
#define sipNameNr_workAreaResized 49790
#define sipName_workAreaResized &sipStrings_QtGui[49790]
#define sipNameNr_storageLocation 49806
#define sipName_storageLocation &sipStrings_QtGui[49806]
#define sipNameNr_unsetUrlHandler 49822
#define sipName_unsetUrlHandler &sipStrings_QtGui[49822]
#define sipNameNr_DesktopLocation 49838
#define sipName_DesktopLocation &sipStrings_QtGui[49838]
#define sipNameNr_maximumDateTime 49854
#define sipName_maximumDateTime &sipStrings_QtGui[49854]
#define sipNameNr_minimumDateTime 49870
#define sipName_minimumDateTime &sipStrings_QtGui[49870]
#define sipNameNr_dateTimeChanged 49886
#define sipName_dateTimeChanged &sipStrings_QtGui[49886]
#define sipNameNr_setSubmitPolicy 49902
#define sipName_setSubmitPolicy &sipStrings_QtGui[49902]
#define sipNameNr_completionModel 49918
#define sipName_completionModel &sipStrings_QtGui[49918]
#define sipNameNr_completionCount 49934
#define sipName_completionCount &sipStrings_QtGui[49934]
#define sipNameNr_setModelSorting 49950
#define sipName_setModelSorting &sipStrings_QtGui[49950]
#define sipNameNr_PopupCompletion 13931
#define sipName_PopupCompletion &sipStrings_QtGui[13931]
#define sipNameNr_editTextChanged 49966
#define sipName_editTextChanged &sipStrings_QtGui[49966]
#define sipNameNr_insertSeparator 49982
#define sipName_insertSeparator &sipStrings_QtGui[49982]
#define sipNameNr_setInsertPolicy 49998
#define sipName_setInsertPolicy &sipStrings_QtGui[49998]
#define sipNameNr_InsertAtCurrent 50014
#define sipName_InsertAtCurrent &sipStrings_QtGui[50014]
#define sipNameNr_maxVisibleItems 50030
#define sipName_maxVisibleItems &sipStrings_QtGui[50030]
#define sipNameNr_setCurrentColor 50046
#define sipName_setCurrentColor &sipStrings_QtGui[50046]
#define sipNameNr_setColumnWidths 50062
#define sipName_setColumnWidths &sipStrings_QtGui[50062]
#define sipNameNr_setSelectedDate 50078
#define sipName_setSelectedDate &sipStrings_QtGui[50078]
#define sipNameNr_isHeaderVisible 50094
#define sipName_isHeaderVisible &sipStrings_QtGui[50094]
#define sipNameNr_QCalendarWidget 50110
#define sipName_QCalendarWidget &sipStrings_QtGui[50110]
#define sipNameNr_QRadialGradient 50126
#define sipName_QRadialGradient &sipStrings_QtGui[50126]
#define sipNameNr_QLinearGradient 50142
#define sipName_QLinearGradient &sipStrings_QtGui[50142]
#define sipNameNr_ConicalGradient 45029
#define sipName_ConicalGradient &sipStrings_QtGui[45029]
#define sipNameNr_QGradient__Type 50158
#define sipName_QGradient__Type &sipStrings_QtGui[50158]
#define sipNameNr_setTextureImage 50174
#define sipName_setTextureImage &sipStrings_QtGui[50174]
#define sipNameNr_closeAllWindows 50190
#define sipName_closeAllWindows &sipStrings_QtGui[50190]
#define sipNameNr_setInputContext 36294
#define sipName_setInputContext &sipStrings_QtGui[36294]
#define sipNameNr_x11ProcessEvent 50206
#define sipName_x11ProcessEvent &sipStrings_QtGui[50206]
#define sipNameNr_isEffectEnabled 50222
#define sipName_isEffectEnabled &sipStrings_QtGui[50222]
#define sipNameNr_layoutDirection 50238
#define sipName_layoutDirection &sipStrings_QtGui[50238]
#define sipNameNr_cursorFlashTime 50254
#define sipName_cursorFlashTime &sipStrings_QtGui[50254]
#define sipNameNr_setActiveWindow 50270
#define sipName_setActiveWindow &sipStrings_QtGui[50270]
#define sipNameNr_topLevelWidgets 50286
#define sipName_topLevelWidgets &sipStrings_QtGui[50286]
#define sipNameNr_PreferencesRole 50302
#define sipName_PreferencesRole &sipStrings_QtGui[50302]
#define sipNameNr_shortcutContext 50318
#define sipName_shortcutContext &sipStrings_QtGui[50318]
#define sipNameNr_setRepeatAction 50334
#define sipName_setRepeatAction &sipStrings_QtGui[50334]
#define sipNameNr_actionTriggered 50350
#define sipName_actionTriggered &sipStrings_QtGui[50350]
#define sipNameNr_SliderToMaximum 50366
#define sipName_SliderToMaximum &sipStrings_QtGui[50366]
#define sipNameNr_SliderToMinimum 50382
#define sipName_SliderToMinimum &sipStrings_QtGui[50382]
#define sipNameNr_QAbstractSlider 50398
#define sipName_QAbstractSlider &sipStrings_QtGui[50398]
#define sipNameNr_documentChanged 50414
#define sipName_documentChanged &sipStrings_QtGui[50414]
#define sipNameNr_registerHandler 50430
#define sipName_registerHandler &sipStrings_QtGui[50430]
#define sipNameNr_initStyleOption 50446
#define sipName_initStyleOption &sipStrings_QtGui[50446]
#define sipNameNr_editingFinished 50462
#define sipName_editingFinished &sipStrings_QtGui[50462]
#define sipNameNr_StepDownEnabled 50478
#define sipName_StepDownEnabled &sipStrings_QtGui[50478]
#define sipNameNr_StepEnabledFlag 5626
#define sipName_StepEnabledFlag &sipStrings_QtGui[5626]
#define sipNameNr_setCornerWidget 50494
#define sipName_setCornerWidget &sipStrings_QtGui[50494]
#define sipNameNr_minimumSizeHint 50510
#define sipName_minimumSizeHint &sipStrings_QtGui[50510]
#define sipNameNr_isOptionEnabled 50526
#define sipName_isOptionEnabled &sipStrings_QtGui[50526]
#define sipNameNr_setDragDropMode 50542
#define sipName_setDragDropMode &sipStrings_QtGui[50542]
#define sipNameNr_CollapsingState 50558
#define sipName_CollapsingState &sipStrings_QtGui[50558]
#define sipNameNr_selectedIndexes 50574
#define sipName_selectedIndexes &sipStrings_QtGui[50574]
#define sipNameNr_viewportEntered 50590
#define sipName_viewportEntered &sipStrings_QtGui[50590]
#define sipNameNr_editorDestroyed 50606
#define sipName_editorDestroyed &sipStrings_QtGui[50606]
#define sipNameNr_setCurrentIndex 50622
#define sipName_setCurrentIndex &sipStrings_QtGui[50622]
#define sipNameNr_setEditTriggers 50638
#define sipName_setEditTriggers &sipStrings_QtGui[50638]
#define sipNameNr_setItemDelegate 50654
#define sipName_setItemDelegate &sipStrings_QtGui[50654]
#define sipNameNr_SingleSelection 50670
#define sipName_SingleSelection &sipStrings_QtGui[50670]
#define sipNameNr_AllEditTriggers 50686
#define sipName_AllEditTriggers &sipStrings_QtGui[50686]
#define sipNameNr_SelectedClicked 50702
#define sipName_SelectedClicked &sipStrings_QtGui[50702]
#define sipNameNr_sizeHintChanged 50718
#define sipName_sizeHintChanged &sipStrings_QtGui[50718]
#define sipNameNr_mousePressEvent 50734
#define sipName_mousePressEvent &sipStrings_QtGui[50734]
#define sipNameNr_keyReleaseEvent 50750
#define sipName_keyReleaseEvent &sipStrings_QtGui[50750]
#define sipNameNr_autoRepeatDelay 50766
#define sipName_autoRepeatDelay &sipStrings_QtGui[50766]
#define sipNameNr_QAbstractButton 50782
#define sipName_QAbstractButton &sipStrings_QtGui[50782]
#define sipNameNr_caseSensitivity 50798
#define sipName_caseSensitivity &sipStrings_QtGui[50798]
#define sipNameNr_beginRemoveRows 50814
#define sipName_beginRemoveRows &sipStrings_QtGui[50814]
#define sipNameNr_beginInsertRows 50830
#define sipName_beginInsertRows &sipStrings_QtGui[50830]
#define sipNameNr_LayoutDirection 10518
#define sipName_LayoutDirection &sipStrings_QtGui[10518]
#define sipNameNr_50846 50846
#define sipName_50846 &sipStrings_QtGui[50846]
#define sipNameNr_50861 50861
#define sipName_50861 &sipStrings_QtGui[50861]
#define sipNameNr_setAppUserTime 50876
#define sipName_setAppUserTime &sipStrings_QtGui[50876]
#define sipNameNr_containerWinId 50891
#define sipName_containerWinId &sipStrings_QtGui[50891]
#define sipNameNr_initializePage 50906
#define sipName_initializePage &sipStrings_QtGui[50906]
#define sipNameNr_subTitleFormat 50921
#define sipName_subTitleFormat &sipStrings_QtGui[50921]
#define sipNameNr_setTitleFormat 50936
#define sipName_setTitleFormat &sipStrings_QtGui[50936]
#define sipNameNr_setWizardStyle 50951
#define sipName_setWizardStyle &sipStrings_QtGui[50951]
#define sipNameNr_hasVisitedPage 50966
#define sipName_hasVisitedPage &sipStrings_QtGui[50966]
#define sipNameNr_HaveHelpButton 50981
#define sipName_HaveHelpButton &sipStrings_QtGui[50981]
#define sipNameNr_NoCancelButton 50996
#define sipName_NoCancelButton &sipStrings_QtGui[50996]
#define sipNameNr_createdWidgets 51011
#define sipName_createdWidgets &sipStrings_QtGui[51011]
#define sipNameNr_windowFilePath 51026
#define sipName_windowFilePath &sipStrings_QtGui[51026]
#define sipNameNr_effectiveWinId 51041
#define sipName_effectiveWinId &sipStrings_QtGui[51041]
#define sipNameNr_windowModality 51056
#define sipName_windowModality &sipStrings_QtGui[51056]
#define sipNameNr_updatesEnabled 51071
#define sipName_updatesEnabled &sipStrings_QtGui[51071]
#define sipNameNr_isEnabledToTLW 51086
#define sipName_isEnabledToTLW &sipStrings_QtGui[51086]
#define sipNameNr_languageChange 51101
#define sipName_languageChange &sipStrings_QtGui[51101]
#define sipNameNr_focusNextChild 51116
#define sipName_focusNextChild &sipStrings_QtGui[51116]
#define sipNameNr_ensurePolished 51131
#define sipName_ensurePolished &sipStrings_QtGui[51131]
#define sipNameNr_setWindowState 51146
#define sipName_setWindowState &sipStrings_QtGui[51146]
#define sipNameNr_showFullScreen 51161
#define sipName_showFullScreen &sipStrings_QtGui[51161]
#define sipNameNr_activateWindow 51176
#define sipName_activateWindow &sipStrings_QtGui[51176]
#define sipNameNr_accessibleName 51191
#define sipName_accessibleName &sipStrings_QtGui[51191]
#define sipNameNr_windowIconText 51206
#define sipName_windowIconText &sipStrings_QtGui[51206]
#define sipNameNr_foregroundRole 51221
#define sipName_foregroundRole &sipStrings_QtGui[51221]
#define sipNameNr_backgroundRole 51236
#define sipName_backgroundRole &sipStrings_QtGui[51236]
#define sipNameNr_setFixedHeight 51251
#define sipName_setFixedHeight &sipStrings_QtGui[51251]
#define sipNameNr_childrenRegion 51266
#define sipName_childrenRegion &sipStrings_QtGui[51266]
#define sipNameNr_normalGeometry 51281
#define sipName_normalGeometry &sipStrings_QtGui[51281]
#define sipNameNr_canUndoChanged 51296
#define sipName_canUndoChanged &sipStrings_QtGui[51296]
#define sipNameNr_canRedoChanged 51311
#define sipName_canRedoChanged &sipStrings_QtGui[51311]
#define sipNameNr_setActiveStack 51326
#define sipName_setActiveStack &sipStrings_QtGui[51326]
#define sipNameNr_setHeaderLabel 51341
#define sipName_setHeaderLabel &sipStrings_QtGui[51341]
#define sipNameNr_isItemExpanded 51356
#define sipName_isItemExpanded &sipStrings_QtGui[51356]
#define sipNameNr_insertChildren 51371
#define sipName_insertChildren &sipStrings_QtGui[51371]
#define sipNameNr_isHeaderHidden 51386
#define sipName_isHeaderHidden &sipStrings_QtGui[51386]
#define sipNameNr_setIndentation 51401
#define sipName_setIndentation &sipStrings_QtGui[51401]
#define sipNameNr_setItemToolTip 51416
#define sipName_setItemToolTip &sipStrings_QtGui[51416]
#define sipNameNr_setItemEnabled 51431
#define sipName_setItemEnabled &sipStrings_QtGui[51431]
#define sipNameNr_movableChanged 51446
#define sipName_movableChanged &sipStrings_QtGui[51446]
#define sipNameNr_QTextTableCell 51461
#define sipName_QTextTableCell &sipStrings_QtGui[51461]
#define sipNameNr_SuppressColors 51476
#define sipName_SuppressColors &sipStrings_QtGui[51476]
#define sipNameNr_setFrameFormat 51491
#define sipName_setFrameFormat &sipStrings_QtGui[51491]
#define sipNameNr_CursorPosition 12398
#define sipName_CursorPosition &sipStrings_QtGui[12398]
#define sipNameNr_SkipCharacters 51506
#define sipName_SkipCharacters &sipStrings_QtGui[51506]
#define sipNameNr_setPreeditArea 51521
#define sipName_setPreeditArea &sipStrings_QtGui[51521]
#define sipNameNr_setLeftPadding 51536
#define sipName_setLeftPadding &sipStrings_QtGui[51536]
#define sipNameNr_headerRowCount 51551
#define sipName_headerRowCount &sipStrings_QtGui[51551]
#define sipNameNr_setCellPadding 51566
#define sipName_setCellPadding &sipStrings_QtGui[51566]
#define sipNameNr_setCellSpacing 51581
#define sipName_setCellSpacing &sipStrings_QtGui[51581]
#define sipNameNr_setBorderStyle 51596
#define sipName_setBorderStyle &sipStrings_QtGui[51596]
#define sipNameNr_setBorderBrush 51611
#define sipName_setBorderBrush &sipStrings_QtGui[51611]
#define sipNameNr_ListUpperAlpha 51626
#define sipName_ListUpperAlpha &sipStrings_QtGui[51626]
#define sipNameNr_ListLowerAlpha 51641
#define sipName_ListLowerAlpha &sipStrings_QtGui[51641]
#define sipNameNr_setRightMargin 51656
#define sipName_setRightMargin &sipStrings_QtGui[51656]
#define sipNameNr_setFontKerning 51671
#define sipName_setFontKerning &sipStrings_QtGui[51671]
#define sipNameNr_setAnchorNames 51686
#define sipName_setAnchorNames &sipStrings_QtGui[51686]
#define sipNameNr_underlineStyle 51701
#define sipName_underlineStyle &sipStrings_QtGui[51701]
#define sipNameNr_UnderlineStyle 6483
#define sipName_UnderlineStyle &sipStrings_QtGui[6483]
#define sipNameNr_setTextOutline 51716
#define sipName_setTextOutline &sipStrings_QtGui[51716]
#define sipNameNr_fontFixedPitch 51731
#define sipName_fontFixedPitch &sipStrings_QtGui[51731]
#define sipNameNr_underlineColor 51746
#define sipName_underlineColor &sipStrings_QtGui[51746]
#define sipNameNr_AlignSubScript 51761
#define sipName_AlignSubScript &sipStrings_QtGui[51761]
#define sipNameNr_lengthProperty 51776
#define sipName_lengthProperty &sipStrings_QtGui[51776]
#define sipNameNr_stringProperty 51791
#define sipName_stringProperty &sipStrings_QtGui[51791]
#define sipNameNr_doubleProperty 51806
#define sipName_doubleProperty &sipStrings_QtGui[51806]
#define sipNameNr_setObjectIndex 51821
#define sipName_setObjectIndex &sipStrings_QtGui[51821]
#define sipNameNr_FrameTopMargin 51836
#define sipName_FrameTopMargin &sipStrings_QtGui[51836]
#define sipNameNr_FontFixedPitch 36763
#define sipName_FontFixedPitch &sipStrings_QtGui[36763]
#define sipNameNr_BlockTopMargin 51851
#define sipName_BlockTopMargin &sipStrings_QtGui[51851]
#define sipNameNr_BlockAlignment 51866
#define sipName_BlockAlignment &sipStrings_QtGui[51866]
#define sipNameNr_PageBreakFlags 10323
#define sipName_PageBreakFlags &sipStrings_QtGui[10323]
#define sipNameNr_PageBreak_Auto 51881
#define sipName_PageBreak_Auto &sipStrings_QtGui[51881]
#define sipNameNr_VariableLength 51896
#define sipName_VariableLength &sipStrings_QtGui[51896]
#define sipNameNr_scrollToAnchor 51911
#define sipName_scrollToAnchor &sipStrings_QtGui[51911]
#define sipNameNr_acceptRichText 51926
#define sipName_acceptRichText &sipStrings_QtGui[51926]
#define sipNameNr_AutoFormatting 12450
#define sipName_AutoFormatting &sipStrings_QtGui[12450]
#define sipNameNr_AutoBulletList 51941
#define sipName_AutoBulletList &sipStrings_QtGui[51941]
#define sipNameNr_ExtraSelection 12476
#define sipName_ExtraSelection &sipStrings_QtGui[12476]
#define sipNameNr_characterCount 51956
#define sipName_characterCount &sipStrings_QtGui[51956]
#define sipNameNr_documentMargin 51971
#define sipName_documentMargin &sipStrings_QtGui[51971]
#define sipNameNr_setIndentWidth 51986
#define sipName_setIndentWidth &sipStrings_QtGui[51986]
#define sipNameNr_contentsChange 52001
#define sipName_contentsChange &sipStrings_QtGui[52001]
#define sipNameNr_setDefaultFont 52016
#define sipName_setDefaultFont &sipStrings_QtGui[52016]
#define sipNameNr_FindWholeWords 52031
#define sipName_FindWholeWords &sipStrings_QtGui[52031]
#define sipNameNr_documentLayout 52046
#define sipName_documentLayout &sipStrings_QtGui[52046]
#define sipNameNr_WhiteSpaceMode 32315
#define sipName_WhiteSpaceMode &sipStrings_QtGui[32315]
#define sipNameNr_beginEditBlock 52061
#define sipName_beginEditBlock &sipStrings_QtGui[52061]
#define sipNameNr_insertFragment 52076
#define sipName_insertFragment &sipStrings_QtGui[52076]
#define sipNameNr_setBlockFormat 52091
#define sipName_setBlockFormat &sipStrings_QtGui[52091]
#define sipNameNr_historyChanged 52106
#define sipName_historyChanged &sipStrings_QtGui[52106]
#define sipNameNr_selectedRanges 52121
#define sipName_selectedRanges &sipStrings_QtGui[52121]
#define sipNameNr_setCurrentCell 52136
#define sipName_setCurrentCell &sipStrings_QtGui[52136]
#define sipNameNr_isColumnHidden 52151
#define sipName_isColumnHidden &sipStrings_QtGui[52151]
#define sipNameNr_setColumnWidth 52166
#define sipName_setColumnWidth &sipStrings_QtGui[52166]
#define sipNameNr_verticalHeader 52181
#define sipName_verticalHeader &sipStrings_QtGui[52181]
#define sipNameNr_SelectRightTab 52196
#define sipName_SelectRightTab &sipStrings_QtGui[52196]
#define sipNameNr_ButtonPosition 8266
#define sipName_ButtonPosition &sipStrings_QtGui[8266]
#define sipNameNr_TriangularEast 52211
#define sipName_TriangularEast &sipStrings_QtGui[52211]
#define sipNameNr_TriangularWest 52226
#define sipName_TriangularWest &sipStrings_QtGui[52226]
#define sipNameNr_QTabBar__Shape 52241
#define sipName_QTabBar__Shape &sipStrings_QtGui[52241]
#define sipNameNr_messageClicked 52256
#define sipName_messageClicked &sipStrings_QtGui[52256]
#define sipNameNr_setContextMenu 52271
#define sipName_setContextMenu &sipStrings_QtGui[52271]
#define sipNameNr_highlightBlock 52286
#define sipName_highlightBlock &sipStrings_QtGui[52286]
#define sipNameNr_leftButtonSize 52301
#define sipName_leftButtonSize &sipStrings_QtGui[52301]
#define sipNameNr_positionOfLine 52316
#define sipName_positionOfLine &sipStrings_QtGui[52316]
#define sipNameNr_ToolBarFeature 4058
#define sipName_ToolBarFeature &sipStrings_QtGui[4058]
#define sipNameNr_HintReturnType 5726
#define sipName_HintReturnType &sipStrings_QtGui[5726]
#define sipNameNr_decorationSize 52331
#define sipName_decorationSize &sipStrings_QtGui[52331]
#define sipNameNr_ButtonFeatures 748
#define sipName_ButtonFeatures &sipStrings_QtGui[748]
#define sipNameNr_NextIsSelected 52346
#define sipName_NextIsSelected &sipStrings_QtGui[52346]
#define sipNameNr_OnlyOneSection 52361
#define sipName_OnlyOneSection &sipStrings_QtGui[52361]
#define sipNameNr_SO_ProgressBar 52376
#define sipName_SO_ProgressBar &sipStrings_QtGui[52376]
#define sipNameNr_standardPixmap 52391
#define sipName_standardPixmap &sipStrings_QtGui[52391]
#define sipNameNr_SP_MediaVolume 52406
#define sipName_SP_MediaVolume &sipStrings_QtGui[52406]
#define sipNameNr_SP_BrowserStop 52421
#define sipName_SP_BrowserStop &sipStrings_QtGui[52421]
#define sipNameNr_SP_VistaShield 52436
#define sipName_SP_VistaShield &sipStrings_QtGui[52436]
#define sipNameNr_SP_CommandLink 52451
#define sipName_SP_CommandLink &sipStrings_QtGui[52451]
#define sipNameNr_SP_DirHomeIcon 52466
#define sipName_SP_DirHomeIcon &sipStrings_QtGui[52466]
#define sipNameNr_SP_DirLinkIcon 52481
#define sipName_SP_DirLinkIcon &sipStrings_QtGui[52481]
#define sipNameNr_SP_DirOpenIcon 52496
#define sipName_SP_DirOpenIcon &sipStrings_QtGui[52496]
#define sipNameNr_SP_DriveCDIcon 52511
#define sipName_SP_DriveCDIcon &sipStrings_QtGui[52511]
#define sipNameNr_SP_DriveHDIcon 52526
#define sipName_SP_DriveHDIcon &sipStrings_QtGui[52526]
#define sipNameNr_SP_DriveFDIcon 52541
#define sipName_SP_DriveFDIcon &sipStrings_QtGui[52541]
#define sipNameNr_SP_DesktopIcon 52556
#define sipName_SP_DesktopIcon &sipStrings_QtGui[52556]
#define sipNameNr_StandardPixmap 19030
#define sipName_StandardPixmap &sipStrings_QtGui[19030]
#define sipNameNr_SH_WizardStyle 52571
#define sipName_SH_WizardStyle &sipStrings_QtGui[52571]
#define sipNameNr_CT_MdiControls 52586
#define sipName_CT_MdiControls &sipStrings_QtGui[52586]
#define sipNameNr_CT_MenuBarItem 52601
#define sipName_CT_MenuBarItem &sipStrings_QtGui[52601]
#define sipNameNr_CT_ProgressBar 52616
#define sipName_CT_ProgressBar &sipStrings_QtGui[52616]
#define sipNameNr_CT_RadioButton 52631
#define sipName_CT_RadioButton &sipStrings_QtGui[52631]
#define sipNameNr_PM_MenuVMargin 52646
#define sipName_PM_MenuVMargin &sipStrings_QtGui[52646]
#define sipNameNr_PM_MenuHMargin 52661
#define sipName_PM_MenuHMargin &sipStrings_QtGui[52661]
#define sipNameNr_subControlRect 52676
#define sipName_subControlRect &sipStrings_QtGui[52676]
#define sipNameNr_SC_SpinBoxDown 52691
#define sipName_SC_SpinBoxDown &sipStrings_QtGui[52691]
#define sipNameNr_CC_MdiControls 52706
#define sipName_CC_MdiControls &sipStrings_QtGui[52706]
#define sipNameNr_ComplexControl 19329
#define sipName_ComplexControl &sipStrings_QtGui[19329]
#define sipNameNr_subElementRect 52721
#define sipName_subElementRect &sipStrings_QtGui[52721]
#define sipNameNr_SE_HeaderArrow 52736
#define sipName_SE_HeaderArrow &sipStrings_QtGui[52736]
#define sipNameNr_SE_HeaderLabel 52751
#define sipName_SE_HeaderLabel &sipStrings_QtGui[52751]
#define sipNameNr_CE_ShapedFrame 52766
#define sipName_CE_ShapedFrame &sipStrings_QtGui[52766]
#define sipNameNr_CE_HeaderLabel 52781
#define sipName_CE_HeaderLabel &sipStrings_QtGui[52781]
#define sipNameNr_CE_MenuBarItem 52796
#define sipName_CE_MenuBarItem &sipStrings_QtGui[52796]
#define sipNameNr_CE_MenuTearoff 52811
#define sipName_CE_MenuTearoff &sipStrings_QtGui[52811]
#define sipNameNr_CE_MenuHMargin 52826
#define sipName_CE_MenuHMargin &sipStrings_QtGui[52826]
#define sipNameNr_CE_MenuVMargin 52841
#define sipName_CE_MenuVMargin &sipStrings_QtGui[52841]
#define sipNameNr_CE_ProgressBar 52856
#define sipName_CE_ProgressBar &sipStrings_QtGui[52856]
#define sipNameNr_CE_RadioButton 52871
#define sipName_CE_RadioButton &sipStrings_QtGui[52871]
#define sipNameNr_ControlElement 19559
#define sipName_ControlElement &sipStrings_QtGui[19559]
#define sipNameNr_PE_FrameWindow 52886
#define sipName_PE_FrameWindow &sipStrings_QtGui[52886]
#define sipNameNr_PE_Q3Separator 52901
#define sipName_PE_Q3Separator &sipStrings_QtGui[52901]
#define sipNameNr_State_ReadOnly 52916
#define sipName_State_ReadOnly &sipStrings_QtGui[52916]
#define sipNameNr_State_Children 52931
#define sipName_State_Children &sipStrings_QtGui[52931]
#define sipNameNr_State_Selected 52946
#define sipName_State_Selected &sipStrings_QtGui[52946]
#define sipNameNr_State_HasFocus 52961
#define sipName_State_HasFocus &sipStrings_QtGui[52961]
#define sipNameNr_State_NoChange 52976
#define sipName_State_NoChange &sipStrings_QtGui[52976]
#define sipNameNr_drawItemPixmap 52991
#define sipName_drawItemPixmap &sipStrings_QtGui[52991]
#define sipNameNr_itemPixmapRect 53006
#define sipName_itemPixmapRect &sipStrings_QtGui[53006]
#define sipNameNr_currentMessage 53021
#define sipName_currentMessage &sipStrings_QtGui[53021]
#define sipNameNr_setDropEnabled 53036
#define sipName_setDropEnabled &sipStrings_QtGui[53036]
#define sipNameNr_accessibleText 53051
#define sipName_accessibleText &sipStrings_QtGui[53051]
#define sipNameNr_setColumnCount 53066
#define sipName_setColumnCount &sipStrings_QtGui[53066]
#define sipNameNr_QStackedWidget 53081
#define sipName_QStackedWidget &sipStrings_QtGui[53081]
#define sipNameNr_QStackedLayout 53096
#define sipName_QStackedLayout &sipStrings_QtGui[53096]
#define sipNameNr_setHandleWidth 53111
#define sipName_setHandleWidth &sipStrings_QtGui[53111]
#define sipNameNr_setCollapsible 53126
#define sipName_setCollapsible &sipStrings_QtGui[53126]
#define sipNameNr_messageChanged 53141
#define sipName_messageChanged &sipStrings_QtGui[53141]
#define sipNameNr_QDoubleSpinBox 53156
#define sipName_QDoubleSpinBox &sipStrings_QtGui[53156]
#define sipNameNr_loopsRemaining 53171
#define sipName_loopsRemaining &sipStrings_QtGui[53171]
#define sipNameNr_TicksBothSides 53186
#define sipName_TicksBothSides &sipStrings_QtGui[53186]
#define sipNameNr_setControlType 53201
#define sipName_setControlType &sipStrings_QtGui[53201]
#define sipNameNr_verticalPolicy 53216
#define sipName_verticalPolicy &sipStrings_QtGui[53216]
#define sipNameNr_discardCommand 53231
#define sipName_discardCommand &sipStrings_QtGui[53231]
#define sipNameNr_restartCommand 53246
#define sipName_restartCommand &sipStrings_QtGui[53246]
#define sipNameNr_setRestartHint 53261
#define sipName_setRestartHint &sipStrings_QtGui[53261]
#define sipNameNr_setAutoDefault 53276
#define sipName_setAutoDefault &sipStrings_QtGui[53276]
#define sipNameNr_setTextVisible 53291
#define sipName_setTextVisible &sipStrings_QtGui[53291]
#define sipNameNr_previewChanged 53306
#define sipName_previewChanged &sipStrings_QtGui[53306]
#define sipNameNr_SinglePageView 53321
#define sipName_SinglePageView &sipStrings_QtGui[53321]
#define sipNameNr_paintRequested 53336
#define sipName_paintRequested &sipStrings_QtGui[53336]
#define sipNameNr_defaultPrinter 53351
#define sipName_defaultPrinter &sipStrings_QtGui[53351]
#define sipNameNr_PPK_CustomBase 53366
#define sipName_PPK_CustomBase &sipStrings_QtGui[53366]
#define sipNameNr_PPK_Resolution 53381
#define sipName_PPK_Resolution &sipStrings_QtGui[53381]
#define sipNameNr_getPageMargins 53396
#define sipName_getPageMargins &sipStrings_QtGui[53396]
#define sipNameNr_setPageMargins 53411
#define sipName_setPageMargins &sipStrings_QtGui[53411]
#define sipNameNr_setPaperSource 53426
#define sipName_setPaperSource &sipStrings_QtGui[53426]
#define sipNameNr_outputFileName 53441
#define sipName_outputFileName &sipStrings_QtGui[53441]
#define sipNameNr_setPrinterName 53456
#define sipName_setPrinterName &sipStrings_QtGui[53456]
#define sipNameNr_QPrinter__Unit 53471
#define sipName_QPrinter__Unit &sipStrings_QtGui[53471]
#define sipNameNr_DuplexLongSide 53486
#define sipName_DuplexLongSide &sipStrings_QtGui[53486]
#define sipNameNr_EnvelopeManual 53501
#define sipName_EnvelopeManual &sipStrings_QtGui[53501]
#define sipNameNr_FirstPageFirst 53516
#define sipName_FirstPageFirst &sipStrings_QtGui[53516]
#define sipNameNr_HighResolution 53531
#define sipName_HighResolution &sipStrings_QtGui[53531]
#define sipNameNr_setCursorWidth 53546
#define sipName_setCursorWidth &sipStrings_QtGui[53546]
#define sipNameNr_centerOnScroll 53561
#define sipName_centerOnScroll &sipStrings_QtGui[53561]
#define sipNameNr_QPlainTextEdit 53576
#define sipName_QPlainTextEdit &sipStrings_QtGui[53576]
#define sipNameNr_setDashPattern 53591
#define sipName_setDashPattern &sipStrings_QtGui[53591]
#define sipNameNr_curveThreshold 53606
#define sipName_curveThreshold &sipStrings_QtGui[53606]
#define sipNameNr_addRoundedRect 53621
#define sipName_addRoundedRect &sipStrings_QtGui[53621]
#define sipNameNr_slopeAtPercent 53636
#define sipName_slopeAtPercent &sipStrings_QtGui[53636]
#define sipNameNr_angleAtPercent 53651
#define sipName_angleAtPercent &sipStrings_QtGui[53651]
#define sipNameNr_pointAtPercent 53666
#define sipName_pointAtPercent &sipStrings_QtGui[53666]
#define sipNameNr_toFillPolygons 53681
#define sipName_toFillPolygons &sipStrings_QtGui[53681]
#define sipNameNr_CurveToElement 53696
#define sipName_CurveToElement &sipStrings_QtGui[53696]
#define sipNameNr_DirtyTransform 53711
#define sipName_DirtyTransform &sipStrings_QtGui[53711]
#define sipNameNr_paintingActive 53726
#define sipName_paintingActive &sipStrings_QtGui[53726]
#define sipNameNr_testRenderHint 53741
#define sipName_testRenderHint &sipStrings_QtGui[53741]
#define sipNameNr_worldTransform 53756
#define sipName_worldTransform &sipStrings_QtGui[53756]
#define sipNameNr_setWorldMatrix 53771
#define sipName_setWorldMatrix &sipStrings_QtGui[53771]
#define sipNameNr_combinedMatrix 53786
#define sipName_combinedMatrix &sipStrings_QtGui[53786]
#define sipNameNr_setBrushOrigin 53801
#define sipName_setBrushOrigin &sipStrings_QtGui[53801]
#define sipNameNr_backgroundMode 53816
#define sipName_backgroundMode &sipStrings_QtGui[53816]
#define sipNameNr_nextFrameDelay 53831
#define sipName_nextFrameDelay &sipStrings_QtGui[53831]
#define sipNameNr_setNoReplayFor 53846
#define sipName_setNoReplayFor &sipStrings_QtGui[53846]
#define sipNameNr_actionGeometry 53861
#define sipName_actionGeometry &sipStrings_QtGui[53861]
#define sipNameNr_showSystemMenu 53876
#define sipName_showSystemMenu &sipStrings_QtGui[53876]
#define sipNameNr_RubberBandMove 53891
#define sipName_RubberBandMove &sipStrings_QtGui[53891]
#define sipNameNr_tileSubWindows 53906
#define sipName_tileSubWindows &sipStrings_QtGui[53906]
#define sipNameNr_setTabPosition 53921
#define sipName_setTabPosition &sipStrings_QtGui[53921]
#define sipNameNr_setDockOptions 53936
#define sipName_setDockOptions &sipStrings_QtGui[53936]
#define sipNameNr_dockWidgetArea 53951
#define sipName_dockWidgetArea &sipStrings_QtGui[53951]
#define sipNameNr_isItemSelected 53966
#define sipName_isItemSelected &sipStrings_QtGui[53966]
#define sipNameNr_visualItemRect 53981
#define sipName_visualItemRect &sipStrings_QtGui[53981]
#define sipNameNr_setCurrentItem 53996
#define sipName_setCurrentItem &sipStrings_QtGui[53996]
#define sipNameNr_getTextMargins 54011
#define sipName_getTextMargins &sipStrings_QtGui[54011]
#define sipNameNr_setTextMargins 54026
#define sipName_setTextMargins &sipStrings_QtGui[54026]
#define sipNameNr_selectionStart 54041
#define sipName_selectionStart &sipStrings_QtGui[54041]
#define sipNameNr_cursorBackward 54056
#define sipName_cursorBackward &sipStrings_QtGui[54056]
#define sipNameNr_addChildWidget 54071
#define sipName_addChildWidget &sipStrings_QtGui[54071]
#define sipNameNr_addChildLayout 54086
#define sipName_addChildLayout &sipStrings_QtGui[54086]
#define sipNameNr_sizeConstraint 54101
#define sipName_sizeConstraint &sipStrings_QtGui[54101]
#define sipNameNr_SetMaximumSize 54116
#define sipName_SetMaximumSize &sipStrings_QtGui[54116]
#define sipNameNr_SetMinimumSize 54131
#define sipName_SetMinimumSize &sipStrings_QtGui[54131]
#define sipNameNr_SizeConstraint 17478
#define sipName_SizeConstraint &sipStrings_QtGui[17478]
#define sipNameNr_SelectNextPage 54146
#define sipName_SelectNextPage &sipStrings_QtGui[54146]
#define sipNameNr_SelectNextLine 54161
#define sipName_SelectNextLine &sipStrings_QtGui[54161]
#define sipNameNr_SelectNextWord 54176
#define sipName_SelectNextWord &sipStrings_QtGui[54176]
#define sipNameNr_SelectNextChar 54191
#define sipName_SelectNextChar &sipStrings_QtGui[54191]
#define sipNameNr_MoveToNextPage 54206
#define sipName_MoveToNextPage &sipStrings_QtGui[54206]
#define sipNameNr_MoveToNextLine 54221
#define sipName_MoveToNextLine &sipStrings_QtGui[54221]
#define sipNameNr_MoveToNextWord 54236
#define sipName_MoveToNextWord &sipStrings_QtGui[54236]
#define sipNameNr_MoveToNextChar 54251
#define sipName_MoveToNextChar &sipStrings_QtGui[54251]
#define sipNameNr_SequenceFormat 9922
#define sipName_SequenceFormat &sipStrings_QtGui[9922]
#define sipNameNr_drawDecoration 54266
#define sipName_drawDecoration &sipStrings_QtGui[54266]
#define sipNameNr_doubleDecimals 54281
#define sipName_doubleDecimals &sipStrings_QtGui[54281]
#define sipNameNr_setDoubleRange 54296
#define sipName_setDoubleRange &sipStrings_QtGui[54296]
#define sipNameNr_setDoubleValue 54311
#define sipName_setDoubleValue &sipStrings_QtGui[54311]
#define sipNameNr_standardFormat 54326
#define sipName_standardFormat &sipStrings_QtGui[54326]
#define sipNameNr_StandardFormat 8746
#define sipName_StandardFormat &sipStrings_QtGui[8746]
#define sipNameNr_setFocusWidget 54341
#define sipName_setFocusWidget &sipStrings_QtGui[54341]
#define sipNameNr_identifierName 54356
#define sipName_identifierName &sipStrings_QtGui[54356]
#define sipNameNr_setCompression 54371
#define sipName_setCompression &sipStrings_QtGui[54371]
#define sipNameNr_scaledClipRect 54386
#define sipName_scaledClipRect &sipStrings_QtGui[54386]
#define sipNameNr_nextImageDelay 54401
#define sipName_nextImageDelay &sipStrings_QtGui[54401]
#define sipNameNr_supportsOption 54416
#define sipName_supportsOption &sipStrings_QtGui[54416]
#define sipNameNr_ScaledClipRect 38851
#define sipName_ScaledClipRect &sipStrings_QtGui[38851]
#define sipNameNr_scaledToHeight 54431
#define sipName_scaledToHeight &sipStrings_QtGui[54431]
#define sipNameNr_Format_MonoLSB 54446
#define sipName_Format_MonoLSB &sipStrings_QtGui[54446]
#define sipNameNr_Format_Invalid 54461
#define sipName_Format_Invalid &sipStrings_QtGui[54461]
#define sipNameNr_QImage__Format 54476
#define sipName_QImage__Format &sipStrings_QtGui[54476]
#define sipNameNr_QItemSelection 54491
#define sipName_QItemSelection &sipStrings_QtGui[54491]
#define sipNameNr_SelectionFlags 4454
#define sipName_SelectionFlags &sipStrings_QtGui[4454]
#define sipNameNr_ClearAndSelect 54506
#define sipName_ClearAndSelect &sipStrings_QtGui[54506]
#define sipNameNr_defaultFactory 54521
#define sipName_defaultFactory &sipStrings_QtGui[54521]
#define sipNameNr_registerEditor 54536
#define sipName_registerEditor &sipStrings_QtGui[54536]
#define sipNameNr_IconEngineHook 8896
#define sipName_IconEngineHook &sipStrings_QtGui[8896]
#define sipNameNr_availableSizes 54551
#define sipName_availableSizes &sipStrings_QtGui[54551]
#define sipNameNr_sectionEntered 54566
#define sipName_sectionEntered &sipStrings_QtGui[54566]
#define sipNameNr_sectionsHidden 54581
#define sipName_sectionsHidden &sipStrings_QtGui[54581]
#define sipNameNr_resizeSections 54596
#define sipName_resizeSections &sipStrings_QtGui[54596]
#define sipNameNr_sectionClicked 54611
#define sipName_sectionClicked &sipStrings_QtGui[54611]
#define sipNameNr_sectionPressed 54626
#define sipName_sectionPressed &sipStrings_QtGui[54626]
#define sipNameNr_sectionResized 54641
#define sipName_sectionResized &sipStrings_QtGui[54641]
#define sipNameNr_logicalIndexAt 54656
#define sipName_logicalIndexAt &sipStrings_QtGui[54656]
#define sipNameNr_itemAtPosition 54671
#define sipName_itemAtPosition &sipStrings_QtGui[54671]
#define sipNameNr_setInteractive 54686
#define sipName_setInteractive &sipStrings_QtGui[54686]
#define sipNameNr_setRenderHints 54701
#define sipName_setRenderHints &sipStrings_QtGui[54701]
#define sipNameNr_ViewportAnchor 8926
#define sipName_ViewportAnchor &sipStrings_QtGui[8926]
#define sipNameNr_RubberBandDrag 54716
#define sipName_RubberBandDrag &sipStrings_QtGui[54716]
#define sipNameNr_ScrollHandDrag 54731
#define sipName_ScrollHandDrag &sipStrings_QtGui[54731]
#define sipNameNr_propertyChange 54746
#define sipName_propertyChange &sipStrings_QtGui[54746]
#define sipNameNr_setFocusPolicy 54761
#define sipName_setFocusPolicy &sipStrings_QtGui[54761]
#define sipNameNr_setWindowTitle 54776
#define sipName_setWindowTitle &sipStrings_QtGui[54776]
#define sipNameNr_isActiveWindow 54791
#define sipName_isActiveWindow &sipStrings_QtGui[54791]
#define sipNameNr_setWindowFlags 54806
#define sipName_setWindowFlags &sipStrings_QtGui[54806]
#define sipNameNr_setStickyFocus 54821
#define sipName_setStickyFocus &sipStrings_QtGui[54821]
#define sipNameNr_drawForeground 54836
#define sipName_drawForeground &sipStrings_QtGui[54836]
#define sipNameNr_drawBackground 54851
#define sipName_drawBackground &sipStrings_QtGui[54851]
#define sipNameNr_QGraphicsScene 54866
#define sipName_QGraphicsScene &sipStrings_QtGui[54866]
#define sipNameNr_newProxyWidget 54881
#define sipName_newProxyWidget &sipStrings_QtGui[54881]
#define sipNameNr_grabMouseEvent 43789
#define sipName_grabMouseEvent &sipStrings_QtGui[43789]
#define sipNameNr_setItemSpacing 54896
#define sipName_setItemSpacing &sipStrings_QtGui[54896]
#define sipNameNr_preferredWidth 54911
#define sipName_preferredWidth &sipStrings_QtGui[54911]
#define sipNameNr_setMaximumSize 54926
#define sipName_setMaximumSize &sipStrings_QtGui[54926]
#define sipNameNr_setMinimumSize 54941
#define sipName_setMinimumSize &sipStrings_QtGui[54941]
#define sipNameNr_updateGeometry 54956
#define sipName_updateGeometry &sipStrings_QtGui[54956]
#define sipNameNr_yTranslationAt 54971
#define sipName_yTranslationAt &sipStrings_QtGui[54971]
#define sipNameNr_xTranslationAt 54986
#define sipName_xTranslationAt &sipStrings_QtGui[54986]
#define sipNameNr_mapRectToScene 55001
#define sipName_mapRectToScene &sipStrings_QtGui[55001]
#define sipNameNr_boundingRegion 55016
#define sipName_boundingRegion &sipStrings_QtGui[55016]
#define sipNameNr_ungrabKeyboard 55031
#define sipName_ungrabKeyboard &sipStrings_QtGui[55031]
#define sipNameNr_topLevelWidget 55046
#define sipName_topLevelWidget &sipStrings_QtGui[55046]
#define sipNameNr_resetTransform 55061
#define sipName_resetTransform &sipStrings_QtGui[55061]
#define sipNameNr_sceneTransform 55076
#define sipName_sceneTransform &sipStrings_QtGui[55076]
#define sipNameNr_hoverMoveEvent 55091
#define sipName_hoverMoveEvent &sipStrings_QtGui[55091]
#define sipNameNr_collidingItems 55106
#define sipName_collidingItems &sipStrings_QtGui[55106]
#define sipNameNr_setAcceptDrops 55121
#define sipName_setAcceptDrops &sipStrings_QtGui[55121]
#define sipNameNr_setFrameShadow 55136
#define sipName_setFrameShadow &sipStrings_QtGui[55136]
#define sipNameNr_QFrame__Shadow 55151
#define sipName_QFrame__Shadow &sipStrings_QtGui[55151]
#define sipNameNr_labelAlignment 55166
#define sipName_labelAlignment &sipStrings_QtGui[55166]
#define sipNameNr_minLeftBearing 55181
#define sipName_minLeftBearing &sipStrings_QtGui[55181]
#define sipNameNr_writingSystems 55196
#define sipName_writingSystems &sipStrings_QtGui[55196]
#define sipNameNr_setCurrentFont 55211
#define sipName_setCurrentFont &sipStrings_QtGui[55211]
#define sipNameNr_setFontFilters 55226
#define sipName_setFontFilters &sipStrings_QtGui[55226]
#define sipNameNr_capitalization 55241
#define sipName_capitalization &sipStrings_QtGui[55241]
#define sipNameNr_setWordSpacing 55256
#define sipName_setWordSpacing &sipStrings_QtGui[55256]
#define sipNameNr_Capitalization 20880
#define sipName_Capitalization &sipStrings_QtGui[20880]
#define sipNameNr_lastResortFont 55271
#define sipName_lastResortFont &sipStrings_QtGui[55271]
#define sipNameNr_ExtraCondensed 55286
#define sipName_ExtraCondensed &sipStrings_QtGui[55286]
#define sipNameNr_UltraCondensed 55301
#define sipName_UltraCondensed &sipStrings_QtGui[55301]
#define sipNameNr_QFont__Stretch 55316
#define sipName_QFont__Stretch &sipStrings_QtGui[55316]
#define sipNameNr_setSidebarUrls 55331
#define sipName_setSidebarUrls &sipStrings_QtGui[55331]
#define sipNameNr_filterSelected 55346
#define sipName_filterSelected &sipStrings_QtGui[55346]
#define sipNameNr_selectedFilter 55361
#define sipName_selectedFilter &sipStrings_QtGui[55361]
#define sipNameNr_QShortcutEvent 55376
#define sipName_QShortcutEvent &sipStrings_QtGui[55376]
#define sipNameNr_QFileOpenEvent 55391
#define sipName_QFileOpenEvent &sipStrings_QtGui[55391]
#define sipNameNr_QDragMoveEvent 55406
#define sipName_QDragMoveEvent &sipStrings_QtGui[55406]
#define sipNameNr_proposedAction 55421
#define sipName_proposedAction &sipStrings_QtGui[55421]
#define sipNameNr_QIconDragEvent 55436
#define sipName_QIconDragEvent &sipStrings_QtGui[55436]
#define sipNameNr_nativeScanCode 55451
#define sipName_nativeScanCode &sipStrings_QtGui[55451]
#define sipNameNr_hiResGlobalPos 55466
#define sipName_hiResGlobalPos &sipStrings_QtGui[55466]
#define sipNameNr_UnknownPointer 55481
#define sipName_UnknownPointer &sipStrings_QtGui[55481]
#define sipNameNr_RotationStylus 55496
#define sipName_RotationStylus &sipStrings_QtGui[55496]
#define sipNameNr_qDrawPlainRect 55511
#define sipName_qDrawPlainRect &sipStrings_QtGui[55511]
#define sipNameNr_qDrawWinButton 55526
#define sipName_qDrawWinButton &sipStrings_QtGui[55526]
#define sipNameNr_qDrawShadeRect 55541
#define sipName_qDrawShadeRect &sipStrings_QtGui[55541]
#define sipNameNr_qDrawShadeLine 55556
#define sipName_qDrawShadeLine &sipStrings_QtGui[55556]
#define sipNameNr_titleBarWidget 55571
#define sipName_titleBarWidget &sipStrings_QtGui[55571]
#define sipNameNr_lazyChildCount 55586
#define sipName_lazyChildCount &sipStrings_QtGui[55586]
#define sipNameNr_standardButton 55601
#define sipName_standardButton &sipStrings_QtGui[55601]
#define sipNameNr_StandardButton 6254
#define sipName_StandardButton &sipStrings_QtGui[6254]
#define sipNameNr_notchesVisible 55616
#define sipName_notchesVisible &sipStrings_QtGui[55616]
#define sipNameNr_setNotchTarget 55631
#define sipName_setNotchTarget &sipStrings_QtGui[55631]
#define sipNameNr_screenGeometry 55646
#define sipName_screenGeometry &sipStrings_QtGui[55646]
#define sipNameNr_QDesktopWidget 55661
#define sipName_QDesktopWidget &sipStrings_QtGui[55661]
#define sipNameNr_MoviesLocation 55676
#define sipName_MoviesLocation &sipStrings_QtGui[55676]
#define sipNameNr_calendarWidget 55691
#define sipName_calendarWidget &sipStrings_QtGui[55691]
#define sipNameNr_currentSection 55706
#define sipName_currentSection &sipStrings_QtGui[55706]
#define sipNameNr_setMaximumTime 55721
#define sipName_setMaximumTime &sipStrings_QtGui[55721]
#define sipNameNr_setMinimumTime 55736
#define sipName_setMinimumTime &sipStrings_QtGui[55736]
#define sipNameNr_mappedWidgetAt 55751
#define sipName_mappedWidgetAt &sipStrings_QtGui[55751]
#define sipNameNr_completionRole 55766
#define sipName_completionRole &sipStrings_QtGui[55766]
#define sipNameNr_completionMode 55781
#define sipName_completionMode &sipStrings_QtGui[55781]
#define sipNameNr_CompletionMode 12240
#define sipName_CompletionMode &sipStrings_QtGui[12240]
#define sipNameNr_setModelColumn 55796
#define sipName_setModelColumn &sipStrings_QtGui[55796]
#define sipNameNr_rootModelIndex 55811
#define sipName_rootModelIndex &sipStrings_QtGui[55811]
#define sipNameNr_InsertAtBottom 55826
#define sipName_InsertAtBottom &sipStrings_QtGui[55826]
#define sipNameNr_autoCompletion 55841
#define sipName_autoCompletion &sipStrings_QtGui[55841]
#define sipNameNr_setCustomColor 55856
#define sipName_setCustomColor &sipStrings_QtGui[55856]
#define sipNameNr_ownsFindBuffer 55871
#define sipName_ownsFindBuffer &sipStrings_QtGui[55871]
#define sipNameNr_setCurrentPage 55886
#define sipName_setCurrentPage &sipStrings_QtGui[55886]
#define sipNameNr_dateTextFormat 55901
#define sipName_dateTextFormat &sipStrings_QtGui[55901]
#define sipNameNr_setGridVisible 55916
#define sipName_setGridVisible &sipStrings_QtGui[55916]
#define sipNameNr_firstDayOfWeek 55931
#define sipName_firstDayOfWeek &sipStrings_QtGui[55931]
#define sipNameNr_setMaximumDate 55946
#define sipName_setMaximumDate &sipStrings_QtGui[55946]
#define sipNameNr_setMinimumDate 55961
#define sipName_setMinimumDate &sipStrings_QtGui[55961]
#define sipNameNr_ISOWeekNumbers 55976
#define sipName_ISOWeekNumbers &sipStrings_QtGui[55976]
#define sipNameNr_buttonReleased 55991
#define sipName_buttonReleased &sipStrings_QtGui[55991]
#define sipNameNr_coordinateMode 56006
#define sipName_coordinateMode &sipStrings_QtGui[56006]
#define sipNameNr_RadialGradient 50127
#define sipName_RadialGradient &sipStrings_QtGui[50127]
#define sipNameNr_LinearGradient 50143
#define sipName_LinearGradient &sipStrings_QtGui[50143]
#define sipNameNr_CoordinateMode 13984
#define sipName_CoordinateMode &sipStrings_QtGui[13984]
#define sipNameNr_setDescription 56021
#define sipName_setDescription &sipStrings_QtGui[56021]
#define sipNameNr_heightForWidth 56036
#define sipName_heightForWidth &sipStrings_QtGui[56036]
#define sipNameNr_x11EventFilter 56051
#define sipName_x11EventFilter &sipStrings_QtGui[56051]
#define sipNameNr_setGlobalStrut 56066
#define sipName_setGlobalStrut &sipStrings_QtGui[56066]
#define sipNameNr_overrideCursor 56081
#define sipName_overrideCursor &sipStrings_QtGui[56081]
#define sipNameNr_showStatusText 56096
#define sipName_showStatusText &sipStrings_QtGui[56096]
#define sipNameNr_setActionGroup 56111
#define sipName_setActionGroup &sipStrings_QtGui[56111]
#define sipNameNr_sliderReleased 56126
#define sipName_sliderReleased &sipStrings_QtGui[56126]
#define sipNameNr_setOrientation 56141
#define sipName_setOrientation &sipStrings_QtGui[56141]
#define sipNameNr_SliderNoAction 56156
#define sipName_SliderNoAction &sipStrings_QtGui[56156]
#define sipNameNr_sliderPosition 56171
#define sipName_sliderPosition &sipStrings_QtGui[56171]
#define sipNameNr_setPaintDevice 56186
#define sipName_setPaintDevice &sipStrings_QtGui[56186]
#define sipNameNr_cursorPosition 56201
#define sipName_cursorPosition &sipStrings_QtGui[56201]
#define sipNameNr_setAccelerated 56216
#define sipName_setAccelerated &sipStrings_QtGui[56216]
#define sipNameNr_correctionMode 56231
#define sipName_correctionMode &sipStrings_QtGui[56231]
#define sipNameNr_CorrectionMode 6353
#define sipName_CorrectionMode &sipStrings_QtGui[6353]
#define sipNameNr_setSourceModel 56246
#define sipName_setSourceModel &sipStrings_QtGui[56246]
#define sipNameNr_enabledOptions 56261
#define sipName_enabledOptions &sipStrings_QtGui[56261]
#define sipNameNr_PrintPageRange 56276
#define sipName_PrintPageRange &sipStrings_QtGui[56276]
#define sipNameNr_PrintSelection 56291
#define sipName_PrintSelection &sipStrings_QtGui[56291]
#define sipNameNr_dragLeaveEvent 56306
#define sipName_dragLeaveEvent &sipStrings_QtGui[56306]
#define sipNameNr_dragEnterEvent 56321
#define sipName_dragEnterEvent &sipStrings_QtGui[56321]
#define sipNameNr_setDirtyRegion 56336
#define sipName_setDirtyRegion &sipStrings_QtGui[56336]
#define sipNameNr_AnimatingState 56351
#define sipName_AnimatingState &sipStrings_QtGui[56351]
#define sipNameNr_ExpandingState 56366
#define sipName_ExpandingState &sipStrings_QtGui[56366]
#define sipNameNr_verticalOffset 56381
#define sipName_verticalOffset &sipStrings_QtGui[56381]
#define sipNameNr_currentChanged 56396
#define sipName_currentChanged &sipStrings_QtGui[56396]
#define sipNameNr_scrollToBottom 56411
#define sipName_scrollToBottom &sipStrings_QtGui[56411]
#define sipNameNr_clearSelection 56426
#define sipName_clearSelection &sipStrings_QtGui[56426]
#define sipNameNr_setIndexWidget 56441
#define sipName_setIndexWidget &sipStrings_QtGui[56441]
#define sipNameNr_sizeHintForRow 56456
#define sipName_sizeHintForRow &sipStrings_QtGui[56456]
#define sipNameNr_keyboardSearch 56471
#define sipName_keyboardSearch &sipStrings_QtGui[56471]
#define sipNameNr_setDragEnabled 56486
#define sipName_setDragEnabled &sipStrings_QtGui[56486]
#define sipNameNr_selectionModel 56501
#define sipName_selectionModel &sipStrings_QtGui[56501]
#define sipNameNr_MultiSelection 56516
#define sipName_MultiSelection &sipStrings_QtGui[56516]
#define sipNameNr_ScrollPerPixel 56531
#define sipName_ScrollPerPixel &sipStrings_QtGui[56531]
#define sipNameNr_EditKeyPressed 56546
#define sipName_EditKeyPressed &sipStrings_QtGui[56546]
#define sipNameNr_CurrentChanged 56561
#define sipName_CurrentChanged &sipStrings_QtGui[56561]
#define sipNameNr_NoEditTriggers 56576
#define sipName_NoEditTriggers &sipStrings_QtGui[56576]
#define sipNameNr_mouseMoveEvent 56591
#define sipName_mouseMoveEvent &sipStrings_QtGui[56591]
#define sipNameNr_nextCheckState 56606
#define sipName_nextCheckState &sipStrings_QtGui[56606]
#define sipNameNr_autoFormatting 56621
#define sipName_autoFormatting &sipStrings_QtGui[56621]
#define sipNameNr_setSearchPaths 56636
#define sipName_setSearchPaths &sipStrings_QtGui[56636]
#define sipNameNr_setNameFilters 56651
#define sipName_setNameFilters &sipStrings_QtGui[56651]
#define sipNameNr_DashDotDotLine 56666
#define sipName_DashDotDotLine &sipStrings_QtGui[56666]
#define sipNameNr_56681 56681
#define sipName_56681 &sipStrings_QtGui[56681]
#define sipNameNr_QPyTextObject 56695
#define sipName_QPyTextObject &sipStrings_QtGui[56695]
#define sipNameNr_appRootWindow 56709
#define sipName_appRootWindow &sipStrings_QtGui[56709]
#define sipNameNr_defaultVisual 56723
#define sipName_defaultVisual &sipStrings_QtGui[56723]
#define sipNameNr_discardClient 56737
#define sipName_discardClient &sipStrings_QtGui[56737]
#define sipNameNr_registerField 56751
#define sipName_registerField &sipStrings_QtGui[56751]
#define sipNameNr_setCommitPage 56765
#define sipName_setCommitPage &sipStrings_QtGui[56765]
#define sipNameNr_WizardOptions 18364
#define sipName_WizardOptions &sipStrings_QtGui[18364]
#define sipNameNr_CustomButton3 36206
#define sipName_CustomButton3 &sipStrings_QtGui[36206]
#define sipNameNr_CustomButton2 36224
#define sipName_CustomButton2 &sipStrings_QtGui[36224]
#define sipNameNr_CustomButton1 36242
#define sipName_CustomButton1 &sipStrings_QtGui[36242]
#define sipNameNr_releaseWidget 56779
#define sipName_releaseWidget &sipStrings_QtGui[56779]
#define sipNameNr_requestWidget 56793
#define sipName_requestWidget &sipStrings_QtGui[56793]
#define sipNameNr_defaultWidget 56807
#define sipName_defaultWidget &sipStrings_QtGui[56807]
#define sipNameNr_QWidgetAction 56821
#define sipName_QWidgetAction &sipStrings_QtGui[56821]
#define sipNameNr_paletteChange 56835
#define sipName_paletteChange &sipStrings_QtGui[56835]
#define sipNameNr_enabledChange 56849
#define sipName_enabledChange &sipStrings_QtGui[56849]
#define sipNameNr_visibleRegion 56863
#define sipName_visibleRegion &sipStrings_QtGui[56863]
#define sipNameNr_showMaximized 56877
#define sipName_showMaximized &sipStrings_QtGui[56877]
#define sipNameNr_showMinimized 56891
#define sipName_showMinimized &sipStrings_QtGui[56891]
#define sipNameNr_setFocusProxy 56905
#define sipName_setFocusProxy &sipStrings_QtGui[56905]
#define sipNameNr_windowOpacity 56919
#define sipName_windowOpacity &sipStrings_QtGui[56919]
#define sipNameNr_setWindowRole 56933
#define sipName_setWindowRole &sipStrings_QtGui[56933]
#define sipNameNr_mapFromGlobal 56947
#define sipName_mapFromGlobal &sipStrings_QtGui[56947]
#define sipNameNr_setFixedWidth 56961
#define sipName_setFixedWidth &sipStrings_QtGui[56961]
#define sipNameNr_sizeIncrement 56975
#define sipName_sizeIncrement &sipStrings_QtGui[56975]
#define sipNameNr_frameGeometry 56989
#define sipName_frameGeometry &sipStrings_QtGui[56989]
#define sipNameNr_QIntValidator 57003
#define sipName_QIntValidator &sipStrings_QtGui[57003]
#define sipNameNr_setEmptyLabel 57017
#define sipName_setEmptyLabel &sipStrings_QtGui[57017]
#define sipNameNr_NotSelectable 57031
#define sipName_NotSelectable &sipStrings_QtGui[57031]
#define sipNameNr_itemCollapsed 57045
#define sipName_itemCollapsed &sipStrings_QtGui[57045]
#define sipNameNr_setHeaderItem 57059
#define sipName_setHeaderItem &sipStrings_QtGui[57059]
#define sipNameNr_ShowIndicator 36476
#define sipName_ShowIndicator &sipStrings_QtGui[36476]
#define sipNameNr_expandToDepth 57073
#define sipName_expandToDepth &sipStrings_QtGui[57073]
#define sipNameNr_fromTranslate 57087
#define sipName_fromTranslate &sipStrings_QtGui[57087]
#define sipNameNr_isTranslating 57101
#define sipName_isTranslating &sipStrings_QtGui[57101]
#define sipNameNr_rotateRadians 57115
#define sipName_rotateRadians &sipStrings_QtGui[57115]
#define sipNameNr_isItemEnabled 57129
#define sipName_isItemEnabled &sipStrings_QtGui[57129]
#define sipNameNr_appendColumns 57143
#define sipName_appendColumns &sipStrings_QtGui[57143]
#define sipNameNr_QTextFragment 57157
#define sipName_QTextFragment &sipStrings_QtGui[57157]
#define sipNameNr_firstPosition 57171
#define sipName_firstPosition &sipStrings_QtGui[57171]
#define sipNameNr_blockInserted 57185
#define sipName_blockInserted &sipStrings_QtGui[57185]
#define sipNameNr_setNumColumns 57199
#define sipName_setNumColumns &sipStrings_QtGui[57199]
#define sipNameNr_setTextOption 57213
#define sipName_setTextOption &sipStrings_QtGui[57213]
#define sipNameNr_bottomPadding 57227
#define sipName_bottomPadding &sipStrings_QtGui[57227]
#define sipNameNr_setTopPadding 57241
#define sipName_setTopPadding &sipStrings_QtGui[57241]
#define sipNameNr_setTextIndent 57255
#define sipName_setTextIndent &sipStrings_QtGui[57255]
#define sipNameNr_setLeftMargin 57269
#define sipName_setLeftMargin &sipStrings_QtGui[57269]
#define sipNameNr_fontStyleHint 57283
#define sipName_fontStyleHint &sipStrings_QtGui[57283]
#define sipNameNr_WaveUnderline 57297
#define sipName_WaveUnderline &sipStrings_QtGui[57297]
#define sipNameNr_DashUnderline 57311
#define sipName_DashUnderline &sipStrings_QtGui[57311]
#define sipNameNr_setAnchorName 57325
#define sipName_setAnchorName &sipStrings_QtGui[57325]
#define sipNameNr_setAnchorHref 57339
#define sipName_setAnchorHref &sipStrings_QtGui[57339]
#define sipNameNr_fontStrikeOut 57353
#define sipName_fontStrikeOut &sipStrings_QtGui[57353]
#define sipNameNr_setObjectType 57367
#define sipName_setObjectType &sipStrings_QtGui[57367]
#define sipNameNr_toImageFormat 57381
#define sipName_toImageFormat &sipStrings_QtGui[57381]
#define sipNameNr_toFrameFormat 57395
#define sipName_toFrameFormat &sipStrings_QtGui[57395]
#define sipNameNr_toTableFormat 57409
#define sipName_toTableFormat &sipStrings_QtGui[57409]
#define sipNameNr_toBlockFormat 57423
#define sipName_toBlockFormat &sipStrings_QtGui[57423]
#define sipNameNr_isTableFormat 57437
#define sipName_isTableFormat &sipStrings_QtGui[57437]
#define sipNameNr_isImageFormat 57451
#define sipName_isImageFormat &sipStrings_QtGui[57451]
#define sipNameNr_isFrameFormat 57465
#define sipName_isFrameFormat &sipStrings_QtGui[57465]
#define sipNameNr_isBlockFormat 57479
#define sipName_isBlockFormat &sipStrings_QtGui[57479]
#define sipNameNr_brushProperty 57493
#define sipName_brushProperty &sipStrings_QtGui[57493]
#define sipNameNr_colorProperty 57507
#define sipName_colorProperty &sipStrings_QtGui[57507]
#define sipNameNr_clearProperty 57521
#define sipName_clearProperty &sipStrings_QtGui[57521]
#define sipNameNr_FontStyleHint 41393
#define sipName_FontStyleHint &sipStrings_QtGui[41393]
#define sipNameNr_FontPixelSize 57535
#define sipName_FontPixelSize &sipStrings_QtGui[57535]
#define sipNameNr_FontStrikeOut 41427
#define sipName_FontStrikeOut &sipStrings_QtGui[41427]
#define sipNameNr_FontUnderline 41597
#define sipName_FontUnderline &sipStrings_QtGui[41597]
#define sipNameNr_FontPointSize 41614
#define sipName_FontPointSize &sipStrings_QtGui[41614]
#define sipNameNr_PageBreakFlag 11188
#define sipName_PageBreakFlag &sipStrings_QtGui[11188]
#define sipNameNr_setFontItalic 57549
#define sipName_setFontItalic &sipStrings_QtGui[57549]
#define sipNameNr_setFontWeight 57563
#define sipName_setFontWeight &sipStrings_QtGui[57563]
#define sipNameNr_setFontFamily 57577
#define sipName_setFontFamily &sipStrings_QtGui[57577]
#define sipNameNr_fontUnderline 57591
#define sipName_fontUnderline &sipStrings_QtGui[57591]
#define sipNameNr_fontPointSize 57605
#define sipName_fontPointSize &sipStrings_QtGui[57605]
#define sipNameNr_fromPlainText 57619
#define sipName_fromPlainText &sipStrings_QtGui[57619]
#define sipNameNr_ImageResource 57633
#define sipName_ImageResource &sipStrings_QtGui[57633]
#define sipNameNr_DocumentTitle 42719
#define sipName_DocumentTitle &sipStrings_QtGui[42719]
#define sipNameNr_QTextDocument 57647
#define sipName_QTextDocument &sipStrings_QtGui[57647]
#define sipNameNr_WhiteSpacePre 57661
#define sipName_WhiteSpacePre &sipStrings_QtGui[57661]
#define sipNameNr_setCharFormat 57675
#define sipName_setCharFormat &sipStrings_QtGui[57675]
#define sipNameNr_SelectionType 11215
#define sipName_SelectionType &sipStrings_QtGui[11215]
#define sipNameNr_NextCharacter 57689
#define sipName_NextCharacter &sipStrings_QtGui[57689]
#define sipNameNr_PreviousBlock 57703
#define sipName_PreviousBlock &sipStrings_QtGui[57703]
#define sipNameNr_MoveOperation 11242
#define sipName_MoveOperation &sipStrings_QtGui[11242]
#define sipNameNr_anchorClicked 57717
#define sipName_anchorClicked &sipStrings_QtGui[57717]
#define sipNameNr_sourceChanged 57731
#define sipName_sourceChanged &sipStrings_QtGui[57731]
#define sipNameNr_cellActivated 57745
#define sipName_cellActivated &sipStrings_QtGui[57745]
#define sipNameNr_clearContents 57759
#define sipName_clearContents &sipStrings_QtGui[57759]
#define sipNameNr_setCellWidget 57773
#define sipName_setCellWidget &sipStrings_QtGui[57773]
#define sipNameNr_currentColumn 57787
#define sipName_currentColumn &sipStrings_QtGui[57787]
#define sipNameNr_columnResized 57801
#define sipName_columnResized &sipStrings_QtGui[57801]
#define sipNameNr_SelectLeftTab 57815
#define sipName_SelectLeftTab &sipStrings_QtGui[57815]
#define sipNameNr_setTabToolTip 57829
#define sipName_setTabToolTip &sipStrings_QtGui[57829]
#define sipNameNr_setTabEnabled 57843
#define sipName_setTabEnabled &sipStrings_QtGui[57843]
#define sipNameNr_QStylePainter 57857
#define sipName_QStylePainter &sipStrings_QtGui[57857]
#define sipNameNr_levelOfDetail 57871
#define sipName_levelOfDetail &sipStrings_QtGui[57871]
#define sipNameNr_HasDecoration 57885
#define sipName_HasDecoration &sipStrings_QtGui[57885]
#define sipNameNr_titleBarFlags 57899
#define sipName_titleBarFlags &sipStrings_QtGui[57899]
#define sipNameNr_titleBarState 57913
#define sipName_titleBarState &sipStrings_QtGui[57913]
#define sipNameNr_cornerWidgets 57927
#define sipName_cornerWidgets &sipStrings_QtGui[57927]
#define sipNameNr_CornerWidgets 7374
#define sipName_CornerWidgets &sipStrings_QtGui[7374]
#define sipNameNr_DefaultButton 7529
#define sipName_DefaultButton &sipStrings_QtGui[7529]
#define sipNameNr_ButtonFeature 1090
#define sipName_ButtonFeature &sipStrings_QtGui[1090]
#define sipNameNr_sortIndicator 57941
#define sipName_sortIndicator &sipStrings_QtGui[57941]
#define sipNameNr_iconAlignment 57955
#define sipName_iconAlignment &sipStrings_QtGui[57955]
#define sipNameNr_SortIndicator 5288
#define sipName_SortIndicator &sipStrings_QtGui[5288]
#define sipNameNr_FrameFeatures 4666
#define sipName_FrameFeatures &sipStrings_QtGui[4666]
#define sipNameNr_SO_CustomBase 57969
#define sipName_SO_CustomBase &sipStrings_QtGui[57969]
#define sipNameNr_SO_Q3ListView 57983
#define sipName_SO_Q3ListView &sipStrings_QtGui[57983]
#define sipNameNr_SO_ToolButton 57997
#define sipName_SO_ToolButton &sipStrings_QtGui[57997]
#define sipNameNr_SO_RubberBand 58011
#define sipName_SO_RubberBand &sipStrings_QtGui[58011]
#define sipNameNr_SO_TabBarBase 58025
#define sipName_SO_TabBarBase &sipStrings_QtGui[58025]
#define sipNameNr_SO_DockWidget 58039
#define sipName_SO_DockWidget &sipStrings_QtGui[58039]
#define sipNameNr_QStyleFactory 58053
#define sipName_QStyleFactory &sipStrings_QtGui[58053]
#define sipNameNr_layoutSpacing 58067
#define sipName_layoutSpacing &sipStrings_QtGui[58067]
#define sipNameNr_SP_CustomBase 58081
#define sipName_SP_CustomBase &sipStrings_QtGui[58081]
#define sipNameNr_SP_MediaPause 58095
#define sipName_SP_MediaPause &sipStrings_QtGui[58095]
#define sipNameNr_SP_ArrowRight 58109
#define sipName_SP_ArrowRight &sipStrings_QtGui[58109]
#define sipNameNr_SH_CustomBase 58123
#define sipName_SH_CustomBase &sipStrings_QtGui[58123]
#define sipNameNr_CT_CustomBase 58137
#define sipName_CT_CustomBase &sipStrings_QtGui[58137]
#define sipNameNr_CT_ToolButton 58151
#define sipName_CT_ToolButton &sipStrings_QtGui[58151]
#define sipNameNr_CT_PushButton 58165
#define sipName_CT_PushButton &sipStrings_QtGui[58165]
#define sipNameNr_PM_CustomBase 58179
#define sipName_PM_CustomBase &sipStrings_QtGui[58179]
#define sipNameNr_SC_DialHandle 58193
#define sipName_SC_DialHandle &sipStrings_QtGui[58193]
#define sipNameNr_SC_DialGroove 58207
#define sipName_SC_DialGroove &sipStrings_QtGui[58207]
#define sipNameNr_SC_Q3ListView 58221
#define sipName_SC_Q3ListView &sipStrings_QtGui[58221]
#define sipNameNr_SC_ToolButton 58235
#define sipName_SC_ToolButton &sipStrings_QtGui[58235]
#define sipNameNr_CC_CustomBase 58249
#define sipName_CC_CustomBase &sipStrings_QtGui[58249]
#define sipNameNr_CC_Q3ListView 58263
#define sipName_CC_Q3ListView &sipStrings_QtGui[58263]
#define sipNameNr_CC_ToolButton 58277
#define sipName_CC_ToolButton &sipStrings_QtGui[58277]
#define sipNameNr_SE_CustomBase 58291
#define sipName_SE_CustomBase &sipStrings_QtGui[58291]
#define sipNameNr_CE_CustomBase 58305
#define sipName_CE_CustomBase &sipStrings_QtGui[58305]
#define sipNameNr_CE_FocusFrame 58319
#define sipName_CE_FocusFrame &sipStrings_QtGui[58319]
#define sipNameNr_CE_RubberBand 58333
#define sipName_CE_RubberBand &sipStrings_QtGui[58333]
#define sipNameNr_CE_ToolBoxTab 58347
#define sipName_CE_ToolBoxTab &sipStrings_QtGui[58347]
#define sipNameNr_CE_PushButton 58361
#define sipName_CE_PushButton &sipStrings_QtGui[58361]
#define sipNameNr_drawPrimitive 58375
#define sipName_drawPrimitive &sipStrings_QtGui[58375]
#define sipNameNr_PE_CustomBase 58389
#define sipName_PE_CustomBase &sipStrings_QtGui[58389]
#define sipNameNr_QStyle__State 58403
#define sipName_QStyle__State &sipStrings_QtGui[58403]
#define sipNameNr_State_Editing 58417
#define sipName_State_Editing &sipStrings_QtGui[58417]
#define sipNameNr_State_Sibling 58431
#define sipName_State_Sibling &sipStrings_QtGui[58431]
#define sipNameNr_State_UpArrow 58445
#define sipName_State_UpArrow &sipStrings_QtGui[58445]
#define sipNameNr_State_Enabled 58459
#define sipName_State_Enabled &sipStrings_QtGui[58459]
#define sipNameNr_setStringList 58473
#define sipName_setStringList &sipStrings_QtGui[58473]
#define sipNameNr_isDropEnabled 58487
#define sipName_isDropEnabled &sipStrings_QtGui[58487]
#define sipNameNr_isDragEnabled 58501
#define sipName_isDragEnabled &sipStrings_QtGui[58501]
#define sipNameNr_setSelectable 58515
#define sipName_setSelectable &sipStrings_QtGui[58515]
#define sipNameNr_QStandardItem 58529
#define sipName_QStandardItem &sipStrings_QtGui[58529]
#define sipNameNr_itemPrototype 58543
#define sipName_itemPrototype &sipStrings_QtGui[58543]
#define sipNameNr_widgetRemoved 58557
#define sipName_widgetRemoved &sipStrings_QtGui[58557]
#define sipNameNr_currentWidget 58571
#define sipName_currentWidget &sipStrings_QtGui[58571]
#define sipNameNr_setRubberBand 58585
#define sipName_setRubberBand &sipStrings_QtGui[58585]
#define sipNameNr_splitterMoved 58599
#define sipName_splitterMoved &sipStrings_QtGui[58599]
#define sipNameNr_isCollapsible 58613
#define sipName_isCollapsible &sipStrings_QtGui[58613]
#define sipNameNr_QSplashScreen 58627
#define sipName_QSplashScreen &sipStrings_QtGui[58627]
#define sipNameNr_textFromValue 58641
#define sipName_textFromValue &sipStrings_QtGui[58641]
#define sipNameNr_valueFromText 58655
#define sipName_valueFromText &sipStrings_QtGui[58655]
#define sipNameNr_setFilterRole 58669
#define sipName_setFilterRole &sipStrings_QtGui[58669]
#define sipNameNr_filterChanged 58683
#define sipName_filterChanged &sipStrings_QtGui[58683]
#define sipNameNr_requestPhase2 58697
#define sipName_requestPhase2 &sipStrings_QtGui[58697]
#define sipNameNr_RestartAnyway 58711
#define sipName_RestartAnyway &sipStrings_QtGui[58711]
#define sipNameNr_textDirection 58725
#define sipName_textDirection &sipStrings_QtGui[58725]
#define sipNameNr_isTextVisible 58739
#define sipName_isTextVisible &sipStrings_QtGui[58739]
#define sipNameNr_updatePreview 58753
#define sipName_updatePreview &sipStrings_QtGui[58753]
#define sipNameNr_setZoomFactor 58767
#define sipName_setZoomFactor &sipStrings_QtGui[58767]
#define sipNameNr_PPK_PaperSize 58781
#define sipName_PPK_PaperSize &sipStrings_QtGui[58781]
#define sipNameNr_PPK_PaperRect 58795
#define sipName_PPK_PaperRect &sipStrings_QtGui[58795]
#define sipNameNr_PPK_PageOrder 58809
#define sipName_PPK_PageOrder &sipStrings_QtGui[58809]
#define sipNameNr_PPK_ColorMode 58823
#define sipName_PPK_ColorMode &sipStrings_QtGui[58823]
#define sipNameNr_collateCopies 58837
#define sipName_collateCopies &sipStrings_QtGui[58837]
#define sipNameNr_setResolution 58851
#define sipName_setResolution &sipStrings_QtGui[58851]
#define sipNameNr_MaxPageSource 58865
#define sipName_MaxPageSource &sipStrings_QtGui[58865]
#define sipNameNr_LargeCapacity 58879
#define sipName_LargeCapacity &sipStrings_QtGui[58879]
#define sipNameNr_LastPageFirst 58893
#define sipName_LastPageFirst &sipStrings_QtGui[58893]
#define sipNameNr_containsPoint 58907
#define sipName_containsPoint &sipStrings_QtGui[58907]
#define sipNameNr_requestUpdate 58921
#define sipName_requestUpdate &sipStrings_QtGui[58921]
#define sipNameNr_contentOffset 58935
#define sipName_contentOffset &sipStrings_QtGui[58935]
#define sipNameNr_updateRequest 58949
#define sipName_updateRequest &sipStrings_QtGui[58949]
#define sipNameNr_copyAvailable 58963
#define sipName_copyAvailable &sipStrings_QtGui[58963]
#define sipNameNr_redoAvailable 58977
#define sipName_redoAvailable &sipStrings_QtGui[58977]
#define sipNameNr_undoAvailable 58991
#define sipName_undoAvailable &sipStrings_QtGui[58991]
#define sipNameNr_overwriteMode 59005
#define sipName_overwriteMode &sipStrings_QtGui[59005]
#define sipNameNr_documentTitle 59019
#define sipName_documentTitle &sipStrings_QtGui[59019]
#define sipNameNr_setCacheLimit 59033
#define sipName_setCacheLimit &sipStrings_QtGui[59033]
#define sipNameNr_fromX11Pixmap 59047
#define sipName_fromX11Pixmap &sipStrings_QtGui[59047]
#define sipNameNr_setParameters 59061
#define sipName_setParameters &sipStrings_QtGui[59061]
#define sipNameNr_outputFormats 59075
#define sipName_outputFormats &sipStrings_QtGui[59075]
#define sipNameNr_pictureFormat 59089
#define sipName_pictureFormat &sipStrings_QtGui[59089]
#define sipNameNr_alternateBase 59103
#define sipName_alternateBase &sipStrings_QtGui[59103]
#define sipNameNr_setColorGroup 59117
#define sipName_setColorGroup &sipStrings_QtGui[59117]
#define sipNameNr_AlternateBase 59131
#define sipName_AlternateBase &sipStrings_QtGui[59131]
#define sipNameNr_setDashOffset 59145
#define sipName_setDashOffset &sipStrings_QtGui[59145]
#define sipNameNr_setMiterLimit 59159
#define sipName_setMiterLimit &sipStrings_QtGui[59159]
#define sipNameNr_toFillPolygon 59173
#define sipName_toFillPolygon &sipStrings_QtGui[59173]
#define sipNameNr_LineToElement 59187
#define sipName_LineToElement &sipStrings_QtGui[59187]
#define sipNameNr_MoveToElement 59201
#define sipName_MoveToElement &sipStrings_QtGui[59201]
#define sipNameNr_isClipEnabled 59215
#define sipName_isClipEnabled &sipStrings_QtGui[59215]
#define sipNameNr_clipOperation 59229
#define sipName_clipOperation &sipStrings_QtGui[59229]
#define sipNameNr_QWindowSystem 59243
#define sipName_QWindowSystem &sipStrings_QtGui[59243]
#define sipNameNr_DirtyClipPath 59257
#define sipName_DirtyClipPath &sipStrings_QtGui[59257]
#define sipNameNr_RasterOpModes 59271
#define sipName_RasterOpModes &sipStrings_QtGui[59271]
#define sipNameNr_setRedirected 59285
#define sipName_setRedirected &sipStrings_QtGui[59285]
#define sipNameNr_drawRoundRect 59299
#define sipName_drawRoundRect &sipStrings_QtGui[59299]
#define sipNameNr_matrixEnabled 59313
#define sipName_matrixEnabled &sipStrings_QtGui[59313]
#define sipNameNr_setClipRegion 59327
#define sipName_setClipRegion &sipStrings_QtGui[59327]
#define sipNameNr_currentPixmap 59341
#define sipName_currentPixmap &sipStrings_QtGui[59341]
#define sipNameNr_clickedButton 59355
#define sipName_clickedButton &sipStrings_QtGui[59355]
#define sipNameNr_defaultButton 59369
#define sipName_defaultButton &sipStrings_QtGui[59369]
#define sipNameNr_setButtonText 59383
#define sipName_setButtonText &sipStrings_QtGui[59383]
#define sipNameNr_setIconPixmap 59397
#define sipName_setIconPixmap &sipStrings_QtGui[59397]
#define sipNameNr_defaultAction 59411
#define sipName_defaultAction &sipStrings_QtGui[59411]
#define sipNameNr_setSystemMenu 59425
#define sipName_setSystemMenu &sipStrings_QtGui[59425]
#define sipNameNr_QMdiSubWindow 59439
#define sipName_QMdiSubWindow &sipStrings_QtGui[59439]
#define sipNameNr_subWindowList 59453
#define sipName_subWindowList &sipStrings_QtGui[59453]
#define sipNameNr_StackingOrder 59467
#define sipName_StackingOrder &sipStrings_QtGui[59467]
#define sipNameNr_CreationOrder 59481
#define sipName_CreationOrder &sipStrings_QtGui[59481]
#define sipNameNr_SubWindowView 59495
#define sipName_SubWindowView &sipStrings_QtGui[59495]
#define sipNameNr_AnimatedDocks 59509
#define sipName_AnimatedDocks &sipStrings_QtGui[59509]
#define sipNameNr_setMenuWidget 59523
#define sipName_setMenuWidget &sipStrings_QtGui[59523]
#define sipNameNr_addDockWidget 59537
#define sipName_addDockWidget &sipStrings_QtGui[59537]
#define sipNameNr_removeToolBar 59551
#define sipName_removeToolBar &sipStrings_QtGui[59551]
#define sipNameNr_insertToolBar 59565
#define sipName_insertToolBar &sipStrings_QtGui[59565]
#define sipNameNr_centralWidget 59579
#define sipName_centralWidget &sipStrings_QtGui[59579]
#define sipNameNr_itemFromIndex 59593
#define sipName_itemFromIndex &sipStrings_QtGui[59593]
#define sipNameNr_indexFromItem 59607
#define sipName_indexFromItem &sipStrings_QtGui[59607]
#define sipNameNr_itemActivated 59621
#define sipName_itemActivated &sipStrings_QtGui[59621]
#define sipNameNr_setItemHidden 59635
#define sipName_setItemHidden &sipStrings_QtGui[59635]
#define sipNameNr_setItemWidget 59649
#define sipName_setItemWidget &sipStrings_QtGui[59649]
#define sipNameNr_setForeground 59663
#define sipName_setForeground &sipStrings_QtGui[59663]
#define sipNameNr_setBackground 59677
#define sipName_setBackground &sipStrings_QtGui[59677]
#define sipNameNr_textAlignment 59691
#define sipName_textAlignment &sipStrings_QtGui[59691]
#define sipNameNr_setLayoutMode 59705
#define sipName_setLayoutMode &sipStrings_QtGui[59705]
#define sipNameNr_returnPressed 59719
#define sipName_returnPressed &sipStrings_QtGui[59719]
#define sipNameNr_cursorForward 59733
#define sipName_cursorForward &sipStrings_QtGui[59733]
#define sipNameNr_checkOverflow 59747
#define sipName_checkOverflow &sipStrings_QtGui[59747]
#define sipNameNr_alignmentRect 59761
#define sipName_alignmentRect &sipStrings_QtGui[59761]
#define sipNameNr_totalSizeHint 59775
#define sipName_totalSizeHint &sipStrings_QtGui[59775]
#define sipNameNr_setTextFormat 59789
#define sipName_setTextFormat &sipStrings_QtGui[59789]
#define sipNameNr_PreviousChild 31765
#define sipName_PreviousChild &sipStrings_QtGui[31765]
#define sipNameNr_SequenceMatch 10828
#define sipName_SequenceMatch &sipStrings_QtGui[10828]
#define sipNameNr_QItemDelegate 59803
#define sipName_QItemDelegate &sipStrings_QtGui[59803]
#define sipNameNr_doubleMaximum 59817
#define sipName_doubleMaximum &sipStrings_QtGui[59817]
#define sipNameNr_doubleMinimum 59831
#define sipName_doubleMinimum &sipStrings_QtGui[59831]
#define sipNameNr_setIntMaximum 59845
#define sipName_setIntMaximum &sipStrings_QtGui[59845]
#define sipNameNr_setIntMinimum 59859
#define sipName_setIntMinimum &sipStrings_QtGui[59859]
#define sipNameNr_comboBoxItems 59873
#define sipName_comboBoxItems &sipStrings_QtGui[59873]
#define sipNameNr_PreeditFormat 59887
#define sipName_PreeditFormat &sipStrings_QtGui[59887]
#define sipNameNr_QInputContext 59901
#define sipName_QInputContext &sipStrings_QtGui[59901]
#define sipNameNr_setScaledSize 59915
#define sipName_setScaledSize &sipStrings_QtGui[59915]
#define sipNameNr_dotsPerMeterY 59929
#define sipName_dotsPerMeterY &sipStrings_QtGui[59929]
#define sipNameNr_dotsPerMeterX 59943
#define sipName_dotsPerMeterX &sipStrings_QtGui[59943]
#define sipNameNr_scaledToWidth 59957
#define sipName_scaledToWidth &sipStrings_QtGui[59957]
#define sipNameNr_setColorTable 59971
#define sipName_setColorTable &sipStrings_QtGui[59971]
#define sipNameNr_Format_RGB444 59985
#define sipName_Format_RGB444 &sipStrings_QtGui[59985]
#define sipNameNr_Format_RGB888 59999
#define sipName_Format_RGB888 &sipStrings_QtGui[59999]
#define sipNameNr_Format_RGB555 60013
#define sipName_Format_RGB555 &sipStrings_QtGui[60013]
#define sipNameNr_Format_RGB666 60027
#define sipName_Format_RGB666 &sipStrings_QtGui[60027]
#define sipNameNr_Format_ARGB32 60041
#define sipName_Format_ARGB32 &sipStrings_QtGui[60041]
#define sipNameNr_isRowSelected 60055
#define sipName_isRowSelected &sipStrings_QtGui[60055]
#define sipNameNr_ToggleCurrent 60069
#define sipName_ToggleCurrent &sipStrings_QtGui[60069]
#define sipNameNr_SelectCurrent 60083
#define sipName_SelectCurrent &sipStrings_QtGui[60083]
#define sipNameNr_SelectionFlag 4946
#define sipName_SelectionFlag &sipStrings_QtGui[4946]
#define sipNameNr_QIconEngineV2 60097
#define sipName_QIconEngineV2 &sipStrings_QtGui[60097]
#define sipNameNr_updateSection 60111
#define sipName_updateSection &sipStrings_QtGui[60111]
#define sipNameNr_sectionsMoved 60125
#define sipName_sectionsMoved &sipStrings_QtGui[60125]
#define sipNameNr_setResizeMode 60139
#define sipName_setResizeMode &sipStrings_QtGui[60139]
#define sipNameNr_resizeSection 60153
#define sipName_resizeSection &sipStrings_QtGui[60153]
#define sipNameNr_visualIndexAt 60167
#define sipName_visualIndexAt &sipStrings_QtGui[60167]
#define sipNameNr_columnStretch 60181
#define sipName_columnStretch &sipStrings_QtGui[60181]
#define sipNameNr_setRowStretch 60195
#define sipName_setRowStretch &sipStrings_QtGui[60195]
#define sipNameNr_isInteractive 60209
#define sipName_isInteractive &sipStrings_QtGui[60209]
#define sipNameNr_setRenderHint 60223
#define sipName_setRenderHint &sipStrings_QtGui[60223]
#define sipNameNr_CacheModeFlag 9981
#define sipName_CacheModeFlag &sipStrings_QtGui[9981]
#define sipNameNr_QGraphicsView 60237
#define sipName_QGraphicsView &sipStrings_QtGui[60237]
#define sipNameNr_lastScreenPos 60251
#define sipName_lastScreenPos &sipStrings_QtGui[60251]
#define sipNameNr_buttonDownPos 60265
#define sipName_buttonDownPos &sipStrings_QtGui[60265]
#define sipNameNr_insertActions 60279
#define sipName_insertActions &sipStrings_QtGui[60279]
#define sipNameNr_selectionArea 60293
#define sipName_selectionArea &sipStrings_QtGui[60293]
#define sipNameNr_addSimpleText 60307
#define sipName_addSimpleText &sipStrings_QtGui[60307]
#define sipNameNr_selectedItems 60321
#define sipName_selectedItems &sipStrings_QtGui[60321]
#define sipNameNr_subWidgetRect 60335
#define sipName_subWidgetRect &sipStrings_QtGui[60335]
#define sipNameNr_stretchFactor 60349
#define sipName_stretchFactor &sipStrings_QtGui[60349]
#define sipNameNr_ownedByLayout 60363
#define sipName_ownedByLayout &sipStrings_QtGui[60363]
#define sipNameNr_maximumHeight 60377
#define sipName_maximumHeight &sipStrings_QtGui[60377]
#define sipNameNr_minimumHeight 60391
#define sipName_minimumHeight &sipStrings_QtGui[60391]
#define sipNameNr_preferredSize 60405
#define sipName_preferredSize &sipStrings_QtGui[60405]
#define sipNameNr_setSizePolicy 60419
#define sipName_setSizePolicy &sipStrings_QtGui[60419]
#define sipNameNr_setRotationAt 60433
#define sipName_setRotationAt &sipStrings_QtGui[60433]
#define sipNameNr_linkActivated 60447
#define sipName_linkActivated &sipStrings_QtGui[60447]
#define sipNameNr_setTextCursor 60461
#define sipName_setTextCursor &sipStrings_QtGui[60461]
#define sipNameNr_setStartAngle 60475
#define sipName_setStartAngle &sipStrings_QtGui[60475]
#define sipNameNr_mapRectToItem 60489
#define sipName_mapRectToItem &sipStrings_QtGui[60489]
#define sipNameNr_itemTransform 60503
#define sipName_itemTransform &sipStrings_QtGui[60503]
#define sipNameNr_mapFromParent 60517
#define sipName_mapFromParent &sipStrings_QtGui[60517]
#define sipNameNr_ensureVisible 60531
#define sipName_ensureVisible &sipStrings_QtGui[60531]
#define sipNameNr_setParentItem 60545
#define sipName_setParentItem &sipStrings_QtGui[60545]
#define sipNameNr_ItemIsMovable 60559
#define sipName_ItemIsMovable &sipStrings_QtGui[60559]
#define sipNameNr_QGraphicsItem 60573
#define sipName_QGraphicsItem &sipStrings_QtGui[60573]
#define sipNameNr_columnSpacing 60587
#define sipName_columnSpacing &sipStrings_QtGui[60587]
#define sipNameNr_setRowSpacing 60601
#define sipName_setRowSpacing &sipStrings_QtGui[60601]
#define sipNameNr_setFrameShape 60615
#define sipName_setFrameShape &sipStrings_QtGui[60615]
#define sipNameNr_setFrameStyle 60629
#define sipName_setFrameStyle &sipStrings_QtGui[60629]
#define sipNameNr_QFrame__Shape 60643
#define sipName_QFrame__Shape &sipStrings_QtGui[60643]
#define sipNameNr_labelForField 60657
#define sipName_labelForField &sipStrings_QtGui[60657]
#define sipNameNr_formAlignment 60671
#define sipName_formAlignment &sipStrings_QtGui[60671]
#define sipNameNr_rowWrapPolicy 60685
#define sipName_rowWrapPolicy &sipStrings_QtGui[60685]
#define sipNameNr_RowWrapPolicy 12052
#define sipName_RowWrapPolicy &sipStrings_QtGui[12052]
#define sipNameNr_QFontMetricsF 60699
#define sipName_QFontMetricsF &sipStrings_QtGui[60699]
#define sipNameNr_standardSizes 60713
#define sipName_standardSizes &sipStrings_QtGui[60713]
#define sipNameNr_WritingSystem 10039
#define sipName_WritingSystem &sipStrings_QtGui[10039]
#define sipNameNr_QFontDatabase 60727
#define sipName_QFontDatabase &sipStrings_QtGui[60727]
#define sipNameNr_writingSystem 60741
#define sipName_writingSystem &sipStrings_QtGui[60741]
#define sipNameNr_ScalableFonts 44266
#define sipName_ScalableFonts &sipStrings_QtGui[44266]
#define sipNameNr_QFontComboBox 60755
#define sipName_QFontComboBox &sipStrings_QtGui[60755]
#define sipNameNr_letterSpacing 60769
#define sipName_letterSpacing &sipStrings_QtGui[60769]
#define sipNameNr_defaultFamily 60783
#define sipName_defaultFamily &sipStrings_QtGui[60783]
#define sipNameNr_substitutions 60797
#define sipName_substitutions &sipStrings_QtGui[60797]
#define sipNameNr_styleStrategy 60811
#define sipName_styleStrategy &sipStrings_QtGui[60811]
#define sipNameNr_setFixedPitch 60825
#define sipName_setFixedPitch &sipStrings_QtGui[60825]
#define sipNameNr_setPointSizeF 60839
#define sipName_setPointSizeF &sipStrings_QtGui[60839]
#define sipNameNr_UltraExpanded 60853
#define sipName_UltraExpanded &sipStrings_QtGui[60853]
#define sipNameNr_ExtraExpanded 60867
#define sipName_ExtraExpanded &sipStrings_QtGui[60867]
#define sipNameNr_SemiCondensed 60881
#define sipName_SemiCondensed &sipStrings_QtGui[60881]
#define sipNameNr_QFont__Weight 60895
#define sipName_QFont__Weight &sipStrings_QtGui[60895]
#define sipNameNr_NoFontMerging 60909
#define sipName_NoFontMerging &sipStrings_QtGui[60909]
#define sipNameNr_PreferQuality 60923
#define sipName_PreferQuality &sipStrings_QtGui[60923]
#define sipNameNr_PreferOutline 60937
#define sipName_PreferOutline &sipStrings_QtGui[60937]
#define sipNameNr_PreferDefault 60951
#define sipName_PreferDefault &sipStrings_QtGui[60951]
#define sipNameNr_StyleStrategy 24360
#define sipName_StyleStrategy &sipStrings_QtGui[24360]
#define sipNameNr_rootDirectory 60965
#define sipName_rootDirectory &sipStrings_QtGui[60965]
#define sipNameNr_setNameFilter 60979
#define sipName_setNameFilter &sipStrings_QtGui[60979]
#define sipNameNr_setProxyModel 60993
#define sipName_setProxyModel &sipStrings_QtGui[60993]
#define sipNameNr_filesSelected 61007
#define sipName_filesSelected &sipStrings_QtGui[61007]
#define sipNameNr_defaultSuffix 61021
#define sipName_defaultSuffix &sipStrings_QtGui[61021]
#define sipNameNr_setAcceptMode 61035
#define sipName_setAcceptMode &sipStrings_QtGui[61035]
#define sipNameNr_selectedFiles 61049
#define sipName_selectedFiles &sipStrings_QtGui[61049]
#define sipNameNr_DirectoryOnly 61063
#define sipName_DirectoryOnly &sipStrings_QtGui[61063]
#define sipNameNr_ExistingFiles 61077
#define sipName_ExistingFiles &sipStrings_QtGui[61077]
#define sipNameNr_setDropAction 61091
#define sipName_setDropAction &sipStrings_QtGui[61091]
#define sipNameNr_preeditString 61105
#define sipName_preeditString &sipStrings_QtGui[61105]
#define sipNameNr_AttributeType 6222
#define sipName_AttributeType &sipStrings_QtGui[6222]
#define sipNameNr_QErrorMessage 61119
#define sipName_QErrorMessage &sipStrings_QtGui[61119]
#define sipNameNr_qDrawWinPanel 61133
#define sipName_qDrawWinPanel &sipStrings_QtGui[61133]
#define sipNameNr_targetChanged 61147
#define sipName_targetChanged &sipStrings_QtGui[61147]
#define sipNameNr_actionChanged 61161
#define sipName_actionChanged &sipStrings_QtGui[61161]
#define sipNameNr_setDragCursor 61175
#define sipName_setDragCursor &sipStrings_QtGui[61175]
#define sipNameNr_isAreaAllowed 61189
#define sipName_isAreaAllowed &sipStrings_QtGui[61189]
#define sipNameNr_helpRequested 61203
#define sipName_helpRequested &sipStrings_QtGui[61203]
#define sipNameNr_centerButtons 61217
#define sipName_centerButtons &sipStrings_QtGui[61217]
#define sipNameNr_showExtension 61231
#define sipName_showExtension &sipStrings_QtGui[61231]
#define sipNameNr_primaryScreen 61245
#define sipName_primaryScreen &sipStrings_QtGui[61245]
#define sipNameNr_setUrlHandler 49824
#define sipName_setUrlHandler &sipStrings_QtGui[49824]
#define sipNameNr_CacheLocation 61259
#define sipName_CacheLocation &sipStrings_QtGui[61259]
#define sipNameNr_MusicLocation 61273
#define sipName_MusicLocation &sipStrings_QtGui[61273]
#define sipNameNr_FontsLocation 61287
#define sipName_FontsLocation &sipStrings_QtGui[61287]
#define sipNameNr_calendarPopup 61301
#define sipName_calendarPopup &sipStrings_QtGui[61301]
#define sipNameNr_displayFormat 61315
#define sipName_displayFormat &sipStrings_QtGui[61315]
#define sipNameNr_MinuteSection 61329
#define sipName_MinuteSection &sipStrings_QtGui[61329]
#define sipNameNr_SecondSection 61343
#define sipName_SecondSection &sipStrings_QtGui[61343]
#define sipNameNr_QDateTimeEdit 61357
#define sipName_QDateTimeEdit &sipStrings_QtGui[61357]
#define sipNameNr_mappedSection 61371
#define sipName_mappedSection &sipStrings_QtGui[61371]
#define sipNameNr_removeMapping 61385
#define sipName_removeMapping &sipStrings_QtGui[61385]
#define sipNameNr_setWrapAround 61399
#define sipName_setWrapAround &sipStrings_QtGui[61399]
#define sipNameNr_pathFromIndex 61413
#define sipName_pathFromIndex &sipStrings_QtGui[61413]
#define sipNameNr_setCurrentRow 61427
#define sipName_setCurrentRow &sipStrings_QtGui[61427]
#define sipNameNr_UnsortedModel 61441
#define sipName_UnsortedModel &sipStrings_QtGui[61441]
#define sipNameNr_clearEditText 61455
#define sipName_clearEditText &sipStrings_QtGui[61455]
#define sipNameNr_selectedColor 61469
#define sipName_selectedColor &sipStrings_QtGui[61469]
#define sipNameNr_colorSelected 61483
#define sipName_colorSelected &sipStrings_QtGui[61483]
#define sipNameNr_previewWidget 61497
#define sipName_previewWidget &sipStrings_QtGui[61497]
#define sipNameNr_ownsSelection 61511
#define sipName_ownsSelection &sipStrings_QtGui[61511]
#define sipNameNr_ownsClipboard 61525
#define sipName_ownsClipboard &sipStrings_QtGui[61525]
#define sipNameNr_setCheckState 61539
#define sipName_setCheckState &sipStrings_QtGui[61539]
#define sipNameNr_showNextMonth 61553
#define sipName_showNextMonth &sipStrings_QtGui[61553]
#define sipNameNr_isGridVisible 61567
#define sipName_isGridVisible &sipStrings_QtGui[61567]
#define sipNameNr_ShortDayNames 61581
#define sipName_ShortDayNames &sipStrings_QtGui[61581]
#define sipNameNr_buttonPressed 61595
#define sipName_buttonPressed &sipStrings_QtGui[61595]
#define sipNameNr_buttonClicked 61609
#define sipName_buttonClicked &sipStrings_QtGui[61609]
#define sipNameNr_checkedButton 61623
#define sipName_checkedButton &sipStrings_QtGui[61623]
#define sipNameNr_setFocalPoint 61637
#define sipName_setFocalPoint &sipStrings_QtGui[61637]
#define sipNameNr_ReflectSpread 61651
#define sipName_ReflectSpread &sipStrings_QtGui[61651]
#define sipNameNr_setNamedColor 61665
#define sipName_setNamedColor &sipStrings_QtGui[61665]
#define sipNameNr_addSpacerItem 61679
#define sipName_addSpacerItem &sipStrings_QtGui[61679]
#define sipNameNr_insertStretch 61693
#define sipName_insertStretch &sipStrings_QtGui[61693]
#define sipNameNr_insertSpacing 61707
#define sipName_insertSpacing &sipStrings_QtGui[61707]
#define sipNameNr_setStyleSheet 61721
#define sipName_setStyleSheet &sipStrings_QtGui[61721]
#define sipNameNr_isLeftToRight 61735
#define sipName_isLeftToRight &sipStrings_QtGui[61735]
#define sipNameNr_startDragTime 61749
#define sipName_startDragTime &sipStrings_QtGui[61749]
#define sipNameNr_setWindowIcon 61763
#define sipName_setWindowIcon &sipStrings_QtGui[61763]
#define sipNameNr_checkedAction 61777
#define sipName_checkedAction &sipStrings_QtGui[61777]
#define sipNameNr_sliderPressed 61791
#define sipName_sliderPressed &sipStrings_QtGui[61791]
#define sipNameNr_triggerAction 61805
#define sipName_triggerAction &sipStrings_QtGui[61805]
#define sipNameNr_setSliderDown 61819
#define sipName_setSliderDown &sipStrings_QtGui[61819]
#define sipNameNr_setSingleStep 61833
#define sipName_setSingleStep &sipStrings_QtGui[61833]
#define sipNameNr_intrinsicSize 61847
#define sipName_intrinsicSize &sipStrings_QtGui[61847]
#define sipNameNr_isAccelerated 61861
#define sipName_isAccelerated &sipStrings_QtGui[61861]
#define sipNameNr_interpretText 61875
#define sipName_interpretText &sipStrings_QtGui[61875]
#define sipNameNr_buttonSymbols 61889
#define sipName_buttonSymbols &sipStrings_QtGui[61889]
#define sipNameNr_ButtonSymbols 7060
#define sipName_ButtonSymbols &sipStrings_QtGui[7060]
#define sipNameNr_StepUpEnabled 61903
#define sipName_StepUpEnabled &sipStrings_QtGui[61903]
#define sipNameNr_setupViewport 61917
#define sipName_setupViewport &sipStrings_QtGui[61917]
#define sipNameNr_mapFromSource 61931
#define sipName_mapFromSource &sipStrings_QtGui[61931]
#define sipNameNr_setOptionTabs 61945
#define sipName_setOptionTabs &sipStrings_QtGui[61945]
#define sipNameNr_setPrintRange 61959
#define sipName_setPrintRange &sipStrings_QtGui[61959]
#define sipNameNr_dragMoveEvent 61973
#define sipName_dragMoveEvent &sipStrings_QtGui[61973]
#define sipNameNr_viewportEvent 61987
#define sipName_viewportEvent &sipStrings_QtGui[61987]
#define sipNameNr_DraggingState 62001
#define sipName_DraggingState &sipStrings_QtGui[62001]
#define sipNameNr_isIndexHidden 62015
#define sipName_isIndexHidden &sipStrings_QtGui[62015]
#define sipNameNr_doubleClicked 62029
#define sipName_doubleClicked &sipStrings_QtGui[62029]
#define sipNameNr_doItemsLayout 62043
#define sipName_doItemsLayout &sipStrings_QtGui[62043]
#define sipNameNr_textElideMode 62057
#define sipName_textElideMode &sipStrings_QtGui[62057]
#define sipNameNr_hasAutoScroll 62071
#define sipName_hasAutoScroll &sipStrings_QtGui[62071]
#define sipNameNr_setAutoScroll 62085
#define sipName_setAutoScroll &sipStrings_QtGui[62085]
#define sipNameNr_selectionMode 62099
#define sipName_selectionMode &sipStrings_QtGui[62099]
#define sipNameNr_SelectionMode 6420
#define sipName_SelectionMode &sipStrings_QtGui[6420]
#define sipNameNr_SelectColumns 62113
#define sipName_SelectColumns &sipStrings_QtGui[62113]
#define sipNameNr_ScrollPerItem 62127
#define sipName_ScrollPerItem &sipStrings_QtGui[62127]
#define sipNameNr_PositionAtTop 62141
#define sipName_PositionAtTop &sipStrings_QtGui[62141]
#define sipNameNr_EnsureVisible 62155
#define sipName_EnsureVisible &sipStrings_QtGui[62155]
#define sipNameNr_AnyKeyPressed 62169
#define sipName_AnyKeyPressed &sipStrings_QtGui[62169]
#define sipNameNr_DoubleClicked 11863
#define sipName_DoubleClicked &sipStrings_QtGui[11863]
#define sipNameNr_setEditorData 62183
#define sipName_setEditorData &sipStrings_QtGui[62183]
#define sipNameNr_focusOutEvent 62197
#define sipName_focusOutEvent &sipStrings_QtGui[62197]
#define sipNameNr_keyPressEvent 62211
#define sipName_keyPressEvent &sipStrings_QtGui[62211]
#define sipNameNr_checkStateSet 62225
#define sipName_checkStateSet &sipStrings_QtGui[62225]
#define sipNameNr_autoExclusive 62239
#define sipName_autoExclusive &sipStrings_QtGui[62239]
#define sipNameNr_setAutoRepeat 62253
#define sipName_setAutoRepeat &sipStrings_QtGui[62253]
#define sipNameNr_isRightToLeft 62267
#define sipName_isRightToLeft &sipStrings_QtGui[62267]
#define sipNameNr_InvalidFormat 62281
#define sipName_InvalidFormat &sipStrings_QtGui[62281]
#define sipNameNr_propertyCount 62295
#define sipName_propertyCount &sipStrings_QtGui[62295]
#define sipNameNr_IteratorFlags 2510
#define sipName_IteratorFlags &sipStrings_QtGui[2510]
#define sipNameNr_testAttribute 62309
#define sipName_testAttribute &sipStrings_QtGui[62309]
#define sipNameNr_connectNotify 45677
#define sipName_connectNotify &sipStrings_QtGui[45677]
#define sipNameNr_endRemoveRows 62323
#define sipName_endRemoveRows &sipStrings_QtGui[62323]
#define sipNameNr_endInsertRows 62337
#define sipName_endInsertRows &sipStrings_QtGui[62337]
#define sipNameNr_removeColumns 62351
#define sipName_removeColumns &sipStrings_QtGui[62351]
#define sipNameNr_insertColumns 62365
#define sipName_insertColumns &sipStrings_QtGui[62365]
#define sipNameNr_setHeaderData 62379
#define sipName_setHeaderData &sipStrings_QtGui[62379]
#define sipNameNr_62393 62393
#define sipName_62393 &sipStrings_QtGui[62393]
#define sipNameNr_clientClosed 62406
#define sipName_clientClosed &sipStrings_QtGui[62406]
#define sipNameNr_arrangeIcons 62419
#define sipName_arrangeIcons &sipStrings_QtGui[62419]
#define sipNameNr_validatePage 62432
#define sipName_validatePage &sipStrings_QtGui[62432]
#define sipNameNr_isCommitPage 62445
#define sipName_isCommitPage &sipStrings_QtGui[62445]
#define sipNameNr_setFinalPage 62458
#define sipName_setFinalPage &sipStrings_QtGui[62458]
#define sipNameNr_visitedPages 62471
#define sipName_visitedPages &sipStrings_QtGui[62471]
#define sipNameNr_WizardOption 20706
#define sipName_WizardOption &sipStrings_QtGui[20706]
#define sipNameNr_ClassicStyle 62484
#define sipName_ClassicStyle &sipStrings_QtGui[62484]
#define sipNameNr_BannerPixmap 62497
#define sipName_BannerPixmap &sipStrings_QtGui[62497]
#define sipNameNr_WizardPixmap 20728
#define sipName_WizardPixmap &sipStrings_QtGui[20728]
#define sipNameNr_CancelButton 3877
#define sipName_CancelButton &sipStrings_QtGui[3877]
#define sipNameNr_FinishButton 62510
#define sipName_FinishButton &sipStrings_QtGui[62510]
#define sipNameNr_CommitButton 62523
#define sipName_CommitButton &sipStrings_QtGui[62523]
#define sipNameNr_WizardButton 20750
#define sipName_WizardButton &sipStrings_QtGui[20750]
#define sipNameNr_deleteWidget 62536
#define sipName_deleteWidget &sipStrings_QtGui[62536]
#define sipNameNr_DrawChildren 62549
#define sipName_DrawChildren &sipStrings_QtGui[62549]
#define sipNameNr_saveGeometry 62562
#define sipName_saveGeometry &sipStrings_QtGui[62562]
#define sipNameNr_isFullScreen 62575
#define sipName_isFullScreen &sipStrings_QtGui[62575]
#define sipNameNr_mouseGrabber 62588
#define sipName_mouseGrabber &sipStrings_QtGui[62588]
#define sipNameNr_releaseMouse 62601
#define sipName_releaseMouse &sipStrings_QtGui[62601]
#define sipNameNr_setFixedSize 62614
#define sipName_setFixedSize &sipStrings_QtGui[62614]
#define sipNameNr_childrenRect 62627
#define sipName_childrenRect &sipStrings_QtGui[62627]
#define sipNameNr_createAction 62640
#define sipName_createAction &sipStrings_QtGui[62640]
#define sipNameNr_Intermediate 62653
#define sipName_Intermediate &sipStrings_QtGui[62653]
#define sipNameNr_setCleanIcon 62666
#define sipName_setCleanIcon &sipStrings_QtGui[62666]
#define sipNameNr_setUndoLimit 62679
#define sipName_setUndoLimit &sipStrings_QtGui[62679]
#define sipNameNr_QUndoCommand 62692
#define sipName_QUndoCommand &sipStrings_QtGui[62692]
#define sipNameNr_indexChanged 62705
#define sipName_indexChanged &sipStrings_QtGui[62705]
#define sipNameNr_cleanChanged 62718
#define sipName_cleanChanged &sipStrings_QtGui[62718]
#define sipNameNr_DropDisabled 62731
#define sipName_DropDisabled &sipStrings_QtGui[62731]
#define sipNameNr_DragDisabled 62744
#define sipName_DragDisabled &sipStrings_QtGui[62744]
#define sipNameNr_itemExpanded 62757
#define sipName_itemExpanded &sipStrings_QtGui[62757]
#define sipNameNr_collapseItem 62770
#define sipName_collapseItem &sipStrings_QtGui[62770]
#define sipNameNr_takeChildren 62783
#define sipName_takeChildren &sipStrings_QtGui[62783]
#define sipNameNr_indexOfChild 62796
#define sipName_indexOfChild &sipStrings_QtGui[62796]
#define sipNameNr_drawBranches 62809
#define sipName_drawBranches &sipStrings_QtGui[62809]
#define sipNameNr_quadToSquare 62822
#define sipName_quadToSquare &sipStrings_QtGui[62822]
#define sipNameNr_squareToQuad 62835
#define sipName_squareToQuad &sipStrings_QtGui[62835]
#define sipNameNr_setAutoRaise 62848
#define sipName_setAutoRaise &sipStrings_QtGui[62848]
#define sipNameNr_setPopupMode 62861
#define sipName_setPopupMode &sipStrings_QtGui[62861]
#define sipNameNr_setArrowType 62874
#define sipName_setArrowType &sipStrings_QtGui[62874]
#define sipNameNr_InstantPopup 62887
#define sipName_InstantPopup &sipStrings_QtGui[62887]
#define sipNameNr_DelayedPopup 62900
#define sipName_DelayedPopup &sipStrings_QtGui[62900]
#define sipNameNr_itemInserted 62913
#define sipName_itemInserted &sipStrings_QtGui[62913]
#define sipNameNr_setFloatable 62926
#define sipName_setFloatable &sipStrings_QtGui[62926]
#define sipNameNr_DelimiterTab 62939
#define sipName_DelimiterTab &sipStrings_QtGui[62939]
#define sipNameNr_WrapAnywhere 62952
#define sipName_WrapAnywhere &sipStrings_QtGui[62952]
#define sipNameNr_setLineCount 62965
#define sipName_setLineCount &sipStrings_QtGui[62965]
#define sipNameNr_setUserState 62978
#define sipName_setUserState &sipStrings_QtGui[62978]
#define sipNameNr_lastPosition 62991
#define sipName_lastPosition &sipStrings_QtGui[62991]
#define sipNameNr_blockRemoved 63004
#define sipName_blockRemoved &sipStrings_QtGui[63004]
#define sipNameNr_cacheEnabled 63017
#define sipName_cacheEnabled &sipStrings_QtGui[63017]
#define sipNameNr_textPosition 63030
#define sipName_textPosition &sipStrings_QtGui[63030]
#define sipNameNr_rightPadding 63043
#define sipName_rightPadding &sipStrings_QtGui[63043]
#define sipNameNr_tabPositions 63056
#define sipName_tabPositions &sipStrings_QtGui[63056]
#define sipNameNr_bottomMargin 63069
#define sipName_bottomMargin &sipStrings_QtGui[63069]
#define sipNameNr_setTopMargin 63082
#define sipName_setTopMargin &sipStrings_QtGui[63082]
#define sipNameNr_fontOverline 63095
#define sipName_fontOverline &sipStrings_QtGui[63095]
#define sipNameNr_toListFormat 63108
#define sipName_toListFormat &sipStrings_QtGui[63108]
#define sipNameNr_toCharFormat 63121
#define sipName_toCharFormat &sipStrings_QtGui[63121]
#define sipNameNr_isListFormat 63134
#define sipName_isListFormat &sipStrings_QtGui[63134]
#define sipNameNr_isCharFormat 63147
#define sipName_isCharFormat &sipStrings_QtGui[63147]
#define sipNameNr_boolProperty 63160
#define sipName_boolProperty &sipStrings_QtGui[63160]
#define sipNameNr_UserProperty 63173
#define sipName_UserProperty &sipStrings_QtGui[63173]
#define sipNameNr_TabPositions 46353
#define sipName_TabPositions &sipStrings_QtGui[46353]
#define sipNameNr_TableColumns 63186
#define sipName_TableColumns &sipStrings_QtGui[63186]
#define sipNameNr_FramePadding 63199
#define sipName_FramePadding &sipStrings_QtGui[63199]
#define sipNameNr_FontOverline 46433
#define sipName_FontOverline &sipStrings_QtGui[46433]
#define sipNameNr_createObject 63212
#define sipName_createObject &sipStrings_QtGui[63212]
#define sipNameNr_UserResource 63225
#define sipName_UserResource &sipStrings_QtGui[63225]
#define sipNameNr_HtmlResource 63238
#define sipName_HtmlResource &sipStrings_QtGui[63238]
#define sipNameNr_ResourceType 10353
#define sipName_ResourceType &sipStrings_QtGui[10353]
#define sipNameNr_FindBackward 63251
#define sipName_FindBackward &sipStrings_QtGui[63251]
#define sipNameNr_endEditBlock 63264
#define sipName_endEditBlock &sipStrings_QtGui[63264]
#define sipNameNr_currentTable 63277
#define sipName_currentTable &sipStrings_QtGui[63277]
#define sipNameNr_atBlockStart 63290
#define sipName_atBlockStart &sipStrings_QtGui[63290]
#define sipNameNr_selectionEnd 63303
#define sipName_selectionEnd &sipStrings_QtGui[63303]
#define sipNameNr_movePosition 63316
#define sipName_movePosition &sipStrings_QtGui[63316]
#define sipNameNr_PreviousCell 63329
#define sipName_PreviousCell &sipStrings_QtGui[63329]
#define sipNameNr_PreviousWord 34331
#define sipName_PreviousWord &sipStrings_QtGui[34331]
#define sipNameNr_StartOfBlock 34274
#define sipName_StartOfBlock &sipStrings_QtGui[34274]
#define sipNameNr_historyTitle 63342
#define sipName_historyTitle &sipStrings_QtGui[63342]
#define sipNameNr_setOpenLinks 63355
#define sipName_setOpenLinks &sipStrings_QtGui[63355]
#define sipNameNr_clearHistory 63368
#define sipName_clearHistory &sipStrings_QtGui[63368]
#define sipNameNr_QTextBrowser 63381
#define sipName_QTextBrowser &sipStrings_QtGui[63381]
#define sipNameNr_visualColumn 63394
#define sipName_visualColumn &sipStrings_QtGui[63394]
#define sipNameNr_QTableWidget 63407
#define sipName_QTableWidget &sipStrings_QtGui[63407]
#define sipNameNr_sortByColumn 63420
#define sipName_sortByColumn &sipStrings_QtGui[63420]
#define sipNameNr_selectColumn 63433
#define sipName_selectColumn &sipStrings_QtGui[63433]
#define sipNameNr_setGridStyle 63446
#define sipName_setGridStyle &sipStrings_QtGui[63446]
#define sipNameNr_setRowHeight 63459
#define sipName_setRowHeight &sipStrings_QtGui[63459]
#define sipNameNr_setExpanding 63472
#define sipName_setExpanding &sipStrings_QtGui[63472]
#define sipNameNr_setTabButton 63485
#define sipName_setTabButton &sipStrings_QtGui[63485]
#define sipNameNr_tabsClosable 63498
#define sipName_tabsClosable &sipStrings_QtGui[63498]
#define sipNameNr_setElideMode 63511
#define sipName_setElideMode &sipStrings_QtGui[63511]
#define sipNameNr_tabWhatsThis 63524
#define sipName_tabWhatsThis &sipStrings_QtGui[63524]
#define sipNameNr_tabTextColor 63537
#define sipName_tabTextColor &sipStrings_QtGui[63537]
#define sipNameNr_isTabEnabled 63550
#define sipName_isTabEnabled &sipStrings_QtGui[63550]
#define sipNameNr_RoundedSouth 63563
#define sipName_RoundedSouth &sipStrings_QtGui[63563]
#define sipNameNr_RoundedNorth 63576
#define sipName_RoundedNorth &sipStrings_QtGui[63576]
#define sipNameNr_currentBlock 63589
#define sipName_currentBlock &sipStrings_QtGui[63589]
#define sipNameNr_dialWrapping 63602
#define sipName_dialWrapping &sipStrings_QtGui[63602]
#define sipNameNr_maxIconWidth 63615
#define sipName_maxIconWidth &sipStrings_QtGui[63615]
#define sipNameNr_menuItemType 63628
#define sipName_menuItemType &sipStrings_QtGui[63628]
#define sipNameNr_NonExclusive 63641
#define sipName_NonExclusive &sipStrings_QtGui[63641]
#define sipNameNr_NotCheckable 63654
#define sipName_NotCheckable &sipStrings_QtGui[63654]
#define sipNameNr_MenuItemType 4597
#define sipName_MenuItemType &sipStrings_QtGui[4597]
#define sipNameNr_CornerWidget 8208
#define sipName_CornerWidget &sipStrings_QtGui[8208]
#define sipNameNr_FrameFeature 5323
#define sipName_FrameFeature &sipStrings_QtGui[5323]
#define sipNameNr_SO_FocusRect 63667
#define sipName_SO_FocusRect &sipStrings_QtGui[63667]
#define sipNameNr_QStyleOption 63680
#define sipName_QStyleOption &sipStrings_QtGui[63680]
#define sipNameNr_SP_MediaStop 63693
#define sipName_SP_MediaStop &sipStrings_QtGui[63693]
#define sipNameNr_SP_MediaPlay 63706
#define sipName_SP_MediaPlay &sipStrings_QtGui[63706]
#define sipNameNr_SP_ArrowBack 63719
#define sipName_SP_ArrowBack &sipStrings_QtGui[63719]
#define sipNameNr_SP_ArrowLeft 63732
#define sipName_SP_ArrowLeft &sipStrings_QtGui[63732]
#define sipNameNr_SP_ArrowDown 63745
#define sipName_SP_ArrowDown &sipStrings_QtGui[63745]
#define sipNameNr_SP_TrashIcon 63758
#define sipName_SP_TrashIcon &sipStrings_QtGui[63758]
#define sipNameNr_SH_Menu_Mask 63771
#define sipName_SH_Menu_Mask &sipStrings_QtGui[63771]
#define sipNameNr_CT_TabWidget 63784
#define sipName_CT_TabWidget &sipStrings_QtGui[63784]
#define sipNameNr_CT_ScrollBar 63797
#define sipName_CT_ScrollBar &sipStrings_QtGui[63797]
#define sipNameNr_CT_TabBarTab 63810
#define sipName_CT_TabBarTab &sipStrings_QtGui[63810]
#define sipNameNr_ContentsType 25075
#define sipName_ContentsType &sipStrings_QtGui[25075]
#define sipNameNr_SC_SpinBoxUp 63823
#define sipName_SC_SpinBoxUp &sipStrings_QtGui[63823]
#define sipNameNr_CC_ScrollBar 63836
#define sipName_CC_ScrollBar &sipStrings_QtGui[63836]
#define sipNameNr_CE_TabBarTab 63849
#define sipName_CE_TabBarTab &sipStrings_QtGui[63849]
#define sipNameNr_PE_PanelMenu 63862
#define sipName_PE_PanelMenu &sipStrings_QtGui[63862]
#define sipNameNr_PE_FrameMenu 63875
#define sipName_PE_FrameMenu &sipStrings_QtGui[63875]
#define sipNameNr_State_Window 63888
#define sipName_State_Window &sipStrings_QtGui[63888]
#define sipNameNr_State_Active 63901
#define sipName_State_Active &sipStrings_QtGui[63901]
#define sipNameNr_State_Bottom 63914
#define sipName_State_Bottom &sipStrings_QtGui[63914]
#define sipNameNr_State_Sunken 63927
#define sipName_State_Sunken &sipStrings_QtGui[63927]
#define sipNameNr_State_Raised 63940
#define sipName_State_Raised &sipStrings_QtGui[63940]
#define sipNameNr_drawItemText 63953
#define sipName_drawItemText &sipStrings_QtGui[63953]
#define sipNameNr_itemTextRect 63966
#define sipName_itemTextRect &sipStrings_QtGui[63966]
#define sipNameNr_sortChildren 63979
#define sipName_sortChildren &sipStrings_QtGui[63979]
#define sipNameNr_isSelectable 63992
#define sipName_isSelectable &sipStrings_QtGui[63992]
#define sipNameNr_appendColumn 64005
#define sipName_appendColumn &sipStrings_QtGui[64005]
#define sipNameNr_stackingMode 64018
#define sipName_stackingMode &sipStrings_QtGui[64018]
#define sipNameNr_StackingMode 9779
#define sipName_StackingMode &sipStrings_QtGui[9779]
#define sipNameNr_moveSplitter 64031
#define sipName_moveSplitter &sipStrings_QtGui[64031]
#define sipNameNr_createHandle 64044
#define sipName_createHandle &sipStrings_QtGui[64044]
#define sipNameNr_opaqueResize 64057
#define sipName_opaqueResize &sipStrings_QtGui[64057]
#define sipNameNr_drawContents 64070
#define sipName_drawContents &sipStrings_QtGui[64070]
#define sipNameNr_clearMessage 64083
#define sipName_clearMessage &sipStrings_QtGui[64083]
#define sipNameNr_filterRegExp 64096
#define sipName_filterRegExp &sipStrings_QtGui[64096]
#define sipNameNr_tickInterval 64109
#define sipName_tickInterval &sipStrings_QtGui[64109]
#define sipNameNr_tickPosition 64122
#define sipName_tickPosition &sipStrings_QtGui[64122]
#define sipNameNr_TickPosition 22246
#define sipName_TickPosition &sipStrings_QtGui[22246]
#define sipNameNr_ControlTypes 13310
#define sipName_ControlTypes &sipStrings_QtGui[13310]
#define sipNameNr_RestartNever 64135
#define sipName_RestartNever &sipStrings_QtGui[64135]
#define sipNameNr_QRadioButton 64148
#define sipName_QRadioButton &sipStrings_QtGui[64148]
#define sipNameNr_setAutoClose 64161
#define sipName_setAutoClose &sipStrings_QtGui[64161]
#define sipNameNr_setAutoReset 64174
#define sipName_setAutoReset &sipStrings_QtGui[64174]
#define sipNameNr_QProgressBar 64187
#define sipName_QProgressBar &sipStrings_QtGui[64187]
#define sipNameNr_AllPagesView 64200
#define sipName_AllPagesView &sipStrings_QtGui[64200]
#define sipNameNr_QPrinterInfo 64213
#define sipName_QPrinterInfo &sipStrings_QtGui[64213]
#define sipNameNr_PPK_PageSize 64226
#define sipName_PPK_PageSize &sipStrings_QtGui[64226]
#define sipNameNr_PPK_PageRect 64239
#define sipName_PPK_PageRect &sipStrings_QtGui[64239]
#define sipNameNr_PPK_FullPage 64252
#define sipName_PPK_FullPage &sipStrings_QtGui[64252]
#define sipNameNr_QPrintEngine 64265
#define sipName_QPrintEngine &sipStrings_QtGui[64265]
#define sipNameNr_QPrintDialog 64278
#define sipName_QPrintDialog &sipStrings_QtGui[64278]
#define sipNameNr_setPaperSize 64291
#define sipName_setPaperSize &sipStrings_QtGui[64291]
#define sipNameNr_outputFormat 64304
#define sipName_outputFormat &sipStrings_QtGui[64304]
#define sipNameNr_printerState 64317
#define sipName_printerState &sipStrings_QtGui[64317]
#define sipNameNr_setNumCopies 64330
#define sipName_setNumCopies &sipStrings_QtGui[64330]
#define sipNameNr_setColorMode 64343
#define sipName_setColorMode &sipStrings_QtGui[64343]
#define sipNameNr_setPageOrder 64356
#define sipName_setPageOrder &sipStrings_QtGui[64356]
#define sipNameNr_printProgram 64369
#define sipName_printProgram &sipStrings_QtGui[64369]
#define sipNameNr_OutputFormat 19791
#define sipName_OutputFormat &sipStrings_QtGui[19791]
#define sipNameNr_PrinterState 19814
#define sipName_PrinterState &sipStrings_QtGui[19814]
#define sipNameNr_centerCursor 64382
#define sipName_centerCursor &sipStrings_QtGui[64382]
#define sipNameNr_tabStopWidth 64395
#define sipName_tabStopWidth &sipStrings_QtGui[64395]
#define sipNameNr_loadResource 64408
#define sipName_loadResource &sipStrings_QtGui[64408]
#define sipNameNr_wordWrapMode 64421
#define sipName_wordWrapMode &sipStrings_QtGui[64421]
#define sipNameNr_lineWrapMode 64434
#define sipName_lineWrapMode &sipStrings_QtGui[64434]
#define sipNameNr_LineWrapMode 9837
#define sipName_LineWrapMode &sipStrings_QtGui[9837]
#define sipNameNr_QPixmapCache 64447
#define sipName_QPixmapCache &sipStrings_QtGui[64447]
#define sipNameNr_defaultDepth 64460
#define sipName_defaultDepth &sipStrings_QtGui[64460]
#define sipNameNr_inputFormats 64473
#define sipName_inputFormats &sipStrings_QtGui[64473]
#define sipNameNr_NColorGroups 64486
#define sipName_NColorGroups &sipStrings_QtGui[64486]
#define sipNameNr_createStroke 64499
#define sipName_createStroke &sipStrings_QtGui[64499]
#define sipNameNr_setJoinStyle 64512
#define sipName_setJoinStyle &sipStrings_QtGui[64512]
#define sipNameNr_addRoundRect 64525
#define sipName_addRoundRect &sipStrings_QtGui[64525]
#define sipNameNr_elementCount 64538
#define sipName_elementCount &sipStrings_QtGui[64538]
#define sipNameNr_closeSubpath 64551
#define sipName_closeSubpath &sipStrings_QtGui[64551]
#define sipNameNr_QPainterPath 64564
#define sipName_QPainterPath &sipStrings_QtGui[64564]
#define sipNameNr_CoreGraphics 64577
#define sipName_CoreGraphics &sipStrings_QtGui[64577]
#define sipNameNr_drawTextItem 64590
#define sipName_drawTextItem &sipStrings_QtGui[64590]
#define sipNameNr_PolylineMode 64603
#define sipName_PolylineMode &sipStrings_QtGui[64603]
#define sipNameNr_DirtyOpacity 64616
#define sipName_DirtyOpacity &sipStrings_QtGui[64616]
#define sipNameNr_PainterPaths 64629
#define sipName_PainterPaths &sipStrings_QtGui[64629]
#define sipNameNr_PatternBrush 64642
#define sipName_PatternBrush &sipStrings_QtGui[64642]
#define sipNameNr_QPaintEngine 64655
#define sipName_QPaintEngine &sipStrings_QtGui[64655]
#define sipNameNr_physicalDpiY 64668
#define sipName_physicalDpiY &sipStrings_QtGui[64668]
#define sipNameNr_physicalDpiX 64681
#define sipName_physicalDpiX &sipStrings_QtGui[64681]
#define sipNameNr_PdmNumColors 64694
#define sipName_PdmNumColors &sipStrings_QtGui[64694]
#define sipNameNr_drawPolyline 64707
#define sipName_drawPolyline &sipStrings_QtGui[64707]
#define sipNameNr_deviceMatrix 64720
#define sipName_deviceMatrix &sipStrings_QtGui[64720]
#define sipNameNr_Antialiasing 13700
#define sipName_Antialiasing &sipStrings_QtGui[13700]
#define sipNameNr_currentImage 64733
#define sipName_currentImage &sipStrings_QtGui[64733]
#define sipNameNr_detailedText 64746
#define sipName_detailedText &sipStrings_QtGui[64746]
#define sipNameNr_escapeButton 64759
#define sipName_escapeButton &sipStrings_QtGui[64759]
#define sipNameNr_standardIcon 64772
#define sipName_standardIcon &sipStrings_QtGui[64772]
#define sipNameNr_setDefaultUp 64785
#define sipName_setDefaultUp &sipStrings_QtGui[64785]
#define sipNameNr_activeAction 64798
#define sipName_activeAction &sipStrings_QtGui[64798]
#define sipNameNr_addSeparator 64811
#define sipName_addSeparator &sipStrings_QtGui[64811]
#define sipNameNr_addSubWindow 64824
#define sipName_addSubWindow &sipStrings_QtGui[64824]
#define sipNameNr_isInvertible 64837
#define sipName_isInvertible &sipStrings_QtGui[64837]
#define sipNameNr_mapToPolygon 64850
#define sipName_mapToPolygon &sipStrings_QtGui[64850]
#define sipNameNr_documentMode 64863
#define sipName_documentMode &sipStrings_QtGui[64863]
#define sipNameNr_toolBarBreak 64876
#define sipName_toolBarBreak &sipStrings_QtGui[64876]
#define sipNameNr_VerticalTabs 64889
#define sipName_VerticalTabs &sipStrings_QtGui[64889]
#define sipNameNr_setStatusBar 64902
#define sipName_setStatusBar &sipStrings_QtGui[64902]
#define sipNameNr_scrollToItem 64915
#define sipName_scrollToItem &sipStrings_QtGui[64915]
#define sipNameNr_isItemHidden 64928
#define sipName_isItemHidden &sipStrings_QtGui[64928]
#define sipNameNr_setTextColor 64941
#define sipName_setTextColor &sipStrings_QtGui[64941]
#define sipNameNr_setBatchSize 64954
#define sipName_setBatchSize &sipStrings_QtGui[64954]
#define sipNameNr_rectForIndex 64967
#define sipName_rectForIndex &sipStrings_QtGui[64967]
#define sipNameNr_indexesMoved 64980
#define sipName_indexesMoved &sipStrings_QtGui[64980]
#define sipNameNr_setRowHidden 64993
#define sipName_setRowHidden &sipStrings_QtGui[64993]
#define sipNameNr_setInputMask 65006
#define sipName_setInputMask &sipStrings_QtGui[65006]
#define sipNameNr_selectedText 65019
#define sipName_selectedText &sipStrings_QtGui[65019]
#define sipNameNr_setMaxLength 65032
#define sipName_setMaxLength &sipStrings_QtGui[65032]
#define sipNameNr_segmentStyle 65045
#define sipName_segmentStyle &sipStrings_QtGui[65045]
#define sipNameNr_setNumDigits 65058
#define sipName_setNumDigits &sipStrings_QtGui[65058]
#define sipNameNr_SegmentStyle 15468
#define sipName_SegmentStyle &sipStrings_QtGui[15468]
#define sipNameNr_controlTypes 65071
#define sipName_controlTypes &sipStrings_QtGui[65071]
#define sipNameNr_removeWidget 65084
#define sipName_removeWidget &sipStrings_QtGui[65084]
#define sipNameNr_SetFixedSize 65097
#define sipName_SetFixedSize &sipStrings_QtGui[65097]
#define sipNameNr_FindPrevious 65110
#define sipName_FindPrevious &sipStrings_QtGui[65110]
#define sipNameNr_HelpContents 65123
#define sipName_HelpContents &sipStrings_QtGui[65123]
#define sipNameNr_PartialMatch 65136
#define sipName_PartialMatch &sipStrings_QtGui[65136]
#define sipNameNr_PortableText 65149
#define sipName_PortableText &sipStrings_QtGui[65149]
#define sipNameNr_okButtonText 65162
#define sipName_okButtonText &sipStrings_QtGui[65162]
#define sipNameNr_textEchoMode 65175
#define sipName_textEchoMode &sipStrings_QtGui[65175]
#define sipNameNr_setTextValue 65188
#define sipName_setTextValue &sipStrings_QtGui[65188]
#define sipNameNr_setInputMode 65201
#define sipName_setInputMode &sipStrings_QtGui[65201]
#define sipNameNr_QInputDialog 65214
#define sipName_QInputDialog &sipStrings_QtGui[65214]
#define sipNameNr_mouseHandler 65227
#define sipName_mouseHandler &sipStrings_QtGui[65227]
#define sipNameNr_QImageWriter 65240
#define sipName_QImageWriter &sipStrings_QtGui[65240]
#define sipNameNr_QImageReader 65253
#define sipName_QImageReader &sipStrings_QtGui[65253]
#define sipNameNr_invertPixels 65266
#define sipName_invertPixels &sipStrings_QtGui[65266]
#define sipNameNr_alphaChannel 65279
#define sipName_alphaChannel &sipStrings_QtGui[65279]
#define sipNameNr_bytesPerLine 65292
#define sipName_bytesPerLine &sipStrings_QtGui[65292]
#define sipNameNr_setNumColors 65305
#define sipName_setNumColors &sipStrings_QtGui[65305]
#define sipNameNr_Format_RGB16 65318
#define sipName_Format_RGB16 &sipStrings_QtGui[65318]
#define sipNameNr_Format_RGB32 65331
#define sipName_Format_RGB32 &sipStrings_QtGui[65331]
#define sipNameNr_QPaintDevice 65344
#define sipName_QPaintDevice &sipStrings_QtGui[65344]
#define sipNameNr_selectedRows 65357
#define sipName_selectedRows &sipStrings_QtGui[65357]
#define sipNameNr_hasSelection 65370
#define sipName_hasSelection &sipStrings_QtGui[65370]
#define sipNameNr_createWidget 65383
#define sipName_createWidget &sipStrings_QtGui[65383]
#define sipNameNr_serialNumber 65396
#define sipName_serialNumber &sipStrings_QtGui[65396]
#define sipNameNr_QIcon__State 65409
#define sipName_QIcon__State &sipStrings_QtGui[65409]
#define sipNameNr_swapSections 65422
#define sipName_swapSections &sipStrings_QtGui[65422]
#define sipNameNr_paintSection 65435
#define sipName_paintSection &sipStrings_QtGui[65435]
#define sipNameNr_sectionMoved 65448
#define sipName_sectionMoved &sipStrings_QtGui[65448]
#define sipNameNr_setClickable 65461
#define sipName_setClickable &sipStrings_QtGui[65461]
#define sipNameNr_logicalIndex 65474
#define sipName_logicalIndex &sipStrings_QtGui[65474]
#define sipNameNr_originCorner 65487
#define sipName_originCorner &sipStrings_QtGui[65487]
#define sipNameNr_resizeAnchor 65500
#define sipName_resizeAnchor &sipStrings_QtGui[65500]
#define sipNameNr_lastScenePos 65513
#define sipName_lastScenePos &sipStrings_QtGui[65513]
#define sipNameNr_insertAction 65526
#define sipName_insertAction &sipStrings_QtGui[65526]
#define sipNameNr_grabShortcut 65539
#define sipName_grabShortcut &sipStrings_QtGui[65539]
#define sipNameNr_bspTreeDepth 65552
#define sipName_bspTreeDepth &sipStrings_QtGui[65552]
#define sipNameNr_setFocusItem 65565
#define sipName_setFocusItem &sipStrings_QtGui[65565]
#define sipNameNr_setSceneRect 65578
#define sipName_setSceneRect &sipStrings_QtGui[65578]
#define sipNameNr_BspTreeIndex 65591
#define sipName_BspTreeIndex &sipStrings_QtGui[65591]
#define sipNameNr_graphicsItem 65604
#define sipName_graphicsItem &sipStrings_QtGui[65604]
#define sipNameNr_maximumWidth 65617
#define sipName_maximumWidth &sipStrings_QtGui[65617]
#define sipNameNr_minimumWidth 65630
#define sipName_minimumWidth &sipStrings_QtGui[65630]
#define sipNameNr_contentsRect 65643
#define sipName_contentsRect &sipStrings_QtGui[65643]
#define sipNameNr_rotationList 65656
#define sipName_rotationList &sipStrings_QtGui[65656]
#define sipNameNr_setTextWidth 65669
#define sipName_setTextWidth &sipStrings_QtGui[65669]
#define sipNameNr_setPlainText 65682
#define sipName_setPlainText &sipStrings_QtGui[65682]
#define sipNameNr_setShapeMode 65695
#define sipName_setShapeMode &sipStrings_QtGui[65695]
#define sipNameNr_setSpanAngle 65708
#define sipName_setSpanAngle &sipStrings_QtGui[65708]
#define sipNameNr_isUnderMouse 65721
#define sipName_isUnderMouse &sipStrings_QtGui[65721]
#define sipNameNr_grabKeyboard 55033
#define sipName_grabKeyboard &sipStrings_QtGui[55033]
#define sipNameNr_setCacheMode 65734
#define sipName_setCacheMode &sipStrings_QtGui[65734]
#define sipNameNr_isAncestorOf 65747
#define sipName_isAncestorOf &sipStrings_QtGui[65747]
#define sipNameNr_mapFromScene 65760
#define sipName_mapFromScene &sipStrings_QtGui[65760]
#define sipNameNr_isObscuredBy 65773
#define sipName_isObscuredBy &sipStrings_QtGui[65773]
#define sipNameNr_topLevelItem 65786
#define sipName_topLevelItem &sipStrings_QtGui[65786]
#define sipNameNr_rowAlignment 14743
#define sipName_rowAlignment &sipStrings_QtGui[14743]
#define sipNameNr_setFrameRect 65799
#define sipName_setFrameRect &sipStrings_QtGui[65799]
#define sipNameNr_midLineWidth 65812
#define sipName_midLineWidth &sipStrings_QtGui[65812]
#define sipNameNr_setLineWidth 65825
#define sipName_setLineWidth &sipStrings_QtGui[65825]
#define sipNameNr_SpanningRole 65838
#define sipName_SpanningRole &sipStrings_QtGui[65838]
#define sipNameNr_WrapLongRows 65851
#define sipName_WrapLongRows &sipStrings_QtGui[65851]
#define sipNameNr_DontWrapRows 65864
#define sipName_DontWrapRows &sipStrings_QtGui[65864]
#define sipNameNr_strikeOutPos 65877
#define sipName_strikeOutPos &sipStrings_QtGui[65877]
#define sipNameNr_underlinePos 65890
#define sipName_underlinePos &sipStrings_QtGui[65890]
#define sipNameNr_boundingRect 65903
#define sipName_boundingRect &sipStrings_QtGui[65903]
#define sipNameNr_rightBearing 65916
#define sipName_rightBearing &sipStrings_QtGui[65916]
#define sipNameNr_QFontMetrics 65929
#define sipName_QFontMetrics &sipStrings_QtGui[65929]
#define sipNameNr_fontSelected 65942
#define sipName_fontSelected &sipStrings_QtGui[65942]
#define sipNameNr_selectedFont 65955
#define sipName_selectedFont &sipStrings_QtGui[65955]
#define sipNameNr_isFixedPitch 65968
#define sipName_isFixedPitch &sipStrings_QtGui[65968]
#define sipNameNr_AllLowercase 65981
#define sipName_AllLowercase &sipStrings_QtGui[65981]
#define sipNameNr_AllUppercase 65994
#define sipName_AllUppercase &sipStrings_QtGui[65994]
#define sipNameNr_setStyleHint 66007
#define sipName_setStyleHint &sipStrings_QtGui[66007]
#define sipNameNr_setStrikeOut 66020
#define sipName_setStrikeOut &sipStrings_QtGui[66020]
#define sipNameNr_setUnderline 66033
#define sipName_setUnderline &sipStrings_QtGui[66033]
#define sipNameNr_setPixelSize 66046
#define sipName_setPixelSize &sipStrings_QtGui[66046]
#define sipNameNr_setPointSize 66059
#define sipName_setPointSize &sipStrings_QtGui[66059]
#define sipNameNr_SemiExpanded 66072
#define sipName_SemiExpanded &sipStrings_QtGui[66072]
#define sipNameNr_StyleOblique 66085
#define sipName_StyleOblique &sipStrings_QtGui[66085]
#define sipNameNr_QFont__Style 66098
#define sipName_QFont__Style &sipStrings_QtGui[66098]
#define sipNameNr_ForceOutline 66111
#define sipName_ForceOutline &sipStrings_QtGui[66111]
#define sipNameNr_PreferDevice 66124
#define sipName_PreferDevice &sipStrings_QtGui[66124]
#define sipNameNr_PreferBitmap 66137
#define sipName_PreferBitmap &sipStrings_QtGui[66137]
#define sipNameNr_restoreState 66150
#define sipName_restoreState &sipStrings_QtGui[66150]
#define sipNameNr_fileSelected 66163
#define sipName_fileSelected &sipStrings_QtGui[66163]
#define sipNameNr_setLabelText 66176
#define sipName_setLabelText &sipStrings_QtGui[66176]
#define sipNameNr_selectFilter 66189
#define sipName_selectFilter &sipStrings_QtGui[66189]
#define sipNameNr_setDirectory 66202
#define sipName_setDirectory &sipStrings_QtGui[66202]
#define sipNameNr_ShowDirsOnly 66215
#define sipName_ShowDirsOnly &sipStrings_QtGui[66215]
#define sipNameNr_ExistingFile 66228
#define sipName_ExistingFile &sipStrings_QtGui[66228]
#define sipNameNr_QActionEvent 66241
#define sipName_QActionEvent &sipStrings_QtGui[66241]
#define sipNameNr_commitString 66254
#define sipName_commitString &sipStrings_QtGui[66254]
#define sipNameNr_QResizeEvent 66267
#define sipName_QResizeEvent &sipStrings_QtGui[66267]
#define sipNameNr_isAutoRepeat 66280
#define sipName_isAutoRepeat &sipStrings_QtGui[66280]
#define sipNameNr_hiResGlobalY 66293
#define sipName_hiResGlobalY &sipStrings_QtGui[66293]
#define sipNameNr_hiResGlobalX 66306
#define sipName_hiResGlobalX &sipStrings_QtGui[66306]
#define sipNameNr_TabletDevice 12161
#define sipName_TabletDevice &sipStrings_QtGui[12161]
#define sipNameNr_QTabletEvent 66319
#define sipName_QTabletEvent &sipStrings_QtGui[66319]
#define sipNameNr_allowedAreas 66332
#define sipName_allowedAreas &sipStrings_QtGui[66332]
#define sipNameNr_iconProvider 66345
#define sipName_iconProvider &sipStrings_QtGui[66345]
#define sipNameNr_FileNameRole 66358
#define sipName_FileNameRole &sipStrings_QtGui[66358]
#define sipNameNr_FilePathRole 66371
#define sipName_FilePathRole &sipStrings_QtGui[66371]
#define sipNameNr_FileIconRole 66384
#define sipName_FileIconRole &sipStrings_QtGui[66384]
#define sipNameNr_ButtonLayout 7995
#define sipName_ButtonLayout &sipStrings_QtGui[7995]
#define sipNameNr_setExtension 66397
#define sipName_setExtension &sipStrings_QtGui[66397]
#define sipNameNr_screenNumber 66410
#define sipName_screenNumber &sipStrings_QtGui[66410]
#define sipNameNr_DataLocation 66423
#define sipName_DataLocation &sipStrings_QtGui[66423]
#define sipNameNr_HomeLocation 66436
#define sipName_HomeLocation &sipStrings_QtGui[66436]
#define sipNameNr_TempLocation 66449
#define sipName_TempLocation &sipStrings_QtGui[66449]
#define sipNameNr_sectionCount 66462
#define sipName_sectionCount &sipStrings_QtGui[66462]
#define sipNameNr_setTimeRange 66475
#define sipName_setTimeRange &sipStrings_QtGui[66475]
#define sipNameNr_MonthSection 66488
#define sipName_MonthSection &sipStrings_QtGui[66488]
#define sipNameNr_clearMapping 66501
#define sipName_clearMapping &sipStrings_QtGui[66501]
#define sipNameNr_submitPolicy 66514
#define sipName_submitPolicy &sipStrings_QtGui[66514]
#define sipNameNr_ManualSubmit 66527
#define sipName_ManualSubmit &sipStrings_QtGui[66527]
#define sipNameNr_SubmitPolicy 6997
#define sipName_SubmitPolicy &sipStrings_QtGui[6997]
#define sipNameNr_modelSorting 66540
#define sipName_modelSorting &sipStrings_QtGui[66540]
#define sipNameNr_ModelSorting 15818
#define sipName_ModelSorting &sipStrings_QtGui[15818]
#define sipNameNr_setCompleter 66553
#define sipName_setCompleter &sipStrings_QtGui[66553]
#define sipNameNr_setValidator 66566
#define sipName_setValidator &sipStrings_QtGui[66566]
#define sipNameNr_insertPolicy 66579
#define sipName_insertPolicy &sipStrings_QtGui[66579]
#define sipNameNr_InsertPolicy 18032
#define sipName_InsertPolicy &sipStrings_QtGui[18032]
#define sipNameNr_currentColor 66592
#define sipName_currentColor &sipStrings_QtGui[66592]
#define sipNameNr_QColorDialog 66605
#define sipName_QColorDialog &sipStrings_QtGui[66605]
#define sipNameNr_createColumn 66618
#define sipName_createColumn &sipStrings_QtGui[66618]
#define sipNameNr_columnWidths 66631
#define sipName_columnWidths &sipStrings_QtGui[66631]
#define sipNameNr_showNextYear 66644
#define sipName_showNextYear &sipStrings_QtGui[66644]
#define sipNameNr_setDateRange 66657
#define sipName_setDateRange &sipStrings_QtGui[66657]
#define sipNameNr_selectedDate 66670
#define sipName_selectedDate &sipStrings_QtGui[66670]
#define sipNameNr_LongDayNames 66683
#define sipName_LongDayNames &sipStrings_QtGui[66683]
#define sipNameNr_removeButton 66696
#define sipName_removeButton &sipStrings_QtGui[66696]
#define sipNameNr_QButtonGroup 66709
#define sipName_QButtonGroup &sipStrings_QtGui[66709]
#define sipNameNr_setFinalStop 66722
#define sipName_setFinalStop &sipStrings_QtGui[66722]
#define sipNameNr_RepeatSpread 66735
#define sipName_RepeatSpread &sipStrings_QtGui[66735]
#define sipNameNr_setTransform 55063
#define sipName_setTransform &sipStrings_QtGui[55063]
#define sipNameNr_textureImage 66748
#define sipName_textureImage &sipStrings_QtGui[66748]
#define sipNameNr_QColor__Spec 66761
#define sipName_QColor__Spec &sipStrings_QtGui[66761]
#define sipNameNr_insertLayout 66774
#define sipName_insertLayout &sipStrings_QtGui[66774]
#define sipNameNr_insertWidget 66787
#define sipName_insertWidget &sipStrings_QtGui[66787]
#define sipNameNr_focusChanged 66800
#define sipName_focusChanged &sipStrings_QtGui[66800]
#define sipNameNr_inputContext 66813
#define sipName_inputContext &sipStrings_QtGui[66813]
#define sipNameNr_mouseButtons 66826
#define sipName_mouseButtons &sipStrings_QtGui[66826]
#define sipNameNr_activeWindow 66839
#define sipName_activeWindow &sipStrings_QtGui[66839]
#define sipNameNr_setColorSpec 66852
#define sipName_setColorSpec &sipStrings_QtGui[66852]
#define sipNameNr_QApplication 66865
#define sipName_QApplication &sipStrings_QtGui[66865]
#define sipNameNr_setExclusive 66878
#define sipName_setExclusive &sipStrings_QtGui[66878]
#define sipNameNr_removeAction 66891
#define sipName_removeAction &sipStrings_QtGui[66891]
#define sipNameNr_QActionGroup 66904
#define sipName_QActionGroup &sipStrings_QtGui[66904]
#define sipNameNr_setShortcuts 66917
#define sipName_setShortcuts &sipStrings_QtGui[66917]
#define sipNameNr_parentWidget 66930
#define sipName_parentWidget &sipStrings_QtGui[66930]
#define sipNameNr_setSeparator 66943
#define sipName_setSeparator &sipStrings_QtGui[66943]
#define sipNameNr_setWhatsThis 66956
#define sipName_setWhatsThis &sipStrings_QtGui[66956]
#define sipNameNr_setStatusTip 66969
#define sipName_setStatusTip &sipStrings_QtGui[66969]
#define sipNameNr_sliderChange 66982
#define sipName_sliderChange &sipStrings_QtGui[66982]
#define sipNameNr_SliderChange 9078
#define sipName_SliderChange &sipStrings_QtGui[9078]
#define sipNameNr_repeatAction 66995
#define sipName_repeatAction &sipStrings_QtGui[66995]
#define sipNameNr_rangeChanged 67008
#define sipName_rangeChanged &sipStrings_QtGui[67008]
#define sipNameNr_SliderAction 9108
#define sipName_SliderAction &sipStrings_QtGui[9108]
#define sipNameNr_isSliderDown 67021
#define sipName_isSliderDown &sipStrings_QtGui[67021]
#define sipNameNr_documentSize 67034
#define sipName_documentSize &sipStrings_QtGui[67034]
#define sipNameNr_PaintContext 1217
#define sipName_PaintContext &sipStrings_QtGui[1217]
#define sipNameNr_setAlignment 67047
#define sipName_setAlignment &sipStrings_QtGui[67047]
#define sipNameNr_UpDownArrows 67060
#define sipName_UpDownArrows &sipStrings_QtGui[67060]
#define sipNameNr_cornerWidget 67073
#define sipName_cornerWidget &sipStrings_QtGui[67073]
#define sipNameNr_DontUseSheet 67086
#define sipName_DontUseSheet &sipStrings_QtGui[67086]
#define sipNameNr_dragDropMode 67099
#define sipName_dragDropMode &sipStrings_QtGui[67099]
#define sipNameNr_EditingState 67112
#define sipName_EditingState &sipStrings_QtGui[67112]
#define sipNameNr_setSelection 67125
#define sipName_setSelection &sipStrings_QtGui[67125]
#define sipNameNr_MovePrevious 67138
#define sipName_MovePrevious &sipStrings_QtGui[67138]
#define sipNameNr_MovePageDown 67151
#define sipName_MovePageDown &sipStrings_QtGui[67151]
#define sipNameNr_CursorAction 7093
#define sipName_CursorAction &sipStrings_QtGui[7093]
#define sipNameNr_setRootIndex 67164
#define sipName_setRootIndex &sipStrings_QtGui[67164]
#define sipNameNr_editTriggers 67177
#define sipName_editTriggers &sipStrings_QtGui[67177]
#define sipNameNr_currentIndex 67190
#define sipName_currentIndex &sipStrings_QtGui[67190]
#define sipNameNr_itemDelegate 67203
#define sipName_itemDelegate &sipStrings_QtGui[67203]
#define sipNameNr_EditTriggers 7157
#define sipName_EditTriggers &sipStrings_QtGui[7157]
#define sipNameNr_InternalMove 67216
#define sipName_InternalMove &sipStrings_QtGui[67216]
#define sipNameNr_DragDropMode 7189
#define sipName_DragDropMode &sipStrings_QtGui[7189]
#define sipNameNr_setModelData 67229
#define sipName_setModelData &sipStrings_QtGui[67229]
#define sipNameNr_createEditor 67242
#define sipName_createEditor &sipStrings_QtGui[67242]
#define sipNameNr_EditNextItem 67255
#define sipName_EditNextItem &sipStrings_QtGui[67255]
#define sipNameNr_focusInEvent 67268
#define sipName_focusInEvent &sipStrings_QtGui[67268]
#define sipNameNr_animateClick 67281
#define sipName_animateClick &sipStrings_QtGui[67281]
#define sipNameNr_setCheckable 67294
#define sipName_setCheckable &sipStrings_QtGui[67294]
#define sipNameNr_columnNumber 67307
#define sipName_columnNumber &sipStrings_QtGui[67307]
#define sipNameNr_loadFromData 67320
#define sipName_loadFromData &sipStrings_QtGui[67320]
#define sipNameNr_valueChanged 67333
#define sipName_valueChanged &sipStrings_QtGui[67333]
#define sipNameNr_frameChanged 67346
#define sipName_frameChanged &sipStrings_QtGui[67346]
#define sipNameNr_currentFrame 67359
#define sipName_currentFrame &sipStrings_QtGui[67359]
#define sipNameNr_setDirection 67372
#define sipName_setDirection &sipStrings_QtGui[67372]
#define sipNameNr_NativeFormat 67385
#define sipName_NativeFormat &sipStrings_QtGui[67385]
#define sipNameNr_stateChanged 67398
#define sipName_stateChanged &sipStrings_QtGui[67398]
#define sipNameNr_UnknownError 67411
#define sipName_UnknownError &sipStrings_QtGui[67411]
#define sipNameNr_QKeySequence 67424
#define sipName_QKeySequence &sipStrings_QtGui[67424]
#define sipNameNr_lastModified 67437
#define sipName_lastModified &sipStrings_QtGui[67437]
#define sipNameNr_IteratorFlag 2861
#define sipName_IteratorFlag &sipStrings_QtGui[2861]
#define sipNameNr_setAttribute 67450
#define sipName_setAttribute &sipStrings_QtGui[67450]
#define sipNameNr___contains__ 67463
#define sipName___contains__ &sipStrings_QtGui[67463]
#define sipNameNr_removeColumn 67476
#define sipName_removeColumn &sipStrings_QtGui[67476]
#define sipNameNr_insertColumn 67489
#define sipName_insertColumn &sipStrings_QtGui[67489]
#define sipNameNr_rowsInserted 67502
#define sipName_rowsInserted &sipStrings_QtGui[67502]
#define sipNameNr_canFetchMore 67515
#define sipName_canFetchMore &sipStrings_QtGui[67515]
#define sipNameNr_dropMimeData 67528
#define sipName_dropMimeData &sipStrings_QtGui[67528]
#define sipNameNr_appUserTime 67541
#define sipName_appUserTime &sipStrings_QtGui[67541]
#define sipNameNr_appColormap 67553
#define sipName_appColormap &sipStrings_QtGui[67553]
#define sipNameNr_embedClient 67565
#define sipName_embedClient &sipStrings_QtGui[67565]
#define sipNameNr_clientWinId 67577
#define sipName_clientWinId &sipStrings_QtGui[67577]
#define sipNameNr_isFinalPage 67589
#define sipName_isFinalPage &sipStrings_QtGui[67589]
#define sipNameNr_setSubTitle 67601
#define sipName_setSubTitle &sipStrings_QtGui[67601]
#define sipNameNr_QWizardPage 67613
#define sipName_QWizardPage &sipStrings_QtGui[67613]
#define sipNameNr_cleanupPage 67625
#define sipName_cleanupPage &sipStrings_QtGui[67625]
#define sipNameNr_titleFormat 67637
#define sipName_titleFormat &sipStrings_QtGui[67637]
#define sipNameNr_wizardStyle 67649
#define sipName_wizardStyle &sipStrings_QtGui[67649]
#define sipNameNr_ModernStyle 67661
#define sipName_ModernStyle &sipStrings_QtGui[67661]
#define sipNameNr_WizardStyle 24047
#define sipName_WizardStyle &sipStrings_QtGui[24047]
#define sipNameNr_unsetLocale 67673
#define sipName_unsetLocale &sipStrings_QtGui[67673]
#define sipNameNr_tabletEvent 67685
#define sipName_tabletEvent &sipStrings_QtGui[67685]
#define sipNameNr_windowState 67697
#define sipName_windowState &sipStrings_QtGui[67697]
#define sipNameNr_isMaximized 67709
#define sipName_isMaximized &sipStrings_QtGui[67709]
#define sipNameNr_isMinimized 67721
#define sipName_isMinimized &sipStrings_QtGui[67721]
#define sipNameNr_mapToGlobal 67733
#define sipName_mapToGlobal &sipStrings_QtGui[67733]
#define sipNameNr_setBaseSize 67745
#define sipName_setBaseSize &sipStrings_QtGui[67745]
#define sipNameNr_isEnabledTo 67757
#define sipName_isEnabledTo &sipStrings_QtGui[67757]
#define sipNameNr_setNotation 67769
#define sipName_setNotation &sipStrings_QtGui[67769]
#define sipNameNr_activeStack 67781
#define sipName_activeStack &sipStrings_QtGui[67781]
#define sipNameNr_removeStack 67793
#define sipName_removeStack &sipStrings_QtGui[67793]
#define sipNameNr_NotEditable 67805
#define sipName_NotEditable &sipStrings_QtGui[67805]
#define sipNameNr_HasChildren 67817
#define sipName_HasChildren &sipStrings_QtGui[67817]
#define sipNameNr_DropEnabled 53039
#define sipName_DropEnabled &sipStrings_QtGui[53039]
#define sipNameNr_DragEnabled 56489
#define sipName_DragEnabled &sipStrings_QtGui[56489]
#define sipNameNr_QTreeWidget 67829
#define sipName_QTreeWidget &sipStrings_QtGui[67829]
#define sipNameNr_removeChild 67841
#define sipName_removeChild &sipStrings_QtGui[67841]
#define sipNameNr_addChildren 67853
#define sipName_addChildren &sipStrings_QtGui[67853]
#define sipNameNr_insertChild 67865
#define sipName_insertChild &sipStrings_QtGui[67865]
#define sipNameNr_collapseAll 67877
#define sipName_collapseAll &sipStrings_QtGui[67877]
#define sipNameNr_setExpanded 67889
#define sipName_setExpanded &sipStrings_QtGui[67889]
#define sipNameNr_indentation 67901
#define sipName_indentation &sipStrings_QtGui[67901]
#define sipNameNr_determinant 67913
#define sipName_determinant &sipStrings_QtGui[67913]
#define sipNameNr_TxTranslate 67925
#define sipName_TxTranslate &sipStrings_QtGui[67925]
#define sipNameNr_QToolButton 67937
#define sipName_QToolButton &sipStrings_QtGui[67937]
#define sipNameNr_itemRemoved 67949
#define sipName_itemRemoved &sipStrings_QtGui[67949]
#define sipNameNr_itemToolTip 67961
#define sipName_itemToolTip &sipStrings_QtGui[67961]
#define sipNameNr_isFloatable 67973
#define sipName_isFloatable &sipStrings_QtGui[67973]
#define sipNameNr_setTabArray 67985
#define sipName_setTabArray &sipStrings_QtGui[67985]
#define sipNameNr_setWrapMode 67997
#define sipName_setWrapMode &sipStrings_QtGui[67997]
#define sipNameNr_QTextOption 68009
#define sipName_QTextOption &sipStrings_QtGui[68009]
#define sipNameNr_setRevision 68021
#define sipName_setRevision &sipStrings_QtGui[68021]
#define sipNameNr_setUserData 68033
#define sipName_setUserData &sipStrings_QtGui[68033]
#define sipNameNr_parentFrame 68045
#define sipName_parentFrame &sipStrings_QtGui[68045]
#define sipNameNr_childFrames 68057
#define sipName_childFrames &sipStrings_QtGui[68057]
#define sipNameNr_frameFormat 68069
#define sipName_frameFormat &sipStrings_QtGui[68069]
#define sipNameNr_QTextObject 68081
#define sipName_QTextObject &sipStrings_QtGui[68081]
#define sipNameNr_clearLayout 68093
#define sipName_clearLayout &sipStrings_QtGui[68093]
#define sipNameNr_beginLayout 68105
#define sipName_beginLayout &sipStrings_QtGui[68105]
#define sipNameNr_FormatRange 14269
#define sipName_FormatRange &sipStrings_QtGui[14269]
#define sipNameNr_QTextLayout 68117
#define sipName_QTextLayout &sipStrings_QtGui[68117]
#define sipNameNr_formatIndex 68129
#define sipName_formatIndex &sipStrings_QtGui[68129]
#define sipNameNr_leftPadding 68141
#define sipName_leftPadding &sipStrings_QtGui[68141]
#define sipNameNr_cellPadding 68153
#define sipName_cellPadding &sipStrings_QtGui[68153]
#define sipNameNr_cellSpacing 68165
#define sipName_cellSpacing &sipStrings_QtGui[68165]
#define sipNameNr_borderStyle 68177
#define sipName_borderStyle &sipStrings_QtGui[68177]
#define sipNameNr_borderBrush 68189
#define sipName_borderBrush &sipStrings_QtGui[68189]
#define sipNameNr_BorderStyle 8149
#define sipName_BorderStyle &sipStrings_QtGui[8149]
#define sipNameNr_ListDecimal 68201
#define sipName_ListDecimal &sipStrings_QtGui[68201]
#define sipNameNr_rightMargin 68213
#define sipName_rightMargin &sipStrings_QtGui[68213]
#define sipNameNr_fontKerning 68225
#define sipName_fontKerning &sipStrings_QtGui[68225]
#define sipNameNr_anchorNames 68237
#define sipName_anchorNames &sipStrings_QtGui[68237]
#define sipNameNr_NoUnderline 68249
#define sipName_NoUnderline &sipStrings_QtGui[68249]
#define sipNameNr_textOutline 68261
#define sipName_textOutline &sipStrings_QtGui[68261]
#define sipNameNr_AlignMiddle 68273
#define sipName_AlignMiddle &sipStrings_QtGui[68273]
#define sipNameNr_AlignNormal 68285
#define sipName_AlignNormal &sipStrings_QtGui[68285]
#define sipNameNr_penProperty 68297
#define sipName_penProperty &sipStrings_QtGui[68297]
#define sipNameNr_intProperty 68309
#define sipName_intProperty &sipStrings_QtGui[68309]
#define sipNameNr_hasProperty 68321
#define sipName_hasProperty &sipStrings_QtGui[68321]
#define sipNameNr_objectIndex 68333
#define sipName_objectIndex &sipStrings_QtGui[68333]
#define sipNameNr_FontKerning 51674
#define sipName_FontKerning &sipStrings_QtGui[51674]
#define sipNameNr_TextToolTip 68345
#define sipName_TextToolTip &sipStrings_QtGui[68345]
#define sipNameNr_ImageHeight 68357
#define sipName_ImageHeight &sipStrings_QtGui[68357]
#define sipNameNr_FrameHeight 68369
#define sipName_FrameHeight &sipStrings_QtGui[68369]
#define sipNameNr_FrameMargin 68381
#define sipName_FrameMargin &sipStrings_QtGui[68381]
#define sipNameNr_FrameBorder 68393
#define sipName_FrameBorder &sipStrings_QtGui[68393]
#define sipNameNr_TextOutline 51719
#define sipName_TextOutline &sipStrings_QtGui[51719]
#define sipNameNr_BlockIndent 68405
#define sipName_BlockIndent &sipStrings_QtGui[68405]
#define sipNameNr_ObjectIndex 51824
#define sipName_ObjectIndex &sipStrings_QtGui[51824]
#define sipNameNr_TableObject 68417
#define sipName_TableObject &sipStrings_QtGui[68417]
#define sipNameNr_ImageObject 68429
#define sipName_ImageObject &sipStrings_QtGui[68429]
#define sipNameNr_ObjectTypes 14294
#define sipName_ObjectTypes &sipStrings_QtGui[14294]
#define sipNameNr_FrameFormat 41344
#define sipName_FrameFormat &sipStrings_QtGui[41344]
#define sipNameNr_TableFormat 41310
#define sipName_TableFormat &sipStrings_QtGui[41310]
#define sipNameNr_BlockFormat 41378
#define sipName_BlockFormat &sipStrings_QtGui[41378]
#define sipNameNr_FixedLength 68441
#define sipName_FixedLength &sipStrings_QtGui[68441]
#define sipNameNr_characterAt 68453
#define sipName_characterAt &sipStrings_QtGui[68453]
#define sipNameNr_indentWidth 68465
#define sipName_indentWidth &sipStrings_QtGui[68465]
#define sipNameNr_addResource 68477
#define sipName_addResource &sipStrings_QtGui[68477]
#define sipNameNr_defaultFont 68489
#define sipName_defaultFont &sipStrings_QtGui[68489]
#define sipNameNr_DocumentUrl 68501
#define sipName_DocumentUrl &sipStrings_QtGui[68501]
#define sipNameNr_blockNumber 68513
#define sipName_blockNumber &sipStrings_QtGui[68513]
#define sipNameNr_insertImage 68525
#define sipName_insertImage &sipStrings_QtGui[68525]
#define sipNameNr_insertFrame 68537
#define sipName_insertFrame &sipStrings_QtGui[68537]
#define sipNameNr_insertTable 68549
#define sipName_insertTable &sipStrings_QtGui[68549]
#define sipNameNr_currentList 68561
#define sipName_currentList &sipStrings_QtGui[68561]
#define sipNameNr_insertBlock 68573
#define sipName_insertBlock &sipStrings_QtGui[68573]
#define sipNameNr_blockFormat 68585
#define sipName_blockFormat &sipStrings_QtGui[68585]
#define sipNameNr_PreviousRow 68597
#define sipName_PreviousRow &sipStrings_QtGui[68597]
#define sipNameNr_StartOfWord 38728
#define sipName_StartOfWord &sipStrings_QtGui[38728]
#define sipNameNr_StartOfLine 38746
#define sipName_StartOfLine &sipStrings_QtGui[38746]
#define sipNameNr_QTextCursor 68609
#define sipName_QTextCursor &sipStrings_QtGui[68609]
#define sipNameNr_cellChanged 68621
#define sipName_cellChanged &sipStrings_QtGui[68621]
#define sipNameNr_cellEntered 68633
#define sipName_cellEntered &sipStrings_QtGui[68633]
#define sipNameNr_cellClicked 68645
#define sipName_cellClicked &sipStrings_QtGui[68645]
#define sipNameNr_cellPressed 68657
#define sipName_cellPressed &sipStrings_QtGui[68657]
#define sipNameNr_tableWidget 68669
#define sipName_tableWidget &sipStrings_QtGui[68669]
#define sipNameNr_rightColumn 68681
#define sipName_rightColumn &sipStrings_QtGui[68681]
#define sipNameNr_columnMoved 68693
#define sipName_columnMoved &sipStrings_QtGui[68693]
#define sipNameNr_setShowGrid 68705
#define sipName_setShowGrid &sipStrings_QtGui[68705]
#define sipNameNr_columnWidth 68717
#define sipName_columnWidth &sipStrings_QtGui[68717]
#define sipNameNr_tabInserted 68729
#define sipName_tabInserted &sipStrings_QtGui[68729]
#define sipNameNr_tabSizeHint 68741
#define sipName_tabSizeHint &sipStrings_QtGui[68741]
#define sipNameNr_setDrawBase 68753
#define sipName_setDrawBase &sipStrings_QtGui[68753]
#define sipNameNr_RoundedEast 68765
#define sipName_RoundedEast &sipStrings_QtGui[68765]
#define sipNameNr_RoundedWest 68777
#define sipName_RoundedWest &sipStrings_QtGui[68777]
#define sipNameNr_contextMenu 68789
#define sipName_contextMenu &sipStrings_QtGui[68789]
#define sipNameNr_MessageIcon 9432
#define sipName_MessageIcon &sipStrings_QtGui[9432]
#define sipNameNr_MiddleClick 68801
#define sipName_MiddleClick &sipStrings_QtGui[68801]
#define sipNameNr_DoubleClick 16233
#define sipName_DoubleClick &sipStrings_QtGui[16233]
#define sipNameNr_rehighlight 68813
#define sipName_rehighlight &sipStrings_QtGui[68813]
#define sipNameNr_exposedRect 68825
#define sipName_exposedRect &sipStrings_QtGui[68825]
#define sipNameNr_currentIcon 68837
#define sipName_currentIcon &sipStrings_QtGui[68837]
#define sipNameNr_sliderValue 68849
#define sipName_sliderValue &sipStrings_QtGui[68849]
#define sipNameNr_subControls 68861
#define sipName_subControls &sipStrings_QtGui[68861]
#define sipNameNr_DefaultItem 68873
#define sipName_DefaultItem &sipStrings_QtGui[68873]
#define sipNameNr_bottomToTop 68885
#define sipName_bottomToTop &sipStrings_QtGui[68885]
#define sipNameNr_textVisible 68897
#define sipName_textVisible &sipStrings_QtGui[68897]
#define sipNameNr_TabPosition 4563
#define sipName_TabPosition &sipStrings_QtGui[4563]
#define sipNameNr_NotAdjacent 68909
#define sipName_NotAdjacent &sipStrings_QtGui[68909]
#define sipNameNr_SO_SizeGrip 68921
#define sipName_SO_SizeGrip &sipStrings_QtGui[68921]
#define sipNameNr_SO_GroupBox 68933
#define sipName_SO_GroupBox &sipStrings_QtGui[68933]
#define sipNameNr_SO_TitleBar 68945
#define sipName_SO_TitleBar &sipStrings_QtGui[68945]
#define sipNameNr_SO_ComboBox 68957
#define sipName_SO_ComboBox &sipStrings_QtGui[68957]
#define sipNameNr_SO_ViewItem 68969
#define sipName_SO_ViewItem &sipStrings_QtGui[68969]
#define sipNameNr_SO_MenuItem 68981
#define sipName_SO_MenuItem &sipStrings_QtGui[68981]
#define sipNameNr_alignedRect 68993
#define sipName_alignedRect &sipStrings_QtGui[68993]
#define sipNameNr_SP_FileIcon 69005
#define sipName_SP_FileIcon &sipStrings_QtGui[69005]
#define sipNameNr_CT_GroupBox 69017
#define sipName_CT_GroupBox &sipStrings_QtGui[69017]
#define sipNameNr_CT_SizeGrip 69029
#define sipName_CT_SizeGrip &sipStrings_QtGui[69029]
#define sipNameNr_CT_LineEdit 69041
#define sipName_CT_LineEdit &sipStrings_QtGui[69041]
#define sipNameNr_CT_Q3Header 69053
#define sipName_CT_Q3Header &sipStrings_QtGui[69053]
#define sipNameNr_CT_MenuItem 69065
#define sipName_CT_MenuItem &sipStrings_QtGui[69065]
#define sipNameNr_CT_Splitter 69077
#define sipName_CT_Splitter &sipStrings_QtGui[69077]
#define sipNameNr_CT_ComboBox 69089
#define sipName_CT_ComboBox &sipStrings_QtGui[69089]
#define sipNameNr_CT_CheckBox 69101
#define sipName_CT_CheckBox &sipStrings_QtGui[69101]
#define sipNameNr_pixelMetric 69113
#define sipName_pixelMetric &sipStrings_QtGui[69113]
#define sipNameNr_PixelMetric 28797
#define sipName_PixelMetric &sipStrings_QtGui[28797]
#define sipNameNr_SubControls 28817
#define sipName_SubControls &sipStrings_QtGui[28817]
#define sipNameNr_CC_GroupBox 69125
#define sipName_CC_GroupBox &sipStrings_QtGui[69125]
#define sipNameNr_CC_TitleBar 69137
#define sipName_CC_TitleBar &sipStrings_QtGui[69137]
#define sipNameNr_CC_ComboBox 69149
#define sipName_CC_ComboBox &sipStrings_QtGui[69149]
#define sipNameNr_drawControl 69161
#define sipName_drawControl &sipStrings_QtGui[69161]
#define sipNameNr_CE_Splitter 69173
#define sipName_CE_Splitter &sipStrings_QtGui[69173]
#define sipNameNr_CE_SizeGrip 69185
#define sipName_CE_SizeGrip &sipStrings_QtGui[69185]
#define sipNameNr_CE_MenuItem 69197
#define sipName_CE_MenuItem &sipStrings_QtGui[69197]
#define sipNameNr_CE_CheckBox 69209
#define sipName_CE_CheckBox &sipStrings_QtGui[69209]
#define sipNameNr_State_Small 69221
#define sipName_State_Small &sipStrings_QtGui[69221]
#define sipNameNr_setRowCount 69233
#define sipName_setRowCount &sipStrings_QtGui[69233]
#define sipNameNr_handleWidth 69245
#define sipName_handleWidth &sipStrings_QtGui[69245]
#define sipNameNr_setDecimals 69257
#define sipName_setDecimals &sipStrings_QtGui[69257]
#define sipNameNr_isAvailable 69269
#define sipName_isAvailable &sipStrings_QtGui[69269]
#define sipNameNr_setSortRole 69281
#define sipName_setSortRole &sipStrings_QtGui[69281]
#define sipNameNr_controlType 69293
#define sipName_controlType &sipStrings_QtGui[69293]
#define sipNameNr_RadioButton 17049
#define sipName_RadioButton &sipStrings_QtGui[17049]
#define sipNameNr_DefaultType 69305
#define sipName_DefaultType &sipStrings_QtGui[69305]
#define sipNameNr_ControlType 15269
#define sipName_ControlType &sipStrings_QtGui[15269]
#define sipNameNr_restartHint 69317
#define sipName_restartHint &sipStrings_QtGui[69317]
#define sipNameNr_RestartHint 9809
#define sipName_RestartHint &sipStrings_QtGui[9809]
#define sipNameNr_QScrollArea 69329
#define sipName_QScrollArea &sipStrings_QtGui[69329]
#define sipNameNr_QRubberBand 69341
#define sipName_QRubberBand &sipStrings_QtGui[69341]
#define sipNameNr_autoDefault 69353
#define sipName_autoDefault &sipStrings_QtGui[69353]
#define sipNameNr_QProxyModel 69365
#define sipName_QProxyModel &sipStrings_QtGui[69365]
#define sipNameNr_wasCanceled 69377
#define sipName_wasCanceled &sipStrings_QtGui[69377]
#define sipNameNr_setZoomMode 69389
#define sipName_setZoomMode &sipStrings_QtGui[69389]
#define sipNameNr_currentPage 69401
#define sipName_currentPage &sipStrings_QtGui[69401]
#define sipNameNr_PPK_Creator 69413
#define sipName_PPK_Creator &sipStrings_QtGui[69413]
#define sipNameNr_printEngine 69425
#define sipName_printEngine &sipStrings_QtGui[69425]
#define sipNameNr_paperSource 69437
#define sipName_paperSource &sipStrings_QtGui[69437]
#define sipNameNr_setFullPage 69449
#define sipName_setFullPage &sipStrings_QtGui[69449]
#define sipNameNr_setPageSize 69461
#define sipName_setPageSize &sipStrings_QtGui[69461]
#define sipNameNr_printerName 69473
#define sipName_printerName &sipStrings_QtGui[69473]
#define sipNameNr_DevicePixel 69485
#define sipName_DevicePixel &sipStrings_QtGui[69485]
#define sipNameNr_LargeFormat 69497
#define sipName_LargeFormat &sipStrings_QtGui[69497]
#define sipNameNr_SmallFormat 69509
#define sipName_SmallFormat &sipStrings_QtGui[69509]
#define sipNameNr_PaperSource 22291
#define sipName_PaperSource &sipStrings_QtGui[22291]
#define sipNameNr_PrinterMode 22335
#define sipName_PrinterMode &sipStrings_QtGui[22335]
#define sipNameNr_cursorWidth 69521
#define sipName_cursorWidth &sipStrings_QtGui[69521]
#define sipNameNr_WidgetWidth 69533
#define sipName_WidgetWidth &sipStrings_QtGui[69533]
#define sipNameNr_setIODevice 69545
#define sipName_setIODevice &sipStrings_QtGui[69545]
#define sipNameNr_setCosmetic 69557
#define sipName_setCosmetic &sipStrings_QtGui[69557]
#define sipNameNr_toolTipText 69569
#define sipName_toolTipText &sipStrings_QtGui[69569]
#define sipNameNr_toolTipBase 69581
#define sipName_toolTipBase &sipStrings_QtGui[69581]
#define sipNameNr_linkVisited 69593
#define sipName_linkVisited &sipStrings_QtGui[69593]
#define sipNameNr_NColorRoles 69605
#define sipName_NColorRoles &sipStrings_QtGui[69605]
#define sipNameNr_ToolTipText 69617
#define sipName_ToolTipText &sipStrings_QtGui[69617]
#define sipNameNr_ToolTipBase 69629
#define sipName_ToolTipBase &sipStrings_QtGui[69629]
#define sipNameNr_LinkVisited 69641
#define sipName_LinkVisited &sipStrings_QtGui[69641]
#define sipNameNr_dashPattern 69653
#define sipName_dashPattern &sipStrings_QtGui[69653]
#define sipNameNr_setCapStyle 69665
#define sipName_setCapStyle &sipStrings_QtGui[69665]
#define sipNameNr_connectPath 69677
#define sipName_connectPath &sipStrings_QtGui[69677]
#define sipNameNr_ElementType 13389
#define sipName_ElementType &sipStrings_QtGui[13389]
#define sipNameNr_updateState 69689
#define sipName_updateState &sipStrings_QtGui[69689]
#define sipNameNr_WindingMode 69701
#define sipName_WindingMode &sipStrings_QtGui[69701]
#define sipNameNr_OddEvenMode 69713
#define sipName_OddEvenMode &sipStrings_QtGui[69713]
#define sipNameNr_AllFeatures 69725
#define sipName_AllFeatures &sipStrings_QtGui[69725]
#define sipNameNr_MaskedBrush 69737
#define sipName_MaskedBrush &sipStrings_QtGui[69737]
#define sipNameNr_BrushStroke 69749
#define sipName_BrushStroke &sipStrings_QtGui[69749]
#define sipNameNr_renderFlags 69761
#define sipName_renderFlags &sipStrings_QtGui[69761]
#define sipNameNr_RenderFlags 19884
#define sipName_RenderFlags &sipStrings_QtGui[19884]
#define sipNameNr_logicalDpiY 69773
#define sipName_logicalDpiY &sipStrings_QtGui[69773]
#define sipNameNr_logicalDpiX 69785
#define sipName_logicalDpiX &sipStrings_QtGui[69785]
#define sipNameNr_PdmHeightMM 69797
#define sipName_PdmHeightMM &sipStrings_QtGui[69797]
#define sipNameNr_worldMatrix 69809
#define sipName_worldMatrix &sipStrings_QtGui[69809]
#define sipNameNr_drawPicture 69821
#define sipName_drawPicture &sipStrings_QtGui[69821]
#define sipNameNr_drawPolygon 69833
#define sipName_drawPolygon &sipStrings_QtGui[69833]
#define sipNameNr_drawEllipse 69845
#define sipName_drawEllipse &sipStrings_QtGui[69845]
#define sipNameNr_setClipPath 69857
#define sipName_setClipPath &sipStrings_QtGui[69857]
#define sipNameNr_brushOrigin 69869
#define sipName_brushOrigin &sipStrings_QtGui[69869]
#define sipNameNr_RenderHints 22489
#define sipName_RenderHints &sipStrings_QtGui[22489]
#define sipNameNr_jumpToFrame 69881
#define sipName_jumpToFrame &sipStrings_QtGui[69881]
#define sipNameNr_information 69893
#define sipName_information &sipStrings_QtGui[69893]
#define sipNameNr_FirstButton 69905
#define sipName_FirstButton &sipStrings_QtGui[69905]
#define sipNameNr_Information 7314
#define sipName_Information &sipStrings_QtGui[7314]
#define sipNameNr_QMessageBox 69917
#define sipName_QMessageBox &sipStrings_QtGui[69917]
#define sipNameNr_isDefaultUp 69929
#define sipName_isDefaultUp &sipStrings_QtGui[69929]
#define sipNameNr_actionEvent 69941
#define sipName_actionEvent &sipStrings_QtGui[69941]
#define sipNameNr_aboutToShow 69953
#define sipName_aboutToShow &sipStrings_QtGui[69953]
#define sipNameNr_aboutToHide 69965
#define sipName_aboutToHide &sipStrings_QtGui[69965]
#define sipNameNr_WindowOrder 16113
#define sipName_WindowOrder &sipStrings_QtGui[16113]
#define sipNameNr_AreaOptions 22643
#define sipName_AreaOptions &sipStrings_QtGui[22643]
#define sipNameNr_tabPosition 69977
#define sipName_tabPosition &sipStrings_QtGui[69977]
#define sipNameNr_setTabShape 69989
#define sipName_setTabShape &sipStrings_QtGui[69989]
#define sipNameNr_dockOptions 70001
#define sipName_dockOptions &sipStrings_QtGui[70001]
#define sipNameNr_DockOptions 15444
#define sipName_DockOptions &sipStrings_QtGui[15444]
#define sipNameNr_setAnimated 70013
#define sipName_setAnimated &sipStrings_QtGui[70013]
#define sipNameNr_toolBarArea 70025
#define sipName_toolBarArea &sipStrings_QtGui[70025]
#define sipNameNr_QMainWindow 70037
#define sipName_QMainWindow &sipStrings_QtGui[70037]
#define sipNameNr_itemChanged 70049
#define sipName_itemChanged &sipStrings_QtGui[70049]
#define sipNameNr_itemEntered 70061
#define sipName_itemEntered &sipStrings_QtGui[70061]
#define sipNameNr_itemClicked 70073
#define sipName_itemClicked &sipStrings_QtGui[70073]
#define sipNameNr_itemPressed 70085
#define sipName_itemPressed &sipStrings_QtGui[70085]
#define sipNameNr_currentItem 70097
#define sipName_currentItem &sipStrings_QtGui[70097]
#define sipNameNr_QListWidget 70109
#define sipName_QListWidget &sipStrings_QtGui[70109]
#define sipNameNr_setSizeHint 70121
#define sipName_setSizeHint &sipStrings_QtGui[70121]
#define sipNameNr_isRowHidden 70133
#define sipName_isRowHidden &sipStrings_QtGui[70133]
#define sipNameNr_setGridSize 70145
#define sipName_setGridSize &sipStrings_QtGui[70145]
#define sipNameNr_setMovement 70157
#define sipName_setMovement &sipStrings_QtGui[70157]
#define sipNameNr_textChanged 70169
#define sipName_textChanged &sipStrings_QtGui[70169]
#define sipNameNr_setModified 70181
#define sipName_setModified &sipStrings_QtGui[70181]
#define sipNameNr_setEchoMode 70193
#define sipName_setEchoMode &sipStrings_QtGui[70193]
#define sipNameNr_displayText 70205
#define sipName_displayText &sipStrings_QtGui[70205]
#define sipNameNr_QWidgetItem 70217
#define sipName_QWidgetItem &sipStrings_QtGui[70217]
#define sipNameNr_QSpacerItem 70229
#define sipName_QSpacerItem &sipStrings_QtGui[70229]
#define sipNameNr_QLayoutItem 70241
#define sipName_QLayoutItem &sipStrings_QtGui[70241]
#define sipNameNr_setWordWrap 70253
#define sipName_setWordWrap &sipStrings_QtGui[70253]
#define sipNameNr_keyBindings 70265
#define sipName_keyBindings &sipStrings_QtGui[70265]
#define sipNameNr_StandardKey 13649
#define sipName_StandardKey &sipStrings_QtGui[13649]
#define sipNameNr_drawDisplay 70277
#define sipName_drawDisplay &sipStrings_QtGui[70277]
#define sipNameNr_setClipping 70289
#define sipName_setClipping &sipStrings_QtGui[70289]
#define sipNameNr_hasClipping 70301
#define sipName_hasClipping &sipStrings_QtGui[70301]
#define sipNameNr_doubleValue 70313
#define sipName_doubleValue &sipStrings_QtGui[70313]
#define sipNameNr_setIntRange 70325
#define sipName_setIntRange &sipStrings_QtGui[70325]
#define sipNameNr_setIntValue 70337
#define sipName_setIntValue &sipStrings_QtGui[70337]
#define sipNameNr_DoubleInput 70349
#define sipName_DoubleInput &sipStrings_QtGui[70349]
#define sipNameNr_filterEvent 70361
#define sipName_filterEvent &sipStrings_QtGui[70361]
#define sipNameNr_isComposing 70373
#define sipName_isComposing &sipStrings_QtGui[70373]
#define sipNameNr_compression 70385
#define sipName_compression &sipStrings_QtGui[70385]
#define sipNameNr_imageFormat 70397
#define sipName_imageFormat &sipStrings_QtGui[70397]
#define sipNameNr_setClipRect 70409
#define sipName_setClipRect &sipStrings_QtGui[70409]
#define sipNameNr_DeviceError 70421
#define sipName_DeviceError &sipStrings_QtGui[70421]
#define sipNameNr_jumpToImage 70433
#define sipName_jumpToImage &sipStrings_QtGui[70433]
#define sipNameNr_Description 15194
#define sipName_Description &sipStrings_QtGui[15194]
#define sipNameNr_ImageOption 9954
#define sipName_ImageOption &sipStrings_QtGui[9954]
#define sipNameNr_paintEngine 70445
#define sipName_paintEngine &sipStrings_QtGui[70445]
#define sipNameNr_isGrayscale 70457
#define sipName_isGrayscale &sipStrings_QtGui[70457]
#define sipNameNr_Format_Mono 70469
#define sipName_Format_Mono &sipStrings_QtGui[70469]
#define sipNameNr_QIconEngine 70481
#define sipName_QIconEngine &sipStrings_QtGui[70481]
#define sipNameNr_QIcon__Mode 70493
#define sipName_QIcon__Mode &sipStrings_QtGui[70493]
#define sipNameNr_showSection 70505
#define sipName_showSection &sipStrings_QtGui[70505]
#define sipNameNr_hideSection 70517
#define sipName_hideSection &sipStrings_QtGui[70517]
#define sipNameNr_isClickable 70529
#define sipName_isClickable &sipStrings_QtGui[70529]
#define sipNameNr_visualIndex 70541
#define sipName_visualIndex &sipStrings_QtGui[70541]
#define sipNameNr_moveSection 70553
#define sipName_moveSection &sipStrings_QtGui[70553]
#define sipNameNr_sectionSize 70565
#define sipName_sectionSize &sipStrings_QtGui[70565]
#define sipNameNr_Interactive 54689
#define sipName_Interactive &sipStrings_QtGui[54689]
#define sipNameNr_QHeaderView 70577
#define sipName_QHeaderView &sipStrings_QtGui[70577]
#define sipNameNr_QGridLayout 70589
#define sipName_QGridLayout &sipStrings_QtGui[70589]
#define sipNameNr_updateScene 70601
#define sipName_updateScene &sipStrings_QtGui[70601]
#define sipNameNr_setDragMode 70613
#define sipName_setDragMode &sipStrings_QtGui[70613]
#define sipNameNr_renderHints 70625
#define sipName_renderHints &sipStrings_QtGui[70625]
#define sipNameNr_polishEvent 70637
#define sipName_polishEvent &sipStrings_QtGui[70637]
#define sipNameNr_setTabOrder 70649
#define sipName_setTabOrder &sipStrings_QtGui[70649]
#define sipNameNr_focusPolicy 70661
#define sipName_focusPolicy &sipStrings_QtGui[70661]
#define sipNameNr_windowTitle 70673
#define sipName_windowTitle &sipStrings_QtGui[70673]
#define sipNameNr_windowFlags 70685
#define sipName_windowFlags &sipStrings_QtGui[70685]
#define sipNameNr_stickyFocus 70697
#define sipName_stickyFocus &sipStrings_QtGui[70697]
#define sipNameNr_SceneLayers 10942
#define sipName_SceneLayers &sipStrings_QtGui[10942]
#define sipNameNr_itemSpacing 70709
#define sipName_itemSpacing &sipStrings_QtGui[70709]
#define sipNameNr_widgetEvent 70721
#define sipName_widgetEvent &sipStrings_QtGui[70721]
#define sipNameNr_isActivated 70733
#define sipName_isActivated &sipStrings_QtGui[70733]
#define sipNameNr_setTimeLine 70745
#define sipName_setTimeLine &sipStrings_QtGui[70745]
#define sipNameNr_linkHovered 70757
#define sipName_linkHovered &sipStrings_QtGui[70757]
#define sipNameNr_setDocument 70769
#define sipName_setDocument &sipStrings_QtGui[70769]
#define sipNameNr_toPlainText 70781
#define sipName_toPlainText &sipStrings_QtGui[70781]
#define sipNameNr_setFillRule 70793
#define sipName_setFillRule &sipStrings_QtGui[70793]
#define sipNameNr_ungrabMouse 70805
#define sipName_ungrabMouse &sipStrings_QtGui[70805]
#define sipNameNr_isVisibleTo 70817
#define sipName_isVisibleTo &sipStrings_QtGui[70817]
#define sipNameNr_mapFromItem 70829
#define sipName_mapFromItem &sipStrings_QtGui[70829]
#define sipNameNr_mapToParent 70841
#define sipName_mapToParent &sipStrings_QtGui[70841]
#define sipNameNr_resetMatrix 70853
#define sipName_resetMatrix &sipStrings_QtGui[70853]
#define sipNameNr_sceneMatrix 70865
#define sipName_sceneMatrix &sipStrings_QtGui[70865]
#define sipNameNr_acceptDrops 70877
#define sipName_acceptDrops &sipStrings_QtGui[70877]
#define sipNameNr_setSelected 70889
#define sipName_setSelected &sipStrings_QtGui[70889]
#define sipNameNr_unsetCursor 70901
#define sipName_unsetCursor &sipStrings_QtGui[70901]
#define sipNameNr_frameShadow 70913
#define sipName_frameShadow &sipStrings_QtGui[70913]
#define sipNameNr_Shadow_Mask 70925
#define sipName_Shadow_Mask &sipStrings_QtGui[70925]
#define sipNameNr_StyledPanel 70937
#define sipName_StyledPanel &sipStrings_QtGui[70937]
#define sipNameNr_WrapAllRows 70949
#define sipName_WrapAllRows &sipStrings_QtGui[70949]
#define sipNameNr_QFormLayout 70961
#define sipName_QFormLayout &sipStrings_QtGui[70961]
#define sipNameNr_overlinePos 70973
#define sipName_overlinePos &sipStrings_QtGui[70973]
#define sipNameNr_leftBearing 70985
#define sipName_leftBearing &sipStrings_QtGui[70985]
#define sipNameNr_lineSpacing 70997
#define sipName_lineSpacing &sipStrings_QtGui[70997]
#define sipNameNr_QFontDialog 71009
#define sipName_QFontDialog &sipStrings_QtGui[71009]
#define sipNameNr_styleString 71021
#define sipName_styleString &sipStrings_QtGui[71021]
#define sipNameNr_smoothSizes 71033
#define sipName_smoothSizes &sipStrings_QtGui[71033]
#define sipNameNr_currentFont 71045
#define sipName_currentFont &sipStrings_QtGui[71045]
#define sipNameNr_FontFilters 12108
#define sipName_FontFilters &sipStrings_QtGui[12108]
#define sipNameNr_fontFilters 71057
#define sipName_fontFilters &sipStrings_QtGui[71057]
#define sipNameNr_wordSpacing 71069
#define sipName_wordSpacing &sipStrings_QtGui[71069]
#define sipNameNr_SpacingType 35320
#define sipName_SpacingType &sipStrings_QtGui[35320]
#define sipNameNr_substitutes 71081
#define sipName_substitutes &sipStrings_QtGui[71081]
#define sipNameNr_setOverline 71093
#define sipName_setOverline &sipStrings_QtGui[71093]
#define sipNameNr_Unstretched 71105
#define sipName_Unstretched &sipStrings_QtGui[71105]
#define sipNameNr_StyleItalic 71117
#define sipName_StyleItalic &sipStrings_QtGui[71117]
#define sipNameNr_StyleNormal 71129
#define sipName_StyleNormal &sipStrings_QtGui[71129]
#define sipNameNr_NoAntialias 71141
#define sipName_NoAntialias &sipStrings_QtGui[71141]
#define sipNameNr_PreferMatch 71153
#define sipName_PreferMatch &sipStrings_QtGui[71153]
#define sipNameNr_QFocusFrame 71165
#define sipName_QFocusFrame &sipStrings_QtGui[71165]
#define sipNameNr_fileRenamed 71177
#define sipName_fileRenamed &sipStrings_QtGui[71177]
#define sipNameNr_setRootPath 71189
#define sipName_setRootPath &sipStrings_QtGui[71189]
#define sipNameNr_sidebarUrls 71201
#define sipName_sidebarUrls &sipStrings_QtGui[71201]
#define sipNameNr_setFileMode 71213
#define sipName_setFileMode &sipStrings_QtGui[71213]
#define sipNameNr_setViewMode 71225
#define sipName_setViewMode &sipStrings_QtGui[71225]
#define sipNameNr_DialogLabel 15794
#define sipName_DialogLabel &sipStrings_QtGui[15794]
#define sipNameNr_QFileDialog 71237
#define sipName_QFileDialog &sipStrings_QtGui[71237]
#define sipNameNr_isAmbiguous 71249
#define sipName_isAmbiguous &sipStrings_QtGui[71249]
#define sipNameNr_encodedData 71261
#define sipName_encodedData &sipStrings_QtGui[71261]
#define sipNameNr_QMimeSource 71273
#define sipName_QMimeSource &sipStrings_QtGui[71273]
#define sipNameNr_QCloseEvent 71285
#define sipName_QCloseEvent &sipStrings_QtGui[71285]
#define sipNameNr_QPaintEvent 71297
#define sipName_QPaintEvent &sipStrings_QtGui[71297]
#define sipNameNr_QFocusEvent 71309
#define sipName_QFocusEvent &sipStrings_QtGui[71309]
#define sipNameNr_pointerType 71321
#define sipName_pointerType &sipStrings_QtGui[71321]
#define sipNameNr_PointerType 13909
#define sipName_PointerType &sipStrings_QtGui[13909]
#define sipNameNr_XFreeEraser 71333
#define sipName_XFreeEraser &sipStrings_QtGui[71333]
#define sipNameNr_QWheelEvent 71345
#define sipName_QWheelEvent &sipStrings_QtGui[71345]
#define sipNameNr_QHoverEvent 71357
#define sipName_QHoverEvent &sipStrings_QtGui[71357]
#define sipNameNr_QMouseEvent 71369
#define sipName_QMouseEvent &sipStrings_QtGui[71369]
#define sipNameNr_QInputEvent 71381
#define sipName_QInputEvent &sipStrings_QtGui[71381]
#define sipNameNr_showMessage 71393
#define sipName_showMessage &sipStrings_QtGui[71393]
#define sipNameNr_setFloating 71405
#define sipName_setFloating &sipStrings_QtGui[71405]
#define sipNameNr_setFeatures 71417
#define sipName_setFeatures &sipStrings_QtGui[71417]
#define sipNameNr_QDockWidget 71429
#define sipName_QDockWidget &sipStrings_QtGui[71429]
#define sipNameNr_InvalidRole 71441
#define sipName_InvalidRole &sipStrings_QtGui[71441]
#define sipNameNr_GnomeLayout 71453
#define sipName_GnomeLayout &sipStrings_QtGui[71453]
#define sipNameNr_notchTarget 71465
#define sipName_notchTarget &sipStrings_QtGui[71465]
#define sipNameNr_displayName 71477
#define sipName_displayName &sipStrings_QtGui[71477]
#define sipNameNr_setDateTime 71489
#define sipName_setDateTime &sipStrings_QtGui[71489]
#define sipNameNr_dateChanged 71501
#define sipName_dateChanged &sipStrings_QtGui[71501]
#define sipNameNr_timeChanged 71513
#define sipName_timeChanged &sipStrings_QtGui[71513]
#define sipNameNr_sectionText 71525
#define sipName_sectionText &sipStrings_QtGui[71525]
#define sipNameNr_maximumTime 71537
#define sipName_maximumTime &sipStrings_QtGui[71537]
#define sipNameNr_minimumTime 71549
#define sipName_minimumTime &sipStrings_QtGui[71549]
#define sipNameNr_YearSection 71561
#define sipName_YearSection &sipStrings_QtGui[71561]
#define sipNameNr_HourSection 71573
#define sipName_HourSection &sipStrings_QtGui[71573]
#define sipNameNr_MSecSection 71585
#define sipName_MSecSection &sipStrings_QtGui[71585]
#define sipNameNr_AmPmSection 71597
#define sipName_AmPmSection &sipStrings_QtGui[71597]
#define sipNameNr_highlighted 71609
#define sipName_highlighted &sipStrings_QtGui[71609]
#define sipNameNr_setEditText 71621
#define sipName_setEditText &sipStrings_QtGui[71621]
#define sipNameNr_setItemIcon 71633
#define sipName_setItemIcon &sipStrings_QtGui[71633]
#define sipNameNr_setItemText 71645
#define sipName_setItemText &sipStrings_QtGui[71645]
#define sipNameNr_insertItems 71657
#define sipName_insertItems &sipStrings_QtGui[71657]
#define sipNameNr_currentText 71669
#define sipName_currentText &sipStrings_QtGui[71669]
#define sipNameNr_modelColumn 71681
#define sipName_modelColumn &sipStrings_QtGui[71681]
#define sipNameNr_setEditable 71693
#define sipName_setEditable &sipStrings_QtGui[71693]
#define sipNameNr_InsertAtTop 71705
#define sipName_InsertAtTop &sipStrings_QtGui[71705]
#define sipNameNr_setMaxCount 71717
#define sipName_setMaxCount &sipStrings_QtGui[71717]
#define sipNameNr_customColor 71729
#define sipName_customColor &sipStrings_QtGui[71729]
#define sipNameNr_customCount 71741
#define sipName_customCount &sipStrings_QtGui[71741]
#define sipNameNr_QColumnView 71753
#define sipName_QColumnView &sipStrings_QtGui[71753]
#define sipNameNr_setMimeData 71765
#define sipName_setMimeData &sipStrings_QtGui[71765]
#define sipNameNr_setTristate 71777
#define sipName_setTristate &sipStrings_QtGui[71777]
#define sipNameNr_updateCells 71789
#define sipName_updateCells &sipStrings_QtGui[71789]
#define sipNameNr_maximumDate 71801
#define sipName_maximumDate &sipStrings_QtGui[71801]
#define sipNameNr_minimumDate 71813
#define sipName_minimumDate &sipStrings_QtGui[71813]
#define sipNameNr_LogicalMode 71825
#define sipName_LogicalMode &sipStrings_QtGui[71825]
#define sipNameNr_description 71837
#define sipName_description &sipStrings_QtGui[71837]
#define sipNameNr_QPushButton 71849
#define sipName_QPushButton &sipStrings_QtGui[71849]
#define sipNameNr_saturationF 71861
#define sipName_saturationF &sipStrings_QtGui[71861]
#define sipNameNr_QVBoxLayout 71873
#define sipName_QVBoxLayout &sipStrings_QtGui[71873]
#define sipNameNr_QHBoxLayout 71885
#define sipName_QHBoxLayout &sipStrings_QtGui[71885]
#define sipNameNr_setGeometry 71897
#define sipName_setGeometry &sipStrings_QtGui[71897]
#define sipNameNr_maximumSize 71909
#define sipName_maximumSize &sipStrings_QtGui[71909]
#define sipNameNr_minimumSize 71921
#define sipName_minimumSize &sipStrings_QtGui[71921]
#define sipNameNr_BottomToTop 71933
#define sipName_BottomToTop &sipStrings_QtGui[71933]
#define sipNameNr_TopToBottom 71945
#define sipName_TopToBottom &sipStrings_QtGui[71945]
#define sipNameNr_transformed 71957
#define sipName_transformed &sipStrings_QtGui[71957]
#define sipNameNr_globalStrut 71969
#define sipName_globalStrut &sipStrings_QtGui[71969]
#define sipNameNr_focusWidget 71981
#define sipName_focusWidget &sipStrings_QtGui[71981]
#define sipNameNr_fontMetrics 71993
#define sipName_fontMetrics &sipStrings_QtGui[71993]
#define sipNameNr_CustomColor 55859
#define sipName_CustomColor &sipStrings_QtGui[55859]
#define sipNameNr_NormalColor 72005
#define sipName_NormalColor &sipStrings_QtGui[72005]
#define sipNameNr_isExclusive 72017
#define sipName_isExclusive &sipStrings_QtGui[72017]
#define sipNameNr_setMenuRole 72029
#define sipName_setMenuRole &sipStrings_QtGui[72029]
#define sipNameNr_AboutQtRole 72041
#define sipName_AboutQtRole &sipStrings_QtGui[72041]
#define sipNameNr_setDisabled 72053
#define sipName_setDisabled &sipStrings_QtGui[72053]
#define sipNameNr_ActionEvent 27344
#define sipName_ActionEvent &sipStrings_QtGui[27344]
#define sipNameNr_isSeparator 72065
#define sipName_isSeparator &sipStrings_QtGui[72065]
#define sipNameNr_setIconText 72077
#define sipName_setIconText &sipStrings_QtGui[72077]
#define sipNameNr_actionGroup 72089
#define sipName_actionGroup &sipStrings_QtGui[72089]
#define sipNameNr_sliderMoved 72101
#define sipName_sliderMoved &sipStrings_QtGui[72101]
#define sipNameNr_hasTracking 72113
#define sipName_hasTracking &sipStrings_QtGui[72113]
#define sipNameNr_setTracking 72125
#define sipName_setTracking &sipStrings_QtGui[72125]
#define sipNameNr_setPageStep 72137
#define sipName_setPageStep &sipStrings_QtGui[72137]
#define sipNameNr_orientation 72149
#define sipName_orientation &sipStrings_QtGui[72149]
#define sipNameNr_updateBlock 72161
#define sipName_updateBlock &sipStrings_QtGui[72161]
#define sipNameNr_paintDevice 72173
#define sipName_paintDevice &sipStrings_QtGui[72173]
#define sipNameNr_stepEnabled 72185
#define sipName_stepEnabled &sipStrings_QtGui[72185]
#define sipNameNr_setLineEdit 72197
#define sipName_setLineEdit &sipStrings_QtGui[72197]
#define sipNameNr_setReadOnly 72209
#define sipName_setReadOnly &sipStrings_QtGui[72209]
#define sipNameNr_setWrapping 72221
#define sipName_setWrapping &sipStrings_QtGui[72221]
#define sipNameNr_StepEnabled 9139
#define sipName_StepEnabled &sipStrings_QtGui[9139]
#define sipNameNr_setViewport 72233
#define sipName_setViewport &sipStrings_QtGui[72233]
#define sipNameNr_mapToSource 72245
#define sipName_mapToSource &sipStrings_QtGui[72245]
#define sipNameNr_sourceModel 72257
#define sipName_sourceModel &sipStrings_QtGui[72257]
#define sipNameNr_PrintToFile 72269
#define sipName_PrintToFile &sipStrings_QtGui[72269]
#define sipNameNr_resizeEvent 72281
#define sipName_resizeEvent &sipStrings_QtGui[72281]
#define sipNameNr_viewOptions 72293
#define sipName_viewOptions &sipStrings_QtGui[72293]
#define sipNameNr_scrollToTop 72305
#define sipName_scrollToTop &sipStrings_QtGui[72305]
#define sipNameNr_indexWidget 72317
#define sipName_indexWidget &sipStrings_QtGui[72317]
#define sipNameNr_dragEnabled 72329
#define sipName_dragEnabled &sipStrings_QtGui[72329]
#define sipNameNr_NoSelection 72341
#define sipName_NoSelection &sipStrings_QtGui[72341]
#define sipNameNr_SelectItems 72353
#define sipName_SelectItems &sipStrings_QtGui[72353]
#define sipNameNr_EditTrigger 8089
#define sipName_EditTrigger &sipStrings_QtGui[8089]
#define sipNameNr_closeEditor 72365
#define sipName_closeEditor &sipStrings_QtGui[72365]
#define sipNameNr_editorEvent 72377
#define sipName_editorEvent &sipStrings_QtGui[72377]
#define sipNameNr_EndEditHint 5018
#define sipName_EndEditHint &sipStrings_QtGui[5018]
#define sipNameNr_changeEvent 72389
#define sipName_changeEvent &sipStrings_QtGui[72389]
#define sipNameNr_setIconSize 72401
#define sipName_setIconSize &sipStrings_QtGui[72401]
#define sipNameNr_isCheckable 72413
#define sipName_isCheckable &sipStrings_QtGui[72413]
#define sipNameNr_setShortcut 72425
#define sipName_setShortcut &sipStrings_QtGui[72425]
#define sipNameNr_setPosition 72437
#define sipName_setPosition &sipStrings_QtGui[72437]
#define sipNameNr___delitem__ 72449
#define sipName___delitem__ &sipStrings_QtGui[72449]
#define sipNameNr___setitem__ 72461
#define sipName___setitem__ &sipStrings_QtGui[72461]
#define sipNameNr_intersected 72473
#define sipName_intersected &sipStrings_QtGui[72473]
#define sipNameNr_bottomRight 72485
#define sipName_bottomRight &sipStrings_QtGui[72485]
#define sipNameNr_customEvent 72497
#define sipName_customEvent &sipStrings_QtGui[72497]
#define sipNameNr_setProperty 72509
#define sipName_setProperty &sipStrings_QtGui[72509]
#define sipNameNr_eventFilter 72521
#define sipName_eventFilter &sipStrings_QtGui[72521]
#define sipNameNr_QTextFormat 72533
#define sipName_QTextFormat &sipStrings_QtGui[72533]
#define sipNameNr_QTextLength 72545
#define sipName_QTextLength &sipStrings_QtGui[72545]
#define sipNameNr_QSizePolicy 72557
#define sipName_QSizePolicy &sipStrings_QtGui[72557]
#define sipNameNr_permissions 72569
#define sipName_permissions &sipStrings_QtGui[72569]
#define sipNameNr_searchPaths 72581
#define sipName_searchPaths &sipStrings_QtGui[72581]
#define sipNameNr_setTimeSpec 72593
#define sipName_setTimeSpec &sipStrings_QtGui[72593]
#define sipNameNr_lastIndexOf 72605
#define sipName_lastIndexOf &sipStrings_QtGui[72605]
#define sipNameNr___getitem__ 72617
#define sipName___getitem__ &sipStrings_QtGui[72617]
#define sipNameNr_createIndex 72629
#define sipName_createIndex &sipStrings_QtGui[72629]
#define sipNameNr_rowsRemoved 72641
#define sipName_rowsRemoved &sipStrings_QtGui[72641]
#define sipNameNr_dataChanged 72653
#define sipName_dataChanged &sipStrings_QtGui[72653]
#define sipNameNr_setItemData 72665
#define sipName_setItemData &sipStrings_QtGui[72665]
#define sipNameNr_hasChildren 72677
#define sipName_hasChildren &sipStrings_QtGui[72677]
#define sipNameNr_columnCount 72689
#define sipName_columnCount &sipStrings_QtGui[72689]
#define sipNameNr_nameFilters 72701
#define sipName_nameFilters &sipStrings_QtGui[72701]
#define sipNameNr_errorString 72713
#define sipName_errorString &sipStrings_QtGui[72713]
#define sipNameNr_setFileName 72725
#define sipName_setFileName &sipStrings_QtGui[72725]
#define sipNameNr_RightToLeft 62269
#define sipName_RightToLeft &sipStrings_QtGui[62269]
#define sipNameNr_LeftToRight 61737
#define sipName_LeftToRight &sipStrings_QtGui[61737]
#define sipNameNr_DashDotLine 72737
#define sipName_DashDotLine &sipStrings_QtGui[72737]
#define sipNameNr_AlignBottom 72749
#define sipName_AlignBottom &sipStrings_QtGui[72749]
#define sipNameNr_Orientation 17241
#define sipName_Orientation &sipStrings_QtGui[17241]
#define sipNameNr_PyQt4_QtGui 72761
#define sipName_PyQt4_QtGui &sipStrings_QtGui[72761]
#define sipNameNr_setAppTime 72773
#define sipName_setAppTime &sipStrings_QtGui[72773]
#define sipNameNr_setAppDpiY 72784
#define sipName_setAppDpiY &sipStrings_QtGui[72784]
#define sipNameNr_setAppDpiX 72795
#define sipName_setAppDpiX &sipStrings_QtGui[72795]
#define sipNameNr_windowList 72806
#define sipName_windowList &sipStrings_QtGui[72806]
#define sipNameNr_QWorkspace 72817
#define sipName_QWorkspace &sipStrings_QtGui[72817]
#define sipNameNr_isComplete 72828
#define sipName_isComplete &sipStrings_QtGui[72828]
#define sipNameNr_removePage 72839
#define sipName_removePage &sipStrings_QtGui[72839]
#define sipNameNr_setStartId 72850
#define sipName_setStartId &sipStrings_QtGui[72850]
#define sipNameNr_LogoPixmap 72861
#define sipName_LogoPixmap &sipStrings_QtGui[72861]
#define sipNameNr_HelpButton 9491
#define sipName_HelpButton &sipStrings_QtGui[9491]
#define sipNameNr_NextButton 72872
#define sipName_NextButton &sipStrings_QtGui[72872]
#define sipNameNr_BackButton 72883
#define sipName_BackButton &sipStrings_QtGui[72883]
#define sipNameNr_IgnoreMask 72894
#define sipName_IgnoreMask &sipStrings_QtGui[72894]
#define sipNameNr_underMouse 72905
#define sipName_underMouse &sipStrings_QtGui[72905]
#define sipNameNr_isTopLevel 72916
#define sipName_isTopLevel &sipStrings_QtGui[72916]
#define sipNameNr_fontChange 72927
#define sipName_fontChange &sipStrings_QtGui[72927]
#define sipNameNr_stackUnder 72938
#define sipName_stackUnder &sipStrings_QtGui[72938]
#define sipNameNr_showNormal 72949
#define sipName_showNormal &sipStrings_QtGui[72949]
#define sipNameNr_focusProxy 72960
#define sipName_focusProxy &sipStrings_QtGui[72960]
#define sipNameNr_windowRole 72971
#define sipName_windowRole &sipStrings_QtGui[72971]
#define sipNameNr_QWhatsThis 72982
#define sipName_QWhatsThis &sipStrings_QtGui[72982]
#define sipNameNr_Acceptable 72993
#define sipName_Acceptable &sipStrings_QtGui[72993]
#define sipNameNr_QValidator 73004
#define sipName_QValidator &sipStrings_QtGui[73004]
#define sipNameNr_emptyLabel 73015
#define sipName_emptyLabel &sipStrings_QtGui[73015]
#define sipNameNr_beginMacro 73026
#define sipName_beginMacro &sipStrings_QtGui[73026]
#define sipNameNr_cleanIndex 73037
#define sipName_cleanIndex &sipStrings_QtGui[73037]
#define sipNameNr_QUndoStack 73048
#define sipName_QUndoStack &sipStrings_QtGui[73048]
#define sipNameNr_QUndoGroup 73059
#define sipName_QUndoGroup &sipStrings_QtGui[73059]
#define sipNameNr_NotChecked 73070
#define sipName_NotChecked &sipStrings_QtGui[73070]
#define sipNameNr_NoChildren 73081
#define sipName_NoChildren &sipStrings_QtGui[73081]
#define sipNameNr_Selectable 45731
#define sipName_Selectable &sipStrings_QtGui[45731]
#define sipNameNr_Unselected 73092
#define sipName_Unselected &sipStrings_QtGui[73092]
#define sipNameNr_expandItem 73103
#define sipName_expandItem &sipStrings_QtGui[73103]
#define sipNameNr_headerItem 73114
#define sipName_headerItem &sipStrings_QtGui[73114]
#define sipNameNr_isDisabled 73125
#define sipName_isDisabled &sipStrings_QtGui[73125]
#define sipNameNr_childCount 73136
#define sipName_childCount &sipStrings_QtGui[73136]
#define sipNameNr_treeWidget 73147
#define sipName_treeWidget &sipStrings_QtGui[73147]
#define sipNameNr_indexBelow 73158
#define sipName_indexBelow &sipStrings_QtGui[73158]
#define sipNameNr_indexAbove 73169
#define sipName_indexAbove &sipStrings_QtGui[73169]
#define sipNameNr_isExpanded 73180
#define sipName_isExpanded &sipStrings_QtGui[73180]
#define sipNameNr_isRotating 73191
#define sipName_isRotating &sipStrings_QtGui[73191]
#define sipNameNr_quadToQuad 73202
#define sipName_quadToQuad &sipStrings_QtGui[73202]
#define sipNameNr_transposed 73213
#define sipName_transposed &sipStrings_QtGui[73213]
#define sipNameNr_mergeCells 73224
#define sipName_mergeCells &sipStrings_QtGui[73224]
#define sipNameNr_QTextTable 73235
#define sipName_QTextTable &sipStrings_QtGui[73235]
#define sipNameNr_setTabStop 73246
#define sipName_setTabStop &sipStrings_QtGui[73246]
#define sipNameNr_ManualWrap 73257
#define sipName_ManualWrap &sipStrings_QtGui[73257]
#define sipNameNr_QTextBlock 73268
#define sipName_QTextBlock &sipStrings_QtGui[73268]
#define sipNameNr_QTextFrame 73279
#define sipName_QTextFrame &sipStrings_QtGui[73279]
#define sipNameNr_itemNumber 73290
#define sipName_itemNumber &sipStrings_QtGui[73290]
#define sipNameNr_textLength 73301
#define sipName_textLength &sipStrings_QtGui[73301]
#define sipNameNr_drawCursor 73312
#define sipName_drawCursor &sipStrings_QtGui[73312]
#define sipNameNr_CursorMode 16282
#define sipName_CursorMode &sipStrings_QtGui[16282]
#define sipNameNr_createLine 73323
#define sipName_createLine &sipStrings_QtGui[73323]
#define sipNameNr_textOption 73334
#define sipName_textOption &sipStrings_QtGui[73334]
#define sipNameNr_setDescent 73345
#define sipName_setDescent &sipStrings_QtGui[73345]
#define sipNameNr_topPadding 73356
#define sipName_topPadding &sipStrings_QtGui[73356]
#define sipNameNr_setColumns 73367
#define sipName_setColumns &sipStrings_QtGui[73367]
#define sipNameNr_setPadding 73378
#define sipName_setPadding &sipStrings_QtGui[73378]
#define sipNameNr_FloatRight 73389
#define sipName_FloatRight &sipStrings_QtGui[73389]
#define sipNameNr_ListSquare 73400
#define sipName_ListSquare &sipStrings_QtGui[73400]
#define sipNameNr_ListCircle 73411
#define sipName_ListCircle &sipStrings_QtGui[73411]
#define sipNameNr_textIndent 73422
#define sipName_textIndent &sipStrings_QtGui[73422]
#define sipNameNr_leftMargin 73433
#define sipName_leftMargin &sipStrings_QtGui[73433]
#define sipNameNr_anchorName 73444
#define sipName_anchorName &sipStrings_QtGui[73444]
#define sipNameNr_anchorHref 73455
#define sipName_anchorHref &sipStrings_QtGui[73455]
#define sipNameNr_objectType 73466
#define sipName_objectType &sipStrings_QtGui[73466]
#define sipNameNr_properties 73477
#define sipName_properties &sipStrings_QtGui[73477]
#define sipNameNr_ImageWidth 73488
#define sipName_ImageWidth &sipStrings_QtGui[73488]
#define sipNameNr_FrameWidth 12766
#define sipName_FrameWidth &sipStrings_QtGui[12766]
#define sipNameNr_ListIndent 73499
#define sipName_ListIndent &sipStrings_QtGui[73499]
#define sipNameNr_ObjectType 57370
#define sipName_ObjectType &sipStrings_QtGui[57370]
#define sipNameNr_FontItalic 57552
#define sipName_FontItalic &sipStrings_QtGui[57552]
#define sipNameNr_FontWeight 57566
#define sipName_FontWeight &sipStrings_QtGui[57566]
#define sipNameNr_FontFamily 57580
#define sipName_FontFamily &sipStrings_QtGui[57580]
#define sipNameNr_TextIndent 57258
#define sipName_TextIndent &sipStrings_QtGui[57258]
#define sipNameNr_OutlinePen 73510
#define sipName_OutlinePen &sipStrings_QtGui[73510]
#define sipNameNr_UserObject 73521
#define sipName_UserObject &sipStrings_QtGui[73521]
#define sipNameNr_UserFormat 73532
#define sipName_UserFormat &sipStrings_QtGui[73532]
#define sipNameNr_ListFormat 46339
#define sipName_ListFormat &sipStrings_QtGui[46339]
#define sipNameNr_CharFormat 536
#define sipName_CharFormat &sipStrings_QtGui[536]
#define sipNameNr_fontItalic 73543
#define sipName_fontItalic &sipStrings_QtGui[73543]
#define sipNameNr_fontWeight 73554
#define sipName_fontWeight &sipStrings_QtGui[73554]
#define sipNameNr_fontFamily 73565
#define sipName_fontFamily &sipStrings_QtGui[73565]
#define sipNameNr_firstBlock 73576
#define sipName_firstBlock &sipStrings_QtGui[73576]
#define sipNameNr_idealWidth 73587
#define sipName_idealWidth &sipStrings_QtGui[73587]
#define sipNameNr_allFormats 73598
#define sipName_allFormats &sipStrings_QtGui[73598]
#define sipNameNr_insertHtml 73609
#define sipName_insertHtml &sipStrings_QtGui[73609]
#define sipNameNr_createList 73620
#define sipName_createList &sipStrings_QtGui[73620]
#define sipNameNr_insertList 73631
#define sipName_insertList &sipStrings_QtGui[73631]
#define sipNameNr_atBlockEnd 73642
#define sipName_atBlockEnd &sipStrings_QtGui[73642]
#define sipNameNr_charFormat 73653
#define sipName_charFormat &sipStrings_QtGui[73653]
#define sipNameNr_deleteChar 73664
#define sipName_deleteChar &sipStrings_QtGui[73664]
#define sipNameNr_EndOfBlock 43300
#define sipName_EndOfBlock &sipStrings_QtGui[43300]
#define sipNameNr_insertText 73675
#define sipName_insertText &sipStrings_QtGui[73675]
#define sipNameNr_KeepAnchor 73686
#define sipName_KeepAnchor &sipStrings_QtGui[73686]
#define sipNameNr_MoveAnchor 73697
#define sipName_MoveAnchor &sipStrings_QtGui[73697]
#define sipNameNr_historyUrl 73708
#define sipName_historyUrl &sipStrings_QtGui[73708]
#define sipNameNr_Triangular 73719
#define sipName_Triangular &sipStrings_QtGui[73719]
#define sipNameNr_QTabWidget 73730
#define sipName_QTabWidget &sipStrings_QtGui[73730]
#define sipNameNr_cellWidget 73741
#define sipName_cellWidget &sipStrings_QtGui[73741]
#define sipNameNr_leftColumn 73752
#define sipName_leftColumn &sipStrings_QtGui[73752]
#define sipNameNr_clearSpans 73763
#define sipName_clearSpans &sipStrings_QtGui[73763]
#define sipNameNr_columnSpan 73774
#define sipName_columnSpan &sipStrings_QtGui[73774]
#define sipNameNr_rowResized 73785
#define sipName_rowResized &sipStrings_QtGui[73785]
#define sipNameNr_showColumn 73796
#define sipName_showColumn &sipStrings_QtGui[73796]
#define sipNameNr_hideColumn 73807
#define sipName_hideColumn &sipStrings_QtGui[73807]
#define sipNameNr_QTableView 73818
#define sipName_QTableView &sipStrings_QtGui[73818]
#define sipNameNr_tabRemoved 73829
#define sipName_tabRemoved &sipStrings_QtGui[73829]
#define sipNameNr_setTabData 73840
#define sipName_setTabData &sipStrings_QtGui[73840]
#define sipNameNr_tabToolTip 73851
#define sipName_tabToolTip &sipStrings_QtGui[73851]
#define sipNameNr_setTabIcon 73862
#define sipName_setTabIcon &sipStrings_QtGui[73862]
#define sipNameNr_setTabText 73873
#define sipName_setTabText &sipStrings_QtGui[73873]
#define sipNameNr_HasDisplay 73884
#define sipName_HasDisplay &sipStrings_QtGui[73884]
#define sipNameNr_SH_Variant 73895
#define sipName_SH_Variant &sipStrings_QtGui[73895]
#define sipNameNr_SH_Default 73906
#define sipName_SH_Default &sipStrings_QtGui[73906]
#define sipNameNr_PopupDelay 12662
#define sipName_PopupDelay &sipStrings_QtGui[12662]
#define sipNameNr_upsideDown 73917
#define sipName_upsideDown &sipStrings_QtGui[73917]
#define sipNameNr_OnlyOneTab 73928
#define sipName_OnlyOneTab &sipStrings_QtGui[73928]
#define sipNameNr_tabBarRect 73939
#define sipName_tabBarRect &sipStrings_QtGui[73939]
#define sipNameNr_tabBarSize 73950
#define sipName_tabBarSize &sipStrings_QtGui[73950]
#define sipNameNr_SO_SpinBox 73961
#define sipName_SO_SpinBox &sipStrings_QtGui[73961]
#define sipNameNr_SO_Complex 73972
#define sipName_SO_Complex &sipStrings_QtGui[73972]
#define sipNameNr_SO_ToolBar 73983
#define sipName_SO_ToolBar &sipStrings_QtGui[73983]
#define sipNameNr_SO_ToolBox 73994
#define sipName_SO_ToolBox &sipStrings_QtGui[73994]
#define sipNameNr_SO_Default 74005
#define sipName_SO_Default &sipStrings_QtGui[74005]
#define sipNameNr_OptionType 492
#define sipName_OptionType &sipStrings_QtGui[492]
#define sipNameNr_SP_ArrowUp 74016
#define sipName_SP_ArrowUp &sipStrings_QtGui[74016]
#define sipNameNr_SP_DirIcon 74027
#define sipName_SP_DirIcon &sipStrings_QtGui[74027]
#define sipNameNr_CT_SpinBox 74038
#define sipName_CT_SpinBox &sipStrings_QtGui[74038]
#define sipNameNr_CT_MenuBar 74049
#define sipName_CT_MenuBar &sipStrings_QtGui[74049]
#define sipNameNr_SubControl 33003
#define sipName_SubControl &sipStrings_QtGui[33003]
#define sipNameNr_CC_SpinBox 74060
#define sipName_CC_SpinBox &sipStrings_QtGui[74060]
#define sipNameNr_SubElement 33117
#define sipName_SubElement &sipStrings_QtGui[33117]
#define sipNameNr_CE_ToolBar 74071
#define sipName_CE_ToolBar &sipStrings_QtGui[74071]
#define sipNameNr_State_Mini 74082
#define sipName_State_Mini &sipStrings_QtGui[74082]
#define sipNameNr_State_Item 74093
#define sipName_State_Item &sipStrings_QtGui[74093]
#define sipNameNr_State_Open 74104
#define sipName_State_Open &sipStrings_QtGui[74104]
#define sipNameNr_State_None 74115
#define sipName_State_None &sipStrings_QtGui[74115]
#define sipNameNr_stringList 74126
#define sipName_stringList &sipStrings_QtGui[74126]
#define sipNameNr_hideOrShow 74137
#define sipName_hideOrShow &sipStrings_QtGui[74137]
#define sipNameNr_QStatusBar 74148
#define sipName_QStatusBar &sipStrings_QtGui[74148]
#define sipNameNr_appendRows 74159
#define sipName_appendRows &sipStrings_QtGui[74159]
#define sipNameNr_takeColumn 74170
#define sipName_takeColumn &sipStrings_QtGui[74170]
#define sipNameNr_filterRole 74181
#define sipName_filterRole &sipStrings_QtGui[74181]
#define sipNameNr_sortColumn 74192
#define sipName_sortColumn &sipStrings_QtGui[74192]
#define sipNameNr_TicksRight 74203
#define sipName_TicksRight &sipStrings_QtGui[74203]
#define sipNameNr_TicksBelow 74214
#define sipName_TicksBelow &sipStrings_QtGui[74214]
#define sipNameNr_TicksAbove 74225
#define sipName_TicksAbove &sipStrings_QtGui[74225]
#define sipNameNr_ToolButton 18827
#define sipName_ToolButton &sipStrings_QtGui[18827]
#define sipNameNr_PushButton 58168
#define sipName_PushButton &sipStrings_QtGui[58168]
#define sipNameNr_IgnoreFlag 74236
#define sipName_IgnoreFlag &sipStrings_QtGui[74236]
#define sipNameNr_ShrinkFlag 74247
#define sipName_ShrinkFlag &sipStrings_QtGui[74247]
#define sipNameNr_ExpandFlag 74258
#define sipName_ExpandFlag &sipStrings_QtGui[74258]
#define sipNameNr_PolicyFlag 17194
#define sipName_PolicyFlag &sipStrings_QtGui[17194]
#define sipNameNr_setContext 74269
#define sipName_setContext &sipStrings_QtGui[74269]
#define sipNameNr_QScrollBar 74280
#define sipName_QScrollBar &sipStrings_QtGui[74280]
#define sipNameNr_takeWidget 74291
#define sipName_takeWidget &sipStrings_QtGui[74291]
#define sipNameNr_RegionType 29538
#define sipName_RegionType &sipStrings_QtGui[29538]
#define sipNameNr_fitToWidth 74302
#define sipName_fitToWidth &sipStrings_QtGui[74302]
#define sipNameNr_zoomFactor 74313
#define sipName_zoomFactor &sipStrings_QtGui[74313]
#define sipNameNr_FitToWidth 74324
#define sipName_FitToWidth &sipStrings_QtGui[74324]
#define sipNameNr_CustomZoom 74335
#define sipName_CustomZoom &sipStrings_QtGui[74335]
#define sipNameNr_PPK_Duplex 74346
#define sipName_PPK_Duplex &sipStrings_QtGui[74346]
#define sipNameNr_setEngines 74357
#define sipName_setEngines &sipStrings_QtGui[74357]
#define sipNameNr_resolution 74368
#define sipName_resolution &sipStrings_QtGui[74368]
#define sipNameNr_setCreator 74379
#define sipName_setCreator &sipStrings_QtGui[74379]
#define sipNameNr_setDocName 74390
#define sipName_setDocName &sipStrings_QtGui[74390]
#define sipNameNr_Millimeter 74401
#define sipName_Millimeter &sipStrings_QtGui[74401]
#define sipNameNr_DuplexAuto 74412
#define sipName_DuplexAuto &sipStrings_QtGui[74412]
#define sipNameNr_DuplexNone 74423
#define sipName_DuplexNone &sipStrings_QtGui[74423]
#define sipNameNr_DuplexMode 25875
#define sipName_DuplexMode &sipStrings_QtGui[25875]
#define sipNameNr_FormSource 74434
#define sipName_FormSource &sipStrings_QtGui[74434]
#define sipNameNr_appendHtml 74445
#define sipName_appendHtml &sipStrings_QtGui[74445]
#define sipNameNr_blockCount 74456
#define sipName_blockCount &sipStrings_QtGui[74456]
#define sipNameNr_cacheLimit 74467
#define sipName_cacheLimit &sipStrings_QtGui[74467]
#define sipNameNr_grabWidget 74478
#define sipName_grabWidget &sipStrings_QtGui[74478]
#define sipNameNr_grabWindow 74489
#define sipName_grabWindow &sipStrings_QtGui[74489]
#define sipNameNr_parameters 74500
#define sipName_parameters &sipStrings_QtGui[74500]
#define sipNameNr_QPictureIO 74511
#define sipName_QPictureIO &sipStrings_QtGui[74511]
#define sipNameNr_isCosmetic 74522
#define sipName_isCosmetic &sipStrings_QtGui[74522]
#define sipNameNr_isBrushSet 74533
#define sipName_isBrushSet &sipStrings_QtGui[74533]
#define sipNameNr_brightText 74544
#define sipName_brightText &sipStrings_QtGui[74544]
#define sipNameNr_windowText 74555
#define sipName_windowText &sipStrings_QtGui[74555]
#define sipNameNr_Background 20774
#define sipName_Background &sipStrings_QtGui[20774]
#define sipNameNr_ButtonText 30158
#define sipName_ButtonText &sipStrings_QtGui[30158]
#define sipNameNr_BrightText 74566
#define sipName_BrightText &sipStrings_QtGui[74566]
#define sipNameNr_Foreground 46467
#define sipName_Foreground &sipStrings_QtGui[46467]
#define sipNameNr_WindowText 74577
#define sipName_WindowText &sipStrings_QtGui[74577]
#define sipNameNr_ColorGroup 25980
#define sipName_ColorGroup &sipStrings_QtGui[25980]
#define sipNameNr_dashOffset 74588
#define sipName_dashOffset &sipStrings_QtGui[74588]
#define sipNameNr_miterLimit 74599
#define sipName_miterLimit &sipStrings_QtGui[74599]
#define sipNameNr_subtracted 74610
#define sipName_subtracted &sipStrings_QtGui[74610]
#define sipNameNr_toReversed 74621
#define sipName_toReversed &sipStrings_QtGui[74621]
#define sipNameNr_hasFeature 74632
#define sipName_hasFeature &sipStrings_QtGui[74632]
#define sipNameNr_PostScript 74643
#define sipName_PostScript &sipStrings_QtGui[74643]
#define sipNameNr_MacPrinter 74654
#define sipName_MacPrinter &sipStrings_QtGui[74654]
#define sipNameNr_ConvexMode 74665
#define sipName_ConvexMode &sipStrings_QtGui[74665]
#define sipNameNr_DirtyFlags 15345
#define sipName_DirtyFlags &sipStrings_QtGui[15345]
#define sipNameNr_DirtyHints 74676
#define sipName_DirtyHints &sipStrings_QtGui[74676]
#define sipNameNr_DirtyBrush 74687
#define sipName_DirtyBrush &sipStrings_QtGui[74687]
#define sipNameNr_BlendModes 74698
#define sipName_BlendModes &sipStrings_QtGui[74698]
#define sipNameNr_PorterDuff 74709
#define sipName_PorterDuff &sipStrings_QtGui[74709]
#define sipNameNr_AlphaBlend 74720
#define sipName_AlphaBlend &sipStrings_QtGui[74720]
#define sipNameNr_RenderFlag 22424
#define sipName_RenderFlag &sipStrings_QtGui[22424]
#define sipNameNr_PdmWidthMM 74731
#define sipName_PdmWidthMM &sipStrings_QtGui[74731]
#define sipNameNr_redirected 74742
#define sipName_redirected &sipStrings_QtGui[74742]
#define sipNameNr_drawPixmap 74753
#define sipName_drawPixmap &sipStrings_QtGui[74753]
#define sipNameNr_drawPoints 74764
#define sipName_drawPoints &sipStrings_QtGui[74764]
#define sipNameNr_strokePath 74775
#define sipName_strokePath &sipStrings_QtGui[74775]
#define sipNameNr_clipRegion 74786
#define sipName_clipRegion &sipStrings_QtGui[74786]
#define sipNameNr_RenderHint 26127
#define sipName_RenderHint &sipStrings_QtGui[26127]
#define sipNameNr_frameCount 74797
#define sipName_frameCount &sipStrings_QtGui[74797]
#define sipNameNr_MovieState 33953
#define sipName_MovieState &sipStrings_QtGui[33953]
#define sipNameNr_buttonText 74808
#define sipName_buttonText &sipStrings_QtGui[74808]
#define sipNameNr_iconPixmap 74819
#define sipName_iconPixmap &sipStrings_QtGui[74819]
#define sipNameNr_ButtonMask 74830
#define sipName_ButtonMask &sipStrings_QtGui[74830]
#define sipNameNr_LastButton 74841
#define sipName_LastButton &sipStrings_QtGui[74841]
#define sipNameNr_enterEvent 74852
#define sipName_enterEvent &sipStrings_QtGui[74852]
#define sipNameNr_menuAction 74863
#define sipName_menuAction &sipStrings_QtGui[74863]
#define sipNameNr_insertMenu 74874
#define sipName_insertMenu &sipStrings_QtGui[74874]
#define sipNameNr_leaveEvent 74885
#define sipName_leaveEvent &sipStrings_QtGui[74885]
#define sipNameNr_showShaded 74896
#define sipName_showShaded &sipStrings_QtGui[74896]
#define sipNameNr_systemMenu 74907
#define sipName_systemMenu &sipStrings_QtGui[74907]
#define sipNameNr_TabbedView 74918
#define sipName_TabbedView &sipStrings_QtGui[74918]
#define sipNameNr_AreaOption 26190
#define sipName_AreaOption &sipStrings_QtGui[26190]
#define sipNameNr_isIdentity 74929
#define sipName_isIdentity &sipStrings_QtGui[74929]
#define sipNameNr_DockOption 17434
#define sipName_DockOption &sipStrings_QtGui[17434]
#define sipNameNr_menuWidget 74940
#define sipName_menuWidget &sipStrings_QtGui[74940]
#define sipNameNr_isAnimated 74951
#define sipName_isAnimated &sipStrings_QtGui[74951]
#define sipNameNr_addToolBar 74962
#define sipName_addToolBar &sipStrings_QtGui[74962]
#define sipNameNr_itemWidget 74973
#define sipName_itemWidget &sipStrings_QtGui[74973]
#define sipNameNr_foreground 74984
#define sipName_foreground &sipStrings_QtGui[74984]
#define sipNameNr_background 74995
#define sipName_background &sipStrings_QtGui[74995]
#define sipNameNr_listWidget 75006
#define sipName_listWidget &sipStrings_QtGui[75006]
#define sipNameNr_layoutMode 75017
#define sipName_layoutMode &sipStrings_QtGui[75017]
#define sipNameNr_isWrapping 75028
#define sipName_isWrapping &sipStrings_QtGui[75028]
#define sipNameNr_SinglePass 75039
#define sipName_SinglePass &sipStrings_QtGui[75039]
#define sipNameNr_LayoutMode 22688
#define sipName_LayoutMode &sipStrings_QtGui[22688]
#define sipNameNr_cursorRect 75050
#define sipName_cursorRect &sipStrings_QtGui[75050]
#define sipNameNr_textEdited 75061
#define sipName_textEdited &sipStrings_QtGui[75061]
#define sipNameNr_isModified 75072
#define sipName_isModified &sipStrings_QtGui[75072]
#define sipNameNr_setBinMode 75083
#define sipName_setBinMode &sipStrings_QtGui[75083]
#define sipNameNr_setOctMode 75094
#define sipName_setOctMode &sipStrings_QtGui[75094]
#define sipNameNr_setDecMode 75105
#define sipName_setDecMode &sipStrings_QtGui[75105]
#define sipNameNr_setHexMode 75116
#define sipName_setHexMode &sipStrings_QtGui[75116]
#define sipNameNr_QLCDNumber 75127
#define sipName_QLCDNumber &sipStrings_QtGui[75127]
#define sipNameNr_changeSize 75138
#define sipName_changeSize &sipStrings_QtGui[75138]
#define sipNameNr_spacerItem 75149
#define sipName_spacerItem &sipStrings_QtGui[75149]
#define sipNameNr_setMenuBar 75160
#define sipName_setMenuBar &sipStrings_QtGui[75160]
#define sipNameNr_setPicture 75171
#define sipName_setPicture &sipStrings_QtGui[75171]
#define sipNameNr_textFormat 75182
#define sipName_textFormat &sipStrings_QtGui[75182]
#define sipNameNr_UnknownKey 75193
#define sipName_UnknownKey &sipStrings_QtGui[75193]
#define sipNameNr_ExactMatch 75204
#define sipName_ExactMatch &sipStrings_QtGui[75204]
#define sipNameNr_NativeText 75215
#define sipName_NativeText &sipStrings_QtGui[75215]
#define sipNameNr_setIntStep 75226
#define sipName_setIntStep &sipStrings_QtGui[75226]
#define sipNameNr_intMaximum 75237
#define sipName_intMaximum &sipStrings_QtGui[75237]
#define sipNameNr_intMinimum 75248
#define sipName_intMinimum &sipStrings_QtGui[75248]
#define sipNameNr_getInteger 75259
#define sipName_getInteger &sipStrings_QtGui[75259]
#define sipNameNr_setQuality 75270
#define sipName_setQuality &sipStrings_QtGui[75270]
#define sipNameNr_scaledSize 75281
#define sipName_scaledSize &sipStrings_QtGui[75281]
#define sipNameNr_imageCount 75292
#define sipName_imageCount &sipStrings_QtGui[75292]
#define sipNameNr_Endianness 75303
#define sipName_Endianness &sipStrings_QtGui[75303]
#define sipNameNr_ScaledSize 59918
#define sipName_ScaledSize &sipStrings_QtGui[59918]
#define sipNameNr_rgbSwapped 75314
#define sipName_rgbSwapped &sipStrings_QtGui[75314]
#define sipNameNr_trueMatrix 75325
#define sipName_trueMatrix &sipStrings_QtGui[75325]
#define sipNameNr_colorTable 75336
#define sipName_colorTable &sipStrings_QtGui[75336]
#define sipNameNr_pixelIndex 75347
#define sipName_pixelIndex &sipStrings_QtGui[75347]
#define sipNameNr_InvertRgba 75358
#define sipName_InvertRgba &sipStrings_QtGui[75358]
#define sipNameNr_InvertMode 34561
#define sipName_InvertMode &sipStrings_QtGui[34561]
#define sipNameNr_actualSize 75369
#define sipName_actualSize &sipStrings_QtGui[75369]
#define sipNameNr_resizeMode 75380
#define sipName_resizeMode &sipStrings_QtGui[75380]
#define sipNameNr_setMovable 75391
#define sipName_setMovable &sipStrings_QtGui[75391]
#define sipNameNr_ResizeMode 17602
#define sipName_ResizeMode &sipStrings_QtGui[17602]
#define sipNameNr_rowStretch 75402
#define sipName_rowStretch &sipStrings_QtGui[75402]
#define sipNameNr_addActions 75413
#define sipName_addActions &sipStrings_QtGui[75413]
#define sipNameNr_windowType 75424
#define sipName_windowType &sipStrings_QtGui[75424]
#define sipNameNr_SceneLayer 11974
#define sipName_SceneLayer &sipStrings_QtGui[11974]
#define sipNameNr_addPolygon 75435
#define sipName_addPolygon &sipStrings_QtGui[75435]
#define sipNameNr_addEllipse 75446
#define sipName_addEllipse &sipStrings_QtGui[75446]
#define sipNameNr_sizePolicy 75457
#define sipName_sizePolicy &sipStrings_QtGui[75457]
#define sipNameNr_setShearAt 75468
#define sipName_setShearAt &sipStrings_QtGui[75468]
#define sipNameNr_setScaleAt 75479
#define sipName_setScaleAt &sipStrings_QtGui[75479]
#define sipNameNr_rotationAt 75490
#define sipName_rotationAt &sipStrings_QtGui[75490]
#define sipNameNr_addToGroup 75501
#define sipName_addToGroup &sipStrings_QtGui[75501]
#define sipNameNr_textCursor 75512
#define sipName_textCursor &sipStrings_QtGui[75512]
#define sipNameNr_adjustSize 75523
#define sipName_adjustSize &sipStrings_QtGui[75523]
#define sipNameNr_setPolygon 75534
#define sipName_setPolygon &sipStrings_QtGui[75534]
#define sipNameNr_startAngle 75545
#define sipName_startAngle &sipStrings_QtGui[75545]
#define sipNameNr_setOpacity 75556
#define sipName_setOpacity &sipStrings_QtGui[75556]
#define sipNameNr_childItems 75567
#define sipName_childItems &sipStrings_QtGui[75567]
#define sipNameNr_sceneEvent 75578
#define sipName_sceneEvent &sipStrings_QtGui[75578]
#define sipNameNr_itemChange 75589
#define sipName_itemChange &sipStrings_QtGui[75589]
#define sipNameNr_mapToScene 75600
#define sipName_mapToScene &sipStrings_QtGui[75600]
#define sipNameNr_opaqueArea 75611
#define sipName_opaqueArea &sipStrings_QtGui[75611]
#define sipNameNr_isObscured 75622
#define sipName_isObscured &sipStrings_QtGui[75622]
#define sipNameNr_clearFocus 75633
#define sipName_clearFocus &sipStrings_QtGui[75633]
#define sipNameNr_isSelected 75644
#define sipName_isSelected &sipStrings_QtGui[75644]
#define sipNameNr_parentItem 75655
#define sipName_parentItem &sipStrings_QtGui[75655]
#define sipNameNr_rowSpacing 75666
#define sipName_rowSpacing &sipStrings_QtGui[75666]
#define sipNameNr_frameShape 75677
#define sipName_frameShape &sipStrings_QtGui[75677]
#define sipNameNr_frameWidth 75688
#define sipName_frameWidth &sipStrings_QtGui[75688]
#define sipNameNr_frameStyle 75699
#define sipName_frameStyle &sipStrings_QtGui[75699]
#define sipNameNr_Shape_Mask 75710
#define sipName_Shape_Mask &sipStrings_QtGui[75710]
#define sipNameNr_isScalable 75721
#define sipName_isScalable &sipStrings_QtGui[75721]
#define sipNameNr_pointSizes 75732
#define sipName_pointSizes &sipStrings_QtGui[75732]
#define sipNameNr_Devanagari 75743
#define sipName_Devanagari &sipStrings_QtGui[75743]
#define sipNameNr_FontFilter 13832
#define sipName_FontFilter &sipStrings_QtGui[13832]
#define sipNameNr_Capitalize 75754
#define sipName_Capitalize &sipStrings_QtGui[75754]
#define sipNameNr_initialize 75765
#define sipName_initialize &sipStrings_QtGui[75765]
#define sipNameNr_substitute 75776
#define sipName_substitute &sipStrings_QtGui[75776]
#define sipNameNr_setRawName 75787
#define sipName_setRawName &sipStrings_QtGui[75787]
#define sipNameNr_setRawMode 75798
#define sipName_setRawMode &sipStrings_QtGui[75798]
#define sipNameNr_setKerning 75809
#define sipName_setKerning &sipStrings_QtGui[75809]
#define sipNameNr_fixedPitch 75820
#define sipName_fixedPitch &sipStrings_QtGui[75820]
#define sipNameNr_pointSizeF 75831
#define sipName_pointSizeF &sipStrings_QtGui[75831]
#define sipNameNr_Decorative 75842
#define sipName_Decorative &sipStrings_QtGui[75842]
#define sipNameNr_OldEnglish 75853
#define sipName_OldEnglish &sipStrings_QtGui[75853]
#define sipNameNr_TypeWriter 75864
#define sipName_TypeWriter &sipStrings_QtGui[75864]
#define sipNameNr_myComputer 75875
#define sipName_myComputer &sipStrings_QtGui[75875]
#define sipNameNr_proxyModel 75886
#define sipName_proxyModel &sipStrings_QtGui[75886]
#define sipNameNr_setHistory 75897
#define sipName_setHistory &sipStrings_QtGui[75897]
#define sipNameNr_acceptMode 75908
#define sipName_acceptMode &sipStrings_QtGui[75908]
#define sipNameNr_setFilters 75919
#define sipName_setFilters &sipStrings_QtGui[75919]
#define sipNameNr_selectFile 75930
#define sipName_selectFile &sipStrings_QtGui[75930]
#define sipNameNr_AcceptSave 75941
#define sipName_AcceptSave &sipStrings_QtGui[75941]
#define sipNameNr_AcceptOpen 75952
#define sipName_AcceptOpen &sipStrings_QtGui[75952]
#define sipNameNr_AcceptMode 17962
#define sipName_AcceptMode &sipStrings_QtGui[17962]
#define sipNameNr_shortcutId 75963
#define sipName_shortcutId &sipStrings_QtGui[75963]
#define sipNameNr_QHelpEvent 75974
#define sipName_QHelpEvent &sipStrings_QtGui[75974]
#define sipNameNr_answerRect 75985
#define sipName_answerRect &sipStrings_QtGui[75985]
#define sipNameNr_dropAction 75996
#define sipName_dropAction &sipStrings_QtGui[75996]
#define sipNameNr_QDropEvent 76007
#define sipName_QDropEvent &sipStrings_QtGui[76007]
#define sipNameNr_QHideEvent 76018
#define sipName_QHideEvent &sipStrings_QtGui[76018]
#define sipNameNr_QShowEvent 76029
#define sipName_QShowEvent &sipStrings_QtGui[76029]
#define sipNameNr_QMoveEvent 76040
#define sipName_QMoveEvent &sipStrings_QtGui[76040]
#define sipNameNr_FourDMouse 76051
#define sipName_FourDMouse &sipStrings_QtGui[76051]
#define sipNameNr_setHotSpot 76062
#define sipName_setHotSpot &sipStrings_QtGui[76062]
#define sipNameNr_isFloating 76073
#define sipName_isFloating &sipStrings_QtGui[76073]
#define sipNameNr_buttonRole 76084
#define sipName_buttonRole &sipStrings_QtGui[76084]
#define sipNameNr_ActionRole 76095
#define sipName_ActionRole &sipStrings_QtGui[76095]
#define sipNameNr_RejectRole 76106
#define sipName_RejectRole &sipStrings_QtGui[76106]
#define sipNameNr_AcceptRole 76117
#define sipName_AcceptRole &sipStrings_QtGui[76117]
#define sipNameNr_ButtonRole 10100
#define sipName_ButtonRole &sipStrings_QtGui[10100]
#define sipNameNr_DialogCode 30938
#define sipName_DialogCode &sipStrings_QtGui[30938]
#define sipNameNr_numScreens 76128
#define sipName_numScreens &sipStrings_QtGui[76128]
#define sipNameNr_DaySection 76139
#define sipName_DaySection &sipStrings_QtGui[76139]
#define sipNameNr_toPrevious 76150
#define sipName_toPrevious &sipStrings_QtGui[76150]
#define sipNameNr_addMapping 76161
#define sipName_addMapping &sipStrings_QtGui[76161]
#define sipNameNr_AutoSubmit 76172
#define sipName_AutoSubmit &sipStrings_QtGui[76172]
#define sipNameNr_wrapAround 76183
#define sipName_wrapAround &sipStrings_QtGui[76183]
#define sipNameNr_currentRow 76194
#define sipName_currentRow &sipStrings_QtGui[76194]
#define sipNameNr_QCompleter 76205
#define sipName_QCompleter &sipStrings_QtGui[76205]
#define sipNameNr_removeItem 76216
#define sipName_removeItem &sipStrings_QtGui[76216]
#define sipNameNr_setOptions 76227
#define sipName_setOptions &sipStrings_QtGui[76227]
#define sipNameNr_testOption 76238
#define sipName_testOption &sipStrings_QtGui[76238]
#define sipNameNr_FindBuffer 35644
#define sipName_FindBuffer &sipStrings_QtGui[35644]
#define sipNameNr_QClipboard 76249
#define sipName_QClipboard &sipStrings_QtGui[76249]
#define sipNameNr_checkState 76260
#define sipName_checkState &sipStrings_QtGui[76260]
#define sipNameNr_isTristate 76271
#define sipName_isTristate &sipStrings_QtGui[76271]
#define sipNameNr_updateCell 76282
#define sipName_updateCell &sipStrings_QtGui[76282]
#define sipNameNr_monthShown 76293
#define sipName_monthShown &sipStrings_QtGui[76293]
#define sipNameNr_focalPoint 76304
#define sipName_focalPoint &sipStrings_QtGui[76304]
#define sipNameNr_setColorAt 76315
#define sipName_setColorAt &sipStrings_QtGui[76315]
#define sipNameNr_NoGradient 76326
#define sipName_NoGradient &sipStrings_QtGui[76326]
#define sipNameNr_setTexture 76337
#define sipName_setTexture &sipStrings_QtGui[76337]
#define sipNameNr_saturation 76348
#define sipName_saturation &sipStrings_QtGui[76348]
#define sipNameNr_colorNames 76359
#define sipName_colorNames &sipStrings_QtGui[76359]
#define sipNameNr_insertItem 76370
#define sipName_insertItem &sipStrings_QtGui[76370]
#define sipNameNr_setStretch 76381
#define sipName_setStretch &sipStrings_QtGui[76381]
#define sipNameNr_setSpacing 76392
#define sipName_setSpacing &sipStrings_QtGui[76392]
#define sipNameNr_invalidate 76403
#define sipName_invalidate &sipStrings_QtGui[76403]
#define sipNameNr_addStretch 76414
#define sipName_addStretch &sipStrings_QtGui[76414]
#define sipNameNr_addSpacing 76425
#define sipName_addSpacing &sipStrings_QtGui[76425]
#define sipNameNr_QBoxLayout 76436
#define sipName_QBoxLayout &sipStrings_QtGui[76436]
#define sipNameNr_styleSheet 76447
#define sipName_styleSheet &sipStrings_QtGui[76447]
#define sipNameNr_sessionKey 76458
#define sipName_sessionKey &sipStrings_QtGui[76458]
#define sipNameNr_topLevelAt 76469
#define sipName_topLevelAt &sipStrings_QtGui[76469]
#define sipNameNr_allWidgets 76480
#define sipName_allWidgets &sipStrings_QtGui[76480]
#define sipNameNr_windowIcon 76491
#define sipName_windowIcon &sipStrings_QtGui[76491]
#define sipNameNr_setPalette 76502
#define sipName_setPalette &sipStrings_QtGui[76502]
#define sipNameNr_setVisible 76513
#define sipName_setVisible &sipStrings_QtGui[76513]
#define sipNameNr_setToolTip 76524
#define sipName_setToolTip &sipStrings_QtGui[76524]
#define sipNameNr_SliderMove 76535
#define sipName_SliderMove &sipStrings_QtGui[76535]
#define sipNameNr_singleStep 76546
#define sipName_singleStep &sipStrings_QtGui[76546]
#define sipNameNr_setMaximum 76557
#define sipName_setMaximum &sipStrings_QtGui[76557]
#define sipNameNr_setMinimum 76568
#define sipName_setMinimum &sipStrings_QtGui[76568]
#define sipNameNr_drawObject 76579
#define sipName_drawObject &sipStrings_QtGui[76579]
#define sipNameNr_selections 76590
#define sipName_selections &sipStrings_QtGui[76590]
#define sipNameNr_closeEvent 76601
#define sipName_closeEvent &sipStrings_QtGui[76601]
#define sipNameNr_isReadOnly 76612
#define sipName_isReadOnly &sipStrings_QtGui[76612]
#define sipNameNr_wheelEvent 76623
#define sipName_wheelEvent &sipStrings_QtGui[76623]
#define sipNameNr_printRange 76634
#define sipName_printRange &sipStrings_QtGui[76634]
#define sipNameNr_PrintRange 6390
#define sipName_PrintRange &sipStrings_QtGui[6390]
#define sipNameNr_OnViewport 76645
#define sipName_OnViewport &sipStrings_QtGui[76645]
#define sipNameNr_moveCursor 76656
#define sipName_moveCursor &sipStrings_QtGui[76656]
#define sipNameNr_MovePageUp 76667
#define sipName_MovePageUp &sipStrings_QtGui[76667]
#define sipNameNr_visualRect 76678
#define sipName_visualRect &sipStrings_QtGui[76678]
#define sipNameNr_SelectRows 76689
#define sipName_SelectRows &sipStrings_QtGui[76689]
#define sipNameNr_ScrollMode 9200
#define sipName_ScrollMode &sipStrings_QtGui[9200]
#define sipNameNr_ScrollHint 9230
#define sipName_ScrollHint &sipStrings_QtGui[9230]
#define sipNameNr_NoDragDrop 76700
#define sipName_NoDragDrop &sipStrings_QtGui[76700]
#define sipNameNr_commitData 76711
#define sipName_commitData &sipStrings_QtGui[76711]
#define sipNameNr_elidedText 76722
#define sipName_elidedText &sipStrings_QtGui[76722]
#define sipNameNr_paintEvent 76733
#define sipName_paintEvent &sipStrings_QtGui[76733]
#define sipNameNr_setChecked 76744
#define sipName_setChecked &sipStrings_QtGui[76744]
#define sipNameNr_autoRepeat 76755
#define sipName_autoRepeat &sipStrings_QtGui[76755]
#define sipNameNr_attributes 76766
#define sipName_attributes &sipStrings_QtGui[76766]
#define sipNameNr_lineNumber 76777
#define sipName_lineNumber &sipStrings_QtGui[76777]
#define sipNameNr_isFinished 76788
#define sipName_isFinished &sipStrings_QtGui[76788]
#define sipNameNr_setEnabled 76799
#define sipName_setEnabled &sipStrings_QtGui[76799]
#define sipNameNr_exactMatch 76810
#define sipName_exactMatch &sipStrings_QtGui[76810]
#define sipNameNr_intersects 76821
#define sipName_intersects &sipStrings_QtGui[76821]
#define sipNameNr_NotRunning 76832
#define sipName_NotRunning &sipStrings_QtGui[76832]
#define sipNameNr_childEvent 76843
#define sipName_childEvent &sipStrings_QtGui[76843]
#define sipNameNr_timerEvent 76854
#define sipName_timerEvent &sipStrings_QtGui[76854]
#define sipNameNr_QTransform 76865
#define sipName_QTransform &sipStrings_QtGui[76865]
#define sipNameNr_isEditable 76876
#define sipName_isEditable &sipStrings_QtGui[76876]
#define sipNameNr_FormatType 16306
#define sipName_FormatType &sipStrings_QtGui[16306]
#define sipNameNr_setDefault 76887
#define sipName_setDefault &sipStrings_QtGui[76887]
#define sipNameNr_Vietnamese 76898
#define sipName_Vietnamese &sipStrings_QtGui[76898]
#define sipNameNr_translated 76909
#define sipName_translated &sipStrings_QtGui[76909]
#define sipNameNr_setSorting 76920
#define sipName_setSorting &sipStrings_QtGui[76920]
#define sipNameNr_fromString 76931
#define sipName_fromString &sipStrings_QtGui[76931]
#define sipNameNr_simplified 76942
#define sipName_simplified &sipStrings_QtGui[76942]
#define sipNameNr___rshift__ 76953
#define sipName___rshift__ &sipStrings_QtGui[76953]
#define sipNameNr___lshift__ 76964
#define sipName___lshift__ &sipStrings_QtGui[76964]
#define sipNameNr_isDetached 76975
#define sipName_isDetached &sipStrings_QtGui[76975]
#define sipNameNr_decodeData 76986
#define sipName_decodeData &sipStrings_QtGui[76986]
#define sipNameNr_encodeData 76997
#define sipName_encodeData &sipStrings_QtGui[76997]
#define sipNameNr_removeRows 77008
#define sipName_removeRows &sipStrings_QtGui[77008]
#define sipNameNr_insertRows 77019
#define sipName_insertRows &sipStrings_QtGui[77019]
#define sipNameNr_headerData 77030
#define sipName_headerData &sipStrings_QtGui[77030]
#define sipNameNr_AnchorHref 57342
#define sipName_AnchorHref &sipStrings_QtGui[57342]
#define sipNameNr_AnchorName 57328
#define sipName_AnchorName &sipStrings_QtGui[57328]
#define sipNameNr_TextFormat 27198
#define sipName_TextFormat &sipStrings_QtGui[27198]
#define sipNameNr___invert__ 77041
#define sipName___invert__ &sipStrings_QtGui[77041]
#define sipNameNr_appVisual 77052
#define sipName_appVisual &sipStrings_QtGui[77052]
#define sipNameNr_appScreen 77062
#define sipName_appScreen &sipStrings_QtGui[77062]
#define sipNameNr_embedInto 77072
#define sipName_embedInto &sipStrings_QtGui[77072]
#define sipNameNr_addWindow 77082
#define sipName_addWindow &sipStrings_QtGui[77082]
#define sipNameNr_setButton 24910
#define sipName_setButton &sipStrings_QtGui[24910]
#define sipNameNr_currentId 77092
#define sipName_currentId &sipStrings_QtGui[77092]
#define sipNameNr_AeroStyle 77102
#define sipName_AeroStyle &sipStrings_QtGui[77102]
#define sipNameNr_clearMask 77112
#define sipName_clearMask &sipStrings_QtGui[77112]
#define sipNameNr_frameSize 77122
#define sipName_frameSize &sipStrings_QtGui[77122]
#define sipNameNr_setRegExp 77132
#define sipName_setRegExp &sipStrings_QtGui[77132]
#define sipNameNr_cleanIcon 77142
#define sipName_cleanIcon &sipStrings_QtGui[77142]
#define sipNameNr_QUndoView 77152
#define sipName_QUndoView &sipStrings_QtGui[77152]
#define sipNameNr_undoLimit 77162
#define sipName_undoLimit &sipStrings_QtGui[77162]
#define sipNameNr_mergeWith 77172
#define sipName_mergeWith &sipStrings_QtGui[77172]
#define sipNameNr_NotHidden 77182
#define sipName_NotHidden &sipStrings_QtGui[77182]
#define sipNameNr_itemBelow 77192
#define sipName_itemBelow &sipStrings_QtGui[77192]
#define sipNameNr_itemAbove 77202
#define sipName_itemAbove &sipStrings_QtGui[77202]
#define sipNameNr_expandAll 77212
#define sipName_expandAll &sipStrings_QtGui[77212]
#define sipNameNr_collapsed 77222
#define sipName_collapsed &sipStrings_QtGui[77222]
#define sipNameNr_setHeader 77232
#define sipName_setHeader &sipStrings_QtGui[77232]
#define sipNameNr_QTreeView 77242
#define sipName_QTreeView &sipStrings_QtGui[77242]
#define sipNameNr_fromScale 77252
#define sipName_fromScale &sipStrings_QtGui[77252]
#define sipNameNr_isScaling 77262
#define sipName_isScaling &sipStrings_QtGui[77262]
#define sipNameNr_TxProject 77272
#define sipName_TxProject &sipStrings_QtGui[77272]
#define sipNameNr_autoRaise 77282
#define sipName_autoRaise &sipStrings_QtGui[77282]
#define sipNameNr_popupMode 77292
#define sipName_popupMode &sipStrings_QtGui[77292]
#define sipNameNr_splitCell 77302
#define sipName_splitCell &sipStrings_QtGui[77302]
#define sipNameNr_delimiter 77312
#define sipName_delimiter &sipStrings_QtGui[77312]
#define sipNameNr_CenterTab 77322
#define sipName_CenterTab &sipStrings_QtGui[77322]
#define sipNameNr_userState 77332
#define sipName_userState &sipStrings_QtGui[77332]
#define sipNameNr_blockList 77342
#define sipName_blockList &sipStrings_QtGui[77342]
#define sipNameNr_QTextList 77352
#define sipName_QTextList &sipStrings_QtGui[77352]
#define sipNameNr_textStart 77362
#define sipName_textStart &sipStrings_QtGui[77362]
#define sipNameNr_xToCursor 77372
#define sipName_xToCursor &sipStrings_QtGui[77372]
#define sipNameNr_cursorToX 77382
#define sipName_cursorToX &sipStrings_QtGui[77382]
#define sipNameNr_QTextLine 77392
#define sipName_QTextLine &sipStrings_QtGui[77392]
#define sipNameNr_SkipWords 77402
#define sipName_SkipWords &sipStrings_QtGui[77402]
#define sipNameNr_endLayout 77412
#define sipName_endLayout &sipStrings_QtGui[77412]
#define sipNameNr_setAscent 77422
#define sipName_setAscent &sipStrings_QtGui[77422]
#define sipNameNr_setBorder 77432
#define sipName_setBorder &sipStrings_QtGui[77432]
#define sipNameNr_FloatLeft 77442
#define sipName_FloatLeft &sipStrings_QtGui[77442]
#define sipNameNr_topMargin 77452
#define sipName_topMargin &sipStrings_QtGui[77452]
#define sipNameNr_setAnchor 77462
#define sipName_setAnchor &sipStrings_QtGui[77462]
#define sipNameNr_ImageName 77472
#define sipName_ImageName &sipStrings_QtGui[77472]
#define sipNameNr_ListStyle 77482
#define sipName_ListStyle &sipStrings_QtGui[77482]
#define sipNameNr_lineCount 77492
#define sipName_lineCount &sipStrings_QtGui[77492]
#define sipNameNr_lastBlock 77502
#define sipName_lastBlock &sipStrings_QtGui[77502]
#define sipNameNr_findBlock 77512
#define sipName_findBlock &sipStrings_QtGui[77512]
#define sipNameNr_rootFrame 77522
#define sipName_rootFrame &sipStrings_QtGui[77522]
#define sipNameNr_FindFlags 14396
#define sipName_FindFlags &sipStrings_QtGui[14396]
#define sipNameNr_WordRight 77532
#define sipName_WordRight &sipStrings_QtGui[77532]
#define sipNameNr_NextBlock 77542
#define sipName_NextBlock &sipStrings_QtGui[77542]
#define sipNameNr_EndOfWord 48452
#define sipName_EndOfWord &sipStrings_QtGui[48452]
#define sipNameNr_EndOfLine 48436
#define sipName_EndOfLine &sipStrings_QtGui[48436]
#define sipNameNr_openLinks 77552
#define sipName_openLinks &sipStrings_QtGui[77552]
#define sipNameNr_setSource 77562
#define sipName_setSource &sipStrings_QtGui[77562]
#define sipNameNr_QTextEdit 77572
#define sipName_QTextEdit &sipStrings_QtGui[77572]
#define sipNameNr_setTabBar 77582
#define sipName_setTabBar &sipStrings_QtGui[77582]
#define sipNameNr_visualRow 77592
#define sipName_visualRow &sipStrings_QtGui[77592]
#define sipNameNr_bottomRow 77602
#define sipName_bottomRow &sipStrings_QtGui[77602]
#define sipNameNr_selectRow 77612
#define sipName_selectRow &sipStrings_QtGui[77612]
#define sipNameNr_gridStyle 77622
#define sipName_gridStyle &sipStrings_QtGui[77622]
#define sipNameNr_rowHeight 77632
#define sipName_rowHeight &sipStrings_QtGui[77632]
#define sipNameNr_expanding 77642
#define sipName_expanding &sipStrings_QtGui[77642]
#define sipNameNr_tabButton 77652
#define sipName_tabButton &sipStrings_QtGui[77652]
#define sipNameNr_RightSide 77662
#define sipName_RightSide &sipStrings_QtGui[77662]
#define sipNameNr_elideMode 77672
#define sipName_elideMode &sipStrings_QtGui[77672]
#define sipNameNr_removeTab 77682
#define sipName_removeTab &sipStrings_QtGui[77682]
#define sipNameNr_insertTab 77692
#define sipName_insertTab &sipStrings_QtGui[77692]
#define sipNameNr_Alternate 77702
#define sipName_Alternate &sipStrings_QtGui[77702]
#define sipNameNr_popupRect 77712
#define sipName_popupRect &sipStrings_QtGui[77712]
#define sipNameNr_arrowType 77722
#define sipName_arrowType &sipStrings_QtGui[77722]
#define sipNameNr_floatable 77732
#define sipName_floatable &sipStrings_QtGui[77732]
#define sipNameNr_checkType 77742
#define sipName_checkType &sipStrings_QtGui[77742]
#define sipNameNr_Exclusive 45664
#define sipName_Exclusive &sipStrings_QtGui[45664]
#define sipNameNr_CheckType 6520
#define sipName_CheckType &sipStrings_QtGui[6520]
#define sipNameNr_EmptyArea 40
#define sipName_EmptyArea &sipStrings_QtGui[40]
#define sipNameNr_Separator 9753
#define sipName_Separator &sipStrings_QtGui[9753]
#define sipNameNr_Beginning 77752
#define sipName_Beginning &sipStrings_QtGui[77752]
#define sipNameNr_SO_Slider 77762
#define sipName_SO_Slider &sipStrings_QtGui[77762]
#define sipNameNr_SO_Header 77772
#define sipName_SO_Header &sipStrings_QtGui[77772]
#define sipNameNr_SO_Button 77782
#define sipName_SO_Button &sipStrings_QtGui[77782]
#define sipNameNr_visualPos 77792
#define sipName_visualPos &sipStrings_QtGui[77792]
#define sipNameNr_CT_Slider 77802
#define sipName_CT_Slider &sipStrings_QtGui[77802]
#define sipNameNr_CC_Slider 77812
#define sipName_CC_Slider &sipStrings_QtGui[77812]
#define sipNameNr_CE_Header 77822
#define sipName_CE_Header &sipStrings_QtGui[77822]
#define sipNameNr_PE_Widget 77832
#define sipName_PE_Widget &sipStrings_QtGui[77832]
#define sipNameNr_State_Top 77842
#define sipName_State_Top &sipStrings_QtGui[77842]
#define sipNameNr_State_Off 77852
#define sipName_State_Off &sipStrings_QtGui[77852]
#define sipNameNr_StateFlag 37830
#define sipName_StateFlag &sipStrings_QtGui[37830]
#define sipNameNr_takeChild 77862
#define sipName_takeChild &sipStrings_QtGui[77862]
#define sipNameNr_appendRow 77872
#define sipName_appendRow &sipStrings_QtGui[77872]
#define sipNameNr_QSplitter 77882
#define sipName_QSplitter &sipStrings_QtGui[77882]
#define sipNameNr_cleanText 77892
#define sipName_cleanText &sipStrings_QtGui[77892]
#define sipNameNr_setSuffix 77902
#define sipName_setSuffix &sipStrings_QtGui[77902]
#define sipNameNr_setPrefix 77912
#define sipName_setPrefix &sipStrings_QtGui[77912]
#define sipNameNr_sortOrder 77922
#define sipName_sortOrder &sipStrings_QtGui[77922]
#define sipNameNr_TicksLeft 77932
#define sipName_TicksLeft &sipStrings_QtGui[77932]
#define sipNameNr_TabWidget 37776
#define sipName_TabWidget &sipStrings_QtGui[37776]
#define sipNameNr_ButtonBox 44559
#define sipName_ButtonBox &sipStrings_QtGui[44559]
#define sipNameNr_Expanding 42570
#define sipName_Expanding &sipStrings_QtGui[42570]
#define sipNameNr_Preferred 77942
#define sipName_Preferred &sipStrings_QtGui[77942]
#define sipNameNr_QSizeGrip 77952
#define sipName_QSizeGrip &sipStrings_QtGui[77952]
#define sipNameNr_QShortcut 77962
#define sipName_QShortcut &sipStrings_QtGui[77962]
#define sipNameNr_Rectangle 77972
#define sipName_Rectangle &sipStrings_QtGui[77972]
#define sipNameNr_forceShow 77982
#define sipName_forceShow &sipStrings_QtGui[77982]
#define sipNameNr_autoClose 77992
#define sipName_autoClose &sipStrings_QtGui[77992]
#define sipNameNr_autoReset 78002
#define sipName_autoReset &sipStrings_QtGui[78002]
#define sipNameNr_FitInView 78012
#define sipName_FitInView &sipStrings_QtGui[78012]
#define sipNameNr_setDuplex 78022
#define sipName_setDuplex &sipStrings_QtGui[78022]
#define sipNameNr_paperSize 78032
#define sipName_paperSize &sipStrings_QtGui[78032]
#define sipNameNr_paperRect 78042
#define sipName_paperRect &sipStrings_QtGui[78042]
#define sipNameNr_numCopies 78052
#define sipName_numCopies &sipStrings_QtGui[78052]
#define sipNameNr_colorMode 78062
#define sipName_colorMode &sipStrings_QtGui[78062]
#define sipNameNr_pageOrder 78072
#define sipName_pageOrder &sipStrings_QtGui[78072]
#define sipNameNr_PdfFormat 78082
#define sipName_PdfFormat &sipStrings_QtGui[78082]
#define sipNameNr_GrayScale 78092
#define sipName_GrayScale &sipStrings_QtGui[78092]
#define sipNameNr_ColorMode 29719
#define sipName_ColorMode &sipStrings_QtGui[29719]
#define sipNameNr_PageOrder 29739
#define sipName_PageOrder &sipStrings_QtGui[29739]
#define sipNameNr_Executive 78102
#define sipName_Executive &sipStrings_QtGui[78102]
#define sipNameNr_Landscape 78112
#define sipName_Landscape &sipStrings_QtGui[78112]
#define sipNameNr_toPolygon 78122
#define sipName_toPolygon &sipStrings_QtGui[78122]
#define sipNameNr_QPolygonF 78132
#define sipName_QPolygonF &sipStrings_QtGui[78132]
#define sipNameNr_putPoints 78142
#define sipName_putPoints &sipStrings_QtGui[78142]
#define sipNameNr_ShareMode 33745
#define sipName_ShareMode &sipStrings_QtGui[33745]
#define sipNameNr_isQBitmap 78152
#define sipName_isQBitmap &sipStrings_QtGui[78152]
#define sipNameNr_setWidthF 78162
#define sipName_setWidthF &sipStrings_QtGui[78162]
#define sipNameNr_highlight 68815
#define sipName_highlight &sipStrings_QtGui[68815]
#define sipNameNr_Highlight 78172
#define sipName_Highlight &sipStrings_QtGui[78172]
#define sipNameNr_ColorRole 29799
#define sipName_ColorRole &sipStrings_QtGui[29799]
#define sipNameNr_joinStyle 78182
#define sipName_joinStyle &sipStrings_QtGui[78182]
#define sipNameNr_elementAt 78192
#define sipName_elementAt &sipStrings_QtGui[78192]
#define sipNameNr_arcMoveTo 78202
#define sipName_arcMoveTo &sipStrings_QtGui[78202]
#define sipNameNr_addRegion 78212
#define sipName_addRegion &sipStrings_QtGui[78212]
#define sipNameNr_isCurveTo 78222
#define sipName_isCurveTo &sipStrings_QtGui[78222]
#define sipNameNr_QuickDraw 78232
#define sipName_QuickDraw &sipStrings_QtGui[78232]
#define sipNameNr_setActive 78242
#define sipName_setActive &sipStrings_QtGui[78242]
#define sipNameNr_DirtyFont 78252
#define sipName_DirtyFont &sipStrings_QtGui[78252]
#define sipNameNr_DirtyFlag 17291
#define sipName_DirtyFlag &sipStrings_QtGui[17291]
#define sipNameNr_StrikeOut 41431
#define sipName_StrikeOut &sipStrings_QtGui[41431]
#define sipNameNr_QTextItem 78262
#define sipName_QTextItem &sipStrings_QtGui[78262]
#define sipNameNr_PdmHeight 78272
#define sipName_PdmHeight &sipStrings_QtGui[78272]
#define sipNameNr_drawPoint 78282
#define sipName_drawPoint &sipStrings_QtGui[78282]
#define sipNameNr_eraseRect 78292
#define sipName_eraseRect &sipStrings_QtGui[78292]
#define sipNameNr_drawImage 78302
#define sipName_drawImage &sipStrings_QtGui[78302]
#define sipNameNr_drawChord 78312
#define sipName_drawChord &sipStrings_QtGui[78312]
#define sipNameNr_drawRects 78322
#define sipName_drawRects &sipStrings_QtGui[78322]
#define sipNameNr_drawLines 78332
#define sipName_drawLines &sipStrings_QtGui[78332]
#define sipNameNr_setWindow 78342
#define sipName_setWindow &sipStrings_QtGui[78342]
#define sipNameNr_setCorner 78352
#define sipName_setCorner &sipStrings_QtGui[78352]
#define sipNameNr_statusBar 78362
#define sipName_statusBar &sipStrings_QtGui[78362]
#define sipNameNr_findItems 78372
#define sipName_findItems &sipStrings_QtGui[78372]
#define sipNameNr_sortItems 78382
#define sipName_sortItems &sipStrings_QtGui[78382]
#define sipNameNr_setHidden 78392
#define sipName_setHidden &sipStrings_QtGui[78392]
#define sipNameNr_textColor 78402
#define sipName_textColor &sipStrings_QtGui[78402]
#define sipNameNr_batchSize 78412
#define sipName_batchSize &sipStrings_QtGui[78412]
#define sipNameNr_QListView 78422
#define sipName_QListView &sipStrings_QtGui[78422]
#define sipNameNr_inputMask 78432
#define sipName_inputMask &sipStrings_QtGui[78432]
#define sipNameNr_backspace 78442
#define sipName_backspace &sipStrings_QtGui[78442]
#define sipNameNr_maxLength 78452
#define sipName_maxLength &sipStrings_QtGui[78452]
#define sipNameNr_QLineEdit 78462
#define sipName_QLineEdit &sipStrings_QtGui[78462]
#define sipNameNr_numDigits 78472
#define sipName_numDigits &sipStrings_QtGui[78472]
#define sipNameNr_setMargin 78482
#define sipName_setMargin &sipStrings_QtGui[78482]
#define sipNameNr_setIndent 78492
#define sipName_setIndent &sipStrings_QtGui[78492]
#define sipNameNr_Underline 27959
#define sipName_Underline &sipStrings_QtGui[27959]
#define sipNameNr_SelectAll 78502
#define sipName_SelectAll &sipStrings_QtGui[78502]
#define sipNameNr_NextChild 51121
#define sipName_NextChild &sipStrings_QtGui[51121]
#define sipNameNr_drawFocus 78512
#define sipName_drawFocus &sipStrings_QtGui[78512]
#define sipNameNr_drawCheck 78522
#define sipName_drawCheck &sipStrings_QtGui[78522]
#define sipNameNr_textValue 78532
#define sipName_textValue &sipStrings_QtGui[78532]
#define sipNameNr_inputMode 78542
#define sipName_inputMode &sipStrings_QtGui[78542]
#define sipNameNr_getDouble 78552
#define sipName_getDouble &sipStrings_QtGui[78552]
#define sipNameNr_TextInput 78562
#define sipName_TextInput &sipStrings_QtGui[78562]
#define sipNameNr_InputMode 17507
#define sipName_InputMode &sipStrings_QtGui[17507]
#define sipNameNr_languages 78572
#define sipName_languages &sipStrings_QtGui[78572]
#define sipNameNr_setFormat 78582
#define sipName_setFormat &sipStrings_QtGui[78582]
#define sipNameNr_Animation 20139
#define sipName_Animation &sipStrings_QtGui[20139]
#define sipNameNr_numColors 78592
#define sipName_numColors &sipStrings_QtGui[78592]
#define sipNameNr_InvertRgb 78602
#define sipName_InvertRgb &sipStrings_QtGui[78602]
#define sipNameNr_selection 78612
#define sipName_selection &sipStrings_QtGui[78612]
#define sipNameNr_isMovable 78622
#define sipName_isMovable &sipStrings_QtGui[78622]
#define sipNameNr_QGroupBox 78632
#define sipName_QGroupBox &sipStrings_QtGui[78632]
#define sipNameNr_fitInView 78642
#define sipName_fitInView &sipStrings_QtGui[78642]
#define sipNameNr_CacheNone 78652
#define sipName_CacheNone &sipStrings_QtGui[78652]
#define sipNameNr_screenPos 78662
#define sipName_screenPos &sipStrings_QtGui[78662]
#define sipNameNr_moveEvent 78672
#define sipName_moveEvent &sipStrings_QtGui[78672]
#define sipNameNr_AllLayers 78682
#define sipName_AllLayers &sipStrings_QtGui[78682]
#define sipNameNr_ItemLayer 78692
#define sipName_ItemLayer &sipStrings_QtGui[78692]
#define sipNameNr_drawItems 78702
#define sipName_drawItems &sipStrings_QtGui[78702]
#define sipNameNr_focusItem 78712
#define sipName_focusItem &sipStrings_QtGui[78712]
#define sipNameNr_addPixmap 78722
#define sipName_addPixmap &sipStrings_QtGui[78722]
#define sipNameNr_sceneRect 78732
#define sipName_sceneRect &sipStrings_QtGui[78732]
#define sipNameNr_shearList 78742
#define sipName_shearList &sipStrings_QtGui[78742]
#define sipNameNr_scaleList 78752
#define sipName_scaleList &sipStrings_QtGui[78752]
#define sipNameNr_textWidth 78762
#define sipName_textWidth &sipStrings_QtGui[78762]
#define sipNameNr_shapeMode 78772
#define sipName_shapeMode &sipStrings_QtGui[78772]
#define sipNameNr_setOffset 78782
#define sipName_setOffset &sipStrings_QtGui[78782]
#define sipNameNr_MaskShape 35037
#define sipName_MaskShape &sipStrings_QtGui[35037]
#define sipNameNr_ShapeMode 7874
#define sipName_ShapeMode &sipStrings_QtGui[7874]
#define sipNameNr_spanAngle 78792
#define sipName_spanAngle &sipStrings_QtGui[78792]
#define sipNameNr_isClipped 78802
#define sipName_isClipped &sipStrings_QtGui[78802]
#define sipNameNr_grabMouse 70807
#define sipName_grabMouse &sipStrings_QtGui[70807]
#define sipNameNr_cacheMode 78812
#define sipName_cacheMode &sipStrings_QtGui[78812]
#define sipNameNr_mapToItem 78822
#define sipName_mapToItem &sipStrings_QtGui[78822]
#define sipNameNr_setZValue 78832
#define sipName_setZValue &sipStrings_QtGui[78832]
#define sipNameNr_hasCursor 78842
#define sipName_hasCursor &sipStrings_QtGui[78842]
#define sipNameNr_setCursor 70903
#define sipName_setCursor &sipStrings_QtGui[70903]
#define sipNameNr_CacheMode 15571
#define sipName_CacheMode &sipStrings_QtGui[15571]
#define sipNameNr_drawFrame 78852
#define sipName_drawFrame &sipStrings_QtGui[78852]
#define sipNameNr_frameRect 78862
#define sipName_frameRect &sipStrings_QtGui[78862]
#define sipNameNr_StyleMask 39378
#define sipName_StyleMask &sipStrings_QtGui[39378]
#define sipNameNr_setLayout 78872
#define sipName_setLayout &sipStrings_QtGui[78872]
#define sipNameNr_FieldRole 78882
#define sipName_FieldRole &sipStrings_QtGui[78882]
#define sipNameNr_LabelRole 78892
#define sipName_LabelRole &sipStrings_QtGui[78892]
#define sipNameNr_lineWidth 78902
#define sipName_lineWidth &sipStrings_QtGui[78902]
#define sipNameNr_charWidth 78912
#define sipName_charWidth &sipStrings_QtGui[78912]
#define sipNameNr_widthChar 78922
#define sipName_widthChar &sipStrings_QtGui[78922]
#define sipNameNr_QFontInfo 78932
#define sipName_QFontInfo &sipStrings_QtGui[78932]
#define sipNameNr_SmallCaps 78942
#define sipName_SmallCaps &sipStrings_QtGui[78942]
#define sipNameNr_MixedCase 78952
#define sipName_MixedCase &sipStrings_QtGui[78952]
#define sipNameNr_setItalic 78962
#define sipName_setItalic &sipStrings_QtGui[78962]
#define sipNameNr_styleHint 78972
#define sipName_styleHint &sipStrings_QtGui[78972]
#define sipNameNr_strikeOut 78982
#define sipName_strikeOut &sipStrings_QtGui[78982]
#define sipNameNr_underline 78992
#define sipName_underline &sipStrings_QtGui[78992]
#define sipNameNr_setWeight 79002
#define sipName_setWeight &sipStrings_QtGui[79002]
#define sipNameNr_pixelSize 79012
#define sipName_pixelSize &sipStrings_QtGui[79012]
#define sipNameNr_pointSize 79022
#define sipName_pointSize &sipStrings_QtGui[79022]
#define sipNameNr_setFamily 79032
#define sipName_setFamily &sipStrings_QtGui[79032]
#define sipNameNr_Condensed 55291
#define sipName_Condensed &sipStrings_QtGui[55291]
#define sipNameNr_SansSerif 79042
#define sipName_SansSerif &sipStrings_QtGui[79042]
#define sipNameNr_Helvetica 79052
#define sipName_Helvetica &sipStrings_QtGui[79052]
#define sipNameNr_StyleHint 37434
#define sipName_StyleHint &sipStrings_QtGui[37434]
#define sipNameNr_labelText 79062
#define sipName_labelText &sipStrings_QtGui[79062]
#define sipNameNr_directory 79072
#define sipName_directory &sipStrings_QtGui[79072]
#define sipNameNr_Directory 26968
#define sipName_Directory &sipStrings_QtGui[26968]
#define sipNameNr_Attribute 10072
#define sipName_Attribute &sipStrings_QtGui[10072]
#define sipNameNr_lostFocus 79082
#define sipName_lostFocus &sipStrings_QtGui[79082]
#define sipNameNr_QKeyEvent 79092
#define sipName_QKeyEvent &sipStrings_QtGui[79092]
#define sipNameNr_globalPos 79102
#define sipName_globalPos &sipStrings_QtGui[79102]
#define sipNameNr_modifiers 79112
#define sipName_modifiers &sipStrings_QtGui[79112]
#define sipNameNr_qtHandler 79122
#define sipName_qtHandler &sipStrings_QtGui[79122]
#define sipNameNr_QDirModel 79132
#define sipName_QDirModel &sipStrings_QtGui[79132]
#define sipNameNr_ApplyRole 79142
#define sipName_ApplyRole &sipStrings_QtGui[79142]
#define sipNameNr_ResetRole 79152
#define sipName_ResetRole &sipStrings_QtGui[79152]
#define sipNameNr_KdeLayout 79162
#define sipName_KdeLayout &sipStrings_QtGui[79162]
#define sipNameNr_MacLayout 79172
#define sipName_MacLayout &sipStrings_QtGui[79172]
#define sipNameNr_WinLayout 79182
#define sipName_WinLayout &sipStrings_QtGui[79182]
#define sipNameNr_setResult 79192
#define sipName_setResult &sipStrings_QtGui[79192]
#define sipNameNr_extension 79202
#define sipName_extension &sipStrings_QtGui[79202]
#define sipNameNr_notchSize 79212
#define sipName_notchSize &sipStrings_QtGui[79212]
#define sipNameNr_QDateEdit 79222
#define sipName_QDateEdit &sipStrings_QtGui[79222]
#define sipNameNr_QTimeEdit 79232
#define sipName_QTimeEdit &sipStrings_QtGui[79232]
#define sipNameNr_sectionAt 79242
#define sipName_sectionAt &sipStrings_QtGui[79242]
#define sipNameNr_splitPath 79252
#define sipName_splitPath &sipStrings_QtGui[79252]
#define sipNameNr_setWidget 79262
#define sipName_setWidget &sipStrings_QtGui[79262]
#define sipNameNr_completer 79272
#define sipName_completer &sipStrings_QtGui[79272]
#define sipNameNr_hidePopup 79282
#define sipName_hidePopup &sipStrings_QtGui[79282]
#define sipNameNr_showPopup 79292
#define sipName_showPopup &sipStrings_QtGui[79292]
#define sipNameNr_validator 79302
#define sipName_validator &sipStrings_QtGui[79302]
#define sipNameNr_QComboBox 79312
#define sipName_QComboBox &sipStrings_QtGui[79312]
#define sipNameNr_setOption 79322
#define sipName_setOption &sipStrings_QtGui[79322]
#define sipNameNr_setPixmap 79332
#define sipName_setPixmap &sipStrings_QtGui[79332]
#define sipNameNr_QCheckBox 79342
#define sipName_QCheckBox &sipStrings_QtGui[79342]
#define sipNameNr_showToday 79352
#define sipName_showToday &sipStrings_QtGui[79352]
#define sipNameNr_paintCell 79362
#define sipName_paintCell &sipStrings_QtGui[79362]
#define sipNameNr_yearShown 79372
#define sipName_yearShown &sipStrings_QtGui[79372]
#define sipNameNr_checkedId 79382
#define sipName_checkedId &sipStrings_QtGui[79382]
#define sipNameNr_addButton 79392
#define sipName_addButton &sipStrings_QtGui[79392]
#define sipNameNr_exclusive 79402
#define sipName_exclusive &sipStrings_QtGui[79402]
#define sipNameNr_setRadius 79412
#define sipName_setRadius &sipStrings_QtGui[79412]
#define sipNameNr_setCenter 79422
#define sipName_setCenter &sipStrings_QtGui[79422]
#define sipNameNr_finalStop 79432
#define sipName_finalStop &sipStrings_QtGui[79432]
#define sipNameNr_setSpread 79442
#define sipName_setSpread &sipStrings_QtGui[79442]
#define sipNameNr_PadSpread 79452
#define sipName_PadSpread &sipStrings_QtGui[79452]
#define sipNameNr_QGradient 79462
#define sipName_QGradient &sipStrings_QtGui[79462]
#define sipNameNr_transform 79472
#define sipName_transform &sipStrings_QtGui[79472]
#define sipNameNr_setMatrix 70855
#define sipName_setMatrix &sipStrings_QtGui[70855]
#define sipNameNr_fromCmykF 79482
#define sipName_fromCmykF &sipStrings_QtGui[79482]
#define sipNameNr_convertTo 79492
#define sipName_convertTo &sipStrings_QtGui[79492]
#define sipNameNr_setGreenF 79502
#define sipName_setGreenF &sipStrings_QtGui[79502]
#define sipNameNr_setAlphaF 79512
#define sipName_setAlphaF &sipStrings_QtGui[79512]
#define sipNameNr_addLayout 79522
#define sipName_addLayout &sipStrings_QtGui[79522]
#define sipNameNr_addWidget 79532
#define sipName_addWidget &sipStrings_QtGui[79532]
#define sipNameNr_fromImage 79542
#define sipName_fromImage &sipStrings_QtGui[79542]
#define sipNameNr_saveState 79552
#define sipName_saveState &sipStrings_QtGui[79552]
#define sipNameNr_sessionId 79562
#define sipName_sessionId &sipStrings_QtGui[79562]
#define sipNameNr_clipboard 79572
#define sipName_clipboard &sipStrings_QtGui[79572]
#define sipNameNr_colorSpec 79582
#define sipName_colorSpec &sipStrings_QtGui[79582]
#define sipNameNr_ManyColor 79592
#define sipName_ManyColor &sipStrings_QtGui[79592]
#define sipNameNr_ColorSpec 18131
#define sipName_ColorSpec &sipStrings_QtGui[18131]
#define sipNameNr_GuiServer 79602
#define sipName_GuiServer &sipStrings_QtGui[79602]
#define sipNameNr_GuiClient 79612
#define sipName_GuiClient &sipStrings_QtGui[79612]
#define sipNameNr_addAction 79622
#define sipName_addAction &sipStrings_QtGui[79622]
#define sipNameNr_shortcuts 79632
#define sipName_shortcuts &sipStrings_QtGui[79632]
#define sipNameNr_AboutRole 79642
#define sipName_AboutRole &sipStrings_QtGui[79642]
#define sipNameNr_triggered 79652
#define sipName_triggered &sipStrings_QtGui[79652]
#define sipNameNr_isVisible 79662
#define sipName_isVisible &sipStrings_QtGui[79662]
#define sipNameNr_whatsThis 79672
#define sipName_whatsThis &sipStrings_QtGui[79672]
#define sipNameNr_statusTip 79682
#define sipName_statusTip &sipStrings_QtGui[79682]
#define sipNameNr_pageCount 79692
#define sipName_pageCount &sipStrings_QtGui[79692]
#define sipNameNr_showEvent 79702
#define sipName_showEvent &sipStrings_QtGui[79702]
#define sipNameNr_hideEvent 79712
#define sipName_hideEvent &sipStrings_QtGui[79712]
#define sipNameNr_alignment 79722
#define sipName_alignment &sipStrings_QtGui[79722]
#define sipNameNr_NoButtons 79732
#define sipName_NoButtons &sipStrings_QtGui[79732]
#define sipNameNr_PlusMinus 79742
#define sipName_PlusMinus &sipStrings_QtGui[79742]
#define sipNameNr_setFromTo 79752
#define sipName_setFromTo &sipStrings_QtGui[79752]
#define sipNameNr_setMinMax 79762
#define sipName_setMinMax &sipStrings_QtGui[79762]
#define sipNameNr_PageRange 56281
#define sipName_PageRange &sipStrings_QtGui[56281]
#define sipNameNr_Selection 361
#define sipName_Selection &sipStrings_QtGui[361]
#define sipNameNr_BelowItem 79772
#define sipName_BelowItem &sipStrings_QtGui[79772]
#define sipNameNr_AboveItem 79782
#define sipName_AboveItem &sipStrings_QtGui[79782]
#define sipNameNr_dropEvent 79792
#define sipName_dropEvent &sipStrings_QtGui[79792]
#define sipNameNr_startDrag 79802
#define sipName_startDrag &sipStrings_QtGui[79802]
#define sipNameNr_MoveRight 79812
#define sipName_MoveRight &sipStrings_QtGui[79812]
#define sipNameNr_selectAll 79822
#define sipName_selectAll &sipStrings_QtGui[79822]
#define sipNameNr_rootIndex 79832
#define sipName_rootIndex &sipStrings_QtGui[79832]
#define sipNameNr_helpEvent 79842
#define sipName_helpEvent &sipStrings_QtGui[79842]
#define sipNameNr_hitButton 79852
#define sipName_hitButton &sipStrings_QtGui[79852]
#define sipNameNr_isChecked 79862
#define sipName_isChecked &sipStrings_QtGui[79862]
#define sipNameNr_isDefault 79872
#define sipName_isDefault &sipStrings_QtGui[79872]
#define sipNameNr_setPaused 79882
#define sipName_setPaused &sipStrings_QtGui[79882]
#define sipNameNr_loopCount 79892
#define sipName_loopCount &sipStrings_QtGui[79892]
#define sipNameNr_takeFirst 79902
#define sipName_takeFirst &sipStrings_QtGui[79902]
#define sipNameNr_removeAll 79912
#define sipName_removeAll &sipStrings_QtGui[79912]
#define sipNameNr_activated 79922
#define sipName_activated &sipStrings_QtGui[79922]
#define sipNameNr_isEnabled 79932
#define sipName_isEnabled &sipStrings_QtGui[79932]
#define sipNameNr_transpose 79942
#define sipName_transpose &sipStrings_QtGui[79942]
#define sipNameNr_setLocale 67675
#define sipName_setLocale &sipStrings_QtGui[67675]
#define sipNameNr_setHeight 79952
#define sipName_setHeight &sipStrings_QtGui[79952]
#define sipNameNr_setBottom 79962
#define sipName_setBottom &sipStrings_QtGui[79962]
#define sipNameNr_receivers 79972
#define sipName_receivers &sipStrings_QtGui[79972]
#define sipNameNr_setParent 79982
#define sipName_setParent &sipStrings_QtGui[79982]
#define sipNameNr_Malayalam 79992
#define sipName_Malayalam &sipStrings_QtGui[79992]
#define sipNameNr_intersect 80002
#define sipName_intersect &sipStrings_QtGui[80002]
#define sipNameNr_setPoints 80012
#define sipName_setPoints &sipStrings_QtGui[80012]
#define sipNameNr_setFilter 80022
#define sipName_setFilter &sipStrings_QtGui[80022]
#define sipNameNr_setStatus 80032
#define sipName_setStatus &sipStrings_QtGui[80032]
#define sipNameNr_setDevice 80042
#define sipName_setDevice &sipStrings_QtGui[80042]
#define sipNameNr_WhatsThis 46756
#define sipName_WhatsThis &sipStrings_QtGui[46756]
#define sipNameNr_Clipboard 61529
#define sipName_Clipboard &sipStrings_QtGui[61529]
#define sipNameNr_translate 80052
#define sipName_translate &sipStrings_QtGui[80052]
#define sipNameNr_sendEvent 80062
#define sipName_sendEvent &sipStrings_QtGui[80062]
#define sipNameNr_direction 80072
#define sipName_direction &sipStrings_QtGui[80072]
#define sipNameNr_Direction 10524
#define sipName_Direction &sipStrings_QtGui[10524]
#define sipNameNr_removeRow 80082
#define sipName_removeRow &sipStrings_QtGui[80082]
#define sipNameNr_insertRow 80092
#define sipName_insertRow &sipStrings_QtGui[80092]
#define sipNameNr_fetchMore 80102
#define sipName_fetchMore &sipStrings_QtGui[80102]
#define sipNameNr_mimeTypes 80112
#define sipName_mimeTypes &sipStrings_QtGui[80112]
#define sipNameNr_NoSection 80122
#define sipName_NoSection &sipStrings_QtGui[80122]
#define sipNameNr_appCells 80132
#define sipName_appCells &sipStrings_QtGui[80132]
#define sipNameNr_appDepth 80141
#define sipName_appDepth &sipStrings_QtGui[80141]
#define sipNameNr_colormap 80150
#define sipName_colormap &sipStrings_QtGui[80150]
#define sipNameNr_appClass 80159
#define sipName_appClass &sipStrings_QtGui[80159]
#define sipNameNr_QX11Info 80168
#define sipName_QX11Info &sipStrings_QtGui[80168]
#define sipNameNr_embedded 80177
#define sipName_embedded &sipStrings_QtGui[80177]
#define sipNameNr_Internal 80186
#define sipName_Internal &sipStrings_QtGui[80186]
#define sipNameNr_subTitle 80195
#define sipName_subTitle &sipStrings_QtGui[80195]
#define sipNameNr_setField 80204
#define sipName_setField &sipStrings_QtGui[80204]
#define sipNameNr_MacStyle 80213
#define sipName_MacStyle &sipStrings_QtGui[80213]
#define sipNameNr_setShown 80222
#define sipName_setShown &sipStrings_QtGui[80222]
#define sipNameNr_baseSize 80231
#define sipName_baseSize &sipStrings_QtGui[80231]
#define sipNameNr_notation 80240
#define sipName_notation &sipStrings_QtGui[80240]
#define sipNameNr_Notation 11139
#define sipName_Notation &sipStrings_QtGui[11139]
#define sipNameNr_setStack 80249
#define sipName_setStack &sipStrings_QtGui[80249]
#define sipNameNr_setIndex 80258
#define sipName_setIndex &sipStrings_QtGui[80258]
#define sipNameNr_setClean 80267
#define sipName_setClean &sipStrings_QtGui[80267]
#define sipNameNr_endMacro 80276
#define sipName_endMacro &sipStrings_QtGui[80276]
#define sipNameNr_redoText 80285
#define sipName_redoText &sipStrings_QtGui[80285]
#define sipNameNr_undoText 80294
#define sipName_undoText &sipStrings_QtGui[80294]
#define sipNameNr_addStack 80303
#define sipName_addStack &sipStrings_QtGui[80303]
#define sipNameNr_UserFlag 80312
#define sipName_UserFlag &sipStrings_QtGui[80312]
#define sipNameNr_Editable 30180
#define sipName_Editable &sipStrings_QtGui[30180]
#define sipNameNr_addChild 80321
#define sipName_addChild &sipStrings_QtGui[80321]
#define sipNameNr_drawTree 80330
#define sipName_drawTree &sipStrings_QtGui[80330]
#define sipNameNr_reexpand 80339
#define sipName_reexpand &sipStrings_QtGui[80339]
#define sipNameNr_collapse 80348
#define sipName_collapse &sipStrings_QtGui[80348]
#define sipNameNr_expanded 80357
#define sipName_expanded &sipStrings_QtGui[80357]
#define sipNameNr_isAffine 80366
#define sipName_isAffine &sipStrings_QtGui[80366]
#define sipNameNr_toAffine 80375
#define sipName_toAffine &sipStrings_QtGui[80375]
#define sipNameNr_TxRotate 80384
#define sipName_TxRotate &sipStrings_QtGui[80384]
#define sipNameNr_hideText 80393
#define sipName_hideText &sipStrings_QtGui[80393]
#define sipNameNr_showText 80402
#define sipName_showText &sipStrings_QtGui[80402]
#define sipNameNr_QToolTip 80411
#define sipName_QToolTip &sipStrings_QtGui[80411]
#define sipNameNr_QToolBox 80420
#define sipName_QToolBox &sipStrings_QtGui[80420]
#define sipNameNr_QToolBar 80429
#define sipName_QToolBar &sipStrings_QtGui[80429]
#define sipNameNr_rowStart 80438
#define sipName_rowStart &sipStrings_QtGui[80438]
#define sipNameNr_RightTab 52202
#define sipName_RightTab &sipStrings_QtGui[52202]
#define sipNameNr_tabArray 80447
#define sipName_tabArray &sipStrings_QtGui[80447]
#define sipNameNr_wrapMode 80456
#define sipName_wrapMode &sipStrings_QtGui[80456]
#define sipNameNr_WordWrap 70256
#define sipName_WordWrap &sipStrings_QtGui[70256]
#define sipNameNr_WrapMode 9841
#define sipName_WrapMode &sipStrings_QtGui[9841]
#define sipNameNr_userData 80465
#define sipName_userData &sipStrings_QtGui[80465]
#define sipNameNr_previous 80474
#define sipName_previous &sipStrings_QtGui[80474]
#define sipNameNr_textList 80483
#define sipName_textList &sipStrings_QtGui[80483]
#define sipNameNr_iterator 24260
#define sipName_iterator &sipStrings_QtGui[24260]
#define sipNameNr_Trailing 80492
#define sipName_Trailing &sipStrings_QtGui[80492]
#define sipNameNr_ListDisc 80501
#define sipName_ListDisc &sipStrings_QtGui[80501]
#define sipNameNr_isAnchor 80510
#define sipName_isAnchor &sipStrings_QtGui[80510]
#define sipNameNr_IsAnchor 80519
#define sipName_IsAnchor &sipStrings_QtGui[80519]
#define sipNameNr_CssFloat 80528
#define sipName_CssFloat &sipStrings_QtGui[80528]
#define sipNameNr_Property 20952
#define sipName_Property &sipStrings_QtGui[20952]
#define sipNameNr_NoObject 80537
#define sipName_NoObject &sipStrings_QtGui[80537]
#define sipNameNr_rawValue 80546
#define sipName_rawValue &sipStrings_QtGui[80546]
#define sipNameNr_AutoNone 80555
#define sipName_AutoNone &sipStrings_QtGui[80555]
#define sipNameNr_fromHtml 80564
#define sipName_fromHtml &sipStrings_QtGui[80564]
#define sipNameNr_revision 80573
#define sipName_revision &sipStrings_QtGui[80573]
#define sipNameNr_resource 80582
#define sipName_resource &sipStrings_QtGui[80582]
#define sipNameNr_FindFlag 16356
#define sipName_FindFlag &sipStrings_QtGui[16356]
#define sipNameNr_FuzzyHit 80591
#define sipName_FuzzyHit &sipStrings_QtGui[80591]
#define sipNameNr_ExactHit 80600
#define sipName_ExactHit &sipStrings_QtGui[80600]
#define sipNameNr_Document 22778
#define sipName_Document &sipStrings_QtGui[22778]
#define sipNameNr_NextCell 80609
#define sipName_NextCell &sipStrings_QtGui[80609]
#define sipNameNr_NextWord 54182
#define sipName_NextWord &sipStrings_QtGui[54182]
#define sipNameNr_WordLeft 80618
#define sipName_WordLeft &sipStrings_QtGui[80618]
#define sipNameNr_MoveMode 21106
#define sipName_MoveMode &sipStrings_QtGui[21106]
#define sipNameNr_backward 80627
#define sipName_backward &sipStrings_QtGui[80627]
#define sipNameNr_TabShape 24575
#define sipName_TabShape &sipStrings_QtGui[24575]
#define sipNameNr_rowMoved 80636
#define sipName_rowMoved &sipStrings_QtGui[80636]
#define sipNameNr_showGrid 80645
#define sipName_showGrid &sipStrings_QtGui[80645]
#define sipNameNr_columnAt 80654
#define sipName_columnAt &sipStrings_QtGui[80654]
#define sipNameNr_tabMoved 80663
#define sipName_tabMoved &sipStrings_QtGui[80663]
#define sipNameNr_LeftSide 80672
#define sipName_LeftSide &sipStrings_QtGui[80672]
#define sipNameNr_drawBase 80681
#define sipName_drawBase &sipStrings_QtGui[80681]
#define sipNameNr_WrapText 80690
#define sipName_WrapText &sipStrings_QtGui[80690]
#define sipNameNr_editable 80699
#define sipName_editable &sipStrings_QtGui[80699]
#define sipNameNr_Position 1262
#define sipName_Position &sipStrings_QtGui[1262]
#define sipNameNr_closable 80708
#define sipName_closable &sipStrings_QtGui[80708]
#define sipNameNr_tabWidth 80717
#define sipName_tabWidth &sipStrings_QtGui[80717]
#define sipNameNr_menuRect 80726
#define sipName_menuRect &sipStrings_QtGui[80726]
#define sipNameNr_Scroller 47237
#define sipName_Scroller &sipStrings_QtGui[47237]
#define sipNameNr_progress 80735
#define sipName_progress &sipStrings_QtGui[80735]
#define sipNameNr_SortDown 80744
#define sipName_SortDown &sipStrings_QtGui[80744]
#define sipNameNr_SO_Frame 80753
#define sipName_SO_Frame &sipStrings_QtGui[80753]
#define sipNameNr_PE_Frame 80762
#define sipName_PE_Frame &sipStrings_QtGui[80762]
#define sipNameNr_State_On 80771
#define sipName_State_On &sipStrings_QtGui[80771]
#define sipNameNr_unpolish 80780
#define sipName_unpolish &sipStrings_QtGui[80780]
#define sipNameNr_reformat 80789
#define sipName_reformat &sipStrings_QtGui[80789]
#define sipNameNr_setChild 80798
#define sipName_setChild &sipStrings_QtGui[80798]
#define sipNameNr_StackAll 80807
#define sipName_StackAll &sipStrings_QtGui[80807]
#define sipNameNr_StackOne 80816
#define sipName_StackOne &sipStrings_QtGui[80816]
#define sipNameNr_splitter 80825
#define sipName_splitter &sipStrings_QtGui[80825]
#define sipNameNr_getRange 80834
#define sipName_getRange &sipStrings_QtGui[80834]
#define sipNameNr_setSizes 80843
#define sipName_setSizes &sipStrings_QtGui[80843]
#define sipNameNr_decimals 80852
#define sipName_decimals &sipStrings_QtGui[80852]
#define sipNameNr_QSpinBox 80861
#define sipName_QSpinBox &sipStrings_QtGui[80861]
#define sipNameNr_setLoops 80870
#define sipName_setLoops &sipStrings_QtGui[80870]
#define sipNameNr_sortRole 80879
#define sipName_sortRole &sipStrings_QtGui[80879]
#define sipNameNr_lessThan 80888
#define sipName_lessThan &sipStrings_QtGui[80888]
#define sipNameNr_LineEdit 42401
#define sipName_LineEdit &sipStrings_QtGui[42401]
#define sipNameNr_GroupBox 24701
#define sipName_GroupBox &sipStrings_QtGui[24701]
#define sipNameNr_ComboBox 24764
#define sipName_ComboBox &sipStrings_QtGui[24764]
#define sipNameNr_CheckBox 25688
#define sipName_CheckBox &sipStrings_QtGui[25688]
#define sipNameNr_GrowFlag 80897
#define sipName_GrowFlag &sipStrings_QtGui[80897]
#define sipNameNr_isPhase2 80906
#define sipName_isPhase2 &sipStrings_QtGui[80906]
#define sipNameNr_numRects 80915
#define sipName_numRects &sipStrings_QtGui[80915]
#define sipNameNr_subtract 80924
#define sipName_subtract &sipStrings_QtGui[80924]
#define sipNameNr_showMenu 80933
#define sipName_showMenu &sipStrings_QtGui[80933]
#define sipNameNr_canceled 80942
#define sipName_canceled &sipStrings_QtGui[80942]
#define sipNameNr_setLabel 80951
#define sipName_setLabel &sipStrings_QtGui[80951]
#define sipNameNr_numPages 80960
#define sipName_numPages &sipStrings_QtGui[80960]
#define sipNameNr_zoomMode 80969
#define sipName_zoomMode &sipStrings_QtGui[80969]
#define sipNameNr_ZoomMode 8542
#define sipName_ZoomMode &sipStrings_QtGui[8542]
#define sipNameNr_pageRect 80978
#define sipName_pageRect &sipStrings_QtGui[80978]
#define sipNameNr_fullPage 80987
#define sipName_fullPage &sipStrings_QtGui[80987]
#define sipNameNr_pageSize 80996
#define sipName_pageSize &sipStrings_QtGui[80996]
#define sipNameNr_Cassette 81005
#define sipName_Cassette &sipStrings_QtGui[81005]
#define sipNameNr_Envelope 81014
#define sipName_Envelope &sipStrings_QtGui[81014]
#define sipNameNr_PageSize 29660
#define sipName_PageSize &sipStrings_QtGui[29660]
#define sipNameNr_Portrait 81023
#define sipName_Portrait &sipStrings_QtGui[81023]
#define sipNameNr_QPrinter 81032
#define sipName_QPrinter &sipStrings_QtGui[81032]
#define sipNameNr_isClosed 81041
#define sipName_isClosed &sipStrings_QtGui[81041]
#define sipNameNr_setPoint 81050
#define sipName_setPoint &sipStrings_QtGui[81050]
#define sipNameNr_canPaste 81059
#define sipName_canPaste &sipStrings_QtGui[81059]
#define sipNameNr_hasAlpha 81068
#define sipName_hasAlpha &sipStrings_QtGui[81068]
#define sipNameNr_ioDevice 81077
#define sipName_ioDevice &sipStrings_QtGui[81077]
#define sipNameNr_QPicture 81086
#define sipName_QPicture &sipStrings_QtGui[81086]
#define sipNameNr_midlight 81095
#define sipName_midlight &sipStrings_QtGui[81095]
#define sipNameNr_Midlight 81104
#define sipName_Midlight &sipStrings_QtGui[81104]
#define sipNameNr_Inactive 81113
#define sipName_Inactive &sipStrings_QtGui[81113]
#define sipNameNr_capStyle 81122
#define sipName_capStyle &sipStrings_QtGui[81122]
#define sipNameNr_isLineTo 81131
#define sipName_isLineTo &sipStrings_QtGui[81131]
#define sipNameNr_isMoveTo 81140
#define sipName_isMoveTo &sipStrings_QtGui[81140]
#define sipNameNr_Direct3D 81149
#define sipName_Direct3D &sipStrings_QtGui[81149]
#define sipNameNr_AllDirty 81158
#define sipName_AllDirty &sipStrings_QtGui[81158]
#define sipNameNr_DirtyPen 81167
#define sipName_DirtyPen &sipStrings_QtGui[81167]
#define sipNameNr_Overline 46437
#define sipName_Overline &sipStrings_QtGui[46437]
#define sipNameNr_heightMM 81176
#define sipName_heightMM &sipStrings_QtGui[81176]
#define sipNameNr_PdmDepth 81185
#define sipName_PdmDepth &sipStrings_QtGui[81185]
#define sipNameNr_PdmWidth 81194
#define sipName_PdmWidth &sipStrings_QtGui[81194]
#define sipNameNr_drawRect 81203
#define sipName_drawRect &sipStrings_QtGui[81203]
#define sipNameNr_drawLine 81212
#define sipName_drawLine &sipStrings_QtGui[81212]
#define sipNameNr_fillRect 81221
#define sipName_fillRect &sipStrings_QtGui[81221]
#define sipNameNr_drawText 81230
#define sipName_drawText &sipStrings_QtGui[81230]
#define sipNameNr_drawPath 81239
#define sipName_drawPath &sipStrings_QtGui[81239]
#define sipNameNr_fillPath 81248
#define sipName_fillPath &sipStrings_QtGui[81248]
#define sipNameNr_fontInfo 81257
#define sipName_fontInfo &sipStrings_QtGui[81257]
#define sipNameNr_initFrom 81266
#define sipName_initFrom &sipStrings_QtGui[81266]
#define sipNameNr_QPainter 81275
#define sipName_QPainter &sipStrings_QtGui[81275]
#define sipNameNr_setSpeed 81284
#define sipName_setSpeed &sipStrings_QtGui[81284]
#define sipNameNr_CacheAll 81293
#define sipName_CacheAll &sipStrings_QtGui[81293]
#define sipNameNr_critical 81302
#define sipName_critical &sipStrings_QtGui[81302]
#define sipNameNr_question 81311
#define sipName_question &sipStrings_QtGui[81311]
#define sipNameNr_FlagMask 81320
#define sipName_FlagMask &sipStrings_QtGui[81320]
#define sipNameNr_Question 21370
#define sipName_Question &sipStrings_QtGui[21370]
#define sipNameNr_Critical 21392
#define sipName_Critical &sipStrings_QtGui[21392]
#define sipNameNr_QMenuBar 81329
#define sipName_QMenuBar &sipStrings_QtGui[81329]
#define sipNameNr_actionAt 81338
#define sipName_actionAt &sipStrings_QtGui[81338]
#define sipNameNr_isShaded 81347
#define sipName_isShaded &sipStrings_QtGui[81347]
#define sipNameNr_QMdiArea 81356
#define sipName_QMdiArea &sipStrings_QtGui[81356]
#define sipNameNr_inverted 81365
#define sipName_inverted &sipStrings_QtGui[81365]
#define sipNameNr_tabShape 81374
#define sipName_tabShape &sipStrings_QtGui[81374]
#define sipNameNr_editItem 81383
#define sipName_editItem &sipStrings_QtGui[81383]
#define sipNameNr_takeItem 81392
#define sipName_takeItem &sipStrings_QtGui[81392]
#define sipNameNr_ItemType 4601
#define sipName_ItemType &sipStrings_QtGui[4601]
#define sipNameNr_gridSize 81401
#define sipName_gridSize &sipStrings_QtGui[81401]
#define sipNameNr_movement 81410
#define sipName_movement &sipStrings_QtGui[81410]
#define sipNameNr_IconMode 81419
#define sipName_IconMode &sipStrings_QtGui[81419]
#define sipNameNr_ListMode 81428
#define sipName_ListMode &sipStrings_QtGui[81428]
#define sipNameNr_Movement 30020
#define sipName_Movement &sipStrings_QtGui[30020]
#define sipNameNr_deselect 81437
#define sipName_deselect &sipStrings_QtGui[81437]
#define sipNameNr_echoMode 81446
#define sipName_echoMode &sipStrings_QtGui[81446]
#define sipNameNr_Password 81455
#define sipName_Password &sipStrings_QtGui[81455]
#define sipNameNr_EchoMode 30040
#define sipName_EchoMode &sipStrings_QtGui[30040]
#define sipNameNr_overflow 81464
#define sipName_overflow &sipStrings_QtGui[81464]
#define sipNameNr_setMovie 81473
#define sipName_setMovie &sipStrings_QtGui[81473]
#define sipNameNr_setBuddy 81482
#define sipName_setBuddy &sipStrings_QtGui[81482]
#define sipNameNr_wordWrap 81491
#define sipName_wordWrap &sipStrings_QtGui[81491]
#define sipNameNr_mnemonic 81500
#define sipName_mnemonic &sipStrings_QtGui[81500]
#define sipNameNr_FindNext 81509
#define sipName_FindNext &sipStrings_QtGui[81509]
#define sipNameNr_intValue 81518
#define sipName_intValue &sipStrings_QtGui[81518]
#define sipNameNr_IntInput 81527
#define sipName_IntInput &sipStrings_QtGui[81527]
#define sipNameNr_canWrite 81536
#define sipName_canWrite &sipStrings_QtGui[81536]
#define sipNameNr_setGamma 81545
#define sipName_setGamma &sipStrings_QtGui[81545]
#define sipNameNr_clipRect 81554
#define sipName_clipRect &sipStrings_QtGui[81554]
#define sipNameNr_ClipRect 38857
#define sipName_ClipRect &sipStrings_QtGui[38857]
#define sipNameNr_textKeys 81563
#define sipName_textKeys &sipStrings_QtGui[81563]
#define sipNameNr_mirrored 81572
#define sipName_mirrored &sipStrings_QtGui[81572]
#define sipNameNr_setPixel 81581
#define sipName_setPixel &sipStrings_QtGui[81581]
#define sipNameNr_scanLine 81590
#define sipName_scanLine &sipStrings_QtGui[81590]
#define sipNameNr_numBytes 81599
#define sipName_numBytes &sipStrings_QtGui[81599]
#define sipNameNr_Deselect 81608
#define sipName_Deselect &sipStrings_QtGui[81608]
#define sipNameNr_NoUpdate 81617
#define sipName_NoUpdate &sipStrings_QtGui[81617]
#define sipNameNr_cacheKey 81626
#define sipName_cacheKey &sipStrings_QtGui[81626]
#define sipNameNr_Selected 4776
#define sipName_Selected &sipStrings_QtGui[4776]
#define sipNameNr_Disabled 7627
#define sipName_Disabled &sipStrings_QtGui[7627]
#define sipNameNr_setTitle 81635
#define sipName_setTitle &sipStrings_QtGui[81635]
#define sipNameNr_cellRect 81644
#define sipName_cellRect &sipStrings_QtGui[81644]
#define sipNameNr_centerOn 81653
#define sipName_centerOn &sipStrings_QtGui[81653]
#define sipNameNr_setScene 81662
#define sipName_setScene &sipStrings_QtGui[81662]
#define sipNameNr_dragMode 81671
#define sipName_dragMode &sipStrings_QtGui[81671]
#define sipNameNr_NoAnchor 81680
#define sipName_NoAnchor &sipStrings_QtGui[81680]
#define sipNameNr_DragMode 17676
#define sipName_DragMode &sipStrings_QtGui[17676]
#define sipNameNr_isLayout 81689
#define sipName_isLayout &sipStrings_QtGui[81689]
#define sipNameNr_geometry 81698
#define sipName_geometry &sipStrings_QtGui[81698]
#define sipNameNr_matrixAt 81707
#define sipName_matrixAt &sipStrings_QtGui[81707]
#define sipNameNr_setPosAt 81716
#define sipName_setPosAt &sipStrings_QtGui[81716]
#define sipNameNr_timeLine 81725
#define sipName_timeLine &sipStrings_QtGui[81725]
#define sipNameNr_fillRule 81734
#define sipName_fillRule &sipStrings_QtGui[81734]
#define sipNameNr_setBrush 81743
#define sipName_setBrush &sipStrings_QtGui[81743]
#define sipNameNr_clipPath 81752
#define sipName_clipPath &sipStrings_QtGui[81752]
#define sipNameNr_isWindow 81761
#define sipName_isWindow &sipStrings_QtGui[81761]
#define sipNameNr_isWidget 81770
#define sipName_isWidget &sipStrings_QtGui[81770]
#define sipNameNr_scenePos 81779
#define sipName_scenePos &sipStrings_QtGui[81779]
#define sipNameNr_setFocus 81788
#define sipName_setFocus &sipStrings_QtGui[81788]
#define sipNameNr_hasFocus 81797
#define sipName_hasFocus &sipStrings_QtGui[81797]
#define sipNameNr_setFlags 81806
#define sipName_setFlags &sipStrings_QtGui[81806]
#define sipNameNr_setGroup 81815
#define sipName_setGroup &sipStrings_QtGui[81815]
#define sipNameNr_WinPanel 61138
#define sipName_WinPanel &sipStrings_QtGui[61138]
#define sipNameNr_ItemRole 23350
#define sipName_ItemRole &sipStrings_QtGui[23350]
#define sipNameNr_maxWidth 81824
#define sipName_maxWidth &sipStrings_QtGui[81824]
#define sipNameNr_families 81833
#define sipName_families &sipStrings_QtGui[81833]
#define sipNameNr_Gurmukhi 81842
#define sipName_Gurmukhi &sipStrings_QtGui[81842]
#define sipNameNr_Cyrillic 81851
#define sipName_Cyrillic &sipStrings_QtGui[81851]
#define sipNameNr_AllFonts 81860
#define sipName_AllFonts &sipStrings_QtGui[81860]
#define sipNameNr_isCopyOf 81869
#define sipName_isCopyOf &sipStrings_QtGui[81869]
#define sipNameNr_overline 81878
#define sipName_overline &sipStrings_QtGui[81878]
#define sipNameNr_Expanded 46069
#define sipName_Expanded &sipStrings_QtGui[46069]
#define sipNameNr_DemiBold 81887
#define sipName_DemiBold &sipStrings_QtGui[81887]
#define sipNameNr_AnyStyle 81896
#define sipName_AnyStyle &sipStrings_QtGui[81896]
#define sipNameNr_Trashcan 81905
#define sipName_Trashcan &sipStrings_QtGui[81905]
#define sipNameNr_Computer 75877
#define sipName_Computer &sipStrings_QtGui[75877]
#define sipNameNr_IconType 10973
#define sipName_IconType &sipStrings_QtGui[10973]
#define sipNameNr_fileMode 81914
#define sipName_fileMode &sipStrings_QtGui[81914]
#define sipNameNr_viewMode 81923
#define sipName_viewMode &sipStrings_QtGui[81923]
#define sipNameNr_FileMode 23482
#define sipName_FileMode &sipStrings_QtGui[23482]
#define sipNameNr_ViewMode 8572
#define sipName_ViewMode &sipStrings_QtGui[8572]
#define sipNameNr_oldState 81932
#define sipName_oldState &sipStrings_QtGui[81932]
#define sipNameNr_provides 81941
#define sipName_provides &sipStrings_QtGui[81941]
#define sipNameNr_Keyboard 46005
#define sipName_Keyboard &sipStrings_QtGui[46005]
#define sipNameNr_gotFocus 81950
#define sipName_gotFocus &sipStrings_QtGui[81950]
#define sipNameNr_rotation 81959
#define sipName_rotation &sipStrings_QtGui[81959]
#define sipNameNr_pressure 81968
#define sipName_pressure &sipStrings_QtGui[81968]
#define sipNameNr_uniqueId 81977
#define sipName_uniqueId &sipStrings_QtGui[81977]
#define sipNameNr_Airbrush 81986
#define sipName_Airbrush &sipStrings_QtGui[81986]
#define sipNameNr_NoDevice 81995
#define sipName_NoDevice &sipStrings_QtGui[81995]
#define sipNameNr_features 82004
#define sipName_features &sipStrings_QtGui[82004]
#define sipNameNr_fileIcon 82013
#define sipName_fileIcon &sipStrings_QtGui[82013]
#define sipNameNr_YesToAll 82022
#define sipName_YesToAll &sipStrings_QtGui[82022]
#define sipNameNr_HelpRole 82031
#define sipName_HelpRole &sipStrings_QtGui[82031]
#define sipNameNr_rejected 82040
#define sipName_rejected &sipStrings_QtGui[82040]
#define sipNameNr_accepted 82049
#define sipName_accepted &sipStrings_QtGui[82049]
#define sipNameNr_setModal 82058
#define sipName_setModal &sipStrings_QtGui[82058]
#define sipNameNr_Accepted 82067
#define sipName_Accepted &sipStrings_QtGui[82067]
#define sipNameNr_Rejected 82076
#define sipName_Rejected &sipStrings_QtGui[82076]
#define sipNameNr_dateTime 82085
#define sipName_dateTime &sipStrings_QtGui[82085]
#define sipNameNr_Sections 18012
#define sipName_Sections &sipStrings_QtGui[18012]
#define sipNameNr_setShape 82094
#define sipName_setShape &sipStrings_QtGui[82094]
#define sipNameNr_complete 82103
#define sipName_complete &sipStrings_QtGui[82103]
#define sipNameNr_setPopup 82112
#define sipName_setPopup &sipStrings_QtGui[82112]
#define sipNameNr_addItems 82121
#define sipName_addItems &sipStrings_QtGui[82121]
#define sipNameNr_itemIcon 82130
#define sipName_itemIcon &sipStrings_QtGui[82130]
#define sipNameNr_itemText 82139
#define sipName_itemText &sipStrings_QtGui[82139]
#define sipNameNr_NoInsert 82148
#define sipName_NoInsert &sipStrings_QtGui[82148]
#define sipNameNr_findData 82157
#define sipName_findData &sipStrings_QtGui[82157]
#define sipNameNr_findText 82166
#define sipName_findText &sipStrings_QtGui[82166]
#define sipNameNr_maxCount 82175
#define sipName_maxCount &sipStrings_QtGui[82175]
#define sipNameNr_getColor 82184
#define sipName_getColor &sipStrings_QtGui[82184]
#define sipNameNr_setImage 82193
#define sipName_setImage &sipStrings_QtGui[82193]
#define sipNameNr_setStart 82202
#define sipName_setStart &sipStrings_QtGui[82202]
#define sipNameNr_setStops 82211
#define sipName_setStops &sipStrings_QtGui[82211]
#define sipNameNr_isOpaque 82220
#define sipName_isOpaque &sipStrings_QtGui[82220]
#define sipNameNr_gradient 82229
#define sipName_gradient &sipStrings_QtGui[82229]
#define sipNameNr_setColor 82238
#define sipName_setColor &sipStrings_QtGui[82238]
#define sipNameNr_fromCmyk 82247
#define sipName_fromCmyk &sipStrings_QtGui[82247]
#define sipNameNr_fromHsvF 82256
#define sipName_fromHsvF &sipStrings_QtGui[82256]
#define sipNameNr_fromRgbF 82265
#define sipName_fromRgbF &sipStrings_QtGui[82265]
#define sipNameNr_fromRgba 82274
#define sipName_fromRgba &sipStrings_QtGui[82274]
#define sipNameNr_setCmykF 82283
#define sipName_setCmykF &sipStrings_QtGui[82283]
#define sipNameNr_getCmykF 82292
#define sipName_getCmykF &sipStrings_QtGui[82292]
#define sipNameNr_magentaF 82301
#define sipName_magentaF &sipStrings_QtGui[82301]
#define sipNameNr_setBlueF 82310
#define sipName_setBlueF &sipStrings_QtGui[82310]
#define sipNameNr_setGreen 82319
#define sipName_setGreen &sipStrings_QtGui[82319]
#define sipNameNr_setAlpha 82328
#define sipName_setAlpha &sipStrings_QtGui[82328]
#define sipNameNr_addStrut 82337
#define sipName_addStrut &sipStrings_QtGui[82337]
#define sipNameNr_fromData 82346
#define sipName_fromData &sipStrings_QtGui[82346]
#define sipNameNr_widgetAt 82355
#define sipName_widgetAt &sipStrings_QtGui[82355]
#define sipNameNr_setStyle 82364
#define sipName_setStyle &sipStrings_QtGui[82364]
#define sipNameNr_selected 73094
#define sipName_selected &sipStrings_QtGui[73094]
#define sipNameNr_menuRole 82373
#define sipName_menuRole &sipStrings_QtGui[82373]
#define sipNameNr_QuitRole 82382
#define sipName_QuitRole &sipStrings_QtGui[82382]
#define sipNameNr_MenuRole 40405
#define sipName_MenuRole &sipStrings_QtGui[40405]
#define sipNameNr_activate 82391
#define sipName_activate &sipStrings_QtGui[82391]
#define sipNameNr_iconText 82400
#define sipName_iconText &sipStrings_QtGui[82400]
#define sipNameNr_pageStep 82409
#define sipName_pageStep &sipStrings_QtGui[82409]
#define sipNameNr_setRange 82418
#define sipName_setRange &sipStrings_QtGui[82418]
#define sipNameNr_document 82427
#define sipName_document &sipStrings_QtGui[82427]
#define sipNameNr_anchorAt 82436
#define sipName_anchorAt &sipStrings_QtGui[82436]
#define sipNameNr_lineEdit 82445
#define sipName_lineEdit &sipStrings_QtGui[82445]
#define sipNameNr_stepDown 82454
#define sipName_stepDown &sipStrings_QtGui[82454]
#define sipNameNr_validate 76405
#define sipName_validate &sipStrings_QtGui[76405]
#define sipNameNr_hasFrame 82463
#define sipName_hasFrame &sipStrings_QtGui[82463]
#define sipNameNr_setFrame 82472
#define sipName_setFrame &sipStrings_QtGui[82472]
#define sipNameNr_wrapping 82481
#define sipName_wrapping &sipStrings_QtGui[82481]
#define sipNameNr_StepNone 82490
#define sipName_StepNone &sipStrings_QtGui[82490]
#define sipNameNr_viewport 82499
#define sipName_viewport &sipStrings_QtGui[82499]
#define sipNameNr_fromPage 82508
#define sipName_fromPage &sipStrings_QtGui[82508]
#define sipNameNr_AllPages 82517
#define sipName_AllPages &sipStrings_QtGui[82517]
#define sipNameNr_setState 82526
#define sipName_setState &sipStrings_QtGui[82526]
#define sipNameNr_MoveNext 82535
#define sipName_MoveNext &sipStrings_QtGui[82535]
#define sipNameNr_MoveHome 82544
#define sipName_MoveHome &sipStrings_QtGui[82544]
#define sipNameNr_MoveLeft 82553
#define sipName_MoveLeft &sipStrings_QtGui[82553]
#define sipNameNr_MoveDown 82562
#define sipName_MoveDown &sipStrings_QtGui[82562]
#define sipNameNr_scrollTo 82571
#define sipName_scrollTo &sipStrings_QtGui[82571]
#define sipNameNr_setModel 82580
#define sipName_setModel &sipStrings_QtGui[82580]
#define sipNameNr_DragDrop 76702
#define sipName_DragDrop &sipStrings_QtGui[76702]
#define sipNameNr_DropOnly 82589
#define sipName_DropOnly &sipStrings_QtGui[82589]
#define sipNameNr_DragOnly 82598
#define sipName_DragOnly &sipStrings_QtGui[82598]
#define sipNameNr_sizeHint 82607
#define sipName_sizeHint &sipStrings_QtGui[82607]
#define sipNameNr_released 82616
#define sipName_released &sipStrings_QtGui[82616]
#define sipNameNr_shortcut 82625
#define sipName_shortcut &sipStrings_QtGui[82625]
#define sipNameNr_iconSize 82634
#define sipName_iconSize &sipStrings_QtGui[82634]
#define sipNameNr_UserType 82643
#define sipName_UserType &sipStrings_QtGui[82643]
#define sipNameNr_fragment 82652
#define sipName_fragment &sipStrings_QtGui[82652]
#define sipNameNr_setCodec 82661
#define sipName_setCodec &sipStrings_QtGui[82661]
#define sipNameNr_takeLast 82670
#define sipName_takeLast &sipStrings_QtGui[82670]
#define sipNameNr_removeAt 82679
#define sipName_removeAt &sipStrings_QtGui[82679]
#define sipNameNr_position 82688
#define sipName_position &sipStrings_QtGui[82688]
#define sipNameNr_setValue 82697
#define sipName_setValue &sipStrings_QtGui[82697]
#define sipNameNr_setWidth 82706
#define sipName_setWidth &sipStrings_QtGui[82706]
#define sipNameNr_finished 82715
#define sipName_finished &sipStrings_QtGui[82715]
#define sipNameNr___idiv__ 82724
#define sipName___idiv__ &sipStrings_QtGui[82724]
#define sipNameNr___isub__ 82733
#define sipName___isub__ &sipStrings_QtGui[82733]
#define sipNameNr_property 82742
#define sipName_property &sipStrings_QtGui[82742]
#define sipNameNr_children 82751
#define sipName_children &sipStrings_QtGui[82751]
#define sipNameNr_QPolygon 82760
#define sipName_QPolygon &sipStrings_QtGui[82760]
#define sipNameNr_QPalette 82769
#define sipName_QPalette &sipStrings_QtGui[82769]
#define sipNameNr_language 82778
#define sipName_language &sipStrings_QtGui[82778]
#define sipNameNr_Japanese 82787
#define sipName_Japanese &sipStrings_QtGui[82787]
#define sipNameNr_Gujarati 82796
#define sipName_Gujarati &sipStrings_QtGui[82796]
#define sipNameNr_Georgian 82805
#define sipName_Georgian &sipStrings_QtGui[82805]
#define sipNameNr_Armenian 82814
#define sipName_Armenian &sipStrings_QtGui[82814]
#define sipNameNr_Language 82823
#define sipName_Language &sipStrings_QtGui[82823]
#define sipNameNr_setAngle 82832
#define sipName_setAngle &sipStrings_QtGui[82832]
#define sipNameNr_ReadOnly 52922
#define sipName_ReadOnly &sipStrings_QtGui[52922]
#define sipNameNr_isHidden 82841
#define sipName_isHidden &sipStrings_QtGui[82841]
#define sipNameNr_fileInfo 82850
#define sipName_fileInfo &sipStrings_QtGui[82850]
#define sipNameNr_rootPath 82859
#define sipName_rootPath &sipStrings_QtGui[82859]
#define sipNameNr_filePath 82868
#define sipName_filePath &sipStrings_QtGui[82868]
#define sipNameNr_timeSpec 82877
#define sipName_timeSpec &sipStrings_QtGui[82877]
#define sipNameNr_toString 82886
#define sipName_toString &sipStrings_QtGui[82886]
#define sipNameNr_contains 82895
#define sipName_contains &sipStrings_QtGui[82895]
#define sipNameNr___imul__ 82904
#define sipName___imul__ &sipStrings_QtGui[82904]
#define sipNameNr___iadd__ 82913
#define sipName___iadd__ &sipStrings_QtGui[82913]
#define sipNameNr_isActive 82922
#define sipName_isActive &sipStrings_QtGui[82922]
#define sipNameNr_mimeData 82931
#define sipName_mimeData &sipStrings_QtGui[82931]
#define sipNameNr_itemData 82940
#define sipName_itemData &sipStrings_QtGui[82940]
#define sipNameNr_rowCount 82949
#define sipName_rowCount &sipStrings_QtGui[82949]
#define sipNameNr___hash__ 82958
#define sipName___hash__ &sipStrings_QtGui[82958]
#define sipNameNr_fileName 82967
#define sipName_fileName &sipStrings_QtGui[82967]
#define sipNameNr_FileName 33632
#define sipName_FileName &sipStrings_QtGui[33632]
#define sipNameNr_FileType 82976
#define sipName_FileType &sipStrings_QtGui[82976]
#define sipNameNr_AlignTop 82985
#define sipName_AlignTop &sipStrings_QtGui[82985]
#define sipNameNr_NoButton 37363
#define sipName_NoButton &sipStrings_QtGui[37363]
#define sipNameNr___bool__ 82994
#define sipName___bool__ &sipStrings_QtGui[82994]
#define sipNameNr___ixor__ 83003
#define sipName___ixor__ &sipStrings_QtGui[83003]
#define sipNameNr___iand__ 83012
#define sipName___iand__ &sipStrings_QtGui[83012]
#define sipNameNr_appTime 83021
#define sipName_appTime &sipStrings_QtGui[83021]
#define sipNameNr_appDpiY 83029
#define sipName_appDpiY &sipStrings_QtGui[83029]
#define sipNameNr_appDpiX 83037
#define sipName_appDpiX &sipStrings_QtGui[83037]
#define sipNameNr_Display 70281
#define sipName_Display &sipStrings_QtGui[70281]
#define sipNameNr_cascade 83045
#define sipName_cascade &sipStrings_QtGui[83045]
#define sipNameNr_pageIds 83053
#define sipName_pageIds &sipStrings_QtGui[83053]
#define sipNameNr_startId 83061
#define sipName_startId &sipStrings_QtGui[83061]
#define sipNameNr_setPage 83069
#define sipName_setPage &sipStrings_QtGui[83069]
#define sipNameNr_addPage 83077
#define sipName_addPage &sipStrings_QtGui[83077]
#define sipNameNr_QWizard 83085
#define sipName_QWizard &sipStrings_QtGui[83085]
#define sipNameNr_isModal 83093
#define sipName_isModal &sipStrings_QtGui[83093]
#define sipNameNr_destroy 83101
#define sipName_destroy &sipStrings_QtGui[83101]
#define sipNameNr_childAt 83109
#define sipName_childAt &sipStrings_QtGui[83109]
#define sipNameNr_mapFrom 83117
#define sipName_mapFrom &sipStrings_QtGui[83117]
#define sipNameNr_command 83125
#define sipName_command &sipStrings_QtGui[83125]
#define sipNameNr_isClean 83133
#define sipName_isClean &sipStrings_QtGui[83133]
#define sipNameNr_canRedo 83141
#define sipName_canRedo &sipStrings_QtGui[83141]
#define sipNameNr_canUndo 83149
#define sipName_canUndo &sipStrings_QtGui[83149]
#define sipNameNr_Enabled 9143
#define sipName_Enabled &sipStrings_QtGui[9143]
#define sipNameNr_drawRow 83157
#define sipName_drawRow &sipStrings_QtGui[83157]
#define sipNameNr_adjoint 83165
#define sipName_adjoint &sipStrings_QtGui[83165]
#define sipNameNr_TxShear 83173
#define sipName_TxShear &sipStrings_QtGui[83173]
#define sipNameNr_TxScale 83181
#define sipName_TxScale &sipStrings_QtGui[83181]
#define sipNameNr_setTabs 83189
#define sipName_setTabs &sipStrings_QtGui[83189]
#define sipNameNr_LeftTab 57821
#define sipName_LeftTab &sipStrings_QtGui[57821]
#define sipNameNr_TabType 24240
#define sipName_TabType &sipStrings_QtGui[24240]
#define sipNameNr_tabStop 83197
#define sipName_tabStop &sipStrings_QtGui[83197]
#define sipNameNr_Leading 83205
#define sipName_Leading &sipStrings_QtGui[83205]
#define sipNameNr_columns 83213
#define sipName_columns &sipStrings_QtGui[83213]
#define sipNameNr_padding 83221
#define sipName_padding &sipStrings_QtGui[83221]
#define sipNameNr_setName 83229
#define sipName_setName &sipStrings_QtGui[83229]
#define sipNameNr_AutoAll 83237
#define sipName_AutoAll &sipStrings_QtGui[83237]
#define sipNameNr_atStart 83245
#define sipName_atStart &sipStrings_QtGui[83245]
#define sipNameNr_NextRow 83253
#define sipName_NextRow &sipStrings_QtGui[83253]
#define sipNameNr_forward 83261
#define sipName_forward &sipStrings_QtGui[83261]
#define sipNameNr_Rounded 83269
#define sipName_Rounded &sipStrings_QtGui[83269]
#define sipNameNr_rowSpan 83277
#define sipName_rowSpan &sipStrings_QtGui[83277]
#define sipNameNr_setSpan 83285
#define sipName_setSpan &sipStrings_QtGui[83285]
#define sipNameNr_showRow 83293
#define sipName_showRow &sipStrings_QtGui[83293]
#define sipNameNr_hideRow 83301
#define sipName_hideRow &sipStrings_QtGui[83301]
#define sipNameNr_moveTab 77684
#define sipName_moveTab &sipStrings_QtGui[77684]
#define sipNameNr_tabRect 83309
#define sipName_tabRect &sipStrings_QtGui[83309]
#define sipNameNr_tabData 83317
#define sipName_tabData &sipStrings_QtGui[83317]
#define sipNameNr_tabIcon 83325
#define sipName_tabIcon &sipStrings_QtGui[83325]
#define sipNameNr_tabText 83333
#define sipName_tabText &sipStrings_QtGui[83333]
#define sipNameNr_QTabBar 83341
#define sipName_QTabBar &sipStrings_QtGui[83341]
#define sipNameNr_Context 1222
#define sipName_Context &sipStrings_QtGui[1222]
#define sipNameNr_Unknown 83349
#define sipName_Unknown &sipStrings_QtGui[83349]
#define sipNameNr_Movable 32664
#define sipName_Movable &sipStrings_QtGui[32664]
#define sipNameNr_SH_Mask 83357
#define sipName_SH_Mask &sipStrings_QtGui[83357]
#define sipNameNr_movable 83365
#define sipName_movable &sipStrings_QtGui[83365]
#define sipNameNr_checked 83373
#define sipName_checked &sipStrings_QtGui[83373]
#define sipNameNr_TearOff 83381
#define sipName_TearOff &sipStrings_QtGui[83381]
#define sipNameNr_SubMenu 83389
#define sipName_SubMenu &sipStrings_QtGui[83389]
#define sipNameNr_HasMenu 83397
#define sipName_HasMenu &sipStrings_QtGui[83397]
#define sipNameNr_CT_Menu 83405
#define sipName_CT_Menu &sipStrings_QtGui[83405]
#define sipNameNr_SC_None 83413
#define sipName_SC_None &sipStrings_QtGui[83413]
#define sipNameNr_CC_Dial 83421
#define sipName_CC_Dial &sipStrings_QtGui[83421]
#define sipNameNr_takeRow 83429
#define sipName_takeRow &sipStrings_QtGui[83429]
#define sipNameNr_repaint 83437
#define sipName_repaint &sipStrings_QtGui[83437]
#define sipNameNr_NoTicks 83445
#define sipName_NoTicks &sipStrings_QtGui[83445]
#define sipNameNr_QSlider 83453
#define sipName_QSlider &sipStrings_QtGui[83453]
#define sipNameNr_SpinBox 28341
#define sipName_SpinBox &sipStrings_QtGui[28341]
#define sipNameNr_Ignored 83461
#define sipName_Ignored &sipStrings_QtGui[83461]
#define sipNameNr_Maximum 43388
#define sipName_Maximum &sipStrings_QtGui[43388]
#define sipNameNr_Minimum 43405
#define sipName_Minimum &sipStrings_QtGui[43405]
#define sipNameNr_context 83469
#define sipName_context &sipStrings_QtGui[83469]
#define sipNameNr_qIsGray 83477
#define sipName_qIsGray &sipStrings_QtGui[83477]
#define sipNameNr_Ellipse 69849
#define sipName_Ellipse &sipStrings_QtGui[69849]
#define sipNameNr_zoomOut 83485
#define sipName_zoomOut &sipStrings_QtGui[83485]
#define sipNameNr_newPage 83493
#define sipName_newPage &sipStrings_QtGui[83493]
#define sipNameNr_creator 83501
#define sipName_creator &sipStrings_QtGui[83501]
#define sipNameNr_docName 83509
#define sipName_docName &sipStrings_QtGui[83509]
#define sipNameNr_Aborted 83517
#define sipName_Aborted &sipStrings_QtGui[83517]
#define sipNameNr_Tractor 83525
#define sipName_Tractor &sipStrings_QtGui[83525]
#define sipNameNr_OnlyOne 83533
#define sipName_OnlyOne &sipStrings_QtGui[83533]
#define sipNameNr_Tabloid 83541
#define sipName_Tabloid &sipStrings_QtGui[83541]
#define sipNameNr_Comm10E 83549
#define sipName_Comm10E &sipStrings_QtGui[83549]
#define sipNameNr_x11Info 83557
#define sipName_x11Info &sipStrings_QtGui[83557]
#define sipNameNr_toImage 83565
#define sipName_toImage &sipStrings_QtGui[83565]
#define sipNameNr_setMask 83573
#define sipName_setMask &sipStrings_QtGui[83573]
#define sipNameNr_isSolid 83581
#define sipName_isSolid &sipStrings_QtGui[83581]
#define sipNameNr_isEqual 83589
#define sipName_isEqual &sipStrings_QtGui[83589]
#define sipNameNr_cubicTo 83597
#define sipName_cubicTo &sipStrings_QtGui[83597]
#define sipNameNr_Element 15173
#define sipName_Element &sipStrings_QtGui[15173]
#define sipNameNr_painter 83605
#define sipName_painter &sipStrings_QtGui[83605]
#define sipNameNr_Picture 69825
#define sipName_Picture &sipStrings_QtGui[69825]
#define sipNameNr_Windows 34051
#define sipName_Windows &sipStrings_QtGui[34051]
#define sipNameNr_widthMM 83613
#define sipName_widthMM &sipStrings_QtGui[83613]
#define sipNameNr_PdmDpiY 83621
#define sipName_PdmDpiY &sipStrings_QtGui[83621]
#define sipNameNr_PdmDpiX 83629
#define sipName_PdmDpiX &sipStrings_QtGui[83629]
#define sipNameNr_drawPie 83637
#define sipName_drawPie &sipStrings_QtGui[83637]
#define sipNameNr_drawArc 83645
#define sipName_drawArc &sipStrings_QtGui[83645]
#define sipNameNr_restore 83653
#define sipName_restore &sipStrings_QtGui[83653]
#define sipNameNr_updated 83661
#define sipName_updated &sipStrings_QtGui[83661]
#define sipNameNr_warning 83669
#define sipName_warning &sipStrings_QtGui[83669]
#define sipNameNr_Default 53283
#define sipName_Default &sipStrings_QtGui[53283]
#define sipNameNr_Warning 24975
#define sipName_Warning &sipStrings_QtGui[24975]
#define sipNameNr_addMenu 83677
#define sipName_addMenu &sipStrings_QtGui[83677]
#define sipNameNr_mdiArea 83685
#define sipName_mdiArea &sipStrings_QtGui[83685]
#define sipNameNr_mapRect 53013
#define sipName_mapRect &sipStrings_QtGui[53013]
#define sipNameNr_setFlow 83693
#define sipName_setFlow &sipStrings_QtGui[83693]
#define sipNameNr_Batched 83701
#define sipName_Batched &sipStrings_QtGui[83701]
#define sipNameNr_display 83709
#define sipName_display &sipStrings_QtGui[83709]
#define sipNameNr_setMode 83717
#define sipName_setMode &sipStrings_QtGui[83717]
#define sipNameNr_Outline 51723
#define sipName_Outline &sipStrings_QtGui[51723]
#define sipNameNr_menuBar 83725
#define sipName_menuBar &sipStrings_QtGui[83725]
#define sipNameNr_picture 83733
#define sipName_picture &sipStrings_QtGui[83733]
#define sipNameNr_Replace 83741
#define sipName_Replace &sipStrings_QtGui[83741]
#define sipNameNr_ZoomOut 83749
#define sipName_ZoomOut &sipStrings_QtGui[83749]
#define sipNameNr_NoMatch 83757
#define sipName_NoMatch &sipStrings_QtGui[83757]
#define sipNameNr_intStep 83765
#define sipName_intStep &sipStrings_QtGui[83765]
#define sipNameNr_getItem 41824
#define sipName_getItem &sipStrings_QtGui[41824]
#define sipNameNr_getText 83773
#define sipName_getText &sipStrings_QtGui[83773]
#define sipNameNr_quality 83781
#define sipName_quality &sipStrings_QtGui[83781]
#define sipNameNr_canRead 83789
#define sipName_canRead &sipStrings_QtGui[83789]
#define sipNameNr_SubType 83797
#define sipName_SubType &sipStrings_QtGui[83797]
#define sipNameNr_Quality 60929
#define sipName_Quality &sipStrings_QtGui[60929]
#define sipNameNr_allGray 83805
#define sipName_allGray &sipStrings_QtGui[83805]
#define sipNameNr_devType 83813
#define sipName_devType &sipStrings_QtGui[83813]
#define sipNameNr_Columns 36103
#define sipName_Columns &sipStrings_QtGui[36103]
#define sipNameNr_Current 31061
#define sipName_Current &sipStrings_QtGui[31061]
#define sipNameNr_indexes 83821
#define sipName_indexes &sipStrings_QtGui[83821]
#define sipNameNr_addFile 83829
#define sipName_addFile &sipStrings_QtGui[83829]
#define sipNameNr_setFlat 83837
#define sipName_setFlat &sipStrings_QtGui[83837]
#define sipNameNr_newSize 83845
#define sipName_newSize &sipStrings_QtGui[83845]
#define sipNameNr_lastPos 83853
#define sipName_lastPos &sipStrings_QtGui[83853]
#define sipNameNr_addText 83861
#define sipName_addText &sipStrings_QtGui[83861]
#define sipNameNr_addRect 83869
#define sipName_addRect &sipStrings_QtGui[83869]
#define sipNameNr_addLine 83877
#define sipName_addLine &sipStrings_QtGui[83877]
#define sipNameNr_NoIndex 83885
#define sipName_NoIndex &sipStrings_QtGui[83885]
#define sipNameNr_posList 83893
#define sipName_posList &sipStrings_QtGui[83893]
#define sipNameNr_setStep 83901
#define sipName_setStep &sipStrings_QtGui[83901]
#define sipNameNr_polygon 83909
#define sipName_polygon &sipStrings_QtGui[83909]
#define sipNameNr_opacity 83917
#define sipName_opacity &sipStrings_QtGui[83917]
#define sipNameNr_advance 83925
#define sipName_advance &sipStrings_QtGui[83925]
#define sipNameNr_setFlag 83933
#define sipName_setFlag &sipStrings_QtGui[83933]
#define sipNameNr_NoCache 83941
#define sipName_NoCache &sipStrings_QtGui[83941]
#define sipNameNr_NoFrame 83949
#define sipName_NoFrame &sipStrings_QtGui[83949]
#define sipNameNr_setItem 83957
#define sipName_setItem &sipStrings_QtGui[83957]
#define sipNameNr_xHeight 83965
#define sipName_xHeight &sipStrings_QtGui[83965]
#define sipNameNr_leading 83973
#define sipName_leading &sipStrings_QtGui[83973]
#define sipNameNr_descent 83981
#define sipName_descent &sipStrings_QtGui[83981]
#define sipNameNr_getFont 83989
#define sipName_getFont &sipStrings_QtGui[83989]
#define sipNameNr_Sinhala 83997
#define sipName_Sinhala &sipStrings_QtGui[83997]
#define sipNameNr_setBold 84005
#define sipName_setBold &sipStrings_QtGui[84005]
#define sipNameNr_cleanup 84013
#define sipName_cleanup &sipStrings_QtGui[84013]
#define sipNameNr_rawName 84021
#define sipName_rawName &sipStrings_QtGui[84021]
#define sipNameNr_rawMode 8633
#define sipName_rawMode &sipStrings_QtGui[8633]
#define sipNameNr_kerning 84029
#define sipName_kerning &sipStrings_QtGui[84029]
#define sipNameNr_Stretch 25794
#define sipName_Stretch &sipStrings_QtGui[25794]
#define sipNameNr_Courier 84037
#define sipName_Courier &sipStrings_QtGui[84037]
#define sipNameNr_Network 84045
#define sipName_Network &sipStrings_QtGui[84045]
#define sipNameNr_history 84053
#define sipName_history &sipStrings_QtGui[84053]
#define sipNameNr_Options 1755
#define sipName_Options &sipStrings_QtGui[1755]
#define sipNameNr_AnyFile 84061
#define sipName_AnyFile &sipStrings_QtGui[84061]
#define sipNameNr_oldSize 84069
#define sipName_oldSize &sipStrings_QtGui[84069]
#define sipNameNr_matches 84077
#define sipName_matches &sipStrings_QtGui[84077]
#define sipNameNr_globalY 84085
#define sipName_globalY &sipStrings_QtGui[84085]
#define sipNameNr_globalX 84093
#define sipName_globalX &sipStrings_QtGui[84093]
#define sipNameNr_Discard 84101
#define sipName_Discard &sipStrings_QtGui[84101]
#define sipNameNr_NoToAll 84109
#define sipName_NoToAll &sipStrings_QtGui[84109]
#define sipNameNr_SaveAll 84117
#define sipName_SaveAll &sipStrings_QtGui[84117]
#define sipNameNr_YesRole 84125
#define sipName_YesRole &sipStrings_QtGui[84125]
#define sipNameNr_resized 84133
#define sipName_resized &sipStrings_QtGui[84133]
#define sipNameNr_openUrl 84141
#define sipName_openUrl &sipStrings_QtGui[84141]
#define sipNameNr_Section 20118
#define sipName_Section &sipStrings_QtGui[20118]
#define sipNameNr_toFirst 84149
#define sipName_toFirst &sipStrings_QtGui[84149]
#define sipNameNr_hotSpot 84157
#define sipName_hotSpot &sipStrings_QtGui[84157]
#define sipNameNr_setView 84165
#define sipName_setView &sipStrings_QtGui[84165]
#define sipNameNr_options 84173
#define sipName_options &sipStrings_QtGui[84173]
#define sipNameNr_getRgba 84181
#define sipName_getRgba &sipStrings_QtGui[84181]
#define sipNameNr_buttons 84189
#define sipName_buttons &sipStrings_QtGui[84189]
#define sipNameNr_texture 84197
#define sipName_texture &sipStrings_QtGui[84197]
#define sipNameNr_lighter 32493
#define sipName_lighter &sipStrings_QtGui[32493]
#define sipNameNr_fromHsv 84205
#define sipName_fromHsv &sipStrings_QtGui[84205]
#define sipNameNr_fromRgb 84213
#define sipName_fromRgb &sipStrings_QtGui[84213]
#define sipNameNr_setCmyk 84221
#define sipName_setCmyk &sipStrings_QtGui[84221]
#define sipNameNr_getCmyk 84229
#define sipName_getCmyk &sipStrings_QtGui[84229]
#define sipNameNr_yellowF 84237
#define sipName_yellowF &sipStrings_QtGui[84237]
#define sipNameNr_setHsvF 84245
#define sipName_setHsvF &sipStrings_QtGui[84245]
#define sipNameNr_getHsvF 84253
#define sipName_getHsvF &sipStrings_QtGui[84253]
#define sipNameNr_setRgba 84261
#define sipName_setRgba &sipStrings_QtGui[84261]
#define sipNameNr_setRgbF 84269
#define sipName_setRgbF &sipStrings_QtGui[84269]
#define sipNameNr_getRgbF 84277
#define sipName_getRgbF &sipStrings_QtGui[84277]
#define sipNameNr_setRedF 84285
#define sipName_setRedF &sipStrings_QtGui[84285]
#define sipNameNr_setBlue 84293
#define sipName_setBlue &sipStrings_QtGui[84293]
#define sipNameNr_stretch 84301
#define sipName_stretch &sipStrings_QtGui[84301]
#define sipNameNr_spacing 84309
#define sipName_spacing &sipStrings_QtGui[84309]
#define sipNameNr_addItem 84317
#define sipName_addItem &sipStrings_QtGui[84317]
#define sipNameNr_QLayout 84325
#define sipName_QLayout &sipStrings_QtGui[84325]
#define sipNameNr_aboutQt 84333
#define sipName_aboutQt &sipStrings_QtGui[84333]
#define sipNameNr_desktop 84341
#define sipName_desktop &sipStrings_QtGui[84341]
#define sipNameNr_actions 84349
#define sipName_actions &sipStrings_QtGui[84349]
#define sipNameNr_hovered 84357
#define sipName_hovered &sipStrings_QtGui[84357]
#define sipNameNr_changed 84365
#define sipName_changed &sipStrings_QtGui[84365]
#define sipNameNr_trigger 84373
#define sipName_trigger &sipStrings_QtGui[84373]
#define sipNameNr_Trigger 8093
#define sipName_Trigger &sipStrings_QtGui[8093]
#define sipNameNr_setFont 84381
#define sipName_setFont &sipStrings_QtGui[84381]
#define sipNameNr_setMenu 84389
#define sipName_setMenu &sipStrings_QtGui[84389]
#define sipNameNr_toolTip 84397
#define sipName_toolTip &sipStrings_QtGui[84397]
#define sipNameNr_QAction 84405
#define sipName_QAction &sipStrings_QtGui[84405]
#define sipNameNr_maximum 84413
#define sipName_maximum &sipStrings_QtGui[84413]
#define sipNameNr_minimum 84421
#define sipName_minimum &sipStrings_QtGui[84421]
#define sipNameNr_hitTest 84429
#define sipName_hitTest &sipStrings_QtGui[84429]
#define sipNameNr_palette 84437
#define sipName_palette &sipStrings_QtGui[84437]
#define sipNameNr_printer 84445
#define sipName_printer &sipStrings_QtGui[84445]
#define sipNameNr_maxPage 84453
#define sipName_maxPage &sipStrings_QtGui[84453]
#define sipNameNr_minPage 84461
#define sipName_minPage &sipStrings_QtGui[84461]
#define sipNameNr_QDialog 84469
#define sipName_QDialog &sipStrings_QtGui[84469]
#define sipNameNr_NoState 84477
#define sipName_NoState &sipStrings_QtGui[84477]
#define sipNameNr_MoveEnd 84485
#define sipName_MoveEnd &sipStrings_QtGui[84485]
#define sipNameNr_entered 84493
#define sipName_entered &sipStrings_QtGui[84493]
#define sipNameNr_indexAt 84501
#define sipName_indexAt &sipStrings_QtGui[84501]
#define sipNameNr_toggled 84509
#define sipName_toggled &sipStrings_QtGui[84509]
#define sipNameNr_clicked 84517
#define sipName_clicked &sipStrings_QtGui[84517]
#define sipNameNr_pressed 84525
#define sipName_pressed &sipStrings_QtGui[84525]
#define sipNameNr_setDown 84533
#define sipName_setDown &sipStrings_QtGui[84533]
#define sipNameNr_setIcon 84541
#define sipName_setIcon &sipStrings_QtGui[84541]
#define sipNameNr_Invalid 54468
#define sipName_Invalid &sipStrings_QtGui[54468]
#define sipNameNr_variant 84549
#define sipName_variant &sipStrings_QtGui[84549]
#define sipNameNr_Forward 28501
#define sipName_Forward &sipStrings_QtGui[28501]
#define sipNameNr_section 84557
#define sipName_section &sipStrings_QtGui[84557]
#define sipNameNr_release 84565
#define sipName_release &sipStrings_QtGui[84565]
#define sipNameNr_setRect 84573
#define sipName_setRect &sipStrings_QtGui[84573]
#define sipNameNr_topLeft 84581
#define sipName_topLeft &sipStrings_QtGui[84581]
#define sipNameNr_started 84589
#define sipName_started &sipStrings_QtGui[84589]
#define sipNameNr_Running 10246
#define sipName_Running &sipStrings_QtGui[10246]
#define sipNameNr___div__ 84597
#define sipName___div__ &sipStrings_QtGui[84597]
#define sipNameNr___sub__ 84605
#define sipName___sub__ &sipStrings_QtGui[84605]
#define sipNameNr_QWidget 84613
#define sipName_QWidget &sipStrings_QtGui[84613]
#define sipNameNr_setHtml 84621
#define sipName_setHtml &sipStrings_QtGui[84621]
#define sipNameNr_setText 84629
#define sipName_setText &sipStrings_QtGui[84629]
#define sipNameNr_QMatrix 84637
#define sipName_QMatrix &sipStrings_QtGui[84637]
#define sipNameNr_QCursor 84645
#define sipName_QCursor &sipStrings_QtGui[84645]
#define sipNameNr_QBitmap 78154
#define sipName_QBitmap &sipStrings_QtGui[78154]
#define sipNameNr_QRegion 84653
#define sipName_QRegion &sipStrings_QtGui[84653]
#define sipNameNr_QPixmap 84661
#define sipName_QPixmap &sipStrings_QtGui[84661]
#define sipNameNr_Myanmar 84669
#define sipName_Myanmar &sipStrings_QtGui[84669]
#define sipNameNr_Tibetan 84677
#define sipName_Tibetan &sipStrings_QtGui[84677]
#define sipNameNr_Kannada 84685
#define sipName_Kannada &sipStrings_QtGui[84685]
#define sipNameNr_Bengali 84693
#define sipName_Bengali &sipStrings_QtGui[84693]
#define sipNameNr_setLine 84701
#define sipName_setLine &sipStrings_QtGui[84701]
#define sipNameNr_resolve 84709
#define sipName_resolve &sipStrings_QtGui[84709]
#define sipNameNr_addPath 84717
#define sipName_addPath &sipStrings_QtGui[84717]
#define sipNameNr_refresh 84725
#define sipName_refresh &sipStrings_QtGui[84725]
#define sipNameNr_sorting 84733
#define sipName_sorting &sipStrings_QtGui[84733]
#define sipNameNr_setPath 84741
#define sipName_setPath &sipStrings_QtGui[84741]
#define sipNameNr_setTime 84749
#define sipName_setTime &sipStrings_QtGui[84749]
#define sipNameNr_restart 84757
#define sipName_restart &sipStrings_QtGui[84757]
#define sipNameNr_setDate 84765
#define sipName_setDate &sipStrings_QtGui[84765]
#define sipNameNr_version 84773
#define sipName_version &sipStrings_QtGui[84773]
#define sipNameNr_Version 137
#define sipName_Version &sipStrings_QtGui[137]
#define sipNameNr_MaxUser 84781
#define sipName_MaxUser &sipStrings_QtGui[84781]
#define sipNameNr___add__ 84789
#define sipName___add__ &sipStrings_QtGui[84789]
#define sipNameNr___mul__ 84797
#define sipName___mul__ &sipStrings_QtGui[84797]
#define sipNameNr___len__ 84805
#define sipName___len__ &sipStrings_QtGui[84805]
#define sipNameNr_replace 84813
#define sipName_replace &sipStrings_QtGui[84813]
#define sipNameNr_prepend 84821
#define sipName_prepend &sipStrings_QtGui[84821]
#define sipNameNr_indexOf 84829
#define sipName_indexOf &sipStrings_QtGui[84829]
#define sipNameNr_isEmpty 84837
#define sipName_isEmpty &sipStrings_QtGui[84837]
#define sipNameNr_setData 84845
#define sipName_setData &sipStrings_QtGui[84845]
#define sipNameNr_isValid 84853
#define sipName_isValid &sipStrings_QtGui[84853]
#define sipNameNr_filters 84861
#define sipName_filters &sipStrings_QtGui[84861]
#define sipNameNr_Refresh 84869
#define sipName_Refresh &sipStrings_QtGui[84869]
#define sipNameNr_Checked 73073
#define sipName_Checked &sipStrings_QtGui[73073]
#define sipNameNr_DotLine 56673
#define sipName_DotLine &sipStrings_QtGui[56673]
#define sipNameNr_Desktop 44578
#define sipName_Desktop &sipStrings_QtGui[44578]
#define sipNameNr_magenta 84877
#define sipName_magenta &sipStrings_QtGui[84877]
#define sipNameNr___and__ 84885
#define sipName___and__ &sipStrings_QtGui[84885]
#define sipNameNr___xor__ 84893
#define sipName___xor__ &sipStrings_QtGui[84893]
#define sipNameNr___int__ 84901
#define sipName___int__ &sipStrings_QtGui[84901]
#define sipNameNr___ior__ 84909
#define sipName___ior__ &sipStrings_QtGui[84909]
#define sipNameNr_QString 84917
#define sipName_QString &sipStrings_QtGui[84917]
#define sipNameNr_visual 84925
#define sipName_visual &sipStrings_QtGui[84925]
#define sipNameNr_wizard 84932
#define sipName_wizard &sipStrings_QtGui[84932]
#define sipNameNr_nextId 84939
#define sipName_nextId &sipStrings_QtGui[84939]
#define sipNameNr_raise_ 84946
#define sipName_raise_ &sipStrings_QtGui[84946]
#define sipNameNr_regExp 84953
#define sipName_regExp &sipStrings_QtGui[84953]
#define sipNameNr_stacks 84960
#define sipName_stacks &sipStrings_QtGui[84960]
#define sipNameNr_expand 80341
#define sipName_expand &sipStrings_QtGui[80341]
#define sipNameNr_header 84967
#define sipName_header &sipStrings_QtGui[84967]
#define sipNameNr_TxNone 84974
#define sipName_TxNone &sipStrings_QtGui[84974]
#define sipNameNr_rowEnd 84981
#define sipName_rowEnd &sipStrings_QtGui[84981]
#define sipNameNr_cellAt 84988
#define sipName_cellAt &sipStrings_QtGui[84988]
#define sipNameNr_lineAt 84995
#define sipName_lineAt &sipStrings_QtGui[84995]
#define sipNameNr_border 85002
#define sipName_border &sipStrings_QtGui[85002]
#define sipNameNr_InFlow 85009
#define sipName_InFlow &sipStrings_QtGui[85009]
#define sipNameNr_object 85016
#define sipName_object &sipStrings_QtGui[85016]
#define sipNameNr_NoMove 85023
#define sipName_NoMove &sipStrings_QtGui[85023]
#define sipNameNr_anchor 85030
#define sipName_anchor &sipStrings_QtGui[85030]
#define sipNameNr_reload 85037
#define sipName_reload &sipStrings_QtGui[85037]
#define sipNameNr_tabBar 85044
#define sipName_tabBar &sipStrings_QtGui[85044]
#define sipNameNr_topRow 85051
#define sipName_topRow &sipStrings_QtGui[85051]
#define sipNameNr_addTab 85058
#define sipName_addTab &sipStrings_QtGui[85058]
#define sipNameNr_unused 85065
#define sipName_unused &sipStrings_QtGui[85065]
#define sipNameNr_opaque 85072
#define sipName_opaque &sipStrings_QtGui[85072]
#define sipNameNr_Bottom 45599
#define sipName_Bottom &sipStrings_QtGui[45599]
#define sipNameNr_Margin 5431
#define sipName_Margin &sipStrings_QtGui[5431]
#define sipNameNr_SortUp 85079
#define sipName_SortUp &sipStrings_QtGui[85079]
#define sipNameNr_SO_Tab 85086
#define sipName_SO_Tab &sipStrings_QtGui[85086]
#define sipNameNr_SC_All 85093
#define sipName_SC_All &sipStrings_QtGui[85093]
#define sipNameNr_polish 80782
#define sipName_polish &sipStrings_QtGui[80782]
#define sipNameNr_QStyle 85100
#define sipName_QStyle &sipStrings_QtGui[85100]
#define sipNameNr_finish 85107
#define sipName_finish &sipStrings_QtGui[85107]
#define sipNameNr_QSound 85114
#define sipName_QSound &sipStrings_QtGui[85114]
#define sipNameNr_Slider 5866
#define sipName_Slider &sipStrings_QtGui[5866]
#define sipNameNr_Policy 2905
#define sipName_Policy &sipStrings_QtGui[2905]
#define sipNameNr_qAlpha 85121
#define sipName_qAlpha &sipStrings_QtGui[85121]
#define sipNameNr_qGreen 85128
#define sipName_qGreen &sipStrings_QtGui[85128]
#define sipNameNr_cancel 85135
#define sipName_cancel &sipStrings_QtGui[85135]
#define sipNameNr_setBar 85142
#define sipName_setBar &sipStrings_QtGui[85142]
#define sipNameNr_zoomIn 85149
#define sipName_zoomIn &sipStrings_QtGui[85149]
#define sipNameNr_duplex 85156
#define sipName_duplex &sipStrings_QtGui[85156]
#define sipNameNr_Cicero 85163
#define sipName_Cicero &sipStrings_QtGui[85163]
#define sipNameNr_Manual 53509
#define sipName_Manual &sipStrings_QtGui[53509]
#define sipNameNr_Middle 68278
#define sipName_Middle &sipStrings_QtGui[68278]
#define sipNameNr_Ledger 85170
#define sipName_Ledger &sipStrings_QtGui[85170]
#define sipNameNr_Letter 85177
#define sipName_Letter &sipStrings_QtGui[85177]
#define sipNameNr_print_ 85184
#define sipName_print_ &sipStrings_QtGui[85184]
#define sipNameNr_NoWrap 41689
#define sipName_NoWrap &sipStrings_QtGui[41689]
#define sipNameNr_widthF 85191
#define sipName_widthF &sipStrings_QtGui[85191]
#define sipNameNr_shadow 85198
#define sipName_shadow &sipStrings_QtGui[85198]
#define sipNameNr_Button 3883
#define sipName_Button &sipStrings_QtGui[3883]
#define sipNameNr_quadTo 85205
#define sipName_quadTo &sipStrings_QtGui[85205]
#define sipNameNr_lineTo 85212
#define sipName_lineTo &sipStrings_QtGui[85212]
#define sipNameNr_OpenVG 85219
#define sipName_OpenVG &sipStrings_QtGui[85219]
#define sipNameNr_Raster 85226
#define sipName_Raster &sipStrings_QtGui[85226]
#define sipNameNr_OpenGL 85233
#define sipName_OpenGL &sipStrings_QtGui[85233]
#define sipNameNr_QMovie 85240
#define sipName_QMovie &sipStrings_QtGui[85240]
#define sipNameNr_Escape 85247
#define sipName_Escape &sipStrings_QtGui[85247]
#define sipNameNr_YesAll 85254
#define sipName_YesAll &sipStrings_QtGui[85254]
#define sipNameNr_NoIcon 85261
#define sipName_NoIcon &sipStrings_QtGui[85261]
#define sipNameNr_corner 85268
#define sipName_corner &sipStrings_QtGui[85268]
#define sipNameNr_Adjust 85275
#define sipName_Adjust &sipStrings_QtGui[85275]
#define sipNameNr_Static 85282
#define sipName_Static &sipStrings_QtGui[85282]
#define sipNameNr_NoEcho 85289
#define sipName_NoEcho &sipStrings_QtGui[85289]
#define sipNameNr_Filled 85296
#define sipName_Filled &sipStrings_QtGui[85296]
#define sipNameNr_margin 85303
#define sipName_margin &sipStrings_QtGui[85303]
#define sipNameNr_indent 85310
#define sipName_indent &sipStrings_QtGui[85310]
#define sipNameNr_QLabel 85317
#define sipName_QLabel &sipStrings_QtGui[85317]
#define sipNameNr_SaveAs 85324
#define sipName_SaveAs &sipStrings_QtGui[85324]
#define sipNameNr_Italic 57556
#define sipName_Italic &sipStrings_QtGui[57556]
#define sipNameNr_AddTab 85331
#define sipName_AddTab &sipStrings_QtGui[85331]
#define sipNameNr_ZoomIn 85338
#define sipName_ZoomIn &sipStrings_QtGui[85338]
#define sipNameNr_Delete 85345
#define sipName_Delete &sipStrings_QtGui[85345]
#define sipNameNr_getInt 85352
#define sipName_getInt &sipStrings_QtGui[85352]
#define sipNameNr_option 85359
#define sipName_option &sipStrings_QtGui[85359]
#define sipNameNr_metric 85366
#define sipName_metric &sipStrings_QtGui[85366]
#define sipNameNr_scaled 85373
#define sipName_scaled &sipStrings_QtGui[85373]
#define sipNameNr_select 81439
#define sipName_select &sipStrings_QtGui[81439]
#define sipNameNr_Toggle 85380
#define sipName_Toggle &sipStrings_QtGui[85380]
#define sipNameNr_Select 54514
#define sipName_Select &sipStrings_QtGui[54514]
#define sipNameNr_Active 53734
#define sipName_Active &sipStrings_QtGui[53734]
#define sipNameNr_Custom 21900
#define sipName_Custom &sipStrings_QtGui[21900]
#define sipNameNr_isFlat 85387
#define sipName_isFlat &sipStrings_QtGui[85387]
#define sipNameNr_NoDrag 85394
#define sipName_NoDrag &sipStrings_QtGui[85394]
#define sipNameNr_newPos 85401
#define sipName_newPos &sipStrings_QtGui[85401]
#define sipNameNr_layout 85408
#define sipName_layout &sipStrings_QtGui[85408]
#define sipNameNr_render 85415
#define sipName_render &sipStrings_QtGui[85415]
#define sipNameNr_toHtml 85422
#define sipName_toHtml &sipStrings_QtGui[85422]
#define sipNameNr_offset 85429
#define sipName_offset &sipStrings_QtGui[85429]
#define sipNameNr_setPen 85436
#define sipName_setPen &sipStrings_QtGui[85436]
#define sipNameNr_scroll 85443
#define sipName_scroll &sipStrings_QtGui[85443]
#define sipNameNr_window 85450
#define sipName_window &sipStrings_QtGui[85450]
#define sipNameNr_zValue 85457
#define sipName_zValue &sipStrings_QtGui[85457]
#define sipNameNr_rotate 85464
#define sipName_rotate &sipStrings_QtGui[85464]
#define sipNameNr_moveBy 85471
#define sipName_moveBy &sipStrings_QtGui[85471]
#define sipNameNr_Sunken 63933
#define sipName_Sunken &sipStrings_QtGui[63933]
#define sipNameNr_Raised 63946
#define sipName_Raised &sipStrings_QtGui[63946]
#define sipNameNr_Shadow 55144
#define sipName_Shadow &sipStrings_QtGui[55144]
#define sipNameNr_addRow 85478
#define sipName_addRow &sipStrings_QtGui[85478]
#define sipNameNr_inFont 85485
#define sipName_inFont &sipStrings_QtGui[85485]
#define sipNameNr_ascent 85492
#define sipName_ascent &sipStrings_QtGui[85492]
#define sipNameNr_styles 85499
#define sipName_styles &sipStrings_QtGui[85499]
#define sipNameNr_Symbol 85506
#define sipName_Symbol &sipStrings_QtGui[85506]
#define sipNameNr_Thaana 85513
#define sipName_Thaana &sipStrings_QtGui[85513]
#define sipNameNr_italic 85520
#define sipName_italic &sipStrings_QtGui[85520]
#define sipNameNr_weight 85527
#define sipName_weight &sipStrings_QtGui[85527]
#define sipNameNr_family 85534
#define sipName_family &sipStrings_QtGui[85534]
#define sipNameNr_Normal 41706
#define sipName_Normal &sipStrings_QtGui[41706]
#define sipNameNr_Weight 57570
#define sipName_Weight &sipStrings_QtGui[57570]
#define sipNameNr_Folder 18969
#define sipName_Folder &sipStrings_QtGui[18969]
#define sipNameNr_Option 2398
#define sipName_Option &sipStrings_QtGui[2398]
#define sipNameNr_Reject 21944
#define sipName_Reject &sipStrings_QtGui[21944]
#define sipNameNr_Accept 21966
#define sipName_Accept &sipStrings_QtGui[21966]
#define sipNameNr_LookIn 85541
#define sipName_LookIn &sipStrings_QtGui[85541]
#define sipNameNr_Detail 57878
#define sipName_Detail &sipStrings_QtGui[57878]
#define sipNameNr_before 85548
#define sipName_before &sipStrings_QtGui[85548]
#define sipNameNr_action 19682
#define sipName_action &sipStrings_QtGui[19682]
#define sipNameNr_Reason 2790
#define sipName_Reason &sipStrings_QtGui[2790]
#define sipNameNr_region 85555
#define sipName_region &sipStrings_QtGui[85555]
#define sipNameNr_reason 85562
#define sipName_reason &sipStrings_QtGui[85562]
#define sipNameNr_Eraser 71338
#define sipName_Eraser &sipStrings_QtGui[71338]
#define sipNameNr_Stylus 55504
#define sipName_Stylus &sipStrings_QtGui[55504]
#define sipNameNr_oldPos 85569
#define sipName_oldPos &sipStrings_QtGui[85569]
#define sipNameNr_target 85576
#define sipName_target &sipStrings_QtGui[85576]
#define sipNameNr_source 32285
#define sipName_source &sipStrings_QtGui[32285]
#define sipNameNr_Cancel 85583
#define sipName_Cancel &sipStrings_QtGui[85583]
#define sipNameNr_Ignore 21922
#define sipName_Ignore &sipStrings_QtGui[21922]
#define sipNameNr_reject 85590
#define sipName_reject &sipStrings_QtGui[85590]
#define sipNameNr_screen 85597
#define sipName_screen &sipStrings_QtGui[85597]
#define sipNameNr_toNext 85604
#define sipName_toNext &sipStrings_QtGui[85604]
#define sipNameNr_toLast 85611
#define sipName_toLast &sipStrings_QtGui[85611]
#define sipNameNr_setPos 85618
#define sipName_setPos &sipStrings_QtGui[85618]
#define sipNameNr_bitmap 85625
#define sipName_bitmap &sipStrings_QtGui[85625]
#define sipNameNr_widget 85632
#define sipName_widget &sipStrings_QtGui[85632]
#define sipNameNr_pixmap 85639
#define sipName_pixmap &sipStrings_QtGui[85639]
#define sipNameNr_button 85646
#define sipName_button &sipStrings_QtGui[85646]
#define sipNameNr_radius 85653
#define sipName_radius &sipStrings_QtGui[85653]
#define sipNameNr_spread 85660
#define sipName_spread &sipStrings_QtGui[85660]
#define sipNameNr_Spread 40191
#define sipName_Spread &sipStrings_QtGui[40191]
#define sipNameNr_matrix 85667
#define sipName_matrix &sipStrings_QtGui[85667]
#define sipNameNr_darker 85674
#define sipName_darker &sipStrings_QtGui[85674]
#define sipNameNr_toCmyk 85681
#define sipName_toCmyk &sipStrings_QtGui[85681]
#define sipNameNr_blackF 85688
#define sipName_blackF &sipStrings_QtGui[85688]
#define sipNameNr_setHsv 85695
#define sipName_setHsv &sipStrings_QtGui[85695]
#define sipNameNr_getHsv 85702
#define sipName_getHsv &sipStrings_QtGui[85702]
#define sipNameNr_valueF 85709
#define sipName_valueF &sipStrings_QtGui[85709]
#define sipNameNr_setRgb 85716
#define sipName_setRgb &sipStrings_QtGui[85716]
#define sipNameNr_getRgb 85723
#define sipName_getRgb &sipStrings_QtGui[85723]
#define sipNameNr_greenF 85730
#define sipName_greenF &sipStrings_QtGui[85730]
#define sipNameNr_setRed 85737
#define sipName_setRed &sipStrings_QtGui[85737]
#define sipNameNr_alphaF 85744
#define sipName_alphaF &sipStrings_QtGui[85744]
#define sipNameNr_itemAt 85751
#define sipName_itemAt &sipStrings_QtGui[85751]
#define sipNameNr_XEvent 85758
#define sipName_XEvent &sipStrings_QtGui[85758]
#define sipNameNr_NoRole 85765
#define sipName_NoRole &sipStrings_QtGui[85765]
#define sipNameNr_cursor 85772
#define sipName_cursor &sipStrings_QtGui[85772]
#define sipNameNr_stepUp 85779
#define sipName_stepUp &sipStrings_QtGui[85779]
#define sipNameNr_stepBy 85786
#define sipName_stepBy &sipStrings_QtGui[85786]
#define sipNameNr_QFrame 85793
#define sipName_QFrame &sipStrings_QtGui[85793]
#define sipNameNr_toPage 85800
#define sipName_toPage &sipStrings_QtGui[85800]
#define sipNameNr_OnItem 85807
#define sipName_OnItem &sipStrings_QtGui[85807]
#define sipNameNr_MoveUp 85814
#define sipName_MoveUp &sipStrings_QtGui[85814]
#define sipNameNr_update 85821
#define sipName_update &sipStrings_QtGui[85821]
#define sipNameNr_NoHint 85828
#define sipName_NoHint &sipStrings_QtGui[85828]
#define sipNameNr_toggle 85835
#define sipName_toggle &sipStrings_QtGui[85835]
#define sipNameNr_isDown 85842
#define sipName_isDown &sipStrings_QtGui[85842]
#define sipNameNr_prefix 85849
#define sipName_prefix &sipStrings_QtGui[85849]
#define sipNameNr_Cursor 23682
#define sipName_Cursor &sipStrings_QtGui[23682]
#define sipNameNr_Paused 79885
#define sipName_Paused &sipStrings_QtGui[79885]
#define sipNameNr_takeAt 85856
#define sipName_takeAt &sipStrings_QtGui[85856]
#define sipNameNr_setKey 85863
#define sipName_setKey &sipStrings_QtGui[85863]
#define sipNameNr_format 80791
#define sipName_format &sipStrings_QtGui[80791]
#define sipNameNr_Format 540
#define sipName_Format &sipStrings_QtGui[540]
#define sipNameNr_locale 85870
#define sipName_locale &sipStrings_QtGui[85870]
#define sipNameNr_escape 85877
#define sipName_escape &sipStrings_QtGui[85877]
#define sipNameNr_united 85884
#define sipName_united &sipStrings_QtGui[85884]
#define sipNameNr_moveTo 85891
#define sipName_moveTo &sipStrings_QtGui[85891]
#define sipNameNr_height 85898
#define sipName_height &sipStrings_QtGui[85898]
#define sipNameNr_center 85905
#define sipName_center &sipStrings_QtGui[85905]
#define sipNameNr_setTop 85912
#define sipName_setTop &sipStrings_QtGui[85912]
#define sipNameNr_bottom 85919
#define sipName_bottom &sipStrings_QtGui[85919]
#define sipNameNr_QImage 85926
#define sipName_QImage &sipStrings_QtGui[85926]
#define sipNameNr_QColor 85933
#define sipName_QColor &sipStrings_QtGui[85933]
#define sipNameNr_QBrush 85940
#define sipName_QBrush &sipStrings_QtGui[85940]
#define sipNameNr_Syriac 85947
#define sipName_Syriac &sipStrings_QtGui[85947]
#define sipNameNr_Telugu 85954
#define sipName_Telugu &sipStrings_QtGui[85954]
#define sipNameNr_Korean 85961
#define sipName_Korean &sipStrings_QtGui[85961]
#define sipNameNr_Hebrew 85968
#define sipName_Hebrew &sipStrings_QtGui[85968]
#define sipNameNr_Arabic 85975
#define sipName_Arabic &sipStrings_QtGui[85975]
#define sipNameNr_suffix 85982
#define sipName_suffix &sipStrings_QtGui[85982]
#define sipNameNr_filter 85989
#define sipName_filter &sipStrings_QtGui[85989]
#define sipNameNr_System 10046
#define sipName_System &sipStrings_QtGui[10046]
#define sipNameNr_Hidden 43593
#define sipName_Hidden &sipStrings_QtGui[43593]
#define sipNameNr_status 85996
#define sipName_status &sipStrings_QtGui[85996]
#define sipNameNr_device 86003
#define sipName_device &sipStrings_QtGui[86003]
#define sipNameNr_result 86010
#define sipName_result &sipStrings_QtGui[86010]
#define sipNameNr_ignore 86017
#define sipName_ignore &sipStrings_QtGui[86017]
#define sipNameNr_accept 86024
#define sipName_accept &sipStrings_QtGui[86024]
#define sipNameNr_notify 86031
#define sipName_notify &sipStrings_QtGui[86031]
#define sipNameNr_length 86038
#define sipName_length &sipStrings_QtGui[86038]
#define sipNameNr_setNum 86045
#define sipName_setNum &sipStrings_QtGui[86045]
#define sipNameNr___ge__ 86052
#define sipName___ge__ &sipStrings_QtGui[86052]
#define sipNameNr___le__ 86059
#define sipName___le__ &sipStrings_QtGui[86059]
#define sipNameNr___gt__ 86066
#define sipName___gt__ &sipStrings_QtGui[86066]
#define sipNameNr_insert 86073
#define sipName_insert &sipStrings_QtGui[86073]
#define sipNameNr_append 86080
#define sipName_append &sipStrings_QtGui[86080]
#define sipNameNr_detach 86087
#define sipName_detach &sipStrings_QtGui[86087]
#define sipNameNr_resize 86094
#define sipName_resize &sipStrings_QtGui[86094]
#define sipNameNr_isNull 86101
#define sipName_isNull &sipStrings_QtGui[86101]
#define sipNameNr_revert 86108
#define sipName_revert &sipStrings_QtGui[86108]
#define sipNameNr_submit 86115
#define sipName_submit &sipStrings_QtGui[86115]
#define sipNameNr___lt__ 86122
#define sipName___lt__ &sipStrings_QtGui[86122]
#define sipNameNr_parent 86129
#define sipName_parent &sipStrings_QtGui[86129]
#define sipNameNr_column 86136
#define sipName_column &sipStrings_QtGui[86136]
#define sipNameNr_create 86143
#define sipName_create &sipStrings_QtGui[86143]
#define sipNameNr_handle 86150
#define sipName_handle &sipStrings_QtGui[86150]
#define sipNameNr_remove 86157
#define sipName_remove &sipStrings_QtGui[86157]
#define sipNameNr_Window 13576
#define sipName_Window &sipStrings_QtGui[13576]
#define sipNameNr_yellow 86164
#define sipName_yellow &sipStrings_QtGui[86164]
#define sipNameNr___ne__ 86171
#define sipName___ne__ &sipStrings_QtGui[86171]
#define sipNameNr___eq__ 86178
#define sipName___eq__ &sipStrings_QtGui[86178]
#define sipNameNr___or__ 86185
#define sipName___or__ &sipStrings_QtGui[86185]
#define sipNameNr_cells 86192
#define sipName_cells &sipStrings_QtGui[86192]
#define sipNameNr_field 86198
#define sipName_field &sipStrings_QtGui[86198]
#define sipNameNr_winId 86204
#define sipName_winId &sipStrings_QtGui[86204]
#define sipNameNr_lower 86210
#define sipName_lower &sipStrings_QtGui[86210]
#define sipNameNr_mapTo 86216
#define sipName_mapTo &sipStrings_QtGui[86216]
#define sipNameNr_stack 86222
#define sipName_stack &sipStrings_QtGui[86222]
#define sipNameNr_Flags 2518
#define sipName_Flags &sipStrings_QtGui[2518]
#define sipNameNr_block 86228
#define sipName_block &sipStrings_QtGui[86228]
#define sipNameNr_Start 32647
#define sipName_Start &sipStrings_QtGui[32647]
#define sipNameNr_South 46792
#define sipName_South &sipStrings_QtGui[46792]
#define sipNameNr_North 46808
#define sipName_North &sipStrings_QtGui[46808]
#define sipNameNr_rowAt 86234
#define sipName_rowAt &sipStrings_QtGui[86234]
#define sipNameNr_tabAt 86240
#define sipName_tabAt &sipStrings_QtGui[86240]
#define sipNameNr_Arrow 10668
#define sipName_Arrow &sipStrings_QtGui[10668]
#define sipNameNr_frame 86246
#define sipName_frame &sipStrings_QtGui[86246]
#define sipNameNr_loops 86252
#define sipName_loops &sipStrings_QtGui[86252]
#define sipNameNr_Label 15800
#define sipName_Label &sipStrings_QtGui[15800]
#define sipNameNr_Frame 7413
#define sipName_Frame &sipStrings_QtGui[7413]
#define sipNameNr_qGray 86258
#define sipName_qGray &sipStrings_QtGui[86258]
#define sipNameNr_qRgba 86264
#define sipName_qRgba &sipStrings_QtGui[86264]
#define sipNameNr_qBlue 86270
#define sipName_qBlue &sipStrings_QtGui[86270]
#define sipNameNr_xored 86276
#define sipName_xored &sipStrings_QtGui[86276]
#define sipNameNr_rects 86282
#define sipName_rects &sipStrings_QtGui[86282]
#define sipNameNr_abort 86288
#define sipName_abort &sipStrings_QtGui[86288]
#define sipNameNr_Didot 86294
#define sipName_Didot &sipStrings_QtGui[86294]
#define sipNameNr_Lower 86300
#define sipName_Lower &sipStrings_QtGui[86300]
#define sipNameNr_Folio 86306
#define sipName_Folio &sipStrings_QtGui[86306]
#define sipNameNr_Legal 86312
#define sipName_Legal &sipStrings_QtGui[86312]
#define sipNameNr_point 86318
#define sipName_point &sipStrings_QtGui[86318]
#define sipNameNr_arcTo 86324
#define sipName_arcTo &sipStrings_QtGui[86324]
#define sipNameNr_begin 86330
#define sipName_begin &sipStrings_QtGui[86330]
#define sipNameNr_speed 86336
#define sipName_speed &sipStrings_QtGui[86336]
#define sipNameNr_about 86342
#define sipName_about &sipStrings_QtGui[86342]
#define sipNameNr_NoAll 86348
#define sipName_NoAll &sipStrings_QtGui[86348]
#define sipNameNr_QMenu 86354
#define sipName_QMenu &sipStrings_QtGui[86354]
#define sipNameNr_paste 86360
#define sipName_paste &sipStrings_QtGui[86360]
#define sipNameNr_movie 86366
#define sipName_movie &sipStrings_QtGui[86366]
#define sipNameNr_Print 86372
#define sipName_Print &sipStrings_QtGui[86372]
#define sipNameNr_Paste 81062
#define sipName_Paste &sipStrings_QtGui[81062]
#define sipNameNr_gamma 86378
#define sipName_gamma &sipStrings_QtGui[86378]
#define sipNameNr_Gamma 81548
#define sipName_Gamma &sipStrings_QtGui[81548]
#define sipNameNr_pixel 86384
#define sipName_pixel &sipStrings_QtGui[86384]
#define sipNameNr_valid 54470
#define sipName_valid &sipStrings_QtGui[54470]
#define sipNameNr_depth 86390
#define sipName_depth &sipStrings_QtGui[86390]
#define sipNameNr_merge 86396
#define sipName_merge &sipStrings_QtGui[86396]
#define sipNameNr_Clear 22473
#define sipName_Clear &sipStrings_QtGui[22473]
#define sipNameNr_sizes 11844
#define sipName_sizes &sipStrings_QtGui[11844]
#define sipNameNr_clone 86402
#define sipName_clone &sipStrings_QtGui[86402]
#define sipNameNr_Fixed 86408
#define sipName_Fixed &sipStrings_QtGui[86408]
#define sipNameNr_title 86414
#define sipName_title &sipStrings_QtGui[86414]
#define sipNameNr_views 86420
#define sipName_views &sipStrings_QtGui[86420]
#define sipNameNr_items 86426
#define sipName_items &sipStrings_QtGui[86426]
#define sipNameNr_posAt 86432
#define sipName_posAt &sipStrings_QtGui[86432]
#define sipNameNr_brush 81989
#define sipName_brush &sipStrings_QtGui[81989]
#define sipNameNr_shear 86438
#define sipName_shear &sipStrings_QtGui[86438]
#define sipNameNr_scene 86444
#define sipName_scene &sipStrings_QtGui[86444]
#define sipNameNr_VLine 86450
#define sipName_VLine &sipStrings_QtGui[86450]
#define sipNameNr_HLine 86456
#define sipName_HLine &sipStrings_QtGui[86456]
#define sipNameNr_Panel 49656
#define sipName_Panel &sipStrings_QtGui[49656]
#define sipNameNr_Shape 15700
#define sipName_Shape &sipStrings_QtGui[15700]
#define sipNameNr_Plain 86462
#define sipName_Plain &sipStrings_QtGui[86462]
#define sipNameNr_Runic 86468
#define sipName_Runic &sipStrings_QtGui[86468]
#define sipNameNr_Ogham 86474
#define sipName_Ogham &sipStrings_QtGui[86474]
#define sipNameNr_Khmer 86480
#define sipName_Khmer &sipStrings_QtGui[86480]
#define sipNameNr_Black 86486
#define sipName_Black &sipStrings_QtGui[86486]
#define sipNameNr_Light 13447
#define sipName_Light &sipStrings_QtGui[13447]
#define sipNameNr_Serif 79046
#define sipName_Serif &sipStrings_QtGui[79046]
#define sipNameNr_Times 86492
#define sipName_Times &sipStrings_QtGui[86492]
#define sipNameNr_Drive 86498
#define sipName_Drive &sipStrings_QtGui[86498]
#define sipNameNr_Other 86504
#define sipName_Other &sipStrings_QtGui[86504]
#define sipNameNr_Mouse 43662
#define sipName_Mouse &sipStrings_QtGui[43662]
#define sipNameNr_yTilt 86510
#define sipName_yTilt &sipStrings_QtGui[86510]
#define sipNameNr_xTilt 86516
#define sipName_xTilt &sipStrings_QtGui[86516]
#define sipNameNr_delta 86522
#define sipName_delta &sipStrings_QtGui[86522]
#define sipNameNr_QDrag 86528
#define sipName_QDrag &sipStrings_QtGui[86528]
#define sipNameNr_Roles 17943
#define sipName_Roles &sipStrings_QtGui[17943]
#define sipNameNr_Reset 64181
#define sipName_Reset &sipStrings_QtGui[64181]
#define sipNameNr_Apply 25460
#define sipName_Apply &sipStrings_QtGui[25460]
#define sipNameNr_Retry 25418
#define sipName_Retry &sipStrings_QtGui[25418]
#define sipNameNr_Abort 25439
#define sipName_Abort &sipStrings_QtGui[25439]
#define sipNameNr_QDial 86534
#define sipName_QDial &sipStrings_QtGui[86534]
#define sipNameNr_shape 86540
#define sipName_shape &sipStrings_QtGui[86540]
#define sipNameNr_popup 86546
#define sipName_popup &sipStrings_QtGui[86546]
#define sipNameNr_image 86552
#define sipName_image &sipStrings_QtGui[86552]
#define sipNameNr_setId 86558
#define sipName_setId &sipStrings_QtGui[86558]
#define sipNameNr_stops 86564
#define sipName_stops &sipStrings_QtGui[86564]
#define sipNameNr_color 86570
#define sipName_color &sipStrings_QtGui[86570]
#define sipNameNr_light 68819
#define sipName_light &sipStrings_QtGui[68819]
#define sipNameNr_toHsv 86576
#define sipName_toHsv &sipStrings_QtGui[86576]
#define sipNameNr_toRgb 86582
#define sipName_toRgb &sipStrings_QtGui[86582]
#define sipNameNr_cyanF 86588
#define sipName_cyanF &sipStrings_QtGui[86588]
#define sipNameNr_blueF 86594
#define sipName_blueF &sipStrings_QtGui[86594]
#define sipNameNr_alpha 86600
#define sipName_alpha &sipStrings_QtGui[86600]
#define sipNameNr_alert 86606
#define sipName_alert &sipStrings_QtGui[86606]
#define sipNameNr_syncX 86612
#define sipName_syncX &sipStrings_QtGui[86612]
#define sipNameNr_style 86618
#define sipName_style &sipStrings_QtGui[86618]
#define sipNameNr_hover 86624
#define sipName_hover &sipStrings_QtGui[86624]
#define sipNameNr_Hover 86630
#define sipName_Hover &sipStrings_QtGui[86630]
#define sipNameNr_fixup 86636
#define sipName_fixup &sipStrings_QtGui[86636]
#define sipNameNr_paint 83439
#define sipName_paint &sipStrings_QtGui[83439]
#define sipNameNr_click 86642
#define sipName_click &sipStrings_QtGui[86642]
#define sipNameNr_Error 7785
#define sipName_Error &sipStrings_QtGui[7785]
#define sipNameNr_Color 11493
#define sipName_Color &sipStrings_QtGui[11493]
#define sipNameNr_Point 26258
#define sipName_Point &sipStrings_QtGui[26258]
#define sipNameNr_State 15950
#define sipName_State &sipStrings_QtGui[15950]
#define sipNameNr_codec 86648
#define sipName_codec &sipStrings_QtGui[86648]
#define sipNameNr_first 86654
#define sipName_first &sipStrings_QtGui[86654]
#define sipNameNr_scale 70463
#define sipName_scale &sipStrings_QtGui[70463]
#define sipNameNr_unite 86660
#define sipName_unite &sipStrings_QtGui[86660]
#define sipNameNr_width 86666
#define sipName_width &sipStrings_QtGui[86666]
#define sipNameNr_state 71783
#define sipName_state &sipStrings_QtGui[71783]
#define sipNameNr_QIcon 86672
#define sipName_QIcon &sipStrings_QtGui[86672]
#define sipNameNr_QFont 86678
#define sipName_QFont &sipStrings_QtGui[86678]
#define sipNameNr_value 86684
#define sipName_value &sipStrings_QtGui[86684]
#define sipNameNr_Tamil 86690
#define sipName_Tamil &sipStrings_QtGui[86690]
#define sipNameNr_Oriya 86696
#define sipName_Oriya &sipStrings_QtGui[86696]
#define sipNameNr_Latin 86702
#define sipName_Latin &sipStrings_QtGui[86702]
#define sipNameNr_Greek 86708
#define sipName_Greek &sipStrings_QtGui[86708]
#define sipNameNr_angle 77976
#define sipName_angle &sipStrings_QtGui[77976]
#define sipNameNr_group 86714
#define sipName_group &sipStrings_QtGui[86714]
#define sipNameNr_isDir 86720
#define sipName_isDir &sipStrings_QtGui[86720]
#define sipNameNr_Style 6492
#define sipName_Style &sipStrings_QtGui[6492]
#define sipNameNr_Close 25607
#define sipName_Close &sipStrings_QtGui[25607]
#define sipNameNr_event 86726
#define sipName_event &sipStrings_QtGui[86726]
#define sipNameNr_exec_ 86732
#define sipName_exec_ &sipStrings_QtGui[86732]
#define sipNameNr_Right 19591
#define sipName_Right &sipStrings_QtGui[19591]
#define sipNameNr_split 86738
#define sipName_split &sipStrings_QtGui[86738]
#define sipNameNr_right 86744
#define sipName_right &sipStrings_QtGui[86744]
#define sipNameNr_qSwap 86750
#define sipName_qSwap &sipStrings_QtGui[86750]
#define sipNameNr_clear 86756
#define sipName_clear &sipStrings_QtGui[86756]
#define sipNameNr_count 86762
#define sipName_count &sipStrings_QtGui[86762]
#define sipNameNr_start 84759
#define sipName_start &sipStrings_QtGui[84759]
#define sipNameNr_reset 86768
#define sipName_reset &sipStrings_QtGui[86768]
#define sipNameNr_match 86774
#define sipName_match &sipStrings_QtGui[86774]
#define sipNameNr_buddy 86780
#define sipName_buddy &sipStrings_QtGui[86780]
#define sipNameNr_index 86786
#define sipName_index &sipStrings_QtGui[86786]
#define sipNameNr_model 86792
#define sipName_model &sipStrings_QtGui[86792]
#define sipNameNr_flags 86798
#define sipName_flags &sipStrings_QtGui[86798]
#define sipNameNr_child 86804
#define sipName_child &sipStrings_QtGui[86804]
#define sipNameNr_error 86810
#define sipName_error &sipStrings_QtGui[86810]
#define sipNameNr_write 27014
#define sipName_write &sipStrings_QtGui[27014]
#define sipNameNr_rmdir 86816
#define sipName_rmdir &sipStrings_QtGui[86816]
#define sipNameNr_mkdir 86822
#define sipName_mkdir &sipStrings_QtGui[86822]
#define sipNameNr_close 86828
#define sipName_close &sipStrings_QtGui[86828]
#define sipNameNr_atEnd 86834
#define sipName_atEnd &sipStrings_QtGui[86834]
#define sipNameNr_green 86840
#define sipName_green &sipStrings_QtGui[86840]
#define sipNameNr_black 86846
#define sipName_black &sipStrings_QtGui[86846]
#define sipNameNr_tile 86852
#define sipName_tile &sipStrings_QtGui[86852]
#define sipNameNr_back 86857
#define sipName_back &sipStrings_QtGui[86857]
#define sipNameNr_page 86862
#define sipName_page &sipStrings_QtGui[86862]
#define sipNameNr_push 86867
#define sipName_push &sipStrings_QtGui[86867]
#define sipNameNr_rows 14701
#define sipName_rows &sipStrings_QtGui[14701]
#define sipNameNr_tabs 86872
#define sipName_tabs &sipStrings_QtGui[86872]
#define sipNameNr_Flag 2869
#define sipName_Flag &sipStrings_QtGui[2869]
#define sipNameNr_Edge 46265
#define sipName_Edge &sipStrings_QtGui[46265]
#define sipNameNr_East 52221
#define sipName_East &sipStrings_QtGui[52221]
#define sipNameNr_West 52236
#define sipName_West &sipStrings_QtGui[52236]
#define sipNameNr_Menu 13630
#define sipName_Menu &sipStrings_QtGui[13630]
#define sipNameNr_Left 22056
#define sipName_Left &sipStrings_QtGui[22056]
#define sipNameNr_init 86877
#define sipName_init &sipStrings_QtGui[86877]
#define sipNameNr_qRgb 86882
#define sipName_qRgb &sipStrings_QtGui[86882]
#define sipNameNr_qRed 86887
#define sipName_qRed &sipStrings_QtGui[86887]
#define sipNameNr_Pica 86892
#define sipName_Pica &sipStrings_QtGui[86892]
#define sipNameNr_Inch 86897
#define sipName_Inch &sipStrings_QtGui[86897]
#define sipNameNr_Unit 53481
#define sipName_Unit &sipStrings_QtGui[53481]
#define sipNameNr_Idle 86902
#define sipName_Idle &sipStrings_QtGui[86902]
#define sipNameNr_Auto 51891
#define sipName_Auto &sipStrings_QtGui[51891]
#define sipNameNr_find 86907
#define sipName_find &sipStrings_QtGui[86907]
#define sipNameNr_play 70284
#define sipName_play &sipStrings_QtGui[70284]
#define sipNameNr_base 60736
#define sipName_base &sipStrings_QtGui[60736]
#define sipNameNr_Link 52461
#define sipName_Link &sipStrings_QtGui[52461]
#define sipNameNr_Base 18925
#define sipName_Base &sipStrings_QtGui[18925]
#define sipNameNr_Dark 86912
#define sipName_Dark &sipStrings_QtGui[86912]
#define sipNameNr_flow 59756
#define sipName_flow &sipStrings_QtGui[59756]
#define sipNameNr_Flow 48345
#define sipName_Flow &sipStrings_QtGui[48345]
#define sipNameNr_Snap 86917
#define sipName_Snap &sipStrings_QtGui[86917]
#define sipNameNr_Free 86922
#define sipName_Free &sipStrings_QtGui[86922]
#define sipNameNr_redo 86927
#define sipName_redo &sipStrings_QtGui[86927]
#define sipNameNr_undo 86932
#define sipName_undo &sipStrings_QtGui[86932]
#define sipNameNr_del_ 86937
#define sipName_del_ &sipStrings_QtGui[86937]
#define sipNameNr_Flat 83840
#define sipName_Flat &sipStrings_QtGui[83840]
#define sipNameNr_Find 86942
#define sipName_Find &sipStrings_QtGui[86942]
#define sipNameNr_Back 37403
#define sipName_Back &sipStrings_QtGui[37403]
#define sipNameNr_Redo 83144
#define sipName_Redo &sipStrings_QtGui[83144]
#define sipNameNr_Undo 83152
#define sipName_Undo &sipStrings_QtGui[83152]
#define sipNameNr_Copy 86947
#define sipName_Copy &sipStrings_QtGui[86947]
#define sipNameNr_keys 86952
#define sipName_keys &sipStrings_QtGui[86952]
#define sipNameNr_bits 86957
#define sipName_bits &sipStrings_QtGui[86957]
#define sipNameNr_Rows 50825
#define sipName_Rows &sipStrings_QtGui[50825]
#define sipNameNr_mode 86962
#define sipName_mode &sipStrings_QtGui[86962]
#define sipNameNr_item 86967
#define sipName_item &sipStrings_QtGui[86967]
#define sipNameNr_line 27964
#define sipName_line &sipStrings_QtGui[27964]
#define sipNameNr_show 86972
#define sipName_show &sipStrings_QtGui[86972]
#define sipNameNr_hide 86977
#define sipName_hide &sipStrings_QtGui[86977]
#define sipNameNr_bold 86982
#define sipName_bold &sipStrings_QtGui[86982]
#define sipNameNr_Bold 5835
#define sipName_Bold &sipStrings_QtGui[5835]
#define sipNameNr_File 66236
#define sipName_File &sipStrings_QtGui[66236]
#define sipNameNr_file 86987
#define sipName_file &sipStrings_QtGui[86987]
#define sipNameNr_href 86992
#define sipName_href &sipStrings_QtGui[86992]
#define sipNameNr_Ruby 86997
#define sipName_Ruby &sipStrings_QtGui[86997]
#define sipNameNr_rect 87002
#define sipName_rect &sipStrings_QtGui[87002]
#define sipNameNr_Puck 87007
#define sipName_Puck &sipStrings_QtGui[87007]
#define sipNameNr_posF 87012
#define sipName_posF &sipStrings_QtGui[87012]
#define sipNameNr_exec 87017
#define sipName_exec &sipStrings_QtGui[87017]
#define sipNameNr_Help 29104
#define sipName_Help &sipStrings_QtGui[29104]
#define sipNameNr_Save 75947
#define sipName_Save &sipStrings_QtGui[75947]
#define sipNameNr_mask 87022
#define sipName_mask &sipStrings_QtGui[87022]
#define sipNameNr_view 58762
#define sipName_view &sipStrings_QtGui[58762]
#define sipNameNr_done 87027
#define sipName_done &sipStrings_QtGui[87027]
#define sipNameNr_Mode 5535
#define sipName_Mode &sipStrings_QtGui[5535]
#define sipNameNr_dark 87032
#define sipName_dark &sipStrings_QtGui[87032]
#define sipNameNr_hueF 87037
#define sipName_hueF &sipStrings_QtGui[87037]
#define sipNameNr_rgba 87042
#define sipName_rgba &sipStrings_QtGui[87042]
#define sipNameNr_redF 87047
#define sipName_redF &sipStrings_QtGui[87047]
#define sipNameNr_spec 87052
#define sipName_spec &sipStrings_QtGui[87052]
#define sipNameNr_Cmyk 82251
#define sipName_Cmyk &sipStrings_QtGui[82251]
#define sipNameNr_Spec 18136
#define sipName_Spec &sipStrings_QtGui[18136]
#define sipNameNr_Down 11710
#define sipName_Down &sipStrings_QtGui[11710]
#define sipNameNr_beep 87057
#define sipName_beep &sipStrings_QtGui[87057]
#define sipNameNr_qApp 87062
#define sipName_qApp &sipStrings_QtGui[87062]
#define sipNameNr_font 87067
#define sipName_font &sipStrings_QtGui[87067]
#define sipNameNr_menu 87072
#define sipName_menu &sipStrings_QtGui[87072]
#define sipNameNr_draw 87077
#define sipName_draw &sipStrings_QtGui[87077]
#define sipNameNr_clip 87082
#define sipName_clip &sipStrings_QtGui[87082]
#define sipNameNr_edit 87087
#define sipName_edit &sipStrings_QtGui[87087]
#define sipNameNr_icon 87092
#define sipName_icon &sipStrings_QtGui[87092]
#define sipNameNr_save 87097
#define sipName_save &sipStrings_QtGui[87097]
#define sipNameNr_Icon 3477
#define sipName_Icon &sipStrings_QtGui[3477]
#define sipNameNr_List 14176
#define sipName_List &sipStrings_QtGui[14176]
#define sipNameNr_Line 28984
#define sipName_Line &sipStrings_QtGui[28984]
#define sipNameNr_Open 74110
#define sipName_Open &sipStrings_QtGui[74110]
#define sipNameNr_last 87102
#define sipName_last &sipStrings_QtGui[87102]
#define sipNameNr_swap 87107
#define sipName_swap &sipStrings_QtGui[87107]
#define sipNameNr_move 9410
#define sipName_move &sipStrings_QtGui[9410]
#define sipNameNr_text 1225
#define sipName_text &sipStrings_QtGui[1225]
#define sipNameNr_QPen 87112
#define sipName_QPen &sipStrings_QtGui[87112]
#define sipNameNr_name 87117
#define sipName_name &sipStrings_QtGui[87117]
#define sipNameNr_Thai 87122
#define sipName_Thai &sipStrings_QtGui[87122]
#define sipNameNr_load 41980
#define sipName_load &sipStrings_QtGui[41980]
#define sipNameNr_Text 4850
#define sipName_Text &sipStrings_QtGui[4850]
#define sipNameNr_home 87127
#define sipName_home &sipStrings_QtGui[87127]
#define sipNameNr_Size 11656
#define sipName_Size &sipStrings_QtGui[11656]
#define sipNameNr_Name 33636
#define sipName_Name &sipStrings_QtGui[33636]
#define sipNameNr_time 87132
#define sipName_time &sipStrings_QtGui[87132]
#define sipNameNr_date 11953
#define sipName_date &sipStrings_QtGui[11953]
#define sipNameNr_type 42490
#define sipName_type &sipStrings_QtGui[42490]
#define sipNameNr_User 84784
#define sipName_User &sipStrings_QtGui[84784]
#define sipNameNr_None 41334
#define sipName_None &sipStrings_QtGui[41334]
#define sipNameNr_Type 498
#define sipName_Type &sipStrings_QtGui[498]
#define sipNameNr_left 87137
#define sipName_left &sipStrings_QtGui[87137]
#define sipNameNr_fill 87142
#define sipName_fill &sipStrings_QtGui[87142]
#define sipNameNr_stop 87147
#define sipName_stop &sipStrings_QtGui[87147]
#define sipNameNr_span 87152
#define sipName_span &sipStrings_QtGui[87152]
#define sipNameNr_sort 87157
#define sipName_sort &sipStrings_QtGui[87157]
#define sipNameNr_data 87162
#define sipName_data &sipStrings_QtGui[87162]
#define sipNameNr_path 64559
#define sipName_path &sipStrings_QtGui[64559]
#define sipNameNr_next 87167
#define sipName_next &sipStrings_QtGui[87167]
#define sipNameNr_read 40193
#define sipName_read &sipStrings_QtGui[40193]
#define sipNameNr_link 87172
#define sipName_link &sipStrings_QtGui[87172]
#define sipNameNr_copy 87177
#define sipName_copy &sipStrings_QtGui[87177]
#define sipNameNr_size 38951
#define sipName_size &sipStrings_QtGui[38951]
#define sipNameNr_open 87182
#define sipName_open &sipStrings_QtGui[87182]
#define sipNameNr_cyan 87187
#define sipName_cyan &sipStrings_QtGui[87187]
#define sipNameNr_blue 87192
#define sipName_blue &sipStrings_QtGui[87192]
#define sipNameNr_m33 87197
#define sipName_m33 &sipStrings_QtGui[87197]
#define sipNameNr_m32 87201
#define sipName_m32 &sipStrings_QtGui[87201]
#define sipNameNr_m31 87205
#define sipName_m31 &sipStrings_QtGui[87205]
#define sipNameNr_m23 87209
#define sipName_m23 &sipStrings_QtGui[87209]
#define sipNameNr_m13 87213
#define sipName_m13 &sipStrings_QtGui[87213]
#define sipNameNr_Tab 37152
#define sipName_Tab &sipStrings_QtGui[37152]
#define sipNameNr_Top 62151
#define sipName_Top &sipStrings_QtGui[62151]
#define sipNameNr_End 41998
#define sipName_End &sipStrings_QtGui[41998]
#define sipNameNr_eor 87217
#define sipName_eor &sipStrings_QtGui[87217]
#define sipNameNr_DLE 87221
#define sipName_DLE &sipStrings_QtGui[87221]
#define sipNameNr_C5E 87225
#define sipName_C5E &sipStrings_QtGui[87225]
#define sipNameNr_B10 87229
#define sipName_B10 &sipStrings_QtGui[87229]
#define sipNameNr_Mid 87233
#define sipName_Mid &sipStrings_QtGui[87233]
#define sipNameNr_All 33086
#define sipName_All &sipStrings_QtGui[33086]
#define sipNameNr_Pdf 87237
#define sipName_Pdf &sipStrings_QtGui[87237]
#define sipNameNr_SVG 87241
#define sipName_SVG &sipStrings_QtGui[87241]
#define sipNameNr_X11 87245
#define sipName_X11 &sipStrings_QtGui[87245]
#define sipNameNr_det 87249
#define sipName_det &sipStrings_QtGui[87249]
#define sipNameNr_m22 87253
#define sipName_m22 &sipStrings_QtGui[87253]
#define sipNameNr_m21 87257
#define sipName_m21 &sipStrings_QtGui[87257]
#define sipNameNr_m12 87261
#define sipName_m12 &sipStrings_QtGui[87261]
#define sipNameNr_m11 87265
#define sipName_m11 &sipStrings_QtGui[87265]
#define sipNameNr_cut 25042
#define sipName_cut &sipStrings_QtGui[25042]
#define sipNameNr_end 74727
#define sipName_end &sipStrings_QtGui[74727]
#define sipNameNr_Bin 87269
#define sipName_Bin &sipStrings_QtGui[87269]
#define sipNameNr_Oct 87273
#define sipName_Oct &sipStrings_QtGui[87273]
#define sipNameNr_Dec 87277
#define sipName_Dec &sipStrings_QtGui[87277]
#define sipNameNr_Hex 87281
#define sipName_Hex &sipStrings_QtGui[87281]
#define sipNameNr_Cut 87285
#define sipName_Cut &sipStrings_QtGui[87285]
#define sipNameNr_New 87289
#define sipName_New &sipStrings_QtGui[87289]
#define sipNameNr_Off 77858
#define sipName_Off &sipStrings_QtGui[77858]
#define sipNameNr_pen 74111
#define sipName_pen &sipStrings_QtGui[74111]
#define sipNameNr_Box 24706
#define sipName_Box &sipStrings_QtGui[24706]
#define sipNameNr_Any 87293
#define sipName_Any &sipStrings_QtGui[87293]
#define sipNameNr_tip 87297
#define sipName_tip &sipStrings_QtGui[87297]
#define sipNameNr_Yes 87301
#define sipName_Yes &sipStrings_QtGui[87301]
#define sipNameNr_hue 87305
#define sipName_hue &sipStrings_QtGui[87305]
#define sipNameNr_rgb 87309
#define sipName_rgb &sipStrings_QtGui[87309]
#define sipNameNr_Hsv 84209
#define sipName_Hsv &sipStrings_QtGui[84209]
#define sipNameNr_Rgb 78608
#define sipName_Rgb &sipStrings_QtGui[78608]
#define sipNameNr_Tty 87313
#define sipName_Tty &sipStrings_QtGui[87313]
#define sipNameNr_Pen 22519
#define sipName_Pen &sipStrings_QtGui[22519]
#define sipNameNr_top 6750
#define sipName_top &sipStrings_QtGui[6750]
#define sipNameNr_add 87317
#define sipName_add &sipStrings_QtGui[87317]
#define sipNameNr_key 87321
#define sipName_key &sipStrings_QtGui[87321]
#define sipNameNr_Lao 87325
#define sipName_Lao &sipStrings_QtGui[87325]
#define sipNameNr_mid 87329
#define sipName_mid &sipStrings_QtGui[87329]
#define sipNameNr_row 10670
#define sipName_row &sipStrings_QtGui[10670]
#define sipNameNr_map 16169
#define sipName_map &sipStrings_QtGui[16169]
#define sipNameNr_pos 87333
#define sipName_pos &sipStrings_QtGui[87333]
#define sipNameNr_red 40266
#define sipName_red &sipStrings_QtGui[40266]
#define sipNameNr_B9 87337
#define sipName_B9 &sipStrings_QtGui[87337]
#define sipNameNr_B8 87340
#define sipName_B8 &sipStrings_QtGui[87340]
#define sipNameNr_B7 87343
#define sipName_B7 &sipStrings_QtGui[87343]
#define sipNameNr_B6 87346
#define sipName_B6 &sipStrings_QtGui[87346]
#define sipNameNr_B4 87349
#define sipName_B4 &sipStrings_QtGui[87349]
#define sipNameNr_B3 87352
#define sipName_B3 &sipStrings_QtGui[87352]
#define sipNameNr_B2 87355
#define sipName_B2 &sipStrings_QtGui[87355]
#define sipNameNr_B1 87358
#define sipName_B1 &sipStrings_QtGui[87358]
#define sipNameNr_B0 87361
#define sipName_B0 &sipStrings_QtGui[87361]
#define sipNameNr_A9 87364
#define sipName_A9 &sipStrings_QtGui[87364]
#define sipNameNr_A8 87367
#define sipName_A8 &sipStrings_QtGui[87367]
#define sipNameNr_A7 87370
#define sipName_A7 &sipStrings_QtGui[87370]
#define sipNameNr_A6 87373
#define sipName_A6 &sipStrings_QtGui[87373]
#define sipNameNr_A5 87376
#define sipName_A5 &sipStrings_QtGui[87376]
#define sipNameNr_A3 87379
#define sipName_A3 &sipStrings_QtGui[87379]
#define sipNameNr_A2 87382
#define sipName_A2 &sipStrings_QtGui[87382]
#define sipNameNr_A1 87385
#define sipName_A1 &sipStrings_QtGui[87385]
#define sipNameNr_A0 87388
#define sipName_A0 &sipStrings_QtGui[87388]
#define sipNameNr_B5 87391
#define sipName_B5 &sipStrings_QtGui[87391]
#define sipNameNr_A4 87394
#define sipName_A4 &sipStrings_QtGui[87394]
#define sipNameNr_On 80777
#define sipName_On &sipStrings_QtGui[80777]
#define sipNameNr_No 87397
#define sipName_No &sipStrings_QtGui[87397]
#define sipNameNr_id 36667
#define sipName_id &sipStrings_QtGui[36667]
#define sipNameNr_Up 29346
#define sipName_Up &sipStrings_QtGui[29346]
#define sipNameNr_dy 81488
#define sipName_dy &sipStrings_QtGui[81488]
#define sipNameNr_dx 87400
#define sipName_dx &sipStrings_QtGui[87400]
#define sipNameNr_Ok 87403
#define sipName_Ok &sipStrings_QtGui[87403]
#define sipNameNr_at 544
#define sipName_at &sipStrings_QtGui[544]
#define sipNameNr_Qt 84338
#define sipName_Qt &sipStrings_QtGui[84338]
#define sipNameNr_z 87406
#define sipName_z &sipStrings_QtGui[87406]
#define sipNameNr_y 2910
#define sipName_y &sipStrings_QtGui[2910]
#define sipNameNr_x 20331
#define sipName_x &sipStrings_QtGui[20331]

#define sipMalloc                   sipAPI_QtGui->api_malloc
#define sipFree                     sipAPI_QtGui->api_free
#define sipBuildResult              sipAPI_QtGui->api_build_result
#define sipCallMethod               sipAPI_QtGui->api_call_method
#define sipParseResult              sipAPI_QtGui->api_parse_result
#define sipParseArgs                sipAPI_QtGui->api_parse_args
#define sipParsePair                sipAPI_QtGui->api_parse_pair
#define sipCommonDtor               sipAPI_QtGui->api_common_dtor
#define sipConvertFromSequenceIndex sipAPI_QtGui->api_convert_from_sequence_index
#define sipConvertFromVoidPtr       sipAPI_QtGui->api_convert_from_void_ptr
#define sipConvertToVoidPtr         sipAPI_QtGui->api_convert_to_void_ptr
#define sipNoFunction               sipAPI_QtGui->api_no_function
#define sipNoMethod                 sipAPI_QtGui->api_no_method
#define sipAbstractMethod           sipAPI_QtGui->api_abstract_method
#define sipBadClass                 sipAPI_QtGui->api_bad_class
#define sipBadCatcherResult         sipAPI_QtGui->api_bad_catcher_result
#define sipBadOperatorArg           sipAPI_QtGui->api_bad_operator_arg
#define sipTrace                    sipAPI_QtGui->api_trace
#define sipTransferBack             sipAPI_QtGui->api_transfer_back
#define sipTransferTo               sipAPI_QtGui->api_transfer_to
#define sipTransferBreak            sipAPI_QtGui->api_transfer_break
#define sipSimpleWrapper_Type       sipAPI_QtGui->api_simplewrapper_type
#define sipWrapper_Type             sipAPI_QtGui->api_wrapper_type
#define sipWrapperType_Type         sipAPI_QtGui->api_wrappertype_type
#define sipVoidPtr_Type             sipAPI_QtGui->api_voidptr_type
#define sipGetPyObject              sipAPI_QtGui->api_get_pyobject
#define sipGetCppPtr                sipAPI_QtGui->api_get_cpp_ptr
#define sipGetComplexCppPtr         sipAPI_QtGui->api_get_complex_cpp_ptr
#define sipIsPyMethod               sipAPI_QtGui->api_is_py_method
#define sipCallHook                 sipAPI_QtGui->api_call_hook
#define sipStartThread              sipAPI_QtGui->api_start_thread
#define sipEndThread                sipAPI_QtGui->api_end_thread
#define sipConnectRx                sipAPI_QtGui->api_connect_rx
#define sipDisconnectRx             sipAPI_QtGui->api_disconnect_rx
#define sipRaiseUnknownException    sipAPI_QtGui->api_raise_unknown_exception
#define sipRaiseTypeException       sipAPI_QtGui->api_raise_type_exception
#define sipBadLengthForSlice        sipAPI_QtGui->api_bad_length_for_slice
#define sipAddTypeInstance          sipAPI_QtGui->api_add_type_instance
#define sipGetAddress               sipAPI_QtGui->api_get_address
#define sipFreeSipslot              sipAPI_QtGui->api_free_sipslot
#define sipSameSlot                 sipAPI_QtGui->api_same_slot
#define sipPySlotExtend             sipAPI_QtGui->api_pyslot_extend
#define sipConvertRx                sipAPI_QtGui->api_convert_rx
#define sipAddDelayedDtor           sipAPI_QtGui->api_add_delayed_dtor
#define sipCanConvertToType         sipAPI_QtGui->api_can_convert_to_type
#define sipConvertToType            sipAPI_QtGui->api_convert_to_type
#define sipForceConvertToType       sipAPI_QtGui->api_force_convert_to_type
#define sipCanConvertToEnum         sipAPI_QtGui->api_can_convert_to_enum
#define sipReleaseType              sipAPI_QtGui->api_release_type
#define sipConvertFromType          sipAPI_QtGui->api_convert_from_type
#define sipConvertFromNewType       sipAPI_QtGui->api_convert_from_new_type
#define sipConvertFromEnum          sipAPI_QtGui->api_convert_from_enum
#define sipGetState                 sipAPI_QtGui->api_get_state
#define sipLong_AsUnsignedLong      sipAPI_QtGui->api_long_as_unsigned_long
#define sipExportSymbol             sipAPI_QtGui->api_export_symbol
#define sipImportSymbol             sipAPI_QtGui->api_import_symbol
#define sipFindType                 sipAPI_QtGui->api_find_type
#define sipFindNamedEnum            sipAPI_QtGui->api_find_named_enum
#define sipBytes_AsChar             sipAPI_QtGui->api_bytes_as_char
#define sipBytes_AsString           sipAPI_QtGui->api_bytes_as_string
#define sipString_AsASCIIChar       sipAPI_QtGui->api_string_as_ascii_char
#define sipString_AsASCIIString     sipAPI_QtGui->api_string_as_ascii_string
#define sipString_AsLatin1Char      sipAPI_QtGui->api_string_as_latin1_char
#define sipString_AsLatin1String    sipAPI_QtGui->api_string_as_latin1_string
#define sipString_AsUTF8Char        sipAPI_QtGui->api_string_as_utf8_char
#define sipString_AsUTF8String      sipAPI_QtGui->api_string_as_utf8_string
#define sipUnicode_AsWChar          sipAPI_QtGui->api_unicode_as_wchar
#define sipUnicode_AsWString        sipAPI_QtGui->api_unicode_as_wstring
#define sipConvertFromConstVoidPtr  sipAPI_QtGui->api_convert_from_const_void_ptr
#define sipConvertFromVoidPtrAndSize    sipAPI_QtGui->api_convert_from_void_ptr_and_size
#define sipConvertFromConstVoidPtrAndSize   sipAPI_QtGui->api_convert_from_const_void_ptr_and_size
#define sipInvokeSlot               sipAPI_QtGui->api_invoke_slot
#define sipSaveSlot                 sipAPI_QtGui->api_save_slot
#define sipClearAnySlotReference    sipAPI_QtGui->api_clear_any_slot_reference
#define sipVisitSlot                sipAPI_QtGui->api_visit_slot
#define sipWrappedTypeName(wt)      ((wt)->type->td_cname)
#define sipDeprecated               sipAPI_QtGui->api_deprecated
#define sipKeepReference            sipAPI_QtGui->api_keep_reference
#define sipRegisterPyType           sipAPI_QtGui->api_register_py_type
#define sipTypeFromPyTypeObject     sipAPI_QtGui->api_type_from_py_type_object
#define sipTypeScope                sipAPI_QtGui->api_type_scope
#define sipResolveTypedef           sipAPI_QtGui->api_resolve_typedef
#define sipRegisterAttributeGetter  sipAPI_QtGui->api_register_attribute_getter
#define sipIsAPIEnabled             sipAPI_QtGui->api_is_api_enabled
#define sipExportModule             sipAPI_QtGui->api_export_module
#define sipInitModule               sipAPI_QtGui->api_init_module

/* These are deprecated. */
#define sipMapStringToClass         sipAPI_QtGui->api_map_string_to_class
#define sipMapIntToClass            sipAPI_QtGui->api_map_int_to_class
#define sipFindClass                sipAPI_QtGui->api_find_class
#define sipFindMappedType           sipAPI_QtGui->api_find_mapped_type
#define sipWrapper_Check(w)         PyObject_TypeCheck((w), sipAPI_QtGui->api_wrapper_type)
#define sipGetWrapper(p, wt)        sipGetPyObject((p), (wt)->type)
#define sipReleaseInstance(p, wt, s)    sipReleaseType((p), (wt)->type, (s))
#define sipReleaseMappedType        sipReleaseType
#define sipCanConvertToInstance(o, wt, f)   sipCanConvertToType((o), (wt)->type, (f))
#define sipCanConvertToMappedType   sipCanConvertToType
#define sipConvertToInstance(o, wt, t, f, s, e)     sipConvertToType((o), (wt)->type, (t), (f), (s), (e))
#define sipConvertToMappedType      sipConvertToType
#define sipForceConvertToInstance(o, wt, t, f, s, e)    sipForceConvertToType((o), (wt)->type, (t), (f), (s), (e))
#define sipForceConvertToMappedType sipForceConvertToType
#define sipConvertFromInstance(p, wt, t)    sipConvertFromType((p), (wt)->type, (t))
#define sipConvertFromMappedType    sipConvertFromType
#define sipConvertFromNamedEnum(v, pt)  sipConvertFromEnum((v), ((sipEnumTypeObject *)(pt))->type)
#define sipConvertFromNewInstance(p, wt, t) sipConvertFromNewType((p), (wt)->type, (t))

/* The strings used by this module. */
extern const char sipStrings_QtGui[];

#define sipType_QtMsgType              sipModuleAPI_QtGui_QtCore->em_types[292]
#define sipEnum_QtMsgType              sipModuleAPI_QtGui_QtCore->em_types[292]->u.td_py_type

#define sipType_QPaintDevice              sipModuleAPI_QtGui.em_types[318]
#define sipClass_QPaintDevice             sipModuleAPI_QtGui.em_types[318]->u.td_wrapper_type

#define sipType_QPaintDevice_PaintDeviceMetric              sipModuleAPI_QtGui.em_types[319]
#define sipEnum_QPaintDevice_PaintDeviceMetric              sipModuleAPI_QtGui.em_types[319]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QPaintDevice;

#define sipType_QWidget              sipModuleAPI_QtGui.em_types[683]
#define sipClass_QWidget             sipModuleAPI_QtGui.em_types[683]->u.td_wrapper_type

#define sipType_QWidget_RenderFlag              sipModuleAPI_QtGui.em_types[684]
#define sipEnum_QWidget_RenderFlag              sipModuleAPI_QtGui.em_types[684]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QWidget;

#define sipType_QAbstractButton              sipModuleAPI_QtGui.em_types[1]
#define sipClass_QAbstractButton             sipModuleAPI_QtGui.em_types[1]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QAbstractButton;

#define sipType_QAbstractItemDelegate              sipModuleAPI_QtGui.em_types[3]
#define sipClass_QAbstractItemDelegate             sipModuleAPI_QtGui.em_types[3]->u.td_wrapper_type

#define sipType_QAbstractItemDelegate_EndEditHint              sipModuleAPI_QtGui.em_types[4]
#define sipEnum_QAbstractItemDelegate_EndEditHint              sipModuleAPI_QtGui.em_types[4]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QAbstractItemDelegate;

#define sipType_QFrame              sipModuleAPI_QtGui.em_types[139]
#define sipClass_QFrame             sipModuleAPI_QtGui.em_types[139]->u.td_wrapper_type

#define sipType_QFrame_StyleMask              sipModuleAPI_QtGui.em_types[142]
#define sipEnum_QFrame_StyleMask              sipModuleAPI_QtGui.em_types[142]->u.td_py_type
#define sipType_QFrame_Shape              sipModuleAPI_QtGui.em_types[141]
#define sipEnum_QFrame_Shape              sipModuleAPI_QtGui.em_types[141]->u.td_py_type
#define sipType_QFrame_Shadow              sipModuleAPI_QtGui.em_types[140]
#define sipEnum_QFrame_Shadow              sipModuleAPI_QtGui.em_types[140]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QFrame;

#define sipType_QAbstractScrollArea              sipModuleAPI_QtGui.em_types[21]
#define sipClass_QAbstractScrollArea             sipModuleAPI_QtGui.em_types[21]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QAbstractScrollArea;

#define sipType_QAbstractItemView              sipModuleAPI_QtGui.em_types[5]
#define sipClass_QAbstractItemView             sipModuleAPI_QtGui.em_types[5]->u.td_wrapper_type

#define sipType_QAbstractItemView_DropIndicatorPosition              sipModuleAPI_QtGui.em_types[8]
#define sipEnum_QAbstractItemView_DropIndicatorPosition              sipModuleAPI_QtGui.em_types[8]->u.td_py_type
#define sipType_QAbstractItemView_State              sipModuleAPI_QtGui.em_types[15]
#define sipEnum_QAbstractItemView_State              sipModuleAPI_QtGui.em_types[15]->u.td_py_type
#define sipType_QAbstractItemView_CursorAction              sipModuleAPI_QtGui.em_types[6]
#define sipEnum_QAbstractItemView_CursorAction              sipModuleAPI_QtGui.em_types[6]->u.td_py_type
#define sipType_QAbstractItemView_SelectionMode              sipModuleAPI_QtGui.em_types[14]
#define sipEnum_QAbstractItemView_SelectionMode              sipModuleAPI_QtGui.em_types[14]->u.td_py_type
#define sipType_QAbstractItemView_SelectionBehavior              sipModuleAPI_QtGui.em_types[13]
#define sipEnum_QAbstractItemView_SelectionBehavior              sipModuleAPI_QtGui.em_types[13]->u.td_py_type
#define sipType_QAbstractItemView_ScrollMode              sipModuleAPI_QtGui.em_types[12]
#define sipEnum_QAbstractItemView_ScrollMode              sipModuleAPI_QtGui.em_types[12]->u.td_py_type
#define sipType_QAbstractItemView_ScrollHint              sipModuleAPI_QtGui.em_types[11]
#define sipEnum_QAbstractItemView_ScrollHint              sipModuleAPI_QtGui.em_types[11]->u.td_py_type
#define sipType_QAbstractItemView_EditTrigger              sipModuleAPI_QtGui.em_types[9]
#define sipEnum_QAbstractItemView_EditTrigger              sipModuleAPI_QtGui.em_types[9]->u.td_py_type
#define sipType_QAbstractItemView_DragDropMode              sipModuleAPI_QtGui.em_types[7]
#define sipEnum_QAbstractItemView_DragDropMode              sipModuleAPI_QtGui.em_types[7]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QAbstractItemView;

#define sipType_QAbstractItemView_EditTriggers              sipModuleAPI_QtGui.em_types[10]
#define sipClass_QAbstractItemView_EditTriggers             sipModuleAPI_QtGui.em_types[10]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QAbstractItemView_EditTriggers;

#define sipType_QDialog              sipModuleAPI_QtGui.em_types[81]
#define sipClass_QDialog             sipModuleAPI_QtGui.em_types[81]->u.td_wrapper_type

#define sipType_QDialog_DialogCode              sipModuleAPI_QtGui.em_types[82]
#define sipEnum_QDialog_DialogCode              sipModuleAPI_QtGui.em_types[82]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QDialog;

#define sipType_QAbstractPrintDialog              sipModuleAPI_QtGui.em_types[16]
#define sipClass_QAbstractPrintDialog             sipModuleAPI_QtGui.em_types[16]->u.td_wrapper_type

#define sipType_QAbstractPrintDialog_PrintDialogOption              sipModuleAPI_QtGui.em_types[17]
#define sipEnum_QAbstractPrintDialog_PrintDialogOption              sipModuleAPI_QtGui.em_types[17]->u.td_py_type
#define sipType_QAbstractPrintDialog_PrintRange              sipModuleAPI_QtGui.em_types[19]
#define sipEnum_QAbstractPrintDialog_PrintRange              sipModuleAPI_QtGui.em_types[19]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QAbstractPrintDialog;

#define sipType_QAbstractPrintDialog_PrintDialogOptions              sipModuleAPI_QtGui.em_types[18]
#define sipClass_QAbstractPrintDialog_PrintDialogOptions             sipModuleAPI_QtGui.em_types[18]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QAbstractPrintDialog_PrintDialogOptions;

#define sipType_QAbstractProxyModel              sipModuleAPI_QtGui.em_types[20]
#define sipClass_QAbstractProxyModel             sipModuleAPI_QtGui.em_types[20]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QAbstractProxyModel;

#define sipType_QAbstractSpinBox              sipModuleAPI_QtGui.em_types[25]
#define sipClass_QAbstractSpinBox             sipModuleAPI_QtGui.em_types[25]->u.td_wrapper_type

#define sipType_QAbstractSpinBox_CorrectionMode              sipModuleAPI_QtGui.em_types[27]
#define sipEnum_QAbstractSpinBox_CorrectionMode              sipModuleAPI_QtGui.em_types[27]->u.td_py_type
#define sipType_QAbstractSpinBox_ButtonSymbols              sipModuleAPI_QtGui.em_types[26]
#define sipEnum_QAbstractSpinBox_ButtonSymbols              sipModuleAPI_QtGui.em_types[26]->u.td_py_type
#define sipType_QAbstractSpinBox_StepEnabledFlag              sipModuleAPI_QtGui.em_types[29]
#define sipEnum_QAbstractSpinBox_StepEnabledFlag              sipModuleAPI_QtGui.em_types[29]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QAbstractSpinBox;

#define sipType_QAbstractSpinBox_StepEnabled              sipModuleAPI_QtGui.em_types[28]
#define sipClass_QAbstractSpinBox_StepEnabled             sipModuleAPI_QtGui.em_types[28]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QAbstractSpinBox_StepEnabled;

#define sipType_QAbstractTextDocumentLayout              sipModuleAPI_QtGui.em_types[30]
#define sipClass_QAbstractTextDocumentLayout             sipModuleAPI_QtGui.em_types[30]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QAbstractTextDocumentLayout;

#define sipType_QAbstractTextDocumentLayout_Selection              sipModuleAPI_QtGui.em_types[32]
#define sipClass_QAbstractTextDocumentLayout_Selection             sipModuleAPI_QtGui.em_types[32]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QAbstractTextDocumentLayout_Selection;

#define sipType_QAbstractTextDocumentLayout_PaintContext              sipModuleAPI_QtGui.em_types[31]
#define sipClass_QAbstractTextDocumentLayout_PaintContext             sipModuleAPI_QtGui.em_types[31]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QAbstractTextDocumentLayout_PaintContext;

#define sipType_QTextObjectInterface              sipModuleAPI_QtGui.em_types[635]
#define sipClass_QTextObjectInterface             sipModuleAPI_QtGui.em_types[635]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTextObjectInterface;

#define sipType_QAbstractSlider              sipModuleAPI_QtGui.em_types[22]
#define sipClass_QAbstractSlider             sipModuleAPI_QtGui.em_types[22]->u.td_wrapper_type

#define sipType_QAbstractSlider_SliderChange              sipModuleAPI_QtGui.em_types[24]
#define sipEnum_QAbstractSlider_SliderChange              sipModuleAPI_QtGui.em_types[24]->u.td_py_type
#define sipType_QAbstractSlider_SliderAction              sipModuleAPI_QtGui.em_types[23]
#define sipEnum_QAbstractSlider_SliderAction              sipModuleAPI_QtGui.em_types[23]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QAbstractSlider;

#define sipType_QAction              sipModuleAPI_QtGui.em_types[33]
#define sipClass_QAction             sipModuleAPI_QtGui.em_types[33]->u.td_wrapper_type

#define sipType_QAction_MenuRole              sipModuleAPI_QtGui.em_types[35]
#define sipEnum_QAction_MenuRole              sipModuleAPI_QtGui.em_types[35]->u.td_py_type
#define sipType_QAction_ActionEvent              sipModuleAPI_QtGui.em_types[34]
#define sipEnum_QAction_ActionEvent              sipModuleAPI_QtGui.em_types[34]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QAction;

#define sipType_QActionGroup              sipModuleAPI_QtGui.em_types[37]
#define sipClass_QActionGroup             sipModuleAPI_QtGui.em_types[37]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QActionGroup;

#define sipType_QApplication              sipModuleAPI_QtGui.em_types[38]
#define sipClass_QApplication             sipModuleAPI_QtGui.em_types[38]->u.td_wrapper_type

#define sipType_QApplication_ColorSpec              sipModuleAPI_QtGui.em_types[39]
#define sipEnum_QApplication_ColorSpec              sipModuleAPI_QtGui.em_types[39]->u.td_py_type
#define sipType_QApplication_Type              sipModuleAPI_QtGui.em_types[40]
#define sipEnum_QApplication_Type              sipModuleAPI_QtGui.em_types[40]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QApplication;

#define sipType_QPixmap              sipModuleAPI_QtGui.em_types[343]
#define sipClass_QPixmap             sipModuleAPI_QtGui.em_types[343]->u.td_wrapper_type

#define sipType_QPixmap_ShareMode              sipModuleAPI_QtGui.em_types[344]
#define sipEnum_QPixmap_ShareMode              sipModuleAPI_QtGui.em_types[344]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QPixmap;

#define sipType_QBitmap              sipModuleAPI_QtGui.em_types[41]
#define sipClass_QBitmap             sipModuleAPI_QtGui.em_types[41]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QBitmap;

#define sipType_QLayoutItem              sipModuleAPI_QtGui.em_types[247]
#define sipClass_QLayoutItem             sipModuleAPI_QtGui.em_types[247]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QLayoutItem;

#define sipType_QLayout              sipModuleAPI_QtGui.em_types[245]
#define sipClass_QLayout             sipModuleAPI_QtGui.em_types[245]->u.td_wrapper_type

#define sipType_QLayout_SizeConstraint              sipModuleAPI_QtGui.em_types[246]
#define sipEnum_QLayout_SizeConstraint              sipModuleAPI_QtGui.em_types[246]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QLayout;

#define sipType_QBoxLayout              sipModuleAPI_QtGui.em_types[42]
#define sipClass_QBoxLayout             sipModuleAPI_QtGui.em_types[42]->u.td_wrapper_type

#define sipType_QBoxLayout_Direction              sipModuleAPI_QtGui.em_types[43]
#define sipEnum_QBoxLayout_Direction              sipModuleAPI_QtGui.em_types[43]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QBoxLayout;

#define sipType_QHBoxLayout              sipModuleAPI_QtGui.em_types[193]
#define sipClass_QHBoxLayout             sipModuleAPI_QtGui.em_types[193]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QHBoxLayout;

#define sipType_QVBoxLayout              sipModuleAPI_QtGui.em_types[666]
#define sipClass_QVBoxLayout             sipModuleAPI_QtGui.em_types[666]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QVBoxLayout;

#define sipType_QColor              sipModuleAPI_QtGui.em_types[54]
#define sipClass_QColor             sipModuleAPI_QtGui.em_types[54]->u.td_wrapper_type

#define sipType_QColor_Spec              sipModuleAPI_QtGui.em_types[55]
#define sipEnum_QColor_Spec              sipModuleAPI_QtGui.em_types[55]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QColor;

#define sipType_QPushButton              sipModuleAPI_QtGui.em_types[375]
#define sipClass_QPushButton             sipModuleAPI_QtGui.em_types[375]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QPushButton;

#define sipType_QCommandLinkButton              sipModuleAPI_QtGui.em_types[63]
#define sipClass_QCommandLinkButton             sipModuleAPI_QtGui.em_types[63]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QCommandLinkButton;

#define sipType_QBrush              sipModuleAPI_QtGui.em_types[44]
#define sipClass_QBrush             sipModuleAPI_QtGui.em_types[44]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QBrush;

#define sipType_QGradient              sipModuleAPI_QtGui.em_types[143]
#define sipClass_QGradient             sipModuleAPI_QtGui.em_types[143]->u.td_wrapper_type

#define sipType_QGradient_Spread              sipModuleAPI_QtGui.em_types[145]
#define sipEnum_QGradient_Spread              sipModuleAPI_QtGui.em_types[145]->u.td_py_type
#define sipType_QGradient_Type              sipModuleAPI_QtGui.em_types[146]
#define sipEnum_QGradient_Type              sipModuleAPI_QtGui.em_types[146]->u.td_py_type
#define sipType_QGradient_CoordinateMode              sipModuleAPI_QtGui.em_types[144]
#define sipEnum_QGradient_CoordinateMode              sipModuleAPI_QtGui.em_types[144]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QGradient;

#define sipType_QLinearGradient              sipModuleAPI_QtGui.em_types[250]
#define sipClass_QLinearGradient             sipModuleAPI_QtGui.em_types[250]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QLinearGradient;

#define sipType_QRadialGradient              sipModuleAPI_QtGui.em_types[377]
#define sipClass_QRadialGradient             sipModuleAPI_QtGui.em_types[377]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QRadialGradient;

#define sipType_QConicalGradient              sipModuleAPI_QtGui.em_types[67]
#define sipClass_QConicalGradient             sipModuleAPI_QtGui.em_types[67]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QConicalGradient;

#define sipType_QButtonGroup              sipModuleAPI_QtGui.em_types[45]
#define sipClass_QButtonGroup             sipModuleAPI_QtGui.em_types[45]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QButtonGroup;

#define sipType_QCalendarWidget              sipModuleAPI_QtGui.em_types[46]
#define sipClass_QCalendarWidget             sipModuleAPI_QtGui.em_types[46]->u.td_wrapper_type

#define sipType_QCalendarWidget_SelectionMode              sipModuleAPI_QtGui.em_types[48]
#define sipEnum_QCalendarWidget_SelectionMode              sipModuleAPI_QtGui.em_types[48]->u.td_py_type
#define sipType_QCalendarWidget_VerticalHeaderFormat              sipModuleAPI_QtGui.em_types[49]
#define sipEnum_QCalendarWidget_VerticalHeaderFormat              sipModuleAPI_QtGui.em_types[49]->u.td_py_type
#define sipType_QCalendarWidget_HorizontalHeaderFormat              sipModuleAPI_QtGui.em_types[47]
#define sipEnum_QCalendarWidget_HorizontalHeaderFormat              sipModuleAPI_QtGui.em_types[47]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QCalendarWidget;

#define sipType_QCheckBox              sipModuleAPI_QtGui.em_types[50]
#define sipClass_QCheckBox             sipModuleAPI_QtGui.em_types[50]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QCheckBox;

#define sipType_QClipboard              sipModuleAPI_QtGui.em_types[51]
#define sipClass_QClipboard             sipModuleAPI_QtGui.em_types[51]->u.td_wrapper_type

#define sipType_QClipboard_Mode              sipModuleAPI_QtGui.em_types[52]
#define sipEnum_QClipboard_Mode              sipModuleAPI_QtGui.em_types[52]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QClipboard;

#define sipType_QColumnView              sipModuleAPI_QtGui.em_types[59]
#define sipClass_QColumnView             sipModuleAPI_QtGui.em_types[59]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QColumnView;

#define sipType_QColorDialog              sipModuleAPI_QtGui.em_types[56]
#define sipClass_QColorDialog             sipModuleAPI_QtGui.em_types[56]->u.td_wrapper_type

#define sipType_QColorDialog_ColorDialogOption              sipModuleAPI_QtGui.em_types[57]
#define sipEnum_QColorDialog_ColorDialogOption              sipModuleAPI_QtGui.em_types[57]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QColorDialog;

#define sipType_QColorDialog_ColorDialogOptions              sipModuleAPI_QtGui.em_types[58]
#define sipClass_QColorDialog_ColorDialogOptions             sipModuleAPI_QtGui.em_types[58]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QColorDialog_ColorDialogOptions;

#define sipType_QComboBox              sipModuleAPI_QtGui.em_types[60]
#define sipClass_QComboBox             sipModuleAPI_QtGui.em_types[60]->u.td_wrapper_type

#define sipType_QComboBox_SizeAdjustPolicy              sipModuleAPI_QtGui.em_types[62]
#define sipEnum_QComboBox_SizeAdjustPolicy              sipModuleAPI_QtGui.em_types[62]->u.td_py_type
#define sipType_QComboBox_InsertPolicy              sipModuleAPI_QtGui.em_types[61]
#define sipEnum_QComboBox_InsertPolicy              sipModuleAPI_QtGui.em_types[61]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QComboBox;

#define sipType_QCompleter              sipModuleAPI_QtGui.em_types[64]
#define sipClass_QCompleter             sipModuleAPI_QtGui.em_types[64]->u.td_wrapper_type

#define sipType_QCompleter_ModelSorting              sipModuleAPI_QtGui.em_types[66]
#define sipEnum_QCompleter_ModelSorting              sipModuleAPI_QtGui.em_types[66]->u.td_py_type
#define sipType_QCompleter_CompletionMode              sipModuleAPI_QtGui.em_types[65]
#define sipEnum_QCompleter_CompletionMode              sipModuleAPI_QtGui.em_types[65]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QCompleter;

#define sipType_QCursor              sipModuleAPI_QtGui.em_types[70]
#define sipClass_QCursor             sipModuleAPI_QtGui.em_types[70]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QCursor;

#define sipType_QDataWidgetMapper              sipModuleAPI_QtGui.em_types[71]
#define sipClass_QDataWidgetMapper             sipModuleAPI_QtGui.em_types[71]->u.td_wrapper_type

#define sipType_QDataWidgetMapper_SubmitPolicy              sipModuleAPI_QtGui.em_types[72]
#define sipEnum_QDataWidgetMapper_SubmitPolicy              sipModuleAPI_QtGui.em_types[72]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QDataWidgetMapper;

#define sipType_QDateTimeEdit              sipModuleAPI_QtGui.em_types[74]
#define sipClass_QDateTimeEdit             sipModuleAPI_QtGui.em_types[74]->u.td_wrapper_type

#define sipType_QDateTimeEdit_Section              sipModuleAPI_QtGui.em_types[75]
#define sipEnum_QDateTimeEdit_Section              sipModuleAPI_QtGui.em_types[75]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QDateTimeEdit;

#define sipType_QDateTimeEdit_Sections              sipModuleAPI_QtGui.em_types[76]
#define sipClass_QDateTimeEdit_Sections             sipModuleAPI_QtGui.em_types[76]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QDateTimeEdit_Sections;

#define sipType_QTimeEdit              sipModuleAPI_QtGui.em_types[646]
#define sipClass_QTimeEdit             sipModuleAPI_QtGui.em_types[646]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTimeEdit;

#define sipType_QDateEdit              sipModuleAPI_QtGui.em_types[73]
#define sipClass_QDateEdit             sipModuleAPI_QtGui.em_types[73]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QDateEdit;

#define sipType_QDesktopServices              sipModuleAPI_QtGui.em_types[77]
#define sipClass_QDesktopServices             sipModuleAPI_QtGui.em_types[77]->u.td_wrapper_type

#define sipType_QDesktopServices_StandardLocation              sipModuleAPI_QtGui.em_types[78]
#define sipEnum_QDesktopServices_StandardLocation              sipModuleAPI_QtGui.em_types[78]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QDesktopServices;

#define sipType_QDesktopWidget              sipModuleAPI_QtGui.em_types[79]
#define sipClass_QDesktopWidget             sipModuleAPI_QtGui.em_types[79]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QDesktopWidget;

#define sipType_QDial              sipModuleAPI_QtGui.em_types[80]
#define sipClass_QDial             sipModuleAPI_QtGui.em_types[80]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QDial;

#define sipType_QDialogButtonBox              sipModuleAPI_QtGui.em_types[83]
#define sipClass_QDialogButtonBox             sipModuleAPI_QtGui.em_types[83]->u.td_wrapper_type

#define sipType_QDialogButtonBox_StandardButton              sipModuleAPI_QtGui.em_types[86]
#define sipEnum_QDialogButtonBox_StandardButton              sipModuleAPI_QtGui.em_types[86]->u.td_py_type
#define sipType_QDialogButtonBox_ButtonRole              sipModuleAPI_QtGui.em_types[85]
#define sipEnum_QDialogButtonBox_ButtonRole              sipModuleAPI_QtGui.em_types[85]->u.td_py_type
#define sipType_QDialogButtonBox_ButtonLayout              sipModuleAPI_QtGui.em_types[84]
#define sipEnum_QDialogButtonBox_ButtonLayout              sipModuleAPI_QtGui.em_types[84]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QDialogButtonBox;

#define sipType_QDialogButtonBox_StandardButtons              sipModuleAPI_QtGui.em_types[87]
#define sipClass_QDialogButtonBox_StandardButtons             sipModuleAPI_QtGui.em_types[87]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QDialogButtonBox_StandardButtons;

#define sipType_QDirModel              sipModuleAPI_QtGui.em_types[88]
#define sipClass_QDirModel             sipModuleAPI_QtGui.em_types[88]->u.td_wrapper_type

#define sipType_QDirModel_Roles              sipModuleAPI_QtGui.em_types[89]
#define sipEnum_QDirModel_Roles              sipModuleAPI_QtGui.em_types[89]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QDirModel;

#define sipType_QDockWidget              sipModuleAPI_QtGui.em_types[90]
#define sipClass_QDockWidget             sipModuleAPI_QtGui.em_types[90]->u.td_wrapper_type

#define sipType_QDockWidget_DockWidgetFeature              sipModuleAPI_QtGui.em_types[91]
#define sipEnum_QDockWidget_DockWidgetFeature              sipModuleAPI_QtGui.em_types[91]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QDockWidget;

#define sipType_QDockWidget_DockWidgetFeatures              sipModuleAPI_QtGui.em_types[92]
#define sipClass_QDockWidget_DockWidgetFeatures             sipModuleAPI_QtGui.em_types[92]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QDockWidget_DockWidgetFeatures;

#define sipType_QDrag              sipModuleAPI_QtGui.em_types[96]
#define sipClass_QDrag             sipModuleAPI_QtGui.em_types[96]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QDrag;

#define sipType_QErrorMessage              sipModuleAPI_QtGui.em_types[101]
#define sipClass_QErrorMessage             sipModuleAPI_QtGui.em_types[101]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QErrorMessage;

#define sipType_QInputEvent              sipModuleAPI_QtGui.em_types[223]
#define sipClass_QInputEvent             sipModuleAPI_QtGui.em_types[223]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QInputEvent;

#define sipType_QMouseEvent              sipModuleAPI_QtGui.em_types[310]
#define sipClass_QMouseEvent             sipModuleAPI_QtGui.em_types[310]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QMouseEvent;

#define sipType_QHoverEvent              sipModuleAPI_QtGui.em_types[198]
#define sipClass_QHoverEvent             sipModuleAPI_QtGui.em_types[198]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QHoverEvent;

#define sipType_QWheelEvent              sipModuleAPI_QtGui.em_types[682]
#define sipClass_QWheelEvent             sipModuleAPI_QtGui.em_types[682]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QWheelEvent;

#define sipType_QTabletEvent              sipModuleAPI_QtGui.em_types[578]
#define sipClass_QTabletEvent             sipModuleAPI_QtGui.em_types[578]->u.td_wrapper_type

#define sipType_QTabletEvent_PointerType              sipModuleAPI_QtGui.em_types[579]
#define sipEnum_QTabletEvent_PointerType              sipModuleAPI_QtGui.em_types[579]->u.td_py_type
#define sipType_QTabletEvent_TabletDevice              sipModuleAPI_QtGui.em_types[580]
#define sipEnum_QTabletEvent_TabletDevice              sipModuleAPI_QtGui.em_types[580]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTabletEvent;

#define sipType_QKeyEvent              sipModuleAPI_QtGui.em_types[236]
#define sipClass_QKeyEvent             sipModuleAPI_QtGui.em_types[236]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QKeyEvent;

#define sipType_QFocusEvent              sipModuleAPI_QtGui.em_types[114]
#define sipClass_QFocusEvent             sipModuleAPI_QtGui.em_types[114]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QFocusEvent;

#define sipType_QPaintEvent              sipModuleAPI_QtGui.em_types[328]
#define sipClass_QPaintEvent             sipModuleAPI_QtGui.em_types[328]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QPaintEvent;

#define sipType_QMoveEvent              sipModuleAPI_QtGui.em_types[311]
#define sipClass_QMoveEvent             sipModuleAPI_QtGui.em_types[311]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QMoveEvent;

#define sipType_QResizeEvent              sipModuleAPI_QtGui.em_types[382]
#define sipClass_QResizeEvent             sipModuleAPI_QtGui.em_types[382]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QResizeEvent;

#define sipType_QCloseEvent              sipModuleAPI_QtGui.em_types[53]
#define sipClass_QCloseEvent             sipModuleAPI_QtGui.em_types[53]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QCloseEvent;

#define sipType_QIconDragEvent              sipModuleAPI_QtGui.em_types[202]
#define sipClass_QIconDragEvent             sipModuleAPI_QtGui.em_types[202]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QIconDragEvent;

#define sipType_QShowEvent              sipModuleAPI_QtGui.em_types[391]
#define sipClass_QShowEvent             sipModuleAPI_QtGui.em_types[391]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QShowEvent;

#define sipType_QHideEvent              sipModuleAPI_QtGui.em_types[197]
#define sipClass_QHideEvent             sipModuleAPI_QtGui.em_types[197]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QHideEvent;

#define sipType_QContextMenuEvent              sipModuleAPI_QtGui.em_types[68]
#define sipClass_QContextMenuEvent             sipModuleAPI_QtGui.em_types[68]->u.td_wrapper_type

#define sipType_QContextMenuEvent_Reason              sipModuleAPI_QtGui.em_types[69]
#define sipEnum_QContextMenuEvent_Reason              sipModuleAPI_QtGui.em_types[69]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QContextMenuEvent;

#define sipType_QInputMethodEvent              sipModuleAPI_QtGui.em_types[224]
#define sipClass_QInputMethodEvent             sipModuleAPI_QtGui.em_types[224]->u.td_wrapper_type

#define sipType_QInputMethodEvent_AttributeType              sipModuleAPI_QtGui.em_types[226]
#define sipEnum_QInputMethodEvent_AttributeType              sipModuleAPI_QtGui.em_types[226]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QInputMethodEvent;

#define sipType_QInputMethodEvent_Attribute              sipModuleAPI_QtGui.em_types[225]
#define sipClass_QInputMethodEvent_Attribute             sipModuleAPI_QtGui.em_types[225]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QInputMethodEvent_Attribute;

#define sipType_QMimeSource              sipModuleAPI_QtGui.em_types[309]
#define sipClass_QMimeSource             sipModuleAPI_QtGui.em_types[309]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QMimeSource;

#define sipType_QDropEvent              sipModuleAPI_QtGui.em_types[100]
#define sipClass_QDropEvent             sipModuleAPI_QtGui.em_types[100]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QDropEvent;

#define sipType_QDragMoveEvent              sipModuleAPI_QtGui.em_types[99]
#define sipClass_QDragMoveEvent             sipModuleAPI_QtGui.em_types[99]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QDragMoveEvent;

#define sipType_QDragEnterEvent              sipModuleAPI_QtGui.em_types[97]
#define sipClass_QDragEnterEvent             sipModuleAPI_QtGui.em_types[97]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QDragEnterEvent;

#define sipType_QDragLeaveEvent              sipModuleAPI_QtGui.em_types[98]
#define sipClass_QDragLeaveEvent             sipModuleAPI_QtGui.em_types[98]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QDragLeaveEvent;

#define sipType_QHelpEvent              sipModuleAPI_QtGui.em_types[196]
#define sipClass_QHelpEvent             sipModuleAPI_QtGui.em_types[196]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QHelpEvent;

#define sipType_QStatusTipEvent              sipModuleAPI_QtGui.em_types[414]
#define sipClass_QStatusTipEvent             sipModuleAPI_QtGui.em_types[414]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStatusTipEvent;

#define sipType_QWhatsThisClickedEvent              sipModuleAPI_QtGui.em_types[681]
#define sipClass_QWhatsThisClickedEvent             sipModuleAPI_QtGui.em_types[681]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QWhatsThisClickedEvent;

#define sipType_QActionEvent              sipModuleAPI_QtGui.em_types[36]
#define sipClass_QActionEvent             sipModuleAPI_QtGui.em_types[36]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QActionEvent;

#define sipType_QFileOpenEvent              sipModuleAPI_QtGui.em_types[111]
#define sipClass_QFileOpenEvent             sipModuleAPI_QtGui.em_types[111]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QFileOpenEvent;

#define sipType_QShortcutEvent              sipModuleAPI_QtGui.em_types[390]
#define sipClass_QShortcutEvent             sipModuleAPI_QtGui.em_types[390]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QShortcutEvent;

#define sipType_QWindowStateChangeEvent              sipModuleAPI_QtGui.em_types[688]
#define sipClass_QWindowStateChangeEvent             sipModuleAPI_QtGui.em_types[688]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QWindowStateChangeEvent;

#define sipType_QFileDialog              sipModuleAPI_QtGui.em_types[102]
#define sipClass_QFileDialog             sipModuleAPI_QtGui.em_types[102]->u.td_wrapper_type

#define sipType_QFileDialog_Option              sipModuleAPI_QtGui.em_types[106]
#define sipEnum_QFileDialog_Option              sipModuleAPI_QtGui.em_types[106]->u.td_py_type
#define sipType_QFileDialog_DialogLabel              sipModuleAPI_QtGui.em_types[104]
#define sipEnum_QFileDialog_DialogLabel              sipModuleAPI_QtGui.em_types[104]->u.td_py_type
#define sipType_QFileDialog_AcceptMode              sipModuleAPI_QtGui.em_types[103]
#define sipEnum_QFileDialog_AcceptMode              sipModuleAPI_QtGui.em_types[103]->u.td_py_type
#define sipType_QFileDialog_FileMode              sipModuleAPI_QtGui.em_types[105]
#define sipEnum_QFileDialog_FileMode              sipModuleAPI_QtGui.em_types[105]->u.td_py_type
#define sipType_QFileDialog_ViewMode              sipModuleAPI_QtGui.em_types[108]
#define sipEnum_QFileDialog_ViewMode              sipModuleAPI_QtGui.em_types[108]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QFileDialog;

#define sipType_QFileDialog_Options              sipModuleAPI_QtGui.em_types[107]
#define sipClass_QFileDialog_Options             sipModuleAPI_QtGui.em_types[107]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QFileDialog_Options;

#define sipType_QFileIconProvider              sipModuleAPI_QtGui.em_types[109]
#define sipClass_QFileIconProvider             sipModuleAPI_QtGui.em_types[109]->u.td_wrapper_type

#define sipType_QFileIconProvider_IconType              sipModuleAPI_QtGui.em_types[110]
#define sipEnum_QFileIconProvider_IconType              sipModuleAPI_QtGui.em_types[110]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QFileIconProvider;

#define sipType_QFileSystemModel              sipModuleAPI_QtGui.em_types[112]
#define sipClass_QFileSystemModel             sipModuleAPI_QtGui.em_types[112]->u.td_wrapper_type

#define sipType_QFileSystemModel_Roles              sipModuleAPI_QtGui.em_types[113]
#define sipEnum_QFileSystemModel_Roles              sipModuleAPI_QtGui.em_types[113]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QFileSystemModel;

#define sipType_QFocusFrame              sipModuleAPI_QtGui.em_types[115]
#define sipClass_QFocusFrame             sipModuleAPI_QtGui.em_types[115]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QFocusFrame;

#define sipType_QFont              sipModuleAPI_QtGui.em_types[116]
#define sipClass_QFont             sipModuleAPI_QtGui.em_types[116]->u.td_wrapper_type

#define sipType_QFont_SpacingType              sipModuleAPI_QtGui.em_types[118]
#define sipEnum_QFont_SpacingType              sipModuleAPI_QtGui.em_types[118]->u.td_py_type
#define sipType_QFont_Capitalization              sipModuleAPI_QtGui.em_types[117]
#define sipEnum_QFont_Capitalization              sipModuleAPI_QtGui.em_types[117]->u.td_py_type
#define sipType_QFont_Stretch              sipModuleAPI_QtGui.em_types[119]
#define sipEnum_QFont_Stretch              sipModuleAPI_QtGui.em_types[119]->u.td_py_type
#define sipType_QFont_Style              sipModuleAPI_QtGui.em_types[120]
#define sipEnum_QFont_Style              sipModuleAPI_QtGui.em_types[120]->u.td_py_type
#define sipType_QFont_Weight              sipModuleAPI_QtGui.em_types[123]
#define sipEnum_QFont_Weight              sipModuleAPI_QtGui.em_types[123]->u.td_py_type
#define sipType_QFont_StyleStrategy              sipModuleAPI_QtGui.em_types[122]
#define sipEnum_QFont_StyleStrategy              sipModuleAPI_QtGui.em_types[122]->u.td_py_type
#define sipType_QFont_StyleHint              sipModuleAPI_QtGui.em_types[121]
#define sipEnum_QFont_StyleHint              sipModuleAPI_QtGui.em_types[121]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QFont;

#define sipType_QFontComboBox              sipModuleAPI_QtGui.em_types[124]
#define sipClass_QFontComboBox             sipModuleAPI_QtGui.em_types[124]->u.td_wrapper_type

#define sipType_QFontComboBox_FontFilter              sipModuleAPI_QtGui.em_types[125]
#define sipEnum_QFontComboBox_FontFilter              sipModuleAPI_QtGui.em_types[125]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QFontComboBox;

#define sipType_QFontComboBox_FontFilters              sipModuleAPI_QtGui.em_types[126]
#define sipClass_QFontComboBox_FontFilters             sipModuleAPI_QtGui.em_types[126]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QFontComboBox_FontFilters;

#define sipType_QFontDatabase              sipModuleAPI_QtGui.em_types[127]
#define sipClass_QFontDatabase             sipModuleAPI_QtGui.em_types[127]->u.td_wrapper_type

#define sipType_QFontDatabase_WritingSystem              sipModuleAPI_QtGui.em_types[128]
#define sipEnum_QFontDatabase_WritingSystem              sipModuleAPI_QtGui.em_types[128]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QFontDatabase;

#define sipType_QFontDialog              sipModuleAPI_QtGui.em_types[129]
#define sipClass_QFontDialog             sipModuleAPI_QtGui.em_types[129]->u.td_wrapper_type

#define sipType_QFontDialog_FontDialogOption              sipModuleAPI_QtGui.em_types[130]
#define sipEnum_QFontDialog_FontDialogOption              sipModuleAPI_QtGui.em_types[130]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QFontDialog;

#define sipType_QFontDialog_FontDialogOptions              sipModuleAPI_QtGui.em_types[131]
#define sipClass_QFontDialog_FontDialogOptions             sipModuleAPI_QtGui.em_types[131]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QFontDialog_FontDialogOptions;

#define sipType_QFontInfo              sipModuleAPI_QtGui.em_types[132]
#define sipClass_QFontInfo             sipModuleAPI_QtGui.em_types[132]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QFontInfo;

#define sipType_QFontMetrics              sipModuleAPI_QtGui.em_types[133]
#define sipClass_QFontMetrics             sipModuleAPI_QtGui.em_types[133]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QFontMetrics;

#define sipType_QFontMetricsF              sipModuleAPI_QtGui.em_types[134]
#define sipClass_QFontMetricsF             sipModuleAPI_QtGui.em_types[134]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QFontMetricsF;

#define sipType_QFormLayout              sipModuleAPI_QtGui.em_types[135]
#define sipClass_QFormLayout             sipModuleAPI_QtGui.em_types[135]->u.td_wrapper_type

#define sipType_QFormLayout_ItemRole              sipModuleAPI_QtGui.em_types[137]
#define sipEnum_QFormLayout_ItemRole              sipModuleAPI_QtGui.em_types[137]->u.td_py_type
#define sipType_QFormLayout_RowWrapPolicy              sipModuleAPI_QtGui.em_types[138]
#define sipEnum_QFormLayout_RowWrapPolicy              sipModuleAPI_QtGui.em_types[138]->u.td_py_type
#define sipType_QFormLayout_FieldGrowthPolicy              sipModuleAPI_QtGui.em_types[136]
#define sipEnum_QFormLayout_FieldGrowthPolicy              sipModuleAPI_QtGui.em_types[136]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QFormLayout;

#define sipType_QGraphicsLayoutItem              sipModuleAPI_QtGui.em_types[157]
#define sipClass_QGraphicsLayoutItem             sipModuleAPI_QtGui.em_types[157]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QGraphicsLayoutItem;

#define sipType_QGraphicsLayout              sipModuleAPI_QtGui.em_types[156]
#define sipClass_QGraphicsLayout             sipModuleAPI_QtGui.em_types[156]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QGraphicsLayout;

#define sipType_QGraphicsGridLayout              sipModuleAPI_QtGui.em_types[148]
#define sipClass_QGraphicsGridLayout             sipModuleAPI_QtGui.em_types[148]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QGraphicsGridLayout;

#define sipType_QGraphicsItem              sipModuleAPI_QtGui.em_types[149]
#define sipClass_QGraphicsItem             sipModuleAPI_QtGui.em_types[149]->u.td_wrapper_type

#define sipType_QGraphicsItem_GraphicsItemFlag              sipModuleAPI_QtGui.em_types[152]
#define sipEnum_QGraphicsItem_GraphicsItemFlag              sipModuleAPI_QtGui.em_types[152]->u.td_py_type
#define sipType_QGraphicsItem_GraphicsItemChange              sipModuleAPI_QtGui.em_types[151]
#define sipEnum_QGraphicsItem_GraphicsItemChange              sipModuleAPI_QtGui.em_types[151]->u.td_py_type
#define sipType_QGraphicsItem_CacheMode              sipModuleAPI_QtGui.em_types[150]
#define sipEnum_QGraphicsItem_CacheMode              sipModuleAPI_QtGui.em_types[150]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QGraphicsItem;

#define sipType_QGraphicsItem_GraphicsItemFlags              sipModuleAPI_QtGui.em_types[153]
#define sipClass_QGraphicsItem_GraphicsItemFlags             sipModuleAPI_QtGui.em_types[153]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QGraphicsItem_GraphicsItemFlags;

#define sipType_QAbstractGraphicsShapeItem              sipModuleAPI_QtGui.em_types[2]
#define sipClass_QAbstractGraphicsShapeItem             sipModuleAPI_QtGui.em_types[2]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QAbstractGraphicsShapeItem;

#define sipType_QGraphicsPathItem              sipModuleAPI_QtGui.em_types[160]
#define sipClass_QGraphicsPathItem             sipModuleAPI_QtGui.em_types[160]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QGraphicsPathItem;

#define sipType_QGraphicsRectItem              sipModuleAPI_QtGui.em_types[165]
#define sipClass_QGraphicsRectItem             sipModuleAPI_QtGui.em_types[165]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QGraphicsRectItem;

#define sipType_QGraphicsEllipseItem              sipModuleAPI_QtGui.em_types[147]
#define sipClass_QGraphicsEllipseItem             sipModuleAPI_QtGui.em_types[147]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QGraphicsEllipseItem;

#define sipType_QGraphicsPolygonItem              sipModuleAPI_QtGui.em_types[163]
#define sipClass_QGraphicsPolygonItem             sipModuleAPI_QtGui.em_types[163]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QGraphicsPolygonItem;

#define sipType_QGraphicsLineItem              sipModuleAPI_QtGui.em_types[158]
#define sipClass_QGraphicsLineItem             sipModuleAPI_QtGui.em_types[158]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QGraphicsLineItem;

#define sipType_QGraphicsPixmapItem              sipModuleAPI_QtGui.em_types[161]
#define sipClass_QGraphicsPixmapItem             sipModuleAPI_QtGui.em_types[161]->u.td_wrapper_type

#define sipType_QGraphicsPixmapItem_ShapeMode              sipModuleAPI_QtGui.em_types[162]
#define sipEnum_QGraphicsPixmapItem_ShapeMode              sipModuleAPI_QtGui.em_types[162]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QGraphicsPixmapItem;

#define sipType_QGraphicsTextItem              sipModuleAPI_QtGui.em_types[181]
#define sipClass_QGraphicsTextItem             sipModuleAPI_QtGui.em_types[181]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QGraphicsTextItem;

#define sipType_QGraphicsSimpleTextItem              sipModuleAPI_QtGui.em_types[180]
#define sipClass_QGraphicsSimpleTextItem             sipModuleAPI_QtGui.em_types[180]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QGraphicsSimpleTextItem;

#define sipType_QGraphicsItemGroup              sipModuleAPI_QtGui.em_types[155]
#define sipClass_QGraphicsItemGroup             sipModuleAPI_QtGui.em_types[155]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QGraphicsItemGroup;

#define sipType_QGraphicsItemAnimation              sipModuleAPI_QtGui.em_types[154]
#define sipClass_QGraphicsItemAnimation             sipModuleAPI_QtGui.em_types[154]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QGraphicsItemAnimation;

#define sipType_QGraphicsLinearLayout              sipModuleAPI_QtGui.em_types[159]
#define sipClass_QGraphicsLinearLayout             sipModuleAPI_QtGui.em_types[159]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QGraphicsLinearLayout;

#define sipType_QGraphicsWidget              sipModuleAPI_QtGui.em_types[190]
#define sipClass_QGraphicsWidget             sipModuleAPI_QtGui.em_types[190]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QGraphicsWidget;

#define sipType_QGraphicsProxyWidget              sipModuleAPI_QtGui.em_types[164]
#define sipClass_QGraphicsProxyWidget             sipModuleAPI_QtGui.em_types[164]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QGraphicsProxyWidget;

#define sipType_QGraphicsScene              sipModuleAPI_QtGui.em_types[166]
#define sipClass_QGraphicsScene             sipModuleAPI_QtGui.em_types[166]->u.td_wrapper_type

#define sipType_QGraphicsScene_SceneLayer              sipModuleAPI_QtGui.em_types[168]
#define sipEnum_QGraphicsScene_SceneLayer              sipModuleAPI_QtGui.em_types[168]->u.td_py_type
#define sipType_QGraphicsScene_ItemIndexMethod              sipModuleAPI_QtGui.em_types[167]
#define sipEnum_QGraphicsScene_ItemIndexMethod              sipModuleAPI_QtGui.em_types[167]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QGraphicsScene;

#define sipType_QGraphicsScene_SceneLayers              sipModuleAPI_QtGui.em_types[169]
#define sipClass_QGraphicsScene_SceneLayers             sipModuleAPI_QtGui.em_types[169]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QGraphicsScene_SceneLayers;

#define sipType_QGraphicsSceneEvent              sipModuleAPI_QtGui.em_types[173]
#define sipClass_QGraphicsSceneEvent             sipModuleAPI_QtGui.em_types[173]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QGraphicsSceneEvent;

#define sipType_QGraphicsSceneMouseEvent              sipModuleAPI_QtGui.em_types[176]
#define sipClass_QGraphicsSceneMouseEvent             sipModuleAPI_QtGui.em_types[176]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QGraphicsSceneMouseEvent;

#define sipType_QGraphicsSceneWheelEvent              sipModuleAPI_QtGui.em_types[179]
#define sipClass_QGraphicsSceneWheelEvent             sipModuleAPI_QtGui.em_types[179]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QGraphicsSceneWheelEvent;

#define sipType_QGraphicsSceneContextMenuEvent              sipModuleAPI_QtGui.em_types[170]
#define sipClass_QGraphicsSceneContextMenuEvent             sipModuleAPI_QtGui.em_types[170]->u.td_wrapper_type

#define sipType_QGraphicsSceneContextMenuEvent_Reason              sipModuleAPI_QtGui.em_types[171]
#define sipEnum_QGraphicsSceneContextMenuEvent_Reason              sipModuleAPI_QtGui.em_types[171]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QGraphicsSceneContextMenuEvent;

#define sipType_QGraphicsSceneHoverEvent              sipModuleAPI_QtGui.em_types[175]
#define sipClass_QGraphicsSceneHoverEvent             sipModuleAPI_QtGui.em_types[175]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QGraphicsSceneHoverEvent;

#define sipType_QGraphicsSceneHelpEvent              sipModuleAPI_QtGui.em_types[174]
#define sipClass_QGraphicsSceneHelpEvent             sipModuleAPI_QtGui.em_types[174]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QGraphicsSceneHelpEvent;

#define sipType_QGraphicsSceneDragDropEvent              sipModuleAPI_QtGui.em_types[172]
#define sipClass_QGraphicsSceneDragDropEvent             sipModuleAPI_QtGui.em_types[172]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QGraphicsSceneDragDropEvent;

#define sipType_QGraphicsSceneResizeEvent              sipModuleAPI_QtGui.em_types[178]
#define sipClass_QGraphicsSceneResizeEvent             sipModuleAPI_QtGui.em_types[178]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QGraphicsSceneResizeEvent;

#define sipType_QGraphicsSceneMoveEvent              sipModuleAPI_QtGui.em_types[177]
#define sipClass_QGraphicsSceneMoveEvent             sipModuleAPI_QtGui.em_types[177]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QGraphicsSceneMoveEvent;

#define sipType_QGraphicsView              sipModuleAPI_QtGui.em_types[182]
#define sipClass_QGraphicsView             sipModuleAPI_QtGui.em_types[182]->u.td_wrapper_type

#define sipType_QGraphicsView_OptimizationFlag              sipModuleAPI_QtGui.em_types[186]
#define sipEnum_QGraphicsView_OptimizationFlag              sipModuleAPI_QtGui.em_types[186]->u.td_py_type
#define sipType_QGraphicsView_ViewportUpdateMode              sipModuleAPI_QtGui.em_types[189]
#define sipEnum_QGraphicsView_ViewportUpdateMode              sipModuleAPI_QtGui.em_types[189]->u.td_py_type
#define sipType_QGraphicsView_ViewportAnchor              sipModuleAPI_QtGui.em_types[188]
#define sipEnum_QGraphicsView_ViewportAnchor              sipModuleAPI_QtGui.em_types[188]->u.td_py_type
#define sipType_QGraphicsView_DragMode              sipModuleAPI_QtGui.em_types[185]
#define sipEnum_QGraphicsView_DragMode              sipModuleAPI_QtGui.em_types[185]->u.td_py_type
#define sipType_QGraphicsView_CacheModeFlag              sipModuleAPI_QtGui.em_types[184]
#define sipEnum_QGraphicsView_CacheModeFlag              sipModuleAPI_QtGui.em_types[184]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QGraphicsView;

#define sipType_QGraphicsView_CacheMode              sipModuleAPI_QtGui.em_types[183]
#define sipClass_QGraphicsView_CacheMode             sipModuleAPI_QtGui.em_types[183]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QGraphicsView_CacheMode;

#define sipType_QGraphicsView_OptimizationFlags              sipModuleAPI_QtGui.em_types[187]
#define sipClass_QGraphicsView_OptimizationFlags             sipModuleAPI_QtGui.em_types[187]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QGraphicsView_OptimizationFlags;

#define sipType_QGridLayout              sipModuleAPI_QtGui.em_types[191]
#define sipClass_QGridLayout             sipModuleAPI_QtGui.em_types[191]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QGridLayout;

#define sipType_QGroupBox              sipModuleAPI_QtGui.em_types[192]
#define sipClass_QGroupBox             sipModuleAPI_QtGui.em_types[192]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QGroupBox;

#define sipType_QHeaderView              sipModuleAPI_QtGui.em_types[194]
#define sipClass_QHeaderView             sipModuleAPI_QtGui.em_types[194]->u.td_wrapper_type

#define sipType_QHeaderView_ResizeMode              sipModuleAPI_QtGui.em_types[195]
#define sipEnum_QHeaderView_ResizeMode              sipModuleAPI_QtGui.em_types[195]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QHeaderView;

#define sipType_QIcon              sipModuleAPI_QtGui.em_types[199]
#define sipClass_QIcon             sipModuleAPI_QtGui.em_types[199]->u.td_wrapper_type

#define sipType_QIcon_State              sipModuleAPI_QtGui.em_types[201]
#define sipEnum_QIcon_State              sipModuleAPI_QtGui.em_types[201]->u.td_py_type
#define sipType_QIcon_Mode              sipModuleAPI_QtGui.em_types[200]
#define sipEnum_QIcon_Mode              sipModuleAPI_QtGui.em_types[200]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QIcon;

#define sipType_QIconEngine              sipModuleAPI_QtGui.em_types[203]
#define sipClass_QIconEngine             sipModuleAPI_QtGui.em_types[203]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QIconEngine;

#define sipType_QIconEngineV2              sipModuleAPI_QtGui.em_types[204]
#define sipClass_QIconEngineV2             sipModuleAPI_QtGui.em_types[204]->u.td_wrapper_type

#define sipType_QIconEngineV2_IconEngineHook              sipModuleAPI_QtGui.em_types[206]
#define sipEnum_QIconEngineV2_IconEngineHook              sipModuleAPI_QtGui.em_types[206]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QIconEngineV2;

#define sipType_QIconEngineV2_AvailableSizesArgument              sipModuleAPI_QtGui.em_types[205]
#define sipClass_QIconEngineV2_AvailableSizesArgument             sipModuleAPI_QtGui.em_types[205]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QIconEngineV2_AvailableSizesArgument;

#define sipType_QItemEditorCreatorBase              sipModuleAPI_QtGui.em_types[229]
#define sipClass_QItemEditorCreatorBase             sipModuleAPI_QtGui.em_types[229]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QItemEditorCreatorBase;

#define sipType_QItemEditorFactory              sipModuleAPI_QtGui.em_types[230]
#define sipClass_QItemEditorFactory             sipModuleAPI_QtGui.em_types[230]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QItemEditorFactory;

#define sipType_QItemSelectionRange              sipModuleAPI_QtGui.em_types[235]
#define sipClass_QItemSelectionRange             sipModuleAPI_QtGui.em_types[235]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QItemSelectionRange;

#define sipType_QItemSelectionModel              sipModuleAPI_QtGui.em_types[232]
#define sipClass_QItemSelectionModel             sipModuleAPI_QtGui.em_types[232]->u.td_wrapper_type

#define sipType_QItemSelectionModel_SelectionFlag              sipModuleAPI_QtGui.em_types[233]
#define sipEnum_QItemSelectionModel_SelectionFlag              sipModuleAPI_QtGui.em_types[233]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QItemSelectionModel;

#define sipType_QItemSelectionModel_SelectionFlags              sipModuleAPI_QtGui.em_types[234]
#define sipClass_QItemSelectionModel_SelectionFlags             sipModuleAPI_QtGui.em_types[234]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QItemSelectionModel_SelectionFlags;

#define sipType_QItemSelection              sipModuleAPI_QtGui.em_types[231]
#define sipClass_QItemSelection             sipModuleAPI_QtGui.em_types[231]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QItemSelection;

#define sipType_QImage              sipModuleAPI_QtGui.em_types[207]
#define sipClass_QImage             sipModuleAPI_QtGui.em_types[207]->u.td_wrapper_type

#define sipType_QImage_Format              sipModuleAPI_QtGui.em_types[208]
#define sipEnum_QImage_Format              sipModuleAPI_QtGui.em_types[208]->u.td_py_type
#define sipType_QImage_InvertMode              sipModuleAPI_QtGui.em_types[209]
#define sipEnum_QImage_InvertMode              sipModuleAPI_QtGui.em_types[209]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QImage;

#define sipType_QImageIOHandler              sipModuleAPI_QtGui.em_types[210]
#define sipClass_QImageIOHandler             sipModuleAPI_QtGui.em_types[210]->u.td_wrapper_type

#define sipType_QImageIOHandler_ImageOption              sipModuleAPI_QtGui.em_types[211]
#define sipEnum_QImageIOHandler_ImageOption              sipModuleAPI_QtGui.em_types[211]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QImageIOHandler;

#define sipType_QImageReader              sipModuleAPI_QtGui.em_types[212]
#define sipClass_QImageReader             sipModuleAPI_QtGui.em_types[212]->u.td_wrapper_type

#define sipType_QImageReader_ImageReaderError              sipModuleAPI_QtGui.em_types[213]
#define sipEnum_QImageReader_ImageReaderError              sipModuleAPI_QtGui.em_types[213]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QImageReader;

#define sipType_QImageWriter              sipModuleAPI_QtGui.em_types[214]
#define sipClass_QImageWriter             sipModuleAPI_QtGui.em_types[214]->u.td_wrapper_type

#define sipType_QImageWriter_ImageWriterError              sipModuleAPI_QtGui.em_types[215]
#define sipEnum_QImageWriter_ImageWriterError              sipModuleAPI_QtGui.em_types[215]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QImageWriter;

#define sipType_QInputContext              sipModuleAPI_QtGui.em_types[216]
#define sipClass_QInputContext             sipModuleAPI_QtGui.em_types[216]->u.td_wrapper_type

#define sipType_QInputContext_StandardFormat              sipModuleAPI_QtGui.em_types[217]
#define sipEnum_QInputContext_StandardFormat              sipModuleAPI_QtGui.em_types[217]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QInputContext;

#define sipType_QInputContextFactory              sipModuleAPI_QtGui.em_types[218]
#define sipClass_QInputContextFactory             sipModuleAPI_QtGui.em_types[218]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QInputContextFactory;

#define sipType_QInputDialog              sipModuleAPI_QtGui.em_types[219]
#define sipClass_QInputDialog             sipModuleAPI_QtGui.em_types[219]->u.td_wrapper_type

#define sipType_QInputDialog_InputMode              sipModuleAPI_QtGui.em_types[222]
#define sipEnum_QInputDialog_InputMode              sipModuleAPI_QtGui.em_types[222]->u.td_py_type
#define sipType_QInputDialog_InputDialogOption              sipModuleAPI_QtGui.em_types[220]
#define sipEnum_QInputDialog_InputDialogOption              sipModuleAPI_QtGui.em_types[220]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QInputDialog;

#define sipType_QInputDialog_InputDialogOptions              sipModuleAPI_QtGui.em_types[221]
#define sipClass_QInputDialog_InputDialogOptions             sipModuleAPI_QtGui.em_types[221]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QInputDialog_InputDialogOptions;

#define sipType_QItemDelegate              sipModuleAPI_QtGui.em_types[228]
#define sipClass_QItemDelegate             sipModuleAPI_QtGui.em_types[228]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QItemDelegate;

#define sipType_QKeySequence              sipModuleAPI_QtGui.em_types[237]
#define sipClass_QKeySequence             sipModuleAPI_QtGui.em_types[237]->u.td_wrapper_type

#define sipType_QKeySequence_StandardKey              sipModuleAPI_QtGui.em_types[240]
#define sipEnum_QKeySequence_StandardKey              sipModuleAPI_QtGui.em_types[240]->u.td_py_type
#define sipType_QKeySequence_SequenceMatch              sipModuleAPI_QtGui.em_types[239]
#define sipEnum_QKeySequence_SequenceMatch              sipModuleAPI_QtGui.em_types[239]->u.td_py_type
#define sipType_QKeySequence_SequenceFormat              sipModuleAPI_QtGui.em_types[238]
#define sipEnum_QKeySequence_SequenceFormat              sipModuleAPI_QtGui.em_types[238]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QKeySequence;

#define sipType_QLabel              sipModuleAPI_QtGui.em_types[244]
#define sipClass_QLabel             sipModuleAPI_QtGui.em_types[244]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QLabel;

#define sipType_QSpacerItem              sipModuleAPI_QtGui.em_types[402]
#define sipClass_QSpacerItem             sipModuleAPI_QtGui.em_types[402]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QSpacerItem;

#define sipType_QWidgetItem              sipModuleAPI_QtGui.em_types[687]
#define sipClass_QWidgetItem             sipModuleAPI_QtGui.em_types[687]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QWidgetItem;

#define sipType_QLCDNumber              sipModuleAPI_QtGui.em_types[241]
#define sipClass_QLCDNumber             sipModuleAPI_QtGui.em_types[241]->u.td_wrapper_type

#define sipType_QLCDNumber_SegmentStyle              sipModuleAPI_QtGui.em_types[243]
#define sipEnum_QLCDNumber_SegmentStyle              sipModuleAPI_QtGui.em_types[243]->u.td_py_type
#define sipType_QLCDNumber_Mode              sipModuleAPI_QtGui.em_types[242]
#define sipEnum_QLCDNumber_Mode              sipModuleAPI_QtGui.em_types[242]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QLCDNumber;

#define sipType_QLineEdit              sipModuleAPI_QtGui.em_types[248]
#define sipClass_QLineEdit             sipModuleAPI_QtGui.em_types[248]->u.td_wrapper_type

#define sipType_QLineEdit_EchoMode              sipModuleAPI_QtGui.em_types[249]
#define sipEnum_QLineEdit_EchoMode              sipModuleAPI_QtGui.em_types[249]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QLineEdit;

#define sipType_QListView              sipModuleAPI_QtGui.em_types[280]
#define sipClass_QListView             sipModuleAPI_QtGui.em_types[280]->u.td_wrapper_type

#define sipType_QListView_ViewMode              sipModuleAPI_QtGui.em_types[285]
#define sipEnum_QListView_ViewMode              sipModuleAPI_QtGui.em_types[285]->u.td_py_type
#define sipType_QListView_LayoutMode              sipModuleAPI_QtGui.em_types[282]
#define sipEnum_QListView_LayoutMode              sipModuleAPI_QtGui.em_types[282]->u.td_py_type
#define sipType_QListView_ResizeMode              sipModuleAPI_QtGui.em_types[284]
#define sipEnum_QListView_ResizeMode              sipModuleAPI_QtGui.em_types[284]->u.td_py_type
#define sipType_QListView_Flow              sipModuleAPI_QtGui.em_types[281]
#define sipEnum_QListView_Flow              sipModuleAPI_QtGui.em_types[281]->u.td_py_type
#define sipType_QListView_Movement              sipModuleAPI_QtGui.em_types[283]
#define sipEnum_QListView_Movement              sipModuleAPI_QtGui.em_types[283]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QListView;

#define sipType_QListWidgetItem              sipModuleAPI_QtGui.em_types[287]
#define sipClass_QListWidgetItem             sipModuleAPI_QtGui.em_types[287]->u.td_wrapper_type

#define sipType_QListWidgetItem_ItemType              sipModuleAPI_QtGui.em_types[288]
#define sipEnum_QListWidgetItem_ItemType              sipModuleAPI_QtGui.em_types[288]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QListWidgetItem;

#define sipType_QListWidget              sipModuleAPI_QtGui.em_types[286]
#define sipClass_QListWidget             sipModuleAPI_QtGui.em_types[286]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QListWidget;

#define sipType_QMainWindow              sipModuleAPI_QtGui.em_types[289]
#define sipClass_QMainWindow             sipModuleAPI_QtGui.em_types[289]->u.td_wrapper_type

#define sipType_QMainWindow_DockOption              sipModuleAPI_QtGui.em_types[290]
#define sipEnum_QMainWindow_DockOption              sipModuleAPI_QtGui.em_types[290]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QMainWindow;

#define sipType_QMainWindow_DockOptions              sipModuleAPI_QtGui.em_types[291]
#define sipClass_QMainWindow_DockOptions             sipModuleAPI_QtGui.em_types[291]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QMainWindow_DockOptions;

#define sipType_QMatrix              sipModuleAPI_QtGui.em_types[293]
#define sipClass_QMatrix             sipModuleAPI_QtGui.em_types[293]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QMatrix;

#define sipType_QMdiArea              sipModuleAPI_QtGui.em_types[294]
#define sipClass_QMdiArea             sipModuleAPI_QtGui.em_types[294]->u.td_wrapper_type

#define sipType_QMdiArea_WindowOrder              sipModuleAPI_QtGui.em_types[298]
#define sipEnum_QMdiArea_WindowOrder              sipModuleAPI_QtGui.em_types[298]->u.td_py_type
#define sipType_QMdiArea_ViewMode              sipModuleAPI_QtGui.em_types[297]
#define sipEnum_QMdiArea_ViewMode              sipModuleAPI_QtGui.em_types[297]->u.td_py_type
#define sipType_QMdiArea_AreaOption              sipModuleAPI_QtGui.em_types[295]
#define sipEnum_QMdiArea_AreaOption              sipModuleAPI_QtGui.em_types[295]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QMdiArea;

#define sipType_QMdiArea_AreaOptions              sipModuleAPI_QtGui.em_types[296]
#define sipClass_QMdiArea_AreaOptions             sipModuleAPI_QtGui.em_types[296]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QMdiArea_AreaOptions;

#define sipType_QMdiSubWindow              sipModuleAPI_QtGui.em_types[299]
#define sipClass_QMdiSubWindow             sipModuleAPI_QtGui.em_types[299]->u.td_wrapper_type

#define sipType_QMdiSubWindow_SubWindowOption              sipModuleAPI_QtGui.em_types[300]
#define sipEnum_QMdiSubWindow_SubWindowOption              sipModuleAPI_QtGui.em_types[300]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QMdiSubWindow;

#define sipType_QMdiSubWindow_SubWindowOptions              sipModuleAPI_QtGui.em_types[301]
#define sipClass_QMdiSubWindow_SubWindowOptions             sipModuleAPI_QtGui.em_types[301]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QMdiSubWindow_SubWindowOptions;

#define sipType_QMenu              sipModuleAPI_QtGui.em_types[302]
#define sipClass_QMenu             sipModuleAPI_QtGui.em_types[302]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QMenu;

#define sipType_QMenuBar              sipModuleAPI_QtGui.em_types[303]
#define sipClass_QMenuBar             sipModuleAPI_QtGui.em_types[303]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QMenuBar;

#define sipType_QMessageBox              sipModuleAPI_QtGui.em_types[304]
#define sipClass_QMessageBox             sipModuleAPI_QtGui.em_types[304]->u.td_wrapper_type

#define sipType_QMessageBox_StandardButton              sipModuleAPI_QtGui.em_types[307]
#define sipEnum_QMessageBox_StandardButton              sipModuleAPI_QtGui.em_types[307]->u.td_py_type
#define sipType_QMessageBox_Icon              sipModuleAPI_QtGui.em_types[306]
#define sipEnum_QMessageBox_Icon              sipModuleAPI_QtGui.em_types[306]->u.td_py_type
#define sipType_QMessageBox_ButtonRole              sipModuleAPI_QtGui.em_types[305]
#define sipEnum_QMessageBox_ButtonRole              sipModuleAPI_QtGui.em_types[305]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QMessageBox;

#define sipType_QMessageBox_StandardButtons              sipModuleAPI_QtGui.em_types[308]
#define sipClass_QMessageBox_StandardButtons             sipModuleAPI_QtGui.em_types[308]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QMessageBox_StandardButtons;

#define sipType_QMovie              sipModuleAPI_QtGui.em_types[312]
#define sipClass_QMovie             sipModuleAPI_QtGui.em_types[312]->u.td_wrapper_type

#define sipType_QMovie_CacheMode              sipModuleAPI_QtGui.em_types[313]
#define sipEnum_QMovie_CacheMode              sipModuleAPI_QtGui.em_types[313]->u.td_py_type
#define sipType_QMovie_MovieState              sipModuleAPI_QtGui.em_types[314]
#define sipEnum_QMovie_MovieState              sipModuleAPI_QtGui.em_types[314]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QMovie;

#define sipType_QPageSetupDialog              sipModuleAPI_QtGui.em_types[315]
#define sipClass_QPageSetupDialog             sipModuleAPI_QtGui.em_types[315]->u.td_wrapper_type

#define sipType_QPageSetupDialog_PageSetupDialogOption              sipModuleAPI_QtGui.em_types[316]
#define sipEnum_QPageSetupDialog_PageSetupDialogOption              sipModuleAPI_QtGui.em_types[316]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QPageSetupDialog;

#define sipType_QPageSetupDialog_PageSetupDialogOptions              sipModuleAPI_QtGui.em_types[317]
#define sipClass_QPageSetupDialog_PageSetupDialogOptions             sipModuleAPI_QtGui.em_types[317]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QPageSetupDialog_PageSetupDialogOptions;

#define sipType_QPainter              sipModuleAPI_QtGui.em_types[329]
#define sipClass_QPainter             sipModuleAPI_QtGui.em_types[329]->u.td_wrapper_type

#define sipType_QPainter_CompositionMode              sipModuleAPI_QtGui.em_types[330]
#define sipEnum_QPainter_CompositionMode              sipModuleAPI_QtGui.em_types[330]->u.td_py_type
#define sipType_QPainter_RenderHint              sipModuleAPI_QtGui.em_types[331]
#define sipEnum_QPainter_RenderHint              sipModuleAPI_QtGui.em_types[331]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QPainter;

#define sipType_QPainter_RenderHints              sipModuleAPI_QtGui.em_types[332]
#define sipClass_QPainter_RenderHints             sipModuleAPI_QtGui.em_types[332]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QPainter_RenderHints;

#define sipType_QTextItem              sipModuleAPI_QtGui.em_types[620]
#define sipClass_QTextItem             sipModuleAPI_QtGui.em_types[620]->u.td_wrapper_type

#define sipType_QTextItem_RenderFlag              sipModuleAPI_QtGui.em_types[621]
#define sipEnum_QTextItem_RenderFlag              sipModuleAPI_QtGui.em_types[621]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTextItem;

#define sipType_QTextItem_RenderFlags              sipModuleAPI_QtGui.em_types[622]
#define sipClass_QTextItem_RenderFlags             sipModuleAPI_QtGui.em_types[622]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTextItem_RenderFlags;

#define sipType_QPaintEngine              sipModuleAPI_QtGui.em_types[320]
#define sipClass_QPaintEngine             sipModuleAPI_QtGui.em_types[320]->u.td_wrapper_type

#define sipType_QPaintEngine_Type              sipModuleAPI_QtGui.em_types[326]
#define sipEnum_QPaintEngine_Type              sipModuleAPI_QtGui.em_types[326]->u.td_py_type
#define sipType_QPaintEngine_PolygonDrawMode              sipModuleAPI_QtGui.em_types[325]
#define sipEnum_QPaintEngine_PolygonDrawMode              sipModuleAPI_QtGui.em_types[325]->u.td_py_type
#define sipType_QPaintEngine_DirtyFlag              sipModuleAPI_QtGui.em_types[321]
#define sipEnum_QPaintEngine_DirtyFlag              sipModuleAPI_QtGui.em_types[321]->u.td_py_type
#define sipType_QPaintEngine_PaintEngineFeature              sipModuleAPI_QtGui.em_types[323]
#define sipEnum_QPaintEngine_PaintEngineFeature              sipModuleAPI_QtGui.em_types[323]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QPaintEngine;

#define sipType_QPaintEngine_PaintEngineFeatures              sipModuleAPI_QtGui.em_types[324]
#define sipClass_QPaintEngine_PaintEngineFeatures             sipModuleAPI_QtGui.em_types[324]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QPaintEngine_PaintEngineFeatures;

#define sipType_QPaintEngine_DirtyFlags              sipModuleAPI_QtGui.em_types[322]
#define sipClass_QPaintEngine_DirtyFlags             sipModuleAPI_QtGui.em_types[322]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QPaintEngine_DirtyFlags;

#define sipType_QPaintEngineState              sipModuleAPI_QtGui.em_types[327]
#define sipClass_QPaintEngineState             sipModuleAPI_QtGui.em_types[327]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QPaintEngineState;

#define sipType_QPainterPath              sipModuleAPI_QtGui.em_types[333]
#define sipClass_QPainterPath             sipModuleAPI_QtGui.em_types[333]->u.td_wrapper_type

#define sipType_QPainterPath_ElementType              sipModuleAPI_QtGui.em_types[335]
#define sipEnum_QPainterPath_ElementType              sipModuleAPI_QtGui.em_types[335]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QPainterPath;

#define sipType_QPainterPath_Element              sipModuleAPI_QtGui.em_types[334]
#define sipClass_QPainterPath_Element             sipModuleAPI_QtGui.em_types[334]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QPainterPath_Element;

#define sipType_QPainterPathStroker              sipModuleAPI_QtGui.em_types[336]
#define sipClass_QPainterPathStroker             sipModuleAPI_QtGui.em_types[336]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QPainterPathStroker;

#define sipType_QPalette              sipModuleAPI_QtGui.em_types[337]
#define sipClass_QPalette             sipModuleAPI_QtGui.em_types[337]->u.td_wrapper_type

#define sipType_QPalette_ColorRole              sipModuleAPI_QtGui.em_types[339]
#define sipEnum_QPalette_ColorRole              sipModuleAPI_QtGui.em_types[339]->u.td_py_type
#define sipType_QPalette_ColorGroup              sipModuleAPI_QtGui.em_types[338]
#define sipEnum_QPalette_ColorGroup              sipModuleAPI_QtGui.em_types[338]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QPalette;

#define sipType_QPen              sipModuleAPI_QtGui.em_types[340]
#define sipClass_QPen             sipModuleAPI_QtGui.em_types[340]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QPen;

#define sipType_QPicture              sipModuleAPI_QtGui.em_types[341]
#define sipClass_QPicture             sipModuleAPI_QtGui.em_types[341]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QPicture;

#define sipType_QPictureIO              sipModuleAPI_QtGui.em_types[342]
#define sipClass_QPictureIO             sipModuleAPI_QtGui.em_types[342]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QPictureIO;

#define sipType_QPixmapCache              sipModuleAPI_QtGui.em_types[345]
#define sipClass_QPixmapCache             sipModuleAPI_QtGui.em_types[345]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QPixmapCache;

#define sipType_QPlainTextEdit              sipModuleAPI_QtGui.em_types[347]
#define sipClass_QPlainTextEdit             sipModuleAPI_QtGui.em_types[347]->u.td_wrapper_type

#define sipType_QPlainTextEdit_LineWrapMode              sipModuleAPI_QtGui.em_types[348]
#define sipEnum_QPlainTextEdit_LineWrapMode              sipModuleAPI_QtGui.em_types[348]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QPlainTextEdit;

#define sipType_QPlainTextDocumentLayout              sipModuleAPI_QtGui.em_types[346]
#define sipClass_QPlainTextDocumentLayout             sipModuleAPI_QtGui.em_types[346]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QPlainTextDocumentLayout;

#define sipType_QPolygon              sipModuleAPI_QtGui.em_types[349]
#define sipClass_QPolygon             sipModuleAPI_QtGui.em_types[349]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QPolygon;

#define sipType_QPolygonF              sipModuleAPI_QtGui.em_types[350]
#define sipClass_QPolygonF             sipModuleAPI_QtGui.em_types[350]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QPolygonF;

#define sipType_QPrinter              sipModuleAPI_QtGui.em_types[358]
#define sipClass_QPrinter             sipModuleAPI_QtGui.em_types[358]->u.td_wrapper_type

#define sipType_QPrinter_Unit              sipModuleAPI_QtGui.em_types[369]
#define sipEnum_QPrinter_Unit              sipModuleAPI_QtGui.em_types[369]->u.td_py_type
#define sipType_QPrinter_DuplexMode              sipModuleAPI_QtGui.em_types[360]
#define sipEnum_QPrinter_DuplexMode              sipModuleAPI_QtGui.em_types[360]->u.td_py_type
#define sipType_QPrinter_PrintRange              sipModuleAPI_QtGui.em_types[366]
#define sipEnum_QPrinter_PrintRange              sipModuleAPI_QtGui.em_types[366]->u.td_py_type
#define sipType_QPrinter_OutputFormat              sipModuleAPI_QtGui.em_types[362]
#define sipEnum_QPrinter_OutputFormat              sipModuleAPI_QtGui.em_types[362]->u.td_py_type
#define sipType_QPrinter_PrinterState              sipModuleAPI_QtGui.em_types[368]
#define sipEnum_QPrinter_PrinterState              sipModuleAPI_QtGui.em_types[368]->u.td_py_type
#define sipType_QPrinter_PaperSource              sipModuleAPI_QtGui.em_types[365]
#define sipEnum_QPrinter_PaperSource              sipModuleAPI_QtGui.em_types[365]->u.td_py_type
#define sipType_QPrinter_ColorMode              sipModuleAPI_QtGui.em_types[359]
#define sipEnum_QPrinter_ColorMode              sipModuleAPI_QtGui.em_types[359]->u.td_py_type
#define sipType_QPrinter_PageOrder              sipModuleAPI_QtGui.em_types[363]
#define sipEnum_QPrinter_PageOrder              sipModuleAPI_QtGui.em_types[363]->u.td_py_type
#define sipType_QPrinter_PageSize              sipModuleAPI_QtGui.em_types[364]
#define sipEnum_QPrinter_PageSize              sipModuleAPI_QtGui.em_types[364]->u.td_py_type
#define sipType_QPrinter_Orientation              sipModuleAPI_QtGui.em_types[361]
#define sipEnum_QPrinter_Orientation              sipModuleAPI_QtGui.em_types[361]->u.td_py_type
#define sipType_QPrinter_PrinterMode              sipModuleAPI_QtGui.em_types[367]
#define sipEnum_QPrinter_PrinterMode              sipModuleAPI_QtGui.em_types[367]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QPrinter;

#define sipType_QPrintDialog              sipModuleAPI_QtGui.em_types[351]
#define sipClass_QPrintDialog             sipModuleAPI_QtGui.em_types[351]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QPrintDialog;

#define sipType_QPrintEngine              sipModuleAPI_QtGui.em_types[352]
#define sipClass_QPrintEngine             sipModuleAPI_QtGui.em_types[352]->u.td_wrapper_type

#define sipType_QPrintEngine_PrintEnginePropertyKey              sipModuleAPI_QtGui.em_types[353]
#define sipEnum_QPrintEngine_PrintEnginePropertyKey              sipModuleAPI_QtGui.em_types[353]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QPrintEngine;

#define sipType_QPrinterInfo              sipModuleAPI_QtGui.em_types[370]
#define sipClass_QPrinterInfo             sipModuleAPI_QtGui.em_types[370]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QPrinterInfo;

#define sipType_QPrintPreviewDialog              sipModuleAPI_QtGui.em_types[354]
#define sipClass_QPrintPreviewDialog             sipModuleAPI_QtGui.em_types[354]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QPrintPreviewDialog;

#define sipType_QPrintPreviewWidget              sipModuleAPI_QtGui.em_types[355]
#define sipClass_QPrintPreviewWidget             sipModuleAPI_QtGui.em_types[355]->u.td_wrapper_type

#define sipType_QPrintPreviewWidget_ZoomMode              sipModuleAPI_QtGui.em_types[357]
#define sipEnum_QPrintPreviewWidget_ZoomMode              sipModuleAPI_QtGui.em_types[357]->u.td_py_type
#define sipType_QPrintPreviewWidget_ViewMode              sipModuleAPI_QtGui.em_types[356]
#define sipEnum_QPrintPreviewWidget_ViewMode              sipModuleAPI_QtGui.em_types[356]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QPrintPreviewWidget;

#define sipType_QProgressBar              sipModuleAPI_QtGui.em_types[371]
#define sipClass_QProgressBar             sipModuleAPI_QtGui.em_types[371]->u.td_wrapper_type

#define sipType_QProgressBar_Direction              sipModuleAPI_QtGui.em_types[372]
#define sipEnum_QProgressBar_Direction              sipModuleAPI_QtGui.em_types[372]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QProgressBar;

#define sipType_QProgressDialog              sipModuleAPI_QtGui.em_types[373]
#define sipClass_QProgressDialog             sipModuleAPI_QtGui.em_types[373]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QProgressDialog;

#define sipType_QProxyModel              sipModuleAPI_QtGui.em_types[374]
#define sipClass_QProxyModel             sipModuleAPI_QtGui.em_types[374]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QProxyModel;

#define sipType_QRadioButton              sipModuleAPI_QtGui.em_types[378]
#define sipClass_QRadioButton             sipModuleAPI_QtGui.em_types[378]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QRadioButton;

#define sipType_QRegion              sipModuleAPI_QtGui.em_types[380]
#define sipClass_QRegion             sipModuleAPI_QtGui.em_types[380]->u.td_wrapper_type

#define sipType_QRegion_RegionType              sipModuleAPI_QtGui.em_types[381]
#define sipEnum_QRegion_RegionType              sipModuleAPI_QtGui.em_types[381]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QRegion;

#define sipType_QRubberBand              sipModuleAPI_QtGui.em_types[383]
#define sipClass_QRubberBand             sipModuleAPI_QtGui.em_types[383]->u.td_wrapper_type

#define sipType_QRubberBand_Shape              sipModuleAPI_QtGui.em_types[384]
#define sipEnum_QRubberBand_Shape              sipModuleAPI_QtGui.em_types[384]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QRubberBand;

#define sipType_QScrollArea              sipModuleAPI_QtGui.em_types[385]
#define sipClass_QScrollArea             sipModuleAPI_QtGui.em_types[385]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QScrollArea;

#define sipType_QScrollBar              sipModuleAPI_QtGui.em_types[386]
#define sipClass_QScrollBar             sipModuleAPI_QtGui.em_types[386]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QScrollBar;

#define sipType_QSessionManager              sipModuleAPI_QtGui.em_types[387]
#define sipClass_QSessionManager             sipModuleAPI_QtGui.em_types[387]->u.td_wrapper_type

#define sipType_QSessionManager_RestartHint              sipModuleAPI_QtGui.em_types[388]
#define sipEnum_QSessionManager_RestartHint              sipModuleAPI_QtGui.em_types[388]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QSessionManager;

#define sipType_QShortcut              sipModuleAPI_QtGui.em_types[389]
#define sipClass_QShortcut             sipModuleAPI_QtGui.em_types[389]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QShortcut;

#define sipType_QSizeGrip              sipModuleAPI_QtGui.em_types[392]
#define sipClass_QSizeGrip             sipModuleAPI_QtGui.em_types[392]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QSizeGrip;

#define sipType_QSizePolicy              sipModuleAPI_QtGui.em_types[393]
#define sipClass_QSizePolicy             sipModuleAPI_QtGui.em_types[393]->u.td_wrapper_type

#define sipType_QSizePolicy_ControlType              sipModuleAPI_QtGui.em_types[394]
#define sipEnum_QSizePolicy_ControlType              sipModuleAPI_QtGui.em_types[394]->u.td_py_type
#define sipType_QSizePolicy_Policy              sipModuleAPI_QtGui.em_types[396]
#define sipEnum_QSizePolicy_Policy              sipModuleAPI_QtGui.em_types[396]->u.td_py_type
#define sipType_QSizePolicy_PolicyFlag              sipModuleAPI_QtGui.em_types[397]
#define sipEnum_QSizePolicy_PolicyFlag              sipModuleAPI_QtGui.em_types[397]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QSizePolicy;

#define sipType_QSizePolicy_ControlTypes              sipModuleAPI_QtGui.em_types[395]
#define sipClass_QSizePolicy_ControlTypes             sipModuleAPI_QtGui.em_types[395]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QSizePolicy_ControlTypes;

#define sipType_QSlider              sipModuleAPI_QtGui.em_types[398]
#define sipClass_QSlider             sipModuleAPI_QtGui.em_types[398]->u.td_wrapper_type

#define sipType_QSlider_TickPosition              sipModuleAPI_QtGui.em_types[399]
#define sipEnum_QSlider_TickPosition              sipModuleAPI_QtGui.em_types[399]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QSlider;

#define sipType_QSortFilterProxyModel              sipModuleAPI_QtGui.em_types[400]
#define sipClass_QSortFilterProxyModel             sipModuleAPI_QtGui.em_types[400]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QSortFilterProxyModel;

#define sipType_QSound              sipModuleAPI_QtGui.em_types[401]
#define sipClass_QSound             sipModuleAPI_QtGui.em_types[401]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QSound;

#define sipType_QSpinBox              sipModuleAPI_QtGui.em_types[403]
#define sipClass_QSpinBox             sipModuleAPI_QtGui.em_types[403]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QSpinBox;

#define sipType_QDoubleSpinBox              sipModuleAPI_QtGui.em_types[93]
#define sipClass_QDoubleSpinBox             sipModuleAPI_QtGui.em_types[93]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QDoubleSpinBox;

#define sipType_QSplashScreen              sipModuleAPI_QtGui.em_types[404]
#define sipClass_QSplashScreen             sipModuleAPI_QtGui.em_types[404]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QSplashScreen;

#define sipType_QSplitter              sipModuleAPI_QtGui.em_types[405]
#define sipClass_QSplitter             sipModuleAPI_QtGui.em_types[405]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QSplitter;

#define sipType_QSplitterHandle              sipModuleAPI_QtGui.em_types[406]
#define sipClass_QSplitterHandle             sipModuleAPI_QtGui.em_types[406]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QSplitterHandle;

#define sipType_QStackedLayout              sipModuleAPI_QtGui.em_types[407]
#define sipClass_QStackedLayout             sipModuleAPI_QtGui.em_types[407]->u.td_wrapper_type

#define sipType_QStackedLayout_StackingMode              sipModuleAPI_QtGui.em_types[408]
#define sipEnum_QStackedLayout_StackingMode              sipModuleAPI_QtGui.em_types[408]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStackedLayout;

#define sipType_QStackedWidget              sipModuleAPI_QtGui.em_types[409]
#define sipClass_QStackedWidget             sipModuleAPI_QtGui.em_types[409]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStackedWidget;

#define sipType_QStandardItemModel              sipModuleAPI_QtGui.em_types[412]
#define sipClass_QStandardItemModel             sipModuleAPI_QtGui.em_types[412]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStandardItemModel;

#define sipType_QStandardItem              sipModuleAPI_QtGui.em_types[410]
#define sipClass_QStandardItem             sipModuleAPI_QtGui.em_types[410]->u.td_wrapper_type

#define sipType_QStandardItem_ItemType              sipModuleAPI_QtGui.em_types[411]
#define sipEnum_QStandardItem_ItemType              sipModuleAPI_QtGui.em_types[411]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStandardItem;

#define sipType_QStatusBar              sipModuleAPI_QtGui.em_types[413]
#define sipClass_QStatusBar             sipModuleAPI_QtGui.em_types[413]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStatusBar;

#define sipType_QStringListModel              sipModuleAPI_QtGui.em_types[415]
#define sipClass_QStringListModel             sipModuleAPI_QtGui.em_types[415]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStringListModel;

#define sipType_QStyle              sipModuleAPI_QtGui.em_types[416]
#define sipClass_QStyle             sipModuleAPI_QtGui.em_types[416]->u.td_wrapper_type

#define sipType_QStyle_StandardPixmap              sipModuleAPI_QtGui.em_types[422]
#define sipEnum_QStyle_StandardPixmap              sipModuleAPI_QtGui.em_types[422]->u.td_py_type
#define sipType_QStyle_StyleHint              sipModuleAPI_QtGui.em_types[425]
#define sipEnum_QStyle_StyleHint              sipModuleAPI_QtGui.em_types[425]->u.td_py_type
#define sipType_QStyle_ContentsType              sipModuleAPI_QtGui.em_types[418]
#define sipEnum_QStyle_ContentsType              sipModuleAPI_QtGui.em_types[418]->u.td_py_type
#define sipType_QStyle_PixelMetric              sipModuleAPI_QtGui.em_types[420]
#define sipEnum_QStyle_PixelMetric              sipModuleAPI_QtGui.em_types[420]->u.td_py_type
#define sipType_QStyle_SubControl              sipModuleAPI_QtGui.em_types[426]
#define sipEnum_QStyle_SubControl              sipModuleAPI_QtGui.em_types[426]->u.td_py_type
#define sipType_QStyle_ComplexControl              sipModuleAPI_QtGui.em_types[417]
#define sipEnum_QStyle_ComplexControl              sipModuleAPI_QtGui.em_types[417]->u.td_py_type
#define sipType_QStyle_SubElement              sipModuleAPI_QtGui.em_types[428]
#define sipEnum_QStyle_SubElement              sipModuleAPI_QtGui.em_types[428]->u.td_py_type
#define sipType_QStyle_ControlElement              sipModuleAPI_QtGui.em_types[419]
#define sipEnum_QStyle_ControlElement              sipModuleAPI_QtGui.em_types[419]->u.td_py_type
#define sipType_QStyle_PrimitiveElement              sipModuleAPI_QtGui.em_types[421]
#define sipEnum_QStyle_PrimitiveElement              sipModuleAPI_QtGui.em_types[421]->u.td_py_type
#define sipType_QStyle_StateFlag              sipModuleAPI_QtGui.em_types[424]
#define sipEnum_QStyle_StateFlag              sipModuleAPI_QtGui.em_types[424]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyle;

#define sipType_QStyle_State              sipModuleAPI_QtGui.em_types[423]
#define sipClass_QStyle_State             sipModuleAPI_QtGui.em_types[423]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyle_State;

#define sipType_QStyle_SubControls              sipModuleAPI_QtGui.em_types[427]
#define sipClass_QStyle_SubControls             sipModuleAPI_QtGui.em_types[427]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyle_SubControls;

#define sipType_QStyledItemDelegate              sipModuleAPI_QtGui.em_types[561]
#define sipClass_QStyledItemDelegate             sipModuleAPI_QtGui.em_types[561]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyledItemDelegate;

#define sipType_QStyleFactory              sipModuleAPI_QtGui.em_types[429]
#define sipClass_QStyleFactory             sipModuleAPI_QtGui.em_types[429]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyleFactory;

#define sipType_QStyleOption              sipModuleAPI_QtGui.em_types[440]
#define sipClass_QStyleOption             sipModuleAPI_QtGui.em_types[440]->u.td_wrapper_type

#define sipType_QStyleOption_StyleOptionVersion              sipModuleAPI_QtGui.em_types[443]
#define sipEnum_QStyleOption_StyleOptionVersion              sipModuleAPI_QtGui.em_types[443]->u.td_py_type
#define sipType_QStyleOption_StyleOptionType              sipModuleAPI_QtGui.em_types[442]
#define sipEnum_QStyleOption_StyleOptionType              sipModuleAPI_QtGui.em_types[442]->u.td_py_type
#define sipType_QStyleOption_OptionType              sipModuleAPI_QtGui.em_types[441]
#define sipEnum_QStyleOption_OptionType              sipModuleAPI_QtGui.em_types[441]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyleOption;

#define sipType_QStyleOptionFocusRect              sipModuleAPI_QtGui.em_types[460]
#define sipClass_QStyleOptionFocusRect             sipModuleAPI_QtGui.em_types[460]->u.td_wrapper_type

#define sipType_QStyleOptionFocusRect_StyleOptionVersion              sipModuleAPI_QtGui.em_types[462]
#define sipEnum_QStyleOptionFocusRect_StyleOptionVersion              sipModuleAPI_QtGui.em_types[462]->u.td_py_type
#define sipType_QStyleOptionFocusRect_StyleOptionType              sipModuleAPI_QtGui.em_types[461]
#define sipEnum_QStyleOptionFocusRect_StyleOptionType              sipModuleAPI_QtGui.em_types[461]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyleOptionFocusRect;

#define sipType_QStyleOptionFrame              sipModuleAPI_QtGui.em_types[463]
#define sipClass_QStyleOptionFrame             sipModuleAPI_QtGui.em_types[463]->u.td_wrapper_type

#define sipType_QStyleOptionFrame_StyleOptionVersion              sipModuleAPI_QtGui.em_types[465]
#define sipEnum_QStyleOptionFrame_StyleOptionVersion              sipModuleAPI_QtGui.em_types[465]->u.td_py_type
#define sipType_QStyleOptionFrame_StyleOptionType              sipModuleAPI_QtGui.em_types[464]
#define sipEnum_QStyleOptionFrame_StyleOptionType              sipModuleAPI_QtGui.em_types[464]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyleOptionFrame;

#define sipType_QStyleOptionFrameV2              sipModuleAPI_QtGui.em_types[466]
#define sipClass_QStyleOptionFrameV2             sipModuleAPI_QtGui.em_types[466]->u.td_wrapper_type

#define sipType_QStyleOptionFrameV2_FrameFeature              sipModuleAPI_QtGui.em_types[467]
#define sipEnum_QStyleOptionFrameV2_FrameFeature              sipModuleAPI_QtGui.em_types[467]->u.td_py_type
#define sipType_QStyleOptionFrameV2_StyleOptionVersion              sipModuleAPI_QtGui.em_types[469]
#define sipEnum_QStyleOptionFrameV2_StyleOptionVersion              sipModuleAPI_QtGui.em_types[469]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyleOptionFrameV2;

#define sipType_QStyleOptionFrameV2_FrameFeatures              sipModuleAPI_QtGui.em_types[468]
#define sipClass_QStyleOptionFrameV2_FrameFeatures             sipModuleAPI_QtGui.em_types[468]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyleOptionFrameV2_FrameFeatures;

#define sipType_QStyleOptionTabWidgetFrame              sipModuleAPI_QtGui.em_types[523]
#define sipClass_QStyleOptionTabWidgetFrame             sipModuleAPI_QtGui.em_types[523]->u.td_wrapper_type

#define sipType_QStyleOptionTabWidgetFrame_StyleOptionVersion              sipModuleAPI_QtGui.em_types[525]
#define sipEnum_QStyleOptionTabWidgetFrame_StyleOptionVersion              sipModuleAPI_QtGui.em_types[525]->u.td_py_type
#define sipType_QStyleOptionTabWidgetFrame_StyleOptionType              sipModuleAPI_QtGui.em_types[524]
#define sipEnum_QStyleOptionTabWidgetFrame_StyleOptionType              sipModuleAPI_QtGui.em_types[524]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyleOptionTabWidgetFrame;

#define sipType_QStyleOptionTabBarBase              sipModuleAPI_QtGui.em_types[514]
#define sipClass_QStyleOptionTabBarBase             sipModuleAPI_QtGui.em_types[514]->u.td_wrapper_type

#define sipType_QStyleOptionTabBarBase_StyleOptionVersion              sipModuleAPI_QtGui.em_types[516]
#define sipEnum_QStyleOptionTabBarBase_StyleOptionVersion              sipModuleAPI_QtGui.em_types[516]->u.td_py_type
#define sipType_QStyleOptionTabBarBase_StyleOptionType              sipModuleAPI_QtGui.em_types[515]
#define sipEnum_QStyleOptionTabBarBase_StyleOptionType              sipModuleAPI_QtGui.em_types[515]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyleOptionTabBarBase;

#define sipType_QStyleOptionHeader              sipModuleAPI_QtGui.em_types[478]
#define sipClass_QStyleOptionHeader             sipModuleAPI_QtGui.em_types[478]->u.td_wrapper_type

#define sipType_QStyleOptionHeader_SortIndicator              sipModuleAPI_QtGui.em_types[481]
#define sipEnum_QStyleOptionHeader_SortIndicator              sipModuleAPI_QtGui.em_types[481]->u.td_py_type
#define sipType_QStyleOptionHeader_SelectedPosition              sipModuleAPI_QtGui.em_types[480]
#define sipEnum_QStyleOptionHeader_SelectedPosition              sipModuleAPI_QtGui.em_types[480]->u.td_py_type
#define sipType_QStyleOptionHeader_SectionPosition              sipModuleAPI_QtGui.em_types[479]
#define sipEnum_QStyleOptionHeader_SectionPosition              sipModuleAPI_QtGui.em_types[479]->u.td_py_type
#define sipType_QStyleOptionHeader_StyleOptionVersion              sipModuleAPI_QtGui.em_types[483]
#define sipEnum_QStyleOptionHeader_StyleOptionVersion              sipModuleAPI_QtGui.em_types[483]->u.td_py_type
#define sipType_QStyleOptionHeader_StyleOptionType              sipModuleAPI_QtGui.em_types[482]
#define sipEnum_QStyleOptionHeader_StyleOptionType              sipModuleAPI_QtGui.em_types[482]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyleOptionHeader;

#define sipType_QStyleOptionButton              sipModuleAPI_QtGui.em_types[444]
#define sipClass_QStyleOptionButton             sipModuleAPI_QtGui.em_types[444]->u.td_wrapper_type

#define sipType_QStyleOptionButton_ButtonFeature              sipModuleAPI_QtGui.em_types[445]
#define sipEnum_QStyleOptionButton_ButtonFeature              sipModuleAPI_QtGui.em_types[445]->u.td_py_type
#define sipType_QStyleOptionButton_StyleOptionVersion              sipModuleAPI_QtGui.em_types[448]
#define sipEnum_QStyleOptionButton_StyleOptionVersion              sipModuleAPI_QtGui.em_types[448]->u.td_py_type
#define sipType_QStyleOptionButton_StyleOptionType              sipModuleAPI_QtGui.em_types[447]
#define sipEnum_QStyleOptionButton_StyleOptionType              sipModuleAPI_QtGui.em_types[447]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyleOptionButton;

#define sipType_QStyleOptionButton_ButtonFeatures              sipModuleAPI_QtGui.em_types[446]
#define sipClass_QStyleOptionButton_ButtonFeatures             sipModuleAPI_QtGui.em_types[446]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyleOptionButton_ButtonFeatures;

#define sipType_QStyleOptionTab              sipModuleAPI_QtGui.em_types[507]
#define sipClass_QStyleOptionTab             sipModuleAPI_QtGui.em_types[507]->u.td_wrapper_type

#define sipType_QStyleOptionTab_CornerWidget              sipModuleAPI_QtGui.em_types[508]
#define sipEnum_QStyleOptionTab_CornerWidget              sipModuleAPI_QtGui.em_types[508]->u.td_py_type
#define sipType_QStyleOptionTab_SelectedPosition              sipModuleAPI_QtGui.em_types[510]
#define sipEnum_QStyleOptionTab_SelectedPosition              sipModuleAPI_QtGui.em_types[510]->u.td_py_type
#define sipType_QStyleOptionTab_TabPosition              sipModuleAPI_QtGui.em_types[513]
#define sipEnum_QStyleOptionTab_TabPosition              sipModuleAPI_QtGui.em_types[513]->u.td_py_type
#define sipType_QStyleOptionTab_StyleOptionVersion              sipModuleAPI_QtGui.em_types[512]
#define sipEnum_QStyleOptionTab_StyleOptionVersion              sipModuleAPI_QtGui.em_types[512]->u.td_py_type
#define sipType_QStyleOptionTab_StyleOptionType              sipModuleAPI_QtGui.em_types[511]
#define sipEnum_QStyleOptionTab_StyleOptionType              sipModuleAPI_QtGui.em_types[511]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyleOptionTab;

#define sipType_QStyleOptionTab_CornerWidgets              sipModuleAPI_QtGui.em_types[509]
#define sipClass_QStyleOptionTab_CornerWidgets             sipModuleAPI_QtGui.em_types[509]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyleOptionTab_CornerWidgets;

#define sipType_QStyleOptionTabV2              sipModuleAPI_QtGui.em_types[519]
#define sipClass_QStyleOptionTabV2             sipModuleAPI_QtGui.em_types[519]->u.td_wrapper_type

#define sipType_QStyleOptionTabV2_StyleOptionVersion              sipModuleAPI_QtGui.em_types[520]
#define sipEnum_QStyleOptionTabV2_StyleOptionVersion              sipModuleAPI_QtGui.em_types[520]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyleOptionTabV2;

#define sipType_QStyleOptionProgressBar              sipModuleAPI_QtGui.em_types[489]
#define sipClass_QStyleOptionProgressBar             sipModuleAPI_QtGui.em_types[489]->u.td_wrapper_type

#define sipType_QStyleOptionProgressBar_StyleOptionVersion              sipModuleAPI_QtGui.em_types[491]
#define sipEnum_QStyleOptionProgressBar_StyleOptionVersion              sipModuleAPI_QtGui.em_types[491]->u.td_py_type
#define sipType_QStyleOptionProgressBar_StyleOptionType              sipModuleAPI_QtGui.em_types[490]
#define sipEnum_QStyleOptionProgressBar_StyleOptionType              sipModuleAPI_QtGui.em_types[490]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyleOptionProgressBar;

#define sipType_QStyleOptionProgressBarV2              sipModuleAPI_QtGui.em_types[492]
#define sipClass_QStyleOptionProgressBarV2             sipModuleAPI_QtGui.em_types[492]->u.td_wrapper_type

#define sipType_QStyleOptionProgressBarV2_StyleOptionVersion              sipModuleAPI_QtGui.em_types[494]
#define sipEnum_QStyleOptionProgressBarV2_StyleOptionVersion              sipModuleAPI_QtGui.em_types[494]->u.td_py_type
#define sipType_QStyleOptionProgressBarV2_StyleOptionType              sipModuleAPI_QtGui.em_types[493]
#define sipEnum_QStyleOptionProgressBarV2_StyleOptionType              sipModuleAPI_QtGui.em_types[493]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyleOptionProgressBarV2;

#define sipType_QStyleOptionMenuItem              sipModuleAPI_QtGui.em_types[484]
#define sipClass_QStyleOptionMenuItem             sipModuleAPI_QtGui.em_types[484]->u.td_wrapper_type

#define sipType_QStyleOptionMenuItem_CheckType              sipModuleAPI_QtGui.em_types[485]
#define sipEnum_QStyleOptionMenuItem_CheckType              sipModuleAPI_QtGui.em_types[485]->u.td_py_type
#define sipType_QStyleOptionMenuItem_MenuItemType              sipModuleAPI_QtGui.em_types[486]
#define sipEnum_QStyleOptionMenuItem_MenuItemType              sipModuleAPI_QtGui.em_types[486]->u.td_py_type
#define sipType_QStyleOptionMenuItem_StyleOptionVersion              sipModuleAPI_QtGui.em_types[488]
#define sipEnum_QStyleOptionMenuItem_StyleOptionVersion              sipModuleAPI_QtGui.em_types[488]->u.td_py_type
#define sipType_QStyleOptionMenuItem_StyleOptionType              sipModuleAPI_QtGui.em_types[487]
#define sipEnum_QStyleOptionMenuItem_StyleOptionType              sipModuleAPI_QtGui.em_types[487]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyleOptionMenuItem;

#define sipType_QStyleOptionDockWidget              sipModuleAPI_QtGui.em_types[455]
#define sipClass_QStyleOptionDockWidget             sipModuleAPI_QtGui.em_types[455]->u.td_wrapper_type

#define sipType_QStyleOptionDockWidget_StyleOptionVersion              sipModuleAPI_QtGui.em_types[457]
#define sipEnum_QStyleOptionDockWidget_StyleOptionVersion              sipModuleAPI_QtGui.em_types[457]->u.td_py_type
#define sipType_QStyleOptionDockWidget_StyleOptionType              sipModuleAPI_QtGui.em_types[456]
#define sipEnum_QStyleOptionDockWidget_StyleOptionType              sipModuleAPI_QtGui.em_types[456]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyleOptionDockWidget;

#define sipType_QStyleOptionViewItem              sipModuleAPI_QtGui.em_types[547]
#define sipClass_QStyleOptionViewItem             sipModuleAPI_QtGui.em_types[547]->u.td_wrapper_type

#define sipType_QStyleOptionViewItem_Position              sipModuleAPI_QtGui.em_types[548]
#define sipEnum_QStyleOptionViewItem_Position              sipModuleAPI_QtGui.em_types[548]->u.td_py_type
#define sipType_QStyleOptionViewItem_StyleOptionVersion              sipModuleAPI_QtGui.em_types[550]
#define sipEnum_QStyleOptionViewItem_StyleOptionVersion              sipModuleAPI_QtGui.em_types[550]->u.td_py_type
#define sipType_QStyleOptionViewItem_StyleOptionType              sipModuleAPI_QtGui.em_types[549]
#define sipEnum_QStyleOptionViewItem_StyleOptionType              sipModuleAPI_QtGui.em_types[549]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyleOptionViewItem;

#define sipType_QStyleOptionToolBox              sipModuleAPI_QtGui.em_types[535]
#define sipClass_QStyleOptionToolBox             sipModuleAPI_QtGui.em_types[535]->u.td_wrapper_type

#define sipType_QStyleOptionToolBox_StyleOptionVersion              sipModuleAPI_QtGui.em_types[537]
#define sipEnum_QStyleOptionToolBox_StyleOptionVersion              sipModuleAPI_QtGui.em_types[537]->u.td_py_type
#define sipType_QStyleOptionToolBox_StyleOptionType              sipModuleAPI_QtGui.em_types[536]
#define sipEnum_QStyleOptionToolBox_StyleOptionType              sipModuleAPI_QtGui.em_types[536]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyleOptionToolBox;

#define sipType_QStyleOptionRubberBand              sipModuleAPI_QtGui.em_types[495]
#define sipClass_QStyleOptionRubberBand             sipModuleAPI_QtGui.em_types[495]->u.td_wrapper_type

#define sipType_QStyleOptionRubberBand_StyleOptionVersion              sipModuleAPI_QtGui.em_types[497]
#define sipEnum_QStyleOptionRubberBand_StyleOptionVersion              sipModuleAPI_QtGui.em_types[497]->u.td_py_type
#define sipType_QStyleOptionRubberBand_StyleOptionType              sipModuleAPI_QtGui.em_types[496]
#define sipEnum_QStyleOptionRubberBand_StyleOptionType              sipModuleAPI_QtGui.em_types[496]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyleOptionRubberBand;

#define sipType_QStyleOptionComplex              sipModuleAPI_QtGui.em_types[452]
#define sipClass_QStyleOptionComplex             sipModuleAPI_QtGui.em_types[452]->u.td_wrapper_type

#define sipType_QStyleOptionComplex_StyleOptionVersion              sipModuleAPI_QtGui.em_types[454]
#define sipEnum_QStyleOptionComplex_StyleOptionVersion              sipModuleAPI_QtGui.em_types[454]->u.td_py_type
#define sipType_QStyleOptionComplex_StyleOptionType              sipModuleAPI_QtGui.em_types[453]
#define sipEnum_QStyleOptionComplex_StyleOptionType              sipModuleAPI_QtGui.em_types[453]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyleOptionComplex;

#define sipType_QStyleOptionSlider              sipModuleAPI_QtGui.em_types[501]
#define sipClass_QStyleOptionSlider             sipModuleAPI_QtGui.em_types[501]->u.td_wrapper_type

#define sipType_QStyleOptionSlider_StyleOptionVersion              sipModuleAPI_QtGui.em_types[503]
#define sipEnum_QStyleOptionSlider_StyleOptionVersion              sipModuleAPI_QtGui.em_types[503]->u.td_py_type
#define sipType_QStyleOptionSlider_StyleOptionType              sipModuleAPI_QtGui.em_types[502]
#define sipEnum_QStyleOptionSlider_StyleOptionType              sipModuleAPI_QtGui.em_types[502]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyleOptionSlider;

#define sipType_QStyleOptionSpinBox              sipModuleAPI_QtGui.em_types[504]
#define sipClass_QStyleOptionSpinBox             sipModuleAPI_QtGui.em_types[504]->u.td_wrapper_type

#define sipType_QStyleOptionSpinBox_StyleOptionVersion              sipModuleAPI_QtGui.em_types[506]
#define sipEnum_QStyleOptionSpinBox_StyleOptionVersion              sipModuleAPI_QtGui.em_types[506]->u.td_py_type
#define sipType_QStyleOptionSpinBox_StyleOptionType              sipModuleAPI_QtGui.em_types[505]
#define sipEnum_QStyleOptionSpinBox_StyleOptionType              sipModuleAPI_QtGui.em_types[505]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyleOptionSpinBox;

#define sipType_QStyleOptionToolButton              sipModuleAPI_QtGui.em_types[542]
#define sipClass_QStyleOptionToolButton             sipModuleAPI_QtGui.em_types[542]->u.td_wrapper_type

#define sipType_QStyleOptionToolButton_ToolButtonFeature              sipModuleAPI_QtGui.em_types[545]
#define sipEnum_QStyleOptionToolButton_ToolButtonFeature              sipModuleAPI_QtGui.em_types[545]->u.td_py_type
#define sipType_QStyleOptionToolButton_StyleOptionVersion              sipModuleAPI_QtGui.em_types[544]
#define sipEnum_QStyleOptionToolButton_StyleOptionVersion              sipModuleAPI_QtGui.em_types[544]->u.td_py_type
#define sipType_QStyleOptionToolButton_StyleOptionType              sipModuleAPI_QtGui.em_types[543]
#define sipEnum_QStyleOptionToolButton_StyleOptionType              sipModuleAPI_QtGui.em_types[543]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyleOptionToolButton;

#define sipType_QStyleOptionToolButton_ToolButtonFeatures              sipModuleAPI_QtGui.em_types[546]
#define sipClass_QStyleOptionToolButton_ToolButtonFeatures             sipModuleAPI_QtGui.em_types[546]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyleOptionToolButton_ToolButtonFeatures;

#define sipType_QStyleOptionComboBox              sipModuleAPI_QtGui.em_types[449]
#define sipClass_QStyleOptionComboBox             sipModuleAPI_QtGui.em_types[449]->u.td_wrapper_type

#define sipType_QStyleOptionComboBox_StyleOptionVersion              sipModuleAPI_QtGui.em_types[451]
#define sipEnum_QStyleOptionComboBox_StyleOptionVersion              sipModuleAPI_QtGui.em_types[451]->u.td_py_type
#define sipType_QStyleOptionComboBox_StyleOptionType              sipModuleAPI_QtGui.em_types[450]
#define sipEnum_QStyleOptionComboBox_StyleOptionType              sipModuleAPI_QtGui.em_types[450]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyleOptionComboBox;

#define sipType_QStyleOptionTitleBar              sipModuleAPI_QtGui.em_types[526]
#define sipClass_QStyleOptionTitleBar             sipModuleAPI_QtGui.em_types[526]->u.td_wrapper_type

#define sipType_QStyleOptionTitleBar_StyleOptionVersion              sipModuleAPI_QtGui.em_types[528]
#define sipEnum_QStyleOptionTitleBar_StyleOptionVersion              sipModuleAPI_QtGui.em_types[528]->u.td_py_type
#define sipType_QStyleOptionTitleBar_StyleOptionType              sipModuleAPI_QtGui.em_types[527]
#define sipEnum_QStyleOptionTitleBar_StyleOptionType              sipModuleAPI_QtGui.em_types[527]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyleOptionTitleBar;

#define sipType_QStyleHintReturn              sipModuleAPI_QtGui.em_types[430]
#define sipClass_QStyleHintReturn             sipModuleAPI_QtGui.em_types[430]->u.td_wrapper_type

#define sipType_QStyleHintReturn_StyleOptionVersion              sipModuleAPI_QtGui.em_types[433]
#define sipEnum_QStyleHintReturn_StyleOptionVersion              sipModuleAPI_QtGui.em_types[433]->u.td_py_type
#define sipType_QStyleHintReturn_StyleOptionType              sipModuleAPI_QtGui.em_types[432]
#define sipEnum_QStyleHintReturn_StyleOptionType              sipModuleAPI_QtGui.em_types[432]->u.td_py_type
#define sipType_QStyleHintReturn_HintReturnType              sipModuleAPI_QtGui.em_types[431]
#define sipEnum_QStyleHintReturn_HintReturnType              sipModuleAPI_QtGui.em_types[431]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyleHintReturn;

#define sipType_QStyleHintReturnMask              sipModuleAPI_QtGui.em_types[434]
#define sipClass_QStyleHintReturnMask             sipModuleAPI_QtGui.em_types[434]->u.td_wrapper_type

#define sipType_QStyleHintReturnMask_StyleOptionVersion              sipModuleAPI_QtGui.em_types[436]
#define sipEnum_QStyleHintReturnMask_StyleOptionVersion              sipModuleAPI_QtGui.em_types[436]->u.td_py_type
#define sipType_QStyleHintReturnMask_StyleOptionType              sipModuleAPI_QtGui.em_types[435]
#define sipEnum_QStyleHintReturnMask_StyleOptionType              sipModuleAPI_QtGui.em_types[435]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyleHintReturnMask;

#define sipType_QStyleOptionToolBar              sipModuleAPI_QtGui.em_types[529]
#define sipClass_QStyleOptionToolBar             sipModuleAPI_QtGui.em_types[529]->u.td_wrapper_type

#define sipType_QStyleOptionToolBar_ToolBarFeature              sipModuleAPI_QtGui.em_types[532]
#define sipEnum_QStyleOptionToolBar_ToolBarFeature              sipModuleAPI_QtGui.em_types[532]->u.td_py_type
#define sipType_QStyleOptionToolBar_ToolBarPosition              sipModuleAPI_QtGui.em_types[534]
#define sipEnum_QStyleOptionToolBar_ToolBarPosition              sipModuleAPI_QtGui.em_types[534]->u.td_py_type
#define sipType_QStyleOptionToolBar_StyleOptionVersion              sipModuleAPI_QtGui.em_types[531]
#define sipEnum_QStyleOptionToolBar_StyleOptionVersion              sipModuleAPI_QtGui.em_types[531]->u.td_py_type
#define sipType_QStyleOptionToolBar_StyleOptionType              sipModuleAPI_QtGui.em_types[530]
#define sipEnum_QStyleOptionToolBar_StyleOptionType              sipModuleAPI_QtGui.em_types[530]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyleOptionToolBar;

#define sipType_QStyleOptionToolBar_ToolBarFeatures              sipModuleAPI_QtGui.em_types[533]
#define sipClass_QStyleOptionToolBar_ToolBarFeatures             sipModuleAPI_QtGui.em_types[533]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyleOptionToolBar_ToolBarFeatures;

#define sipType_QStyleOptionGroupBox              sipModuleAPI_QtGui.em_types[475]
#define sipClass_QStyleOptionGroupBox             sipModuleAPI_QtGui.em_types[475]->u.td_wrapper_type

#define sipType_QStyleOptionGroupBox_StyleOptionVersion              sipModuleAPI_QtGui.em_types[477]
#define sipEnum_QStyleOptionGroupBox_StyleOptionVersion              sipModuleAPI_QtGui.em_types[477]->u.td_py_type
#define sipType_QStyleOptionGroupBox_StyleOptionType              sipModuleAPI_QtGui.em_types[476]
#define sipEnum_QStyleOptionGroupBox_StyleOptionType              sipModuleAPI_QtGui.em_types[476]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyleOptionGroupBox;

#define sipType_QStyleOptionViewItemV2              sipModuleAPI_QtGui.em_types[551]
#define sipClass_QStyleOptionViewItemV2             sipModuleAPI_QtGui.em_types[551]->u.td_wrapper_type

#define sipType_QStyleOptionViewItemV2_ViewItemFeature              sipModuleAPI_QtGui.em_types[553]
#define sipEnum_QStyleOptionViewItemV2_ViewItemFeature              sipModuleAPI_QtGui.em_types[553]->u.td_py_type
#define sipType_QStyleOptionViewItemV2_StyleOptionVersion              sipModuleAPI_QtGui.em_types[552]
#define sipEnum_QStyleOptionViewItemV2_StyleOptionVersion              sipModuleAPI_QtGui.em_types[552]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyleOptionViewItemV2;

#define sipType_QStyleOptionViewItemV2_ViewItemFeatures              sipModuleAPI_QtGui.em_types[554]
#define sipClass_QStyleOptionViewItemV2_ViewItemFeatures             sipModuleAPI_QtGui.em_types[554]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyleOptionViewItemV2_ViewItemFeatures;

#define sipType_QStyleOptionSizeGrip              sipModuleAPI_QtGui.em_types[498]
#define sipClass_QStyleOptionSizeGrip             sipModuleAPI_QtGui.em_types[498]->u.td_wrapper_type

#define sipType_QStyleOptionSizeGrip_StyleOptionVersion              sipModuleAPI_QtGui.em_types[500]
#define sipEnum_QStyleOptionSizeGrip_StyleOptionVersion              sipModuleAPI_QtGui.em_types[500]->u.td_py_type
#define sipType_QStyleOptionSizeGrip_StyleOptionType              sipModuleAPI_QtGui.em_types[499]
#define sipEnum_QStyleOptionSizeGrip_StyleOptionType              sipModuleAPI_QtGui.em_types[499]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyleOptionSizeGrip;

#define sipType_QStyleOptionGraphicsItem              sipModuleAPI_QtGui.em_types[472]
#define sipClass_QStyleOptionGraphicsItem             sipModuleAPI_QtGui.em_types[472]->u.td_wrapper_type

#define sipType_QStyleOptionGraphicsItem_StyleOptionVersion              sipModuleAPI_QtGui.em_types[474]
#define sipEnum_QStyleOptionGraphicsItem_StyleOptionVersion              sipModuleAPI_QtGui.em_types[474]->u.td_py_type
#define sipType_QStyleOptionGraphicsItem_StyleOptionType              sipModuleAPI_QtGui.em_types[473]
#define sipEnum_QStyleOptionGraphicsItem_StyleOptionType              sipModuleAPI_QtGui.em_types[473]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyleOptionGraphicsItem;

#define sipType_QStyleOptionDockWidgetV2              sipModuleAPI_QtGui.em_types[458]
#define sipClass_QStyleOptionDockWidgetV2             sipModuleAPI_QtGui.em_types[458]->u.td_wrapper_type

#define sipType_QStyleOptionDockWidgetV2_StyleOptionVersion              sipModuleAPI_QtGui.em_types[459]
#define sipEnum_QStyleOptionDockWidgetV2_StyleOptionVersion              sipModuleAPI_QtGui.em_types[459]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyleOptionDockWidgetV2;

#define sipType_QStyleOptionViewItemV3              sipModuleAPI_QtGui.em_types[555]
#define sipClass_QStyleOptionViewItemV3             sipModuleAPI_QtGui.em_types[555]->u.td_wrapper_type

#define sipType_QStyleOptionViewItemV3_StyleOptionVersion              sipModuleAPI_QtGui.em_types[556]
#define sipEnum_QStyleOptionViewItemV3_StyleOptionVersion              sipModuleAPI_QtGui.em_types[556]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyleOptionViewItemV3;

#define sipType_QStyleOptionToolBoxV2              sipModuleAPI_QtGui.em_types[538]
#define sipClass_QStyleOptionToolBoxV2             sipModuleAPI_QtGui.em_types[538]->u.td_wrapper_type

#define sipType_QStyleOptionToolBoxV2_SelectedPosition              sipModuleAPI_QtGui.em_types[539]
#define sipEnum_QStyleOptionToolBoxV2_SelectedPosition              sipModuleAPI_QtGui.em_types[539]->u.td_py_type
#define sipType_QStyleOptionToolBoxV2_TabPosition              sipModuleAPI_QtGui.em_types[541]
#define sipEnum_QStyleOptionToolBoxV2_TabPosition              sipModuleAPI_QtGui.em_types[541]->u.td_py_type
#define sipType_QStyleOptionToolBoxV2_StyleOptionVersion              sipModuleAPI_QtGui.em_types[540]
#define sipEnum_QStyleOptionToolBoxV2_StyleOptionVersion              sipModuleAPI_QtGui.em_types[540]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyleOptionToolBoxV2;

#define sipType_QStyleHintReturnVariant              sipModuleAPI_QtGui.em_types[437]
#define sipClass_QStyleHintReturnVariant             sipModuleAPI_QtGui.em_types[437]->u.td_wrapper_type

#define sipType_QStyleHintReturnVariant_StyleOptionVersion              sipModuleAPI_QtGui.em_types[439]
#define sipEnum_QStyleHintReturnVariant_StyleOptionVersion              sipModuleAPI_QtGui.em_types[439]->u.td_py_type
#define sipType_QStyleHintReturnVariant_StyleOptionType              sipModuleAPI_QtGui.em_types[438]
#define sipEnum_QStyleHintReturnVariant_StyleOptionType              sipModuleAPI_QtGui.em_types[438]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyleHintReturnVariant;

#define sipType_QStyleOptionViewItemV4              sipModuleAPI_QtGui.em_types[557]
#define sipClass_QStyleOptionViewItemV4             sipModuleAPI_QtGui.em_types[557]->u.td_wrapper_type

#define sipType_QStyleOptionViewItemV4_ViewItemPosition              sipModuleAPI_QtGui.em_types[559]
#define sipEnum_QStyleOptionViewItemV4_ViewItemPosition              sipModuleAPI_QtGui.em_types[559]->u.td_py_type
#define sipType_QStyleOptionViewItemV4_StyleOptionVersion              sipModuleAPI_QtGui.em_types[558]
#define sipEnum_QStyleOptionViewItemV4_StyleOptionVersion              sipModuleAPI_QtGui.em_types[558]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyleOptionViewItemV4;

#define sipType_QStyleOptionFrameV3              sipModuleAPI_QtGui.em_types[470]
#define sipClass_QStyleOptionFrameV3             sipModuleAPI_QtGui.em_types[470]->u.td_wrapper_type

#define sipType_QStyleOptionFrameV3_StyleOptionVersion              sipModuleAPI_QtGui.em_types[471]
#define sipEnum_QStyleOptionFrameV3_StyleOptionVersion              sipModuleAPI_QtGui.em_types[471]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyleOptionFrameV3;

#define sipType_QStyleOptionTabBarBaseV2              sipModuleAPI_QtGui.em_types[517]
#define sipClass_QStyleOptionTabBarBaseV2             sipModuleAPI_QtGui.em_types[517]->u.td_wrapper_type

#define sipType_QStyleOptionTabBarBaseV2_StyleOptionVersion              sipModuleAPI_QtGui.em_types[518]
#define sipEnum_QStyleOptionTabBarBaseV2_StyleOptionVersion              sipModuleAPI_QtGui.em_types[518]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyleOptionTabBarBaseV2;

#define sipType_QStyleOptionTabV3              sipModuleAPI_QtGui.em_types[521]
#define sipClass_QStyleOptionTabV3             sipModuleAPI_QtGui.em_types[521]->u.td_wrapper_type

#define sipType_QStyleOptionTabV3_StyleOptionVersion              sipModuleAPI_QtGui.em_types[522]
#define sipEnum_QStyleOptionTabV3_StyleOptionVersion              sipModuleAPI_QtGui.em_types[522]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStyleOptionTabV3;

#define sipType_QStylePainter              sipModuleAPI_QtGui.em_types[560]
#define sipClass_QStylePainter             sipModuleAPI_QtGui.em_types[560]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QStylePainter;

#define sipType_QSyntaxHighlighter              sipModuleAPI_QtGui.em_types[562]
#define sipClass_QSyntaxHighlighter             sipModuleAPI_QtGui.em_types[562]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QSyntaxHighlighter;

#define sipType_QSystemTrayIcon              sipModuleAPI_QtGui.em_types[563]
#define sipClass_QSystemTrayIcon             sipModuleAPI_QtGui.em_types[563]->u.td_wrapper_type

#define sipType_QSystemTrayIcon_MessageIcon              sipModuleAPI_QtGui.em_types[565]
#define sipEnum_QSystemTrayIcon_MessageIcon              sipModuleAPI_QtGui.em_types[565]->u.td_py_type
#define sipType_QSystemTrayIcon_ActivationReason              sipModuleAPI_QtGui.em_types[564]
#define sipEnum_QSystemTrayIcon_ActivationReason              sipModuleAPI_QtGui.em_types[564]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QSystemTrayIcon;

#define sipType_QTabBar              sipModuleAPI_QtGui.em_types[566]
#define sipClass_QTabBar             sipModuleAPI_QtGui.em_types[566]->u.td_wrapper_type

#define sipType_QTabBar_SelectionBehavior              sipModuleAPI_QtGui.em_types[568]
#define sipEnum_QTabBar_SelectionBehavior              sipModuleAPI_QtGui.em_types[568]->u.td_py_type
#define sipType_QTabBar_ButtonPosition              sipModuleAPI_QtGui.em_types[567]
#define sipEnum_QTabBar_ButtonPosition              sipModuleAPI_QtGui.em_types[567]->u.td_py_type
#define sipType_QTabBar_Shape              sipModuleAPI_QtGui.em_types[569]
#define sipEnum_QTabBar_Shape              sipModuleAPI_QtGui.em_types[569]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTabBar;

#define sipType_QTableView              sipModuleAPI_QtGui.em_types[573]
#define sipClass_QTableView             sipModuleAPI_QtGui.em_types[573]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTableView;

#define sipType_QTableWidgetSelectionRange              sipModuleAPI_QtGui.em_types[577]
#define sipClass_QTableWidgetSelectionRange             sipModuleAPI_QtGui.em_types[577]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTableWidgetSelectionRange;

#define sipType_QTableWidgetItem              sipModuleAPI_QtGui.em_types[575]
#define sipClass_QTableWidgetItem             sipModuleAPI_QtGui.em_types[575]->u.td_wrapper_type

#define sipType_QTableWidgetItem_ItemType              sipModuleAPI_QtGui.em_types[576]
#define sipEnum_QTableWidgetItem_ItemType              sipModuleAPI_QtGui.em_types[576]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTableWidgetItem;

#define sipType_QTableWidget              sipModuleAPI_QtGui.em_types[574]
#define sipClass_QTableWidget             sipModuleAPI_QtGui.em_types[574]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTableWidget;

#define sipType_QTabWidget              sipModuleAPI_QtGui.em_types[570]
#define sipClass_QTabWidget             sipModuleAPI_QtGui.em_types[570]->u.td_wrapper_type

#define sipType_QTabWidget_TabShape              sipModuleAPI_QtGui.em_types[572]
#define sipEnum_QTabWidget_TabShape              sipModuleAPI_QtGui.em_types[572]->u.td_py_type
#define sipType_QTabWidget_TabPosition              sipModuleAPI_QtGui.em_types[571]
#define sipEnum_QTabWidget_TabPosition              sipModuleAPI_QtGui.em_types[571]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTabWidget;

#define sipType_QTextEdit              sipModuleAPI_QtGui.em_types[601]
#define sipClass_QTextEdit             sipModuleAPI_QtGui.em_types[601]->u.td_wrapper_type

#define sipType_QTextEdit_AutoFormattingFlag              sipModuleAPI_QtGui.em_types[603]
#define sipEnum_QTextEdit_AutoFormattingFlag              sipModuleAPI_QtGui.em_types[603]->u.td_py_type
#define sipType_QTextEdit_LineWrapMode              sipModuleAPI_QtGui.em_types[605]
#define sipEnum_QTextEdit_LineWrapMode              sipModuleAPI_QtGui.em_types[605]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTextEdit;

#define sipType_QTextBrowser              sipModuleAPI_QtGui.em_types[586]
#define sipClass_QTextBrowser             sipModuleAPI_QtGui.em_types[586]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTextBrowser;

#define sipType_QTextCursor              sipModuleAPI_QtGui.em_types[590]
#define sipClass_QTextCursor             sipModuleAPI_QtGui.em_types[590]->u.td_wrapper_type

#define sipType_QTextCursor_SelectionType              sipModuleAPI_QtGui.em_types[593]
#define sipEnum_QTextCursor_SelectionType              sipModuleAPI_QtGui.em_types[593]->u.td_py_type
#define sipType_QTextCursor_MoveOperation              sipModuleAPI_QtGui.em_types[592]
#define sipEnum_QTextCursor_MoveOperation              sipModuleAPI_QtGui.em_types[592]->u.td_py_type
#define sipType_QTextCursor_MoveMode              sipModuleAPI_QtGui.em_types[591]
#define sipEnum_QTextCursor_MoveMode              sipModuleAPI_QtGui.em_types[591]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTextCursor;


#define sipType_Qt_WhiteSpaceMode              sipModuleAPI_QtGui.em_types[705]
#define sipEnum_Qt_WhiteSpaceMode              sipModuleAPI_QtGui.em_types[705]->u.td_py_type
#define sipType_Qt_HitTestAccuracy              sipModuleAPI_QtGui.em_types[704]
#define sipEnum_Qt_HitTestAccuracy              sipModuleAPI_QtGui.em_types[704]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_Qt;

#define sipType_QTextDocument              sipModuleAPI_QtGui.em_types[594]
#define sipClass_QTextDocument             sipModuleAPI_QtGui.em_types[594]->u.td_wrapper_type

#define sipType_QTextDocument_ResourceType              sipModuleAPI_QtGui.em_types[598]
#define sipEnum_QTextDocument_ResourceType              sipModuleAPI_QtGui.em_types[598]->u.td_py_type
#define sipType_QTextDocument_FindFlag              sipModuleAPI_QtGui.em_types[595]
#define sipEnum_QTextDocument_FindFlag              sipModuleAPI_QtGui.em_types[595]->u.td_py_type
#define sipType_QTextDocument_MetaInformation              sipModuleAPI_QtGui.em_types[597]
#define sipEnum_QTextDocument_MetaInformation              sipModuleAPI_QtGui.em_types[597]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTextDocument;

#define sipType_QTextDocument_FindFlags              sipModuleAPI_QtGui.em_types[596]
#define sipClass_QTextDocument_FindFlags             sipModuleAPI_QtGui.em_types[596]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTextDocument_FindFlags;

#define sipType_QTextDocumentFragment              sipModuleAPI_QtGui.em_types[599]
#define sipClass_QTextDocumentFragment             sipModuleAPI_QtGui.em_types[599]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTextDocumentFragment;

#define sipType_QTextDocumentWriter              sipModuleAPI_QtGui.em_types[600]
#define sipClass_QTextDocumentWriter             sipModuleAPI_QtGui.em_types[600]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTextDocumentWriter;

#define sipType_QTextEdit_ExtraSelection              sipModuleAPI_QtGui.em_types[604]
#define sipClass_QTextEdit_ExtraSelection             sipModuleAPI_QtGui.em_types[604]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTextEdit_ExtraSelection;

#define sipType_QTextEdit_AutoFormatting              sipModuleAPI_QtGui.em_types[602]
#define sipClass_QTextEdit_AutoFormatting             sipModuleAPI_QtGui.em_types[602]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTextEdit_AutoFormatting;

#define sipType_QTextLength              sipModuleAPI_QtGui.em_types[626]
#define sipClass_QTextLength             sipModuleAPI_QtGui.em_types[626]->u.td_wrapper_type

#define sipType_QTextLength_Type              sipModuleAPI_QtGui.em_types[627]
#define sipEnum_QTextLength_Type              sipModuleAPI_QtGui.em_types[627]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTextLength;

#define sipType_QTextFormat              sipModuleAPI_QtGui.em_types[606]
#define sipClass_QTextFormat             sipModuleAPI_QtGui.em_types[606]->u.td_wrapper_type

#define sipType_QTextFormat_Property              sipModuleAPI_QtGui.em_types[611]
#define sipEnum_QTextFormat_Property              sipModuleAPI_QtGui.em_types[611]->u.td_py_type
#define sipType_QTextFormat_PageBreakFlag              sipModuleAPI_QtGui.em_types[609]
#define sipEnum_QTextFormat_PageBreakFlag              sipModuleAPI_QtGui.em_types[609]->u.td_py_type
#define sipType_QTextFormat_ObjectTypes              sipModuleAPI_QtGui.em_types[608]
#define sipEnum_QTextFormat_ObjectTypes              sipModuleAPI_QtGui.em_types[608]->u.td_py_type
#define sipType_QTextFormat_FormatType              sipModuleAPI_QtGui.em_types[607]
#define sipEnum_QTextFormat_FormatType              sipModuleAPI_QtGui.em_types[607]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTextFormat;

#define sipType_QTextFormat_PageBreakFlags              sipModuleAPI_QtGui.em_types[610]
#define sipClass_QTextFormat_PageBreakFlags             sipModuleAPI_QtGui.em_types[610]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTextFormat_PageBreakFlags;

#define sipType_QTextCharFormat              sipModuleAPI_QtGui.em_types[587]
#define sipClass_QTextCharFormat             sipModuleAPI_QtGui.em_types[587]->u.td_wrapper_type

#define sipType_QTextCharFormat_UnderlineStyle              sipModuleAPI_QtGui.em_types[588]
#define sipEnum_QTextCharFormat_UnderlineStyle              sipModuleAPI_QtGui.em_types[588]->u.td_py_type
#define sipType_QTextCharFormat_VerticalAlignment              sipModuleAPI_QtGui.em_types[589]
#define sipEnum_QTextCharFormat_VerticalAlignment              sipModuleAPI_QtGui.em_types[589]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTextCharFormat;

#define sipType_QTextBlockFormat              sipModuleAPI_QtGui.em_types[583]
#define sipClass_QTextBlockFormat             sipModuleAPI_QtGui.em_types[583]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTextBlockFormat;

#define sipType_QTextListFormat              sipModuleAPI_QtGui.em_types[632]
#define sipClass_QTextListFormat             sipModuleAPI_QtGui.em_types[632]->u.td_wrapper_type

#define sipType_QTextListFormat_Style              sipModuleAPI_QtGui.em_types[633]
#define sipEnum_QTextListFormat_Style              sipModuleAPI_QtGui.em_types[633]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTextListFormat;

#define sipType_QTextImageFormat              sipModuleAPI_QtGui.em_types[618]
#define sipClass_QTextImageFormat             sipModuleAPI_QtGui.em_types[618]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTextImageFormat;

#define sipType_QTextFrameFormat              sipModuleAPI_QtGui.em_types[615]
#define sipClass_QTextFrameFormat             sipModuleAPI_QtGui.em_types[615]->u.td_wrapper_type

#define sipType_QTextFrameFormat_BorderStyle              sipModuleAPI_QtGui.em_types[616]
#define sipEnum_QTextFrameFormat_BorderStyle              sipModuleAPI_QtGui.em_types[616]->u.td_py_type
#define sipType_QTextFrameFormat_Position              sipModuleAPI_QtGui.em_types[617]
#define sipEnum_QTextFrameFormat_Position              sipModuleAPI_QtGui.em_types[617]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTextFrameFormat;

#define sipType_QTextTableFormat              sipModuleAPI_QtGui.em_types[645]
#define sipClass_QTextTableFormat             sipModuleAPI_QtGui.em_types[645]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTextTableFormat;

#define sipType_QTextTableCellFormat              sipModuleAPI_QtGui.em_types[644]
#define sipClass_QTextTableCellFormat             sipModuleAPI_QtGui.em_types[644]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTextTableCellFormat;

#define sipType_QTextInlineObject              sipModuleAPI_QtGui.em_types[619]
#define sipClass_QTextInlineObject             sipModuleAPI_QtGui.em_types[619]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTextInlineObject;

#define sipType_QTextLayout              sipModuleAPI_QtGui.em_types[623]
#define sipClass_QTextLayout             sipModuleAPI_QtGui.em_types[623]->u.td_wrapper_type

#define sipType_QTextLayout_CursorMode              sipModuleAPI_QtGui.em_types[624]
#define sipEnum_QTextLayout_CursorMode              sipModuleAPI_QtGui.em_types[624]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTextLayout;

#define sipType_QTextLayout_FormatRange              sipModuleAPI_QtGui.em_types[625]
#define sipClass_QTextLayout_FormatRange             sipModuleAPI_QtGui.em_types[625]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTextLayout_FormatRange;

#define sipType_QTextLine              sipModuleAPI_QtGui.em_types[628]
#define sipClass_QTextLine             sipModuleAPI_QtGui.em_types[628]->u.td_wrapper_type

#define sipType_QTextLine_CursorPosition              sipModuleAPI_QtGui.em_types[629]
#define sipEnum_QTextLine_CursorPosition              sipModuleAPI_QtGui.em_types[629]->u.td_py_type
#define sipType_QTextLine_Edge              sipModuleAPI_QtGui.em_types[630]
#define sipEnum_QTextLine_Edge              sipModuleAPI_QtGui.em_types[630]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTextLine;

#define sipType_QTextObject              sipModuleAPI_QtGui.em_types[634]
#define sipClass_QTextObject             sipModuleAPI_QtGui.em_types[634]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTextObject;

#define sipType_QTextBlockGroup              sipModuleAPI_QtGui.em_types[584]
#define sipClass_QTextBlockGroup             sipModuleAPI_QtGui.em_types[584]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTextBlockGroup;

#define sipType_QTextList              sipModuleAPI_QtGui.em_types[631]
#define sipClass_QTextList             sipModuleAPI_QtGui.em_types[631]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTextList;

#define sipType_QTextFrame              sipModuleAPI_QtGui.em_types[613]
#define sipClass_QTextFrame             sipModuleAPI_QtGui.em_types[613]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTextFrame;

#define sipType_QTextFrame_iterator              sipModuleAPI_QtGui.em_types[614]
#define sipClass_QTextFrame_iterator             sipModuleAPI_QtGui.em_types[614]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTextFrame_iterator;

#define sipType_QTextBlock              sipModuleAPI_QtGui.em_types[581]
#define sipClass_QTextBlock             sipModuleAPI_QtGui.em_types[581]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTextBlock;

#define sipType_QTextBlock_iterator              sipModuleAPI_QtGui.em_types[582]
#define sipClass_QTextBlock_iterator             sipModuleAPI_QtGui.em_types[582]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTextBlock_iterator;

#define sipType_QTextFragment              sipModuleAPI_QtGui.em_types[612]
#define sipClass_QTextFragment             sipModuleAPI_QtGui.em_types[612]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTextFragment;

#define sipType_QTextBlockUserData              sipModuleAPI_QtGui.em_types[585]
#define sipClass_QTextBlockUserData             sipModuleAPI_QtGui.em_types[585]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTextBlockUserData;

#define sipType_QTextOption              sipModuleAPI_QtGui.em_types[636]
#define sipClass_QTextOption             sipModuleAPI_QtGui.em_types[636]->u.td_wrapper_type

#define sipType_QTextOption_TabType              sipModuleAPI_QtGui.em_types[640]
#define sipEnum_QTextOption_TabType              sipModuleAPI_QtGui.em_types[640]->u.td_py_type
#define sipType_QTextOption_Flag              sipModuleAPI_QtGui.em_types[637]
#define sipEnum_QTextOption_Flag              sipModuleAPI_QtGui.em_types[637]->u.td_py_type
#define sipType_QTextOption_WrapMode              sipModuleAPI_QtGui.em_types[641]
#define sipEnum_QTextOption_WrapMode              sipModuleAPI_QtGui.em_types[641]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTextOption;

#define sipType_QTextOption_Flags              sipModuleAPI_QtGui.em_types[638]
#define sipClass_QTextOption_Flags             sipModuleAPI_QtGui.em_types[638]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTextOption_Flags;

#define sipType_QTextOption_Tab              sipModuleAPI_QtGui.em_types[639]
#define sipClass_QTextOption_Tab             sipModuleAPI_QtGui.em_types[639]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTextOption_Tab;

#define sipType_QTextTableCell              sipModuleAPI_QtGui.em_types[643]
#define sipClass_QTextTableCell             sipModuleAPI_QtGui.em_types[643]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTextTableCell;

#define sipType_QTextTable              sipModuleAPI_QtGui.em_types[642]
#define sipClass_QTextTable             sipModuleAPI_QtGui.em_types[642]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTextTable;

#define sipType_QToolBar              sipModuleAPI_QtGui.em_types[647]
#define sipClass_QToolBar             sipModuleAPI_QtGui.em_types[647]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QToolBar;

#define sipType_QToolBox              sipModuleAPI_QtGui.em_types[648]
#define sipClass_QToolBox             sipModuleAPI_QtGui.em_types[648]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QToolBox;

#define sipType_QToolButton              sipModuleAPI_QtGui.em_types[649]
#define sipClass_QToolButton             sipModuleAPI_QtGui.em_types[649]->u.td_wrapper_type

#define sipType_QToolButton_ToolButtonPopupMode              sipModuleAPI_QtGui.em_types[650]
#define sipEnum_QToolButton_ToolButtonPopupMode              sipModuleAPI_QtGui.em_types[650]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QToolButton;

#define sipType_QToolTip              sipModuleAPI_QtGui.em_types[651]
#define sipClass_QToolTip             sipModuleAPI_QtGui.em_types[651]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QToolTip;

#define sipType_QTransform              sipModuleAPI_QtGui.em_types[652]
#define sipClass_QTransform             sipModuleAPI_QtGui.em_types[652]->u.td_wrapper_type

#define sipType_QTransform_TransformationType              sipModuleAPI_QtGui.em_types[653]
#define sipEnum_QTransform_TransformationType              sipModuleAPI_QtGui.em_types[653]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTransform;

#define sipType_QTreeView              sipModuleAPI_QtGui.em_types[654]
#define sipClass_QTreeView             sipModuleAPI_QtGui.em_types[654]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTreeView;

#define sipType_QTreeWidgetItem              sipModuleAPI_QtGui.em_types[656]
#define sipClass_QTreeWidgetItem             sipModuleAPI_QtGui.em_types[656]->u.td_wrapper_type

#define sipType_QTreeWidgetItem_ChildIndicatorPolicy              sipModuleAPI_QtGui.em_types[657]
#define sipEnum_QTreeWidgetItem_ChildIndicatorPolicy              sipModuleAPI_QtGui.em_types[657]->u.td_py_type
#define sipType_QTreeWidgetItem_ItemType              sipModuleAPI_QtGui.em_types[658]
#define sipEnum_QTreeWidgetItem_ItemType              sipModuleAPI_QtGui.em_types[658]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTreeWidgetItem;

#define sipType_QTreeWidget              sipModuleAPI_QtGui.em_types[655]
#define sipClass_QTreeWidget             sipModuleAPI_QtGui.em_types[655]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTreeWidget;

#define sipType_QTreeWidgetItemIterator              sipModuleAPI_QtGui.em_types[659]
#define sipClass_QTreeWidgetItemIterator             sipModuleAPI_QtGui.em_types[659]->u.td_wrapper_type

#define sipType_QTreeWidgetItemIterator_IteratorFlag              sipModuleAPI_QtGui.em_types[660]
#define sipEnum_QTreeWidgetItemIterator_IteratorFlag              sipModuleAPI_QtGui.em_types[660]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTreeWidgetItemIterator;

#define sipType_QTreeWidgetItemIterator_IteratorFlags              sipModuleAPI_QtGui.em_types[661]
#define sipClass_QTreeWidgetItemIterator_IteratorFlags             sipModuleAPI_QtGui.em_types[661]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QTreeWidgetItemIterator_IteratorFlags;

#define sipType_QUndoGroup              sipModuleAPI_QtGui.em_types[663]
#define sipClass_QUndoGroup             sipModuleAPI_QtGui.em_types[663]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QUndoGroup;

#define sipType_QUndoCommand              sipModuleAPI_QtGui.em_types[662]
#define sipClass_QUndoCommand             sipModuleAPI_QtGui.em_types[662]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QUndoCommand;

#define sipType_QUndoStack              sipModuleAPI_QtGui.em_types[664]
#define sipClass_QUndoStack             sipModuleAPI_QtGui.em_types[664]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QUndoStack;

#define sipType_QUndoView              sipModuleAPI_QtGui.em_types[665]
#define sipClass_QUndoView             sipModuleAPI_QtGui.em_types[665]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QUndoView;

#define sipType_QValidator              sipModuleAPI_QtGui.em_types[667]
#define sipClass_QValidator             sipModuleAPI_QtGui.em_types[667]->u.td_wrapper_type

#define sipType_QValidator_State              sipModuleAPI_QtGui.em_types[668]
#define sipEnum_QValidator_State              sipModuleAPI_QtGui.em_types[668]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QValidator;

#define sipType_QIntValidator              sipModuleAPI_QtGui.em_types[227]
#define sipClass_QIntValidator             sipModuleAPI_QtGui.em_types[227]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QIntValidator;

#define sipType_QDoubleValidator              sipModuleAPI_QtGui.em_types[94]
#define sipClass_QDoubleValidator             sipModuleAPI_QtGui.em_types[94]->u.td_wrapper_type

#define sipType_QDoubleValidator_Notation              sipModuleAPI_QtGui.em_types[95]
#define sipEnum_QDoubleValidator_Notation              sipModuleAPI_QtGui.em_types[95]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QDoubleValidator;

#define sipType_QRegExpValidator              sipModuleAPI_QtGui.em_types[379]
#define sipClass_QRegExpValidator             sipModuleAPI_QtGui.em_types[379]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QRegExpValidator;

#define sipType_QWhatsThis              sipModuleAPI_QtGui.em_types[680]
#define sipClass_QWhatsThis             sipModuleAPI_QtGui.em_types[680]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QWhatsThis;

#define sipType_QWidget_RenderFlags              sipModuleAPI_QtGui.em_types[685]
#define sipClass_QWidget_RenderFlags             sipModuleAPI_QtGui.em_types[685]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QWidget_RenderFlags;

#define sipType_QWidgetAction              sipModuleAPI_QtGui.em_types[686]
#define sipClass_QWidgetAction             sipModuleAPI_QtGui.em_types[686]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QWidgetAction;

#define sipType_QWizard              sipModuleAPI_QtGui.em_types[689]
#define sipClass_QWizard             sipModuleAPI_QtGui.em_types[689]->u.td_wrapper_type

#define sipType_QWizard_WizardOption              sipModuleAPI_QtGui.em_types[691]
#define sipEnum_QWizard_WizardOption              sipModuleAPI_QtGui.em_types[691]->u.td_py_type
#define sipType_QWizard_WizardStyle              sipModuleAPI_QtGui.em_types[694]
#define sipEnum_QWizard_WizardStyle              sipModuleAPI_QtGui.em_types[694]->u.td_py_type
#define sipType_QWizard_WizardPixmap              sipModuleAPI_QtGui.em_types[693]
#define sipEnum_QWizard_WizardPixmap              sipModuleAPI_QtGui.em_types[693]->u.td_py_type
#define sipType_QWizard_WizardButton              sipModuleAPI_QtGui.em_types[690]
#define sipEnum_QWizard_WizardButton              sipModuleAPI_QtGui.em_types[690]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QWizard;

#define sipType_QWizard_WizardOptions              sipModuleAPI_QtGui.em_types[692]
#define sipClass_QWizard_WizardOptions             sipModuleAPI_QtGui.em_types[692]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QWizard_WizardOptions;

#define sipType_QWizardPage              sipModuleAPI_QtGui.em_types[695]
#define sipClass_QWizardPage             sipModuleAPI_QtGui.em_types[695]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QWizardPage;

#define sipType_QWorkspace              sipModuleAPI_QtGui.em_types[696]
#define sipClass_QWorkspace             sipModuleAPI_QtGui.em_types[696]->u.td_wrapper_type

#define sipType_QWorkspace_WindowOrder              sipModuleAPI_QtGui.em_types[697]
#define sipEnum_QWorkspace_WindowOrder              sipModuleAPI_QtGui.em_types[697]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QWorkspace;

#define sipType_QX11EmbedWidget              sipModuleAPI_QtGui.em_types[700]
#define sipClass_QX11EmbedWidget             sipModuleAPI_QtGui.em_types[700]->u.td_wrapper_type

#define sipType_QX11EmbedWidget_Error              sipModuleAPI_QtGui.em_types[701]
#define sipEnum_QX11EmbedWidget_Error              sipModuleAPI_QtGui.em_types[701]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QX11EmbedWidget;

#define sipType_QX11EmbedContainer              sipModuleAPI_QtGui.em_types[698]
#define sipClass_QX11EmbedContainer             sipModuleAPI_QtGui.em_types[698]->u.td_wrapper_type

#define sipType_QX11EmbedContainer_Error              sipModuleAPI_QtGui.em_types[699]
#define sipEnum_QX11EmbedContainer_Error              sipModuleAPI_QtGui.em_types[699]->u.td_py_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QX11EmbedContainer;

#define sipType_Display              sipModuleAPI_QtGui.em_types[0]
#define sipClass_Display             sipModuleAPI_QtGui.em_types[0]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_Display;

#define sipType_QX11Info              sipModuleAPI_QtGui.em_types[702]
#define sipClass_QX11Info             sipModuleAPI_QtGui.em_types[702]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QX11Info;

#define sipType_QPyTextObject              sipModuleAPI_QtGui.em_types[376]
#define sipClass_QPyTextObject             sipModuleAPI_QtGui.em_types[376]->u.td_wrapper_type

extern pyqt4ClassTypeDef sipTypeDef_QtGui_QPyTextObject;

#define sipType_QList_0101QUndoStack      sipModuleAPI_QtGui.em_types[277]

extern sipMappedTypeDef sipTypeDef_QtGui_QList_0101QUndoStack;

#define sipType_QList_0101QTreeWidgetItem      sipModuleAPI_QtGui.em_types[276]

extern sipMappedTypeDef sipTypeDef_QtGui_QList_0101QTreeWidgetItem;

#define sipType_QList_0101QTextFrame      sipModuleAPI_QtGui.em_types[273]

extern sipMappedTypeDef sipTypeDef_QtGui_QList_0101QTextFrame;

#define sipType_QList_0100QTextBlock      sipModuleAPI_QtGui.em_types[271]

extern sipMappedTypeDef sipTypeDef_QtGui_QList_0100QTextBlock;

#define sipType_QVector_0100QTextLayout_FormatRange      sipModuleAPI_QtGui.em_types[678]

extern sipMappedTypeDef sipTypeDef_QtGui_QVector_0100QTextLayout_FormatRange;

#define sipType_QList_0100QTextLayout_FormatRange      sipModuleAPI_QtGui.em_types[274]

extern sipMappedTypeDef sipTypeDef_QtGui_QList_0100QTextLayout_FormatRange;

#define sipType_QList_0100QTextOption_Tab      sipModuleAPI_QtGui.em_types[275]

extern sipMappedTypeDef sipTypeDef_QtGui_QList_0100QTextOption_Tab;

#define sipType_QVector_0100QTextLength      sipModuleAPI_QtGui.em_types[679]

extern sipMappedTypeDef sipTypeDef_QtGui_QVector_0100QTextLength;

#define sipType_QVector_0100QTextFormat      sipModuleAPI_QtGui.em_types[677]

extern sipMappedTypeDef sipTypeDef_QtGui_QVector_0100QTextFormat;

#define sipType_QList_0101QTableWidgetItem      sipModuleAPI_QtGui.em_types[269]

extern sipMappedTypeDef sipTypeDef_QtGui_QList_0101QTableWidgetItem;

#define sipType_QList_0100QTableWidgetSelectionRange      sipModuleAPI_QtGui.em_types[270]

extern sipMappedTypeDef sipTypeDef_QtGui_QList_0100QTableWidgetSelectionRange;

#define sipType_QList_0101QStandardItem      sipModuleAPI_QtGui.em_types[268]

extern sipMappedTypeDef sipTypeDef_QtGui_QList_0101QStandardItem;

#define sipType_QList_0100QPrinterInfo      sipModuleAPI_QtGui.em_types[265]

extern sipMappedTypeDef sipTypeDef_QtGui_QList_0100QPrinterInfo;

#define sipType_QList_0100QTextEdit_ExtraSelection      sipModuleAPI_QtGui.em_types[272]

extern sipMappedTypeDef sipTypeDef_QtGui_QList_0100QTextEdit_ExtraSelection;

#define sipType_QList_0100QPolygonF      sipModuleAPI_QtGui.em_types[263]

extern sipMappedTypeDef sipTypeDef_QtGui_QList_0100QPolygonF;

#define sipType_QVector_0100QRect      sipModuleAPI_QtGui.em_types[675]

extern sipMappedTypeDef sipTypeDef_QtGui_QVector_0100QRect;

#define sipType_QVector_0100QRectF      sipModuleAPI_QtGui.em_types[676]

extern sipMappedTypeDef sipTypeDef_QtGui_QVector_0100QRectF;

#define sipType_QVector_0100QPoint      sipModuleAPI_QtGui.em_types[673]

extern sipMappedTypeDef sipTypeDef_QtGui_QVector_0100QPoint;

#define sipType_QVector_0100QLine      sipModuleAPI_QtGui.em_types[670]

extern sipMappedTypeDef sipTypeDef_QtGui_QVector_0100QLine;

#define sipType_QVector_0100QPointF      sipModuleAPI_QtGui.em_types[674]

extern sipMappedTypeDef sipTypeDef_QtGui_QVector_0100QPointF;

#define sipType_QVector_0100QLineF      sipModuleAPI_QtGui.em_types[671]

extern sipMappedTypeDef sipTypeDef_QtGui_QVector_0100QLineF;

#define sipType_QList_0101QMdiSubWindow      sipModuleAPI_QtGui.em_types[261]

extern sipMappedTypeDef sipTypeDef_QtGui_QList_0101QMdiSubWindow;

#define sipType_QList_0101QDockWidget      sipModuleAPI_QtGui.em_types[253]

extern sipMappedTypeDef sipTypeDef_QtGui_QList_0101QDockWidget;

#define sipType_QList_0101QListWidgetItem      sipModuleAPI_QtGui.em_types[260]

extern sipMappedTypeDef sipTypeDef_QtGui_QList_0101QListWidgetItem;

#define sipType_QList_0100QRectF      sipModuleAPI_QtGui.em_types[266]

extern sipMappedTypeDef sipTypeDef_QtGui_QList_0100QRectF;

#define sipType_QList_0101QGraphicsView      sipModuleAPI_QtGui.em_types[256]

extern sipMappedTypeDef sipTypeDef_QtGui_QList_0101QGraphicsView;

#define sipType_QList_0600QPair_2400_0100QPointF      sipModuleAPI_QtGui.em_types[262]

extern sipMappedTypeDef sipTypeDef_QtGui_QList_0600QPair_2400_0100QPointF;

#define sipType_QList_0101QGraphicsItem      sipModuleAPI_QtGui.em_types[255]

extern sipMappedTypeDef sipTypeDef_QtGui_QList_0101QGraphicsItem;

#define sipType_QList_0100QInputMethodEvent_Attribute      sipModuleAPI_QtGui.em_types[258]

extern sipMappedTypeDef sipTypeDef_QtGui_QList_0100QInputMethodEvent_Attribute;

#define sipType_QMap_0100QDate_0100QTextCharFormat      sipModuleAPI_QtGui.em_types[292]

extern sipMappedTypeDef sipTypeDef_QtGui_QMap_0100QDate_0100QTextCharFormat;

#define sipType_QList_0101QAbstractButton      sipModuleAPI_QtGui.em_types[251]

extern sipMappedTypeDef sipTypeDef_QtGui_QList_0101QAbstractButton;

#define sipType_QList_0101QGraphicsWidget      sipModuleAPI_QtGui.em_types[257]

extern sipMappedTypeDef sipTypeDef_QtGui_QList_0101QGraphicsWidget;

#define sipType_QList_0100QKeySequence      sipModuleAPI_QtGui.em_types[259]

extern sipMappedTypeDef sipTypeDef_QtGui_QList_0100QKeySequence;

#define sipType_QList_0101QAction      sipModuleAPI_QtGui.em_types[252]

extern sipMappedTypeDef sipTypeDef_QtGui_QList_0101QAction;

#define sipType_QList_0100QSize      sipModuleAPI_QtGui.em_types[267]

extern sipMappedTypeDef sipTypeDef_QtGui_QList_0100QSize;

#define sipType_QVector_0100QAbstractTextDocumentLayout_Selection      sipModuleAPI_QtGui.em_types[669]

extern sipMappedTypeDef sipTypeDef_QtGui_QVector_0100QAbstractTextDocumentLayout_Selection;

#define sipType_QList_0101QWidget      sipModuleAPI_QtGui.em_types[278]

extern sipMappedTypeDef sipTypeDef_QtGui_QList_0101QWidget;

#define sipType_QVector_0600QPair_2400_0100QColor      sipModuleAPI_QtGui.em_types[672]

extern sipMappedTypeDef sipTypeDef_QtGui_QVector_0600QPair_2400_0100QColor;

#define sipType_QList_0100QWizard_WizardButton      sipModuleAPI_QtGui.em_types[279]

extern sipMappedTypeDef sipTypeDef_QtGui_QList_0100QWizard_WizardButton;

#define sipType_QList_0100QPrinter_PageSize      sipModuleAPI_QtGui.em_types[264]

extern sipMappedTypeDef sipTypeDef_QtGui_QList_0100QPrinter_PageSize;

#define sipType_QList_0100QFontDatabase_WritingSystem      sipModuleAPI_QtGui.em_types[254]

extern sipMappedTypeDef sipTypeDef_QtGui_QList_0100QFontDatabase_WritingSystem;

#define sipType_XEvent      sipModuleAPI_QtGui.em_types[706]

extern sipMappedTypeDef sipTypeDef_QtGui_XEvent;

/* The SIP API, this module's API and the APIs of any imported modules. */
extern const sipAPIDef *sipAPI_QtGui;
extern sipExportedModuleDef sipModuleAPI_QtGui;

#define sipType_QSysInfo              sipModuleAPI_QtGui_QtCore->em_types[155]
#define sipClass_QSysInfo             sipModuleAPI_QtGui_QtCore->em_types[155]->u.td_wrapper_type

#define sipType_QSysInfo_Endian              sipModuleAPI_QtGui_QtCore->em_types[156]
#define sipEnum_QSysInfo_Endian              sipModuleAPI_QtGui_QtCore->em_types[156]->u.td_py_type
#define sipType_QSysInfo_Sizes              sipModuleAPI_QtGui_QtCore->em_types[157]
#define sipEnum_QSysInfo_Sizes              sipModuleAPI_QtGui_QtCore->em_types[157]->u.td_py_type

#if !defined(sipType_Qt)
#define sipType_Qt              sipModuleAPI_QtGui_QtCore->em_types[219]
#define sipClass_Qt             sipModuleAPI_QtGui_QtCore->em_types[219]->u.td_wrapper_type
#endif

#define sipType_Qt_WindowFrameSection              sipModuleAPI_QtGui_QtCore->em_types[287]
#define sipEnum_Qt_WindowFrameSection              sipModuleAPI_QtGui_QtCore->em_types[287]->u.td_py_type
#define sipType_Qt_SizeHint              sipModuleAPI_QtGui_QtCore->em_types[271]
#define sipEnum_Qt_SizeHint              sipModuleAPI_QtGui_QtCore->em_types[271]->u.td_py_type
#define sipType_Qt_SizeMode              sipModuleAPI_QtGui_QtCore->em_types[272]
#define sipEnum_Qt_SizeMode              sipModuleAPI_QtGui_QtCore->em_types[272]->u.td_py_type
#define sipType_Qt_EventPriority              sipModuleAPI_QtGui_QtCore->em_types[242]
#define sipEnum_Qt_EventPriority              sipModuleAPI_QtGui_QtCore->em_types[242]->u.td_py_type
#define sipType_Qt_Axis              sipModuleAPI_QtGui_QtCore->em_types[226]
#define sipEnum_Qt_Axis              sipModuleAPI_QtGui_QtCore->em_types[226]->u.td_py_type
#define sipType_Qt_MaskMode              sipModuleAPI_QtGui_QtCore->em_types[258]
#define sipEnum_Qt_MaskMode              sipModuleAPI_QtGui_QtCore->em_types[258]->u.td_py_type
#define sipType_Qt_TextInteractionFlag              sipModuleAPI_QtGui_QtCore->em_types[277]
#define sipEnum_Qt_TextInteractionFlag              sipModuleAPI_QtGui_QtCore->em_types[277]->u.td_py_type
#define sipType_Qt_ItemSelectionMode              sipModuleAPI_QtGui_QtCore->em_types[253]
#define sipEnum_Qt_ItemSelectionMode              sipModuleAPI_QtGui_QtCore->em_types[253]->u.td_py_type
#define sipType_Qt_ApplicationAttribute              sipModuleAPI_QtGui_QtCore->em_types[223]
#define sipEnum_Qt_ApplicationAttribute              sipModuleAPI_QtGui_QtCore->em_types[223]->u.td_py_type
#define sipType_Qt_WindowModality              sipModuleAPI_QtGui_QtCore->em_types[288]
#define sipEnum_Qt_WindowModality              sipModuleAPI_QtGui_QtCore->em_types[288]->u.td_py_type
#define sipType_Qt_MatchFlag              sipModuleAPI_QtGui_QtCore->em_types[259]
#define sipEnum_Qt_MatchFlag              sipModuleAPI_QtGui_QtCore->em_types[259]->u.td_py_type
#define sipType_Qt_ItemFlag              sipModuleAPI_QtGui_QtCore->em_types[251]
#define sipEnum_Qt_ItemFlag              sipModuleAPI_QtGui_QtCore->em_types[251]->u.td_py_type
#define sipType_Qt_ItemDataRole              sipModuleAPI_QtGui_QtCore->em_types[250]
#define sipEnum_Qt_ItemDataRole              sipModuleAPI_QtGui_QtCore->em_types[250]->u.td_py_type
#define sipType_Qt_CheckState              sipModuleAPI_QtGui_QtCore->em_types[230]
#define sipEnum_Qt_CheckState              sipModuleAPI_QtGui_QtCore->em_types[230]->u.td_py_type
#define sipType_Qt_DropAction              sipModuleAPI_QtGui_QtCore->em_types[240]
#define sipEnum_Qt_DropAction              sipModuleAPI_QtGui_QtCore->em_types[240]->u.td_py_type
#define sipType_Qt_LayoutDirection              sipModuleAPI_QtGui_QtCore->em_types[257]
#define sipEnum_Qt_LayoutDirection              sipModuleAPI_QtGui_QtCore->em_types[257]->u.td_py_type
#define sipType_Qt_ToolButtonStyle              sipModuleAPI_QtGui_QtCore->em_types[282]
#define sipEnum_Qt_ToolButtonStyle              sipModuleAPI_QtGui_QtCore->em_types[282]->u.td_py_type
#define sipType_Qt_InputMethodQuery              sipModuleAPI_QtGui_QtCore->em_types[249]
#define sipEnum_Qt_InputMethodQuery              sipModuleAPI_QtGui_QtCore->em_types[249]->u.td_py_type
#define sipType_Qt_ContextMenuPolicy              sipModuleAPI_QtGui_QtCore->em_types[233]
#define sipEnum_Qt_ContextMenuPolicy              sipModuleAPI_QtGui_QtCore->em_types[233]->u.td_py_type
#define sipType_Qt_FocusReason              sipModuleAPI_QtGui_QtCore->em_types[245]
#define sipEnum_Qt_FocusReason              sipModuleAPI_QtGui_QtCore->em_types[245]->u.td_py_type
#define sipType_Qt_TransformationMode              sipModuleAPI_QtGui_QtCore->em_types[283]
#define sipEnum_Qt_TransformationMode              sipModuleAPI_QtGui_QtCore->em_types[283]->u.td_py_type
#define sipType_Qt_ClipOperation              sipModuleAPI_QtGui_QtCore->em_types[231]
#define sipEnum_Qt_ClipOperation              sipModuleAPI_QtGui_QtCore->em_types[231]->u.td_py_type
#define sipType_Qt_FillRule              sipModuleAPI_QtGui_QtCore->em_types[243]
#define sipEnum_Qt_FillRule              sipModuleAPI_QtGui_QtCore->em_types[243]->u.td_py_type
#define sipType_Qt_ShortcutContext              sipModuleAPI_QtGui_QtCore->em_types[270]
#define sipEnum_Qt_ShortcutContext              sipModuleAPI_QtGui_QtCore->em_types[270]->u.td_py_type
#define sipType_Qt_ConnectionType              sipModuleAPI_QtGui_QtCore->em_types[232]
#define sipEnum_Qt_ConnectionType              sipModuleAPI_QtGui_QtCore->em_types[232]->u.td_py_type
#define sipType_Qt_Corner              sipModuleAPI_QtGui_QtCore->em_types[234]
#define sipEnum_Qt_Corner              sipModuleAPI_QtGui_QtCore->em_types[234]->u.td_py_type
#define sipType_Qt_CaseSensitivity              sipModuleAPI_QtGui_QtCore->em_types[229]
#define sipEnum_Qt_CaseSensitivity              sipModuleAPI_QtGui_QtCore->em_types[229]->u.td_py_type
#define sipType_Qt_ScrollBarPolicy              sipModuleAPI_QtGui_QtCore->em_types[269]
#define sipEnum_Qt_ScrollBarPolicy              sipModuleAPI_QtGui_QtCore->em_types[269]->u.td_py_type
#define sipType_Qt_DayOfWeek              sipModuleAPI_QtGui_QtCore->em_types[237]
#define sipEnum_Qt_DayOfWeek              sipModuleAPI_QtGui_QtCore->em_types[237]->u.td_py_type
#define sipType_Qt_TimeSpec              sipModuleAPI_QtGui_QtCore->em_types[279]
#define sipEnum_Qt_TimeSpec              sipModuleAPI_QtGui_QtCore->em_types[279]->u.td_py_type
#define sipType_Qt_DateFormat              sipModuleAPI_QtGui_QtCore->em_types[236]
#define sipEnum_Qt_DateFormat              sipModuleAPI_QtGui_QtCore->em_types[236]->u.td_py_type
#define sipType_Qt_ToolBarArea              sipModuleAPI_QtGui_QtCore->em_types[280]
#define sipEnum_Qt_ToolBarArea              sipModuleAPI_QtGui_QtCore->em_types[280]->u.td_py_type
#define sipType_Qt_DockWidgetArea              sipModuleAPI_QtGui_QtCore->em_types[238]
#define sipEnum_Qt_DockWidgetArea              sipModuleAPI_QtGui_QtCore->em_types[238]->u.td_py_type
#define sipType_Qt_AnchorAttribute              sipModuleAPI_QtGui_QtCore->em_types[222]
#define sipEnum_Qt_AnchorAttribute              sipModuleAPI_QtGui_QtCore->em_types[222]->u.td_py_type
#define sipType_Qt_AspectRatioMode              sipModuleAPI_QtGui_QtCore->em_types[225]
#define sipEnum_Qt_AspectRatioMode              sipModuleAPI_QtGui_QtCore->em_types[225]->u.td_py_type
#define sipType_Qt_TextFormat              sipModuleAPI_QtGui_QtCore->em_types[276]
#define sipEnum_Qt_TextFormat              sipModuleAPI_QtGui_QtCore->em_types[276]->u.td_py_type
#define sipType_Qt_CursorShape              sipModuleAPI_QtGui_QtCore->em_types[235]
#define sipEnum_Qt_CursorShape              sipModuleAPI_QtGui_QtCore->em_types[235]->u.td_py_type
#define sipType_Qt_UIEffect              sipModuleAPI_QtGui_QtCore->em_types[284]
#define sipEnum_Qt_UIEffect              sipModuleAPI_QtGui_QtCore->em_types[284]->u.td_py_type
#define sipType_Qt_BrushStyle              sipModuleAPI_QtGui_QtCore->em_types[228]
#define sipEnum_Qt_BrushStyle              sipModuleAPI_QtGui_QtCore->em_types[228]->u.td_py_type
#define sipType_Qt_PenJoinStyle              sipModuleAPI_QtGui_QtCore->em_types[267]
#define sipEnum_Qt_PenJoinStyle              sipModuleAPI_QtGui_QtCore->em_types[267]->u.td_py_type
#define sipType_Qt_PenCapStyle              sipModuleAPI_QtGui_QtCore->em_types[266]
#define sipEnum_Qt_PenCapStyle              sipModuleAPI_QtGui_QtCore->em_types[266]->u.td_py_type
#define sipType_Qt_PenStyle              sipModuleAPI_QtGui_QtCore->em_types[268]
#define sipEnum_Qt_PenStyle              sipModuleAPI_QtGui_QtCore->em_types[268]->u.td_py_type
#define sipType_Qt_ArrowType              sipModuleAPI_QtGui_QtCore->em_types[224]
#define sipEnum_Qt_ArrowType              sipModuleAPI_QtGui_QtCore->em_types[224]->u.td_py_type
#define sipType_Qt_Key              sipModuleAPI_QtGui_QtCore->em_types[254]
#define sipEnum_Qt_Key              sipModuleAPI_QtGui_QtCore->em_types[254]->u.td_py_type
#define sipType_Qt_BGMode              sipModuleAPI_QtGui_QtCore->em_types[227]
#define sipEnum_Qt_BGMode              sipModuleAPI_QtGui_QtCore->em_types[227]->u.td_py_type
#define sipType_Qt_ImageConversionFlag              sipModuleAPI_QtGui_QtCore->em_types[247]
#define sipEnum_Qt_ImageConversionFlag              sipModuleAPI_QtGui_QtCore->em_types[247]->u.td_py_type
#define sipType_Qt_WidgetAttribute              sipModuleAPI_QtGui_QtCore->em_types[285]
#define sipEnum_Qt_WidgetAttribute              sipModuleAPI_QtGui_QtCore->em_types[285]->u.td_py_type
#define sipType_Qt_WindowState              sipModuleAPI_QtGui_QtCore->em_types[289]
#define sipEnum_Qt_WindowState              sipModuleAPI_QtGui_QtCore->em_types[289]->u.td_py_type
#define sipType_Qt_WindowType              sipModuleAPI_QtGui_QtCore->em_types[291]
#define sipEnum_Qt_WindowType              sipModuleAPI_QtGui_QtCore->em_types[291]->u.td_py_type
#define sipType_Qt_TextElideMode              sipModuleAPI_QtGui_QtCore->em_types[274]
#define sipEnum_Qt_TextElideMode              sipModuleAPI_QtGui_QtCore->em_types[274]->u.td_py_type
#define sipType_Qt_TextFlag              sipModuleAPI_QtGui_QtCore->em_types[275]
#define sipEnum_Qt_TextFlag              sipModuleAPI_QtGui_QtCore->em_types[275]->u.td_py_type
#define sipType_Qt_AlignmentFlag              sipModuleAPI_QtGui_QtCore->em_types[221]
#define sipEnum_Qt_AlignmentFlag              sipModuleAPI_QtGui_QtCore->em_types[221]->u.td_py_type
#define sipType_Qt_SortOrder              sipModuleAPI_QtGui_QtCore->em_types[273]
#define sipEnum_Qt_SortOrder              sipModuleAPI_QtGui_QtCore->em_types[273]->u.td_py_type
#define sipType_Qt_FocusPolicy              sipModuleAPI_QtGui_QtCore->em_types[244]
#define sipEnum_Qt_FocusPolicy              sipModuleAPI_QtGui_QtCore->em_types[244]->u.td_py_type
#define sipType_Qt_Orientation              sipModuleAPI_QtGui_QtCore->em_types[264]
#define sipEnum_Qt_Orientation              sipModuleAPI_QtGui_QtCore->em_types[264]->u.td_py_type
#define sipType_Qt_MouseButton              sipModuleAPI_QtGui_QtCore->em_types[262]
#define sipEnum_Qt_MouseButton              sipModuleAPI_QtGui_QtCore->em_types[262]->u.td_py_type
#define sipType_Qt_Modifier              sipModuleAPI_QtGui_QtCore->em_types[261]
#define sipEnum_Qt_Modifier              sipModuleAPI_QtGui_QtCore->em_types[261]->u.td_py_type
#define sipType_Qt_KeyboardModifier              sipModuleAPI_QtGui_QtCore->em_types[255]
#define sipEnum_Qt_KeyboardModifier              sipModuleAPI_QtGui_QtCore->em_types[255]->u.td_py_type
#define sipType_Qt_GlobalColor              sipModuleAPI_QtGui_QtCore->em_types[246]
#define sipEnum_Qt_GlobalColor              sipModuleAPI_QtGui_QtCore->em_types[246]->u.td_py_type

#define sipType_Qt_KeyboardModifiers              sipModuleAPI_QtGui_QtCore->em_types[256]
#define sipClass_Qt_KeyboardModifiers             sipModuleAPI_QtGui_QtCore->em_types[256]->u.td_wrapper_type

#define sipType_Qt_MouseButtons              sipModuleAPI_QtGui_QtCore->em_types[263]
#define sipClass_Qt_MouseButtons             sipModuleAPI_QtGui_QtCore->em_types[263]->u.td_wrapper_type

#define sipType_Qt_Orientations              sipModuleAPI_QtGui_QtCore->em_types[265]
#define sipClass_Qt_Orientations             sipModuleAPI_QtGui_QtCore->em_types[265]->u.td_wrapper_type

#define sipType_Qt_Alignment              sipModuleAPI_QtGui_QtCore->em_types[220]
#define sipClass_Qt_Alignment             sipModuleAPI_QtGui_QtCore->em_types[220]->u.td_wrapper_type

#define sipType_Qt_WindowFlags              sipModuleAPI_QtGui_QtCore->em_types[286]
#define sipClass_Qt_WindowFlags             sipModuleAPI_QtGui_QtCore->em_types[286]->u.td_wrapper_type

#define sipType_Qt_WindowStates              sipModuleAPI_QtGui_QtCore->em_types[290]
#define sipClass_Qt_WindowStates             sipModuleAPI_QtGui_QtCore->em_types[290]->u.td_wrapper_type

#define sipType_Qt_ImageConversionFlags              sipModuleAPI_QtGui_QtCore->em_types[248]
#define sipClass_Qt_ImageConversionFlags             sipModuleAPI_QtGui_QtCore->em_types[248]->u.td_wrapper_type

#define sipType_Qt_DockWidgetAreas              sipModuleAPI_QtGui_QtCore->em_types[239]
#define sipClass_Qt_DockWidgetAreas             sipModuleAPI_QtGui_QtCore->em_types[239]->u.td_wrapper_type

#define sipType_Qt_ToolBarAreas              sipModuleAPI_QtGui_QtCore->em_types[281]
#define sipClass_Qt_ToolBarAreas             sipModuleAPI_QtGui_QtCore->em_types[281]->u.td_wrapper_type

#define sipType_Qt_DropActions              sipModuleAPI_QtGui_QtCore->em_types[241]
#define sipClass_Qt_DropActions             sipModuleAPI_QtGui_QtCore->em_types[241]->u.td_wrapper_type

#define sipType_Qt_ItemFlags              sipModuleAPI_QtGui_QtCore->em_types[252]
#define sipClass_Qt_ItemFlags             sipModuleAPI_QtGui_QtCore->em_types[252]->u.td_wrapper_type

#define sipType_Qt_MatchFlags              sipModuleAPI_QtGui_QtCore->em_types[260]
#define sipClass_Qt_MatchFlags             sipModuleAPI_QtGui_QtCore->em_types[260]->u.td_wrapper_type

#define sipType_Qt_TextInteractionFlags              sipModuleAPI_QtGui_QtCore->em_types[278]
#define sipClass_Qt_TextInteractionFlags             sipModuleAPI_QtGui_QtCore->em_types[278]->u.td_wrapper_type

#define sipType_QObject              sipModuleAPI_QtGui_QtCore->em_types[111]
#define sipClass_QObject             sipModuleAPI_QtGui_QtCore->em_types[111]->u.td_wrapper_type

#define sipType_QAbstractEventDispatcher              sipModuleAPI_QtGui_QtCore->em_types[0]
#define sipClass_QAbstractEventDispatcher             sipModuleAPI_QtGui_QtCore->em_types[0]->u.td_wrapper_type

#define sipType_QAbstractFileEngine              sipModuleAPI_QtGui_QtCore->em_types[1]
#define sipClass_QAbstractFileEngine             sipModuleAPI_QtGui_QtCore->em_types[1]->u.td_wrapper_type

#define sipType_QAbstractFileEngine_FileTime              sipModuleAPI_QtGui_QtCore->em_types[6]
#define sipEnum_QAbstractFileEngine_FileTime              sipModuleAPI_QtGui_QtCore->em_types[6]->u.td_py_type
#define sipType_QAbstractFileEngine_FileOwner              sipModuleAPI_QtGui_QtCore->em_types[5]
#define sipEnum_QAbstractFileEngine_FileOwner              sipModuleAPI_QtGui_QtCore->em_types[5]->u.td_py_type
#define sipType_QAbstractFileEngine_FileName              sipModuleAPI_QtGui_QtCore->em_types[4]
#define sipEnum_QAbstractFileEngine_FileName              sipModuleAPI_QtGui_QtCore->em_types[4]->u.td_py_type
#define sipType_QAbstractFileEngine_FileFlag              sipModuleAPI_QtGui_QtCore->em_types[2]
#define sipEnum_QAbstractFileEngine_FileFlag              sipModuleAPI_QtGui_QtCore->em_types[2]->u.td_py_type

#define sipType_QAbstractFileEngine_FileFlags              sipModuleAPI_QtGui_QtCore->em_types[3]
#define sipClass_QAbstractFileEngine_FileFlags             sipModuleAPI_QtGui_QtCore->em_types[3]->u.td_wrapper_type

#define sipType_QAbstractFileEngineHandler              sipModuleAPI_QtGui_QtCore->em_types[7]
#define sipClass_QAbstractFileEngineHandler             sipModuleAPI_QtGui_QtCore->em_types[7]->u.td_wrapper_type

#define sipType_QAbstractFileEngineIterator              sipModuleAPI_QtGui_QtCore->em_types[8]
#define sipClass_QAbstractFileEngineIterator             sipModuleAPI_QtGui_QtCore->em_types[8]->u.td_wrapper_type

#define sipType_QModelIndex              sipModuleAPI_QtGui_QtCore->em_types[107]
#define sipClass_QModelIndex             sipModuleAPI_QtGui_QtCore->em_types[107]->u.td_wrapper_type

#define sipType_QPersistentModelIndex              sipModuleAPI_QtGui_QtCore->em_types[114]
#define sipClass_QPersistentModelIndex             sipModuleAPI_QtGui_QtCore->em_types[114]->u.td_wrapper_type

#define sipType_QAbstractItemModel              sipModuleAPI_QtGui_QtCore->em_types[9]
#define sipClass_QAbstractItemModel             sipModuleAPI_QtGui_QtCore->em_types[9]->u.td_wrapper_type

#define sipType_QAbstractTableModel              sipModuleAPI_QtGui_QtCore->em_types[11]
#define sipClass_QAbstractTableModel             sipModuleAPI_QtGui_QtCore->em_types[11]->u.td_wrapper_type

#define sipType_QAbstractListModel              sipModuleAPI_QtGui_QtCore->em_types[10]
#define sipClass_QAbstractListModel             sipModuleAPI_QtGui_QtCore->em_types[10]->u.td_wrapper_type

#define sipType_QBasicTimer              sipModuleAPI_QtGui_QtCore->em_types[12]
#define sipClass_QBasicTimer             sipModuleAPI_QtGui_QtCore->em_types[12]->u.td_wrapper_type

#define sipType_QBitArray              sipModuleAPI_QtGui_QtCore->em_types[13]
#define sipClass_QBitArray             sipModuleAPI_QtGui_QtCore->em_types[13]->u.td_wrapper_type

#define sipType_QIODevice              sipModuleAPI_QtGui_QtCore->em_types[62]
#define sipClass_QIODevice             sipModuleAPI_QtGui_QtCore->em_types[62]->u.td_wrapper_type

#define sipType_QIODevice_OpenModeFlag              sipModuleAPI_QtGui_QtCore->em_types[64]
#define sipEnum_QIODevice_OpenModeFlag              sipModuleAPI_QtGui_QtCore->em_types[64]->u.td_py_type

#define sipType_QBuffer              sipModuleAPI_QtGui_QtCore->em_types[14]
#define sipClass_QBuffer             sipModuleAPI_QtGui_QtCore->em_types[14]->u.td_wrapper_type

#define sipType_QByteArray              sipModuleAPI_QtGui_QtCore->em_types[15]
#define sipClass_QByteArray             sipModuleAPI_QtGui_QtCore->em_types[15]->u.td_wrapper_type

#define sipType_QByteArrayMatcher              sipModuleAPI_QtGui_QtCore->em_types[16]
#define sipClass_QByteArrayMatcher             sipModuleAPI_QtGui_QtCore->em_types[16]->u.td_wrapper_type

#define sipType_QLatin1Char              sipModuleAPI_QtGui_QtCore->em_types[65]
#define sipClass_QLatin1Char             sipModuleAPI_QtGui_QtCore->em_types[65]->u.td_wrapper_type


#define sipType_QChar_UnicodeVersion              sipModuleAPI_QtGui_QtCore->em_types[24]
#define sipEnum_QChar_UnicodeVersion              sipModuleAPI_QtGui_QtCore->em_types[24]->u.td_py_type
#define sipType_QChar_CombiningClass              sipModuleAPI_QtGui_QtCore->em_types[19]
#define sipEnum_QChar_CombiningClass              sipModuleAPI_QtGui_QtCore->em_types[19]->u.td_py_type
#define sipType_QChar_Joining              sipModuleAPI_QtGui_QtCore->em_types[22]
#define sipEnum_QChar_Joining              sipModuleAPI_QtGui_QtCore->em_types[22]->u.td_py_type
#define sipType_QChar_Decomposition              sipModuleAPI_QtGui_QtCore->em_types[20]
#define sipEnum_QChar_Decomposition              sipModuleAPI_QtGui_QtCore->em_types[20]->u.td_py_type
#define sipType_QChar_Direction              sipModuleAPI_QtGui_QtCore->em_types[21]
#define sipEnum_QChar_Direction              sipModuleAPI_QtGui_QtCore->em_types[21]->u.td_py_type
#define sipType_QChar_Category              sipModuleAPI_QtGui_QtCore->em_types[18]
#define sipEnum_QChar_Category              sipModuleAPI_QtGui_QtCore->em_types[18]->u.td_py_type
#define sipType_QChar_SpecialCharacter              sipModuleAPI_QtGui_QtCore->em_types[23]
#define sipEnum_QChar_SpecialCharacter              sipModuleAPI_QtGui_QtCore->em_types[23]->u.td_py_type

#define sipType_QCoreApplication              sipModuleAPI_QtGui_QtCore->em_types[26]
#define sipClass_QCoreApplication             sipModuleAPI_QtGui_QtCore->em_types[26]->u.td_wrapper_type

#define sipType_QCoreApplication_Encoding              sipModuleAPI_QtGui_QtCore->em_types[27]
#define sipEnum_QCoreApplication_Encoding              sipModuleAPI_QtGui_QtCore->em_types[27]->u.td_py_type

#define sipType_QEvent              sipModuleAPI_QtGui_QtCore->em_types[46]
#define sipClass_QEvent             sipModuleAPI_QtGui_QtCore->em_types[46]->u.td_wrapper_type

#define sipType_QEvent_Type              sipModuleAPI_QtGui_QtCore->em_types[47]
#define sipEnum_QEvent_Type              sipModuleAPI_QtGui_QtCore->em_types[47]->u.td_py_type

#define sipType_QTimerEvent              sipModuleAPI_QtGui_QtCore->em_types[190]
#define sipClass_QTimerEvent             sipModuleAPI_QtGui_QtCore->em_types[190]->u.td_wrapper_type

#define sipType_QChildEvent              sipModuleAPI_QtGui_QtCore->em_types[25]
#define sipClass_QChildEvent             sipModuleAPI_QtGui_QtCore->em_types[25]->u.td_wrapper_type

#define sipType_QDynamicPropertyChangeEvent              sipModuleAPI_QtGui_QtCore->em_types[45]
#define sipClass_QDynamicPropertyChangeEvent             sipModuleAPI_QtGui_QtCore->em_types[45]->u.td_wrapper_type

#define sipType_QCryptographicHash              sipModuleAPI_QtGui_QtCore->em_types[28]
#define sipClass_QCryptographicHash             sipModuleAPI_QtGui_QtCore->em_types[28]->u.td_wrapper_type

#define sipType_QCryptographicHash_Algorithm              sipModuleAPI_QtGui_QtCore->em_types[29]
#define sipEnum_QCryptographicHash_Algorithm              sipModuleAPI_QtGui_QtCore->em_types[29]->u.td_py_type

#define sipType_QDataStream              sipModuleAPI_QtGui_QtCore->em_types[30]
#define sipClass_QDataStream             sipModuleAPI_QtGui_QtCore->em_types[30]->u.td_wrapper_type

#define sipType_QDataStream_Status              sipModuleAPI_QtGui_QtCore->em_types[32]
#define sipEnum_QDataStream_Status              sipModuleAPI_QtGui_QtCore->em_types[32]->u.td_py_type
#define sipType_QDataStream_ByteOrder              sipModuleAPI_QtGui_QtCore->em_types[31]
#define sipEnum_QDataStream_ByteOrder              sipModuleAPI_QtGui_QtCore->em_types[31]->u.td_py_type
#define sipType_QDataStream_Version              sipModuleAPI_QtGui_QtCore->em_types[33]
#define sipEnum_QDataStream_Version              sipModuleAPI_QtGui_QtCore->em_types[33]->u.td_py_type

#define sipType_QDate              sipModuleAPI_QtGui_QtCore->em_types[34]
#define sipClass_QDate             sipModuleAPI_QtGui_QtCore->em_types[34]->u.td_wrapper_type

#define sipType_QDate_MonthNameType              sipModuleAPI_QtGui_QtCore->em_types[35]
#define sipEnum_QDate_MonthNameType              sipModuleAPI_QtGui_QtCore->em_types[35]->u.td_py_type

#define sipType_QTime              sipModuleAPI_QtGui_QtCore->em_types[184]
#define sipClass_QTime             sipModuleAPI_QtGui_QtCore->em_types[184]->u.td_wrapper_type

#define sipType_QDateTime              sipModuleAPI_QtGui_QtCore->em_types[36]
#define sipClass_QDateTime             sipModuleAPI_QtGui_QtCore->em_types[36]->u.td_wrapper_type

#define sipType_QDir              sipModuleAPI_QtGui_QtCore->em_types[37]
#define sipClass_QDir             sipModuleAPI_QtGui_QtCore->em_types[37]->u.td_wrapper_type

#define sipType_QDir_SortFlag              sipModuleAPI_QtGui_QtCore->em_types[40]
#define sipEnum_QDir_SortFlag              sipModuleAPI_QtGui_QtCore->em_types[40]->u.td_py_type
#define sipType_QDir_Filter              sipModuleAPI_QtGui_QtCore->em_types[38]
#define sipEnum_QDir_Filter              sipModuleAPI_QtGui_QtCore->em_types[38]->u.td_py_type

#define sipType_QDir_Filters              sipModuleAPI_QtGui_QtCore->em_types[39]
#define sipClass_QDir_Filters             sipModuleAPI_QtGui_QtCore->em_types[39]->u.td_wrapper_type

#define sipType_QDir_SortFlags              sipModuleAPI_QtGui_QtCore->em_types[41]
#define sipClass_QDir_SortFlags             sipModuleAPI_QtGui_QtCore->em_types[41]->u.td_wrapper_type

#define sipType_QDirIterator              sipModuleAPI_QtGui_QtCore->em_types[42]
#define sipClass_QDirIterator             sipModuleAPI_QtGui_QtCore->em_types[42]->u.td_wrapper_type

#define sipType_QDirIterator_IteratorFlag              sipModuleAPI_QtGui_QtCore->em_types[43]
#define sipEnum_QDirIterator_IteratorFlag              sipModuleAPI_QtGui_QtCore->em_types[43]->u.td_py_type

#define sipType_QDirIterator_IteratorFlags              sipModuleAPI_QtGui_QtCore->em_types[44]
#define sipClass_QDirIterator_IteratorFlags             sipModuleAPI_QtGui_QtCore->em_types[44]->u.td_wrapper_type

#define sipType_QEventLoop              sipModuleAPI_QtGui_QtCore->em_types[48]
#define sipClass_QEventLoop             sipModuleAPI_QtGui_QtCore->em_types[48]->u.td_wrapper_type

#define sipType_QEventLoop_ProcessEventsFlag              sipModuleAPI_QtGui_QtCore->em_types[49]
#define sipEnum_QEventLoop_ProcessEventsFlag              sipModuleAPI_QtGui_QtCore->em_types[49]->u.td_py_type

#define sipType_QEventLoop_ProcessEventsFlags              sipModuleAPI_QtGui_QtCore->em_types[50]
#define sipClass_QEventLoop_ProcessEventsFlags             sipModuleAPI_QtGui_QtCore->em_types[50]->u.td_wrapper_type

#define sipType_QFile              sipModuleAPI_QtGui_QtCore->em_types[52]
#define sipClass_QFile             sipModuleAPI_QtGui_QtCore->em_types[52]->u.td_wrapper_type

#define sipType_QFile_Permission              sipModuleAPI_QtGui_QtCore->em_types[55]
#define sipEnum_QFile_Permission              sipModuleAPI_QtGui_QtCore->em_types[55]->u.td_py_type
#define sipType_QFile_MemoryMapFlags              sipModuleAPI_QtGui_QtCore->em_types[54]
#define sipEnum_QFile_MemoryMapFlags              sipModuleAPI_QtGui_QtCore->em_types[54]->u.td_py_type
#define sipType_QFile_FileError              sipModuleAPI_QtGui_QtCore->em_types[53]
#define sipEnum_QFile_FileError              sipModuleAPI_QtGui_QtCore->em_types[53]->u.td_py_type

#define sipType_QFile_Permissions              sipModuleAPI_QtGui_QtCore->em_types[56]
#define sipClass_QFile_Permissions             sipModuleAPI_QtGui_QtCore->em_types[56]->u.td_wrapper_type

#define sipType_QFileInfo              sipModuleAPI_QtGui_QtCore->em_types[57]
#define sipClass_QFileInfo             sipModuleAPI_QtGui_QtCore->em_types[57]->u.td_wrapper_type

#define sipType_QFileSystemWatcher              sipModuleAPI_QtGui_QtCore->em_types[58]
#define sipClass_QFileSystemWatcher             sipModuleAPI_QtGui_QtCore->em_types[58]->u.td_wrapper_type

#define sipType_QFSFileEngine              sipModuleAPI_QtGui_QtCore->em_types[51]
#define sipClass_QFSFileEngine             sipModuleAPI_QtGui_QtCore->em_types[51]->u.td_wrapper_type

#define sipType_QIODevice_OpenMode              sipModuleAPI_QtGui_QtCore->em_types[63]
#define sipClass_QIODevice_OpenMode             sipModuleAPI_QtGui_QtCore->em_types[63]->u.td_wrapper_type

#define sipType_QLibrary              sipModuleAPI_QtGui_QtCore->em_types[67]
#define sipClass_QLibrary             sipModuleAPI_QtGui_QtCore->em_types[67]->u.td_wrapper_type

#define sipType_QLibrary_LoadHint              sipModuleAPI_QtGui_QtCore->em_types[68]
#define sipEnum_QLibrary_LoadHint              sipModuleAPI_QtGui_QtCore->em_types[68]->u.td_py_type

#define sipType_QLibrary_LoadHints              sipModuleAPI_QtGui_QtCore->em_types[69]
#define sipClass_QLibrary_LoadHints             sipModuleAPI_QtGui_QtCore->em_types[69]->u.td_wrapper_type

#define sipType_QLibraryInfo              sipModuleAPI_QtGui_QtCore->em_types[70]
#define sipClass_QLibraryInfo             sipModuleAPI_QtGui_QtCore->em_types[70]->u.td_wrapper_type

#define sipType_QLibraryInfo_LibraryLocation              sipModuleAPI_QtGui_QtCore->em_types[71]
#define sipEnum_QLibraryInfo_LibraryLocation              sipModuleAPI_QtGui_QtCore->em_types[71]->u.td_py_type

#define sipType_QLine              sipModuleAPI_QtGui_QtCore->em_types[72]
#define sipClass_QLine             sipModuleAPI_QtGui_QtCore->em_types[72]->u.td_wrapper_type

#define sipType_QLineF              sipModuleAPI_QtGui_QtCore->em_types[73]
#define sipClass_QLineF             sipModuleAPI_QtGui_QtCore->em_types[73]->u.td_wrapper_type

#define sipType_QLineF_IntersectType              sipModuleAPI_QtGui_QtCore->em_types[74]
#define sipEnum_QLineF_IntersectType              sipModuleAPI_QtGui_QtCore->em_types[74]->u.td_py_type

#define sipType_QLocale              sipModuleAPI_QtGui_QtCore->em_types[88]
#define sipClass_QLocale             sipModuleAPI_QtGui_QtCore->em_types[88]->u.td_wrapper_type

#define sipType_QLocale_MeasurementSystem              sipModuleAPI_QtGui_QtCore->em_types[92]
#define sipEnum_QLocale_MeasurementSystem              sipModuleAPI_QtGui_QtCore->em_types[92]->u.td_py_type
#define sipType_QLocale_FormatType              sipModuleAPI_QtGui_QtCore->em_types[90]
#define sipEnum_QLocale_FormatType              sipModuleAPI_QtGui_QtCore->em_types[90]->u.td_py_type
#define sipType_QLocale_NumberOption              sipModuleAPI_QtGui_QtCore->em_types[93]
#define sipEnum_QLocale_NumberOption              sipModuleAPI_QtGui_QtCore->em_types[93]->u.td_py_type
#define sipType_QLocale_Country              sipModuleAPI_QtGui_QtCore->em_types[89]
#define sipEnum_QLocale_Country              sipModuleAPI_QtGui_QtCore->em_types[89]->u.td_py_type
#define sipType_QLocale_Language              sipModuleAPI_QtGui_QtCore->em_types[91]
#define sipEnum_QLocale_Language              sipModuleAPI_QtGui_QtCore->em_types[91]->u.td_py_type

#define sipType_QLocale_NumberOptions              sipModuleAPI_QtGui_QtCore->em_types[94]
#define sipClass_QLocale_NumberOptions             sipModuleAPI_QtGui_QtCore->em_types[94]->u.td_wrapper_type

#define sipType_QSystemLocale              sipModuleAPI_QtGui_QtCore->em_types[158]
#define sipClass_QSystemLocale             sipModuleAPI_QtGui_QtCore->em_types[158]->u.td_wrapper_type

#define sipType_QSystemLocale_QueryType              sipModuleAPI_QtGui_QtCore->em_types[159]
#define sipEnum_QSystemLocale_QueryType              sipModuleAPI_QtGui_QtCore->em_types[159]->u.td_py_type

#define sipType_QMetaMethod              sipModuleAPI_QtGui_QtCore->em_types[99]
#define sipClass_QMetaMethod             sipModuleAPI_QtGui_QtCore->em_types[99]->u.td_wrapper_type

#define sipType_QMetaMethod_MethodType              sipModuleAPI_QtGui_QtCore->em_types[101]
#define sipEnum_QMetaMethod_MethodType              sipModuleAPI_QtGui_QtCore->em_types[101]->u.td_py_type
#define sipType_QMetaMethod_Access              sipModuleAPI_QtGui_QtCore->em_types[100]
#define sipEnum_QMetaMethod_Access              sipModuleAPI_QtGui_QtCore->em_types[100]->u.td_py_type

#define sipType_QMetaEnum              sipModuleAPI_QtGui_QtCore->em_types[98]
#define sipClass_QMetaEnum             sipModuleAPI_QtGui_QtCore->em_types[98]->u.td_wrapper_type

#define sipType_QMetaProperty              sipModuleAPI_QtGui_QtCore->em_types[103]
#define sipClass_QMetaProperty             sipModuleAPI_QtGui_QtCore->em_types[103]->u.td_wrapper_type

#define sipType_QMetaClassInfo              sipModuleAPI_QtGui_QtCore->em_types[97]
#define sipClass_QMetaClassInfo             sipModuleAPI_QtGui_QtCore->em_types[97]->u.td_wrapper_type

#define sipType_QMetaType              sipModuleAPI_QtGui_QtCore->em_types[104]
#define sipClass_QMetaType             sipModuleAPI_QtGui_QtCore->em_types[104]->u.td_wrapper_type

#define sipType_QMetaType_Type              sipModuleAPI_QtGui_QtCore->em_types[105]
#define sipEnum_QMetaType_Type              sipModuleAPI_QtGui_QtCore->em_types[105]->u.td_py_type

#define sipType_QMimeData              sipModuleAPI_QtGui_QtCore->em_types[106]
#define sipClass_QMimeData             sipModuleAPI_QtGui_QtCore->em_types[106]->u.td_wrapper_type

#define sipType_QMutex              sipModuleAPI_QtGui_QtCore->em_types[108]
#define sipClass_QMutex             sipModuleAPI_QtGui_QtCore->em_types[108]->u.td_wrapper_type

#define sipType_QMutex_RecursionMode              sipModuleAPI_QtGui_QtCore->em_types[109]
#define sipEnum_QMutex_RecursionMode              sipModuleAPI_QtGui_QtCore->em_types[109]->u.td_py_type

#define sipType_QMutexLocker              sipModuleAPI_QtGui_QtCore->em_types[110]
#define sipClass_QMutexLocker             sipModuleAPI_QtGui_QtCore->em_types[110]->u.td_wrapper_type

#define sipType_QObjectCleanupHandler              sipModuleAPI_QtGui_QtCore->em_types[112]
#define sipClass_QObjectCleanupHandler             sipModuleAPI_QtGui_QtCore->em_types[112]->u.td_wrapper_type

#define sipType_QMetaObject              sipModuleAPI_QtGui_QtCore->em_types[102]
#define sipClass_QMetaObject             sipModuleAPI_QtGui_QtCore->em_types[102]->u.td_wrapper_type

#define sipType_QGenericArgument              sipModuleAPI_QtGui_QtCore->em_types[59]
#define sipClass_QGenericArgument             sipModuleAPI_QtGui_QtCore->em_types[59]->u.td_wrapper_type

#define sipType_QGenericReturnArgument              sipModuleAPI_QtGui_QtCore->em_types[60]
#define sipClass_QGenericReturnArgument             sipModuleAPI_QtGui_QtCore->em_types[60]->u.td_wrapper_type

#define sipType_QPluginLoader              sipModuleAPI_QtGui_QtCore->em_types[115]
#define sipClass_QPluginLoader             sipModuleAPI_QtGui_QtCore->em_types[115]->u.td_wrapper_type

#define sipType_QPoint              sipModuleAPI_QtGui_QtCore->em_types[116]
#define sipClass_QPoint             sipModuleAPI_QtGui_QtCore->em_types[116]->u.td_wrapper_type

#define sipType_QPointF              sipModuleAPI_QtGui_QtCore->em_types[117]
#define sipClass_QPointF             sipModuleAPI_QtGui_QtCore->em_types[117]->u.td_wrapper_type

#define sipType_QProcess              sipModuleAPI_QtGui_QtCore->em_types[118]
#define sipClass_QProcess             sipModuleAPI_QtGui_QtCore->em_types[118]->u.td_wrapper_type

#define sipType_QProcess_ProcessChannelMode              sipModuleAPI_QtGui_QtCore->em_types[121]
#define sipEnum_QProcess_ProcessChannelMode              sipModuleAPI_QtGui_QtCore->em_types[121]->u.td_py_type
#define sipType_QProcess_ProcessChannel              sipModuleAPI_QtGui_QtCore->em_types[120]
#define sipEnum_QProcess_ProcessChannel              sipModuleAPI_QtGui_QtCore->em_types[120]->u.td_py_type
#define sipType_QProcess_ProcessState              sipModuleAPI_QtGui_QtCore->em_types[123]
#define sipEnum_QProcess_ProcessState              sipModuleAPI_QtGui_QtCore->em_types[123]->u.td_py_type
#define sipType_QProcess_ProcessError              sipModuleAPI_QtGui_QtCore->em_types[122]
#define sipEnum_QProcess_ProcessError              sipModuleAPI_QtGui_QtCore->em_types[122]->u.td_py_type
#define sipType_QProcess_ExitStatus              sipModuleAPI_QtGui_QtCore->em_types[119]
#define sipEnum_QProcess_ExitStatus              sipModuleAPI_QtGui_QtCore->em_types[119]->u.td_py_type

#define sipType_QReadWriteLock              sipModuleAPI_QtGui_QtCore->em_types[125]
#define sipClass_QReadWriteLock             sipModuleAPI_QtGui_QtCore->em_types[125]->u.td_wrapper_type

#define sipType_QReadWriteLock_RecursionMode              sipModuleAPI_QtGui_QtCore->em_types[126]
#define sipEnum_QReadWriteLock_RecursionMode              sipModuleAPI_QtGui_QtCore->em_types[126]->u.td_py_type

#define sipType_QReadLocker              sipModuleAPI_QtGui_QtCore->em_types[124]
#define sipClass_QReadLocker             sipModuleAPI_QtGui_QtCore->em_types[124]->u.td_wrapper_type

#define sipType_QWriteLocker              sipModuleAPI_QtGui_QtCore->em_types[208]
#define sipClass_QWriteLocker             sipModuleAPI_QtGui_QtCore->em_types[208]->u.td_wrapper_type

#define sipType_QRect              sipModuleAPI_QtGui_QtCore->em_types[127]
#define sipClass_QRect             sipModuleAPI_QtGui_QtCore->em_types[127]->u.td_wrapper_type

#define sipType_QRectF              sipModuleAPI_QtGui_QtCore->em_types[128]
#define sipClass_QRectF             sipModuleAPI_QtGui_QtCore->em_types[128]->u.td_wrapper_type

#define sipType_QRegExp              sipModuleAPI_QtGui_QtCore->em_types[129]
#define sipClass_QRegExp             sipModuleAPI_QtGui_QtCore->em_types[129]->u.td_wrapper_type

#define sipType_QRegExp_CaretMode              sipModuleAPI_QtGui_QtCore->em_types[130]
#define sipEnum_QRegExp_CaretMode              sipModuleAPI_QtGui_QtCore->em_types[130]->u.td_py_type
#define sipType_QRegExp_PatternSyntax              sipModuleAPI_QtGui_QtCore->em_types[131]
#define sipEnum_QRegExp_PatternSyntax              sipModuleAPI_QtGui_QtCore->em_types[131]->u.td_py_type

#define sipType_QResource              sipModuleAPI_QtGui_QtCore->em_types[132]
#define sipClass_QResource             sipModuleAPI_QtGui_QtCore->em_types[132]->u.td_wrapper_type

#define sipType_QRunnable              sipModuleAPI_QtGui_QtCore->em_types[133]
#define sipClass_QRunnable             sipModuleAPI_QtGui_QtCore->em_types[133]->u.td_wrapper_type

#define sipType_QSemaphore              sipModuleAPI_QtGui_QtCore->em_types[134]
#define sipClass_QSemaphore             sipModuleAPI_QtGui_QtCore->em_types[134]->u.td_wrapper_type

#define sipType_QSettings              sipModuleAPI_QtGui_QtCore->em_types[135]
#define sipClass_QSettings             sipModuleAPI_QtGui_QtCore->em_types[135]->u.td_wrapper_type

#define sipType_QSettings_Scope              sipModuleAPI_QtGui_QtCore->em_types[137]
#define sipEnum_QSettings_Scope              sipModuleAPI_QtGui_QtCore->em_types[137]->u.td_py_type
#define sipType_QSettings_Format              sipModuleAPI_QtGui_QtCore->em_types[136]
#define sipEnum_QSettings_Format              sipModuleAPI_QtGui_QtCore->em_types[136]->u.td_py_type
#define sipType_QSettings_Status              sipModuleAPI_QtGui_QtCore->em_types[138]
#define sipEnum_QSettings_Status              sipModuleAPI_QtGui_QtCore->em_types[138]->u.td_py_type

#define sipType_QSharedMemory              sipModuleAPI_QtGui_QtCore->em_types[139]
#define sipClass_QSharedMemory             sipModuleAPI_QtGui_QtCore->em_types[139]->u.td_wrapper_type

#define sipType_QSharedMemory_SharedMemoryError              sipModuleAPI_QtGui_QtCore->em_types[141]
#define sipEnum_QSharedMemory_SharedMemoryError              sipModuleAPI_QtGui_QtCore->em_types[141]->u.td_py_type
#define sipType_QSharedMemory_AccessMode              sipModuleAPI_QtGui_QtCore->em_types[140]
#define sipEnum_QSharedMemory_AccessMode              sipModuleAPI_QtGui_QtCore->em_types[140]->u.td_py_type

#define sipType_QSignalMapper              sipModuleAPI_QtGui_QtCore->em_types[142]
#define sipClass_QSignalMapper             sipModuleAPI_QtGui_QtCore->em_types[142]->u.td_wrapper_type

#define sipType_QSize              sipModuleAPI_QtGui_QtCore->em_types[143]
#define sipClass_QSize             sipModuleAPI_QtGui_QtCore->em_types[143]->u.td_wrapper_type

#define sipType_QSizeF              sipModuleAPI_QtGui_QtCore->em_types[144]
#define sipClass_QSizeF             sipModuleAPI_QtGui_QtCore->em_types[144]->u.td_wrapper_type

#define sipType_QSocketNotifier              sipModuleAPI_QtGui_QtCore->em_types[145]
#define sipClass_QSocketNotifier             sipModuleAPI_QtGui_QtCore->em_types[145]->u.td_wrapper_type

#define sipType_QSocketNotifier_Type              sipModuleAPI_QtGui_QtCore->em_types[146]
#define sipEnum_QSocketNotifier_Type              sipModuleAPI_QtGui_QtCore->em_types[146]->u.td_py_type


#define sipType_QString_NormalizationForm              sipModuleAPI_QtGui_QtCore->em_types[148]
#define sipEnum_QString_NormalizationForm              sipModuleAPI_QtGui_QtCore->em_types[148]->u.td_py_type
#define sipType_QString_SplitBehavior              sipModuleAPI_QtGui_QtCore->em_types[151]
#define sipEnum_QString_SplitBehavior              sipModuleAPI_QtGui_QtCore->em_types[151]->u.td_py_type
#define sipType_QString_SectionFlag              sipModuleAPI_QtGui_QtCore->em_types[149]
#define sipEnum_QString_SectionFlag              sipModuleAPI_QtGui_QtCore->em_types[149]->u.td_py_type

#define sipType_QString_SectionFlags              sipModuleAPI_QtGui_QtCore->em_types[150]
#define sipClass_QString_SectionFlags             sipModuleAPI_QtGui_QtCore->em_types[150]->u.td_wrapper_type

#define sipType_QLatin1String              sipModuleAPI_QtGui_QtCore->em_types[66]
#define sipClass_QLatin1String             sipModuleAPI_QtGui_QtCore->em_types[66]->u.td_wrapper_type



#define sipType_QStringMatcher              sipModuleAPI_QtGui_QtCore->em_types[153]
#define sipClass_QStringMatcher             sipModuleAPI_QtGui_QtCore->em_types[153]->u.td_wrapper_type

#define sipType_QSystemSemaphore              sipModuleAPI_QtGui_QtCore->em_types[160]
#define sipClass_QSystemSemaphore             sipModuleAPI_QtGui_QtCore->em_types[160]->u.td_wrapper_type

#define sipType_QSystemSemaphore_SystemSemaphoreError              sipModuleAPI_QtGui_QtCore->em_types[162]
#define sipEnum_QSystemSemaphore_SystemSemaphoreError              sipModuleAPI_QtGui_QtCore->em_types[162]->u.td_py_type
#define sipType_QSystemSemaphore_AccessMode              sipModuleAPI_QtGui_QtCore->em_types[161]
#define sipEnum_QSystemSemaphore_AccessMode              sipModuleAPI_QtGui_QtCore->em_types[161]->u.td_py_type

#define sipType_QTemporaryFile              sipModuleAPI_QtGui_QtCore->em_types[163]
#define sipClass_QTemporaryFile             sipModuleAPI_QtGui_QtCore->em_types[163]->u.td_wrapper_type

#define sipType_QTextBoundaryFinder              sipModuleAPI_QtGui_QtCore->em_types[164]
#define sipClass_QTextBoundaryFinder             sipModuleAPI_QtGui_QtCore->em_types[164]->u.td_wrapper_type

#define sipType_QTextBoundaryFinder_BoundaryType              sipModuleAPI_QtGui_QtCore->em_types[167]
#define sipEnum_QTextBoundaryFinder_BoundaryType              sipModuleAPI_QtGui_QtCore->em_types[167]->u.td_py_type
#define sipType_QTextBoundaryFinder_BoundaryReason              sipModuleAPI_QtGui_QtCore->em_types[165]
#define sipEnum_QTextBoundaryFinder_BoundaryReason              sipModuleAPI_QtGui_QtCore->em_types[165]->u.td_py_type

#define sipType_QTextBoundaryFinder_BoundaryReasons              sipModuleAPI_QtGui_QtCore->em_types[166]
#define sipClass_QTextBoundaryFinder_BoundaryReasons             sipModuleAPI_QtGui_QtCore->em_types[166]->u.td_wrapper_type

#define sipType_QTextCodec              sipModuleAPI_QtGui_QtCore->em_types[168]
#define sipClass_QTextCodec             sipModuleAPI_QtGui_QtCore->em_types[168]->u.td_wrapper_type

#define sipType_QTextCodec_ConversionFlag              sipModuleAPI_QtGui_QtCore->em_types[169]
#define sipEnum_QTextCodec_ConversionFlag              sipModuleAPI_QtGui_QtCore->em_types[169]->u.td_py_type

#define sipType_QTextCodec_ConversionFlags              sipModuleAPI_QtGui_QtCore->em_types[170]
#define sipClass_QTextCodec_ConversionFlags             sipModuleAPI_QtGui_QtCore->em_types[170]->u.td_wrapper_type

#define sipType_QTextCodec_ConverterState              sipModuleAPI_QtGui_QtCore->em_types[171]
#define sipClass_QTextCodec_ConverterState             sipModuleAPI_QtGui_QtCore->em_types[171]->u.td_wrapper_type

#define sipType_QTextEncoder              sipModuleAPI_QtGui_QtCore->em_types[173]
#define sipClass_QTextEncoder             sipModuleAPI_QtGui_QtCore->em_types[173]->u.td_wrapper_type

#define sipType_QTextDecoder              sipModuleAPI_QtGui_QtCore->em_types[172]
#define sipClass_QTextDecoder             sipModuleAPI_QtGui_QtCore->em_types[172]->u.td_wrapper_type

#define sipType_QTextStream              sipModuleAPI_QtGui_QtCore->em_types[174]
#define sipClass_QTextStream             sipModuleAPI_QtGui_QtCore->em_types[174]->u.td_wrapper_type

#define sipType_QTextStream_Status              sipModuleAPI_QtGui_QtCore->em_types[179]
#define sipEnum_QTextStream_Status              sipModuleAPI_QtGui_QtCore->em_types[179]->u.td_py_type
#define sipType_QTextStream_NumberFlag              sipModuleAPI_QtGui_QtCore->em_types[176]
#define sipEnum_QTextStream_NumberFlag              sipModuleAPI_QtGui_QtCore->em_types[176]->u.td_py_type
#define sipType_QTextStream_FieldAlignment              sipModuleAPI_QtGui_QtCore->em_types[175]
#define sipEnum_QTextStream_FieldAlignment              sipModuleAPI_QtGui_QtCore->em_types[175]->u.td_py_type
#define sipType_QTextStream_RealNumberNotation              sipModuleAPI_QtGui_QtCore->em_types[178]
#define sipEnum_QTextStream_RealNumberNotation              sipModuleAPI_QtGui_QtCore->em_types[178]->u.td_py_type

#define sipType_QTextStream_NumberFlags              sipModuleAPI_QtGui_QtCore->em_types[177]
#define sipClass_QTextStream_NumberFlags             sipModuleAPI_QtGui_QtCore->em_types[177]->u.td_wrapper_type

#define sipType_QTextStreamManipulator              sipModuleAPI_QtGui_QtCore->em_types[180]
#define sipClass_QTextStreamManipulator             sipModuleAPI_QtGui_QtCore->em_types[180]->u.td_wrapper_type

#define sipType_QThread              sipModuleAPI_QtGui_QtCore->em_types[181]
#define sipClass_QThread             sipModuleAPI_QtGui_QtCore->em_types[181]->u.td_wrapper_type

#define sipType_QThread_Priority              sipModuleAPI_QtGui_QtCore->em_types[182]
#define sipEnum_QThread_Priority              sipModuleAPI_QtGui_QtCore->em_types[182]->u.td_py_type

#define sipType_QThreadPool              sipModuleAPI_QtGui_QtCore->em_types[183]
#define sipClass_QThreadPool             sipModuleAPI_QtGui_QtCore->em_types[183]->u.td_wrapper_type

#define sipType_QTimeLine              sipModuleAPI_QtGui_QtCore->em_types[185]
#define sipClass_QTimeLine             sipModuleAPI_QtGui_QtCore->em_types[185]->u.td_wrapper_type

#define sipType_QTimeLine_State              sipModuleAPI_QtGui_QtCore->em_types[188]
#define sipEnum_QTimeLine_State              sipModuleAPI_QtGui_QtCore->em_types[188]->u.td_py_type
#define sipType_QTimeLine_Direction              sipModuleAPI_QtGui_QtCore->em_types[187]
#define sipEnum_QTimeLine_Direction              sipModuleAPI_QtGui_QtCore->em_types[187]->u.td_py_type
#define sipType_QTimeLine_CurveShape              sipModuleAPI_QtGui_QtCore->em_types[186]
#define sipEnum_QTimeLine_CurveShape              sipModuleAPI_QtGui_QtCore->em_types[186]->u.td_py_type

#define sipType_QTimer              sipModuleAPI_QtGui_QtCore->em_types[189]
#define sipClass_QTimer             sipModuleAPI_QtGui_QtCore->em_types[189]->u.td_wrapper_type

#define sipType_QTranslator              sipModuleAPI_QtGui_QtCore->em_types[191]
#define sipClass_QTranslator             sipModuleAPI_QtGui_QtCore->em_types[191]->u.td_wrapper_type

#define sipType_QUrl              sipModuleAPI_QtGui_QtCore->em_types[192]
#define sipClass_QUrl             sipModuleAPI_QtGui_QtCore->em_types[192]->u.td_wrapper_type

#define sipType_QUrl_ParsingMode              sipModuleAPI_QtGui_QtCore->em_types[195]
#define sipEnum_QUrl_ParsingMode              sipModuleAPI_QtGui_QtCore->em_types[195]->u.td_py_type
#define sipType_QUrl_FormattingOption              sipModuleAPI_QtGui_QtCore->em_types[193]
#define sipEnum_QUrl_FormattingOption              sipModuleAPI_QtGui_QtCore->em_types[193]->u.td_py_type

#define sipType_QUrl_FormattingOptions              sipModuleAPI_QtGui_QtCore->em_types[194]
#define sipClass_QUrl_FormattingOptions             sipModuleAPI_QtGui_QtCore->em_types[194]->u.td_wrapper_type

#define sipType_QUuid              sipModuleAPI_QtGui_QtCore->em_types[196]
#define sipClass_QUuid             sipModuleAPI_QtGui_QtCore->em_types[196]->u.td_wrapper_type

#define sipType_QUuid_Version              sipModuleAPI_QtGui_QtCore->em_types[198]
#define sipEnum_QUuid_Version              sipModuleAPI_QtGui_QtCore->em_types[198]->u.td_py_type
#define sipType_QUuid_Variant              sipModuleAPI_QtGui_QtCore->em_types[197]
#define sipEnum_QUuid_Variant              sipModuleAPI_QtGui_QtCore->em_types[197]->u.td_py_type


#define sipType_QWaitCondition              sipModuleAPI_QtGui_QtCore->em_types[206]
#define sipClass_QWaitCondition             sipModuleAPI_QtGui_QtCore->em_types[206]->u.td_wrapper_type

#define sipType_QXmlStreamAttribute              sipModuleAPI_QtGui_QtCore->em_types[209]
#define sipClass_QXmlStreamAttribute             sipModuleAPI_QtGui_QtCore->em_types[209]->u.td_wrapper_type

#define sipType_QXmlStreamAttributes              sipModuleAPI_QtGui_QtCore->em_types[210]
#define sipClass_QXmlStreamAttributes             sipModuleAPI_QtGui_QtCore->em_types[210]->u.td_wrapper_type

#define sipType_QXmlStreamNamespaceDeclaration              sipModuleAPI_QtGui_QtCore->em_types[213]
#define sipClass_QXmlStreamNamespaceDeclaration             sipModuleAPI_QtGui_QtCore->em_types[213]->u.td_wrapper_type

#define sipType_QXmlStreamNotationDeclaration              sipModuleAPI_QtGui_QtCore->em_types[214]
#define sipClass_QXmlStreamNotationDeclaration             sipModuleAPI_QtGui_QtCore->em_types[214]->u.td_wrapper_type

#define sipType_QXmlStreamEntityDeclaration              sipModuleAPI_QtGui_QtCore->em_types[211]
#define sipClass_QXmlStreamEntityDeclaration             sipModuleAPI_QtGui_QtCore->em_types[211]->u.td_wrapper_type

#define sipType_QXmlStreamEntityResolver              sipModuleAPI_QtGui_QtCore->em_types[212]
#define sipClass_QXmlStreamEntityResolver             sipModuleAPI_QtGui_QtCore->em_types[212]->u.td_wrapper_type

#define sipType_QXmlStreamReader              sipModuleAPI_QtGui_QtCore->em_types[215]
#define sipClass_QXmlStreamReader             sipModuleAPI_QtGui_QtCore->em_types[215]->u.td_wrapper_type

#define sipType_QXmlStreamReader_Error              sipModuleAPI_QtGui_QtCore->em_types[216]
#define sipEnum_QXmlStreamReader_Error              sipModuleAPI_QtGui_QtCore->em_types[216]->u.td_py_type
#define sipType_QXmlStreamReader_TokenType              sipModuleAPI_QtGui_QtCore->em_types[217]
#define sipEnum_QXmlStreamReader_TokenType              sipModuleAPI_QtGui_QtCore->em_types[217]->u.td_py_type

#define sipType_QXmlStreamWriter              sipModuleAPI_QtGui_QtCore->em_types[218]
#define sipClass_QXmlStreamWriter             sipModuleAPI_QtGui_QtCore->em_types[218]->u.td_wrapper_type

#define sipType_QList_0600QPair_0100QByteArray_0100QByteArray      sipModuleAPI_QtGui_QtCore->em_types[80]

#define sipType_QList_0600QPair_0100QString_0100QString      sipModuleAPI_QtGui_QtCore->em_types[81]

#define sipType_QList_0100QUrl      sipModuleAPI_QtGui_QtCore->em_types[84]

#define sipType_QMap_1800_0100QVariant      sipModuleAPI_QtGui_QtCore->em_types[96]

#define sipType_QList_0100QByteArray      sipModuleAPI_QtGui_QtCore->em_types[75]

#define sipType_QVector_0100QXmlStreamNotationDeclaration      sipModuleAPI_QtGui_QtCore->em_types[203]

#define sipType_QVector_0100QXmlStreamNamespaceDeclaration      sipModuleAPI_QtGui_QtCore->em_types[202]

#define sipType_QVector_0100QXmlStreamEntityDeclaration      sipModuleAPI_QtGui_QtCore->em_types[201]

#define sipType_QMap_0100QString_0100QVariant      sipModuleAPI_QtGui_QtCore->em_types[95]

#define sipType_QList_0100QVariant      sipModuleAPI_QtGui_QtCore->em_types[85]

#define sipType_QHash_0100QString_0100QVariant      sipModuleAPI_QtGui_QtCore->em_types[61]

#define sipType_QList_0101QObject      sipModuleAPI_QtGui_QtCore->em_types[79]

#define sipType_QList_0100QModelIndex      sipModuleAPI_QtGui_QtCore->em_types[78]

#define sipType_QList_0100QFileInfo      sipModuleAPI_QtGui_QtCore->em_types[76]

#define sipType_QVector_2400      sipModuleAPI_QtGui_QtCore->em_types[204]

#define sipType_QVector_1900      sipModuleAPI_QtGui_QtCore->em_types[205]

#define sipType_QVariant      sipModuleAPI_QtGui_QtCore->em_types[199]

#define sipType_QVariant_Type              sipModuleAPI_QtGui_QtCore->em_types[200]
#define sipEnum_QVariant_Type              sipModuleAPI_QtGui_QtCore->em_types[200]->u.td_py_type

#define sipType_QStringList      sipModuleAPI_QtGui_QtCore->em_types[152]

#define sipType_QStringRef      sipModuleAPI_QtGui_QtCore->em_types[154]

#define sipType_QString      sipModuleAPI_QtGui_QtCore->em_types[147]

#define sipType_QPair_1800_1800      sipModuleAPI_QtGui_QtCore->em_types[113]

#define sipType_QList_0100QLocale_Country      sipModuleAPI_QtGui_QtCore->em_types[77]

#define sipType_QList_2400      sipModuleAPI_QtGui_QtCore->em_types[87]

#define sipType_QList_1800      sipModuleAPI_QtGui_QtCore->em_types[86]

#define sipType_QList_0600QPair_2400_2400      sipModuleAPI_QtGui_QtCore->em_types[83]

#define sipType_QList_0600QPair_1800_1800      sipModuleAPI_QtGui_QtCore->em_types[82]

#define sipType_QChar      sipModuleAPI_QtGui_QtCore->em_types[17]
extern const sipExportedModuleDef *sipModuleAPI_QtGui_QtCore;

typedef const QMetaObject *(*sip_qt_metaobject_func)(sipSimpleWrapper *,sipTypeDef *);
extern sip_qt_metaobject_func sip_QtGui_qt_metaobject;

typedef int (*sip_qt_metacall_func)(sipSimpleWrapper *,sipTypeDef *,QMetaObject::Call,int,void **);
extern sip_qt_metacall_func sip_QtGui_qt_metacall;

typedef int (*sip_qt_metacast_func)(sipSimpleWrapper *,sipTypeDef *,const char *);
extern sip_qt_metacast_func sip_QtGui_qt_metacast;

#endif
